import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class DkGeneralNotifier implements OnDestroy {
    private draggingNotifierSubject;
    private pinColumnNotifierSubject;
    private rowGroupingNotifierSubject;
    private scrollbarWidthSubject;
    private refreshDataSourceSubject;
    constructor();
    ngOnDestroy(): void;
    get onDraggingNotifierChanged$(): Observable<boolean>;
    get onPinColumnNotifierChanged$(): Observable<boolean>;
    get onRowGroupingNotifierChanged$(): Observable<boolean>;
    get onScrollbarWidthChanged$(): Observable<number>;
    get onRefreshDataSourceChanged$(): Observable<void>;
    get scrollbarWidth(): number;
    set scrollbarWidth(value: number);
    initialized(): Observable<void>;
    notifyColumnSlotDragging(notifyDragging: boolean): void;
    notifyColumnSlotPinning(notifyPinnig: boolean): void;
    notifyRowGroupingColumnSlot(notifyRowGrouping: boolean): void;
    /**
     * For dragging purposes, this method generates a unique identifer for the
     * given asset.
     *
     * @param {string} containerName The string that represents a draggable container (DraggableContainer enum).
     * @param {string} assetId The unique id of the target element. It could be a column or a border.
     *
     * @returns {string} Returns the unique id for the draggable container.
     */
    createDraggableContainerId(containerName: string, assetId: string): string;
    refreshDataSource(): void;
    private changeDraggingNotifier;
    private changePinColumnNotifier;
    private changeRowGroupingNotifier;
    private changeScrollbarWidth;
    private changeRefreshDataSource;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGeneralNotifier, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGeneralNotifier>;
}
