import { OnInit, AfterViewInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { CdkVirtualForOf, CdkVirtualScrollViewport } from '@angular/cdk/scrolling';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { DkGridRowContent } from '../dk-grid-content.model';
import { DkDataSource } from '../../datasource/dk-datasource';
import { DkGridGroupRowEntry, DkGridRowEntry } from '../../rows/dk-grid-row-entry';
import { DkGridStructure } from '../../grid/dk-grid-structure.service';
import { DkGridContentStructure } from '../dk-grid-content-structure.service';
import { DkContentPanelDispatcher } from '../dk-content-panel-dispatcher.service';
import { DkGridEditionConfig } from '../../editing/dk-grid-edition-config.service';
import { DkGridSelectionConfig } from '../../selection/dk-grid-selection-config.service';
import { DkGridFilterConfig } from '../../filtering/dk-grid-filter-config.service';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import { DkGridUI } from '../../grid/dk-grid-ui.service';
import { SelectableFn } from '../../selection/dk-grid-selection.service';
import { DkGeneralNotifier } from '../../common/dk-general-notifier.service';
import { DkRowGroupingConfig } from '../../row-grouping/dk-row-grouping-config.service';
import { DkRowGroupingDispatcher } from '../../row-grouping/dk-row-grouping-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridContentComponent<T extends object> implements OnInit, AfterViewInit, OnDestroy {
    private dikeConfig;
    private cdr;
    private gridConfig;
    private gridStructure;
    private gridContentStructure;
    contentPanelDispatcher: DkContentPanelDispatcher<T>;
    private gridEditionConfig;
    private gridSelectionConfig;
    private gridFilterConfig;
    private generalNotifier;
    private rowGroupingConfig;
    private rowGroupingDispatcher;
    private gridUI;
    datasource: DkDataSource<DkGridRowEntry>;
    virtualFor: CdkVirtualForOf<DkGridRowEntry>;
    virtualScrollViewport: CdkVirtualScrollViewport;
    minBufferPx: number;
    maxBufferPx: number;
    divisionLineWidthPx: string;
    divisionLineWidthResizingPx: string;
    divisionPanelSpaceWidthPx: string;
    headerRowContentHeightPx: string;
    headerRowHorizontalGutterHeightPx: string;
    headerGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    headerIndentGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    filterRowHeightPx: string;
    filterRowContentHeightPx: string;
    filterRowHorizontalGutterHeightPx: string;
    filterSelectionGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    filterIndentGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    contentRowHeight$: Observable<DkGridRowContent>;
    contentRowHeightPx: string;
    contentRowContentHeightPx: string;
    contentRowHorizontalGutterHeightPx: string;
    contentEmptyRowGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    contentIndentGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    horizontalScrollHeightPx: string;
    horizontalScrollGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    verticalGutterWidthPx: string;
    displayRowFiltering$: Observable<boolean>;
    displayEmptyRow: boolean;
    onRowGroupingIndent$: Observable<boolean>;
    onEditionMode$: Observable<boolean>;
    onAllowSelection$: Observable<boolean>;
    selectableFunction$: Observable<SelectableFn<T>>;
    onRootGroupRow$: Observable<DkGridGroupRowEntry<T>>;
    stripedRows: boolean;
    verticalRowsLinesVisible: boolean;
    private unsubscribeAll;
    private changesDataColumnsSubscription;
    private changesBoundDataSubscription;
    private changesHeaderHeightSubscription;
    private changesGridStructureSubscription;
    private changesSelectionSubscription;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, gridConfig: DkGridConfig, gridStructure: DkGridStructure<T>, gridContentStructure: DkGridContentStructure<T>, contentPanelDispatcher: DkContentPanelDispatcher<T>, gridEditionConfig: DkGridEditionConfig<T>, gridSelectionConfig: DkGridSelectionConfig<T>, gridFilterConfig: DkGridFilterConfig<T>, generalNotifier: DkGeneralNotifier, rowGroupingConfig: DkRowGroupingConfig, rowGroupingDispatcher: DkRowGroupingDispatcher<T>, gridUI: DkGridUI);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    private setChangesDataColumnsSubscription;
    private changeCdkVirtualScrollViewport;
    private setChangesBoundDataSubscription;
    private setChangesHeaderHeightSubscription;
    private setChangesGridStructureSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridContentComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridContentComponent<any>, "dk-grid-content", never, { "datasource": "datasource"; }, {}, never, never>;
}
