import { OnInit, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { MatRadioChange } from '@angular/material/radio';
import { DkGridPanel } from '../../panels/dk-grid-panels';
import { DkColumnMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import { DkGridPanelDispatcher } from '../../panels/dk-grid-panel-dispatcher.service';
import { DkContentPanelDispatcher } from '../../content/dk-content-panel-dispatcher.service';
import { DkRowGroupingConfig } from '../../row-grouping/dk-row-grouping-config.service';
import * as i0 from "@angular/core";
export declare class DkColumnPinningComponent<T extends object> implements OnChanges, OnInit {
    private gridConfig;
    private gridPanelDispatcher;
    private contentPanelDispatcher;
    private rowGroupingConfig;
    columnSlot: DkColumnMeshSlot;
    moveColumn: EventEmitter<boolean>;
    panel: DkGridPanel;
    movable: boolean;
    groupable: boolean;
    allowLocking: boolean;
    allowRowGrouping: boolean;
    isColumnGroup: boolean;
    leftPanelOption: DkGridPanel;
    centerPanelOption: DkGridPanel;
    rightPanelOption: DkGridPanel;
    groupPanelOption: DkGridPanel;
    selectedOption: DkGridPanel | '';
    constructor(gridConfig: DkGridConfig, gridPanelDispatcher: DkGridPanelDispatcher<T>, contentPanelDispatcher: DkContentPanelDispatcher<T>, rowGroupingConfig: DkRowGroupingConfig);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    onRadioLockedGroupChanged(event: MatRadioChange): void;
    onRadioPanelGroupChanged(event: MatRadioChange): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkColumnPinningComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkColumnPinningComponent<any>, "dk-column-pinning", ["dkgColumnPinning"], { "columnSlot": "columnSlot"; }, { "moveColumn": "moveColumn"; }, never, never>;
}
