import { BehaviorSubject, Subscription, Observable } from 'rxjs';
import { DkDataSource } from './dk-datasource';
import { DkGridRowEntry } from '../rows/dk-grid-row-entry';
export declare abstract class DkContentDataSource extends DkDataSource<DkGridRowEntry> {
    protected dikeDataSource: DkDataSource<DkGridRowEntry> | DkDataSource<DkGridRowEntry>[];
    protected changeSubscription: Subscription;
    protected contentSubject: BehaviorSubject<DkGridRowEntry[]>;
    constructor(dikeDataSource: DkDataSource<DkGridRowEntry> | DkDataSource<DkGridRowEntry>[]);
    get data(): DkGridRowEntry[];
    set data(value: DkGridRowEntry[]);
    connect(): Observable<DkGridRowEntry[]>;
    disconnect(): void;
    reconnect(): void;
    dispose(releaseSource: boolean): void;
    protected abstract setChangeSubscription(isReconnection: boolean): void;
    protected abstract getDikeDataSource(): DkDataSource<DkGridRowEntry> | DkDataSource<DkGridRowEntry>[];
    private changeContentData;
}
