import { Observable, Subscription } from 'rxjs';
import { DkGridGroupRowEntry, DkGridRowEntry } from '../rows/dk-grid-row-entry';
import { DkContentDataSource } from './dk-content-datasource';
import { DkDataSource, DkGridDataSource } from './dk-datasource';
import { DkGridSelectionConfig } from '../selection/dk-grid-selection-config.service';
import { DkGridSelection } from '../selection/dk-grid-selection.service';
import { DkRowGroupingDispatcher } from '../row-grouping/dk-row-grouping-dispatcher.service';
import { DkGeneralNotifier } from '../common/dk-general-notifier.service';
import { DkDataSourceDispatcher } from './dk-data-source-dispatcher.service';
export declare abstract class DkGroupedContentDataSource<T extends object> extends DkContentDataSource {
    protected gridDataSource: DkGridDataSource<T>;
    protected gridSelectionConfig: DkGridSelectionConfig<T>;
    protected gridSelection: DkGridSelection<T>;
    protected dataSourceDispatcher: DkDataSourceDispatcher<T>;
    protected rowGroupingDispatcher: DkRowGroupingDispatcher<T>;
    protected generalNotifier: DkGeneralNotifier;
    protected changeRowSelectionSubscription: Subscription;
    protected changeSomeRowSelectionSubscription: Subscription;
    protected changeAllRowSelectionSubscription: Subscription;
    protected changeGroupSelectionSubscription: Subscription;
    constructor(gridDataSource: DkGridDataSource<T>, gridSelectionConfig: DkGridSelectionConfig<T>, gridSelection: DkGridSelection<T>, dataSourceDispatcher: DkDataSourceDispatcher<T>, rowGroupingDispatcher: DkRowGroupingDispatcher<T>, generalNotifier: DkGeneralNotifier);
    protected setChangeRowSelectionSubscription(groupRow: DkGridGroupRowEntry<T>): void;
    protected setChangeSomeRowSelectionSubscription(parentGroup: DkGridGroupRowEntry<T>, childGroups: DkGridGroupRowEntry<T>[]): void;
    protected setChangeAllRowSelectionSubscription(parentGroup: DkGridGroupRowEntry<T>, childGroups: DkGridGroupRowEntry<T>[]): void;
    protected setChangeGroupSelectionSubscription(groupRow: DkGridGroupRowEntry<T>): void;
    protected getDecoratedGridDataSource(gridDataSource: DkGridDataSource<T>): DkDataSource<DkGridRowEntry>;
    protected abstract getDataSourceStream(): Observable<DkGridRowEntry[]>;
}
