import { Observable } from "rxjs";
import { DkDataSource, DkGridDataSource } from "./dk-datasource";
import { DkGroupedContentDataSource } from "./dk-grouped-content-datasource";
import { DkGridGroupRowEntry, DkGridRowEntry } from "../rows/dk-grid-row-entry";
import { DkDataSourceDispatcher } from "./dk-data-source-dispatcher.service";
import { DkRowGroupingDispatcher } from "../row-grouping/dk-row-grouping-dispatcher.service";
import { DkGeneralNotifier } from '../common/dk-general-notifier.service';
import { DkGridSelectionConfig } from "../selection/dk-grid-selection-config.service";
import { DkGridSelection } from "../selection/dk-grid-selection.service";
export declare class DkWrappingDataSource<T extends object> extends DkGroupedContentDataSource<T> {
    private DISPOSING_SUBSET_ROWS;
    private groupingDataSource;
    private rootGroupRowSubject;
    constructor(gridDataSource: DkGridDataSource<T>, gridSelectionConfig: DkGridSelectionConfig<T>, gridSelection: DkGridSelection<T>, dataSourceDispatcher: DkDataSourceDispatcher<T>, rowGroupingDispatcher: DkRowGroupingDispatcher<T>, generalNotifier: DkGeneralNotifier);
    get onRootGroupRowChanged$(): Observable<DkGridGroupRowEntry<T>>;
    disconnect(): void;
    dispose(releaseSource: boolean): void;
    protected getDataSourceStream(): Observable<DkGridRowEntry[]>;
    protected setChangeSubscription(): void;
    protected getDikeDataSource(): DkDataSource<DkGridRowEntry>;
    private disposeRootGroup;
    private disposeDataRows;
    private changeRootGroupRow;
}
