import { ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { AbstractControl } from '@angular/forms';
import { CustomErrorMessage } from './dk-edition-message.errors';
import { DkGridMessaging } from '../grid/dk-grid-messaging.service';
import { DkEditionErrorMessagesFactory } from './dk-edition-error-messages-factory.service';
import * as i0 from "@angular/core";
export declare class DkEditionErrorNotificationDirective implements OnChanges, OnDestroy {
    private elementRef;
    private render2;
    private editionErrorFactory;
    private gridMessaging;
    editionControl: AbstractControl;
    customErrorMessages: CustomErrorMessage;
    errorIndicatorClass: string;
    private changesEditionControlSubscription;
    private changesEditionControlStatusSubscription;
    constructor(elementRef: ElementRef, render2: Renderer2, editionErrorFactory: DkEditionErrorMessagesFactory, gridMessaging: DkGridMessaging);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    onMouseOver(): void;
    onMouseLeave(): void;
    private setChangesEditionControlSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkEditionErrorNotificationDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<DkEditionErrorNotificationDirective, "[dkEditionErrorNotification]", ["dkgEditionErrorNotification"], { "editionControl": "dkEditionErrorNotification"; "customErrorMessages": "customErrorMessages"; "errorIndicatorClass": "errorIndicatorClass"; }, {}, never>;
}
