import { EventEmitter, OnDestroy, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { DkColumnDataType } from '../columns/dk-column-def';
import { DkGridEditionSettings, EditionFieldSettings, EditionToolbarAlignment, EditionToolbarPosition, RowStatus } from './dk-edition.model';
import * as i0 from "@angular/core";
export declare class DkGridEditionConfig<T extends object> implements OnDestroy {
    private maxRowsInEdition;
    private rowEditionDblClick;
    private rowEditionEnterKey;
    private rowEditionEscKey;
    private splitDeleteOperation;
    private deleteOperationRowSubsetSize;
    private splitUndoOperation;
    private undoOperationRowSubsetSize;
    private waitForMultipleRowsDeletion;
    private waitForMultipleRowsUpdate;
    private waitForMultipleRowsCancellation;
    private waitForMultipleRowsRestoration;
    readonly editionFilterStateEmitter: EventEmitter<boolean>;
    private gridInstanceEditionSettings;
    private dikeTextBox;
    private dikeMultiTextBox;
    private dikeTextOptionsBox;
    private dikeNumericBox;
    private dikeNumericOptionsBox;
    private dikeDateBox;
    private dikeBinaryBox;
    private dikeBinaryOptionsBox;
    private allowEditionSubject;
    private editionModeSubject;
    private editionToolbarSubject;
    private editionToolbarPositionSubject;
    private editionToolbarAlignmentSubject;
    private editionFilterStateSubject;
    private editionFilterSubject;
    private enableEditionFilterRowsSubject;
    constructor(maxRowsInEdition: number, rowEditionDblClick: boolean, rowEditionEnterKey: boolean, rowEditionEscKey: boolean, splitDeleteOperation: boolean, deleteOperationRowSubsetSize: number, splitUndoOperation: boolean, undoOperationRowSubsetSize: number, waitForMultipleRowsDeletion: boolean, waitForMultipleRowsUpdate: boolean, waitForMultipleRowsCancellation: boolean, waitForMultipleRowsRestoration: boolean);
    ngOnDestroy(): void;
    get onAllowEditionChanged$(): Observable<boolean>;
    get onEditionModeChanged$(): Observable<boolean>;
    get onEditionToolbarChanged$(): Observable<boolean>;
    get onEditionToolbarPositionChanged$(): Observable<EditionToolbarPosition>;
    get onEditionToolbarAlignmentChanged$(): Observable<EditionToolbarAlignment>;
    get onEditionFilterStateChanged$(): Observable<boolean>;
    get onEditionFilterChanged$(): Observable<RowStatus | void>;
    get onEnableEditionFilterRowsChanged$(): Observable<boolean>;
    get enableEditionFilterRows(): boolean;
    set enableEditionFilterRows(value: boolean);
    get textBoxTemplate(): TemplateRef<any>;
    set textBoxTemplate(template: TemplateRef<any>);
    get multiTextBoxTemplate(): TemplateRef<any>;
    set multiTextBoxTemplate(template: TemplateRef<any>);
    get textOptionsBoxTemplate(): TemplateRef<any>;
    set textOptionsBoxTemplate(template: TemplateRef<any>);
    get numericBoxTemplate(): TemplateRef<any>;
    set numericBoxTemplate(template: TemplateRef<any>);
    get numericOptionsBoxTemplate(): TemplateRef<any>;
    set numericOptionsBoxTemplate(template: TemplateRef<any>);
    get dateBoxTemplate(): TemplateRef<any>;
    set dateBoxTemplate(template: TemplateRef<any>);
    get binaryBoxTemplate(): TemplateRef<any>;
    set binaryBoxTemplate(template: TemplateRef<any>);
    get binaryOptionsBoxTemplate(): TemplateRef<any>;
    set binaryOptionsBoxTemplate(template: TemplateRef<any>);
    get allowEdition(): boolean;
    set allowEdition(value: boolean);
    get editionMode(): boolean;
    set editionMode(value: boolean);
    get editionToolbar(): boolean;
    set editionToolbar(value: boolean);
    get editionToolbarPosition(): EditionToolbarPosition;
    set editionToolbarPosition(value: EditionToolbarPosition);
    get editionToolbarAlignment(): EditionToolbarAlignment;
    set editionToolbarAlignment(value: EditionToolbarAlignment);
    get editionFilterState(): boolean;
    get editionFilter(): void | RowStatus;
    set editionFilter(value: void | RowStatus);
    get gridEditionSettings(): DkGridEditionSettings<T>;
    set gridEditionSettings(value: DkGridEditionSettings<T>);
    cancelEditionFilter(): void;
    getEditionSettings(dataType: DkColumnDataType, currentSettings: EditionFieldSettings, newSettings: EditionFieldSettings): EditionFieldSettings;
    getDefaultEditionTemplate(columnDataType: DkColumnDataType, editionSettings: EditionFieldSettings): TemplateRef<any>;
    private doesHaveOptions;
    private changeAllowEdition;
    private changeEditionMode;
    private changeEditionToolbar;
    private changeEditionToolbarPosition;
    private changeEditionToolbarAlignment;
    private changeEditionFilterState;
    private changeEditionFilter;
    private changeEnableEditionFilterRows;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridEditionConfig<any>, [{ optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridEditionConfig<any>>;
}
