import { ChangeDetectorRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { EditionToolbarAlignment, EditionToolbarPosition } from '../dk-edition.model';
import { DkGridEditionConfig } from '../dk-grid-edition-config.service';
import { DkGridRowEditionDispatcher } from '../dk-grid-row-edition-dispatcher.service';
import { DkGridSelection } from '../../selection/dk-grid-selection.service';
import { DkGridSelectionConfig } from '../../selection/dk-grid-selection-config.service';
import { DkGridStructure } from '../../grid/dk-grid-structure.service';
import * as i0 from "@angular/core";
export declare class DkGridEditionToolbarComponent<T extends object> implements OnInit, OnChanges, OnDestroy {
    private cdr;
    private gridStructure;
    private gridEditionConfig;
    private gridSelection;
    private gridSelectionConfig;
    private rowEditionDispatcher;
    toolbarPosition: EditionToolbarPosition;
    toolbarAlignment: EditionToolbarAlignment;
    saveAction: boolean;
    deleteAction: boolean;
    cancelAction: boolean;
    undoAction: boolean;
    toolbarAlignmentStyle: {
        [key: string]: any;
    };
    isEditionFilter$: Observable<boolean>;
    allowSelection$: Observable<boolean>;
    enableEditionFilterRows$: Observable<boolean>;
    editionToolbarItemHeight$: Observable<string>;
    private unsubscribeAll;
    private headerEditionActionsSubscription;
    private headerDeleteActionSubscription;
    private headerUndoActionSubscription;
    constructor(cdr: ChangeDetectorRef, gridStructure: DkGridStructure<T>, gridEditionConfig: DkGridEditionConfig<T>, gridSelection: DkGridSelection<T>, gridSelectionConfig: DkGridSelectionConfig<T>, rowEditionDispatcher: DkGridRowEditionDispatcher<T>);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    onSaveEdition(): void;
    onDeleteRows(): void;
    onCancelEdition(): void;
    onRestoreRows(): void;
    onEditingFilter(): void;
    onUpdatedFilter(): void;
    onDeletedFilter(): void;
    onCancelEditionFilter(): void;
    private getToolbarAlignmentStyle;
    private setMultipleEditionActionsSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridEditionToolbarComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridEditionToolbarComponent<any>, "dk-grid-edition-toolbar", never, { "toolbarPosition": "toolbarPosition"; "toolbarAlignment": "toolbarAlignment"; }, {}, never, never>;
}
