import { FieldUpdate, RowStatus } from './dk-edition.model';
import { DkGridDataStore } from '../datasource/dk-grid-data-store.service';
export declare abstract class Memento {
    private mementoTimestamp;
    private mementoId;
    constructor(mementoTimestamp: number);
    get timestamp(): number;
    get snapShotId(): string;
    abstract restore(): void;
}
export declare class RowMemento<T extends object> extends Memento {
    private gridDataStore;
    private rowId;
    private rowStatus;
    private fields;
    constructor(gridDataStore: DkGridDataStore<T>, rowId: number, rowStatus: RowStatus, fields: FieldUpdate<T, string | number | Date | boolean | null | undefined>[], timestamp: number);
    restore(): void;
}
