import { ChangeDetectorRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { DkGridDataRowEntry } from '../../rows/dk-grid-row-entry';
import { RowStatus } from '../dk-edition.model';
import { CustomErrorMessage } from '../dk-edition-message.errors';
import { DkGridEditionConfig } from '../dk-grid-edition-config.service';
import { DkGridSelection } from '../../selection/dk-grid-selection.service';
import { DkGridSelectionConfig } from '../../selection/dk-grid-selection-config.service';
import { DkGridRowEditionDispatcher } from '../dk-grid-row-edition-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridRowEditionMenuComponent<T extends object> implements OnInit, OnChanges, OnDestroy {
    private dikeConfig;
    private cdr;
    private gridEditionConfig;
    private gridSelection;
    private gridSelectionConfig;
    private rowEditionDispatcher;
    row: DkGridDataRowEntry<T>;
    isHeaderRow: boolean;
    isEmptyRow: boolean;
    rowContentHeightPx: string;
    rowHorizontalGutterHeightPx: string;
    isVerticalLineVisible: boolean;
    rowContentWidthPx: string;
    rowVerticalGutterWidthPx: string;
    rowGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    rowEditAction: boolean;
    rowDeleteAction: boolean;
    rowSaveAction: boolean;
    rowCancelAction: boolean;
    saveAction: boolean;
    deleteAction: boolean;
    cancelAction: boolean;
    undoAction: boolean;
    editionToolbar$: Observable<boolean>;
    cardinalityRowHistory$: Observable<number>;
    isEditionFilter$: Observable<boolean>;
    allowSelection$: Observable<boolean>;
    editionFilter$: Observable<void | RowStatus>;
    enableEditionFilterRows$: Observable<boolean>;
    crossFieldValidationErrors: CustomErrorMessage;
    private rowEditionActionsSubscription;
    private headerEditionActionsSubscription;
    private headerDeleteActionSubscription;
    private headerUndoActionSubscription;
    private unsubscribeAll;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, gridEditionConfig: DkGridEditionConfig<T>, gridSelection: DkGridSelection<T>, gridSelectionConfig: DkGridSelectionConfig<T>, rowEditionDispatcher: DkGridRowEditionDispatcher<T>);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    onSaveEdition(): void;
    onDeleteRows(): void;
    onCancelEdition(): void;
    onRestoreRows(): void;
    onRowEdition(): void;
    onDeleteRow(): void;
    onSaveRowEdition(): void;
    onCancelRowEdition(): void;
    onUndoRowUpdate(): void;
    onEditingFilter(): void;
    onUpdatedFilter(): void;
    onDeletedFilter(): void;
    onCancelEditionFilter(): void;
    private setGridDisplay;
    private setRowEditionActionsSubscription;
    private setMultipleEditionActionsSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowEditionMenuComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowEditionMenuComponent<any>, "dk-grid-row-edition-menu", never, { "row": "row"; "isHeaderRow": "isHeaderRow"; "isEmptyRow": "isEmptyRow"; "rowContentHeightPx": "rowContentHeightPx"; "rowHorizontalGutterHeightPx": "rowHorizontalGutterHeightPx"; "isVerticalLineVisible": "isVerticalLineVisible"; }, {}, never, never>;
}
