import { OnInit, AfterViewInit } from '@angular/core';
import { Observable } from 'rxjs';
import { DkFilter, DkTextFilter, DkNumericFilter, DkDateFilter } from '../dk-filter.model';
import { Condition } from '../dk-filter-types';
import { ColumnAlignment } from '../../columns/dk-column-def';
import { DkFilterFactory, CustomSelectionFilterConditionInstance } from '../dk-filter-factory.service';
import { CustomBinaryFilterCondition } from '../dk-binary-filter.conditions';
import { CustomMultipleNumericFilterCondition } from '../dk-multiple-numeric-filter.condition';
import { CustomMultipleTextFilterCondition } from '../dk-multiple-text-filter.conditions';
import { DkGridFilterConfig } from '../dk-grid-filter-config.service';
import * as i0 from "@angular/core";
export declare class DkColumnFilterComponent<T extends object> implements OnInit, AfterViewInit {
    private filterFactory;
    private gridFilterConfig;
    columnId: string;
    isFilterRow: boolean;
    contentAlign: ColumnAlignment;
    private dikeFilter;
    selectionFilterInstance: CustomSelectionFilterConditionInstance<T>;
    binarySelectionFilterInstance: CustomBinaryFilterCondition<T>;
    numericSelectionFilterInstance: CustomMultipleNumericFilterCondition<T>;
    textSelectionFilterCondition: CustomMultipleTextFilterCondition<T>;
    dateConditions: Condition<T, string | number | Date, DkDateFilter>[];
    numericConditions: Condition<T, number, DkNumericFilter>[];
    textConditions: Condition<T, string, DkTextFilter>[];
    initialFilter: DkFilter[];
    caseSensitive: boolean;
    filterType: string;
    onDemandFilter$: Observable<boolean>;
    clearGridFilter$: Observable<void>;
    constructor(filterFactory: DkFilterFactory<T>, gridFilterConfig: DkGridFilterConfig<T>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    addFilterCondition(): void;
    clearFilter(): void;
    applyFilter(): void;
    canAddFilterCondition(): boolean;
    isFilterApplied(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkColumnFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkColumnFilterComponent<any>, "dk-column-filter", ["dkgColumnFilter"], { "columnId": "columnId"; "isFilterRow": "isFilterRow"; "contentAlign": "contentAlign"; }, {}, never, never>;
}
