import { OnInit, EventEmitter, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { FormGroup, FormBuilder, FormArray, AbstractControl } from '@angular/forms';
import { MatSelectChange } from '@angular/material/select';
import { Observable } from 'rxjs';
import { ColumnAlignment } from '../../columns/dk-column-def';
import { DkDateFilter, DkDateFilterEmission, DkFilterBehaviour } from '../dk-filter.model';
import { Condition } from '../dk-filter-types';
import { DkConfig } from '../../grid/dk-config';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkDateFilterComponent<T extends object> implements OnInit, OnDestroy, DkFilterBehaviour<DkDateFilterEmission> {
    private dikeConfig;
    private cdr;
    private formBuilder;
    private gridConfig;
    contentAlign: ColumnAlignment;
    isFilterRow: boolean;
    appliedFilter: DkDateFilter[];
    conditionTypes: Condition<T, string | number | Date | null | undefined, DkDateFilter>[];
    onDemandFilter: boolean;
    clearRowFilterControl: Observable<void>;
    filterChange: EventEmitter<DkDateFilterEmission>;
    dateFilterForm: FormGroup;
    matSelectPanelClass: string;
    private valueChangesSubscription;
    private clearFilterChangesSubscription;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, formBuilder: FormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    ngOnDestroy(): void;
    get conditions(): FormArray;
    addCondition(): void;
    removeCondition(indexGroup: number): void;
    clear(): void;
    applyFilter(): void;
    isFilterApplied(): boolean;
    onLogicalOperatorChange(): void;
    onConditionTypeChange(event: MatSelectChange, conditionGroup: AbstractControl): void;
    onSelectedValueContains(value: string, searchString: string): boolean;
    private createForm;
    private createConditionGroup;
    private addValueControl;
    private setInitialFormState;
    private setRangeFormState;
    private setEmptyFormState;
    private emitValues;
    private setClearFilterChangesSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkDateFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkDateFilterComponent<any>, "dk-date-filter", never, { "contentAlign": "contentAlign"; "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "conditionTypes": "conditionTypes"; "onDemandFilter": "onDemandFilter"; "clearRowFilterControl": "clearRowFilterControl"; }, {}, never, never>;
}
