import { EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from '../grid/dk-config';
import { DkFilterable } from './dk-filter.model';
import { DkFilterFactory } from './dk-filter-factory.service';
import { DkGridEditionConfig } from '../editing/dk-grid-edition-config.service';
import * as i0 from "@angular/core";
export declare class DkGridFilterConfig<T extends object> implements OnDestroy {
    private dikeConfig;
    private filterFactory;
    private gridEditionConfig;
    dataFilterables: Map<string, DkFilterable<T>>;
    editionFilterables: Map<string, DkFilterable<T>>;
    readonly registerEmitter: EventEmitter<DkFilterable<T>>;
    readonly deregisterEmitter: EventEmitter<DkFilterable<T>>;
    readonly filterEmitter: EventEmitter<DkFilterable<T>>;
    readonly editionFilterEmitter: EventEmitter<DkFilterable<T>>;
    readonly clearFilterEmitter: EventEmitter<void>;
    readonly clearEditionFilterEmitter: EventEmitter<void>;
    private allowRowFilterSubject;
    private onDemandFilterSubject;
    constructor(dikeConfig: DkConfig, filterFactory: DkFilterFactory<T>, gridEditionConfig: DkGridEditionConfig<T>);
    ngOnDestroy(): void;
    get onAllowRowFilterChanged$(): Observable<boolean>;
    get onDemandFilterChanged$(): Observable<boolean>;
    get allowRowFilter(): boolean;
    set allowRowFilter(value: boolean);
    get onDemandFilter(): boolean;
    set onDemandFilter(value: boolean);
    get filterables(): Map<string, DkFilterable<T>>;
    initialized(): Observable<void>;
    getRowFilterColumnId(columnId: string): string;
    getColumnIdFromFilterable(filterable: DkFilterable<T>): string;
    cloneFilterable(columnId: string, newColumnId: string): void;
    register(filterable: DkFilterable<T>): void;
    deregister(filterable: DkFilterable<T>): void;
    applyFilter(filterable: DkFilterable<T>): void;
    clearFilter(): void;
    private changeAllowRowFilter;
    private changeOnDemandFilter;
    private changeRegistration;
    private changeDeregistration;
    private changeFilter;
    private changeClearFilter;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridFilterConfig<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridFilterConfig<any>>;
}
