import { OnInit, EventEmitter, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { FormGroup, FormBuilder, FormArray, AbstractControl } from '@angular/forms';
import { MatSelectChange } from '@angular/material/select';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { ColumnAlignment } from '../../columns/dk-column-def';
import { Condition } from '../dk-filter-types';
import { DkFilterBehaviour, DkNumericFilter, DkNumericFilterEmission } from '../dk-filter.model';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkNumericFilterComponent<T extends object> implements OnInit, OnDestroy, DkFilterBehaviour<DkNumericFilterEmission> {
    private dikeConfig;
    private numericFilterDebounceTime;
    private cdr;
    private formBuilder;
    private gridConfig;
    contentAlign: ColumnAlignment;
    isFilterRow: boolean;
    appliedFilter: DkNumericFilter[];
    conditionTypes: Condition<T, number | null | undefined, DkNumericFilter>[];
    onDemandFilter: boolean;
    clearRowFilterControl: Observable<void>;
    filterChange: EventEmitter<DkNumericFilterEmission>;
    numericFilterForm: FormGroup;
    matSelectPanelClass: string;
    private valueChangesSubscription;
    private clearFilterChangesSubscription;
    constructor(dikeConfig: DkConfig, numericFilterDebounceTime: number, cdr: ChangeDetectorRef, formBuilder: FormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    ngOnDestroy(): void;
    get conditions(): FormArray;
    addCondition(): void;
    removeCondition(indexGroup: number): void;
    clear(): void;
    applyFilter(): void;
    isFilterApplied(): boolean;
    onLogicalOperatorChange(): void;
    onConditionTypeChange(event: MatSelectChange, conditionGroup: AbstractControl): void;
    onSelectedValueContains(value: string, searchString: string): boolean;
    private createForm;
    private createConditionGroup;
    private addValueControl;
    private setInitialFormState;
    private setRangeFormState;
    private setEmptyFormState;
    private emitValues;
    private setClearFilterChangesSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkNumericFilterComponent<any>, [null, { optional: true; }, null, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkNumericFilterComponent<any>, "dk-numeric-filter", never, { "contentAlign": "contentAlign"; "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "conditionTypes": "conditionTypes"; "onDemandFilter": "onDemandFilter"; "clearRowFilterControl": "clearRowFilterControl"; }, {}, never, never>;
}
