import { OnInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { Observable } from 'rxjs';
import { DkColumnMeshSlot, DkGutterMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkSlotPlacement } from '../../common/dk-slot-placement';
import { DkContentColumnStructure } from '../../columns/dk-content-column-structure';
import { DkContentPanel, PanelsVisibilityTruthTable } from '../../panels/dk-grid-panels';
import { DkGridUI } from '../../grid/dk-grid-ui.service';
import { DkGridFilterConfig } from '../dk-grid-filter-config.service';
import { DkGridContentStructure } from '../../content/dk-grid-content-structure.service';
import { DkContentPanelDispatcher } from '../../content/dk-content-panel-dispatcher.service';
import { DkGridEditionConfig } from '../../editing/dk-grid-edition-config.service';
import * as i0 from "@angular/core";
export declare class DkRowFilterComponent<T extends object> implements OnInit, OnDestroy {
    private cdr;
    private gridContentStructure;
    private gridUI;
    private gridFilterConfig;
    private gridEditionConfig;
    private contentPanelDispatcher;
    columnStructure: DkContentColumnStructure<T>;
    panel: DkContentPanel;
    isVerticalRowsVisible: boolean;
    editionFilterState: boolean;
    filterRowHeightPx: string;
    filterHorizontalGutterHeightPx: string;
    isThereOuterColumns: boolean;
    panelsVisibility: PanelsVisibilityTruthTable;
    inOrderComplementGutterVisibility: boolean;
    outerColumnSlots$: Observable<DkColumnMeshSlot[]>;
    visibleDataColumnSlots$: Observable<DkColumnMeshSlot[]>;
    scrollbarSlot$: Observable<DkColumnMeshSlot>;
    horizontalGutterSlot$: Observable<DkSlotPlacement>;
    gutterSlotAction$: Observable<DkGutterMeshSlot>;
    private unsubscribeAll;
    constructor(cdr: ChangeDetectorRef, gridContentStructure: DkGridContentStructure<T>, gridUI: DkGridUI, gridFilterConfig: DkGridFilterConfig<T>, gridEditionConfig: DkGridEditionConfig<T>, contentPanelDispatcher: DkContentPanelDispatcher<T>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkRowFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkRowFilterComponent<any>, "dk-row-filter", never, { "columnStructure": "columnStructure"; }, {}, never, never>;
}
