import { ElementRef, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridBorder, DkGridSize } from './dk-grid.model';
import { DkGridRowPagination, DkGridRowToolbar, DkGridRowGrouping } from '../content/dk-grid-content.model';
import { DkConfig } from './dk-config';
import { DkGridEditionConfig } from '../editing/dk-grid-edition-config.service';
import { DkRowGroupingConfig } from '../row-grouping/dk-row-grouping-config.service';
import { DkPaginationDispatcher } from '../paging/dk-pagination-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridStructure<T extends object> implements OnDestroy {
    private dikeConfig;
    private gridRowGroupingRowHeight;
    private gridRowGroupingColumnHeight;
    private gridPaginationRowHeight;
    private gridEditionToolbarRowHeight;
    private gridEditionToolbarItemHeight;
    private gridBorderWidth;
    private gridBorderGap;
    private paginationDispatcher;
    private gridEditionConfig;
    private rowGroupingConfig;
    private wrapperId;
    private wrapperElementRef;
    private gridMesh;
    private gridSizeSubject;
    private editionToolbarVisibilitySubject;
    private editionToolbarRowSubject;
    private editionToolbarItemHeightSubject;
    private rowGroupingSubject;
    private rowGroupingColumnHeightSubject;
    private paginationRowSubject;
    private borderTopSubject;
    private borderRightSubject;
    private borderBottomSubject;
    private borderLeftSubject;
    private updateCdkVirtualScrollViewport;
    private gridTemplateColumnsSubject;
    private gridTemplateRowsSubject;
    private mainWrapperTemplateColumnsSubject;
    private mainWrapperTemplateRowsSubject;
    private changesAllowRowGroupingSubscription;
    private changesAllowPaginationSubscription;
    private changesEditionConfigSubscription;
    constructor(dikeConfig: DkConfig, gridRowGroupingRowHeight: number, gridRowGroupingColumnHeight: number, gridPaginationRowHeight: number, gridEditionToolbarRowHeight: number, gridEditionToolbarItemHeight: number, gridBorderWidth: number, gridBorderGap: number, paginationDispatcher: DkPaginationDispatcher, gridEditionConfig: DkGridEditionConfig<T>, rowGroupingConfig: DkRowGroupingConfig);
    ngOnDestroy(): void;
    get onGridSizeChanged$(): Observable<DkGridSize>;
    get mainWrapperId(): string;
    get mainWrapperElementRef(): ElementRef;
    set mainWrapperElementRef(value: ElementRef);
    get onMainWrapperTemplateColumnsChanged$(): Observable<string>;
    get onMainWrapperTemplateRowsChanged$(): Observable<string>;
    get onGridTemplateColumnsChanged$(): Observable<string>;
    get onGridTemplateRowsChanged$(): Observable<string>;
    get onEditionToolbarVisibilityChanged$(): Observable<boolean>;
    get onEditionToolbarRowChanged$(): Observable<DkGridRowToolbar>;
    get onEditionToolbarItemHeightChanged$(): Observable<number>;
    get onRowGroupingRowChanged$(): Observable<DkGridRowGrouping>;
    get onRowGroupingColumnHeightChanged$(): Observable<number>;
    get onPaginationRowChanged$(): Observable<DkGridRowPagination>;
    get onBorderTopChanged$(): Observable<DkGridBorder>;
    get onBorderRightChanged$(): Observable<DkGridBorder>;
    get onBorderBottomChanged$(): Observable<DkGridBorder>;
    get onBorderLeftChanged$(): Observable<DkGridBorder>;
    get onUpdateCdkScrollViewport$(): Observable<void>;
    get borderWidth(): number;
    get borderGap(): number;
    setGridSize(size: DkGridSize): void;
    setBorderTop(borderTop: DkGridBorder): void;
    setBorderRight(borderRight: DkGridBorder): void;
    setBorderBottom(borderBottom: DkGridBorder): void;
    setBorderLeft(borderLeft: DkGridBorder): void;
    get editionToolbarRow(): DkGridRowToolbar;
    get editionToolbarRowHeight(): number;
    set editionToolbarRowHeight(height: number);
    get editionToolbarItemHeight(): number;
    set editionToolbarItemHeight(value: number);
    get rowGroupingRow(): DkGridRowGrouping;
    get rowGroupingRowHeight(): number;
    get rowGroupingColumnHeight(): number;
    set rowGroupingColumnHeight(value: number);
    set rowGroupingRowHeight(height: number);
    get paginationRow(): DkGridRowPagination;
    get paginationRowHeight(): number;
    set paginationRowHeight(height: number);
    private createGridSize;
    private createGridBorder;
    private createGridRowGrouping;
    private createGridRowToolbar;
    private createGridRowPagination;
    private changeGridSize;
    private changeBorderTop;
    private changeBorderRight;
    private changeBorderBottom;
    private changeBorderLeft;
    private changeEditionToolbarVisibility;
    private changeEditionToolbarRow;
    private changeEditionToolbarItemHeight;
    private changeRowGrouping;
    private changeRowGroupingColumnHeight;
    private changePaginationRow;
    private changeCdkScrollViewport;
    private changeMainWrapperTemplateColumns;
    private changeMainWrapperTemplateRows;
    private changeGridTemplateRows;
    private setChangesAllowRowGroupingSubscription;
    private setChangesAllowPaginationSubscription;
    private setChangeEditionConfigSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridStructure<any>, [null, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, null, null, null]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridStructure<any>>;
}
