import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from './dk-config';
import { DkContentPanel, PanelsVisibilityTruthTable } from '../panels/dk-grid-panels';
import * as i0 from "@angular/core";
export declare class DkGridUI implements OnDestroy {
    private dikeConfig;
    private gridElevationSubject;
    private gridElevationValueSubject;
    private gridElevationClassSubject;
    private verticalRowLinesSubject;
    private stripedRowsSubject;
    constructor(dikeConfig: DkConfig);
    ngOnDestroy(): void;
    get onGridElevationChanged$(): Observable<boolean>;
    get onGridElevationValueChanged$(): Observable<number>;
    get onGridElevationClassChanged$(): Observable<string>;
    get onVerticalRowLinesChanged$(): Observable<boolean>;
    get onStripedRowsChanged$(): Observable<boolean>;
    get gridElevation(): boolean;
    set gridElevation(value: boolean);
    get gridElevationValue(): number;
    set gridElevationValue(value: number);
    get verticalRowLines(): boolean;
    set verticalRowLines(value: boolean);
    get stripedRows(): boolean;
    set stripedRows(value: boolean);
    isInOrderComplementGutterHidden(panel: DkContentPanel, isThereOuterColumns: boolean, panelsVisibility: PanelsVisibilityTruthTable): boolean;
    private createMatElevationClass;
    private changeGridElevation;
    private changeGridElevationValue;
    private changeGridElevationClass;
    private changeVerticalRowLines;
    private changeStripedRows;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridUI, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridUI>;
}
