import { OnInit, OnDestroy, AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { CdkDragStart, CdkDragEnd, CdkDragDrop, CdkDragEnter, CdkDragExit } from '@angular/cdk/drag-drop';
import { CdkScrollable, ScrollDispatcher } from '@angular/cdk/scrolling';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { DkMeshSlot, DkColumnMeshSlot, DkGutterMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkSlotPlacement } from '../../common/dk-slot-placement';
import { DraggableContainer, ShareableDropElements } from '../../common/dk-draggable-containers';
import { DkContentColumnStructure } from '../../columns/dk-content-column-structure';
import { DkContentPanel, DkGridPanel, PanelsVisibilityTruthTable } from '../../panels/dk-grid-panels';
import { DkGridRowHeader } from '../../content/dk-grid-content.model';
import { DkGridBorder } from '../../grid/dk-grid.model';
import { DkGridContentStructure } from '../../content/dk-grid-content-structure.service';
import { DkGridUI } from '../../grid/dk-grid-ui.service';
import { DkGridStructure } from '../../grid/dk-grid-structure.service';
import { DkGeneralNotifier } from '../../common/dk-general-notifier.service';
import { DkContentPanelDispatcher } from '../../content/dk-content-panel-dispatcher.service';
import { DkGridPanelDispatcher } from '../../panels/dk-grid-panel-dispatcher.service';
import { DkGroupPanelDispatcher } from '../../row-grouping/dk-group-panel-dispatcher.service';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkGridRowHeaderComponent<T extends object> implements OnInit, AfterViewInit, OnDestroy {
    private dikeConfig;
    private cdr;
    private scrollDispatcher;
    private gridConfig;
    private gridStructure;
    private gridContentStructure;
    private contentPanelDispatcher;
    private groupPanelDispatcher;
    private gridPanelDispatcher;
    private generalNotifier;
    private gridUI;
    columnStructure: DkContentColumnStructure<T>;
    scrollableHeaderPanel: CdkScrollable;
    isDragging: boolean;
    panel: DkContentPanel;
    gridRowHeader: DkGridRowHeader;
    headerHorizontalGutterHeightPx: string;
    borders: [DkGridBorder, DkGridBorder];
    shareables: Record<DkGridPanel, ShareableDropElements>;
    outerColumnSlots$: Observable<DkColumnMeshSlot[]>;
    visibleColumnSlots$: Observable<DkColumnMeshSlot[]>;
    isThereOuterColumns: boolean;
    panelsVisibility: PanelsVisibilityTruthTable;
    inOrderComplementGutterVisibility: boolean;
    scrollbarSlot$: Observable<DkColumnMeshSlot>;
    horizontalGutterSlot$: Observable<DkSlotPlacement>;
    gutterSlotAction$: Observable<DkGutterMeshSlot>;
    sourceContainer: DraggableContainer;
    dropSwapContainer: DraggableContainer;
    dropGutterContainer: DraggableContainer;
    rowGroupingPanelId: string;
    allowColumnDragging$: Observable<boolean>;
    private changeScrollingSubscription;
    private unsubscribeAll;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, scrollDispatcher: ScrollDispatcher, gridConfig: DkGridConfig, gridStructure: DkGridStructure<T>, gridContentStructure: DkGridContentStructure<T>, contentPanelDispatcher: DkContentPanelDispatcher<T>, groupPanelDispatcher: DkGroupPanelDispatcher<T>, gridPanelDispatcher: DkGridPanelDispatcher<T>, generalNotifier: DkGeneralNotifier, gridUI: DkGridUI);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    noDroppingAllowed(): boolean;
    onDragStart(event: CdkDragStart): void;
    onDragEnd(event: CdkDragEnd): void;
    onDropListEntered(entered: CdkDragEnter<DkMeshSlot>): void;
    onDropListExited(exited: CdkDragExit<DkMeshSlot>): void;
    onDrop(dropped: CdkDragDrop<DkMeshSlot, DkColumnMeshSlot>): void;
    private setChangeScrollingSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowHeaderComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowHeaderComponent<any>, "dk-grid-row-header", never, { "columnStructure": "columnStructure"; }, {}, never, never>;
}
