import { EventEmitter, OnDestroy } from '@angular/core';
import { DkGridPanel } from './dk-grid-panels';
import { DkColumnDef, DkDataColumnDef, DkColumnMoveEvent } from '../columns/dk-column-def';
import { DkColumnStructure } from '../columns/dk-column-structure';
import { DkContentColumnStructure } from '../columns/dk-content-column-structure';
import { DkColumnMeshSlot, DkMeshSlot } from '../columns/dk-column-mesh-slot';
import { DkPanelDispatcher } from './dk-panel-dispatcher.service';
import { DkContentPanelDispatcher } from '../content/dk-content-panel-dispatcher.service';
import { DkGroupPanelDispatcher } from '../row-grouping/dk-group-panel-dispatcher.service';
import { DkRowGroupingConfig } from '../row-grouping/dk-row-grouping-config.service';
import * as i0 from "@angular/core";
export declare class DkGridPanelDispatcher<T extends object> extends DkPanelDispatcher<T, DkGridPanel> implements OnDestroy {
    private rowGroupingConfig;
    readonly columnResizedEmitter: EventEmitter<DkDataColumnDef<T, string | number | Date | boolean | null | undefined>>;
    readonly columnMovedEmitter: EventEmitter<DkColumnMoveEvent>;
    private contentPanelDispatcher;
    private groupPanelDispatcher;
    private changeNonGroupableSubscription;
    private emitColumnResizingSubscription;
    constructor(rowGroupingConfig: DkRowGroupingConfig, contentPanelDispatcher: DkContentPanelDispatcher<T>, groupPanelDispatcher: DkGroupPanelDispatcher<T>);
    ngOnDestroy(): void;
    get gridPanels(): Partial<Record<DkGridPanel, DkColumnStructure<T, DkGridPanel>>>;
    addColumns(columns: DkColumnDef | DkColumnDef[]): void;
    movePanelColumnSlots(fromPanel: DkColumnStructure<T, DkGridPanel>, destinationPanel: DkColumnStructure<T, DkGridPanel>, onlyVisibleColumnSlots: boolean): DkColumnDef[];
    moveColumnSlotIntoPanel(columnSlot: DkColumnMeshSlot, fromPanel: DkColumnStructure<T, DkGridPanel>, destinationPanel: DkColumnStructure<T, DkGridPanel>): DkColumnDef[];
    moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkColumnStructure<T, DkGridPanel>, destinationSlot: DkMeshSlot): void;
    swapColumnSlotsInDifferentPanel(sourcePanel: DkContentColumnStructure<T>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkContentColumnStructure<T>, destinationSlot: DkColumnMeshSlot): void;
    joinColumnGroupSlots(sourcePanel: DkContentColumnStructure<T>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkContentColumnStructure<T>, destinationSlot: DkColumnMeshSlot): void;
    interchageColumnSlots(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkColumnStructure<T, DkGridPanel>, destinationSlot: DkMeshSlot): void;
    doSlotsBelongToSameGroup(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkColumnStructure<T, DkGridPanel>, destinationSlot: DkMeshSlot): boolean;
    swapColumnSlotsInSamePanel(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationSlot: DkColumnMeshSlot): void;
    moveColumnSlotToGutterSlotInSamePanel(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationSlot: DkMeshSlot): void;
    protected setChangeColumnSlotsSubscription(): void;
    protected setChangeDataColumnSlotsSubscription(): void;
    protected setChangeListHeightSubscription(): void;
    protected setChangeShareableDropElementsSubscription(): void;
    private setChangeNonGroupableSubscription;
    private isBeforeOrAfterMovement;
    private setEmitColumnResizingSubscription;
    private emitSwappedColumnsInSamePanel;
    private emitSwappedColumnsInDifferentPanel;
    private emitJoinedColumnGroup;
    private emitColumnToGutter;
    private emitColumnsToPanel;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridPanelDispatcher<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridPanelDispatcher<any>>;
}
