import { OnInit, QueryList, AfterViewInit, OnDestroy, AfterViewChecked } from '@angular/core';
import { ScrollDispatcher, CdkScrollable } from '@angular/cdk/scrolling';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { DkContentPanelDispatcher } from '../../content/dk-content-panel-dispatcher.service';
import { DkGridEditionConfig } from '../../editing/dk-grid-edition-config.service';
import { DkGridSelectionConfig } from '../../selection/dk-grid-selection-config.service';
import { DkRowGroupingConfig } from '../../row-grouping/dk-row-grouping-config.service';
import { DkRowGroupingDispatcher } from '../../row-grouping/dk-row-grouping-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkRowPanelsComponent<T extends object> implements OnInit, AfterViewInit, AfterViewChecked, OnDestroy {
    private dikeConfig;
    contentPanelDispatcher: DkContentPanelDispatcher<T>;
    private scrollDispatcher;
    private gridEditionConfig;
    private gridSelectionConfig;
    private rowGroupingConfig;
    private rowGroupingDispatcher;
    isContentContainer: boolean;
    wrapperType: 'header' | 'filter' | 'content' | 'empty-content' | 'scrolling';
    scrollablePanels: QueryList<CdkScrollable>;
    onRowGroupingIndent$: Observable<boolean>;
    onEditionMode$: Observable<boolean>;
    onAllowSelection$: Observable<boolean>;
    private unsubscribeAll;
    private changeScrollingSubscription;
    private currentCdkScrollableSubject;
    constructor(dikeConfig: DkConfig, contentPanelDispatcher: DkContentPanelDispatcher<T>, scrollDispatcher: ScrollDispatcher, gridEditionConfig: DkGridEditionConfig<T>, gridSelectionConfig: DkGridSelectionConfig<T>, rowGroupingConfig: DkRowGroupingConfig, rowGroupingDispatcher: DkRowGroupingDispatcher<T>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    ngOnDestroy(): void;
    private moveCdkScrollable;
    private getCdkScrollablePanel;
    private setChangeScrollingSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkRowPanelsComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkRowPanelsComponent<any>, "dk-row-panels", never, { "isContentContainer": "isContentContainer"; "wrapperType": "wrapperType"; }, {}, never, ["[row-grouping-indent]", "[row-checkbox-selection]", "[row-edition-menu]", "[left-panel]", "[left-panel-right-division]", "[center-panel]", "[right-panel-left-division]", "[right-panel]"]>;
}
