import { ChangeDetectorRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridGroupRowEntry } from '../../rows/dk-grid-row-entry';
import { DkRowGroupingDispatcher } from '../dk-row-grouping-dispatcher.service';
import { DkGridFilter } from '../../filtering/dk-grid-filter.service';
import { DkGridSelectionConfig } from '../../selection/dk-grid-selection-config.service';
import * as i0 from "@angular/core";
export declare class DkGridRowGroupComponent<T extends object> implements OnChanges, OnInit, OnDestroy {
    private cdr;
    private gridFilter;
    private gridSelectionConfig;
    private rowGroupingDispatcher;
    row: DkGridGroupRowEntry<T>;
    rowGroupHeight: string;
    rowLevel: number;
    isFilterApplied: boolean;
    allRowsSelected$: Observable<boolean>;
    rowCollapse$: Observable<boolean>;
    onAllowSelection$: Observable<boolean>;
    private unsubscribeAll;
    constructor(cdr: ChangeDetectorRef, gridFilter: DkGridFilter<T>, gridSelectionConfig: DkGridSelectionConfig<T>, rowGroupingDispatcher: DkRowGroupingDispatcher<T>);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    onOpenCloseGroup(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowGroupComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowGroupComponent<any>, "dk-grid-row-group", never, { "row": "row"; "rowGroupHeight": "rowGroupHeight"; }, {}, never, never>;
}
