import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from '../grid/dk-config';
import { DkGroupPanel, DkGridPanel } from '../panels/dk-grid-panels';
import { DkColumnStructure } from '../columns/dk-column-structure';
import { DkGroupColumnStructure } from '../columns/dk-group-column-structure';
import { DkColumnMeshSlot, DkMeshSlot } from '../columns/dk-column-mesh-slot';
import { DkColumnDef } from '../columns/dk-column-def';
import { DkGridConfig } from '../grid/dk-grid-config.service';
import { DkGridFactoryColumns } from '../columns/dk-grid-factory-columns.service';
import { DkGridFactoryMeshSlots } from '../columns/dk-grid-factory-mesh-slots.service';
import { DkGridFilterConfig } from '../filtering/dk-grid-filter-config.service';
import { DkSortDispatcher } from '../sorting/dk-sort-dispatcher.service';
import { DkGridEditionConfig } from '../editing/dk-grid-edition-config.service';
import { DkPanelDispatcher } from '../panels/dk-panel-dispatcher.service';
import { DkRowGroupingConfig } from './dk-row-grouping-config.service';
import * as i0 from "@angular/core";
export declare class DkGroupPanelDispatcher<T extends object> extends DkPanelDispatcher<T, DkGroupPanel> implements OnDestroy {
    private gridFactoryColumns;
    private rowGroupingConfig;
    private nonGroupableDataColumnsSubject;
    private rowGroupingAreaUUID;
    constructor(dikeConfig: DkConfig, gridConfig: DkGridConfig, gridFactoryColumns: DkGridFactoryColumns<T>, gridFactoryMeshSlots: DkGridFactoryMeshSlots<T>, gridFilterConfig: DkGridFilterConfig<T>, sortDispatcher: DkSortDispatcher<T>, gridEditionConfig: DkGridEditionConfig<T>, rowGroupingConfig: DkRowGroupingConfig);
    ngOnDestroy(): void;
    get onNonGroupableDataColumnsChanged$(): Observable<DkColumnDef[]>;
    get groupPanel(): DkGroupColumnStructure<T>;
    get rowGroupingAreaId(): string;
    addColumns(columns: DkColumnDef | DkColumnDef[]): void;
    movePanelColumnSlots(fromPanel: DkColumnStructure<T, DkGridPanel>, destinationPanel: DkGroupColumnStructure<T>, onlyVisibleColumnSlots: boolean): DkColumnDef[];
    moveColumnSlotIntoPanel(columnSlot: DkColumnMeshSlot, fromPanel: DkColumnStructure<T, DkGridPanel>, destinationPanel: DkGroupColumnStructure<T>): DkColumnDef[];
    moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkGroupColumnStructure<T>, destinationSlot: DkMeshSlot): void;
    swapColumnSlotsInDifferentPanel(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkGroupColumnStructure<T>, destinationSlot: DkColumnMeshSlot): void;
    joinColumnGroupSlots(sourcePanel: DkColumnStructure<T, DkGridPanel>, sourceSlot: DkColumnMeshSlot, destinationPanel: DkGroupColumnStructure<T>, destinationSlot: DkColumnMeshSlot): void;
    private getActualGroupableFromClonedColumnsDef;
    private splitGroupableAndNonGroupableBranches;
    private getLeafFromBranch;
    private extractDataColumns;
    private rejectNonGroupableDataColumns;
    private changeNonGroupableDataColumns;
    protected setChangeColumnSlotsSubscription(): void;
    protected setChangeDataColumnSlotsSubscription(): void;
    protected setChangeListHeightSubscription(): void;
    protected setChangeShareableDropElementsSubscription(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGroupPanelDispatcher<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGroupPanelDispatcher<any>>;
}
