import { FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { DkDataColumnDef } from '../columns/dk-column-def';
import { RowEditionActions, RowFormField, RowStatus } from '../editing/dk-edition.model';
import { DkContentPanel } from '../panels/dk-grid-panels';
export declare abstract class DkGridRowEntry {
    isGroup: boolean;
    protected isSelected: boolean;
    private selectedSubject;
    private timestampSubject;
    constructor(timestampCreation: number);
    get selectedChange(): Observable<boolean>;
    get timestampChange(): Observable<number>;
    get timestamp(): number;
    set timestamp(value: number);
    get selected(): boolean;
    set selected(value: boolean);
    protected changeSelected(value: boolean): void;
    protected changeTimestamp(value: number): void;
    dispose(): void;
}
export declare class DkGridGroupRowEntry<T extends object> extends DkGridRowEntry {
    private groupKey;
    private groupId;
    private groupLevel;
    private groupTotalCount;
    private dataColumnDef;
    private dataRowEntries;
    private groupCount;
    private selectedRowsCount;
    private selectedRowsTotal;
    private collapseSubject;
    private allRowsSelectedSubject;
    private someRowsSelectedSubject;
    constructor(groupKey: unknown, groupId: string, groupLevel: number, groupTotalCount: number, dataColumnDef: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>, dataRowEntries: DkGridDataRowEntry<T>[], timestamp: number);
    get collapseChange(): Observable<boolean>;
    get allRowsSelectedChange(): Observable<boolean>;
    get someRowsSelectedChange(): Observable<boolean>;
    get key(): unknown;
    get id(): string;
    get level(): number;
    get count(): number;
    set count(value: number);
    get totalCount(): number;
    get totalSelectableRows(): number;
    set totalSelectableRows(value: number);
    get rowSelectionCount(): number;
    set rowSelectionCount(value: number);
    get collapse(): boolean;
    set collapse(value: boolean);
    get allRowsSelected(): boolean;
    set allRowsSelected(value: boolean);
    get someRowsSelected(): boolean;
    set someRowsSelected(value: boolean);
    get dataColumn(): DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    get dataRows(): DkGridDataRowEntry<T>[];
    dispose(): void;
    private changeCollapse;
    private changeAllRowsSelected;
    private changeSomeRowsSelected;
}
export declare class DkGridDataRowEntry<T extends object> extends DkGridRowEntry {
    private rowId;
    private rowEntry;
    rowFormFields: Map<string, RowFormField>;
    private rowStatus;
    private rowEditionActions;
    private rowFormGroupSubject;
    private isRowEditingSubject;
    constructor(rowId: number, timestamp: number, rowEntry: T);
    get rowFormGroupChange(): Observable<FormGroup>;
    get editionActionsChange(): Observable<RowEditionActions>;
    get isEditingChange(): Observable<boolean>;
    get id(): number;
    get entry(): T;
    get status(): RowStatus;
    set status(value: RowStatus);
    get isEditing(): boolean;
    set isEditing(value: boolean);
    get rowFormGroup(): FormGroup;
    set rowFormGroup(value: FormGroup);
    getRowPanelFormGroup(panel: DkContentPanel): FormGroup;
    dispose(): void;
    private changeRowEditionActions;
    private changeRowFormGroup;
    private changeRowEditing;
}
