import { OnChanges, SimpleChanges, ChangeDetectorRef, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { DkGridRowEntry } from '../../rows/dk-grid-row-entry';
import { DkGridSelection, SelectableFn } from '../dk-grid-selection.service';
import { DkGridSelectionConfig } from '../dk-grid-selection-config.service';
import * as i0 from "@angular/core";
export declare class DkGridRowSelectionComponent<T extends object> implements OnChanges, OnDestroy {
    private dikeConfig;
    private cdr;
    private gridSelection;
    private gridSelectionConfig;
    row: DkGridRowEntry;
    isHeaderRow: boolean;
    isIndependentTrack: boolean;
    rowContentHeightPx: string;
    rowHorizontalGutterHeightPx: string;
    isVerticalLineVisible: boolean;
    selectableRow: SelectableFn<T>;
    isSelected: boolean;
    rowContentWidthPx: string;
    rowVerticalGutterWidthPx: string;
    rowGridDisplay: {
        display: string;
        gridTemplateRows: string;
        gridTemplateColumns: string;
    };
    enableAllRowSelection$: Observable<boolean>;
    allSelected$: Observable<boolean>;
    someSelected$: Observable<boolean>;
    private changesSelectionSubscription;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, gridSelection: DkGridSelection<T>, gridSelectionConfig: DkGridSelectionConfig<T>);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    changeSelection(value: boolean): void;
    selectAll(value: boolean): void;
    private setGridDisplay;
    private setChangesSelectionSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowSelectionComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowSelectionComponent<any>, "dk-grid-row-selection", never, { "row": "row"; "isHeaderRow": "isHeaderRow"; "isIndependentTrack": "isIndependentTrack"; "rowContentHeightPx": "rowContentHeightPx"; "rowHorizontalGutterHeightPx": "rowHorizontalGutterHeightPx"; "isVerticalLineVisible": "isVerticalLineVisible"; "selectableRow": "selectableRow"; }, {}, never, never>;
}
