import { EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { SelectableFn } from './dk-grid-selection.service';
import * as i0 from "@angular/core";
export declare class DkGridSelectionConfig<T extends object> implements OnDestroy {
    readonly selectionEmitter: EventEmitter<DkGridDataRowEntry<T>[]>;
    readonly selectedRowEmitter: EventEmitter<DkGridDataRowEntry<T>>;
    readonly deselectedRowEmitter: EventEmitter<DkGridDataRowEntry<T>>;
    private allowSelectionSubject;
    private enableAllRowsSelectionSubject;
    private defaultSelectableFn;
    private selectableFnSubject;
    constructor();
    ngOnDestroy(): void;
    get onAllowSelectionChanged$(): Observable<boolean>;
    get onEnableAllRowsSelectionChanged$(): Observable<boolean>;
    get onSelectableFnChanged$(): Observable<SelectableFn<T>>;
    get allowSelection(): boolean;
    set allowSelection(value: boolean);
    get enableAllRowsSelection(): boolean;
    set enableAllRowsSelection(value: boolean);
    get selectableFn(): SelectableFn<T>;
    set selectableFn(value: SelectableFn<T>);
    private changeAllowSelection;
    private changeEnableAllRowsSelection;
    private changeSelectableFn;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridSelectionConfig<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridSelectionConfig<any>>;
}
