import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { DkGridSelectionConfig } from './dk-grid-selection-config.service';
import { DkRowGroupingDispatcher } from '../row-grouping/dk-row-grouping-dispatcher.service';
import * as i0 from "@angular/core";
export declare type SelectableFn<T> = (entry: T) => boolean;
export declare class DkGridSelection<T extends object> implements OnDestroy {
    private gridSelectionConfig;
    private rowGroupingDispatcher;
    private selectedRows;
    private changesAllowSelectionSubscription;
    constructor(gridSelectionConfig: DkGridSelectionConfig<T>, rowGroupingDispatcher: DkRowGroupingDispatcher<T>);
    ngOnDestroy(): void;
    get selectionChange(): Observable<DkGridDataRowEntry<T>[]>;
    get selectedRowChange(): Observable<DkGridDataRowEntry<T>>;
    get deselectedRowChange(): Observable<DkGridDataRowEntry<T>>;
    get selectableRows(): SelectableFn<T>;
    set selectableRows(value: SelectableFn<T>);
    selectOne(row: DkGridDataRowEntry<T>): void;
    select(rows: DkGridDataRowEntry<T>[]): void;
    deselectOne(row: DkGridDataRowEntry<T>): void;
    deselect(rows: DkGridDataRowEntry<T>[]): void;
    getSelectedRows(): DkGridDataRowEntry<T>[];
    getSelectedEntries(): T[];
    selectAll(): void;
    deselectAll(): void;
    private releaseSelection;
    private changeSelection;
    private changeSelectedRow;
    private changeDeselectedRow;
    private setChangesAllowSelectionSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridSelection<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridSelection<any>>;
}
