import { EventEmitter, OnDestroy } from '@angular/core';
import { MatSort, MatSortable, SortDirection } from '@angular/material/sort';
import { Observable } from 'rxjs';
import { DkConfig } from '../grid/dk-config';
import { DkDataColumnDef } from '../columns/dk-column-def';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { DkColumnSortEvent } from './dk-grid-sorting.service';
import * as i0 from "@angular/core";
export declare class DkSortDispatcher<T extends object> implements OnDestroy {
    private dikeConfig;
    readonly sortChangeEmitter: EventEmitter<DkColumnSortEvent<T>>;
    private allowSortingSubject;
    private dataSortSubject;
    private changeAllowSortingSubscription;
    constructor(dikeConfig: DkConfig);
    ngOnDestroy(): void;
    get onAllowSortingChanged$(): Observable<boolean>;
    get onDataSortChanged$(): Observable<MatSort | null>;
    get allowSorting(): boolean;
    set allowSorting(value: boolean);
    get dataSort(): MatSort;
    set dataSort(value: MatSort);
    initialized(): Observable<void>;
    isColumnActiveSortable(columnId: string): boolean;
    updateActiveSortable(newColumnId: string): void;
    clearSorting(): void;
    getSortAlternativeColumnId(columnId: string): string;
    addSortable(columnId: string): MatSortable;
    removeSortable(columnId: string): MatSortable;
    quickSort(rows: DkGridDataRowEntry<T>[], direction: SortDirection, column: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>): DkGridDataRowEntry<T>[];
    private getPreviousActiveSortDirection;
    private getSortDirectionStates;
    private changeAllowSorting;
    private changeDataSort;
    private setChangeAllowSortingSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkSortDispatcher<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkSortDispatcher<any>>;
}
