import * as i0 from '@angular/core';
import { InjectionToken, Injectable, Inject, Optional, EventEmitter, Component, ChangeDetectionStrategy, Input, ContentChildren, NgModule, ViewEncapsulation, Directive, HostListener, HostBinding, Pipe, ViewChild, ViewChildren, Output, Injector, ElementRef, TemplateRef } from '@angular/core';
import * as i6 from '@angular/material/form-field';
import { MatFormFieldModule, MAT_FORM_FIELD_DEFAULT_OPTIONS } from '@angular/material/form-field';
import * as i8 from '@angular/common';
import { CommonModule, DOCUMENT } from '@angular/common';
import { coerceNumberProperty, coerceBooleanProperty } from '@angular/cdk/coercion';
import { BehaviorSubject, defer, Observable, Subscription, of, Subject, merge, fromEvent, EMPTY, asapScheduler, combineLatest, NEVER, zip, asyncScheduler } from 'rxjs';
import * as i1 from '@angular/forms';
import { FormGroup, Validators, FormControl, ReactiveFormsModule } from '@angular/forms';
import * as i5 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i3 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i7 from '@angular/material/select';
import { MatSelect, MatSelectModule, MAT_SELECT_SCROLL_STRATEGY } from '@angular/material/select';
import * as i7$1 from '@angular/material/list';
import { MatSelectionList, MatListModule } from '@angular/material/list';
import * as i3$1 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i9 from '@angular/material/datepicker';
import { MatDatepickerModule, MAT_DATEPICKER_SCROLL_STRATEGY } from '@angular/material/datepicker';
import * as i11 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5$1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { map, takeUntil, tap, concatMap, debounceTime, distinctUntilChanged, take, observeOn, switchMap, skip, filter, catchError, throttleTime } from 'rxjs/operators';
import * as i8$1 from '@angular/material/core';
import { MatRippleModule } from '@angular/material/core';
import * as i2 from '@angular/cdk/scrolling';
import { CdkVirtualScrollViewport, CdkScrollable, ScrollingModule, CdkVirtualForOf } from '@angular/cdk/scrolling';
import * as i9$1 from '@angular/material/menu';
import { MatMenuModule, MAT_MENU_SCROLL_STRATEGY } from '@angular/material/menu';
import * as i15 from '@angular/material/badge';
import { MatBadgeModule } from '@angular/material/badge';
import * as i14 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import { DataSource, isDataSource } from '@angular/cdk/collections';
import * as i18 from '@angular/cdk/drag-drop';
import { DragDropModule } from '@angular/cdk/drag-drop';
import * as i1$1 from '@angular/cdk/overlay';
import { OverlayConfig, OverlayModule, Overlay, ScrollDispatcher } from '@angular/cdk/overlay';
import * as i3$2 from '@angular/material/sort';
import { MatSortModule, MatSort } from '@angular/material/sort';
import * as i8$2 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import { NestedTreeControl, CdkTreeModule } from '@angular/cdk/tree';
import * as i2$1 from '@angular/material/tree';
import { MatTreeNestedDataSource, MatTreeModule } from '@angular/material/tree';
import * as i7$2 from '@angular/material/divider';
import { MatDividerModule } from '@angular/material/divider';
import { ComponentPortal } from '@angular/cdk/portal';
import * as i42 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import * as i43 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import * as i1$2 from '@angular/material/snack-bar';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import * as i3$3 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';

const DK_CONFIG = {
    HEIGHT: '90vh',
    WIDTH: 'auto',
    HEADER_ROW_HEIGHT: 60,
    FILTER_ROW_HEIGHT: 55,
    CONTENT_ROW_HEIGHT: 50,
    ROW_GROUPING_ROW_HEIGHT: 71,
    ROW_GROUPING_COLUMN_HEIGHT: 36,
    PAGINATION_ROW_HEIGHT: 64,
    EDITION_TOOLBAR_ROW_HEIGHT: 55,
    EDITION_TOOLBAR_ITEM_HEIGHT: 42,
    DIVISION_PANEL_LINE_WIDTH: 1,
    DIVISION_PANEL_LINE_WIDTH_RESIZING: 5,
    DIVISION_PANEL_GAP: 13,
    BORDER_WIDTH: 1,
    BORDER_GAP: 15,
    ROW_INDEX: 70,
    FILTER_DEBOUNCE_TIME: 400,
    COLUMN_CONTEXT_MENU: true,
    COLUMN_CONTEXT_MENU_WIDTH: 345,
    COLUMN_CONTEXT_MENU_HEIGHT: 490,
    LOADING_MESSAGE: 'Loading',
    PROCESSING_MESSAGE: 'Processing',
    CUSTOM_SCROLLBARS: true,
    VERTICAL_ROW_LINES: false,
    STRIPED_ROWS: false,
    ROW_GROUPING_INDENT: true,
    ROW_GROUPING_INDENT_WIDTH: 25,
    ALLOW_PAGINATION: false,
    PAGE_SIZE: 50,
    ALLOW_COLUMN_DRAGGING: false,
    // Immutable properties:
    GRID_ELEVATION: 2,
    MIN_GRID_ELEVATION: 0,
    MAX_GRID_ELEVATION: 24,
    SORT_SUFIX: 'sort-bis',
    FILTER_SUFIX: 'row-filter',
    HORIZONTAL_SCROLL_HEIGHT: 20,
    DRAGGABLE_CELL_HEIGHT: 45,
    ROW_EDITION_MENU_CELL_WIDTH: 60,
    THROTTLE_CHANGING_GRID_EDITION_PRISTINE_STATUS: 10,
    ROW_SELECTION_CELL_WIDTH: 60,
    DROP_BORDER_CONTAINER_WIDTH: 5,
    THROTTLE_CHANGING_GRID_STRUCTURE_TIME: 10,
    COLUMN_GAP: 5,
    ROW_GAP: 3,
    DRAGGABLE_COLUMN: 40,
    THROTTLE_SCROLL_TIME: 0,
    COLUMN_WIDTH: 200,
    MAT_SELECT_PANEL_CLASS: 'dkg-custom-select-panel',
    ROW_GROUPING_CELL_WIDTH: 60,
    ROW_GROUPING_COLLAPSE_CELL_WIDTH: 55,
    ROW_GROUPING_INFO_ICON_WIDTH: 60
};
const CONFIG_GRID = new InjectionToken('CONFIG_GRID', {
    factory: () => DK_CONFIG
});

function generateUUID() {
    let dt = new Date().getTime();
    let uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, c => {
        var r = (dt + Math.random() * 16) % 16 | 0;
        dt = Math.floor(dt / 16);
        return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
    });
    return uuid;
}

class DkColumn {
    constructor(fieldName, headerText) {
        this.columnId = generateUUID();
        this._fieldName = fieldName;
        this._headerText = headerText;
        this._dataType = 'Text';
        this.order = -1;
        this.width = 0;
        this.minWidth = 0;
        this.maxWidth = 0;
        this.contentAlign = 'left';
        this.headerTooltip = '';
        this.resizable = false;
        this.draggable = false;
        this.locked = false;
        this.visible = true;
        this.sortable = false;
        this.filterable = false;
        this.editable = false;
        this.groupable = false;
        this.displayMenu = true;
        this.panel = 'centerPanel';
    }
    get fieldName() {
        return this._fieldName;
    }
    get headerText() {
        return this._headerText;
    }
    get dataType() {
        return this._dataType;
    }
    resizeWidth(value) {
        if (this.resizable) {
            return this.setWidth(value);
        }
        return false;
    }
    assign(column) {
        this._fieldName = column.fieldName;
        this._headerText = column.headerText;
        this._dataType = column.dataType;
        this.order = column.order;
        this.width = column.width;
        this.minWidth = column.minWidth;
        this.maxWidth = column.maxWidth;
        this.contentAlign = column.contentAlign;
        this.headerTooltip = column.headerTooltip;
        this.resizable = column.resizable;
        this.draggable = column.draggable;
        this.locked = column.locked;
        this.visible = column.visible;
        this.sortable = column.sortable;
        this.filterable = column.filterable;
        this.editable = column.editable;
        this.groupable = column.groupable;
        this.displayMenu = column.displayMenu;
        this.columnType = column.columnType;
        this.panel = column.panel;
        return this;
    }
    setWidth(value) {
        if (value >= this.minWidth && value <= this.maxWidth) {
            this.width = value;
            return true;
        }
        return false;
    }
}
class DkGutterColumn extends DkColumn {
    constructor(fieldName) {
        super(fieldName, '');
        this.columnType = 'Gutter-Column';
    }
    assign(column) {
        super.assign(column);
        this.columnIdBelongTo = column.columnIdBelongTo;
        return this;
    }
}
class DkRowIndexColumn extends DkColumn {
    constructor(headerText) {
        super('Row-Index-Column', headerText);
        this.columnType = 'Row-Index-Column';
        this.contentAlign = 'end';
    }
}
class DkScrollbarGapColumn extends DkColumn {
    constructor() {
        super('Scrollbar-Gap-Column', '');
        this.columnType = 'Scrollbar-Gap-Column';
    }
}
class DkDataColumn extends DkColumn {
    constructor(fieldName, headerText, dataType) {
        super(fieldName, headerText);
        this._dataType = dataType;
        this.contentAlign = this.getContentAlignment(this.dataType);
        this.columnType = 'Data-Column';
        this.getValue = null;
        this.setValue = null;
    }
    assign(column) {
        super.assign(column);
        this.getValue = column.getValue;
        this.setValue = column.setValue;
        return this;
    }
    getContentAlignment(dataType) {
        switch (dataType) {
            case 'Binary':
            case 'Date':
                return 'center';
            case 'Numeric':
                return 'end';
            default:
                return 'start';
        }
    }
}
class DkGroupColumn extends DkColumn {
    constructor(groupName, headerText) {
        super(groupName, headerText);
        this._dataType = 'Text';
        this.columnType = 'Group-Column';
    }
}

class DkColumnDef {
    constructor(fieldName, headerText) {
        this._fieldName = fieldName;
        this._headerText = headerText;
        this.slotId = null;
        this.belongToGroup = null;
        this.columnId = null;
        this.order = -1;
        this.headerTooltip = '';
        this.resizable = false;
        this.draggable = false;
        this.locked = false;
        this.visible = true;
        this.displayMenu = true;
        this.panel = 'centerPanel';
        this.displayOn = 'open';
    }
    get fieldName() {
        return this._fieldName;
    }
    get headerText() {
        return this._headerText;
    }
    assign(column) {
        this.slotId = column.slotId;
        this.belongToGroup = column.belongToGroup;
        this.columnId = column.columnId;
        this._fieldName = column.fieldName;
        this._headerText = column.headerText;
        this.order = column.order;
        this.headerTooltip = column.headerTooltip;
        this.resizable = column.resizable;
        this.draggable = column.draggable;
        this.locked = column.locked;
        this.visible = column.visible;
        this.displayMenu = column.displayMenu;
        this.panel = column.panel;
        this.displayOn = column.displayOn;
        return this;
    }
}
class DkGroupColumnDef extends DkColumnDef {
    constructor(fieldName, headerText) {
        super(fieldName, headerText);
        this.children = null;
        this.displayStatus = 'open';
    }
    assign(column) {
        super.assign(column);
        if (!!column.children && column.children.length > 0) {
            this.children = [];
            column.children.forEach(childColumn => {
                let newChildColumn;
                if (isDkGroupColumnDef(childColumn)) {
                    newChildColumn = new DkGroupColumnDef(childColumn.fieldName, childColumn.headerText).assign(childColumn);
                }
                else if (isDkDataColumnDef(childColumn)) {
                    newChildColumn = DkDataColumnDef.getDataColumnDefInstance(childColumn.fieldName, childColumn.headerText, childColumn.dataType).assign(childColumn);
                }
                this.children.push(newChildColumn);
            });
        }
        this.displayStatus = column.displayStatus;
        return this;
    }
}
class DkDataColumnDef extends DkColumnDef {
    constructor(fieldName, headerText, dataType) {
        super(fieldName, headerText);
        this._dataType = dataType;
        this.width = 0;
        this.minWidth = 0;
        this.maxWidth = 0;
        this.contentAlign = 'start';
        this.sortable = false;
        this.filterable = false;
        this.editable = false;
        this.groupable = false;
        this.editionSettings = null;
        this.editionTemplate = null;
        this.displayTemplate = null;
    }
    get dataType() {
        return this._dataType;
    }
    assign(column) {
        super.assign(column);
        this._dataType = column.dataType;
        this.width = column.width;
        this.minWidth = column.minWidth;
        this.maxWidth = column.maxWidth;
        this.contentAlign = column.contentAlign;
        this.sortable = column.sortable;
        this.filterable = column.filterable;
        this.editable = column.editable;
        this.groupable = column.groupable;
        this.filter = !!column.filter ? [...column.filter] : null;
        this.customFilterConditions = column.customFilterConditions;
        this.getValue = column.getValue;
        this.setValue = column.setValue;
        if (!!column.editionSettings) {
            this.editionSettings = Object.assign({}, column.editionSettings);
        }
        this.editionTemplate = column.editionTemplate;
        this.displayTemplate = column.displayTemplate;
        return this;
    }
    static getDataColumnDefInstance(fieldName, headerText, dataType) {
        switch (dataType) {
            case 'Binary':
                return new DkBinaryColumnDef(fieldName, headerText);
            case 'Date':
                return new DkDateColumnDef(fieldName, headerText);
            case 'Numeric':
                return new DkNumericColumnDef(fieldName, headerText);
            default:
                return new DkTextColumnDef(fieldName, headerText);
        }
    }
}
class DkTextColumnDef extends DkDataColumnDef {
    constructor(fieldName, headerText) {
        super(fieldName, headerText, 'Text');
        this.getValue = (entry) => {
            return (entry[this.fieldName]);
        };
        this.setValue = (entry, value) => {
            entry[this.fieldName] = value;
        };
        this._filter = null;
        this._customFilterConditions = null;
    }
    get filter() {
        return !!this._filter ? [...this._filter] : null;
    }
    set filter(value) {
        this._filter = !!value ? [...value] : value;
    }
    get customFilterConditions() {
        return this._customFilterConditions;
    }
    set customFilterConditions(value) {
        this._customFilterConditions = value;
    }
}
class DkNumericColumnDef extends DkDataColumnDef {
    constructor(fieldName, headerText) {
        super(fieldName, headerText, 'Numeric');
        this.getValue = (entry) => {
            return (entry[this.fieldName]);
        };
        this.setValue = (entry, value) => {
            entry[this.fieldName] = value;
        };
        this.contentAlign = 'end';
        this._filter = null;
        this._customFilterConditions = null;
    }
    get filter() {
        return !!this._filter ? [...this._filter] : null;
    }
    set filter(value) {
        this._filter = !!value ? [...value] : value;
    }
    get customFilterConditions() {
        return this._customFilterConditions;
    }
    set customFilterConditions(value) {
        this._customFilterConditions = value;
    }
}
class DkDateColumnDef extends DkDataColumnDef {
    constructor(fieldName, headerText) {
        super(fieldName, headerText, 'Date');
        this.getValue = (entry) => {
            return (entry[this.fieldName]);
        };
        this.setValue = (entry, value) => {
            entry[this.fieldName] = value;
        };
        this.contentAlign = 'center';
        this.filter = null;
        this._customFilterConditions = null;
    }
    get filter() {
        return !!this._filter ? [...this._filter] : null;
    }
    set filter(value) {
        this._filter = !!value ? [...value] : value;
    }
    get customFilterConditions() {
        return this._customFilterConditions;
    }
    set customFilterConditions(value) {
        this._customFilterConditions = value;
    }
}
class DkBinaryColumnDef extends DkDataColumnDef {
    constructor(fieldName, headerText) {
        super(fieldName, headerText, 'Binary');
        this.getValue = (entry) => {
            return (entry[this.fieldName]);
        };
        this.setValue = (entry, value) => {
            entry[this.fieldName] = value;
        };
        this.contentAlign = 'center';
        this._filter = null;
        this._customFilterConditions = null;
    }
    get filter() {
        return !!this._filter ? [...this._filter] : null;
    }
    set filter(value) {
        this._filter = !!value ? [...value] : value;
    }
    get customFilterConditions() {
        return this._customFilterConditions;
    }
    set customFilterConditions(value) {
        this._customFilterConditions = value;
    }
}
function isDkGroupColumnDef(column) {
    return column instanceof DkGroupColumnDef;
}
function isDkDataColumnDef(column) {
    return column instanceof DkDataColumnDef;
}

var ConditionType;
(function (ConditionType) {
    ConditionType["EQUALS"] = "equals";
    ConditionType["NOT_EQUALS"] = "notEquals";
    ConditionType["CONTAINS"] = "contains";
    ConditionType["NOT_CONTAINS"] = "notContains";
    ConditionType["STARTS_WITH"] = "startsWith";
    ConditionType["ENDS_WITH"] = "endsWith";
    ConditionType["LESS_THAN"] = "lessThan";
    ConditionType["LESS_THAN_OR_EQUAL"] = "lessThanOrEqual";
    ConditionType["GREATER_THAN"] = "greaterThan";
    ConditionType["GREATER_THAN_OR_EQUAL"] = "greaterThanOrEqual";
    ConditionType["RANGE"] = "range";
    ConditionType["EMPTY"] = "empty";
    ConditionType["NOT_EMPTY"] = "notEmpty";
})(ConditionType || (ConditionType = {}));
class DkFilterCondition {
    constructor() {
        this.indexConditions = {};
        this.addCondition({
            text: 'Empty',
            value: ConditionType.EMPTY,
            eval: (entry, dataColumnDef) => {
                let fieldValue = dataColumnDef.getValue(entry);
                return fieldValue === null || fieldValue === undefined || new String(fieldValue).valueOf().trim() === '';
            }
        });
    }
    assign(filterConditions) {
        Object.getOwnPropertyNames(filterConditions.indexConditions).forEach(keyName => {
            this.indexConditions[keyName] = Object.assign({}, filterConditions.indexConditions[keyName]);
        });
        return this;
    }
    get conditions() {
        let arrayConditions = [];
        Object.getOwnPropertyNames(this.indexConditions).forEach(keyName => {
            arrayConditions.push(Object.assign({}, this.indexConditions[keyName]));
        });
        return arrayConditions;
    }
    addCondition(condition) {
        if (condition) {
            this.indexConditions[condition.value] = Object.assign({}, condition);
        }
        return this;
    }
    removeCondition(name) {
        let foundCondition = this.getCondition(name);
        if (foundCondition) {
            delete this.indexConditions[name];
        }
        return foundCondition;
    }
    getCondition(name) {
        return this.indexConditions[name] ? Object.assign({}, this.indexConditions[name]) : null;
    }
}
class DkSelectionFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        this.dikeFilterOptions = [];
    }
    assign(value) {
        super.assign(value);
        value.dikeFilterOptions.forEach(option => {
            this.dikeFilterOptions.push(Object.assign({}, option));
        });
        return this;
    }
    addCondition(condition) {
        if (condition && this.isValidCondition(condition.value)) {
            super.addCondition(condition);
        }
        else {
            throw new Error(`Error from abstract DkSelectionFilterCondition - Conditions different from empty, equals or notEquals are not allowed in multiple-selection instances.`);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
                return true;
            default:
                return false;
        }
    }
}
class DkBinarySelectionFilterCondition extends DkSelectionFilterCondition {
    constructor() {
        super();
        this.MAX_OPTIONS = 2;
    }
    set options(options) {
        if (options.length !== this.MAX_OPTIONS) {
            throw new Error(`Error from abstract DkBinarySelectionFilterCondition - The number of options must be ${this.MAX_OPTIONS}. If there are more than 2 options to be assigned a concrete class from abstract DkMultipleSelectionFilterCondition class must be used.`);
        }
        this.dikeFilterOptions = [];
        options.forEach(option => this.dikeFilterOptions.push(Object.assign({}, option)));
    }
    get options() {
        return [...this.dikeFilterOptions];
    }
    assign(value) {
        super.assign(value);
        if (this.dikeFilterOptions.length > this.MAX_OPTIONS) {
            this.dikeFilterOptions = this.dikeFilterOptions.slice(0, this.MAX_OPTIONS);
        }
        return this;
    }
}
class DkMultipleSelectionFilterCondition extends DkSelectionFilterCondition {
    constructor() {
        super();
    }
    set options(options) {
        this.dikeFilterOptions = [];
        options.forEach(option => this.dikeFilterOptions.push(Object.assign({}, option)));
    }
    get options() {
        return [...this.dikeFilterOptions];
    }
    assign(value) {
        super.assign(value);
        return this;
    }
}

class DkTextCaseFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        this.equals();
        this.notEquals();
        this.contains();
        this.notContains();
        this.startsWith();
        this.endsWith();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    fieldValue === values.value : fieldValue.toLowerCase() === values.value.toLowerCase();
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    fieldValue !== values.value : fieldValue.toLowerCase() !== values.value.toLowerCase();
            }
        });
    }
    contains() {
        this.addCondition({
            text: 'Contains',
            value: ConditionType.CONTAINS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    fieldValue.includes(values.value) : fieldValue.toLowerCase().includes(values.value.toLowerCase());
            }
        });
    }
    notContains() {
        this.addCondition({
            text: 'Not Contains',
            value: ConditionType.NOT_CONTAINS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    !fieldValue.includes(values.value) : !fieldValue.toLowerCase().includes(values.value.toLowerCase());
            }
        });
    }
    startsWith() {
        this.addCondition({
            text: 'Starts With',
            value: ConditionType.STARTS_WITH,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    fieldValue.startsWith(values.value) : fieldValue.toLowerCase().startsWith(values.value.toLowerCase());
            }
        });
    }
    endsWith() {
        this.addCondition({
            text: 'Ends With',
            value: ConditionType.ENDS_WITH,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return values.caseSensitive ?
                    fieldValue.endsWith(values.value) : fieldValue.toLowerCase().endsWith(values.value.toLowerCase());
            }
        });
    }
    isNullOrUndefined(fieldValue) {
        return fieldValue === 'null' || fieldValue === 'undefined' ? '' : fieldValue;
    }
}
class CustomTextCaseFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkTextCaseFilterCondition().getCondition(name);
        if (condition && this.isValidCondition(name)) {
            this.addCondition(condition);
        }
        else {
            throw new Error(`Error from CustomTextCaseFilterCondition - Conditions different from empty, equals, notEquals, contains, not contains, starts with or ends with are not allowed in text instances.`);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
            case ConditionType.CONTAINS:
            case ConditionType.NOT_CONTAINS:
            case ConditionType.STARTS_WITH:
            case ConditionType.ENDS_WITH:
                return true;
            default:
                return false;
        }
    }
}
class CustomRowTextCaseFilterCondition extends CustomTextCaseFilterCondition {
    constructor() {
        super();
    }
    addCondition(condition) {
        if (condition) {
            if (this.conditions.length > 0) {
                this.indexConditions = {};
            }
            super.addCondition(condition);
        }
        return this;
    }
}

class DkNumericFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        // For Numeric type, the Empty condition has a different implementation:
        this.addCondition({
            text: 'Empty',
            value: ConditionType.EMPTY,
            eval: (entry, dataColumnDef) => {
                return Number.isNaN(this.isNullOrUndefined(dataColumnDef.getValue(entry)));
            }
        });
        this.equals();
        this.notEquals();
        this.lessThan();
        this.lessThanOrEqual();
        this.greaterThan();
        this.greaterThanOrEqual();
        this.range();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue === values.value1;
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue !== values.value1;
            }
        });
    }
    lessThan() {
        this.addCondition({
            text: 'Less Than',
            value: ConditionType.LESS_THAN,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue < values.value1;
            }
        });
    }
    lessThanOrEqual() {
        this.addCondition({
            text: 'Less Than Or Equal',
            value: ConditionType.LESS_THAN_OR_EQUAL,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue <= values.value1;
            }
        });
    }
    greaterThan() {
        this.addCondition({
            text: 'Greater Than',
            value: ConditionType.GREATER_THAN,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue > values.value1;
            }
        });
    }
    greaterThanOrEqual() {
        this.addCondition({
            text: 'Greater Than Or Equal',
            value: ConditionType.GREATER_THAN_OR_EQUAL,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue >= values.value1;
            }
        });
    }
    range() {
        this.addCondition({
            text: 'Range',
            value: ConditionType.RANGE,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue > values.value1 && fieldValue < values.value2;
            }
        });
    }
    isNullOrUndefined(fieldValue) {
        return fieldValue === null || fieldValue === undefined || new String(fieldValue).valueOf().trim() === '' ? NaN : new Number(fieldValue).valueOf();
    }
}
class CustomNumericFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkNumericFilterCondition().getCondition(name);
        if (condition && this.isValidCondition(name)) {
            this.addCondition(condition);
        }
        else {
            throw new Error(`Error from CustomNumericFilterCondition - The given condition (${name}) is not allowed in this numeric instance.`);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
            case ConditionType.LESS_THAN:
            case ConditionType.LESS_THAN_OR_EQUAL:
            case ConditionType.GREATER_THAN:
            case ConditionType.GREATER_THAN_OR_EQUAL:
            case ConditionType.RANGE:
                return true;
            default:
                return false;
        }
    }
}
class CustomRowNumericFilterCondition extends CustomNumericFilterCondition {
    constructor() {
        super();
    }
    addCondition(condition) {
        if (condition) {
            if (this.conditions.length > 0) {
                this.indexConditions = {};
            }
            super.addCondition(condition);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
            case ConditionType.LESS_THAN:
            case ConditionType.LESS_THAN_OR_EQUAL:
            case ConditionType.GREATER_THAN:
            case ConditionType.GREATER_THAN_OR_EQUAL:
                return true;
            default:
                return false;
        }
    }
}

class DkBinaryFilterCondition extends DkBinarySelectionFilterCondition {
    constructor() {
        super();
        this.options = [{ label: 'TRUE', value: 'true' }, { label: 'FALSE', value: 'false' }];
        this.equals();
        this.notEquals();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = new String(dataColumnDef.getValue(entry)).valueOf();
                let value = new String(values.value).valueOf();
                return fieldValue === value;
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = new String(dataColumnDef.getValue(entry)).valueOf();
                let value = new String(values.value).valueOf();
                return fieldValue !== value;
            }
        });
    }
}
class CustomBinaryFilterCondition extends DkBinarySelectionFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkBinaryFilterCondition().getCondition(name);
        if (condition) {
            this.addCondition(condition);
        }
        return this;
    }
}

class DkDateFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        // For Date type, the Empty condition has a different implementation:
        this.addCondition({
            text: 'Empty',
            value: ConditionType.EMPTY,
            eval: (entry, dataColumnDef) => {
                let fieldValue = dataColumnDef.getValue(entry);
                return fieldValue === null || fieldValue === undefined || new Date(fieldValue).toString() === 'Invalid Date';
            }
        });
        this.equals();
        this.notEquals();
        this.lessThan();
        this.lessThanOrEqual();
        this.greaterThan();
        this.greaterThanOrEqual();
        this.range();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                // Load the date into memory as it comes from the datasource:
                let fieldValue = new Date(dataColumnDef.getValue(entry));
                return fieldValue.getFullYear() === values.value1.getFullYear() &&
                    fieldValue.getMonth() === values.value1.getMonth() &&
                    fieldValue.getDate() === values.value1.getDate();
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                return !this.getCondition(ConditionType.EQUALS).eval(entry, dataColumnDef, values);
            }
        });
    }
    lessThan() {
        this.addCondition({
            text: 'Less Than',
            value: ConditionType.LESS_THAN,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = new Date(dataColumnDef.getValue(entry));
                return fieldValue < values.value1;
            }
        });
    }
    lessThanOrEqual() {
        this.addCondition({
            text: 'Less Than Or Equal',
            value: ConditionType.LESS_THAN_OR_EQUAL,
            eval: (entry, dataColumnDef, values) => {
                return this.getCondition(ConditionType.LESS_THAN).eval(entry, dataColumnDef, values) ||
                    this.getCondition(ConditionType.EQUALS).eval(entry, dataColumnDef, values);
            }
        });
    }
    greaterThan() {
        this.addCondition({
            text: 'Greater Than',
            value: ConditionType.GREATER_THAN,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = new Date(dataColumnDef.getValue(entry));
                return fieldValue > values.value1;
            }
        });
    }
    greaterThanOrEqual() {
        this.addCondition({
            text: 'Greater Than Or Equal',
            value: ConditionType.GREATER_THAN_OR_EQUAL,
            eval: (entry, dataColumnDef, values) => {
                return this.getCondition(ConditionType.GREATER_THAN).eval(entry, dataColumnDef, values) ||
                    this.getCondition(ConditionType.EQUALS).eval(entry, dataColumnDef, values);
            }
        });
    }
    range() {
        this.addCondition({
            text: 'Range',
            value: ConditionType.RANGE,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = new Date(dataColumnDef.getValue(entry));
                return fieldValue > values.value1 && fieldValue < values.value2;
            }
        });
    }
}
class CustomDateFilterCondition extends DkFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkDateFilterCondition().getCondition(name);
        if (condition && this.isValidCondition(name)) {
            this.addCondition(condition);
        }
        else {
            throw new Error(`Error from CustomDateFilterCondition - The given condition (${name}) is not allowed in this date instance.`);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
            case ConditionType.LESS_THAN:
            case ConditionType.LESS_THAN_OR_EQUAL:
            case ConditionType.GREATER_THAN:
            case ConditionType.GREATER_THAN_OR_EQUAL:
            case ConditionType.RANGE:
                return true;
            default:
                return false;
        }
    }
}
class CustomRowDateFilterCondition extends CustomDateFilterCondition {
    constructor() {
        super();
    }
    addCondition(condition) {
        if (condition) {
            if (this.conditions.length > 0) {
                this.indexConditions = {};
            }
            super.addCondition(condition);
        }
        return this;
    }
    isValidCondition(name) {
        switch (name) {
            case ConditionType.EMPTY:
            case ConditionType.EQUALS:
            case ConditionType.NOT_EQUALS:
            case ConditionType.LESS_THAN:
            case ConditionType.LESS_THAN_OR_EQUAL:
            case ConditionType.GREATER_THAN:
            case ConditionType.GREATER_THAN_OR_EQUAL:
                return true;
            default:
                return false;
        }
    }
}

class DkMultipleNumericFilterCondition extends DkMultipleSelectionFilterCondition {
    constructor() {
        super();
        // For Numeric type, the Empty condition has a different implementation:
        this.addCondition({
            text: 'Empty',
            value: ConditionType.EMPTY,
            eval: (entry, dataColumnDef) => {
                return Number.isNaN(this.isNullOrUndefined(dataColumnDef.getValue(entry)));
            }
        });
        this.equals();
        this.notEquals();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue === values.value1;
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(dataColumnDef.getValue(entry));
                return fieldValue !== values.value1;
            }
        });
    }
    isNullOrUndefined(fieldValue) {
        return fieldValue === null || fieldValue === undefined || new String(fieldValue).valueOf().trim() === '' ? NaN : new Number(fieldValue).valueOf();
    }
}
class CustomMultipleNumericFilterCondition extends DkMultipleSelectionFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkMultipleNumericFilterCondition().getCondition(name);
        if (condition) {
            this.addCondition(condition);
        }
        return this;
    }
}

class DkMultipleTextFilterCondition extends DkMultipleSelectionFilterCondition {
    constructor() {
        super();
        this.equals();
        this.notEquals();
    }
    equals() {
        this.addCondition({
            text: 'Equals',
            value: ConditionType.EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return fieldValue === values.value;
            }
        });
    }
    notEquals() {
        this.addCondition({
            text: 'Not Equals',
            value: ConditionType.NOT_EQUALS,
            eval: (entry, dataColumnDef, values) => {
                let fieldValue = this.isNullOrUndefined(new String(dataColumnDef.getValue(entry)).valueOf());
                return fieldValue !== values.value;
            }
        });
    }
    isNullOrUndefined(fieldValue) {
        return fieldValue === 'null' || fieldValue === 'undefined' ? '' : fieldValue;
    }
}
class CustomMultipleTextFilterCondition extends DkMultipleSelectionFilterCondition {
    constructor() {
        super();
        this.removeCondition(ConditionType.EMPTY);
    }
    addExistingCondition(name) {
        let condition = new DkMultipleTextFilterCondition().getCondition(name);
        if (condition) {
            this.addCondition(condition);
        }
        return this;
    }
}

/**
 * This classes are responsible for filtering execution.
 * All the instances are created by DkFilterFactory class.
 */
class DkFilterDispatcherConditions {
    constructor() { }
}
class DkTextCaseFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(textFilterConditions) {
        super();
        this.filterConditions = new CustomTextCaseFilterCondition();
        this.filterConditions.assign(textFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, Object.assign({ caseSensitive: filterable.caseSensitive }, filterable.orConditions[i]));
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = true;
        for (let i = 0; i < filterable.andConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.andConditions[i].condition).eval(entry, dataColumnDef, Object.assign({ caseSensitive: filterable.caseSensitive }, filterable.andConditions[i]));
            if (!trueRow) {
                return false;
            }
        }
        return trueRow;
    }
}
class DkNumericFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(numericFilterConditions) {
        super();
        this.filterConditions = new CustomNumericFilterCondition();
        this.filterConditions.assign(numericFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, filterable.orConditions[i]);
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = true;
        for (let i = 0; i < filterable.andConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.andConditions[i].condition).eval(entry, dataColumnDef, filterable.andConditions[i]);
            if (!trueRow) {
                return false;
            }
        }
        return trueRow;
    }
}
class DkDateFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(dateFilterConditions) {
        super();
        this.filterConditions = new CustomDateFilterCondition();
        this.filterConditions.assign(dateFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, filterable.orConditions[i]);
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = true;
        for (let i = 0; i < filterable.andConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.andConditions[i].condition).eval(entry, dataColumnDef, filterable.andConditions[i]);
            if (!trueRow) {
                return false;
            }
        }
        return trueRow;
    }
}
class DkBinaryFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(binaryFilterConditions) {
        super();
        this.filterConditions = new CustomBinaryFilterCondition();
        this.filterConditions.assign(binaryFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, filterable.orConditions[i]);
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        let trueRow = true;
        for (let i = 0; i < filterable.andConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.andConditions[i].condition).eval(entry, dataColumnDef, filterable.andConditions[i]);
            if (!trueRow) {
                return false;
            }
        }
        return trueRow;
    }
}
class DkMultipleNumericFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(multipleNumericFilterConditions) {
        super();
        this.filterConditions = new CustomMultipleNumericFilterCondition();
        this.filterConditions.assign(multipleNumericFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        if (filterable.orConditions.length === 0) {
            return false;
        }
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, filterable.orConditions[i]);
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        if (filterable.andConditions.length === 0) {
            return false;
        }
        let trueRow = true;
        let andConditionsWithoutEmpty = filterable.andConditions.filter(andFilter => andFilter.condition !== ConditionType.NOT_EMPTY);
        for (let i = 0; i < andConditionsWithoutEmpty.length; i++) {
            trueRow = this.filterConditions.getCondition(andConditionsWithoutEmpty[i].condition).eval(entry, dataColumnDef, andConditionsWithoutEmpty[i]);
            if (!trueRow) {
                return false;
            }
        }
        let notEmptyCondition = filterable.andConditions.find(andFilter => andFilter.condition === ConditionType.NOT_EMPTY);
        if (notEmptyCondition) {
            return trueRow && !this.filterConditions.getCondition(ConditionType.EMPTY).eval(entry, dataColumnDef);
        }
        return trueRow;
    }
}
class DkMultipleTextFilterDispatcherConditions extends DkFilterDispatcherConditions {
    constructor(multipleTextFilterConditions) {
        super();
        this.filterConditions = new CustomMultipleTextFilterCondition();
        this.filterConditions.assign(multipleTextFilterConditions);
    }
    orConditionsEval(entry, filterable, dataColumnDef) {
        if (filterable.orConditions.length === 0) {
            return false;
        }
        let trueRow = false;
        for (let i = 0; i < filterable.orConditions.length; i++) {
            trueRow = this.filterConditions.getCondition(filterable.orConditions[i].condition).eval(entry, dataColumnDef, filterable.orConditions[i]);
            if (trueRow) {
                return true;
            }
        }
        return trueRow;
    }
    andConditionsEval(entry, filterable, dataColumnDef) {
        if (filterable.andConditions.length === 0) {
            return false;
        }
        let trueRow = true;
        let andConditionsWithoutEmpty = filterable.andConditions.filter(andFilter => andFilter.condition !== ConditionType.NOT_EMPTY);
        for (let i = 0; i < andConditionsWithoutEmpty.length; i++) {
            trueRow = this.filterConditions.getCondition(andConditionsWithoutEmpty[i].condition).eval(entry, dataColumnDef, andConditionsWithoutEmpty[i]);
            if (!trueRow) {
                return false;
            }
        }
        let notEmptyCondition = filterable.andConditions.find(andFilter => andFilter.condition === ConditionType.NOT_EMPTY);
        if (notEmptyCondition) {
            return trueRow && !this.filterConditions.getCondition(ConditionType.EMPTY).eval(entry, dataColumnDef);
        }
        return trueRow;
    }
}

const DK_FILTER_BEHAVIOUR = new InjectionToken('dk-filter-behaviour');
const TEXT_FILTER_DEBOUNCE_TIME = new InjectionToken('text-filter-debounce-time');
const NUMERIC_FILTER_DEBOUNCE_TIME = new InjectionToken('numeric-filter-debounce-time');
const CUSTOM_TEXT_FILTER_CONDITIONS = new InjectionToken('custom-text-filter-conditions');
const CUSTOM_NUMERIC_FILTER_CONDITIONS = new InjectionToken('custom-numeric-filter-conditions');
const CUSTOM_DATE_FILTER_CONDITIONS = new InjectionToken('custom-date-filter-conditions');
const CUSTOM_BINARY_FILTER_CONDITIONS = new InjectionToken('custom-binary-filter-conditions');
// Row-Filters:
const CUSTOM_ROW_TEXT_FILTER_CONDITIONS = new InjectionToken('custom-row-text-filter-conditions');
const CUSTOM_ROW_NUMERIC_FILTER_CONDITIONS = new InjectionToken('custom-row-numeric-filter-conditions');
const CUSTOM_ROW_DATE_FILTER_CONDITIONS = new InjectionToken('custom-row-date-filter-conditions');

class DkFilterFactory {
    constructor(dikeConfig, customTextFilterConditions, customNumericFilterConditions, customDateFilterConditions, customBinaryFilterConditions, customRowTextFilterConditions, customRowNumericFilterConditions, customRowDateFilterConditions) {
        this.dikeConfig = dikeConfig;
        this.customTextFilterConditions = customTextFilterConditions;
        this.customNumericFilterConditions = customNumericFilterConditions;
        this.customDateFilterConditions = customDateFilterConditions;
        this.customBinaryFilterConditions = customBinaryFilterConditions;
        this.customRowTextFilterConditions = customRowTextFilterConditions;
        this.customRowNumericFilterConditions = customRowNumericFilterConditions;
        this.customRowDateFilterConditions = customRowDateFilterConditions;
        this.gridCustomFilterConditions = {
            customTextFilterConditions: new CustomTextCaseFilterCondition(),
            customNumericFilterConditions: new CustomNumericFilterCondition(),
            customDateFilterConditions: new CustomDateFilterCondition(),
            customBinaryFilterConditions: new CustomBinaryFilterCondition(),
            customRowTextFilterConditions: new CustomRowTextCaseFilterCondition(),
            customRowNumericFilterConditions: new CustomRowNumericFilterCondition(),
            customRowDateFilterConditions: new CustomRowDateFilterCondition()
        };
        // Standard filters:
        this.dikeTextFilterConditions = new DkTextCaseFilterCondition();
        if (this.customTextFilterConditions === null || this.customTextFilterConditions === undefined) {
            this.customTextFilterConditions = new CustomTextCaseFilterCondition();
        }
        this.dikeNumericFilterConditions = new DkNumericFilterCondition();
        if (this.customNumericFilterConditions === null || this.customNumericFilterConditions === undefined) {
            this.customNumericFilterConditions = new CustomNumericFilterCondition();
        }
        this.dikeDateFilterConditions = new DkDateFilterCondition();
        if (this.customDateFilterConditions === null || this.customDateFilterConditions === undefined) {
            this.customDateFilterConditions = new CustomDateFilterCondition();
        }
        // Multiple filters:
        this.dikeBinaryFilterConditions = new DkBinaryFilterCondition();
        if (this.customBinaryFilterConditions === null || this.customBinaryFilterConditions === undefined) {
            this.customBinaryFilterConditions = new CustomBinaryFilterCondition();
        }
        // Row filters:
        if (this.customRowTextFilterConditions === null || this.customRowTextFilterConditions === undefined ||
            this.customRowTextFilterConditions.conditions.length === 0) {
            this.customRowTextFilterConditions = new CustomRowTextCaseFilterCondition();
            this.customRowTextFilterConditions.addExistingCondition(ConditionType.CONTAINS);
        }
        if (this.customRowNumericFilterConditions === null || this.customRowNumericFilterConditions === undefined ||
            this.customRowNumericFilterConditions.conditions.length === 0) {
            this.customRowNumericFilterConditions = new CustomRowNumericFilterCondition();
            this.customRowNumericFilterConditions.addExistingCondition(ConditionType.EQUALS);
        }
        if (this.customRowDateFilterConditions === null || this.customRowDateFilterConditions === undefined ||
            this.customRowDateFilterConditions.conditions.length === 0) {
            this.customRowDateFilterConditions = new CustomRowDateFilterCondition();
            this.customRowDateFilterConditions.addExistingCondition(ConditionType.EQUALS);
        }
    }
    setGridCustomConditions(gridCustomConditions) {
        // Standard filters:
        if (!this.isNullOrUndefined(gridCustomConditions.customTextFilterConditions)) {
            this.gridCustomFilterConditions.customTextFilterConditions = gridCustomConditions.customTextFilterConditions;
        }
        if (!this.isNullOrUndefined(gridCustomConditions.customNumericFilterConditions)) {
            this.gridCustomFilterConditions.customNumericFilterConditions = gridCustomConditions.customNumericFilterConditions;
        }
        if (!this.isNullOrUndefined(gridCustomConditions.customDateFilterConditions)) {
            this.gridCustomFilterConditions.customDateFilterConditions = gridCustomConditions.customDateFilterConditions;
        }
        // Multiple filters:
        if (!this.isNullOrUndefined(gridCustomConditions.customBinaryFilterConditions)) {
            this.gridCustomFilterConditions.customBinaryFilterConditions = gridCustomConditions.customBinaryFilterConditions;
            this.customBinaryFilterConditions = new CustomBinaryFilterCondition();
            this.customBinaryFilterConditions.assign(this.gridCustomFilterConditions.customBinaryFilterConditions);
        }
        // Row filters:
        if (!this.isNullOrUndefined(gridCustomConditions.customRowTextFilterConditions)) {
            this.gridCustomFilterConditions.customRowTextFilterConditions = gridCustomConditions.customRowTextFilterConditions;
            this.customRowTextFilterConditions = new CustomRowTextCaseFilterCondition();
            this.customRowTextFilterConditions.assign(this.gridCustomFilterConditions.customRowTextFilterConditions);
        }
        if (!this.isNullOrUndefined(gridCustomConditions.customRowNumericFilterConditions)) {
            this.gridCustomFilterConditions.customRowNumericFilterConditions = gridCustomConditions.customRowNumericFilterConditions;
            this.customRowNumericFilterConditions = new CustomRowNumericFilterCondition();
            this.customRowNumericFilterConditions.assign(this.gridCustomFilterConditions.customRowNumericFilterConditions);
        }
        if (!this.isNullOrUndefined(gridCustomConditions.customRowDateFilterConditions)) {
            this.gridCustomFilterConditions.customRowDateFilterConditions = gridCustomConditions.customRowDateFilterConditions;
            this.customRowDateFilterConditions = new CustomRowDateFilterCondition();
            this.customRowDateFilterConditions.assign(this.gridCustomFilterConditions.customRowDateFilterConditions);
        }
    }
    isCustomSelectionFilterCondition(value) {
        return value && (value instanceof CustomBinaryFilterCondition ||
            value instanceof CustomMultipleNumericFilterCondition ||
            value instanceof CustomMultipleTextFilterCondition);
    }
    isCustomTextFilterCondition(value) {
        return value && (value instanceof CustomRowTextCaseFilterCondition ||
            value instanceof CustomTextCaseFilterCondition ||
            value instanceof CustomMultipleTextFilterCondition);
    }
    isCustomNumericFilterCondition(value) {
        return value && (value instanceof CustomRowNumericFilterCondition ||
            value instanceof CustomNumericFilterCondition ||
            value instanceof CustomMultipleNumericFilterCondition);
    }
    isCustomDateFilterCondition(value) {
        return value && (value instanceof CustomRowDateFilterCondition ||
            value instanceof CustomDateFilterCondition);
    }
    isCustomBinaryFilterCondition(value) {
        return value && value instanceof CustomBinaryFilterCondition;
    }
    isCustomConditionInstanceValid(filterable) {
        switch (filterable.dataType) {
            case 'Text':
                return filterable.customFilterConditions instanceof CustomTextCaseFilterCondition ||
                    filterable.customFilterConditions instanceof CustomMultipleTextFilterCondition;
            case 'Numeric':
                return filterable.customFilterConditions instanceof CustomNumericFilterCondition ||
                    filterable.customFilterConditions instanceof CustomMultipleNumericFilterCondition;
            case 'Date':
                return filterable.customFilterConditions instanceof CustomDateFilterCondition;
            case 'Binary':
                return filterable.customFilterConditions instanceof CustomBinaryFilterCondition;
            default:
                return false;
        }
    }
    getFilterFromOptions(selectionInstance) {
        if (selectionInstance instanceof DkBinaryFilterCondition ||
            selectionInstance instanceof CustomBinaryFilterCondition) {
            return this.getBinaryFilterFromOptions(selectionInstance);
        }
        else if (selectionInstance instanceof DkMultipleNumericFilterCondition ||
            selectionInstance instanceof CustomMultipleNumericFilterCondition) {
            return this.getMultipleNumericFilterFromOptions(selectionInstance);
        }
        else if (selectionInstance instanceof DkMultipleTextFilterCondition ||
            selectionInstance instanceof CustomMultipleTextFilterCondition) {
            return this.getMultipleTextFilterFromOptions(selectionInstance);
        }
        return null;
    }
    getBinaryFilterFromOptions(binaryInstance) {
        let binaryFilter = null;
        let selectedOption = binaryInstance.options.find(option => option.selected !== null && option.selected !== undefined && option.selected);
        if (selectedOption) {
            binaryFilter = [];
            binaryFilter.push({
                logicalOperator: 'and',
                condition: ConditionType.EQUALS,
                value: selectedOption.value
            });
        }
        return binaryFilter;
    }
    getMultipleNumericFilterFromOptions(numericInstance) {
        let numericFilter = null;
        if (numericInstance.options.length > 0 &&
            numericInstance.options.some(option => option.selected !== null && option.selected !== undefined && option.selected)) {
            numericFilter = [];
            numericInstance.options.forEach(option => {
                if (option.selected !== null && option.selected !== undefined && option.selected) {
                    numericFilter.push({
                        logicalOperator: 'or',
                        condition: ConditionType.EQUALS,
                        value1: option.value
                    });
                }
            });
        }
        return numericFilter;
    }
    getMultipleTextFilterFromOptions(textInstance) {
        let textFilter = null;
        if (textInstance.options.length > 0 &&
            textInstance.options.some(option => option.selected !== null && option.selected !== undefined && option.selected)) {
            textFilter = [];
            textInstance.options.forEach(option => {
                if (option.selected !== null && option.selected !== undefined && option.selected) {
                    textFilter.push({
                        logicalOperator: 'or',
                        condition: ConditionType.EQUALS,
                        value: option.value
                    });
                }
            });
        }
        return textFilter;
    }
    getFilterConditionInstance(filterable) {
        if (this.isRowFilter(filterable)) {
            return this.getRowFilterCondition(filterable);
        }
        return this.getContextFilterCondition(filterable);
    }
    getRowFilterCondition(filterable) {
        switch (filterable.dataType) {
            case 'Text':
            case 'Binary':
                return this.createRowTextFilterCondition();
            case 'Numeric':
                return this.createRowNumericFilterCondition();
            case 'Date':
                return this.createRowDateFilterCondition();
            default:
                throw new Error(`Error from DkFilterFactory - There are no default Row-DkFilterCondition class definition for the given data type: ${filterable.dataType}`);
        }
    }
    createRowTextFilterCondition() {
        let newCustomRowInstance = new CustomRowTextCaseFilterCondition();
        return newCustomRowInstance.assign(this.customRowTextFilterConditions);
    }
    createRowNumericFilterCondition() {
        let newCustomRowInstance = new CustomRowNumericFilterCondition();
        return newCustomRowInstance.assign(this.customRowNumericFilterConditions);
    }
    createRowDateFilterCondition() {
        let newCustomRowInstance = new CustomRowDateFilterCondition();
        return newCustomRowInstance.assign(this.customRowDateFilterConditions);
    }
    getContextFilterCondition(filterable) {
        switch (filterable.dataType) {
            case 'Text':
                return this.createTextFilterCondition(filterable);
            case 'Numeric':
                return this.createNumericFilterCondition(filterable);
            case 'Date':
                return this.createDateFilterCondition(filterable);
            case 'Binary':
                return this.createBinaryFilterCondition(filterable);
            default:
                throw new Error(`Error from DkFilterFactory - There are no DkFilterCondition class definition for the given data type: ${filterable.dataType}`);
        }
    }
    createTextFilterCondition(filterable) {
        if (filterable.customFilterConditions) {
            if (filterable.customFilterConditions instanceof CustomMultipleTextFilterCondition) {
                let newMultipleCustomInstance;
                newMultipleCustomInstance = new CustomMultipleTextFilterCondition();
                newMultipleCustomInstance.assign(filterable.customFilterConditions);
                return newMultipleCustomInstance;
            }
            else if (filterable.customFilterConditions instanceof CustomTextCaseFilterCondition) {
                let newCustomInstance;
                newCustomInstance = new CustomTextCaseFilterCondition();
                newCustomInstance.assign(filterable.customFilterConditions);
                return newCustomInstance;
            }
        }
        let newCustomConfigInstance = new CustomTextCaseFilterCondition();
        return newCustomConfigInstance.assign(this.dikeTextFilterConditions).assign(this.customTextFilterConditions).assign(this.gridCustomFilterConditions.customTextFilterConditions);
    }
    createNumericFilterCondition(filterable) {
        if (filterable.customFilterConditions) {
            if (filterable.customFilterConditions instanceof CustomMultipleNumericFilterCondition) {
                let newMultipleCustomInstance;
                newMultipleCustomInstance = new CustomMultipleNumericFilterCondition();
                newMultipleCustomInstance.assign(filterable.customFilterConditions);
                return newMultipleCustomInstance;
            }
            else if (filterable.customFilterConditions instanceof CustomNumericFilterCondition) {
                let newCustomInstance;
                newCustomInstance = new CustomNumericFilterCondition();
                newCustomInstance.assign(filterable.customFilterConditions);
                return newCustomInstance;
            }
        }
        let newCustomConfigInstance = new CustomNumericFilterCondition();
        return newCustomConfigInstance.assign(this.dikeNumericFilterConditions).assign(this.customNumericFilterConditions).assign(this.gridCustomFilterConditions.customNumericFilterConditions);
    }
    createDateFilterCondition(filterable) {
        let newCustomInstance = new CustomDateFilterCondition();
        if (filterable.customFilterConditions && filterable.customFilterConditions instanceof CustomDateFilterCondition) {
            newCustomInstance.assign(filterable.customFilterConditions);
            return newCustomInstance;
        }
        return newCustomInstance.assign(this.dikeDateFilterConditions).assign(this.customDateFilterConditions).assign(this.gridCustomFilterConditions.customDateFilterConditions);
    }
    createBinaryFilterCondition(filterable) {
        let newCustomInstance = new CustomBinaryFilterCondition();
        if (filterable.customFilterConditions && filterable.customFilterConditions instanceof CustomBinaryFilterCondition) {
            newCustomInstance.assign(filterable.customFilterConditions);
        }
        else if (!this.isNullOrUndefined(this.customBinaryFilterConditions) && this.customBinaryFilterConditions.conditions.length > 0) {
            newCustomInstance.assign(this.customBinaryFilterConditions);
        }
        else {
            newCustomInstance.assign(this.dikeBinaryFilterConditions);
        }
        return newCustomInstance;
    }
    getFilterDispatcherConditionInstance(filterable) {
        switch (filterable.dataType) {
            case 'Text':
                return this.createTextFilterDispatcher(filterable);
            case 'Numeric':
                return this.createNumericFilterDispatcher(filterable);
            case 'Date':
                return this.createDateFilterDispatcher(filterable);
            case 'Binary':
                return this.createBinaryFilterDispatcher(filterable);
            default:
                throw new Error(`Error from DkFilterFactory - There are no DikeFilterDispatcherCondition class definition for the given data type: ${filterable.dataType}`);
        }
    }
    isRowFilter(filterable) {
        return filterable.columnId.trim().includes(this.dikeConfig.FILTER_SUFIX);
    }
    createTextFilterDispatcher(filterable) {
        let conditions = this.getFilterConditionInstance(filterable);
        if (filterable.customFilterConditions && filterable.customFilterConditions instanceof CustomMultipleTextFilterCondition) {
            return new DkMultipleTextFilterDispatcherConditions(conditions);
        }
        return new DkTextCaseFilterDispatcherConditions(conditions);
    }
    createNumericFilterDispatcher(filterable) {
        let conditions = this.getFilterConditionInstance(filterable);
        if (filterable.customFilterConditions && filterable.customFilterConditions instanceof CustomMultipleNumericFilterCondition) {
            return new DkMultipleNumericFilterDispatcherConditions(conditions);
        }
        return new DkNumericFilterDispatcherConditions(conditions);
    }
    createDateFilterDispatcher(filterable) {
        let conditions = this.getFilterConditionInstance(filterable);
        return new DkDateFilterDispatcherConditions(conditions);
    }
    createBinaryFilterDispatcher(filterable) {
        let conditions = this.getFilterConditionInstance(filterable);
        return new DkBinaryFilterDispatcherConditions(conditions);
    }
    isNullOrUndefined(value) {
        return value === null || value === undefined;
    }
}
DkFilterFactory.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterFactory, deps: [{ token: CONFIG_GRID }, { token: CUSTOM_TEXT_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_NUMERIC_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_DATE_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_BINARY_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_ROW_TEXT_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_ROW_NUMERIC_FILTER_CONDITIONS, optional: true }, { token: CUSTOM_ROW_DATE_FILTER_CONDITIONS, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
DkFilterFactory.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterFactory });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterFactory, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: CustomTextCaseFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_TEXT_FILTER_CONDITIONS]
                    }] }, { type: CustomNumericFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_NUMERIC_FILTER_CONDITIONS]
                    }] }, { type: CustomDateFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_DATE_FILTER_CONDITIONS]
                    }] }, { type: CustomBinaryFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_BINARY_FILTER_CONDITIONS]
                    }] }, { type: CustomRowTextCaseFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_ROW_TEXT_FILTER_CONDITIONS]
                    }] }, { type: CustomRowNumericFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_ROW_NUMERIC_FILTER_CONDITIONS]
                    }] }, { type: CustomRowDateFilterCondition, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_ROW_DATE_FILTER_CONDITIONS]
                    }] }];
    } });

const MAX_ROWS_IN_EDITION = new InjectionToken('max-rows-in-edition');
const ROW_EDITION_DBLCLICK = new InjectionToken('row-edition-dblclick');
const ROW_EDITION_ENTER_KEY = new InjectionToken('row-edition-enter-key');
const ROW_EDITION_ESC_KEY = new InjectionToken('row-edition-esc-key');
const SPLIT_DELETE_OPERATION = new InjectionToken('split-delete-operation');
const DELETE_OPERATION_ROW_SUBSET_SIZE = new InjectionToken('delete-operation-row-subset-size');
const SPLIT_UNDO_OPERATION = new InjectionToken('split-undo-operation');
const UNDO_OPERATION_ROW_SUBSET_SIZE = new InjectionToken('undo-operation-row-subset-size');
const CUSTOM_EDITION_ERROR_MESSAGES = new InjectionToken('custom-edition-error-messages');
const WAIT_FOR_MULTIPLE_ROWS_DELETION = new InjectionToken('wait-for-multiple-rows-deletion');
const WAIT_FOR_MULTIPLE_ROWS_UPDATE = new InjectionToken('wait-for-multiple-rows-update');
const WAIT_FOR_MULTIPLE_ROWS_CANCELATION = new InjectionToken('wait-for-multiple-rows-cancelation');
const WAIT_FOR_MULTIPLE_ROWS_RESTORATION = new InjectionToken('wait-for-multiple-rows-restoration');

class DkGridEditionConfig {
    constructor(maxRowsInEdition, rowEditionDblClick, rowEditionEnterKey, rowEditionEscKey, splitDeleteOperation, deleteOperationRowSubsetSize, splitUndoOperation, undoOperationRowSubsetSize, waitForMultipleRowsDeletion, waitForMultipleRowsUpdate, waitForMultipleRowsCancellation, waitForMultipleRowsRestoration) {
        this.maxRowsInEdition = maxRowsInEdition;
        this.rowEditionDblClick = rowEditionDblClick;
        this.rowEditionEnterKey = rowEditionEnterKey;
        this.rowEditionEscKey = rowEditionEscKey;
        this.splitDeleteOperation = splitDeleteOperation;
        this.deleteOperationRowSubsetSize = deleteOperationRowSubsetSize;
        this.splitUndoOperation = splitUndoOperation;
        this.undoOperationRowSubsetSize = undoOperationRowSubsetSize;
        this.waitForMultipleRowsDeletion = waitForMultipleRowsDeletion;
        this.waitForMultipleRowsUpdate = waitForMultipleRowsUpdate;
        this.waitForMultipleRowsCancellation = waitForMultipleRowsCancellation;
        this.waitForMultipleRowsRestoration = waitForMultipleRowsRestoration;
        this.gridInstanceEditionSettings = {
            maxRowsInEdition: 10,
            rowEditionDblClick: true,
            rowEditionEnterkey: true,
            rowEditionEscKey: true,
            splitDeleteOperation: false,
            deleteOperationRowSubsetSize: 2000,
            splitUndoOperation: false,
            undoOperationRowSubsetSize: 50000,
            crossFieldValidation: null,
            waitForMultipleRowsCancelation: true,
            waitForMultipleRowsDeletion: true,
            waitForMultipleRowsRestoration: true,
            waitForMultipleRowsUpdate: true
        };
        if (this.maxRowsInEdition !== null && this.maxRowsInEdition !== undefined) {
            this.gridInstanceEditionSettings.maxRowsInEdition = this.maxRowsInEdition;
        }
        if (this.rowEditionDblClick !== null && this.rowEditionDblClick !== undefined) {
            this.gridInstanceEditionSettings.rowEditionDblClick = this.rowEditionDblClick;
        }
        if (this.rowEditionEnterKey !== null && this.rowEditionEnterKey !== undefined) {
            this.gridInstanceEditionSettings.rowEditionEnterkey = this.rowEditionEnterKey;
        }
        if (this.rowEditionEscKey !== null && this.rowEditionEscKey !== undefined) {
            this.gridInstanceEditionSettings.rowEditionEscKey = this.rowEditionEscKey;
        }
        if (this.splitDeleteOperation !== null && this.splitDeleteOperation !== undefined) {
            this.gridInstanceEditionSettings.splitDeleteOperation = this.splitDeleteOperation;
        }
        if (this.deleteOperationRowSubsetSize !== null && this.deleteOperationRowSubsetSize !== undefined) {
            this.gridInstanceEditionSettings.deleteOperationRowSubsetSize = this.deleteOperationRowSubsetSize;
        }
        if (this.splitUndoOperation !== null && this.splitUndoOperation !== undefined) {
            this.gridInstanceEditionSettings.splitUndoOperation = this.splitUndoOperation;
        }
        if (this.undoOperationRowSubsetSize !== null && this.undoOperationRowSubsetSize !== undefined) {
            this.gridInstanceEditionSettings.undoOperationRowSubsetSize = this.undoOperationRowSubsetSize;
        }
        if (this.waitForMultipleRowsCancellation !== null && this.waitForMultipleRowsCancellation !== undefined) {
            this.gridInstanceEditionSettings.waitForMultipleRowsCancelation = this.waitForMultipleRowsCancellation;
        }
        if (this.waitForMultipleRowsDeletion !== null && this.waitForMultipleRowsDeletion !== undefined) {
            this.gridInstanceEditionSettings.waitForMultipleRowsDeletion = this.waitForMultipleRowsDeletion;
        }
        if (this.waitForMultipleRowsRestoration !== null && this.waitForMultipleRowsRestoration !== undefined) {
            this.gridInstanceEditionSettings.waitForMultipleRowsRestoration = this.waitForMultipleRowsRestoration;
        }
        if (this.waitForMultipleRowsUpdate !== null && this.waitForMultipleRowsUpdate !== undefined) {
            this.gridInstanceEditionSettings.waitForMultipleRowsUpdate = this.waitForMultipleRowsUpdate;
        }
        this.dikeTextBox = null;
        this.dikeMultiTextBox = null;
        this.dikeTextOptionsBox = null;
        this.dikeNumericBox = null;
        this.dikeNumericOptionsBox = null;
        this.dikeDateBox = null;
        this.dikeBinaryBox = null;
        this.dikeBinaryOptionsBox = null;
        this.allowEditionSubject = new BehaviorSubject(false);
        this.editionModeSubject = new BehaviorSubject(false);
        this.editionToolbarSubject = new BehaviorSubject(false);
        this.editionToolbarPositionSubject = new BehaviorSubject('bottom');
        this.editionToolbarAlignmentSubject = new BehaviorSubject('left');
        this.editionFilterStateSubject = new BehaviorSubject(false);
        this.editionFilterSubject = new BehaviorSubject(undefined);
        this.enableEditionFilterRowsSubject = new BehaviorSubject(false);
        this.editionFilterStateEmitter = new EventEmitter();
    }
    ngOnDestroy() {
        this.allowEditionSubject.complete();
        this.editionModeSubject.complete();
        this.editionToolbarSubject.complete();
        this.editionToolbarPositionSubject.complete();
        this.editionToolbarAlignmentSubject.complete();
        this.editionFilterStateSubject.complete();
        this.editionFilterSubject.complete();
        this.enableEditionFilterRowsSubject.complete();
    }
    get onAllowEditionChanged$() {
        return this.allowEditionSubject.asObservable();
    }
    get onEditionModeChanged$() {
        return this.editionModeSubject.asObservable();
    }
    get onEditionToolbarChanged$() {
        return this.editionToolbarSubject.asObservable();
    }
    get onEditionToolbarPositionChanged$() {
        return this.editionToolbarPositionSubject.asObservable();
    }
    get onEditionToolbarAlignmentChanged$() {
        return this.editionToolbarAlignmentSubject.asObservable();
    }
    get onEditionFilterStateChanged$() {
        return this.editionFilterStateSubject.asObservable();
    }
    get onEditionFilterChanged$() {
        return this.editionFilterSubject.asObservable();
    }
    get onEnableEditionFilterRowsChanged$() {
        return this.enableEditionFilterRowsSubject.asObservable();
    }
    get enableEditionFilterRows() {
        return this.enableEditionFilterRowsSubject.value;
    }
    set enableEditionFilterRows(value) {
        this.changeEnableEditionFilterRows(value);
    }
    get textBoxTemplate() {
        return this.dikeTextBox;
    }
    set textBoxTemplate(template) {
        this.dikeTextBox = template;
    }
    get multiTextBoxTemplate() {
        return this.dikeMultiTextBox;
    }
    set multiTextBoxTemplate(template) {
        this.dikeMultiTextBox = template;
    }
    get textOptionsBoxTemplate() {
        return this.dikeTextOptionsBox;
    }
    set textOptionsBoxTemplate(template) {
        this.dikeTextOptionsBox = template;
    }
    get numericBoxTemplate() {
        return this.dikeNumericBox;
    }
    set numericBoxTemplate(template) {
        this.dikeNumericBox = template;
    }
    get numericOptionsBoxTemplate() {
        return this.dikeNumericOptionsBox;
    }
    set numericOptionsBoxTemplate(template) {
        this.dikeNumericOptionsBox = template;
    }
    get dateBoxTemplate() {
        return this.dikeDateBox;
    }
    set dateBoxTemplate(template) {
        this.dikeDateBox = template;
    }
    get binaryBoxTemplate() {
        return this.dikeBinaryBox;
    }
    set binaryBoxTemplate(template) {
        this.dikeBinaryBox = template;
    }
    get binaryOptionsBoxTemplate() {
        return this.dikeBinaryOptionsBox;
    }
    set binaryOptionsBoxTemplate(template) {
        this.dikeBinaryOptionsBox = template;
    }
    get allowEdition() {
        return this.allowEditionSubject.value;
    }
    set allowEdition(value) {
        this.changeAllowEdition(value);
    }
    get editionMode() {
        return this.editionModeSubject.value;
    }
    set editionMode(value) {
        this.changeEditionMode(value);
    }
    get editionToolbar() {
        return this.editionToolbarSubject.value;
    }
    set editionToolbar(value) {
        this.changeEditionToolbar(value);
    }
    get editionToolbarPosition() {
        return this.editionToolbarPositionSubject.value;
    }
    set editionToolbarPosition(value) {
        this.changeEditionToolbarPosition(value);
    }
    get editionToolbarAlignment() {
        return this.editionToolbarAlignmentSubject.value;
    }
    set editionToolbarAlignment(value) {
        this.changeEditionToolbarAlignment(value);
    }
    get editionFilterState() {
        return this.editionFilterStateSubject.value;
    }
    get editionFilter() {
        return this.editionFilterSubject.value;
    }
    set editionFilter(value) {
        this.changeEditionFilter(value);
    }
    get gridEditionSettings() {
        return this.gridInstanceEditionSettings;
    }
    set gridEditionSettings(value) {
        this.gridInstanceEditionSettings = Object.assign(Object.assign({}, this.gridInstanceEditionSettings), value);
    }
    cancelEditionFilter() {
        this.changeEditionFilter(undefined);
    }
    getEditionSettings(dataType, currentSettings, newSettings) {
        /**
         * This method is used for assigning settings from a new columnDef or
         * for an existing column slot which will merge its edition field settings
         * with the given new settings.
         */
        let editionSettings = null;
        // One of them has one value at least:
        if (!!currentSettings || !!newSettings) {
            // Merge the edition settings:
            editionSettings = Object.assign(Object.assign({}, (currentSettings !== null && currentSettings !== void 0 ? currentSettings : {})), (newSettings !== null && newSettings !== void 0 ? newSettings : {}));
            let hasOptions = this.doesHaveOptions(editionSettings);
            // If the edition settings have options and the data type is BINARY, take only the first two elements:
            if (hasOptions && dataType === 'Binary') {
                editionSettings.options = editionSettings.options.slice(0, 2);
            }
        }
        return editionSettings;
    }
    getDefaultEditionTemplate(columnDataType, editionSettings) {
        let hasOptions = this.doesHaveOptions(editionSettings);
        switch (columnDataType) {
            case 'Text':
                return hasOptions ? this.textOptionsBoxTemplate : this.textBoxTemplate;
            case 'Numeric':
                return hasOptions ? this.numericOptionsBoxTemplate : this.numericBoxTemplate;
            case 'Date':
                return this.dateBoxTemplate;
            case 'Binary':
                return hasOptions ? this.binaryOptionsBoxTemplate : this.binaryBoxTemplate;
            default:
                return this.textBoxTemplate;
        }
    }
    doesHaveOptions(editionSettings) {
        return !!editionSettings &&
            editionSettings.options !== undefined && editionSettings.options !== null &&
            editionSettings.options.length > 0;
    }
    changeAllowEdition(value) {
        this.allowEditionSubject.next(value);
    }
    changeEditionMode(value) {
        this.editionModeSubject.next(value);
    }
    changeEditionToolbar(value) {
        this.editionToolbarSubject.next(value);
    }
    changeEditionToolbarPosition(value) {
        this.editionToolbarPositionSubject.next(value);
    }
    changeEditionToolbarAlignment(value) {
        this.editionToolbarAlignmentSubject.next(value);
    }
    changeEditionFilterState(value) {
        this.editionFilterStateSubject.next(value);
        this.editionFilterStateEmitter.emit(value);
    }
    changeEditionFilter(value) {
        // If value is undefined, it means the edition filtering is cancelled:
        if (value === undefined) {
            this.changeEditionFilterState(false);
        }
        else if (!this.editionFilterState) {
            this.changeEditionFilterState(true);
        }
        this.editionFilterSubject.next(value);
    }
    changeEnableEditionFilterRows(value) {
        this.enableEditionFilterRowsSubject.next(value);
    }
}
DkGridEditionConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionConfig, deps: [{ token: MAX_ROWS_IN_EDITION, optional: true }, { token: ROW_EDITION_DBLCLICK, optional: true }, { token: ROW_EDITION_ENTER_KEY, optional: true }, { token: ROW_EDITION_ESC_KEY, optional: true }, { token: SPLIT_DELETE_OPERATION, optional: true }, { token: DELETE_OPERATION_ROW_SUBSET_SIZE, optional: true }, { token: SPLIT_UNDO_OPERATION, optional: true }, { token: UNDO_OPERATION_ROW_SUBSET_SIZE, optional: true }, { token: WAIT_FOR_MULTIPLE_ROWS_DELETION, optional: true }, { token: WAIT_FOR_MULTIPLE_ROWS_UPDATE, optional: true }, { token: WAIT_FOR_MULTIPLE_ROWS_CANCELATION, optional: true }, { token: WAIT_FOR_MULTIPLE_ROWS_RESTORATION, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridEditionConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionConfig, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [MAX_ROWS_IN_EDITION]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_EDITION_DBLCLICK]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_EDITION_ENTER_KEY]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_EDITION_ESC_KEY]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [SPLIT_DELETE_OPERATION]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [DELETE_OPERATION_ROW_SUBSET_SIZE]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [SPLIT_UNDO_OPERATION]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [UNDO_OPERATION_ROW_SUBSET_SIZE]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [WAIT_FOR_MULTIPLE_ROWS_DELETION]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [WAIT_FOR_MULTIPLE_ROWS_UPDATE]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [WAIT_FOR_MULTIPLE_ROWS_CANCELATION]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [WAIT_FOR_MULTIPLE_ROWS_RESTORATION]
                    }] }];
    } });

class DkGridFilterConfig {
    constructor(dikeConfig, filterFactory, gridEditionConfig) {
        this.dikeConfig = dikeConfig;
        this.filterFactory = filterFactory;
        this.gridEditionConfig = gridEditionConfig;
        this.dataFilterables = new Map();
        this.editionFilterables = new Map();
        this.allowRowFilterSubject = new BehaviorSubject(false);
        this.onDemandFilterSubject = new BehaviorSubject(false);
        this.registerEmitter = new EventEmitter();
        this.deregisterEmitter = new EventEmitter();
        this.filterEmitter = new EventEmitter();
        this.editionFilterEmitter = new EventEmitter();
        this.clearFilterEmitter = new EventEmitter();
        this.clearEditionFilterEmitter = new EventEmitter();
    }
    ngOnDestroy() {
        this.allowRowFilterSubject.complete();
        this.onDemandFilterSubject.complete();
    }
    get onAllowRowFilterChanged$() {
        return this.allowRowFilterSubject.asObservable();
    }
    get onDemandFilterChanged$() {
        return this.onDemandFilterSubject.asObservable();
    }
    get allowRowFilter() {
        return this.allowRowFilterSubject.value;
    }
    set allowRowFilter(value) {
        this.changeAllowRowFilter(value);
    }
    get onDemandFilter() {
        return this.onDemandFilterSubject.value;
    }
    set onDemandFilter(value) {
        this.changeOnDemandFilter(value);
    }
    get filterables() {
        return this.gridEditionConfig.editionFilterState ? this.editionFilterables : this.dataFilterables;
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    getRowFilterColumnId(columnId) {
        return `${columnId}-${this.dikeConfig.FILTER_SUFIX}`;
    }
    getColumnIdFromFilterable(filterable) {
        let columnId = filterable.columnId;
        if (this.filterFactory.isRowFilter(filterable)) {
            columnId = filterable.columnId.substring(0, filterable.columnId.length - `-${this.dikeConfig.FILTER_SUFIX}`.length);
        }
        return columnId;
    }
    cloneFilterable(columnId, newColumnId) {
        /**
         * When cloning a Filterables:
         *
         *  1. Filterable given by columnId must be cloned in dataFilterables and editionFilterables.
         *  2. Cloned filterable must be set silently, meaning not sending the register and deregister events.
         */
        if (this.dataFilterables.has(columnId)) {
            // Get the existing filterable from dataFilterables and editionFilterables:
            let dataFilterable = this.dataFilterables.get(columnId);
            let editionFilterable = this.editionFilterables.get(columnId);
            // Create the new filterables for dataFilterables and editionFilterables:
            let newDataFilterable = Object.assign(Object.assign({}, dataFilterable), { columnId: newColumnId });
            let newEditionFilterable = Object.assign(Object.assign({}, editionFilterable), { columnId: newColumnId });
            // Delete the existing filterables:
            this.dataFilterables.delete(columnId);
            this.editionFilterables.delete(columnId);
            // Add filterables with the new columnId:
            this.dataFilterables.set(newColumnId, newDataFilterable);
            this.editionFilterables.set(newColumnId, newEditionFilterable);
        }
    }
    register(filterable) {
        if (filterable.customFilterConditions && !this.filterFactory.isCustomConditionInstanceValid(filterable)) {
            filterable.customFilterConditions = null;
        }
        else if (this.filterFactory.isCustomSelectionFilterCondition(filterable.customFilterConditions)) {
            /**
             * filterable.customFilterConditions instance is valid according to filterable data type and
             * the instance is a type derived from DkSelectionFilterCondition<M, V> abstract class:
             */
            // Get the initial filter from option otherwise set filterable.filter to null:
            filterable.filter = this.filterFactory.getFilterFromOptions(filterable.customFilterConditions);
        }
        // Store the filterable existance flag for later use:
        let filterableExists = this.dataFilterables.has(filterable.columnId);
        /**
         * register method could be invoked more than one time
         * for the same Fitlerable.
         *
         *  1.  If the given filterable exists in the Map structure, it will be
         *      overwritten with the new Filterable definition.
         */
        // Add or overwrite the given filterable to dataFilterables:
        this.dataFilterables.set(filterable.columnId, filterable);
        // And add or overwrite it to editionFilterables.
        this.editionFilterables.set(filterable.columnId, filterable);
        // Send or resend the just registered Filterable:
        this.changeRegistration(Object.assign({}, filterable));
        // The filterable did not exist and has an initial filter:
        if (!filterableExists && filterable.filter && filterable.filter.length > 0) {
            /**
             * Edition Filterables:
             *
             * 1. If the given filterable has an intial filter clear from
             *    editionFilterable. Initial filters apply only to dataFilterables.
             * 2. Edition filters could only set via the UI.
             */
            this.editionFilterables.set(filterable.columnId, Object.assign(Object.assign({}, filterable), { filter: [] }));
            // If DikeGrid instance is not in editionFilterState, send the initial filter:
            if (!this.gridEditionConfig.editionFilterState) {
                this.changeFilter(Object.assign({}, filterable));
            }
        }
        else if (filterableExists) {
            /**
             * The filterable exists meaning that the user is redefining this filterable and it is
             * highly likely that the user has changed the filter because the filter conditions
             * must exist in the new customFilterConditions.
             */
            this.applyFilter(Object.assign(Object.assign({}, filterable), { filter: filterable.filter && filterable.filter.length > 0 ? filterable.filter : [] }));
        }
    }
    deregister(filterable) {
        if (this.dataFilterables.has(filterable.columnId)) {
            // Delete filterable from dataFilterables:
            this.dataFilterables.delete(filterable.columnId);
            // And delete from editionFilterables:
            this.editionFilterables.delete(filterable.columnId);
            this.changeDeregistration(Object.assign({}, filterable));
            // Does DikeGrid instance have applied the filter from the deleted filterable?
            if (filterable.filter && filterable.filter.length > 0) {
                this.changeFilter(Object.assign(Object.assign({}, filterable), { filter: [] }));
            }
        }
    }
    applyFilter(filterable) {
        // Before sending the new filter to the subscribers, store it in filterables map:
        if (this.gridEditionConfig.editionFilterState) {
            this.editionFilterables.set(filterable.columnId, Object.assign({}, filterable));
        }
        else {
            this.dataFilterables.set(filterable.columnId, Object.assign({}, filterable));
        }
        // Then emit the filter to the subscribers:
        this.changeFilter(Object.assign({}, filterable));
    }
    clearFilter() {
        /**
         * Removing filters depends on which view the user is:
         *
         * If the user is in edition mode, the edition filters will be removed. Otherwise,
         * the data filters are removed.
         */
        for (let columnId of this.filterables.keys()) {
            let filterable = Object.assign(Object.assign({}, this.filterables.get(columnId)), { filter: null });
            this.filterables.set(columnId, filterable);
        }
        this.changeClearFilter();
    }
    changeAllowRowFilter(value) {
        this.allowRowFilterSubject.next(value);
    }
    changeOnDemandFilter(value) {
        this.onDemandFilterSubject.next(value);
    }
    changeRegistration(filterable) {
        this.registerEmitter.emit(filterable);
    }
    changeDeregistration(filterable) {
        this.deregisterEmitter.emit(filterable);
    }
    changeFilter(filterable) {
        // The user is navigating the edited rows:
        if (this.gridEditionConfig.editionFilterState) {
            this.editionFilterEmitter.emit(filterable);
        }
        else {
            // Otherwise, emit the filterable to the common stream:
            this.filterEmitter.emit(filterable);
        }
    }
    changeClearFilter() {
        // The user is navigating the edited rows:
        if (this.gridEditionConfig.editionFilterState) {
            this.clearEditionFilterEmitter.emit();
        }
        else {
            // Otherwise, clear the common filters:
            this.clearFilterEmitter.emit();
        }
    }
}
DkGridFilterConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilterConfig, deps: [{ token: CONFIG_GRID }, { token: DkFilterFactory }, { token: DkGridEditionConfig }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridFilterConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilterConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilterConfig, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkFilterFactory }, { type: DkGridEditionConfig }];
    } });

class DkGridFactoryColumns {
    constructor(dikeConfig, gridFilterConfig) {
        this.dikeConfig = dikeConfig;
        this.gridFilterConfig = gridFilterConfig;
        this.rootColumns = [];
    }
    ngOnDestroy() {
        this.rootColumns = null;
    }
    createDikeGutterColumn(panel, fieldName) {
        let dikeColumn = new DkGutterColumn(`${fieldName}-gutter`);
        dikeColumn.panel = panel;
        dikeColumn.width = this.dikeConfig.COLUMN_GAP;
        dikeColumn.minWidth = this.dikeConfig.COLUMN_GAP;
        dikeColumn.maxWidth = this.dikeConfig.COLUMN_GAP;
        return dikeColumn;
    }
    createDikeRowIndexColumn(panel, width = 0) {
        let dikeColumn = new DkRowIndexColumn('Row Id');
        dikeColumn.panel = panel;
        dikeColumn.width = width <= 0 ? this.dikeConfig.ROW_INDEX : width;
        dikeColumn.minWidth = width <= 0 ? this.dikeConfig.ROW_INDEX : width;
        dikeColumn.maxWidth = width <= 0 ? this.dikeConfig.ROW_INDEX : width;
        return dikeColumn;
    }
    createDikeScrollbarGapColumn(panel, width) {
        let dikeColumn = new DkScrollbarGapColumn();
        dikeColumn.panel = panel;
        dikeColumn.width = width;
        dikeColumn.minWidth = width;
        dikeColumn.maxWidth = width;
        return dikeColumn;
    }
    createDikeDataColumn(fieldName, headerText, dataType) {
        if (dataType !== 'Text' && dataType !== 'Numeric' && dataType !== 'Date' && dataType !== 'Binary') {
            throw new Error(`Error from DkGridFactoryColumns - DkColumnDataType must be specified for column: ${fieldName} - ${headerText}`);
        }
        return new DkDataColumn(fieldName, headerText, dataType);
    }
    createDikeGroupColumn(groupName, headerText) {
        return new DkGroupColumn(groupName, headerText);
    }
    cloneDikeDataColumn(dikeColumn) {
        return this.createDikeDataColumn(dikeColumn.fieldName, dikeColumn.headerText, dikeColumn.dataType).assign(dikeColumn);
    }
    createDikeDataColumnDefFromUIColumn(column) {
        let dataColumnDef = DkDataColumnDef.getDataColumnDefInstance(column.fieldName, column.headerText, column.dataType);
        dataColumnDef.slotId = generateUUID();
        dataColumnDef.order = column.order;
        dataColumnDef.width = column.width;
        dataColumnDef.minWidth = column.minWidth;
        dataColumnDef.maxWidth = column.maxWidth;
        if (column.contentAlign) {
            dataColumnDef.contentAlign = column.contentAlign;
        }
        dataColumnDef.headerTooltip = column.headerTooltip;
        dataColumnDef.resizable = column.resizable;
        dataColumnDef.draggable = column.draggable;
        dataColumnDef.locked = column.locked;
        dataColumnDef.visible = column.visible;
        dataColumnDef.sortable = column.sortable;
        dataColumnDef.filterable = column.filterable;
        dataColumnDef.editable = column.editable;
        dataColumnDef.groupable = column.groupable;
        dataColumnDef.displayMenu = column.displayMenu;
        dataColumnDef.filter = column.filter ? [...column.filter] : null;
        dataColumnDef.customFilterConditions = column.customFilterConditions;
        dataColumnDef.panel = column.panel;
        dataColumnDef.displayOn = column.displayOn;
        if (column.getValue) {
            dataColumnDef.getValue = column.getValue;
        }
        if (column.setValue) {
            dataColumnDef.setValue = column.setValue;
        }
        dataColumnDef.editionSettings = column.editionSettings ? Object.assign({}, column.editionSettings) : null;
        dataColumnDef.editionTemplate = column.editionTemplate;
        dataColumnDef.displayTemplate = column.displayTemplate;
        return dataColumnDef;
    }
    createDikeGroupColumnDefFromUIColumn(column) {
        let groupColumnDef = new DkGroupColumnDef(column.fieldName, column.headerText);
        groupColumnDef.slotId = generateUUID();
        groupColumnDef.order = column.order;
        groupColumnDef.headerTooltip = column.headerTooltip;
        groupColumnDef.resizable = column.resizable;
        groupColumnDef.draggable = column.draggable;
        groupColumnDef.locked = column.locked;
        groupColumnDef.visible = column.visible;
        groupColumnDef.displayMenu = column.displayMenu;
        groupColumnDef.panel = column.panel;
        groupColumnDef.displayOn = column.displayOn;
        groupColumnDef.displayStatus = column.displayStatus;
        groupColumnDef.children = [];
        return groupColumnDef;
    }
    createDikeDataColumnDefFromColumnSlot(columnSlot) {
        if (columnSlot.dikeColumn.columnType !== 'Data-Column') {
            throw new Error(`Error from DkGridFactoryColumns - DkDataColumnDef instance could be only created from a DkDataColumn instance.`);
        }
        let dataColumnDef = DkDataColumnDef.getDataColumnDefInstance(columnSlot.dikeColumn.fieldName, columnSlot.dikeColumn.headerText, columnSlot.dikeColumn.dataType);
        dataColumnDef.slotId = columnSlot.slotId;
        dataColumnDef.belongToGroup = columnSlot.belongToGroup;
        dataColumnDef.columnId = columnSlot.dikeColumn.columnId;
        dataColumnDef.width = columnSlot.dikeColumn.width;
        dataColumnDef.minWidth = columnSlot.dikeColumn.minWidth;
        dataColumnDef.maxWidth = columnSlot.dikeColumn.maxWidth;
        dataColumnDef.contentAlign = columnSlot.dikeColumn.contentAlign;
        dataColumnDef.order = columnSlot.dikeColumn.order;
        dataColumnDef.headerTooltip = columnSlot.dikeColumn.headerTooltip;
        dataColumnDef.resizable = columnSlot.dikeColumn.resizable;
        dataColumnDef.draggable = columnSlot.dikeColumn.draggable;
        dataColumnDef.locked = columnSlot.dikeColumn.locked;
        dataColumnDef.visible = columnSlot.dikeColumn.visible;
        dataColumnDef.sortable = columnSlot.dikeColumn.sortable;
        dataColumnDef.filterable = columnSlot.dikeColumn.filterable;
        dataColumnDef.editable = columnSlot.dikeColumn.editable;
        dataColumnDef.groupable = columnSlot.dikeColumn.groupable;
        dataColumnDef.displayMenu = columnSlot.dikeColumn.displayMenu;
        // This method is invoked when a columnSlot is being cloned, take the filterables depending on which view the user is navigating (edition or normal):
        if (columnSlot.dikeColumn.filterable && this.gridFilterConfig.filterables.has(columnSlot.dikeColumn.columnId)) {
            let filterable = this.gridFilterConfig.filterables.get(columnSlot.dikeColumn.columnId);
            dataColumnDef.filter = filterable.filter ? [...filterable.filter] : null;
            dataColumnDef.customFilterConditions = filterable.customFilterConditions ? filterable.customFilterConditions : null;
        }
        dataColumnDef.panel = columnSlot.dikeColumn.panel;
        dataColumnDef.displayOn = columnSlot.initialDisplayOn;
        if (columnSlot.dikeColumn instanceof DkDataColumn) {
            if (columnSlot.dikeColumn.getValue) {
                dataColumnDef.getValue = columnSlot.dikeColumn.getValue;
            }
            if (columnSlot.dikeColumn.setValue) {
                dataColumnDef.setValue = columnSlot.dikeColumn.setValue;
            }
            dataColumnDef.editionSettings = columnSlot.editionSettings ? Object.assign({}, columnSlot.editionSettings) : null;
            dataColumnDef.editionTemplate = columnSlot.editionTemplate;
            dataColumnDef.displayTemplate = columnSlot.displayTemplate;
        }
        return dataColumnDef;
    }
    createDikeGroupColumnDefFromColumnSlot(columnSlot) {
        if (columnSlot.dikeColumn.columnType !== 'Group-Column') {
            throw new Error(`Error from DkGridFactoryColumns - DkGroupColumnDef instance could only be created from a DkGroupColumn instance.`);
        }
        let groupColumnDef = new DkGroupColumnDef(columnSlot.dikeColumn.fieldName, columnSlot.dikeColumn.headerText);
        groupColumnDef.slotId = columnSlot.slotId;
        groupColumnDef.belongToGroup = columnSlot.belongToGroup;
        groupColumnDef.columnId = columnSlot.dikeColumn.columnId;
        groupColumnDef.order = columnSlot.dikeColumn.order;
        groupColumnDef.headerTooltip = columnSlot.dikeColumn.headerTooltip;
        groupColumnDef.resizable = columnSlot.dikeColumn.resizable;
        groupColumnDef.draggable = columnSlot.dikeColumn.draggable;
        groupColumnDef.locked = columnSlot.dikeColumn.locked;
        groupColumnDef.visible = columnSlot.dikeColumn.visible;
        groupColumnDef.displayMenu = columnSlot.dikeColumn.displayMenu;
        groupColumnDef.panel = columnSlot.dikeColumn.panel;
        groupColumnDef.displayOn = columnSlot.initialDisplayOn;
        groupColumnDef.displayStatus = columnSlot.displayStatus;
        groupColumnDef.children = [];
        return groupColumnDef;
    }
    createDikeGroupColumnDefFromGroupColumnDef(column) {
        /**
         * This method will create a new DkGroupColumnDef instance based on the given
         * DkGroupColumnDef column group instance.
         *
         * IMPORTANT: The method only get the group properties without the children.
         */
        let groupColumnDef = new DkGroupColumnDef(column.fieldName, column.headerText);
        groupColumnDef.slotId = column.slotId;
        groupColumnDef.belongToGroup = column.belongToGroup;
        groupColumnDef.columnId = column.columnId;
        groupColumnDef.order = column.order;
        groupColumnDef.headerTooltip = column.headerTooltip;
        groupColumnDef.resizable = column.resizable;
        groupColumnDef.draggable = column.draggable;
        groupColumnDef.locked = column.locked;
        groupColumnDef.visible = column.visible;
        groupColumnDef.displayMenu = column.displayMenu;
        groupColumnDef.panel = column.panel;
        groupColumnDef.displayOn = column.displayOn;
        groupColumnDef.displayStatus = column.displayStatus;
        groupColumnDef.children = [];
        return groupColumnDef;
    }
    cloneDikeGroupColumnDef(column) {
        return new DkGroupColumnDef(column.fieldName, column.headerText).assign(column);
    }
    cloneDikeDataColumnDef(column) {
        return DkDataColumnDef.getDataColumnDefInstance(column.fieldName, column.headerText, column.dataType).assign(column);
    }
    removeRootColumnFromArray(slotId) {
        let column = this.rootColumns.find(root => root.slotId === slotId);
        if (!!column) {
            let newRootColumnsArray = [];
            this.rootColumns.forEach(root => {
                if (root.slotId !== slotId) {
                    newRootColumnsArray.push(root);
                }
            });
            this.rootColumns = newRootColumnsArray;
        }
        else {
            throw new Error(`Error from DkGridFactoryColumns - root column (${slotId}) does not exist in rootColumns array.`);
        }
        return column;
    }
}
DkGridFactoryColumns.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryColumns, deps: [{ token: CONFIG_GRID }, { token: DkGridFilterConfig }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridFactoryColumns.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryColumns });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryColumns, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGridFilterConfig }];
    } });

class DkGridColumnComponent {
    constructor(gridFactoryColumns) {
        this.gridFactoryColumns = gridFactoryColumns;
        this.slotId = '';
        this.fieldName = '';
        this.headerText = '';
        this.headerTooltip = '';
        this.dataType = 'Text';
        this._order = -1;
        this._width = 0;
        this._minWidth = 0;
        this._maxWidth = 0;
        this._draggable = false;
        this._locked = false;
        this._resizable = false;
        this._visible = true;
        this._sortable = false;
        this._filterable = false;
        this._editable = false;
        this._groupable = false;
        this._displayMenu = true;
        this.filter = null;
        this.customFilterConditions = null;
        this.panel = 'centerPanel';
        this.displayOn = 'open';
        this.displayStatus = 'open';
        this.getValue = null;
        this.setValue = null;
        this.editionSettings = null;
        this.editionTemplate = null;
        this.displayTemplate = null;
    }
    get order() { return this._order; }
    set order(value) { this._order = coerceNumberProperty(value, -1); }
    get width() { return this._width; }
    set width(value) { this._width = coerceNumberProperty(value, 0); }
    get minWidth() { return this._minWidth; }
    set minWidth(value) { this._minWidth = coerceNumberProperty(value, 0); }
    get maxWidth() { return this._maxWidth; }
    set maxWidth(value) { this._maxWidth = coerceNumberProperty(value, 0); }
    get draggable() { return this._draggable; }
    set draggable(value) { this._draggable = coerceBooleanProperty(value); }
    get locked() { return this._locked; }
    set locked(value) { this._locked = coerceBooleanProperty(value); }
    get resizable() { return this._resizable; }
    set resizable(value) { this._resizable = coerceBooleanProperty(value); }
    get visible() { return this._visible; }
    set visible(value) { this._visible = coerceBooleanProperty(value); }
    get sortable() { return this._sortable; }
    set sortable(value) { this._sortable = coerceBooleanProperty(value); }
    get filterable() { return this._filterable; }
    set filterable(value) { this._filterable = coerceBooleanProperty(value); }
    get editable() { return this._editable; }
    set editable(value) { this._editable = coerceBooleanProperty(value); }
    get groupable() { return this._groupable; }
    set groupable(value) { this._groupable = coerceBooleanProperty(value); }
    get displayMenu() { return this._displayMenu; }
    set displayMenu(value) { this._displayMenu = coerceBooleanProperty(value); }
    ngAfterContentInit() {
        // Does the current column is a Data column?
        if (this.childColumns.length === 0) {
            // Create the data column with its slotId UUID:
            let dataColumDef = this.gridFactoryColumns.createDikeDataColumnDefFromUIColumn(this);
            // Very important, save the UUID in the UI column component:
            this.slotId = dataColumDef.slotId;
            // Add the data column to the rootColumns array:
            this.gridFactoryColumns.rootColumns.push(dataColumDef);
            // Does the current column have children columns?:
        }
        else if (this.childColumns.length > 0) {
            // Create the parent column with its UUID columnId:
            let groupColumDef = this.gridFactoryColumns.createDikeGroupColumnDefFromUIColumn(this);
            this.slotId = groupColumDef.slotId;
            // Save children columns into groupColumDef.children array:
            this.childColumns.forEach(gridColumn => {
                let childColumn = null;
                // Child column must exist in the rootColumns array, otherwise throw an Exception:
                if (this.gridFactoryColumns.rootColumns.some(root => root.slotId === gridColumn.slotId)) {
                    childColumn = this.gridFactoryColumns.removeRootColumnFromArray(gridColumn.slotId);
                }
                else {
                    throw new Error(`Error from DkGridColumnComponent - The current DkGridColumnComponent with fieldName: ${gridColumn.fieldName} and headerText: ${gridColumn.headerText} must be in the DkGridFactoryColumns.rootColumns array.`);
                }
                // Associate the child column to its parent column (groupColumDef):
                groupColumDef.children.push(childColumn);
            });
            // Finally, add the parent column to the rootColumns array:
            this.gridFactoryColumns.rootColumns.push(groupColumDef);
        }
    }
}
DkGridColumnComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColumnComponent, deps: [{ token: DkGridFactoryColumns }], target: i0.ɵɵFactoryTarget.Component });
DkGridColumnComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridColumnComponent, selector: "dk-grid-column", inputs: { fieldName: "fieldName", headerText: "headerText", headerTooltip: "headerTooltip", dataType: "dataType", order: "order", width: "width", minWidth: "minWidth", maxWidth: "maxWidth", contentAlign: "contentAlign", draggable: "draggable", locked: "locked", resizable: "resizable", visible: "visible", sortable: "sortable", filterable: "filterable", editable: "editable", groupable: "groupable", displayMenu: "displayMenu", filter: "filter", customFilterConditions: "customFilterConditions", panel: "panel", displayOn: "displayOn", displayStatus: "displayStatus", getValue: "getValue", setValue: "setValue", editionSettings: "editionSettings", editionTemplate: "editionTemplate", displayTemplate: "displayTemplate" }, queries: [{ propertyName: "childColumns", predicate: DkGridColumnComponent }], exportAs: ["dkgColumn"], ngImport: i0, template: "", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColumnComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-column', exportAs: 'dkgColumn', changeDetection: ChangeDetectionStrategy.OnPush, template: "", styles: [""] }]
        }], ctorParameters: function () { return [{ type: DkGridFactoryColumns }]; }, propDecorators: { fieldName: [{
                type: Input
            }], headerText: [{
                type: Input
            }], headerTooltip: [{
                type: Input
            }], dataType: [{
                type: Input
            }], order: [{
                type: Input
            }], width: [{
                type: Input
            }], minWidth: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], contentAlign: [{
                type: Input
            }], draggable: [{
                type: Input
            }], locked: [{
                type: Input
            }], resizable: [{
                type: Input
            }], visible: [{
                type: Input
            }], sortable: [{
                type: Input
            }], filterable: [{
                type: Input
            }], editable: [{
                type: Input
            }], groupable: [{
                type: Input
            }], displayMenu: [{
                type: Input
            }], filter: [{
                type: Input
            }], customFilterConditions: [{
                type: Input
            }], panel: [{
                type: Input
            }], displayOn: [{
                type: Input
            }], displayStatus: [{
                type: Input
            }], getValue: [{
                type: Input
            }], setValue: [{
                type: Input
            }], editionSettings: [{
                type: Input
            }], editionTemplate: [{
                type: Input
            }], displayTemplate: [{
                type: Input
            }], childColumns: [{
                type: ContentChildren,
                args: [DkGridColumnComponent]
            }] } });

class DkColumnsModule {
}
DkColumnsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkColumnsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnsModule, declarations: [DkGridColumnComponent], imports: [CommonModule], exports: [DkGridColumnComponent] });
DkColumnsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnsModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridColumnComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        DkGridColumnComponent
                    ]
                }]
        }] });

class DkGridEmptyCellComponent {
    constructor(cdr) {
        this.cdr = cdr;
        this.changesOverValueSubscription = Subscription.EMPTY;
        this.cellHeight = '';
        this.isHeaderCell = false;
        this.contentAlign = 'start';
        this.isOverValue = false;
        this.isColumnOver$ = of({ isOver: false, isForHeaderRow: false });
    }
    ngOnInit() {
        this.setChangesOverValueSubscription(this.isColumnOver$);
    }
    setChangesOverValueSubscription(columnOver$) {
        const isOverValue$ = columnOver$.pipe(map(value => {
            if (!this.isHeaderCell || this.isHeaderCell && value.isForHeaderRow) {
                return value.isOver;
            }
            else {
                return false;
            }
        }));
        this.changesOverValueSubscription.unsubscribe();
        this.changesOverValueSubscription = isOverValue$.subscribe(value => {
            this.isOverValue = value;
            this.cdr.markForCheck();
        });
    }
}
DkGridEmptyCellComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEmptyCellComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DkGridEmptyCellComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: { isColumnOver$: "isColumnOver$", cellHeight: "cellHeight", isHeaderCell: "isHeaderCell", contentAlign: "contentAlign" }, host: { properties: { "style.height": "cellHeight", "class.dkg-empty-cell-header": "isHeaderCell", "class.dkg-column-over-column": "isOverValue", "class.dkg-cell-content-start-align": "contentAlign === 'start'", "class.dkg-cell-content-left-align": "contentAlign === 'left'", "class.dkg-cell-content-center-align": "contentAlign === 'center'", "class.dkg-cell-content-right-align": "contentAlign === 'right'", "class.dkg-cell-content-end-align": "contentAlign === 'end'" }, classAttribute: "dkg-empty-cell" }, ngImport: i0, template: "<ng-content></ng-content>\n\n", styles: [".dkg-empty-cell{display:flex;flex-direction:row;flex-wrap:nowrap;align-items:center;justify-content:center;padding-left:7px;padding-right:7px;box-sizing:border-box;min-width:0}.dkg-empty-cell p{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin:0}.dkg-empty-cell>*:not([mat-icon-button]){width:100%}.dkg-empty-cell.dkg-cell-content-start-align>*{text-align:start}.dkg-empty-cell.dkg-cell-content-left-align>*{text-align:left}.dkg-empty-cell.dkg-cell-content-center-align>*{text-align:center}.dkg-empty-cell.dkg-cell-content-right-align>*{text-align:right}.dkg-empty-cell.dkg-cell-content-end-align>*{text-align:end}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEmptyCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-empty-cell', host: {
                        'class': 'dkg-empty-cell',
                        '[style.height]': 'cellHeight',
                        '[class.dkg-empty-cell-header]': 'isHeaderCell',
                        '[class.dkg-column-over-column]': 'isOverValue',
                        '[class.dkg-cell-content-start-align]': "contentAlign === 'start'",
                        '[class.dkg-cell-content-left-align]': "contentAlign === 'left'",
                        '[class.dkg-cell-content-center-align]': "contentAlign === 'center'",
                        '[class.dkg-cell-content-right-align]': "contentAlign === 'right'",
                        '[class.dkg-cell-content-end-align]': "contentAlign === 'end'"
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>\n\n", styles: [".dkg-empty-cell{display:flex;flex-direction:row;flex-wrap:nowrap;align-items:center;justify-content:center;padding-left:7px;padding-right:7px;box-sizing:border-box;min-width:0}.dkg-empty-cell p{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin:0}.dkg-empty-cell>*:not([mat-icon-button]){width:100%}.dkg-empty-cell.dkg-cell-content-start-align>*{text-align:start}.dkg-empty-cell.dkg-cell-content-left-align>*{text-align:left}.dkg-empty-cell.dkg-cell-content-center-align>*{text-align:center}.dkg-empty-cell.dkg-cell-content-right-align>*{text-align:right}.dkg-empty-cell.dkg-cell-content-end-align>*{text-align:end}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { isColumnOver$: [{
                type: Input
            }], cellHeight: [{
                type: Input
            }], isHeaderCell: [{
                type: Input
            }], contentAlign: [{
                type: Input
            }] } });

class DkGeneralNotifier {
    constructor() {
        this.draggingNotifierSubject = new BehaviorSubject(false);
        this.pinColumnNotifierSubject = new BehaviorSubject(false);
        this.rowGroupingNotifierSubject = new BehaviorSubject(false);
        this.scrollbarWidthSubject = new BehaviorSubject(0);
        this.refreshDataSourceSubject = new Subject();
    }
    ngOnDestroy() {
        this.draggingNotifierSubject.complete();
        this.pinColumnNotifierSubject.complete();
        this.rowGroupingNotifierSubject.complete();
        this.scrollbarWidthSubject.complete();
        this.refreshDataSourceSubject.complete();
    }
    get onDraggingNotifierChanged$() {
        return this.draggingNotifierSubject.asObservable();
    }
    get onPinColumnNotifierChanged$() {
        return this.pinColumnNotifierSubject.asObservable();
    }
    get onRowGroupingNotifierChanged$() {
        return this.rowGroupingNotifierSubject.asObservable();
    }
    get onScrollbarWidthChanged$() {
        return this.scrollbarWidthSubject.asObservable();
    }
    get onRefreshDataSourceChanged$() {
        return this.refreshDataSourceSubject.asObservable();
    }
    get scrollbarWidth() {
        return this.scrollbarWidthSubject.value;
    }
    set scrollbarWidth(value) {
        this.changeScrollbarWidth(value > 0 ? value : 0);
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    notifyColumnSlotDragging(notifyDragging) {
        this.changeDraggingNotifier(notifyDragging);
    }
    notifyColumnSlotPinning(notifyPinnig) {
        this.changePinColumnNotifier(notifyPinnig);
    }
    notifyRowGroupingColumnSlot(notifyRowGrouping) {
        this.changeRowGroupingNotifier(notifyRowGrouping);
    }
    /**
     * For dragging purposes, this method generates a unique identifer for the
     * given asset.
     *
     * @param {string} containerName The string that represents a draggable container (DraggableContainer enum).
     * @param {string} assetId The unique id of the target element. It could be a column or a border.
     *
     * @returns {string} Returns the unique id for the draggable container.
     */
    createDraggableContainerId(containerName, assetId) {
        return `${containerName}-${assetId}`;
    }
    refreshDataSource() {
        this.changeRefreshDataSource();
    }
    changeDraggingNotifier(value) {
        this.draggingNotifierSubject.next(value);
    }
    changePinColumnNotifier(value) {
        this.pinColumnNotifierSubject.next(value);
    }
    changeRowGroupingNotifier(value) {
        this.rowGroupingNotifierSubject.next(value);
    }
    changeScrollbarWidth(value) {
        this.scrollbarWidthSubject.next(value);
    }
    changeRefreshDataSource() {
        this.refreshDataSourceSubject.next();
    }
}
DkGeneralNotifier.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGeneralNotifier, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DkGeneralNotifier.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGeneralNotifier });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGeneralNotifier, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class DkGridDraggableCellComponent {
    constructor(dikeConfig, generalNotifier) {
        this.dikeConfig = dikeConfig;
        this.generalNotifier = generalNotifier;
        this.draggable = false;
        this.locked = false;
        this.draggableCellHeight = `${this.dikeConfig.DRAGGABLE_CELL_HEIGHT}px`;
    }
    ngOnInit() {
        this.draggableContainer$ = merge(this.generalNotifier.onPinColumnNotifierChanged$.pipe(map(value => value ? 'pinning' : '')), this.generalNotifier.onRowGroupingNotifierChanged$.pipe(map(value => value ? 'row-grouping' : '')));
    }
}
DkGridDraggableCellComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDraggableCellComponent, deps: [{ token: CONFIG_GRID }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Component });
DkGridDraggableCellComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridDraggableCellComponent, selector: "dk-grid-draggable-cell", inputs: { draggable: "draggable", locked: "locked" }, host: { properties: { "style.height": "draggableCellHeight" }, classAttribute: "dkg-draggable-cell" }, ngImport: i0, template: "<div class=\"dkg-draggable-cell-content\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-draggable-cell-icon\">\n  <ng-container *ngIf=\"draggable; else notAllowedIcon\">\n    <ng-container *ngIf=\"!locked; else lockedIcon\">\n      <ng-container [ngSwitch]=\"draggableContainer$ | async\">\n        <ng-container *ngSwitchCase=\"'pinning'\">\n          <mat-icon>push_pin</mat-icon>\n        </ng-container>\n\n        <ng-container *ngSwitchCase=\"'row-grouping'\">\n          <mat-icon>list</mat-icon>\n        </ng-container>\n\n        <ng-container *ngSwitchDefault>\n          <mat-icon>open_with</mat-icon>\n        </ng-container>\n\n      </ng-container>\n    </ng-container>\n  </ng-container>\n</div>\n\n<ng-template #notAllowedIcon>\n  <mat-icon>do_not_disturb</mat-icon>\n</ng-template>\n\n<ng-template #lockedIcon>\n  <mat-icon>lock</mat-icon>\n</ng-template>\n", styles: [".dkg-draggable-cell{padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-around;align-items:center;border-radius:4px}.dkg-draggable-cell-content{padding-right:7px}.dkg-draggable-cell-content p{margin:0}.dkg-draggable-cell-icon{padding-left:7px;display:flex;flex-direction:column;justify-content:center;align-items:center}\n"], components: [{ type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i8.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDraggableCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-draggable-cell', host: {
                        'class': 'dkg-draggable-cell',
                        '[style.height]': 'draggableCellHeight'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-draggable-cell-content\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-draggable-cell-icon\">\n  <ng-container *ngIf=\"draggable; else notAllowedIcon\">\n    <ng-container *ngIf=\"!locked; else lockedIcon\">\n      <ng-container [ngSwitch]=\"draggableContainer$ | async\">\n        <ng-container *ngSwitchCase=\"'pinning'\">\n          <mat-icon>push_pin</mat-icon>\n        </ng-container>\n\n        <ng-container *ngSwitchCase=\"'row-grouping'\">\n          <mat-icon>list</mat-icon>\n        </ng-container>\n\n        <ng-container *ngSwitchDefault>\n          <mat-icon>open_with</mat-icon>\n        </ng-container>\n\n      </ng-container>\n    </ng-container>\n  </ng-container>\n</div>\n\n<ng-template #notAllowedIcon>\n  <mat-icon>do_not_disturb</mat-icon>\n</ng-template>\n\n<ng-template #lockedIcon>\n  <mat-icon>lock</mat-icon>\n</ng-template>\n", styles: [".dkg-draggable-cell{padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-around;align-items:center;border-radius:4px}.dkg-draggable-cell-content{padding-right:7px}.dkg-draggable-cell-content p{margin:0}.dkg-draggable-cell-icon{padding-left:7px;display:flex;flex-direction:column;justify-content:center;align-items:center}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGeneralNotifier }];
    }, propDecorators: { draggable: [{
                type: Input
            }], locked: [{
                type: Input
            }] } });

class DkGridTemplateColumnsHeaderDirective {
    constructor(cdr) {
        this.cdr = cdr;
        this.unsubscribeAll = new Subject();
        this.gridTemplateColumnsValue = '';
    }
    ngOnInit() {
        this.columnStructure.onGridTemplateColumnsHeaderChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridTemplateColumnsHeaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridTemplateColumnsHeaderDirective, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
DkGridTemplateColumnsHeaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridTemplateColumnsHeaderDirective, selector: "[dkGridTemplateColumnsHeader]", inputs: { columnStructure: ["dkGridTemplateColumnsHeader", "columnStructure"] }, host: { properties: { "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgTemplateColumnsHeader"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridTemplateColumnsHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridTemplateColumnsHeader]',
                    exportAs: 'dkgTemplateColumnsHeader',
                    host: {
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { columnStructure: [{
                type: Input,
                args: ['dkGridTemplateColumnsHeader']
            }] } });

class DkGridColResizerDirective {
    constructor(document, elementRef, render2) {
        this.document = document;
        this.elementRef = elementRef;
        this.render2 = render2;
        this.resizeSubscription = Subscription.EMPTY;
        this.isResizable = false;
        this.columnId = '';
        this.resizerType = 'Data-Column';
        this.originalWidths = {};
    }
    ngOnInit() {
        this.mousedown$ = fromEvent(this.elementRef.nativeElement, 'mousedown');
        this.mousemove$ = fromEvent(this.document, 'mousemove').pipe(tap(() => this.render2.setStyle(this.document.body, 'cursor', 'col-resize')));
        this.mouseup$ = fromEvent(this.document, 'mouseup').pipe(tap(() => {
            this.render2.setStyle(this.document.body, 'cursor', 'default');
            // Resizing operation has been finished:
            if (this.isResizable) {
                this.notifyResizingAction(false);
            }
        }));
        this.resizeDirection = this.columnStructure.panel === 'rightPanel' ? -1 : 1;
        this.setResizeSubscription();
    }
    ngOnDestroy() {
        this.resizeSubscription.unsubscribe();
    }
    onMouseOver() {
        if (this.isResizable) {
            this.render2.setStyle(this.elementRef.nativeElement, 'cursor', 'col-resize');
        }
    }
    onMouseLeave() {
        this.render2.setStyle(this.elementRef.nativeElement, 'cursor', 'default');
    }
    changeDataColumnSlotsWidth(delta) {
        delta *= this.resizeDirection;
        if (this.columnSlots.length > 0) {
            let deltaPerColumn = Math.floor(delta / this.columnSlots.length);
            let deltaMod = delta % this.columnSlots.length;
            let finalDelta = 0;
            this.columnSlots.forEach((slot, index) => {
                finalDelta = index === this.columnSlots.length - 1 ? deltaPerColumn + deltaMod : deltaPerColumn;
                this.columnStructure.setColumnSlotWidth(slot, this.originalWidths[slot.dikeColumn.columnId] + finalDelta);
            });
        }
    }
    getDataColumnSlots() {
        let dataColumnSlots = [];
        // Get only data columns (leaves) from its corresponding level:
        switch (this.resizerType) {
            case 'Group-Column':
                dataColumnSlots.push(...this.columnStructure.getDataColumnSlotsFromSlot(this.columnId));
                break;
            case 'Data-Column':
                dataColumnSlots.push(this.columnStructure.getColumnSlot(this.columnId));
                break;
            case 'Panel':
                dataColumnSlots.push(...this.columnStructure.getDataColumnSlots());
                break;
        }
        // Get only visible and resizable slots:
        return dataColumnSlots.filter(slot => slot.dikeColumn.visible && slot.dikeColumn.resizable);
    }
    getDataColumnslotsOriginalWidth(dataSlots) {
        let originalDataColumnWidths = {};
        dataSlots.forEach(slot => originalDataColumnWidths[slot.dikeColumn.columnId] = slot.dikeColumn.width);
        return originalDataColumnWidths;
    }
    setResizeSubscription() {
        this.resizeSubscription.unsubscribe();
        this.resizeSubscription = this.mousedown$.pipe(concatMap((downEvent) => {
            downEvent.preventDefault();
            this.mousedown_x = downEvent.pageX;
            // If the resize action is allowed, notify the action to draw the corresponding line:
            if (this.isResizable) {
                this.notifyResizingAction(true);
            }
            // Get the corresponding data slots:
            this.columnSlots = this.getDataColumnSlots();
            // Then get its original widths:
            this.originalWidths = this.getDataColumnslotsOriginalWidth(this.columnSlots);
            return this.mousemove$.pipe(map((moveEvent) => {
                moveEvent.preventDefault();
                return moveEvent.pageX - this.mousedown_x;
            }), takeUntil(merge(this.mouseup$, this.isResizable ? EMPTY : of(this.isResizable))));
        })).subscribe(deltaWidth => this.changeDataColumnSlotsWidth(deltaWidth));
    }
    notifyResizingAction(isResizing) {
        if (this.resizerType === 'Panel') {
            // Notify that the whole panel is being resizing:
            this.columnStructure.isPanelResizing(isResizing);
        }
        else {
            // Notify that the current slot is being resizing:
            this.columnStructure.notifySlotResizing(this.gutterSlot, isResizing);
        }
    }
}
DkGridColResizerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColResizerDirective, deps: [{ token: DOCUMENT }, { token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
DkGridColResizerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: { isResizable: ["dkGridColResizer", "isResizable"], columnStructure: "columnStructure", resizerType: "resizerType", columnId: "columnId", gutterSlot: "gutterSlot" }, host: { listeners: { "mouseenter": "onMouseOver()", "mouseleave": "onMouseLeave()" } }, exportAs: ["dkgColResizer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColResizerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridColResizer]',
                    exportAs: 'dkgColResizer'
                }]
        }], ctorParameters: function () {
        return [{ type: Document, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }, { type: i0.ElementRef }, { type: i0.Renderer2 }];
    }, propDecorators: { isResizable: [{
                type: Input,
                args: ['dkGridColResizer']
            }], columnStructure: [{
                type: Input
            }], resizerType: [{
                type: Input
            }], columnId: [{
                type: Input
            }], gutterSlot: [{
                type: Input
            }], onMouseOver: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

class DkGridItemPlacementDirective {
    constructor() {
        this.gridColumnStart = '';
        this.gridColumnEnd = '';
        this.gridRowStart = '';
        this.gridRowEnd = '';
        this.alignSelf = '';
        this.justifySelf = '';
    }
}
DkGridItemPlacementDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridItemPlacementDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DkGridItemPlacementDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: { gridColumnStart: "gridColumnStart", gridColumnEnd: "gridColumnEnd", gridRowStart: "gridRowStart", gridRowEnd: "gridRowEnd", alignSelf: "alignSelf", justifySelf: "justifySelf" }, host: { properties: { "style.grid-column-start": "gridColumnStart", "style.grid-column-end": "gridColumnEnd", "style.grid-row-start": "gridRowStart", "style.grid-row-end": "gridRowEnd", "style.align-self": "alignSelf", "style.justify-self": "justifySelf" } }, exportAs: ["dkgItemPlacement"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridItemPlacementDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridItemPlacement]',
                    exportAs: 'dkgItemPlacement',
                    host: {
                        '[style.grid-column-start]': 'gridColumnStart',
                        '[style.grid-column-end]': 'gridColumnEnd',
                        '[style.grid-row-start]': 'gridRowStart',
                        '[style.grid-row-end]': 'gridRowEnd',
                        '[style.align-self]': 'alignSelf',
                        '[style.justify-self]': 'justifySelf',
                    }
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { gridColumnStart: [{
                type: Input
            }], gridColumnEnd: [{
                type: Input
            }], gridRowStart: [{
                type: Input
            }], gridRowEnd: [{
                type: Input
            }], alignSelf: [{
                type: Input
            }], justifySelf: [{
                type: Input
            }] } });

class DisabledElementDirective {
    constructor() { }
    get disabled() {
        return true;
    }
}
DisabledElementDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DisabledElementDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DisabledElementDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DisabledElementDirective, selector: "[disabled-element]", host: { properties: { "attr.disabled": "this.disabled" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DisabledElementDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[disabled-element]'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { disabled: [{
                type: HostBinding,
                args: ['attr.disabled']
            }] } });

class ColumnOverValueForHeaderPipe {
    transform(value) {
        return value.isForHeaderRow ? value.isOver : false;
    }
}
ColumnOverValueForHeaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnOverValueForHeaderPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ColumnOverValueForHeaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnOverValueForHeaderPipe, name: "columnOverValueForHeader" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnOverValueForHeaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'columnOverValueForHeader'
                }]
        }] });

class DraggableContainerIdPipe {
    constructor(generalNotifier) {
        this.generalNotifier = generalNotifier;
    }
    transform(assetId, containerName) {
        return this.generalNotifier.createDraggableContainerId(containerName, assetId);
    }
}
DraggableContainerIdPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggableContainerIdPipe, deps: [{ token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Pipe });
DraggableContainerIdPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggableContainerIdPipe, name: "draggableContainerId" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggableContainerIdPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'draggableContainerId'
                }]
        }], ctorParameters: function () { return [{ type: DkGeneralNotifier }]; } });

const ROOT_GROUP_ID = 'root-group';
class DkMeshSlot {
    constructor(dikeColumn) {
        this.slotPosition = { gridColumnStart: 0, gridColumnEnd: 0, gridRowStart: 0, gridRowEnd: 0 };
        this.dikeColumn = dikeColumn;
        this.slotId = '';
        this.belongToGroup = '';
        this.slotHeight = 0;
        this.connectedSiblingIds = {};
        this.connectedSiblingIds['drop-gutter-container'] = [];
        this.connectedSiblingIds['drop-swap-column-container'] = [];
        this.connectedSiblingIds['source-column-container'] = [];
        this.connectedSiblingIds['drop-border-container'] = [];
        this.columnOverSubject = new BehaviorSubject({
            isOver: false,
            isForHeaderRow: false
        });
        this.initialDisplayOn = 'open';
        this.currentDisplayOn = 'open';
    }
    get onColumnOverChanged$() {
        return this.columnOverSubject.asObservable();
    }
    isColumnOver(value) {
        this.changeColumnOver(value);
    }
    changeColumnOver(value) {
        this.columnOverSubject.next(value);
    }
}
class DkGutterMeshSlot extends DkMeshSlot {
    constructor(dikeColumn) {
        super(dikeColumn);
        if (dikeColumn && dikeColumn.columnType !== 'Gutter-Column') {
            throw new Error('DkGutterMeshSlot must be created with a DkGutterColumn column type.');
        }
        this.columnResizingSubject = new BehaviorSubject({
            isResizing: false,
            isForHeaderRow: false
        });
    }
    get onColumnResizingChanged$() {
        return this.columnResizingSubject.asObservable();
    }
    isColumnResizing(value) {
        this.changeColumnResizing(value);
    }
    changeColumnResizing(value) {
        this.columnResizingSubject.next(value);
    }
}
class DkColumnMeshSlot extends DkMeshSlot {
    constructor(dikeColumn, dikeGutterColumn = null) {
        super(dikeColumn);
        this.dikeGutterSlot = dikeGutterColumn ? new DkGutterMeshSlot(dikeGutterColumn) : null;
        if (this.dikeGutterSlot) {
            this.dikeGutterSlot.dikeColumn.panel = dikeColumn.panel;
            this.dikeGutterSlot.dikeColumn.columnIdBelongTo = this.dikeColumn.columnId;
        }
        this.complementDikeGutterSlot = null;
        this.horizontalGutter = null;
        this.isFirst = false;
        this.isLast = false;
        this.displayStatus = 'open';
        this.canChangeDisplayStatus = false;
        this.editionSettings = null;
        this.editionTemplate = null;
        this.displayTemplate = null;
    }
}

class DraggingConnectedContainerIdsPipe {
    constructor(generalNotifier) {
        this.generalNotifier = generalNotifier;
    }
    transform(slot, panel, dropShareables, [leftBorder, rightBorder], rowGroupingAreaId) {
        if (!slot.dikeColumn.draggable || slot.dikeColumn.locked) {
            return [];
        }
        let connectedIds = [
            ...[
                ...slot.connectedSiblingIds['drop-swap-column-container'],
                ...this.getConnectedContainerIds(panel, slot.belongToGroup, dropShareables, 'drop-swap-column-container')
            ].map(swapColumnId => this.generalNotifier.createDraggableContainerId('drop-swap-column-container', swapColumnId)),
            ...[
                ...slot.connectedSiblingIds['drop-gutter-container'],
                ...this.getConnectedContainerIds(panel, slot.belongToGroup, dropShareables, 'drop-gutter-container')
            ].map(gutterId => this.generalNotifier.createDraggableContainerId('drop-gutter-container', gutterId)),
            ...[
                ...this.getConnectedContainerIds(panel, slot.belongToGroup, dropShareables, 'drop-border-container')
            ].map(borderId => {
                // In the case of border, borderId represents the border type:
                if (borderId === 'leftBorder') {
                    return this.generalNotifier.createDraggableContainerId('drop-border-container', leftBorder.borderId);
                }
                else if (borderId === 'rightBorder') {
                    return this.generalNotifier.createDraggableContainerId('drop-border-container', rightBorder.borderId);
                }
            })
        ];
        // The given data slot belongs to any of the Content Panels and is groupable:
        if (panel !== 'groupPanel' && slot.dikeColumn.columnType === 'Data-Column' && slot.dikeColumn.groupable) {
            // Gutters from Group Panel columns are obtained:
            let groupGutterIds = [
                ...this.getGutterContainerIds('groupPanel', ROOT_GROUP_ID, dropShareables)
            ].map(gutterId => `drop-gutter-container-${gutterId}`);
            // And the row-grouping-area itself:
            connectedIds = [...connectedIds, ...groupGutterIds,
                this.generalNotifier.createDraggableContainerId('drop-row-grouping-area-container', rowGroupingAreaId)
            ];
        }
        return connectedIds;
    }
    getConnectedContainerIds(currentPanel, belongToGroup, dropPanelShareables, containerName) {
        // For any slot comming from the Group Panel, only matters the borders and the Content Panels' gutters:
        if (currentPanel === 'groupPanel') {
            switch (containerName) {
                case 'drop-gutter-container':
                    return this.getContentGutterContainerIds(belongToGroup, dropPanelShareables);
                case 'drop-border-container':
                    return ['leftBorder', 'rightBorder'];
                default:
                    return [];
            }
        }
        return this.getContentConnectedContainerIds(currentPanel, belongToGroup, dropPanelShareables, containerName);
    }
    getContentConnectedContainerIds(currentPanel, belongToGroup, dropPanelShareables, containerName) {
        let dropShareablesOne;
        let dropShareablesTwo;
        switch (currentPanel) {
            case 'leftPanel':
                dropShareablesOne = dropPanelShareables.centerPanel;
                dropShareablesTwo = dropPanelShareables.rightPanel;
                break;
            case 'centerPanel':
                dropShareablesOne = dropPanelShareables.leftPanel;
                dropShareablesTwo = dropPanelShareables.rightPanel;
                break;
            case 'rightPanel':
                dropShareablesOne = dropPanelShareables.leftPanel;
                dropShareablesTwo = dropPanelShareables.centerPanel;
                break;
            default:
                throw new Error(`The given panel (${currentPanel}) does not exist.`);
        }
        let dropElementIds = [];
        if (dropShareablesOne.has(belongToGroup)) {
            dropElementIds.push(...dropShareablesOne.get(belongToGroup)[containerName]);
        }
        if (dropShareablesTwo.has(belongToGroup)) {
            dropElementIds.push(...dropShareablesTwo.get(belongToGroup)[containerName]);
        }
        /**
         * If the given belongToGroup groupId is not split and the
         * container is DROP_BORDER, then add both borders to the
         * returned array. Thus, the current slot could move to
         * left or right panel dragging it to the corresponding
         * border.
         */
        if (dropElementIds.length === 0 && containerName === 'drop-border-container') {
            dropElementIds = ['leftBorder', 'rightBorder'];
        }
        /**
         * If a column slot is in the left or right panel, avoid moving it to
         * the same border panel. It means a column slot which is in the left panel,
         * dragging to the left border is avoided.
         */
        return containerName === 'drop-border-container' ? dropElementIds.filter(elementId => {
            if (currentPanel === 'leftPanel') {
                return elementId === 'rightBorder';
            }
            else if (currentPanel === 'rightPanel') {
                return elementId === 'leftBorder';
            }
            else {
                return true;
            }
        }) : dropElementIds;
    }
    getContentGutterContainerIds(belongToGroup, dropPanelShareables) {
        let elementIds = [];
        let contentPanels = ['leftPanel', 'centerPanel', 'rightPanel'];
        /**
         * For each Content Panel, gutters from the ROOT_GROUP_ID will be obtained.
         *
         * Remember that Group Panel contains only root slots because it does not have
         * group columns only data columns.
         *
         * Therefore belongToGroup parameter has the value ROOT_GROUP_ID.
         */
        contentPanels.forEach(panel => {
            elementIds = [...elementIds, ...this.getGutterContainerIds(panel, belongToGroup, dropPanelShareables)];
        });
        return elementIds;
    }
    getGutterContainerIds(targetPanel, belongToGroup, dropPanelShareables) {
        let dropElementIds = [];
        if (dropPanelShareables[targetPanel].has(belongToGroup)) {
            dropElementIds.push(...dropPanelShareables[targetPanel].get(belongToGroup)['drop-gutter-container']);
        }
        return dropElementIds;
    }
}
DraggingConnectedContainerIdsPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggingConnectedContainerIdsPipe, deps: [{ token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Pipe });
DraggingConnectedContainerIdsPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggingConnectedContainerIdsPipe, name: "draggingConnectedContainerIds" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DraggingConnectedContainerIdsPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'draggingConnectedContainerIds'
                }]
        }], ctorParameters: function () { return [{ type: DkGeneralNotifier }]; } });

class DkCommonModule {
}
DkCommonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkCommonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkCommonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkCommonModule, declarations: [DkGridEmptyCellComponent,
        DkGridDraggableCellComponent,
        DkGridTemplateColumnsHeaderDirective,
        DkGridColResizerDirective,
        DkGridItemPlacementDirective,
        DisabledElementDirective,
        ColumnOverValueForHeaderPipe,
        DraggableContainerIdPipe,
        DraggingConnectedContainerIdsPipe], imports: [CommonModule,
        MatIconModule], exports: [DkGridEmptyCellComponent,
        DkGridDraggableCellComponent,
        DkGridTemplateColumnsHeaderDirective,
        DkGridColResizerDirective,
        DkGridItemPlacementDirective,
        DisabledElementDirective,
        ColumnOverValueForHeaderPipe,
        DraggableContainerIdPipe,
        DraggingConnectedContainerIdsPipe] });
DkCommonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkCommonModule, imports: [[
            CommonModule,
            MatIconModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkCommonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridEmptyCellComponent,
                        DkGridDraggableCellComponent,
                        DkGridTemplateColumnsHeaderDirective,
                        DkGridColResizerDirective,
                        DkGridItemPlacementDirective,
                        DisabledElementDirective,
                        ColumnOverValueForHeaderPipe,
                        DraggableContainerIdPipe,
                        DraggingConnectedContainerIdsPipe
                    ],
                    imports: [
                        CommonModule,
                        MatIconModule
                    ],
                    exports: [
                        DkGridEmptyCellComponent,
                        DkGridDraggableCellComponent,
                        DkGridTemplateColumnsHeaderDirective,
                        DkGridColResizerDirective,
                        DkGridItemPlacementDirective,
                        DisabledElementDirective,
                        ColumnOverValueForHeaderPipe,
                        DraggableContainerIdPipe,
                        DraggingConnectedContainerIdsPipe
                    ]
                }]
        }] });

class DkGridHorizontalGutterComponent {
    constructor() {
        this.isHeaderGutter = false;
        this.gutterHeight = '';
    }
}
DkGridHorizontalGutterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridHorizontalGutterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DkGridHorizontalGutterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: { isHeaderGutter: "isHeaderGutter", gutterHeight: "gutterHeight" }, host: { properties: { "style.height": "gutterHeight", "class.dkg-horizontal-gutter-header": "isHeaderGutter" }, classAttribute: "dkg-horizontal-gutter" }, ngImport: i0, template: "<div class=\"dkg-horizontal-gutter-line\"></div>\n\n\n", styles: [".dkg-horizontal-gutter{align-self:center;justify-self:center;width:100%;display:flex;flex-direction:column;justify-content:center}.dkg-horizontal-gutter-line{border-top-style:solid;border-top-width:1px}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridHorizontalGutterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-horizontal-gutter', host: {
                        'class': 'dkg-horizontal-gutter',
                        '[style.height]': 'gutterHeight',
                        '[class.dkg-horizontal-gutter-header]': 'isHeaderGutter'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-horizontal-gutter-line\"></div>\n\n\n", styles: [".dkg-horizontal-gutter{align-self:center;justify-self:center;width:100%;display:flex;flex-direction:column;justify-content:center}.dkg-horizontal-gutter-line{border-top-style:solid;border-top-width:1px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { isHeaderGutter: [{
                type: Input
            }], gutterHeight: [{
                type: Input
            }] } });

class DkGridVerticalGutterComponent {
    constructor() {
        this.isHeaderGutter = false;
        this.isEmpty = false;
        this.gutterHeight = '';
        this.isColumnOver$ = of({ isOver: false, isForHeaderRow: false });
        this.isColumnResizing$ = of({ isResizing: false, isForHeaderRow: false });
    }
    ngOnInit() {
        this.isOver$ = this.isColumnOver$.pipe(map(value => {
            if (!this.isHeaderGutter || this.isHeaderGutter && value.isForHeaderRow) {
                return value.isOver;
            }
            else {
                return false;
            }
        }));
        this.isResizing$ = this.isColumnResizing$.pipe(map(value => {
            if (!this.isHeaderGutter || this.isHeaderGutter && value.isForHeaderRow) {
                return value.isResizing;
            }
            else {
                return false;
            }
        }));
    }
}
DkGridVerticalGutterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridVerticalGutterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DkGridVerticalGutterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: { isColumnOver$: "isColumnOver$", isColumnResizing$: "isColumnResizing$", isEmpty: "isEmpty", isHeaderGutter: "isHeaderGutter", gutterHeight: "gutterHeight", flexboxJustifyContent: "flexboxJustifyContent" }, host: { properties: { "style.height": "gutterHeight", "style.justify-content": "flexboxJustifyContent", "class.dkg-vertical-gutter-header": "isHeaderGutter" }, classAttribute: "dkg-vertical-gutter" }, ngImport: i0, template: "<div\n  [class.dkg-vertical-normal-gutter-line]=\"!this.isEmpty && !((isOver$ | async) || (isResizing$ | async))\"\n  [class.dkg-column-over-gutter-line]=\"isOver$ | async\"\n  [class.dkg-column-resizing-gutter-line]=\"isResizing$ | async\">\n</div>\n", styles: [".dkg-vertical-gutter{justify-self:center;align-self:center;width:5px;display:flex;flex-direction:row;justify-content:center}.dkg-vertical-normal-gutter-line{border-top:0;border-right-style:solid;border-right-width:1px}.dkg-column-resizing-gutter-line,.dkg-column-over-gutter-line{border-top:0;border-right-style:solid;border-right-width:5px}\n"], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridVerticalGutterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-vertical-gutter', host: {
                        'class': 'dkg-vertical-gutter',
                        '[style.height]': 'gutterHeight',
                        '[style.justify-content]': 'flexboxJustifyContent',
                        '[class.dkg-vertical-gutter-header]': 'isHeaderGutter'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  [class.dkg-vertical-normal-gutter-line]=\"!this.isEmpty && !((isOver$ | async) || (isResizing$ | async))\"\n  [class.dkg-column-over-gutter-line]=\"isOver$ | async\"\n  [class.dkg-column-resizing-gutter-line]=\"isResizing$ | async\">\n</div>\n", styles: [".dkg-vertical-gutter{justify-self:center;align-self:center;width:5px;display:flex;flex-direction:row;justify-content:center}.dkg-vertical-normal-gutter-line{border-top:0;border-right-style:solid;border-right-width:1px}.dkg-column-resizing-gutter-line,.dkg-column-over-gutter-line{border-top:0;border-right-style:solid;border-right-width:5px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { isColumnOver$: [{
                type: Input
            }], isColumnResizing$: [{
                type: Input
            }], isEmpty: [{
                type: Input
            }], isHeaderGutter: [{
                type: Input
            }], gutterHeight: [{
                type: Input
            }], flexboxJustifyContent: [{
                type: Input
            }] } });

class GutterFlexboxPositionPipe {
    transform(columnSlot, panel, panelsVisibility, isComplementGutter) {
        let justifyContent = '';
        if (panel === 'leftPanel') {
            if (columnSlot.isLast && !isComplementGutter) {
                justifyContent = 'flex-end';
            }
        }
        else if (panel === 'centerPanel') {
            if (columnSlot.isFirst && isComplementGutter && (panelsVisibility.LC || panelsVisibility.LCR)) {
                justifyContent = 'flex-start';
            }
            if (columnSlot.isLast && !isComplementGutter) {
                justifyContent = 'flex-end';
            }
        }
        else if (panel === 'rightPanel') {
            if (columnSlot.isFirst) {
                justifyContent = 'flex-start';
            }
            if (columnSlot.isLast && isComplementGutter) {
                justifyContent = 'flex-end';
            }
        }
        return justifyContent;
    }
}
GutterFlexboxPositionPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GutterFlexboxPositionPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
GutterFlexboxPositionPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GutterFlexboxPositionPipe, name: "gutterFlexboxPosition" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GutterFlexboxPositionPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'gutterFlexboxPosition'
                }]
        }] });

class DkGuttersModule {
}
DkGuttersModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGuttersModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkGuttersModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGuttersModule, declarations: [DkGridHorizontalGutterComponent,
        DkGridVerticalGutterComponent,
        GutterFlexboxPositionPipe], imports: [CommonModule], exports: [DkGridHorizontalGutterComponent,
        DkGridVerticalGutterComponent,
        GutterFlexboxPositionPipe] });
DkGuttersModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGuttersModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGuttersModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridHorizontalGutterComponent,
                        DkGridVerticalGutterComponent,
                        GutterFlexboxPositionPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        DkGridHorizontalGutterComponent,
                        DkGridVerticalGutterComponent,
                        GutterFlexboxPositionPipe
                    ]
                }]
        }] });

const GRID_HEIGHT = new InjectionToken('grid-height');
const GRID_WIDTH = new InjectionToken('grid-width');
const HEADER_ROW_HEIGHT = new InjectionToken('header-row-height');
const FILTER_ROW_HEIGHT = new InjectionToken('filter-row-height');
const CONTENT_ROW_HEIGHT = new InjectionToken('content-row-height');
const ROW_GROUPING_ROW_HEIGHT = new InjectionToken('row-grouping-row-height');
const ROW_GROUPING_COLUMN_HEIGHT = new InjectionToken('row-grouping-column-height');
const PAGINATION_ROW_HEIGHT = new InjectionToken('pagination-row-height');
const EDITION_TOOLBAR_ROW_HEIGHT = new InjectionToken('edition-toolbar-row-height');
const EDITION_TOOLBAR_ITEM_HEIGHT = new InjectionToken('edition-toolbar-item-height');
const DIVISION_PANEL_LINE_WIDTH = new InjectionToken('division-panel-line-width');
const DIVISION_PANEL_LINE_WIDTH_RESIZING = new InjectionToken('division-panel-line-width-resizing');
const DIVISION_PANEL_GAP = new InjectionToken('division-panel-gap');
const BORDER_WIDTH = new InjectionToken('border-width');
const BORDER_GAP = new InjectionToken('border-gap');
const LOADING_MESSAGE = new InjectionToken('loading-message');
const PROCESSING_MESSAGE = new InjectionToken('processing-message');
const CUSTOM_SCROLLBARS = new InjectionToken('custom-scrollbars');

const DK_CONTEXT_MENU_DATA = new InjectionToken('dk-context-menu-data');
// Public tokens:
const COLUMN_CONTEXT_MENU = new InjectionToken('column-context-menu');
const COLUMN_CONTEXT_MENU_WIDTH = new InjectionToken('column-context-menu-width');
const COLUMN_CONTEXT_MENU_HEIGHT = new InjectionToken('column-context-menu-height');

class DkGridConfig {
    constructor(dikeConfig, gridCustomScrollbars, loadingMessage, processingMessage, gridHeight, gridWidth, gridDivisionPanelLineWidth, gridDivisionPanelLineWidthResizing, gridDivisionPanelGap, allowGridColumnContextMenu, gridColumnContextMenuWidth, gridColumnContextMenuHeight) {
        this.dikeConfig = dikeConfig;
        this.gridCustomScrollbars = gridCustomScrollbars;
        this.loadingMessage = loadingMessage;
        this.processingMessage = processingMessage;
        this.gridHeight = gridHeight;
        this.gridWidth = gridWidth;
        this.gridDivisionPanelLineWidth = gridDivisionPanelLineWidth;
        this.gridDivisionPanelLineWidthResizing = gridDivisionPanelLineWidthResizing;
        this.gridDivisionPanelGap = gridDivisionPanelGap;
        this.allowGridColumnContextMenu = allowGridColumnContextMenu;
        this.gridColumnContextMenuWidth = gridColumnContextMenuWidth;
        this.gridColumnContextMenuHeight = gridColumnContextMenuHeight;
        if (this.gridCustomScrollbars === null || this.gridCustomScrollbars === undefined) {
            this.gridCustomScrollbars = this.dikeConfig.CUSTOM_SCROLLBARS;
        }
        if (this.loadingMessage === null || this.loadingMessage === undefined || this.loadingMessage.trim() === '') {
            this.loadingMessage = this.dikeConfig.LOADING_MESSAGE;
        }
        if (this.processingMessage === null || this.processingMessage === undefined || this.processingMessage.trim() === '') {
            this.processingMessage = this.dikeConfig.PROCESSING_MESSAGE;
        }
        if (this.gridHeight === null || this.gridHeight === undefined || this.gridHeight.trim() === '') {
            this.gridHeight = this.dikeConfig.HEIGHT;
        }
        if (this.gridWidth === null || this.gridWidth === undefined || this.gridWidth.trim() === '') {
            this.gridWidth = this.dikeConfig.WIDTH;
        }
        if (this.gridDivisionPanelLineWidth === null || this.gridDivisionPanelLineWidth === undefined) {
            this.gridDivisionPanelLineWidth = this.dikeConfig.DIVISION_PANEL_LINE_WIDTH;
        }
        if (this.gridDivisionPanelLineWidthResizing === null || this.gridDivisionPanelLineWidthResizing === undefined) {
            this.gridDivisionPanelLineWidthResizing = this.dikeConfig.DIVISION_PANEL_LINE_WIDTH_RESIZING;
        }
        if (this.gridDivisionPanelGap === null || this.gridDivisionPanelGap === undefined) {
            this.gridDivisionPanelGap = this.dikeConfig.DIVISION_PANEL_GAP;
        }
        if (this.allowGridColumnContextMenu === null || this.allowGridColumnContextMenu === undefined) {
            this.allowGridColumnContextMenu = this.dikeConfig.COLUMN_CONTEXT_MENU;
        }
        if (this.gridColumnContextMenuWidth === null || this.gridColumnContextMenuWidth === undefined) {
            this.gridColumnContextMenuWidth = this.dikeConfig.COLUMN_CONTEXT_MENU_WIDTH;
        }
        if (this.gridColumnContextMenuHeight === null || this.gridColumnContextMenuHeight === undefined) {
            this.gridColumnContextMenuHeight = this.dikeConfig.COLUMN_CONTEXT_MENU_HEIGHT;
        }
        this.dikeGridId = generateUUID();
        this.allowColumnDraggingSubject = new BehaviorSubject(this.dikeConfig.ALLOW_COLUMN_DRAGGING);
        this.allowColumnContextMenuSubject = new BehaviorSubject(this.allowGridColumnContextMenu);
        this.waitIndicatorSubject = new BehaviorSubject({ active: false });
        this.initializedSubject = new BehaviorSubject(false);
    }
    ngOnDestroy() {
        this.allowColumnDraggingSubject.complete();
        this.allowColumnContextMenuSubject.complete();
        this.waitIndicatorSubject.complete();
        this.initializedSubject.complete();
    }
    get onAllowColumnDraggingChanged$() {
        return this.allowColumnDraggingSubject.asObservable();
    }
    get onAllowColumnContextMenuChanged$() {
        return this.allowColumnContextMenuSubject.asObservable();
    }
    get onWaitIndicatorChanged$() {
        return this.waitIndicatorSubject.asObservable();
    }
    get onInitializedChanged$() {
        return this.initializedSubject.asObservable();
    }
    get textDisplayTemplate() {
        return this.dikeTextDisplay;
    }
    set textDisplayTemplate(template) {
        this.dikeTextDisplay = template;
    }
    get numericDisplayTemplate() {
        return this.dikeNumericDisplay;
    }
    set numericDisplayTemplate(template) {
        this.dikeNumericDisplay = template;
    }
    get dateDisplayTemplate() {
        return this.dikeDateDisplay;
    }
    set dateDisplayTemplate(template) {
        this.dikeDateDisplay = template;
    }
    get binaryDisplayTemplate() {
        return this.dikeBinaryDisplay;
    }
    set binaryDisplayTemplate(template) {
        this.dikeBinaryDisplay = template;
    }
    get gridId() {
        return this.dikeGridId;
    }
    set gridId(value) {
        if (value !== null && value !== undefined && value.trim() !== '') {
            this.dikeGridId = value;
        }
    }
    get height() {
        return this.gridHeight;
    }
    set height(value) {
        this.gridHeight = value;
    }
    get width() {
        return this.gridWidth;
    }
    set width(value) {
        this.gridWidth = value;
    }
    get allowColumnDragging() {
        return this.allowColumnDraggingSubject.value;
    }
    set allowColumnDragging(value) {
        this.changeAllowColumnDragging(value);
    }
    get allowColumnContextMenu() {
        return this.allowColumnContextMenuSubject.value;
    }
    set allowColumnContextMenu(value) {
        this.changeAllowColumnContextMenu(value);
    }
    get divisionPanelLineWidth() {
        return this.gridDivisionPanelLineWidth;
    }
    get divisionPanelLineWidthResizing() {
        return this.gridDivisionPanelLineWidthResizing;
    }
    get divisionPanelGap() {
        return this.gridDivisionPanelGap;
    }
    get columnContextMenuWidth() {
        return this.gridColumnContextMenuWidth;
    }
    get columnContextMenuHeight() {
        return this.gridColumnContextMenuHeight;
    }
    get customScrollbars() {
        return this.gridCustomScrollbars;
    }
    get isWaitingIndicatorActive() {
        return this.waitIndicatorSubject.value.active;
    }
    initialized() {
        this.changeInitialized(true);
    }
    isInitialized() {
        return this.initializedSubject.value;
    }
    displayLoadingIndicator() {
        if (!this.isWaitingIndicatorActive) {
            this.changeWaitingIndicator({ active: true, message: this.loadingMessage });
        }
    }
    displayProcessingIndicator() {
        if (!this.isWaitingIndicatorActive) {
            this.changeWaitingIndicator({ active: true, message: this.processingMessage });
        }
    }
    displayWaitingIndicator(message) {
        if (!this.isWaitingIndicatorActive) {
            this.changeWaitingIndicator({ active: true, message });
        }
    }
    hideWaitingIndicator() {
        this.changeWaitingIndicator({ active: false });
    }
    getDefaultDisplayTemplate(columnDataType) {
        switch (columnDataType) {
            case 'Text':
                return this.textDisplayTemplate;
            case 'Numeric':
                return this.numericDisplayTemplate;
            case 'Date':
                return this.dateDisplayTemplate;
            case 'Binary':
                return this.binaryDisplayTemplate;
            default:
                return this.textDisplayTemplate;
        }
    }
    getCdkBufferPx(visiblecolumns) {
        if (visiblecolumns > 10 && visiblecolumns <= 15) {
            return { minBufferPx: 350, maxBufferPx: 700 };
        }
        else if (visiblecolumns > 15 && visiblecolumns <= 20) {
            return { minBufferPx: 350, maxBufferPx: 750 };
        }
        else if (visiblecolumns > 20 && visiblecolumns <= 25) {
            return { minBufferPx: 400, maxBufferPx: 800 };
        }
        else if (visiblecolumns > 25) {
            return { minBufferPx: 450, maxBufferPx: 850 };
        }
        return { minBufferPx: 300, maxBufferPx: 650 };
    }
    changeAllowColumnDragging(value) {
        this.allowColumnDraggingSubject.next(value);
    }
    changeAllowColumnContextMenu(value) {
        this.allowColumnContextMenuSubject.next(value);
    }
    changeWaitingIndicator(value) {
        this.waitIndicatorSubject.next(value);
    }
    changeInitialized(value) {
        this.initializedSubject.next(value);
    }
}
DkGridConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridConfig, deps: [{ token: CONFIG_GRID }, { token: CUSTOM_SCROLLBARS, optional: true }, { token: LOADING_MESSAGE, optional: true }, { token: PROCESSING_MESSAGE, optional: true }, { token: GRID_HEIGHT, optional: true }, { token: GRID_WIDTH, optional: true }, { token: DIVISION_PANEL_LINE_WIDTH, optional: true }, { token: DIVISION_PANEL_LINE_WIDTH_RESIZING, optional: true }, { token: DIVISION_PANEL_GAP, optional: true }, { token: COLUMN_CONTEXT_MENU, optional: true }, { token: COLUMN_CONTEXT_MENU_WIDTH, optional: true }, { token: COLUMN_CONTEXT_MENU_HEIGHT, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridConfig, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_SCROLLBARS]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [LOADING_MESSAGE]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [PROCESSING_MESSAGE]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [GRID_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [GRID_WIDTH]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [DIVISION_PANEL_LINE_WIDTH]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [DIVISION_PANEL_LINE_WIDTH_RESIZING]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [DIVISION_PANEL_GAP]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [COLUMN_CONTEXT_MENU]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [COLUMN_CONTEXT_MENU_WIDTH]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [COLUMN_CONTEXT_MENU_HEIGHT]
                    }] }];
    } });

class DkBinaryFilterComponent {
    constructor(dikeConfig, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        this.CLEAR_FILTER = 'clear-filter';
        this.onDemandFilter = false;
        this.displayEmptyValuesOption = false;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this.filterChange = new EventEmitter();
    }
    ngOnInit() {
        this.displayEmptyValuesOption = this.hasEmptyCondition(this.selectionFilterInstance.conditions);
        this.conditionTypes = this.selectionFilterInstance.conditions.filter(condition => {
            return condition.value !== ConditionType.EMPTY;
        });
        this.options = this.selectionFilterInstance.options;
        this.createForm(this.appliedFilter ? this.appliedFilter : []);
    }
    get conditions() {
        return this.binaryFilterForm.get('conditions');
    }
    addCondition() {
    }
    clear() {
        this.appliedFilter = [];
        this.createForm(this.appliedFilter);
        this.filterChange.emit({
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    onConditionTypeChange(event, conditionGroup) {
        if (!(conditionGroup instanceof FormGroup)) {
            return;
        }
        if (event.value === ConditionType.EMPTY) {
            conditionGroup.removeControl('value');
        }
        else if (!conditionGroup.contains('value')) {
            conditionGroup.addControl('value', this.addValueControl(''));
        }
        this.emitValues(!this.onDemandFilter);
    }
    onBinaryOptionChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onIncludeEmptyValuesChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onOptionChange(event) {
        if (event.value === this.CLEAR_FILTER) {
            this.clear();
        }
        else {
            this.emitValues(!this.onDemandFilter);
        }
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    createForm(initialFilter) {
        let initialFilterWithoutEmptyCondition = initialFilter.filter(filter => {
            return filter.condition !== ConditionType.EMPTY;
        });
        let emptyFilter = initialFilter.find(filter => filter.condition === ConditionType.EMPTY);
        this.binaryFilterForm = this.formBuilder.group({
            emptyValues: [!!emptyFilter],
            conditions: this.formBuilder.array([])
        });
        initialFilterWithoutEmptyCondition.forEach(filter => {
            let newCondition = this.createConditionGroup(filter.logicalOperator, filter.condition);
            newCondition.addControl('value', this.addValueControl(filter.value ? filter.value : ''));
            this.conditions.push(newCondition);
        });
        if (initialFilterWithoutEmptyCondition.length === 0) {
            let newCondition = this.createConditionGroup();
            newCondition.addControl('value', this.addValueControl(''));
            this.conditions.push(newCondition);
        }
    }
    createConditionGroup(logicalOp = 'and', conditionType = ConditionType.EQUALS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    addValueControl(value) {
        return new FormControl(value, Validators.required);
    }
    hasEmptyCondition(conditions) {
        return conditions.some(condition => condition.value === ConditionType.EMPTY);
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.binaryFilterForm.valid) {
                this.appliedFilter = [...this.conditions.value];
                if (this.binaryFilterForm.get('emptyValues').value) {
                    this.appliedFilter.push({
                        logicalOperator: 'or',
                        condition: ConditionType.EMPTY
                    });
                }
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
        }
    }
}
DkBinaryFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkBinaryFilterComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkBinaryFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkBinaryFilterComponent, selector: "dk-binary-filter", inputs: { isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", selectionFilterInstance: "selectionFilterInstance", onDemandFilter: "onDemandFilter" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkBinaryFilterComponent }], ngImport: i0, template: "<form [formGroup]=\"binaryFilterForm\">\n\n  <ng-container *ngIf=\"!isFilterRow && displayEmptyValuesOption\">\n    <div class=\"dkg-binary-filter-include-empty\">\n      <mat-checkbox formControlName=\"emptyValues\" (change)=\"onIncludeEmptyValuesChange()\">Include empty values</mat-checkbox>\n    </div>\n  </ng-container>\n\n  <div formArrayName=\"conditions\" class=\"dkg-binary-filter-wrapper\">\n\n    <div class=\"dkg-binary-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n          <mat-radio-group class=\"dkg-binary-filter-element dkg-binary-filter-options\"\n            formControlName=\"value\"\n            (change)=\"onBinaryOptionChange()\">\n\n              <mat-radio-button\n                *ngFor=\"let option of options\" [value]=\"option.value\">\n                {{ option.label }}\n              </mat-radio-button>\n          </mat-radio-group>\n\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\">\n          <mat-label>Options</mat-label>\n          <mat-select formControlName=\"value\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onOptionChange($event)\">\n            <mat-option [value]=\"CLEAR_FILTER\">Clear</mat-option>\n            <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n              {{ option.label }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n\n</form>\n", styles: [".dkg-binary-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-binary-filter-include-empty{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-binary-filter-content{display:flex;flex-direction:column;justify-content:space-around}.dkg-binary-filter-options{display:flex;flex-direction:row;flex-wrap:wrap;justify-content:space-between;flex:auto;margin:7px 0}.dkg-binary-filter-options>mat-radio-button{margin:10px}\n"], components: [{ type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i1.FormArrayName, selector: "[formArrayName]", inputs: ["formArrayName"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkBinaryFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-binary-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkBinaryFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form [formGroup]=\"binaryFilterForm\">\n\n  <ng-container *ngIf=\"!isFilterRow && displayEmptyValuesOption\">\n    <div class=\"dkg-binary-filter-include-empty\">\n      <mat-checkbox formControlName=\"emptyValues\" (change)=\"onIncludeEmptyValuesChange()\">Include empty values</mat-checkbox>\n    </div>\n  </ng-container>\n\n  <div formArrayName=\"conditions\" class=\"dkg-binary-filter-wrapper\">\n\n    <div class=\"dkg-binary-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n          <mat-radio-group class=\"dkg-binary-filter-element dkg-binary-filter-options\"\n            formControlName=\"value\"\n            (change)=\"onBinaryOptionChange()\">\n\n              <mat-radio-button\n                *ngFor=\"let option of options\" [value]=\"option.value\">\n                {{ option.label }}\n              </mat-radio-button>\n          </mat-radio-group>\n\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\">\n          <mat-label>Options</mat-label>\n          <mat-select formControlName=\"value\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onOptionChange($event)\">\n            <mat-option [value]=\"CLEAR_FILTER\">Clear</mat-option>\n            <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n              {{ option.label }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n\n</form>\n", styles: [".dkg-binary-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-binary-filter-include-empty{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-binary-filter-content{display:flex;flex-direction:column;justify-content:space-around}.dkg-binary-filter-options{display:flex;flex-direction:row;flex-wrap:wrap;justify-content:space-between;flex:auto;margin:7px 0}.dkg-binary-filter-options>mat-radio-button{margin:10px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], selectionFilterInstance: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }] } });

class DkTextFilterComponent {
    constructor(dikeConfig, textFilterDebounceTime, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.textFilterDebounceTime = textFilterDebounceTime;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        if (this.textFilterDebounceTime === null || this.textFilterDebounceTime === undefined) {
            this.textFilterDebounceTime = this.dikeConfig.FILTER_DEBOUNCE_TIME;
        }
        this.contentAlign = 'start';
        this.onDemandFilter = false;
        this.isCaseSensitive = false;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this.filterChange = new EventEmitter();
        this.valueChangesSubscription = new Subscription();
        this.clearFilterChangesSubscription = new Subscription();
    }
    ngOnInit() {
        this.createForm(this.appliedFilter ? this.appliedFilter : [], this.isCaseSensitive);
        if (this.isFilterRow && !!this.clearRowFilterControl) {
            this.setClearFilterChangesSubscription();
        }
    }
    ngOnDestroy() {
        this.valueChangesSubscription.unsubscribe();
        this.clearFilterChangesSubscription.unsubscribe();
    }
    get conditions() {
        return this.textFilterForm.get('conditions');
    }
    get caseSensitive() {
        return this.textFilterForm.get('caseSensitive');
    }
    addCondition() {
        let newCondition = this.isFilterRow ?
            this.createConditionGroup('and', this.conditionTypes[0].value) : this.createConditionGroup();
        newCondition.addControl('value', this.addValueControl(''));
        this.conditions.push(newCondition);
        this.cdr.markForCheck();
    }
    removeCondition(indexGroup) {
        this.conditions.removeAt(indexGroup);
        this.emitValues(!this.onDemandFilter);
        this.cdr.markForCheck();
    }
    clear() {
        this.appliedFilter = [];
        this.isCaseSensitive = false;
        this.createForm(this.appliedFilter, this.isCaseSensitive);
        this.filterChange.emit({
            caseSensitive: this.isCaseSensitive,
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    onLogicalOperatorChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onConditionTypeChange(event, conditionGroup) {
        if (!(conditionGroup instanceof FormGroup)) {
            return;
        }
        if (event.value === ConditionType.EMPTY) {
            conditionGroup.removeControl('value');
        }
        else if (!conditionGroup.contains('value')) {
            conditionGroup.addControl('value', this.addValueControl(''));
        }
        this.emitValues(!this.onDemandFilter);
    }
    onCaseSensitiveChange() {
        this.emitValues(!this.onDemandFilter);
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    createForm(initialFilter, isCaseSensitive) {
        this.textFilterForm = this.formBuilder.group({
            caseSensitive: [isCaseSensitive],
            conditions: this.formBuilder.array([])
        });
        initialFilter.forEach(filter => {
            let newCondition = this.createConditionGroup(filter.logicalOperator, filter.condition);
            if (filter.condition !== ConditionType.EMPTY) {
                newCondition.addControl('value', this.addValueControl(filter.value ? filter.value : ''));
            }
            this.conditions.push(newCondition);
        });
        /**
         * Add the default condition, If the filter is not a row-filter.
         *
         * If the filter is a row-filter filter then add the condition
         * at position zero from conditionTypes. Remember that
         * row-filters do not have initial filters, therefore they
         * wil fall into this if condition.
         */
        if (initialFilter.length === 0) {
            this.addCondition();
        }
    }
    createConditionGroup(logicalOp = 'and', conditionType = ConditionType.CONTAINS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    addValueControl(value) {
        let inputValue = new FormControl(value, Validators.required);
        let subscription = inputValue.valueChanges.pipe(map(value => value), debounceTime(this.textFilterDebounceTime), distinctUntilChanged()).subscribe(() => {
            this.emitValues(!this.onDemandFilter);
            this.cdr.markForCheck();
        });
        this.valueChangesSubscription.add(subscription);
        return inputValue;
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.textFilterForm.valid) {
                this.appliedFilter = [...this.conditions.value];
                this.isCaseSensitive = this.caseSensitive.value;
                this.filterChange.emit({
                    caseSensitive: this.isCaseSensitive,
                    filter: this.appliedFilter
                });
            }
            else if (this.isFilterRow) {
                this.appliedFilter = [];
                this.filterChange.emit({
                    caseSensitive: this.isCaseSensitive,
                    filter: this.appliedFilter
                });
            }
        }
    }
    setClearFilterChangesSubscription() {
        this.clearFilterChangesSubscription.unsubscribe();
        // This subscription only applies to row filters:
        if (this.isFilterRow) {
            this.clearFilterChangesSubscription = this.clearRowFilterControl.subscribe(() => {
                /**
                 * Clearing input controls:
                 *
                 * It could have used the methods reset(...) or patchValue(...) from the
                 * AbstractControl class. These methods updates the value of the attached
                 * input control and then a fitlerChange emission event is sent. The latter
                 * will start a second filtering execution in DkFilteringDataSource class,
                 * because clearing filters sends the first filtering execution.
                 *
                 * To avoid sending a second filtering execution, the following path was executed:
                 */
                // 1. Dispose all the listeners. In this case only one listener is attached:
                this.valueChangesSubscription.unsubscribe();
                // 2. Creating a new Subscription will store the new listener:
                this.valueChangesSubscription = new Subscription();
                // 3. Remove the control that represents the row filter:
                this.conditions.controls.pop();
                // 4. Create a new FormControl asking for new memory:
                this.addCondition();
            });
        }
    }
}
DkTextFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkTextFilterComponent, deps: [{ token: CONFIG_GRID }, { token: TEXT_FILTER_DEBOUNCE_TIME, optional: true }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkTextFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkTextFilterComponent, selector: "dk-text-filter", inputs: { contentAlign: "contentAlign", isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", isCaseSensitive: "isCaseSensitive", conditionTypes: "conditionTypes", onDemandFilter: "onDemandFilter", clearRowFilterControl: "clearRowFilterControl" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkTextFilterComponent }], ngImport: i0, template: "<form [formGroup]=\"textFilterForm\">\n\n  <div *ngIf=\"!isFilterRow\"\n    class=\"dkg-text-filter-case-sensitive\">\n    <mat-checkbox formControlName=\"caseSensitive\" (change)=\"onCaseSensitiveChange()\">Case sensitive</mat-checkbox>\n  </div>\n\n  <div formArrayName=\"conditions\" class=\"dkg-text-filter-wrapper\">\n\n    <div class=\"dkg-text-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-text-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-text-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>Condition Value</mat-label>\n            <input matInput\n              type=\"text\"\n              formControlName=\"value\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <input matInput\n            type=\"text\"\n            formControlName=\"value\"\n            autocomplete=\"off\">\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n", styles: [".dkg-text-filter-case-sensitive{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-text-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-text-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-text-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-text-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"], components: [{ type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i1.FormArrayName, selector: "[formArrayName]", inputs: ["formArrayName"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i11.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkTextFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-text-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkTextFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form [formGroup]=\"textFilterForm\">\n\n  <div *ngIf=\"!isFilterRow\"\n    class=\"dkg-text-filter-case-sensitive\">\n    <mat-checkbox formControlName=\"caseSensitive\" (change)=\"onCaseSensitiveChange()\">Case sensitive</mat-checkbox>\n  </div>\n\n  <div formArrayName=\"conditions\" class=\"dkg-text-filter-wrapper\">\n\n    <div class=\"dkg-text-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-text-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-text-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>Condition Value</mat-label>\n            <input matInput\n              type=\"text\"\n              formControlName=\"value\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <input matInput\n            type=\"text\"\n            formControlName=\"value\"\n            autocomplete=\"off\">\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n", styles: [".dkg-text-filter-case-sensitive{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-text-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-text-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-text-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-text-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [TEXT_FILTER_DEBOUNCE_TIME]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { contentAlign: [{
                type: Input
            }], isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], isCaseSensitive: [{
                type: Input
            }], conditionTypes: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }], clearRowFilterControl: [{
                type: Input
            }] } });

class DkNumericFilterComponent {
    constructor(dikeConfig, numericFilterDebounceTime, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.numericFilterDebounceTime = numericFilterDebounceTime;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        if (this.numericFilterDebounceTime === null || this.numericFilterDebounceTime === undefined) {
            this.numericFilterDebounceTime = this.dikeConfig.FILTER_DEBOUNCE_TIME;
        }
        this.contentAlign = 'end';
        this.onDemandFilter = false;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this.filterChange = new EventEmitter();
        this.valueChangesSubscription = new Subscription();
        this.clearFilterChangesSubscription = new Subscription();
    }
    ngOnInit() {
        this.createForm(this.appliedFilter ? this.appliedFilter : []);
        if (this.isFilterRow && !!this.clearRowFilterControl) {
            this.setClearFilterChangesSubscription();
        }
    }
    ngOnDestroy() {
        this.valueChangesSubscription.unsubscribe();
        this.clearFilterChangesSubscription.unsubscribe();
    }
    get conditions() {
        return this.numericFilterForm.get('conditions');
    }
    addCondition() {
        let newCondition = this.isFilterRow ?
            this.createConditionGroup('and', this.conditionTypes[0].value) : this.createConditionGroup();
        this.setInitialFormState(newCondition, [{ name: 'value1', value: '' }], ['value2']);
        this.conditions.push(newCondition);
        this.cdr.markForCheck();
    }
    removeCondition(indexGroup) {
        this.conditions.removeAt(indexGroup);
        this.emitValues(!this.onDemandFilter);
        this.cdr.markForCheck();
    }
    clear() {
        this.appliedFilter = [];
        this.createForm(this.appliedFilter);
        this.filterChange.emit({
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    onLogicalOperatorChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onConditionTypeChange(event, conditionGroup) {
        if (!(conditionGroup instanceof FormGroup)) {
            return;
        }
        if (event.value === ConditionType.EMPTY) {
            this.setEmptyFormState(conditionGroup, ['value1', 'value2']);
        }
        else if (this.onSelectedValueContains(event.value, ConditionType.RANGE)) {
            this.setRangeFormState(conditionGroup, [
                { name: 'value1', value: '' },
                { name: 'value2', value: '' }
            ]);
        }
        else {
            this.setInitialFormState(conditionGroup, [{ name: 'value1', value: '' }], ['value2']);
        }
        this.emitValues(!this.onDemandFilter);
    }
    onSelectedValueContains(value, searchString) {
        return value.toLowerCase().includes(searchString.toLowerCase());
    }
    createForm(initialFilter) {
        this.numericFilterForm = this.formBuilder.group({
            conditions: this.formBuilder.array([])
        });
        initialFilter.forEach(filter => {
            let newCondition = this.createConditionGroup(filter.logicalOperator, filter.condition);
            if (this.onSelectedValueContains(filter.condition, ConditionType.RANGE)) {
                this.setRangeFormState(newCondition, [
                    { name: 'value1', value: filter.value1 ? filter.value1 : '' },
                    { name: 'value2', value: filter.value2 ? filter.value2 : '' }
                ]);
            }
            else if (filter.condition !== ConditionType.EMPTY) {
                this.setInitialFormState(newCondition, [
                    { name: 'value1', value: filter.value1 ? filter.value1 : '' }
                ], ['value2']);
            }
            this.conditions.push(newCondition);
        });
        /**
         * Add the default condition, If the filter is not a row-filter.
         *
         * If the filter is a row-filter filter then add the condition
         * at position zero from conditionTypes. Remember that
         * row-filters do not have initial filters, therefore they
         * wil fall into this if condition.
         */
        if (initialFilter.length === 0) {
            this.addCondition();
        }
    }
    createConditionGroup(logicalOp = 'and', conditionType = ConditionType.EQUALS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    addValueControl(value) {
        let inputValue = new FormControl(value, Validators.required);
        let subscription = inputValue.valueChanges.pipe(map(value => value), debounceTime(this.numericFilterDebounceTime), distinctUntilChanged()).subscribe(() => {
            this.emitValues(!this.onDemandFilter);
            this.cdr.markForCheck();
        });
        this.valueChangesSubscription.add(subscription);
        return inputValue;
    }
    setInitialFormState(conditionGroup, controlsToAdd, controlsToRemove) {
        controlsToAdd.forEach(control => {
            if (!conditionGroup.contains(control.name)) {
                conditionGroup.addControl(control.name, this.addValueControl(control.value));
            }
        });
        controlsToRemove.forEach(control => {
            if (conditionGroup.contains(control)) {
                conditionGroup.removeControl(control);
            }
        });
    }
    setRangeFormState(conditionGroup, valueControls) {
        valueControls.forEach(control => {
            if (!conditionGroup.contains(control.name)) {
                conditionGroup.addControl(control.name, this.addValueControl(control.value));
            }
        });
    }
    setEmptyFormState(conditionGroup, valueControls) {
        valueControls.forEach(control => {
            if (conditionGroup.contains(control)) {
                conditionGroup.removeControl(control);
            }
        });
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.numericFilterForm.valid) {
                this.appliedFilter = [...this.conditions.value];
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
            else if (this.isFilterRow) {
                this.appliedFilter = [];
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
        }
    }
    setClearFilterChangesSubscription() {
        this.clearFilterChangesSubscription.unsubscribe();
        // This subscription only applies to row filters:
        if (this.isFilterRow) {
            this.clearFilterChangesSubscription = this.clearRowFilterControl.subscribe(() => {
                /**
                 * Clearing input controls:
                 *
                 * It could have used the methods reset(...) or patchValue(...) from the
                 * AbstractControl class. These methods updates the value of the attached
                 * input control and then a fitlerChange emission event is sent. The latter
                 * will start a second filtering execution in DkFilteringDataSource class,
                 * because clearing filters sends the first filtering execution.
                 *
                 * To avoid sending a second filtering execution, the following path was executed:
                 */
                // 1. Dispose all the listeners. In this case only one listener is attached:
                this.valueChangesSubscription.unsubscribe();
                // 2. Creating a new Subscription will store the new listener:
                this.valueChangesSubscription = new Subscription();
                // 3. Remove the control that represents the row filter:
                this.conditions.controls.pop();
                // 4. Create a new FormControl asking new memory:
                this.addCondition();
            });
        }
    }
}
DkNumericFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkNumericFilterComponent, deps: [{ token: CONFIG_GRID }, { token: NUMERIC_FILTER_DEBOUNCE_TIME, optional: true }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkNumericFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkNumericFilterComponent, selector: "dk-numeric-filter", inputs: { contentAlign: "contentAlign", isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", conditionTypes: "conditionTypes", onDemandFilter: "onDemandFilter", clearRowFilterControl: "clearRowFilterControl" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkNumericFilterComponent }], ngImport: i0, template: "<form [formGroup]=\"numericFilterForm\">\n  <div formArrayName=\"conditions\" class=\"dkg-numeric-filter-wrapper\">\n\n    <div class=\"dkg-numeric-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-numeric-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-numeric-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'From Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput\n              type=\"number\"\n              formControlName=\"value1\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n        <ng-container *ngIf=\"matSel.selected && onSelectedValueContains(matSel.value, 'range')\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'To Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput\n              type=\"number\"\n              formControlName=\"value2\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <input matInput\n            type=\"number\"\n            formControlName=\"value1\"\n            autocomplete=\"off\">\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n", styles: [".dkg-numeric-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-numeric-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-numeric-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-numeric-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"], components: [{ type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1.FormArrayName, selector: "[formArrayName]", inputs: ["formArrayName"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i11.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkNumericFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-numeric-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkNumericFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form [formGroup]=\"numericFilterForm\">\n  <div formArrayName=\"conditions\" class=\"dkg-numeric-filter-wrapper\">\n\n    <div class=\"dkg-numeric-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-numeric-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-numeric-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'From Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput\n              type=\"number\"\n              formControlName=\"value1\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n        <ng-container *ngIf=\"matSel.selected && onSelectedValueContains(matSel.value, 'range')\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'To Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput\n              type=\"number\"\n              formControlName=\"value2\"\n              autocomplete=\"off\">\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <input matInput\n            type=\"number\"\n            formControlName=\"value1\"\n            autocomplete=\"off\">\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n", styles: [".dkg-numeric-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-numeric-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-numeric-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-numeric-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [NUMERIC_FILTER_DEBOUNCE_TIME]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { contentAlign: [{
                type: Input
            }], isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], conditionTypes: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }], clearRowFilterControl: [{
                type: Input
            }] } });

class DkDateFilterComponent {
    constructor(dikeConfig, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        this.contentAlign = 'start';
        this.onDemandFilter = false;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this.filterChange = new EventEmitter();
        this.valueChangesSubscription = new Subscription();
        this.clearFilterChangesSubscription = new Subscription();
    }
    ngOnInit() {
        this.createForm(this.appliedFilter ? this.appliedFilter : []);
        if (this.isFilterRow && !!this.clearRowFilterControl) {
            this.setClearFilterChangesSubscription();
        }
    }
    ngOnDestroy() {
        this.valueChangesSubscription.unsubscribe();
        this.clearFilterChangesSubscription.unsubscribe();
    }
    get conditions() {
        return this.dateFilterForm.get('conditions');
    }
    addCondition() {
        let newCondition = this.isFilterRow ?
            this.createConditionGroup('and', this.conditionTypes[0].value) : this.createConditionGroup();
        this.setInitialFormState(newCondition, [{ name: 'value1', value: '' }], ['value2']);
        this.conditions.push(newCondition);
        this.cdr.markForCheck();
    }
    removeCondition(indexGroup) {
        this.conditions.removeAt(indexGroup);
        this.emitValues(!this.onDemandFilter);
        this.cdr.markForCheck();
    }
    clear() {
        this.appliedFilter = [];
        this.createForm(this.appliedFilter);
        this.filterChange.emit({
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    onLogicalOperatorChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onConditionTypeChange(event, conditionGroup) {
        if (!(conditionGroup instanceof FormGroup)) {
            return;
        }
        if (event.value === ConditionType.EMPTY) {
            this.setEmptyFormState(conditionGroup, ['value1', 'value2']);
        }
        else if (this.onSelectedValueContains(event.value, ConditionType.RANGE)) {
            this.setRangeFormState(conditionGroup, [
                { name: 'value1', value: '' },
                { name: 'value2', value: '' }
            ]);
        }
        else {
            this.setInitialFormState(conditionGroup, [{ name: 'value1', value: '' }], ['value2']);
        }
        this.emitValues(!this.onDemandFilter);
    }
    onSelectedValueContains(value, searchString) {
        return value.toLowerCase().includes(searchString.toLowerCase());
    }
    createForm(initialFilter) {
        this.dateFilterForm = this.formBuilder.group({
            conditions: this.formBuilder.array([])
        });
        initialFilter.forEach(filter => {
            let newCondition = this.createConditionGroup(filter.logicalOperator, filter.condition);
            if (this.onSelectedValueContains(filter.condition, ConditionType.RANGE)) {
                this.setRangeFormState(newCondition, [
                    { name: 'value1', value: filter.value1 ? filter.value1 : '' },
                    { name: 'value2', value: filter.value2 ? filter.value2 : '' }
                ]);
            }
            else if (filter.condition !== ConditionType.EMPTY) {
                this.setInitialFormState(newCondition, [
                    { name: 'value1', value: filter.value1 ? filter.value1 : '' }
                ], ['value2']);
            }
            this.conditions.push(newCondition);
        });
        /**
         * Add the default condition, If the filter is not a row-filter.
         *
         * If the filter is a row-filter filter then add the condition
         * at position zero from conditionTypes. Remember that
         * row-filters do not have initial filters, therefore they
         * wil fall into this if condition.
         */
        if (initialFilter.length === 0) {
            this.addCondition();
        }
    }
    createConditionGroup(logicalOp = 'and', conditionType = ConditionType.EQUALS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    addValueControl(value) {
        let inputValue = new FormControl(value, Validators.required);
        let subscription = inputValue.valueChanges.pipe(map(value => value), debounceTime(0), distinctUntilChanged()).subscribe(() => {
            this.emitValues(!this.onDemandFilter);
            this.cdr.markForCheck();
        });
        this.valueChangesSubscription.add(subscription);
        return inputValue;
    }
    setInitialFormState(conditionGroup, controlsToAdd, controlsToRemove) {
        controlsToAdd.forEach(control => {
            if (!conditionGroup.contains(control.name)) {
                conditionGroup.addControl(control.name, this.addValueControl(control.value));
            }
        });
        controlsToRemove.forEach(control => {
            if (conditionGroup.contains(control)) {
                conditionGroup.removeControl(control);
            }
        });
    }
    setRangeFormState(conditionGroup, valueControls) {
        valueControls.forEach(control => {
            if (!conditionGroup.contains(control.name)) {
                conditionGroup.addControl(control.name, this.addValueControl(control.value));
            }
        });
    }
    setEmptyFormState(conditionGroup, valueControls) {
        valueControls.forEach(control => {
            if (conditionGroup.contains(control)) {
                conditionGroup.removeControl(control);
            }
        });
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.dateFilterForm.valid) {
                this.appliedFilter = [...this.conditions.value];
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
            else if (this.isFilterRow) {
                this.appliedFilter = [];
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
        }
    }
    setClearFilterChangesSubscription() {
        this.clearFilterChangesSubscription.unsubscribe();
        // This subscription only applies to row filters:
        if (this.isFilterRow) {
            this.clearFilterChangesSubscription = this.clearRowFilterControl.subscribe(() => {
                /**
                 * Clearing input controls:
                 *
                 * It could have used the methods reset(...) or patchValue(...) from the
                 * AbstractControl class. These methods updates the value of the attached
                 * input control and then a fitlerChange emission event is sent. The latter
                 * will start a second filtering execution in DkFilteringDataSource class,
                 * because clearing filters sends the first filtering execution.
                 *
                 * To avoid sending a second filtering execution, the following path was executed:
                 */
                // 1. Dispose all the listeners. In this case only one listener is attached:
                this.valueChangesSubscription.unsubscribe();
                // 2. Creating a new Subscription will store the new listener:
                this.valueChangesSubscription = new Subscription();
                // 3. Remove the control that represents the row filter:
                this.conditions.controls.pop();
                // 4. Create a new FormControl asking new memory:
                this.addCondition();
            });
        }
    }
}
DkDateFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDateFilterComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkDateFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkDateFilterComponent, selector: "dk-date-filter", inputs: { contentAlign: "contentAlign", isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", conditionTypes: "conditionTypes", onDemandFilter: "onDemandFilter", clearRowFilterControl: "clearRowFilterControl" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkDateFilterComponent }], ngImport: i0, template: "<form [formGroup]=\"dateFilterForm\">\n  <div formArrayName=\"conditions\" class=\"dkg-date-filter-wrapper\">\n\n    <div class=\"dkg-date-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-date-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-date-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'From Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput disabled-element\n              [matDatepicker]=\"dpValue1\"\n              type=\"text\"\n              formControlName=\"value1\"\n              autocomplete=\"off\">\n            <mat-datepicker-toggle matSuffix [for]=\"dpValue1\"></mat-datepicker-toggle>\n            <mat-datepicker #dpValue1></mat-datepicker>\n          </mat-form-field>\n        </ng-container>\n\n        <ng-container *ngIf=\"matSel.selected && onSelectedValueContains(matSel.value, 'range')\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'To Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput disabled-element\n              [matDatepicker]=\"dpValue2\"\n              type=\"text\"\n              formControlName=\"value2\"\n              autocomplete=\"off\">\n            <mat-datepicker-toggle matSuffix [for]=\"dpValue2\"></mat-datepicker-toggle>\n            <mat-datepicker #dpValue2></mat-datepicker>\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <button mat-icon-button matPrefix (click)=\"clear()\">\n            <mat-icon>clear</mat-icon>\n          </button>\n          <input matInput disabled-element\n            [matDatepicker]=\"dpValue3\"\n            type=\"text\"\n            formControlName=\"value1\"\n            autocomplete=\"off\">\n          <mat-datepicker-toggle matSuffix [for]=\"dpValue3\"></mat-datepicker-toggle>\n          <mat-datepicker #dpValue3></mat-datepicker>\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n\n", styles: [".dkg-date-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-date-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-date-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-date-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"], components: [{ type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i9.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { type: i9.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1.FormArrayName, selector: "[formArrayName]", inputs: ["formArrayName"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i11.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i9.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { type: DisabledElementDirective, selector: "[disabled-element]" }, { type: i6.MatSuffix, selector: "[matSuffix]" }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i6.MatPrefix, selector: "[matPrefix]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDateFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-date-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkDateFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form [formGroup]=\"dateFilterForm\">\n  <div formArrayName=\"conditions\" class=\"dkg-date-filter-wrapper\">\n\n    <div class=\"dkg-date-filter-content\"\n      *ngFor=\"let conditionGroup of conditions.controls; let i = index\" [formGroupName]=\"i\">\n\n      <ng-container *ngIf=\"i > 0\">\n        <div class=\"dkg-date-filter-logical-operator\">\n          <mat-radio-group class=\"dkg-date-filter-logical-operator-options\"\n            formControlName=\"logicalOperator\"\n            (change)=\"onLogicalOperatorChange()\">\n            <mat-radio-button value=\"and\">AND</mat-radio-button>\n            <mat-radio-button value=\"or\">OR</mat-radio-button>\n          </mat-radio-group>\n\n          <button mat-icon-button (click)=\"removeCondition(i)\">\n            <mat-icon color=\"accent\">delete</mat-icon>\n          </button>\n        </div>\n      </ng-container>\n\n      <ng-container *ngIf=\"!isFilterRow\">\n        <mat-form-field>\n          <mat-label>Condition Types</mat-label>\n          <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n            (selectionChange)=\"onConditionTypeChange($event, conditionGroup)\">\n            <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n              {{ cType.text }}\n            </mat-option>\n          </mat-select>\n        </mat-form-field>\n\n        <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'From Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput disabled-element\n              [matDatepicker]=\"dpValue1\"\n              type=\"text\"\n              formControlName=\"value1\"\n              autocomplete=\"off\">\n            <mat-datepicker-toggle matSuffix [for]=\"dpValue1\"></mat-datepicker-toggle>\n            <mat-datepicker #dpValue1></mat-datepicker>\n          </mat-form-field>\n        </ng-container>\n\n        <ng-container *ngIf=\"matSel.selected && onSelectedValueContains(matSel.value, 'range')\">\n          <mat-form-field>\n            <mat-label>{{ matSel.selected && onSelectedValueContains(matSel.value, 'range') ? 'To Condition Value' : 'Condition Value' }}</mat-label>\n            <input matInput disabled-element\n              [matDatepicker]=\"dpValue2\"\n              type=\"text\"\n              formControlName=\"value2\"\n              autocomplete=\"off\">\n            <mat-datepicker-toggle matSuffix [for]=\"dpValue2\"></mat-datepicker-toggle>\n            <mat-datepicker #dpValue2></mat-datepicker>\n          </mat-form-field>\n        </ng-container>\n\n      </ng-container>\n\n      <ng-container *ngIf=\"isFilterRow\">\n        <mat-form-field floatLabel=\"never\" [ngStyle]=\"{ 'text-align': contentAlign }\">\n          <button mat-icon-button matPrefix (click)=\"clear()\">\n            <mat-icon>clear</mat-icon>\n          </button>\n          <input matInput disabled-element\n            [matDatepicker]=\"dpValue3\"\n            type=\"text\"\n            formControlName=\"value1\"\n            autocomplete=\"off\">\n          <mat-datepicker-toggle matSuffix [for]=\"dpValue3\"></mat-datepicker-toggle>\n          <mat-datepicker #dpValue3></mat-datepicker>\n        </mat-form-field>\n      </ng-container>\n\n    </div>\n\n  </div>\n</form>\n\n", styles: [".dkg-date-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-date-filter-logical-operator{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-end;margin-bottom:13px}.dkg-date-filter-logical-operator-options{display:flex;flex-direction:row;justify-content:space-around;flex:auto;margin:7px 0}.dkg-date-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { contentAlign: [{
                type: Input
            }], isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], conditionTypes: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }], clearRowFilterControl: [{
                type: Input
            }] } });

class DkMultipleNumericFilterComponent {
    constructor(dikeConfig, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        this.onDemandFilter = false;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this.filterChange = new EventEmitter();
        this.EMPTY_VALUES = {
            label: 'Empty values',
            value: -Infinity
        };
        this.CLEAR_SELECTION = {
            label: 'Clear',
            value: Infinity
        };
    }
    ngOnInit() {
        this.conditionTypes = this.selectionFilterInstance.conditions.filter(condition => {
            return condition.value !== ConditionType.EMPTY;
        });
        this.options = this.getOptionsFromFilter(this.selectionFilterInstance.options, this.appliedFilter ? this.appliedFilter : []);
        this.addEmptyOption(this.appliedFilter ? this.appliedFilter : []);
        this.createForm(this.appliedFilter ? this.appliedFilter : []);
    }
    ngAfterViewInit() {
        setTimeout(() => {
            if (!this.isFilterRow) {
                this.isAllSelectedControlChecked = () => {
                    return this.selectionList.selectedOptions.hasValue() && this.isAllSelected();
                };
                this.isAllSelectedControlIndeterminate = () => {
                    return this.selectionList.selectedOptions.hasValue() && !this.isAllSelected();
                };
            }
        }, 0);
    }
    addCondition() {
    }
    clear() {
        this.appliedFilter = [];
        if (!this.isFilterRow) {
            this.selectionList.deselectAll();
        }
        this.createForm(this.appliedFilter);
        this.filterChange.emit({
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    onConditionTypeChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onSelectedOptionChange() {
        this.emitValues(!this.onDemandFilter);
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    onSelectAllOptionsChange() {
        this.toggleSet();
        this.emitValues(!this.onDemandFilter);
    }
    isAllSelectedControlChecked() {
        return false;
    }
    isAllSelectedControlIndeterminate() {
        return false;
    }
    isAllSelected() {
        return this.selectionList.selectedOptions.selected.length === this.options.length;
    }
    toggleSet() {
        this.isAllSelected() ?
            this.selectionList.selectedOptions.clear() : this.selectionList.selectAll();
    }
    onOptionChange(event) {
        const selectedOp = event.value;
        if (selectedOp.value === this.CLEAR_SELECTION.value) {
            this.clear();
        }
        else {
            this.emitValues(!this.onDemandFilter);
        }
    }
    createForm(initialFilter) {
        let initialFilterWithoutEmptyCondition = initialFilter.filter(filter => {
            return filter.condition !== ConditionType.EMPTY;
        });
        if (initialFilterWithoutEmptyCondition.length > 0) {
            this.multipleNumericFilterForm = this.createConditionGroup(initialFilterWithoutEmptyCondition[0].logicalOperator, initialFilterWithoutEmptyCondition[0].condition);
        }
        else {
            this.multipleNumericFilterForm = this.createConditionGroup();
        }
    }
    createConditionGroup(logicalOp = 'or', conditionType = ConditionType.EQUALS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    getOptionsFromFilter(options, initialFilter) {
        let newOptions = [];
        options.forEach(option => newOptions.push(Object.assign(Object.assign({}, option), { selected: initialFilter.some(filter => filter.value1 === option.value) })));
        return newOptions;
    }
    addEmptyOption(initialFilter) {
        let hasEmptyCondition = this.selectionFilterInstance.conditions.some(condition => condition.value === ConditionType.EMPTY);
        if (hasEmptyCondition) {
            this.options.unshift(Object.assign(Object.assign({}, this.EMPTY_VALUES), { selected: initialFilter.some(filter => filter.condition === ConditionType.EMPTY) }));
        }
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.multipleNumericFilterForm.valid) {
                this.appliedFilter = this.getFilterToApply();
                this.filterChange.emit({
                    filter: this.appliedFilter
                });
            }
        }
    }
    getFilterToApply() {
        let numericFilter = [];
        let selectedCondition = this.multipleNumericFilterForm.get('condition').value;
        let logicalOp = selectedCondition === ConditionType.EQUALS ? 'or' : 'and';
        if (!this.isFilterRow) {
            this.selectionList.selectedOptions.selected.forEach(selectedOp => {
                numericFilter.push(Object.assign({}, this.getNumericFilterElement(selectedOp.value, logicalOp, selectedCondition)));
            });
        }
        else {
            numericFilter.push(Object.assign({}, this.getNumericFilterElement(this.select.value, 'and', selectedCondition)));
        }
        return numericFilter;
    }
    getNumericFilterElement(selectedOption, logicalOp, selectedCondition) {
        let filter = {
            logicalOperator: logicalOp,
            condition: selectedCondition
        };
        if (selectedOption.value === this.EMPTY_VALUES.value) {
            filter.condition = selectedCondition === ConditionType.EQUALS ? ConditionType.EMPTY : ConditionType.NOT_EMPTY;
        }
        else {
            filter.value1 = selectedOption.value;
        }
        return filter;
    }
}
DkMultipleNumericFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkMultipleNumericFilterComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkMultipleNumericFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkMultipleNumericFilterComponent, selector: "dk-multiple-numeric-filter", inputs: { isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", selectionFilterInstance: "selectionFilterInstance", onDemandFilter: "onDemandFilter" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkMultipleNumericFilterComponent }], viewQueries: [{ propertyName: "selectionList", first: true, predicate: MatSelectionList, descendants: true }, { propertyName: "select", first: true, predicate: MatSelect, descendants: true }], ngImport: i0, template: "<form class=\"dkg-multiple-numeric-selection-filter-wrapper\"\n  [formGroup]=\"multipleNumericFilterForm\">\n\n  <div class=\"dkg-multiple-numeric-selection-filter-content\">\n\n    <ng-container *ngIf=\"!isFilterRow\">\n\n      <mat-form-field>\n        <mat-label>Condition Types</mat-label>\n        <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n          (selectionChange)=\"onConditionTypeChange()\">\n          <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n            {{ cType.text }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n        <div class=\"dkg-multiple-numeric-selection-all-options\">\n          <mat-checkbox\n            (change)=\"onSelectAllOptionsChange()\"\n            [checked]=\"isAllSelectedControlChecked()\"\n            [indeterminate]=\"isAllSelectedControlIndeterminate()\">Select all</mat-checkbox>\n        </div>\n\n        <mat-selection-list (selectionChange)=\"onSelectedOptionChange()\">\n          <mat-list-option *ngFor=\"let option of options\" [value]=\"option\" [selected]=\"option.selected\">\n            {{ option.label }}\n          </mat-list-option>\n        </mat-selection-list>\n\n      </ng-container>\n\n    </ng-container>\n\n    <ng-container *ngIf=\"isFilterRow\">\n      <mat-form-field floatLabel=\"never\">\n        <mat-label>Options</mat-label>\n        <mat-select [panelClass]=\"matSelectPanelClass\" (selectionChange)=\"onOptionChange($event)\">\n          <mat-option [value]=\"CLEAR_SELECTION\">Clear</mat-option>\n          <mat-option *ngFor=\"let option of options\" [value]=\"option\">\n            {{ option.label }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n    </ng-container>\n\n  </div>\n\n</form>\n", styles: [".dkg-multiple-numeric-selection-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-multiple-numeric-selection-all-options{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-multiple-numeric-selection-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"], components: [{ type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i7$1.MatSelectionList, selector: "mat-selection-list", inputs: ["disableRipple", "tabIndex", "color", "compareWith", "disabled", "multiple"], outputs: ["selectionChange"], exportAs: ["matSelectionList"] }, { type: i7$1.MatListOption, selector: "mat-list-option", inputs: ["disableRipple", "checkboxPosition", "color", "value", "disabled", "selected"], outputs: ["selectedChange"], exportAs: ["matListOption"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkMultipleNumericFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-multiple-numeric-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkMultipleNumericFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form class=\"dkg-multiple-numeric-selection-filter-wrapper\"\n  [formGroup]=\"multipleNumericFilterForm\">\n\n  <div class=\"dkg-multiple-numeric-selection-filter-content\">\n\n    <ng-container *ngIf=\"!isFilterRow\">\n\n      <mat-form-field>\n        <mat-label>Condition Types</mat-label>\n        <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n          (selectionChange)=\"onConditionTypeChange()\">\n          <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n            {{ cType.text }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n        <div class=\"dkg-multiple-numeric-selection-all-options\">\n          <mat-checkbox\n            (change)=\"onSelectAllOptionsChange()\"\n            [checked]=\"isAllSelectedControlChecked()\"\n            [indeterminate]=\"isAllSelectedControlIndeterminate()\">Select all</mat-checkbox>\n        </div>\n\n        <mat-selection-list (selectionChange)=\"onSelectedOptionChange()\">\n          <mat-list-option *ngFor=\"let option of options\" [value]=\"option\" [selected]=\"option.selected\">\n            {{ option.label }}\n          </mat-list-option>\n        </mat-selection-list>\n\n      </ng-container>\n\n    </ng-container>\n\n    <ng-container *ngIf=\"isFilterRow\">\n      <mat-form-field floatLabel=\"never\">\n        <mat-label>Options</mat-label>\n        <mat-select [panelClass]=\"matSelectPanelClass\" (selectionChange)=\"onOptionChange($event)\">\n          <mat-option [value]=\"CLEAR_SELECTION\">Clear</mat-option>\n          <mat-option *ngFor=\"let option of options\" [value]=\"option\">\n            {{ option.label }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n    </ng-container>\n\n  </div>\n\n</form>\n", styles: [".dkg-multiple-numeric-selection-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-multiple-numeric-selection-all-options{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-multiple-numeric-selection-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], selectionFilterInstance: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }], selectionList: [{
                type: ViewChild,
                args: [MatSelectionList]
            }], select: [{
                type: ViewChild,
                args: [MatSelect]
            }] } });

class DkMultipleTextFilterComponent {
    constructor(dikeConfig, cdr, formBuilder, gridConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.formBuilder = formBuilder;
        this.gridConfig = gridConfig;
        this.onDemandFilter = false;
        this.isCaseSensitive = true;
        this.isFilterRow = false;
        this.appliedFilter = null;
        this.filterChange = new EventEmitter();
        this.EMPTY_VALUES = {
            label: 'Empty values',
            value: 'emptyValues'
        };
        this.CLEAR_SELECTION = {
            label: 'Clear',
            value: 'clearFilter'
        };
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
    }
    ngOnInit() {
        this.conditionTypes = this.selectionFilterInstance.conditions.filter(condition => {
            return condition.value !== ConditionType.EMPTY;
        });
        this.options = this.getOptionsFromFilter(this.selectionFilterInstance.options, this.appliedFilter ? this.appliedFilter : []);
        this.addEmptyOption(this.appliedFilter ? this.appliedFilter : []);
        this.createForm(this.appliedFilter ? this.appliedFilter : []);
    }
    ngAfterViewInit() {
        setTimeout(() => {
            if (!this.isFilterRow) {
                this.isAllSelectedControlChecked = () => {
                    return this.selectionList.selectedOptions.hasValue() && this.isAllSelected();
                };
                this.isAllSelectedControlIndeterminate = () => {
                    return this.selectionList.selectedOptions.hasValue() && !this.isAllSelected();
                };
            }
        }, 0);
    }
    addCondition() {
    }
    clear() {
        this.appliedFilter = [];
        if (!this.isFilterRow) {
            this.selectionList.deselectAll();
        }
        this.createForm(this.appliedFilter);
        this.filterChange.emit({
            caseSensitive: this.isCaseSensitive,
            filter: this.appliedFilter
        });
        this.cdr.markForCheck();
    }
    applyFilter() {
        this.emitValues(this.onDemandFilter);
    }
    onConditionTypeChange() {
        this.emitValues(!this.onDemandFilter);
    }
    onSelectedOptionChange() {
        this.emitValues(!this.onDemandFilter);
    }
    isFilterApplied() {
        return this.appliedFilter && this.appliedFilter.length > 0;
    }
    onSelectAllOptionsChange() {
        this.toggleSet();
        this.emitValues(!this.onDemandFilter);
    }
    isAllSelectedControlChecked() {
        return false;
    }
    isAllSelectedControlIndeterminate() {
        return false;
    }
    isAllSelected() {
        return this.selectionList.selectedOptions.selected.length === this.options.length;
    }
    toggleSet() {
        this.isAllSelected() ?
            this.selectionList.selectedOptions.clear() : this.selectionList.selectAll();
    }
    onOptionChange(event) {
        const selectedOp = event.value;
        if (selectedOp.value === this.CLEAR_SELECTION.value) {
            this.clear();
        }
        else {
            this.emitValues(!this.onDemandFilter);
        }
    }
    createForm(initialFilter) {
        let initialFilterWithoutEmptyCondition = initialFilter.filter(filter => {
            return filter.condition !== ConditionType.EMPTY;
        });
        if (initialFilterWithoutEmptyCondition.length > 0) {
            this.multipleTextFilterForm = this.createConditionGroup(initialFilterWithoutEmptyCondition[0].logicalOperator, initialFilterWithoutEmptyCondition[0].condition);
        }
        else {
            this.multipleTextFilterForm = this.createConditionGroup();
        }
    }
    createConditionGroup(logicalOp = 'or', conditionType = ConditionType.EQUALS) {
        return this.formBuilder.group({
            logicalOperator: [logicalOp],
            condition: [conditionType, Validators.required]
        });
    }
    getOptionsFromFilter(options, initialFilter) {
        let newOptions = [];
        options.forEach(option => newOptions.push(Object.assign(Object.assign({}, option), { selected: initialFilter.some(filter => filter.value === option.value) })));
        return newOptions;
    }
    addEmptyOption(initialFilter) {
        let hasEmptyCondition = this.selectionFilterInstance.conditions.some(condition => condition.value === ConditionType.EMPTY);
        if (hasEmptyCondition) {
            this.options.unshift(Object.assign(Object.assign({}, this.EMPTY_VALUES), { selected: initialFilter.some(filter => filter.condition === ConditionType.EMPTY) }));
        }
    }
    emitValues(emit) {
        if (this.isFilterRow || emit) {
            if (this.multipleTextFilterForm.valid) {
                this.appliedFilter = this.getFilterToApply();
                this.filterChange.emit({
                    caseSensitive: this.isCaseSensitive,
                    filter: this.appliedFilter
                });
            }
        }
    }
    getFilterToApply() {
        let textFilter = [];
        let selectedCondition = this.multipleTextFilterForm.get('condition').value;
        let logicalOp = selectedCondition === ConditionType.EQUALS ? 'or' : 'and';
        if (!this.isFilterRow) {
            this.selectionList.selectedOptions.selected.forEach(selectedOp => {
                textFilter.push(Object.assign({}, this.getNumericFilterElement(selectedOp.value, logicalOp, selectedCondition)));
            });
        }
        else {
            textFilter.push(Object.assign({}, this.getNumericFilterElement(this.select.value, 'and', selectedCondition)));
        }
        return textFilter;
    }
    getNumericFilterElement(selectedOption, logicalOp, selectedCondition) {
        let filter = {
            logicalOperator: logicalOp,
            condition: selectedCondition
        };
        if (selectedOption.value === this.EMPTY_VALUES.value) {
            filter.condition = selectedCondition === ConditionType.EQUALS ? ConditionType.EMPTY : ConditionType.NOT_EMPTY;
        }
        else {
            filter.value = selectedOption.value;
        }
        return filter;
    }
}
DkMultipleTextFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkMultipleTextFilterComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i1.FormBuilder }, { token: DkGridConfig }], target: i0.ɵɵFactoryTarget.Component });
DkMultipleTextFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkMultipleTextFilterComponent, selector: "dk-multiple-text-filter", inputs: { isFilterRow: "isFilterRow", appliedFilter: "appliedFilter", selectionFilterInstance: "selectionFilterInstance", onDemandFilter: "onDemandFilter" }, providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkMultipleTextFilterComponent }], viewQueries: [{ propertyName: "selectionList", first: true, predicate: MatSelectionList, descendants: true }, { propertyName: "select", first: true, predicate: MatSelect, descendants: true }], ngImport: i0, template: "<form class=\"dkg-multiple-text-selection-filter-wrapper\"\n  [formGroup]=\"multipleTextFilterForm\">\n\n  <div class=\"dkg-multiple-text-selection-filter-content\">\n\n    <ng-container *ngIf=\"!isFilterRow\">\n\n      <mat-form-field>\n        <mat-label>Condition Types</mat-label>\n        <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n          (selectionChange)=\"onConditionTypeChange()\">\n          <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n            {{ cType.text }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n        <div class=\"dkg-multiple-text-selection-all-options\">\n          <mat-checkbox\n            (change)=\"onSelectAllOptionsChange()\"\n            [checked]=\"isAllSelectedControlChecked()\"\n            [indeterminate]=\"isAllSelectedControlIndeterminate()\">Select all</mat-checkbox>\n        </div>\n\n        <mat-selection-list (selectionChange)=\"onSelectedOptionChange()\">\n          <mat-list-option *ngFor=\"let option of options\" [value]=\"option\" [selected]=\"option.selected\">\n            {{ option.label }}\n          </mat-list-option>\n        </mat-selection-list>\n\n      </ng-container>\n\n    </ng-container>\n\n    <ng-container *ngIf=\"isFilterRow\">\n      <mat-form-field floatLabel=\"never\">\n        <mat-label>Options</mat-label>\n        <mat-select [panelClass]=\"matSelectPanelClass\" (selectionChange)=\"onOptionChange($event)\">\n          <mat-option [value]=\"CLEAR_SELECTION\">Clear</mat-option>\n          <mat-option *ngFor=\"let option of options\" [value]=\"option\">\n            {{ option.label }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n    </ng-container>\n\n  </div>\n\n</form>\n\n", styles: [".dkg-multiple-text-selection-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-multiple-text-selection-all-options{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-multiple-text-selection-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"], components: [{ type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i7$1.MatSelectionList, selector: "mat-selection-list", inputs: ["disableRipple", "tabIndex", "color", "compareWith", "disabled", "multiple"], outputs: ["selectionChange"], exportAs: ["matSelectionList"] }, { type: i7$1.MatListOption, selector: "mat-list-option", inputs: ["disableRipple", "checkboxPosition", "color", "value", "disabled", "selected"], outputs: ["selectedChange"], exportAs: ["matListOption"] }], directives: [{ type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i6.MatLabel, selector: "mat-label" }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkMultipleTextFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-multiple-text-filter', providers: [{ provide: DK_FILTER_BEHAVIOUR, useExisting: DkMultipleTextFilterComponent }], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<form class=\"dkg-multiple-text-selection-filter-wrapper\"\n  [formGroup]=\"multipleTextFilterForm\">\n\n  <div class=\"dkg-multiple-text-selection-filter-content\">\n\n    <ng-container *ngIf=\"!isFilterRow\">\n\n      <mat-form-field>\n        <mat-label>Condition Types</mat-label>\n        <mat-select #matSel=\"matSelect\" formControlName=\"condition\" [panelClass]=\"matSelectPanelClass\"\n          (selectionChange)=\"onConditionTypeChange()\">\n          <mat-option *ngFor=\"let cType of conditionTypes\" [value]=\"cType.value\">\n            {{ cType.text }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n\n      <ng-container *ngIf=\"matSel.selected && matSel.value !== 'empty'\">\n\n        <div class=\"dkg-multiple-text-selection-all-options\">\n          <mat-checkbox\n            (change)=\"onSelectAllOptionsChange()\"\n            [checked]=\"isAllSelectedControlChecked()\"\n            [indeterminate]=\"isAllSelectedControlIndeterminate()\">Select all</mat-checkbox>\n        </div>\n\n        <mat-selection-list (selectionChange)=\"onSelectedOptionChange()\">\n          <mat-list-option *ngFor=\"let option of options\" [value]=\"option\" [selected]=\"option.selected\">\n            {{ option.label }}\n          </mat-list-option>\n        </mat-selection-list>\n\n      </ng-container>\n\n    </ng-container>\n\n    <ng-container *ngIf=\"isFilterRow\">\n      <mat-form-field floatLabel=\"never\">\n        <mat-label>Options</mat-label>\n        <mat-select [panelClass]=\"matSelectPanelClass\" (selectionChange)=\"onOptionChange($event)\">\n          <mat-option [value]=\"CLEAR_SELECTION\">Clear</mat-option>\n          <mat-option *ngFor=\"let option of options\" [value]=\"option\">\n            {{ option.label }}\n          </mat-option>\n        </mat-select>\n      </mat-form-field>\n    </ng-container>\n\n  </div>\n\n</form>\n\n", styles: [".dkg-multiple-text-selection-filter-wrapper{height:100%;width:100%;box-sizing:border-box;display:flex;flex-direction:column;justify-content:flex-start}.dkg-multiple-text-selection-all-options{box-sizing:border-box;display:flex;flex-direction:row;justify-content:space-around;margin:10px 0 13px}.dkg-multiple-text-selection-filter-content{display:flex;flex-direction:column;justify-content:space-around}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i1.FormBuilder }, { type: DkGridConfig }];
    }, propDecorators: { isFilterRow: [{
                type: Input
            }], appliedFilter: [{
                type: Input
            }], selectionFilterInstance: [{
                type: Input
            }], onDemandFilter: [{
                type: Input
            }], selectionList: [{
                type: ViewChild,
                args: [MatSelectionList]
            }], select: [{
                type: ViewChild,
                args: [MatSelect]
            }] } });

class DkColumnFilterComponent {
    constructor(filterFactory, gridFilterConfig) {
        this.filterFactory = filterFactory;
        this.gridFilterConfig = gridFilterConfig;
        this.isFilterRow = false;
        this.caseSensitive = false;
        this.dateConditions = null;
        this.numericConditions = null;
        this.textConditions = null;
        this.selectionFilterInstance = null;
        this.binarySelectionFilterInstance = null;
        this.numericSelectionFilterInstance = null;
        this.textSelectionFilterCondition = null;
        this.filterType = '';
    }
    ngOnInit() {
        this.onDemandFilter$ = this.gridFilterConfig.onDemandFilterChanged$;
        this.clearGridFilter$ = merge(this.gridFilterConfig.clearFilterEmitter.asObservable(), this.gridFilterConfig.clearEditionFilterEmitter.asObservable());
        /**
         * Regarding to filtering, the user could be in data context or edition context.
         * Depending on the context the user is, get the corresponding filterable:
         */
        let filterable = this.gridFilterConfig.filterables.get(this.columnId);
        if (filterable) {
            this.caseSensitive = filterable.dataType === 'Text' && filterable.caseSensitive;
            this.initialFilter = filterable.filter ? [...filterable.filter] : [];
            let filterInstance = this.filterFactory.getFilterConditionInstance(filterable);
            if (this.filterFactory.isCustomSelectionFilterCondition(filterInstance)) {
                this.filterType = `Multiple-${filterable.dataType}`;
                this.selectionFilterInstance = filterInstance;
                if (this.filterFactory.isCustomBinaryFilterCondition(filterInstance)) {
                    this.binarySelectionFilterInstance = filterInstance;
                }
                else if (this.filterFactory.isCustomNumericFilterCondition(filterInstance)) {
                    this.numericSelectionFilterInstance = filterInstance;
                }
                else if (this.filterFactory.isCustomTextFilterCondition(filterInstance)) {
                    this.textSelectionFilterCondition = filterInstance;
                }
            }
            else {
                this.filterType = `${filterable.dataType}`;
                if (this.filterFactory.isCustomDateFilterCondition(filterInstance)) {
                    this.dateConditions = filterInstance.conditions;
                }
                else if (this.filterFactory.isCustomNumericFilterCondition(filterInstance)) {
                    this.numericConditions = filterInstance.conditions;
                }
                else if (this.filterFactory.isCustomTextFilterCondition(filterInstance)) {
                    this.textConditions = filterInstance.conditions;
                }
            }
        }
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.dikeFilter.filterChange.subscribe((value) => {
                let filterable = this.gridFilterConfig.filterables.get(this.columnId);
                if (filterable) {
                    let returnedfilter;
                    switch (filterable.dataType) {
                        case 'Text':
                            filterable.caseSensitive = value.caseSensitive;
                            returnedfilter = value.filter;
                            break;
                        default:
                            returnedfilter = value.filter;
                    }
                    this.gridFilterConfig.applyFilter(Object.assign(Object.assign({}, filterable), { filter: [...returnedfilter] }));
                }
            });
        }, 0);
    }
    addFilterCondition() {
        this.dikeFilter.addCondition();
    }
    clearFilter() {
        this.dikeFilter.clear();
    }
    applyFilter() {
        this.dikeFilter.applyFilter();
    }
    canAddFilterCondition() {
        return !(this.selectionFilterInstance !== null && this.selectionFilterInstance !== undefined);
    }
    isFilterApplied() {
        return this.dikeFilter.isFilterApplied();
    }
}
DkColumnFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnFilterComponent, deps: [{ token: DkFilterFactory }, { token: DkGridFilterConfig }], target: i0.ɵɵFactoryTarget.Component });
DkColumnFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkColumnFilterComponent, selector: "dk-column-filter", inputs: { columnId: "columnId", isFilterRow: "isFilterRow", contentAlign: "contentAlign" }, viewQueries: [{ propertyName: "dikeFilter", first: true, predicate: DK_FILTER_BEHAVIOUR, descendants: true }], exportAs: ["dkgColumnFilter"], ngImport: i0, template: "<div class=\"dkg-filter-main-wrapper\"\n  [class.dkg-row-filter]=\"isFilterRow\">\n\n  <ng-container [ngSwitch]=\"filterType\">\n    <dk-text-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [isCaseSensitive]=\"caseSensitive\"\n      [conditionTypes]=\"textConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Text'\">\n    </dk-text-filter>\n\n    <dk-numeric-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [conditionTypes]=\"numericConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Numeric'\">\n    </dk-numeric-filter>\n\n    <dk-date-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [conditionTypes]=\"dateConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Date'\">\n    </dk-date-filter>\n\n    <dk-binary-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"binarySelectionFilterInstance\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Binary'\">\n    </dk-binary-filter>\n\n    <dk-multiple-numeric-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"numericSelectionFilterInstance\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Numeric'\">\n    </dk-multiple-numeric-filter>\n\n    <dk-multiple-text-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"textSelectionFilterCondition\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Text'\">\n    </dk-multiple-text-filter>\n  </ng-container>\n</div>\n", styles: [".dkg-filter-main-wrapper{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-row-filter{padding:0}\n"], components: [{ type: DkTextFilterComponent, selector: "dk-text-filter", inputs: ["contentAlign", "isFilterRow", "appliedFilter", "isCaseSensitive", "conditionTypes", "onDemandFilter", "clearRowFilterControl"] }, { type: DkNumericFilterComponent, selector: "dk-numeric-filter", inputs: ["contentAlign", "isFilterRow", "appliedFilter", "conditionTypes", "onDemandFilter", "clearRowFilterControl"] }, { type: DkDateFilterComponent, selector: "dk-date-filter", inputs: ["contentAlign", "isFilterRow", "appliedFilter", "conditionTypes", "onDemandFilter", "clearRowFilterControl"] }, { type: DkBinaryFilterComponent, selector: "dk-binary-filter", inputs: ["isFilterRow", "appliedFilter", "selectionFilterInstance", "onDemandFilter"] }, { type: DkMultipleNumericFilterComponent, selector: "dk-multiple-numeric-filter", inputs: ["isFilterRow", "appliedFilter", "selectionFilterInstance", "onDemandFilter"] }, { type: DkMultipleTextFilterComponent, selector: "dk-multiple-text-filter", inputs: ["isFilterRow", "appliedFilter", "selectionFilterInstance", "onDemandFilter"] }], directives: [{ type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-column-filter', exportAs: 'dkgColumnFilter', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-filter-main-wrapper\"\n  [class.dkg-row-filter]=\"isFilterRow\">\n\n  <ng-container [ngSwitch]=\"filterType\">\n    <dk-text-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [isCaseSensitive]=\"caseSensitive\"\n      [conditionTypes]=\"textConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Text'\">\n    </dk-text-filter>\n\n    <dk-numeric-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [conditionTypes]=\"numericConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Numeric'\">\n    </dk-numeric-filter>\n\n    <dk-date-filter\n      [contentAlign]=\"contentAlign\"\n      [appliedFilter]=\"initialFilter\"\n      [conditionTypes]=\"dateConditions\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      [clearRowFilterControl]=\"clearGridFilter$\"\n      *ngSwitchCase=\"'Date'\">\n    </dk-date-filter>\n\n    <dk-binary-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"binarySelectionFilterInstance\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Binary'\">\n    </dk-binary-filter>\n\n    <dk-multiple-numeric-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"numericSelectionFilterInstance\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Numeric'\">\n    </dk-multiple-numeric-filter>\n\n    <dk-multiple-text-filter\n      [appliedFilter]=\"initialFilter\"\n      [selectionFilterInstance]=\"textSelectionFilterCondition\"\n      [onDemandFilter]=\"onDemandFilter$ | async\"\n      [isFilterRow]=\"isFilterRow\"\n      *ngSwitchCase=\"'Multiple-Text'\">\n    </dk-multiple-text-filter>\n  </ng-container>\n</div>\n", styles: [".dkg-filter-main-wrapper{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-row-filter{padding:0}\n"] }]
        }], ctorParameters: function () { return [{ type: DkFilterFactory }, { type: DkGridFilterConfig }]; }, propDecorators: { columnId: [{
                type: Input
            }], isFilterRow: [{
                type: Input
            }], contentAlign: [{
                type: Input
            }], dikeFilter: [{
                type: ViewChild,
                args: [DK_FILTER_BEHAVIOUR]
            }] } });

class DkGridContentMesh {
    constructor() {
        this.rhHeader = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.rhFilter = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.rhContent = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.totalHeaderRows = 0;
        this.viewPortContentHeight = 0;
        this.horizontalContentScrollHeight = 0;
        this.allowRowFiltering = false;
    }
    get headerRowHeight() {
        return this.rhHeader;
    }
    set headerRowHeight(rowHeader) {
        this.rhHeader.contentHeight = rowHeader.contentHeight > 0 ? rowHeader.contentHeight : 0;
        this.rhHeader.horizontalGutterHeight = rowHeader.horizontalGutterHeight > 0 ? rowHeader.horizontalGutterHeight : 0;
        this.rhHeader.rowHeight = this.rhHeader.contentHeight + this.rhHeader.horizontalGutterHeight;
    }
    get headerRows() {
        return this.totalHeaderRows;
    }
    set headerRows(value) {
        this.totalHeaderRows = value;
    }
    get rowFiltering() {
        return this.allowRowFiltering;
    }
    set rowFiltering(value) {
        this.allowRowFiltering = value;
    }
    get filterRowHeight() {
        return this.rhFilter;
    }
    set filterRowHeight(rowFilter) {
        this.rhFilter.contentHeight = rowFilter.contentHeight > 0 ? rowFilter.contentHeight : 0;
        this.rhFilter.horizontalGutterHeight = rowFilter.horizontalGutterHeight > 0 ? rowFilter.horizontalGutterHeight : 0;
        this.rhFilter.rowHeight = this.rhFilter.contentHeight + this.rhFilter.horizontalGutterHeight;
    }
    get contentRowHeight() {
        return this.rhContent;
    }
    set contentRowHeight(rowContent) {
        this.rhContent.contentHeight = rowContent.contentHeight > 0 ? rowContent.contentHeight : 0;
        this.rhContent.horizontalGutterHeight = rowContent.horizontalGutterHeight > 0 ? rowContent.horizontalGutterHeight : 0;
        this.rhContent.rowHeight = this.rhContent.contentHeight + this.rhContent.horizontalGutterHeight;
    }
    get contentViewPortHeight() {
        return this.viewPortContentHeight;
    }
    set contentViewPortHeight(value) {
        this.viewPortContentHeight = value > 0 ? value : 0;
    }
    get horizontalScrollHeight() {
        return this.horizontalContentScrollHeight;
    }
    set horizontalScrollHeight(height) {
        this.horizontalContentScrollHeight = height > 0 ? height : 0;
    }
    getGridContentMeshTemplateRows() {
        let headerRow = '';
        let filterRow = this.allowRowFiltering && this.rhFilter.rowHeight > 0 ? `${this.rhFilter.rowHeight}px` : '';
        let contentRow = '';
        let contentHorizontalScrolling = '';
        if (this.rhHeader.rowHeight > 0 && this.totalHeaderRows > 0) {
            headerRow = `${this.rhHeader.rowHeight * this.totalHeaderRows}px`;
        }
        if (this.rhContent.rowHeight > 0) {
            contentRow = '1fr';
            contentHorizontalScrolling = this.horizontalContentScrollHeight > 0 ? `${this.horizontalContentScrollHeight}px` : '';
        }
        return `${headerRow} ${filterRow} ${contentRow} ${contentHorizontalScrolling}`.trim();
    }
    getGridContentMeshTemplateColumns() {
        return '1fr';
    }
}

class DoubleLinkedList {
    constructor() {
        this.isEmpty = () => this.headNode === null;
        this.treeLevel = 0;
        this.listHeight = 0;
        this.maxHeight = 0;
        this.headNode = null;
        this.tailNode = null;
        this.parentNode = null;
    }
    get first() {
        return this.headNode;
    }
    get last() {
        return this.tailNode;
    }
    get level() {
        return this.treeLevel;
    }
    set level(value) {
        this.treeLevel = value;
    }
    get height() {
        return this.listHeight;
    }
    set height(value) {
        this.listHeight = value;
    }
    get greatestHeight() {
        return this.maxHeight;
    }
    set greatestHeight(value) {
        this.maxHeight = value;
    }
    get parent() {
        return this.parentNode;
    }
    set parent(value) {
        this.parentNode = value;
    }
    toArray() {
        const elements = [];
        let current = this.headNode;
        while (current) {
            elements.push(current.value);
            current = current.next;
        }
        return elements;
    }
    getAllLeavesArray() {
        const elements = [];
        let current = this.headNode;
        while (current) {
            if (current.children) {
                elements.push(...current.children.getAllLeavesArray());
            }
            else {
                elements.push(current.value);
            }
            current = current.next;
        }
        return elements;
    }
    append(value, children) {
        const newNode = this.createNode(value, children);
        if (this.isEmpty()) {
            this.headNode = newNode;
            this.tailNode = newNode;
        }
        else {
            this.tailNode.next = newNode;
            newNode.prev = this.tailNode;
            this.tailNode = newNode;
        }
        return newNode;
    }
    prepend(value, children) {
        const newNode = this.createNode(value, children);
        if (this.isEmpty()) {
            this.headNode = newNode;
            this.tailNode = newNode;
        }
        else {
            newNode.next = this.headNode;
            this.headNode.prev = newNode;
            this.headNode = newNode;
        }
        return newNode;
    }
    removeNode(node) {
        if (this.isEmpty()) {
            return null;
        }
        if (node === this.headNode && node === this.tailNode) {
            this.headNode = null;
            this.tailNode = null;
        }
        else if (node === this.headNode) {
            this.headNode.next.prev = null;
            this.headNode = node.next;
            node.next = null;
        }
        else if (node === this.tailNode) {
            this.tailNode = node.prev;
            this.tailNode.next = null;
            node.prev = null;
        }
        else {
            node.prev.next = node.next;
            node.next.prev = node.prev;
            node.prev = null;
            node.next = null;
        }
        return node;
    }
    insertNodeBefore(node, before) {
        if (before === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeBefore method: before node can not be null.`);
        }
        else if (node === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeBefore method: The node which will be inserted can not be null.`);
        }
        if (before === this.headNode) {
            this.prepend(node.value, node.children);
        }
        else {
            node.next = before;
            node.prev = before.prev;
            before.prev.next = node;
            before.prev = node;
        }
    }
    insertNodeAfter(node, after) {
        if (after === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeAfter method: after node can not be null.`);
        }
        else if (node === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeAfter method: The node which will be inserted can not be null.`);
        }
        if (after === this.tailNode) {
            this.append(node.value, node.children);
        }
        else {
            node.next = after.next;
            node.prev = after;
            after.next.prev = node;
            after.next = node;
        }
    }
    insertNodeAt(newNode, nodeAt) {
        if (nodeAt === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeAt method: nodeAt node can not be null.`);
        }
        else if (newNode === null) {
            throw new Error(`DoubleLinkedList<T>.insertNodeAt method: The new node which will be inserted can not be null.`);
        }
        if (nodeAt === this.headNode && nodeAt === this.tailNode) {
            this.headNode = newNode;
            this.tailNode = newNode;
        }
        else if (nodeAt === this.headNode) {
            newNode.next = nodeAt.next;
            nodeAt.next.prev = newNode;
            this.headNode = newNode;
            nodeAt.next = null;
        }
        else if (nodeAt === this.tailNode) {
            newNode.prev = nodeAt.prev;
            nodeAt.prev.next = newNode;
            this.tailNode = newNode;
            nodeAt.prev = null;
        }
        else {
            newNode.next = nodeAt.next;
            nodeAt.next.prev = newNode;
            newNode.prev = nodeAt.prev;
            nodeAt.prev.next = newNode;
            nodeAt.next = null;
            nodeAt.prev = null;
        }
        return nodeAt;
    }
    swapNodes(source, destination) {
        if (source === null) {
            throw new Error(`DoubleLinkedList<T>.swapNodes method: source node can not be null.`);
        }
        else if (destination === null) {
            throw new Error(`DoubleLinkedList<T>.swapNodes method: destination node can not be null.`);
        }
        if (this.isEmpty() || this.headNode === this.tailNode || source === destination) {
            return false;
        }
        let contiguousNodes = this.areNodesContiguous(source, destination);
        /**
         * Make source be at the left:
         *
         * 1. Is the destination node the Head of the list?
         * 2. If nodes are contiguois and the destination is at the left side.
         */
        if (destination.prev === null || contiguousNodes.leftDestination) {
            let tmpNode = source;
            source = destination;
            destination = tmpNode;
        }
        let isolatedSource = null;
        // Contiguous?
        if (contiguousNodes.contiguous) {
            isolatedSource = this.removeNode(source);
            this.insertNodeAfter(isolatedSource, destination);
        }
        else {
            let prevDestination = destination.prev;
            let isolatedDestination = this.removeNode(destination);
            this.insertNodeAfter(isolatedDestination, source);
            isolatedSource = this.removeNode(source);
            this.insertNodeAfter(isolatedSource, prevDestination);
        }
        return true;
    }
    *items() {
        let current = this.headNode;
        while (current) {
            yield current;
            current = current.next;
        }
    }
    find(compare) {
        if (this.isEmpty()) {
            return null;
        }
        let current = this.headNode;
        while (current) {
            if (compare(current.value)) {
                return current;
            }
            current = current.next;
        }
        return null;
    }
    findInTree(compare) {
        if (this.isEmpty()) {
            return null;
        }
        let current = this.headNode;
        while (current) {
            if (compare(current.value)) {
                return current;
            }
            if (current.children) {
                let foundNode = current.children.findInTree(compare);
                if (foundNode) {
                    return foundNode;
                }
            }
            current = current.next;
        }
        return null;
    }
    printList(out) {
        let current = this.headNode;
        while (current) {
            out(current.value);
            if (current.children) {
                current.children.printList(out);
            }
            current = current.next;
        }
    }
    createNode(value, children) {
        return { value, prev: null, next: null, children, selfList: this, selfHeight: 1 };
    }
    areNodesContiguous(source, destination) {
        if (source === null || source === undefined) {
            throw new Error(`DoubleLinkedList<T>.areNodesContiguous method: source node can not be null.`);
        }
        else if (destination === null || destination === undefined) {
            throw new Error(`DoubleLinkedList<T>.areNodesContiguous method: destination node can not be null.`);
        }
        return {
            contiguous: source.next === destination && destination.prev === source || source.prev === destination && destination.next === source,
            leftDestination: source.prev === destination && destination.next === source,
            rightDestination: source.next === destination && destination.prev === source
        };
    }
}

/**
 * Remember that every row is split in two parts: the column
 * itself and horizontal gutter. Therefore, rowUnit constant
 * will have a value of 2 meaning it has 2 tracks:
 */
const DkGridRowUnit = 2;
// Horizontal gutter per row will occupy 1 track:
const DkGridHorizontalGutterUnit = 1;
const spanUnit = 1;

class DkColumnMesh extends DoubleLinkedList {
    constructor(belongToGroupId) {
        super();
        this.belongToGroupId = belongToGroupId;
        this.listSiblingDropIds = {};
        this.listSiblingDropIds['drop-gutter-container'] = [];
        this.listSiblingDropIds['drop-swap-column-container'] = [];
        this.listSiblingDropIds['source-column-container'] = [];
        this.listSiblingDropIds['drop-border-container'] = [];
    }
    insert(value, children) {
        let newNode = null;
        let current = this.headNode;
        while (current && value.dikeColumn.order > current.value.dikeColumn.order) {
            current = current.next;
        }
        if (current === null) {
            newNode = this.append(value, children);
        }
        else if (current === this.headNode) {
            newNode = this.prepend(value, children);
        }
        else {
            newNode = this.createNode(value, children);
            newNode.next = current;
            newNode.prev = current.prev;
            current.prev.next = newNode;
            current.prev = newNode;
        }
        if (newNode && children) {
            children.parent = newNode;
        }
    }
    /**
     * Remove the given column slot from the current list instance.
     *
     * If the current list turns out empty after deleting the given column slot,
     * the parent column slot is deleted as well. If the parent column slot turns out
     * empty then the parent of the parent slot is deleted as well and so forth.
     *
     * @param {DkGridFactoryColumns} gridFactoryColumns The factory which helps creating each DkColumnDef instance.
     * @param {DkColumnMeshSlot} columnSlot The column slot which represents the column to be removed.
     * @returns {DkColumnDef} Returns the DkColumnDef instance which represents the deleted column.
     */
    removeColumnMeshSlot(gridFactoryColumns, columnSlot) {
        // This referecne will hold the deleted column slot as a cloned DkColumnDef:
        let columnDef = null;
        // Get the node that holds the given column slot:
        let foundNode = this.getDikeColumnMeshSlotNode(columnSlot.dikeColumn.columnId, false);
        // The node which holds the given colum slot ives in the current list instance:
        if (foundNode) {
            // Before deleting the found node, clone it until its leaves, if it is a Group column:
            columnDef = this.getClonedDikeColumnDefToDepth(gridFactoryColumns, foundNode.value.dikeColumn.columnId);
            // Delete the node from the current list:
            this.removeNode(foundNode);
            // After deletion, if the current list instance turns out empty, then delete the node which has the list instance (the parent node):
            if (this.isEmpty() && this.parent) {
                let parentColumnDef = this.parent.selfList.removeColumnMeshSlot(gridFactoryColumns, this.parent.value);
                /**
                 * Premises:
                 *
                 *  1.  If the current list left empty and its parent reference is not null, then the parent node is a Group Column.
                 *  2.  The execution falls in this if clause because the parent node only had one child column which was removed.
                 *  3.  The method getClonedDikeColumnDefToDepth(...) returns a DkDataColumnDef or a DkGroupColumnDef instance.
                 *  4.  The DkGridFactoryColumns service returns the children property as an empty array to be filled by
                 *      getClonedDikeColumnDefToDepth(...) method.
                 *
                 * Exception: In this specific case getClonedDikeColumnDefToDepth(...) method will return a DkGroupColumnDef but
                 *            with its children property set to null.
                 *
                 *  1.  The exception occurs because before deleting the parent node, its unique child column was deleted leaving the
                 *      list empty.
                 *  2.  Internally, the method getClonedDikeColumnDefToDepth(...) invokes the method cloneChildrenDikeColumnMeshSlotNodes(...) to
                 *      clone the child nodes for the current node.
                 *  3.  The cloneChildrenDikeColumnMeshSlotNodes(...) method evaluates if the given node has children, if it does not, it sets
                 *      the children property of the DkGroupColumnDef instance to null.
                 */
                if (!parentColumnDef.children) {
                    parentColumnDef.children = [];
                }
                parentColumnDef.children.push(columnDef);
                columnDef = parentColumnDef;
            }
        }
        return columnDef;
    }
    getNodesInOrder(displayStatus) {
        const elements = [];
        let current = this.headNode;
        while (current) {
            if (current.value.currentDisplayOn === displayStatus) {
                elements.push(current.value);
                if (current.children) {
                    elements.push(...current.children.getNodesInOrder(current.value.displayStatus));
                }
            }
            current = current.next;
        }
        return elements;
    }
    getLeavesArray(displayStatus) {
        const elements = [];
        let current = this.headNode;
        while (current) {
            if (current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    elements.push(...current.children.getLeavesArray(current.value.displayStatus));
                }
                else {
                    elements.push(current.value);
                }
            }
            current = current.next;
        }
        return elements;
    }
    getDikeColumnMeshSlot(columnId) {
        let foundNode = this.getDikeColumnMeshSlotNode(columnId);
        return foundNode ? foundNode.value : null;
    }
    getDikeMeshSlot(columnId) {
        if (this.isEmpty()) {
            return null;
        }
        let current = this.headNode;
        while (current) {
            if (current.value.complementDikeGutterSlot && current.value.complementDikeGutterSlot.dikeColumn.columnId === columnId) {
                return current.value.complementDikeGutterSlot;
            }
            else if (current.value.dikeColumn.columnId === columnId) {
                return current.value;
            }
            else if (current.value.dikeGutterSlot && current.value.dikeGutterSlot.dikeColumn.columnId === columnId) {
                return current.value.dikeGutterSlot;
            }
            if (current.children) {
                let foundSlot = current.children.getDikeMeshSlot(columnId);
                if (foundSlot) {
                    return foundSlot;
                }
            }
            current = current.next;
        }
        return null;
    }
    getDikeColumnMeshSlotByUniqueId(slotId, isTreeSearch = true) {
        let foundNode = isTreeSearch ? this.findInTree(slot => slot.slotId === slotId) : this.find(slot => slot.slotId === slotId);
        return !!foundNode ? foundNode.value : null;
    }
    getDikeMeshSlotByUniqueId(slotId) {
        if (this.isEmpty()) {
            return null;
        }
        let current = this.headNode;
        while (current) {
            if (current.value.complementDikeGutterSlot && current.value.complementDikeGutterSlot.slotId === slotId) {
                return current.value.complementDikeGutterSlot;
            }
            else if (current.value.slotId === slotId) {
                return current.value;
            }
            else if (current.value.dikeGutterSlot && current.value.dikeGutterSlot.slotId === slotId) {
                return current.value.dikeGutterSlot;
            }
            if (current.children) {
                let foundSlot = current.children.getDikeMeshSlotByUniqueId(slotId);
                if (foundSlot) {
                    return foundSlot;
                }
            }
            current = current.next;
        }
        return null;
    }
    getChildrenLeavesFromColumnMeshSlot(columnId) {
        // It retrieves all leaves from the list which belongs to the given meshSlot:
        let foundNode = this.getDikeColumnMeshSlotNode(columnId);
        if (foundNode) {
            if (foundNode.children) {
                return foundNode.children.getLeavesArray(foundNode.value.displayStatus);
            }
            else {
                return [];
            }
        }
        return null;
    }
    getVisibleColumnMeshSlots() {
        return this.toArray().filter(slot => slot.dikeColumn.visible);
    }
    getListDropppableIdsByBelongToGroupMeshSlot(belongToGroupId) {
        if (belongToGroupId === this.belongToGroupId) {
            return this.listSiblingDropIds;
        }
        let current = this.headNode;
        while (current) {
            if (current.value.slotId === belongToGroupId) {
                return current.children.listSiblingDropIds;
            }
            if (current.children) {
                let droppablesIds = current.children.getListDropppableIdsByBelongToGroupMeshSlot(belongToGroupId);
                if (droppablesIds) {
                    return droppablesIds;
                }
            }
            current = current.next;
        }
        return null;
    }
    getDikeColumnMeshListInstance(belongToGroupId) {
        if (belongToGroupId === this.belongToGroupId) {
            return this;
        }
        let current = this.headNode;
        while (current) {
            if (current.value.slotId === belongToGroupId) {
                return current.children;
            }
            if (current.children) {
                let listInstance = current.children.getDikeColumnMeshListInstance(belongToGroupId);
                if (listInstance) {
                    return listInstance;
                }
            }
            current = current.next;
        }
        return null;
    }
    /**
     * Instance list method.
     *
     * Firstly, the INode<DkColumnMeshSlot>, where the column slot is stored,
     * is retrieved. Then the column slot is cloned creating a DkColumnDef
     * instance.
     *
     * Lastly, all column slots descendants are cloned.
     *
     * @param {DkGridFactoryColumns} gridFactoryColumns The factory which helps creating each DkColumnDef instance.
     * @param {string} columnId The column id which represents the column to be cloned.
     * @returns {DkColumnDef} The cloned column stored in a DkColumnDef instance.
     */
    getClonedDikeColumnDefToDepth(gridFactoryColumns, columnId) {
        let foundNode = this.getDikeColumnMeshSlotNode(columnId, false);
        if (foundNode) {
            let columnDef = this.createClonedDikeColumnDefFromColumnSlot(gridFactoryColumns, foundNode.value);
            if (foundNode.children && isDkGroupColumnDef(columnDef)) {
                columnDef.children = foundNode.children.cloneChildrenDikeColumnMeshSlotNodes(gridFactoryColumns);
            }
            return columnDef;
        }
        return null;
    }
    /**
     * Instance list method.
     *
     * Firstly, the INode<DkColumnMeshSlot>, where the column slot is stored,
     * is retrieved. Then the column slot and all its descendants are cloned.
     *
     * Lastly, the line of ascent is retrieved.
     *
     * @param {DkGridFactoryColumns} gridFactoryColumns The factory which helps creating each DkColumnDef.
     * @param {string} columnId The column id which represents the column to be cloned.
     * @returns {DkColumnDef} The cloned line of ascent stored in a DkColumnDef instance.
     */
    getClonedDikeColumnDefBranch(gridFactoryColumns, columnId) {
        let foundNode = this.getDikeColumnMeshSlotNode(columnId, false);
        if (foundNode) {
            // Clone the column slot given by columnId and all its children:
            let columnDef = this.getClonedDikeColumnDefToDepth(gridFactoryColumns, columnId);
            // Then clone the line of ascent of the current column slot traversing the list through the parent pointer:
            let currentParent = foundNode.selfList.parent;
            while (currentParent) {
                let parentColumnDef = this.createClonedDikeColumnDefFromColumnSlot(gridFactoryColumns, currentParent.value);
                parentColumnDef.children.push(columnDef);
                columnDef = parentColumnDef;
                currentParent = currentParent.selfList.parent;
            }
            return columnDef;
        }
        return null;
    }
    setColumnMeshSlotVisible(columnSlot, isVisible) {
        let foundNode = this.getDikeColumnMeshSlotNode(columnSlot.dikeColumn.columnId, true);
        if (foundNode) {
            // Change the node's visibility:
            foundNode.value.dikeColumn.visible = isVisible;
            // Does the found node have children?
            if (foundNode.children) {
                foundNode.children.setListVisibility(isVisible);
            }
            return true;
        }
        return false;
    }
    isColumnMeshVisible() {
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible) {
                return true;
            }
            current = current.next;
        }
        return false;
    }
    doesNodeSlotExist(slotId, isTreeSearch = true) {
        let foundNode = isTreeSearch ? this.findInTree(slot => slot.slotId === slotId) : this.find(slot => slot.slotId === slotId);
        return !!foundNode;
    }
    /**
     *
     * Source and destination nodes will be interchage between them.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column.
     * @param {DkColumnMeshSlot} destinationColumnSlot The destination, data or group, column.
     *
     * @returns {boolean} True if swapping operation was successfuly acomplished.
     */
    swapColumnSlotNodes(sourceColumnSlot, destinationColumnSlot) {
        // The underlaying nodes will be necessary because we need to modify the source instance list:
        let sourceNode = this.getDikeColumnMeshSlotNode(sourceColumnSlot.dikeColumn.columnId, false);
        let destinationNode = this.getDikeColumnMeshSlotNode(destinationColumnSlot.dikeColumn.columnId, false);
        if (sourceNode && destinationNode && sourceNode.value.belongToGroup === destinationNode.value.belongToGroup &&
            sourceNode.value.dikeColumn.columnId !== destinationNode.value.dikeColumn.columnId) {
            return this.swapNodes(sourceNode, destinationNode);
        }
        return false;
    }
    calculateListVisibleHeight(displayStatus) {
        let current = this.headNode;
        let childrenHeight = 0;
        let maxHeight = 0;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    childrenHeight = current.children.calculateListVisibleHeight(current.value.displayStatus);
                }
                else {
                    childrenHeight = 0;
                }
                maxHeight = Math.max(maxHeight, current.selfHeight + childrenHeight);
            }
            current = current.next;
        }
        // Update the height of the current list:
        this.listHeight = maxHeight;
        return maxHeight;
    }
    verifyColumnVisibility() {
        /**
         * Premises:
         *
         *  1. Column visibility is always given by its child columns.
         *  2. Regardless which display status a parent column has, if the parent column does not have at least
         *     one visible child column, then the parent column become invisible.
         */
        let current = this.headNode;
        let listVisibility = false;
        while (current) {
            // Is current node a group column?
            if (current.children) {
                current.value.dikeColumn.visible = current.children.verifyColumnVisibility();
            }
            // If at least, there is one column visible, then this column visibility will update the list visibility:
            if (!listVisibility) {
                listVisibility = current.value.dikeColumn.visible;
            }
            current = current.next;
        }
        return listVisibility;
    }
    verifyGroupColumnDisplayStatus() {
        let current = this.headNode;
        let displayCounter = { open: 0, closed: 0 };
        while (current) {
            if (current.value.dikeColumn.visible) {
                // Data columns can never change its display status:
                current.value.canChangeDisplayStatus = false;
                // Is current node a group column?
                if (current.children) {
                    // Get the number of children columns with OPEN and CLOSED on-display status:
                    let childrenCounter = current.children.verifyGroupColumnDisplayStatus();
                    // If there is no difference in on-display status, then there is nothing to show on CLOSED or OPEN group status:
                    if (!(childrenCounter['open'] > 0 && childrenCounter['closed'] > 0)) {
                        // Set all current node children to OPEN status and the parent group node can not change its display status:
                        current.children.changeDisplayOnStatus('open');
                        // Then set parent node display status to OPEN:
                        current.value.displayStatus = 'open';
                    }
                    else {
                        /**
                         * At this point of the evaluation, there are some children columns of the current node that
                         * will display on OPEN parent status and other that will display on CLOSED parent status.
                         *
                         * Therefore, the current group column can change its display status between OPEN and CLOSED.
                         */
                        current.value.canChangeDisplayStatus = true;
                    }
                }
                // It does not matter which type of column the current node is, set its initial display status:
                current.value.currentDisplayOn = current.value.initialDisplayOn;
                // Then count its status:
                displayCounter[current.value.currentDisplayOn]++;
            }
            current = current.next;
        }
        return displayCounter;
    }
    setColumnMeshSlotsOrder(index) {
        let current = this.headNode;
        let order = index;
        while (current) {
            current.value.dikeColumn.order = order++;
            if (current.children) {
                current.children.setColumnMeshSlotsOrder(index);
            }
            current = current.next;
        }
    }
    changeColumnMeshSlotReference(oldRef, newRef) {
        let oldRefNode = this.getDikeColumnMeshSlotNode(oldRef.dikeColumn.columnId);
        if (!!oldRefNode) {
            oldRefNode.value = newRef;
            return true;
        }
        return false;
    }
    setListVisibility(isVisible) {
        let current = this.headNode;
        while (current) {
            current.value.dikeColumn.visible = isVisible;
            if (current.children) {
                current.children.setListVisibility(isVisible);
            }
            current = current.next;
        }
    }
    /**
     * Instance list method.
     *
     * This method must be called from a parent node,
     * if the parent has children slot nodes.
     *
     * @param {DkGridFactoryColumns} gridFactoryColumns The factory which helps creating each DkColumnDef.
     * @returns {DkColumnDef[]} The cloned children slots.
     */
    cloneChildrenDikeColumnMeshSlotNodes(gridFactoryColumns) {
        let current = this.headNode;
        let childrenColumnDef = null;
        /**
         * We must verify if the current list is not empty, if we accidentally called this method
         * for a parent slot node that does not have children. If that the case we return null. Otherwise,
         * ask for memory to the childrenColumnDef.
         */
        if (!this.isEmpty()) {
            childrenColumnDef = [];
        }
        while (current) {
            let columnDef = this.createClonedDikeColumnDefFromColumnSlot(gridFactoryColumns, current.value);
            if (current.children && isDkGroupColumnDef(columnDef)) {
                columnDef.children = current.children.cloneChildrenDikeColumnMeshSlotNodes(gridFactoryColumns);
            }
            childrenColumnDef.push(columnDef);
            current = current.next;
        }
        return childrenColumnDef;
    }
    /**
     * Instance list method.
     *
     * A column slot is stored in a new instance of type DkColumnDef when cloning.
     * Remember only a Group column or a Data column could be cloned. Otherwise, an
     * Error is thrown.
     *
     * @param {DkGridFactoryColumns} gridFactoryColumns The factory which helps creating each DkColumnDef.
     * @param {DkColumnMeshSlot} columnSlot The column slot to be cloned.
     * @returns {DkColumnDef} The cloned column slot.
     */
    createClonedDikeColumnDefFromColumnSlot(gridFactoryColumns, columnSlot) {
        if (columnSlot.dikeColumn.columnType === 'Group-Column') {
            return gridFactoryColumns.createDikeGroupColumnDefFromColumnSlot(columnSlot);
        }
        else if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            return gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot);
        }
        throw new Error(`The given slot (${columnSlot.dikeColumn.columnType}) is not valid for cloning.`);
    }
    getDikeColumnMeshSlotNode(columnId, isTreeSearch = true) {
        return isTreeSearch ? this.findInTree(slot => slot.dikeColumn.columnId === columnId) : this.find(slot => slot.dikeColumn.columnId === columnId);
    }
    getChildrenIds(displayStatus) {
        let current = this.headNode;
        this.listSiblingDropIds['drop-gutter-container'] = [];
        this.listSiblingDropIds['drop-swap-column-container'] = [];
        this.listSiblingDropIds['source-column-container'] = [];
        this.listSiblingDropIds['drop-border-container'] = [];
        while (current) {
            // Traversing all visible slots and visible in the current display status:
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                // Only draggable slots and not locked will be considered in swapping operations:
                if (current.value.dikeColumn.draggable && !current.value.dikeColumn.locked) {
                    if (current.value.complementDikeGutterSlot) {
                        this.listSiblingDropIds['drop-gutter-container'].push(current.value.complementDikeGutterSlot.dikeColumn.columnId);
                    }
                    this.listSiblingDropIds['source-column-container'].push(current.value.dikeColumn.columnId);
                    this.listSiblingDropIds['drop-swap-column-container'].push(current.value.dikeColumn.columnId);
                    if (current.value.dikeGutterSlot) {
                        this.listSiblingDropIds['drop-gutter-container'].push(current.value.dikeGutterSlot.dikeColumn.columnId);
                    }
                }
                // Traverse its children slots:
                if (current.children) {
                    current.children.getChildrenIds(current.value.displayStatus);
                }
            }
            current = current.next;
        }
    }
    spreadSiblingColumnIds(displayStatus) {
        let current = this.headNode;
        while (current) {
            // Traversing all visible slots and visible in the current display status:
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                // Only draggable and not locked slots will be considered in swapping operations:
                if (current.value.dikeColumn.draggable && !current.value.dikeColumn.locked) {
                    if (current.value.complementDikeGutterSlot) {
                        current.value.complementDikeGutterSlot.connectedSiblingIds['source-column-container'] = [
                            ...this.listSiblingDropIds['source-column-container']
                        ];
                    }
                    current.value.connectedSiblingIds['source-column-container'] = [...this.listSiblingDropIds['source-column-container']];
                    current.value.connectedSiblingIds['drop-swap-column-container'] = [...this.listSiblingDropIds['drop-swap-column-container']];
                    current.value.connectedSiblingIds['drop-gutter-container'] = [...this.listSiblingDropIds['drop-gutter-container']];
                    if (current.value.dikeGutterSlot) {
                        current.value.dikeGutterSlot.connectedSiblingIds['source-column-container'] = [
                            ...this.listSiblingDropIds['source-column-container']
                        ];
                    }
                }
                // Traverse its children slots:
                if (current.children) {
                    current.children.spreadSiblingColumnIds(current.value.displayStatus);
                }
            }
            current = current.next;
        }
    }
    calculateOuterColumnMeshSlotsPlacement(currentHeight, gridColumnStart, gridRowStart, outerSlots) {
        /**
         * Since outer columns are always leaves (if they lived in the tree), the
         * currentHeight will be the greatest height.
         */
        let currentGridColumnStart = gridColumnStart;
        let spanCounter = 0;
        const spanUnit = 1;
        let leafNodePosition = {
            gridColumnStart: currentGridColumnStart,
            gridColumnEnd: `span ${spanUnit}`,
            gridRowStart: gridRowStart,
            gridRowEnd: `span ${currentHeight * DkGridRowUnit - DkGridHorizontalGutterUnit}`
        };
        outerSlots.forEach((outerSlot, index) => {
            // Assing the current position:
            outerSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart });
            // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
            outerSlot.slotHeight = currentHeight;
            // Then prepare the next grid-column-start, if exists:
            currentGridColumnStart += spanUnit;
            spanCounter += spanUnit;
            let isLast = index === outerSlots.length - 1;
            // The current outer slot is not the last one and it has a right-gutter:
            if (!isLast && outerSlot.dikeGutterSlot) {
                outerSlot.dikeGutterSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart });
                // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                outerSlot.dikeGutterSlot.slotHeight = currentHeight;
                currentGridColumnStart += spanUnit;
                spanCounter += spanUnit;
            }
        });
        return spanCounter;
    }
    calculateScrollbarGapMeshSlotPlacement(currentHeight, gridColumnStart, gridRowStart, scrollbarGapSlot) {
        /**
         * Since scrollbar gap is always a leaf (if they lived in the tree), the
         * currentHeight will be the greatest height.
         */
        let currentGridColumnStart = gridColumnStart;
        let spanCounter = 0;
        const spanUnit = 1;
        let leafNodePosition = {
            gridColumnStart: currentGridColumnStart,
            gridColumnEnd: `span ${spanUnit}`,
            gridRowStart: gridRowStart,
            gridRowEnd: `span ${currentHeight}`
        };
        scrollbarGapSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart });
        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
        scrollbarGapSlot.slotHeight = currentHeight;
        spanCounter += spanUnit;
        return spanCounter;
    }
    calculateOuterColumnSlotsContainerWidth(outerSlots) {
        let currentWidth = 0;
        outerSlots.forEach((outerSlot, index) => {
            currentWidth += outerSlot.dikeColumn.width;
            let isLast = index === outerSlots.length - 1;
            // The current outer slot is not the last one and it has a right-gutter:
            if (!isLast && outerSlot.dikeGutterSlot) {
                currentWidth += outerSlot.dikeGutterSlot.dikeColumn.width;
            }
        });
        return currentWidth;
    }
    getOuterColumnSlotsTemplate(outerColumSlots) {
        /**
         * This implementation applies for InOrder and PreOrder instances. It does not
         * matter on which panel the outer slots will be drawn:
         *
         *    1. Outer slots always be displayed with their right-gutter. It means
         *       the column will be drawn firstly, then dikeGutterSlot property (right-gutter).
         *
         *    2. Since every most left-gutter will be drawn for any panel we
         *       have to avoid adding the space in the css grid-template-columns property.
         */
        let meshTemplate = '';
        outerColumSlots.forEach((outerSlot, index) => {
            meshTemplate += `${outerSlot.dikeColumn.width}px `;
            let isLast = index === outerColumSlots.length - 1;
            // The current outer slot is not the last one and it has a right-gutter:
            if (!isLast && outerSlot.dikeGutterSlot) {
                meshTemplate += `${outerSlot.dikeGutterSlot.dikeColumn.width}px `;
            }
        });
        return meshTemplate;
    }
    getFirstVisibleNode(displayStatus, descendant = false) {
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (descendant && current.children) {
                    return current.children.getFirstVisibleNode(current.value.displayStatus, descendant);
                }
                else {
                    return current;
                }
            }
            current = current.next;
        }
        return null;
    }
    setFirstVisibleNodesInTree(displayStatus) {
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                current.value.isFirst = true;
                if (current.children) {
                    current.children.setFirstVisibleNodesInTree(current.value.displayStatus);
                }
                return;
            }
            current = current.next;
        }
    }
    getLastVisibleNode(displayStatus, descendant = false) {
        let current = this.tailNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (descendant && current.children) {
                    return current.children.getLastVisibleNode(current.value.displayStatus, descendant);
                }
                else {
                    return current;
                }
            }
            current = current.prev;
        }
        return null;
    }
    setLastVisibleNodesInTree(displayStatus) {
        let current = this.tailNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                current.value.isLast = true;
                if (current.children) {
                    current.children.setLastVisibleNodesInTree(current.value.displayStatus);
                }
                return;
            }
            current = current.prev;
        }
    }
    resetDikeColumnSlotGutters() {
        let current = this.headNode;
        while (current) {
            current.value.complementDikeGutterSlot = null;
            current.value.isFirst = false;
            current.value.isLast = false;
            if (current.children) {
                current.children.resetDikeColumnSlotGutters();
            }
            current = current.next;
        }
    }
    changeDisplayOnStatus(status) {
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible) {
                current.value.currentDisplayOn = status;
            }
            current = current.next;
        }
    }
}

class InOrderDkColumnMesh extends DkColumnMesh {
    constructor(leftOuterGutterSlot, belongToGroupId) {
        super(belongToGroupId);
        this.leftOuterGutterSlot = leftOuterGutterSlot;
        this.leftOuterGutterSlot.belongToGroup = this.belongToGroupId;
    }
    isComplementGutter(gutter) {
        return gutter.dikeColumn.columnId === this.leftOuterGutterSlot.dikeColumn.columnId;
    }
    getContentMeshTemplate(displayStatus, outerSlots) {
        return `${this.getOuterColumnSlotsTemplate(outerSlots)} ${this.getColumnSlotsTemplate(displayStatus)}`.trim();
    }
    getHeaderMeshTemplate(displayStatus, outerSlots, scrollbarGapSlot) {
        let scrollbarGapMesh = scrollbarGapSlot ? `${scrollbarGapSlot.dikeColumn.width}px` : '';
        return `${this.getOuterColumnSlotsTemplate(outerSlots)} ${this.getColumnSlotsTemplate(displayStatus)} ${scrollbarGapMesh}`.trim();
    }
    getEdgeGutters(displayStatus, isComplementGutter) {
        let edgeGutters = [];
        let visibleNode = isComplementGutter ? this.getFirstVisibleNode(displayStatus) : this.getLastVisibleNode(displayStatus);
        if (visibleNode) {
            edgeGutters.push(isComplementGutter ? visibleNode.value.complementDikeGutterSlot : visibleNode.value.dikeGutterSlot);
            if (visibleNode.children) {
                edgeGutters.push(...visibleNode.children.getEdgeGutters(visibleNode.value.displayStatus, isComplementGutter));
            }
        }
        return edgeGutters;
    }
    /**
     * Source column slot will be place after the destination gutter slot.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column slot.
     * @param {DkMeshSlot} destinationGutterSlot The destination gutter.
     *
     * @returns {boolean} True if the movement was done successfully.
     */
    swapToGutterSlotNode(sourceColumnSlot, destinationGutterSlot) {
        // sourceNode is searched in the linked-list because we need the node not the column slot:
        let sourceNode = this.getDikeColumnMeshSlotNode(sourceColumnSlot.dikeColumn.columnId);
        // Get the node which has the given gutter slot:
        let destinationNode = destinationGutterSlot && destinationGutterSlot.dikeColumn.columnType === 'Gutter-Column' ?
            this.getDikeColumnMeshSlotNode(destinationGutterSlot.dikeColumn.columnIdBelongTo) : null;
        if (sourceNode && destinationNode && sourceNode !== destinationNode &&
            sourceNode.value.belongToGroup === destinationNode.value.belongToGroup) {
            let contiguousNodes = this.areNodesContiguous(sourceNode, destinationNode);
            // The destination gutter is the complementDikeGutterSlot:
            if (destinationGutterSlot.dikeColumn.columnId === this.leftOuterGutterSlot.dikeColumn.columnId) {
                let isolatedNode = this.removeNode(sourceNode);
                this.insertNodeBefore(isolatedNode, destinationNode);
                return true;
            }
            else if (contiguousNodes.contiguous) {
                // Nodes are contiguous and the movement direction is towards the right:
                if (contiguousNodes.rightDestination) {
                    let isolatedNode = this.removeNode(sourceNode);
                    this.insertNodeAfter(isolatedNode, destinationNode);
                    return true;
                }
            }
            else {
                let isolatedNode = this.removeNode(sourceNode);
                this.insertNodeAfter(isolatedNode, destinationNode);
                return true;
            }
        }
        return false;
    }
    calculateContainerWidth(displayStatus, outerSlots, scrollbarGapSlot) {
        return this.calculateOuterColumnSlotsContainerWidth(outerSlots) +
            this.calculateColumnSlotsMeshContainerWidth(displayStatus) +
            (scrollbarGapSlot ? scrollbarGapSlot.dikeColumn.width : 0);
    }
    setColumnMeshSlotPlacement(displayStatus, greatestHeight, outerSlots, scrollbarGapSlot) {
        /**
         * Before calculating slot positions set complementDikeGutterSlot property to
         * null and isFirst / isLast properties to false for every DkColumnMeshSlot
         * which lives in the list.
         */
        this.resetDikeColumnSlotGutters();
        // Set the first and last nodes in the whole tree:
        this.setFirstVisibleNodesInTree(displayStatus);
        this.setLastVisibleNodesInTree(displayStatus);
        // Then set the leftOuterGutterSlot:
        this.setComplementDikeGutterSlot(displayStatus);
        const gridColumnStart = 1;
        const gridRowStart = 1;
        // Calculate the positions for outer slots:
        let outerSpanCounter = this.calculateOuterColumnMeshSlotsPlacement(greatestHeight, gridColumnStart, gridRowStart, outerSlots);
        // Calculate the positions for every slot in the double-linked list:
        let columnSpanCounter = this.calculateColumnMeshSlotsPlacement(displayStatus, greatestHeight, gridColumnStart + outerSpanCounter, gridRowStart);
        // Calculate the position for the scrollbar gap:
        if (scrollbarGapSlot) {
            this.calculateScrollbarGapMeshSlotPlacement(greatestHeight, gridColumnStart + outerSpanCounter + columnSpanCounter, gridRowStart, scrollbarGapSlot);
        }
        /**
         * Get the first and the last visible descendant node:
         */
        let firstVisibleDescendantNode = null;
        // Get the last visible leaf:
        let lastVisibleDescendantNode = this.getLastVisibleNode(displayStatus, true);
        // If outerSpanCounter is greater than zero it means this panel has the outer slots:
        if (outerSpanCounter > 0) {
            // We create a node just to maintain variable compatibility:
            firstVisibleDescendantNode = this.createNode(outerSlots[0], null);
        }
        else {
            // Get the first visible leaf:
            firstVisibleDescendantNode = this.getFirstVisibleNode(displayStatus, true);
        }
        // Get all columnIds of the visible slots:
        this.getChildrenIds(displayStatus);
        // Then set sibling column ids per list in each node belonging the same list:
        this.spreadSiblingColumnIds(displayStatus);
        if (firstVisibleDescendantNode && lastVisibleDescendantNode) {
            return {
                gridColumnStart: firstVisibleDescendantNode.value.complementDikeGutterSlot ?
                    firstVisibleDescendantNode.value.complementDikeGutterSlot.slotPosition.gridColumnStart :
                    firstVisibleDescendantNode.value.slotPosition.gridColumnStart,
                gridColumnEnd: lastVisibleDescendantNode.value.dikeGutterSlot ?
                    lastVisibleDescendantNode.value.dikeGutterSlot.slotPosition.gridColumnStart + spanUnit :
                    lastVisibleDescendantNode.value.slotPosition.gridColumnStart + spanUnit,
                gridRowStart: greatestHeight * DkGridRowUnit,
                gridRowEnd: `span ${DkGridHorizontalGutterUnit}`
            };
        }
        return null;
    }
    calculateColumnSlotsMeshContainerWidth(displayStatus) {
        let columnsWidth = 0;
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    columnsWidth += current.children.calculateColumnSlotsMeshContainerWidth(current.value.displayStatus);
                }
                else {
                    if (current.value.complementDikeGutterSlot) {
                        columnsWidth += current.value.complementDikeGutterSlot.dikeColumn.width;
                    }
                    columnsWidth += current.value.dikeColumn.width;
                    if (current.value.dikeGutterSlot) {
                        columnsWidth += current.value.dikeGutterSlot.dikeColumn.width;
                    }
                }
            }
            current = current.next;
        }
        return columnsWidth;
    }
    calculateColumnMeshSlotsPlacement(displayStatus, currentHeight, gridColumnStart, gridRowStart) {
        /**
         * IMPORTANT:
         *
         * 1. Before traversing the tree in order to establish the slot positions,
         *    the following methods MUST be executed in the following order:
         *
         *      (a). verifyGroupColumnDisplayStatus();
         *      (b). calculateListVisibleHeight();
         *
         * 2. For the first invocation currentHeight will be the greatest height. Then
         *    we pass the children height for each level.
         */
        let current = this.headNode;
        let currentGridColumnStart = gridColumnStart;
        let spanCounter = 0;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    // Get the height of the current children list:
                    let childrenHeight = current.children.listHeight;
                    /**
                     * The current node is not a leaf then its grid-row-end will be given by:
                     *
                     * grid-row-end = (listHeight - childrenHeight) * DkGridRowUnit;
                     */
                    // currentGridRowTracks represents a complete row track:
                    let currentGridRowTracks = currentHeight - childrenHeight;
                    // currentGridRowEndSpan represents the actual span units the column group must grow:
                    let currentGridRowEndSpan = (currentHeight - childrenHeight) * DkGridRowUnit;
                    // The grid-column-end for a non-leaf node will be given by the sum of its children columns span:
                    let childrenSpan = current.children.calculateColumnMeshSlotsPlacement(current.value.displayStatus, childrenHeight, currentGridColumnStart, gridRowStart + currentGridRowEndSpan);
                    /**
                     * Determine how many horizontal spanUnits we have to substract in order
                     * to display the left and the right gutter:
                     *
                     * 1. Since we are in InOrderDkColumnMesh instance, the right-gutter always
                     *    be visible.
                     *
                     * 2. It is going to be enough to verify the most-left gutter visibility. If the
                     *    column group is the first visible node in the list then it will have its
                     *    complementDikeGutterSlot property pointing to the leftOuterGutterSlot instance.
                     *    Therefore, we will substract 2 spanUnits, otherwise only 1 spanUnit.
                     */
                    let actualColumnGroupSpan = current.value.complementDikeGutterSlot ? childrenSpan - spanUnit * 2 : childrenSpan - spanUnit;
                    /**
                     * Column group Horizontal Gutter.
                     *
                     * The column group horizontal gutter will occupy the whole children span units
                     * including the children's gutters.
                     *
                     * 1. Horizontal position.
                     *    (a). grid-column-start. This will be given by the same grid-column-start of the column group.
                     *    (b). grid-column-end. It will be given in span units. The value will be the whole span units
                     *                          the children columns occupy.
                     *
                     * 2. Vertical position.
                     *    (a). grid-row-start. As we state in the main algorithm, it will be given by the previous
                     *         grid-row-start position plus the previous span units. Remember its previous slot is the
                     *         column group itself.
                     *    (b). grid-row-end. It will be one horizontal gutter unit.
                     */
                    current.value.horizontalGutter = {
                        gridColumnStart: currentGridColumnStart,
                        // gridColumnEnd: `span ${childrenSpan}`,
                        gridColumnEnd: currentGridColumnStart + childrenSpan,
                        gridRowStart: gridRowStart + currentGridRowEndSpan - DkGridHorizontalGutterUnit,
                        gridRowEnd: `span ${DkGridHorizontalGutterUnit}`
                    };
                    // Display the most-left gutter, if it has the instance:
                    if (current.value.complementDikeGutterSlot) {
                        current.value.complementDikeGutterSlot.slotPosition = {
                            gridColumnStart: currentGridColumnStart,
                            // gridColumnEnd: `span ${spanUnit}`,
                            gridColumnEnd: currentGridColumnStart + spanUnit,
                            gridRowStart: gridRowStart,
                            gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                        };
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.complementDikeGutterSlot.slotHeight = currentGridRowTracks;
                        currentGridColumnStart += spanUnit;
                    }
                    // Then display the column group itself:
                    current.value.slotPosition = {
                        gridColumnStart: currentGridColumnStart,
                        // gridColumnEnd: `span ${actualColumnGroupSpan}`,
                        gridColumnEnd: currentGridColumnStart + actualColumnGroupSpan,
                        gridRowStart: gridRowStart,
                        gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                    };
                    // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                    current.value.slotHeight = currentGridRowTracks;
                    // Prepare the next grid-column-start position:
                    currentGridColumnStart += actualColumnGroupSpan;
                    // Then set the position for the column group right gutter:
                    if (current.value.dikeGutterSlot) {
                        current.value.dikeGutterSlot.slotPosition = {
                            gridColumnStart: currentGridColumnStart,
                            // gridColumnEnd: `span ${spanUnit}`,
                            gridColumnEnd: currentGridColumnStart + spanUnit,
                            gridRowStart: gridRowStart,
                            gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                        };
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.dikeGutterSlot.slotHeight = currentGridRowTracks;
                        // Then prepare the next grid-column-start for the next column in the list:
                        currentGridColumnStart += spanUnit;
                    }
                    /**
                     * Since we did not modify the returned childrenSpan counter, that are the actual
                     * span tracks for the next grid-column-start:
                     */
                    spanCounter += childrenSpan;
                }
                else {
                    let leafNodePosition = {
                        gridColumnStart: currentGridColumnStart,
                        gridColumnEnd: `span ${spanUnit}`,
                        gridRowStart: gridRowStart,
                        gridRowEnd: `span ${currentHeight * DkGridRowUnit - DkGridHorizontalGutterUnit}`
                    };
                    // Firstly, check the most-left gutter:
                    if (current.value.complementDikeGutterSlot) {
                        current.value.complementDikeGutterSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.complementDikeGutterSlot.slotHeight = currentHeight;
                        currentGridColumnStart += spanUnit;
                        spanCounter += spanUnit;
                    }
                    // Then update the slot position where the column lives:
                    current.value.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                    // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                    current.value.slotHeight = currentHeight;
                    currentGridColumnStart += spanUnit;
                    spanCounter += spanUnit;
                    // Finally, set the position for the column's right gutter:
                    if (current.value.dikeGutterSlot) {
                        current.value.dikeGutterSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.dikeGutterSlot.slotHeight = currentHeight;
                        currentGridColumnStart += spanUnit;
                        spanCounter += spanUnit;
                    }
                }
            }
            current = current.next;
        }
        return spanCounter;
    }
    getColumnSlotsTemplate(displayStatus) {
        let meshTemplate = '';
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    meshTemplate += current.children.getColumnSlotsTemplate(current.value.displayStatus);
                }
                else {
                    /**
                     * Fistly, draw the left-outer-gutter:
                     *
                     * The method setComplementDikeGutterSlot() will mark all the nodes
                     * which belong to the first visible branch. Therefore, it does not
                     * matter if we evaluate the complementDikeGutterSlot for each leaf,
                     * only the first visible node for each level will have the most-leftOuterGutterSlot
                     * instance.
                     */
                    if (current.value.complementDikeGutterSlot) {
                        meshTemplate += `${current.value.complementDikeGutterSlot.dikeColumn.width}px `;
                    }
                    // Then, draw the column:
                    meshTemplate += `${current.value.dikeColumn.width}px `;
                    // Lastly, draw the dikeGutterSlot which represents the right-gutter for each column:
                    if (current.value.dikeGutterSlot) {
                        meshTemplate += `${current.value.dikeGutterSlot.dikeColumn.width}px `;
                    }
                }
            }
            current = current.next;
        }
        return meshTemplate;
    }
    setComplementDikeGutterSlot(displayStatus) {
        let firstVisibleNode = this.getFirstVisibleNode(displayStatus);
        this.leftOuterGutterSlot.dikeColumn.columnIdBelongTo = '';
        if (firstVisibleNode) {
            this.leftOuterGutterSlot.dikeColumn.columnIdBelongTo = firstVisibleNode.value.dikeColumn.columnId;
            firstVisibleNode.value.complementDikeGutterSlot = this.leftOuterGutterSlot;
            if (firstVisibleNode.children) {
                firstVisibleNode.children.setComplementDikeGutterSlot(firstVisibleNode.value.displayStatus);
            }
        }
    }
}

function baseColumnDefFieldValidation(baseColumn, columnType) {
    if (baseColumn.fieldName === null || baseColumn.fieldName === undefined || baseColumn.fieldName.trim() === '') {
        throw new Error(`fieldName property must be provided for a ${columnType} column.`);
    }
    if (baseColumn.headerText === null || baseColumn.headerText === undefined || baseColumn.headerText.trim() === '') {
        throw new Error(`headerText property must be provided for a ${columnType} column.`);
    }
    if (baseColumn.panel !== 'leftPanel' &&
        baseColumn.panel !== 'centerPanel' &&
        baseColumn.panel !== 'rightPanel' &&
        baseColumn.panel !== 'groupPanel') {
        baseColumn.panel = 'centerPanel';
    }
    if (baseColumn.displayOn !== 'open' && baseColumn.displayOn !== 'closed') {
        baseColumn.displayOn = 'open';
    }
}
function groupColumnDefFieldValidation(groupColumn) {
    if (groupColumn.children === null || groupColumn.children === undefined || groupColumn.children.length === 0) {
        throw new Error(`children property must be provided for a Group column.`);
    }
    if (groupColumn.displayStatus !== 'open' && groupColumn.displayStatus !== 'closed') {
        groupColumn.displayStatus = 'open';
    }
}
function dataColumnDefFieldValidation(dataColumn, dikeConfig) {
    if (dataColumn.dataType !== 'Text' && dataColumn.dataType !== 'Numeric' &&
        dataColumn.dataType !== 'Date' && dataColumn.dataType !== 'Binary') {
        throw new Error(`DkColumnDataType must be specified for column: ${dataColumn.fieldName} - ${dataColumn.headerText}`);
    }
    if (dataColumn.width <= 0) {
        dataColumn.width = dikeConfig.COLUMN_WIDTH;
    }
    if (dataColumn.minWidth <= 0 || dataColumn.minWidth > dataColumn.width) {
        dataColumn.minWidth = dataColumn.width;
    }
    if (dataColumn.maxWidth <= 0 || dataColumn.maxWidth < dataColumn.width) {
        dataColumn.maxWidth = dataColumn.width;
    }
}
function columnDefFieldValidation(columnDef, dikeConfig) {
    if (isDkGroupColumnDef(columnDef)) {
        baseColumnDefFieldValidation(columnDef, 'Group');
        groupColumnDefFieldValidation(columnDef);
    }
    else if (isDkDataColumnDef(columnDef)) {
        baseColumnDefFieldValidation(columnDef, 'Data');
        dataColumnDefFieldValidation(columnDef, dikeConfig);
    }
    else {
        throw new Error(`The given DkColumnDef is not a DkGroupColumnDef nor DkDataColumnDef.`);
    }
}

class DkColumnStructure {
    constructor(panel, dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig) {
        this.panel = panel;
        this.dikeConfig = dikeConfig;
        this.gridConfig = gridConfig;
        this.gridFactoryColumns = gridFactoryColumns;
        this.gridFactoryMeshSlots = gridFactoryMeshSlots;
        this.gridFilterConfig = gridFilterConfig;
        this.sortDispatcher = sortDispatcher;
        this.gridEditionConfig = gridEditionConfig;
        this.measureScrollLeftOffset = 0;
        this.gridColumnMesh = this.createChildrenList(this.panel, ROOT_GROUP_ID);
        this.gridColumnMesh.level = 1;
        this.gridColumnMesh.parent = null;
        this.scrollbarGapSlot = null;
        this.listHeightSubject = new BehaviorSubject(0);
        this.scrollbarGapSlotSubject = new BehaviorSubject(this.scrollbarGapSlot);
        this.horizontalGutterSlotSubject = new BehaviorSubject(null);
        this.outerColumnSlotsSubject = new BehaviorSubject([]);
        this.colSlotsSubject = new BehaviorSubject([]);
        this.dataColumnSlotsSubject = new BehaviorSubject([]);
        this.containerWidthSubject = new BehaviorSubject(0);
        this.columnSetVisibilitySubject = new BehaviorSubject(false);
        this.gutterSlotOverSubject = new BehaviorSubject(null);
        this.gutterSlotResizingSubject = new BehaviorSubject(null);
        this.panelResizingSubject = new BehaviorSubject(false);
        this.columnResizedSubject = new Subject();
    }
    get onListHeightChanged$() {
        return this.listHeightSubject.asObservable();
    }
    get onOuterColumnSlotsChanged$() {
        return this.outerColumnSlotsSubject.asObservable();
    }
    get onColumnSlotsChanged$() {
        return this.colSlotsSubject.asObservable();
    }
    get onDataColumnSlotsChanged$() {
        return this.dataColumnSlotsSubject.asObservable();
    }
    get onScrollbarGapSlotChanged$() {
        return this.scrollbarGapSlotSubject.asObservable();
    }
    get onContainerWidthChanged$() {
        return this.containerWidthSubject.asObservable();
    }
    get onColumnSetVisibilityChanged$() {
        return this.columnSetVisibilitySubject.asObservable();
    }
    get onHorizontalGutterSlotChanged$() {
        return this.horizontalGutterSlotSubject.asObservable();
    }
    get onGutterSlotOverChanged$() {
        return this.gutterSlotOverSubject.asObservable();
    }
    get onGutterSlotResizingChanged$() {
        return this.gutterSlotResizingSubject.asObservable();
    }
    get onPanelResizingChanged$() {
        return this.panelResizingSubject.asObservable();
    }
    get onColumnSizeChanged$() {
        return this.columnResizedSubject.asObservable();
    }
    get firstColumnSlot() {
        return this.gridColumnMesh.first ? this.gridColumnMesh.first.value : null;
    }
    get lastColumnSlot() {
        return this.gridColumnMesh.last ? this.gridColumnMesh.last.value : null;
    }
    setGreatestHeight(value) {
        this.gridColumnMesh.greatestHeight = value > 0 ? value : 0;
    }
    setScrollbarGapColumnSlot(visible, width = 0) {
        this.scrollbarGapSlot = null;
        if (visible) {
            this.scrollbarGapSlot = this.gridFactoryMeshSlots.createDikeScrollbarGapMeshSlot(this.panel, width);
        }
        this.changeScrollbarGapSlot(this.scrollbarGapSlot);
        this.changeGridTemplateColumns();
    }
    getColumnSlots() {
        // Returns all visible column slots:
        return [...this.colSlotsSubject.value];
    }
    getDataColumnSlots() {
        // Returns all visible data column slots:
        return [...this.dataColumnSlotsSubject.value];
    }
    getAllDataColumnSlots() {
        // Returns all visible and non-visible data column slots:
        return [...this.gridColumnMesh.getAllLeavesArray()];
    }
    getAllRootColumnSlots() {
        // Retrieves only the slots which live in the this.gridColumnMesh instance:
        return [...this.gridColumnMesh.toArray()];
    }
    getColumnSlot(columnId) {
        return this.gridColumnMesh.getDikeColumnMeshSlot(columnId);
    }
    getColumnSlotByUniqueId(slotId) {
        return this.gridColumnMesh.getDikeColumnMeshSlotByUniqueId(slotId);
    }
    getSlot(columnId) {
        return this.gridColumnMesh.getDikeMeshSlot(columnId);
    }
    getSlotByUniqueId(slotId) {
        return this.gridColumnMesh.getDikeMeshSlotByUniqueId(slotId);
    }
    getDataColumnSlotsFromSlot(columnId) {
        return this.gridColumnMesh.getChildrenLeavesFromColumnMeshSlot(columnId);
    }
    doesSlotExist(slotId) {
        return this.gridColumnMesh.doesNodeSlotExist(slotId);
    }
    /**
     * Panel-tree structure method.
     *
     * Parameter belongToGroupId represents the group id which some slot belongs to. The given group id is
     * looked for in the entire panel tree structure.
     *
     * It uses getDikeColumnMeshListInstance method from DkColumnMesh abstract class. If the corresponding
     * double-linked list instance exists then the group exists.
     *
     * @param {string} belongToGroupId The group id which is looked for.
     *
     * @returns {boolean} Returns true if the group exists in the current panel.
     */
    doesGroupExist(belongToGroupId) {
        return !!this.gridColumnMesh.getDikeColumnMeshListInstance(belongToGroupId);
    }
    getColumnSlotWidth(columnId) {
        let columnSlot = this.gridColumnMesh.getDikeColumnMeshSlot(columnId);
        return columnSlot ? columnSlot.dikeColumn.width : 0;
    }
    setColumnSlotWidth(columnSlot, value) {
        if (columnSlot && columnSlot.dikeColumn.resizable && columnSlot.dikeColumn.resizeWidth(value)) {
            this.changeGridTemplateColumns();
            // Emit the columns that changed its size:
            this.emitColumnResizing(columnSlot);
        }
    }
    setColumnSlotsOrder(index) {
        this.gridColumnMesh.setColumnMeshSlotsOrder(index);
    }
    isColumnStructureVisible() {
        return this.columnSetVisibilitySubject.value;
    }
    isPanelResizing(value) {
        this.changePanelResized(value);
    }
    getMeasureScrollLeftOffset() {
        return this.measureScrollLeftOffset;
    }
    setMeasureScrollLeftOffset(value) {
        this.measureScrollLeftOffset = value;
    }
    getListDropppableIdsByBelongToGroupSlot(belongToGroupId) {
        return this.gridColumnMesh.getListDropppableIdsByBelongToGroupMeshSlot(belongToGroupId);
    }
    notifySlotOver(slot, value) {
        // It does not matter the type of the slot, the slot itself must notify that some column is on it:
        slot.isColumnOver({ isOver: value, isForHeaderRow: true });
        // The slot is a gutter slot:
        if (slot.dikeColumn.columnType === 'Gutter-Column') {
            // If the value is true, send the slot itself to break the horizontal gutter for each row, including the header:
            this.changeGutterSlotOver(value ? slot : null);
            // Retrieve the column slot to which the gutter slot belongs to:
            let columnSlot = this.getColumnSlot(slot.dikeColumn.columnIdBelongTo);
            // If the column slot is a group column, retrieve all the edge gutters of its descendants, according to the list instance (pre-order or in-order):
            if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Group-Column') {
                // Get the list instance where the column slot lives. This instance will allow verifying if the given slot is the complement-gutter of the list:
                let groupListInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.belongToGroup);
                // Get the list instance where the column slot's children live. Remember that the target are all descendants of the given column slot:
                let childrenListInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.slotId);
                // Get all edge gutters of the column slot's descendants, distinguishing if the given slot is the complement gutter slot in its list instance:
                let edgeGutterSlots = childrenListInstance.getEdgeGutters(columnSlot.displayStatus, groupListInstance.isComplementGutter(slot));
                // Lastly, all the found edge gutters will be notified that some column is on them:
                edgeGutterSlots.forEach(gutterSlot => gutterSlot.isColumnOver({ isOver: value, isForHeaderRow: true }));
            }
        }
        else if (slot.dikeColumn.columnType === 'Group-Column') {
            // Get the list instance where the column slot's children live. Remember that the target are all descendants of the given column slot:
            let childrenListInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(slot.slotId);
            // Get all the data columns under the given slot which is an instance of DkColumnMeshSlot:
            let leafColumnSlots = childrenListInstance.getLeavesArray(slot.displayStatus);
            // For each data slot, notify that some column is on them. Prevent the header UI takes the notification:
            leafColumnSlots.forEach(leafSlot => leafSlot.isColumnOver({ isOver: value, isForHeaderRow: false }));
        }
    }
    notifySlotResizing(gutterSlot, value) {
        // The gutter slot itself must notify that is being resized:
        gutterSlot.isColumnResizing({ isResizing: value, isForHeaderRow: true });
        // If the value is true, send the gutter slot itself to break the horizontal gutter for each row, including the header:
        this.changeGutterSlotResized(value ? gutterSlot : null);
        // Retrieve the column slot to which the gutter slot belongs to:
        let columnSlot = this.getColumnSlot(gutterSlot.dikeColumn.columnIdBelongTo);
        // If the column slot is a group column, retrieve all the edge gutters of its descendants, according to the list instance (pre-order or in-order):
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Group-Column') {
            // Get the list instance where the column slot lives. This instance will allow verifying if the given slot is the complement-gutter of the list:
            let groupListInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.belongToGroup);
            // Get the list instance where the column slot's children live. Remember that the target are all descendants of the given column slot:
            let childrenListInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.slotId);
            // Get all edge gutters of the column slot's descendants, distinguishing if the given slot is the complement gutter slot in its list instance:
            let edgeGutterSlots = childrenListInstance.getEdgeGutters(columnSlot.displayStatus, groupListInstance.isComplementGutter(gutterSlot));
            // Lastly, all the found edge gutters will be notified that they are being resizing:
            edgeGutterSlots.forEach(edgeGutterSlot => edgeGutterSlot.isColumnResizing({ isResizing: value, isForHeaderRow: true }));
        }
    }
    /**
     * Instance level-list method.
     *
     * Given the column slot, all its children are returned in a DkColumnDef structure
     * including the column slot itself.
     *
     * If lineOfAscent flag is true, then all the column slots above the given column slot
     * are retrieved.
     *
     * The column slots above the given column slot are its parent and the parent of its
     * parent and so forth.
     *
     * @param {DkColumnMeshSlot} columnSlot The column slot which will be cloned.
     * @param {boolean} lineOfAscent Flag which indicates if the line of ascent of the given column slot is retrieved or not. Default value is false.
     *
     * @returns {DkColumnDef} The cloned column slot stored in a DkColumnDef instance.
     */
    cloneColumnSlot(columnSlot, lineOfAscent) {
        if (columnSlot.dikeColumn.panel === this.panel) {
            // Given the belongToGroup id, retrieve the corresponding DkColumnMesh list instance:
            let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.belongToGroup);
            return lineOfAscent ? listInstance.getClonedDikeColumnDefBranch(this.gridFactoryColumns, columnSlot.dikeColumn.columnId) :
                listInstance.getClonedDikeColumnDefToDepth(this.gridFactoryColumns, columnSlot.dikeColumn.columnId);
        }
        throw new Error(`Error from DkColumnStructure - The given column slot (${columnSlot.dikeColumn.fieldName} - ${columnSlot.dikeColumn.headerText}) can not be cloned because it does not belong to the current panel (${this.panel}).`);
    }
    /**
     * Instance level-list method.
     *
     * The given column slot is removed from the corresponding level-list instance.
     *
     * This method remove sortable and filterables from the corresponding map variables.
     *
     * @param {DkColumnMeshSlot} columnSlot The column slot which will be deleted.
     *
     * @returns {DkColumnDef} Returns the deleted column slot as a cloned DkColumnDef.
     */
    removeColumnSlot(columnSlot) {
        // Given the belongToGroup id, retrieve the corresponding DkColumnMesh list instance:
        let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.belongToGroup);
        /**
         * Before deleting the given colum slot:
         *
         *  1. Search the given slot in the found list instance. This ensures the given column slot
         *     lives in the current panel instance.
         *  2. Once the given column slot was found, remove its filterables and its sortables, if
         *     the colum slot has them.
         */
        if (listInstance && !!listInstance.getDikeColumnMeshSlot(columnSlot.dikeColumn.columnId)) {
            /**
             * The given colum slot lives in the current panel, clone in a DkColumnDef instance.
             * We are getting a DkColumnDef instance because if the given column slot is a Group-Column,
             * we will have all the child columns in one structure.
             *
             * This instance will only serve to remove sortables and filterables which could be applied
             * to the given slot itself, if it is a data column.
             *
             * If the given slot is a group column, clearFilterablesAndSortablesFromRemovedColumnSlot(...)
             * method will iterate until it reaches the child data columns. The child data columns could
             * have the sortables and filterables applied.
             */
            let columnDef = this.cloneColumnSlot(columnSlot, false);
            // Remove Sortables and Filterables:
            this.clearFilterablesAndSortablesFromRemovedColumnSlot(columnDef);
            // Delete the node from the list instance, reusing the columnDef reference:
            columnDef = listInstance.removeColumnMeshSlot(this.gridFactoryColumns, columnSlot);
            // The given column slot has been removed:
            if (columnDef) {
                // Send the panel structure changes:
                this.changeColSlots();
                this.changeGridTemplateColumns();
            }
            /**
             * This instance is the actual deleted column which could be the given column slot itself or
             * it could be the parent or grand-parent of the given column slot.
             */
            return columnDef;
        }
        return null;
    }
    /**
     * Instance level-list method.
     *
     * The given column slot is removed from the corresponding level-list instance but its
     * sortables and filterables are not removed, if the given column slot has them.
     *
     * The DikeGrid instance is cloning column slots due to swapping columns between panels.
     *
     * The difference between removeColumnSlot(...) method with this method, is that if the
     * given columnSlot has sortables and filterables, they do not be removed from its
     * map variables. Therefore, the given column slot must be cloned before. When the
     * cloned columnDef is inserted into the destination panel:
     *
     *  1. Its sortable is updated as active if the DikeGrid was sorted with the given
     *     column slot. Finally, the older sortable is removed from the map variables.
     *
     *  2. Its filterables (context filterable and row filterable) are set from the older
     *     filterables taken from the map variable. Finally, older filterables are removed
     *     from the map variable.
     *
     * IMPORTANT: When filterables are cloned, they are cloned silently meaning not sending
     *            register and deregister events, avoiding proccesing the existing filters
     *            because they have already been applied before.
     *
     * @param {DkColumnMeshSlot} columnSlot The column slot which will be deleted.
     * @param {boolean} notifyChanges A flag that indicates if the Observables must be updated. Its default value is true.
     *
     * @returns {DkColumnDef} Returns the deleted column slot as a cloned DkColumnDef.
     */
    removeClonedColumnSlot(columnSlot, notifyChanges = true) {
        // Given the belongToGroup id, retrieve the corresponding DkColumnMesh list instance:
        let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(columnSlot.belongToGroup);
        // Delete the node from the list instance:
        let removedColumnDef = listInstance.removeColumnMeshSlot(this.gridFactoryColumns, columnSlot);
        // The DkColumnMeshSlot was removed:
        if (!!removedColumnDef && notifyChanges) {
            // Send the panel structure changes:
            this.changeColSlots();
            this.changeGridTemplateColumns();
        }
        return removedColumnDef;
    }
    setColumnSlotFilterability(columnSlot, isFilterable, filter, customFilterConditions) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            columnSlot.dikeColumn.filterable = isFilterable;
            if (isFilterable) {
                // Prepare the filterable object:
                let filterable = {
                    columnId: columnSlot.dikeColumn.columnId,
                    fieldName: columnSlot.dikeColumn.fieldName,
                    headerText: columnSlot.dikeColumn.headerText,
                    dataType: columnSlot.dikeColumn.dataType,
                    filter: filter && filter.length > 0 ? [...filter] : null,
                    customFilterConditions: customFilterConditions
                };
                this.addFilterable(filterable);
            }
            else {
                this.removeFilterable(columnSlot.dikeColumn.columnId);
            }
            // Finally, notify the change:
            this.changeColSlots();
        }
    }
    removeAllFilterables(onlyRowFilterables = false) {
        let dataSlots = this.getAllDataColumnSlots();
        dataSlots.forEach(slot => {
            // Remove the row-filterable:
            this.removeFilterable(this.gridFilterConfig.getRowFilterColumnId(slot.dikeColumn.columnId));
            // Must the filterable column be removed as well?
            if (!onlyRowFilterables) {
                this.removeFilterable(slot.dikeColumn.columnId);
            }
        });
    }
    /**
     * Instance level-list method.
     *
     * Source and destination slots will be interchage between them.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column.
     * @param {DkColumnMeshSlot} destinationColumnSlot The destination, data or group, column.
     *
     * @returns {void} No return value.
     */
    swapColumnSlots(sourceColumnSlot, destinationColumnSlot) {
        if (sourceColumnSlot && destinationColumnSlot && sourceColumnSlot.dikeColumn.panel === destinationColumnSlot.dikeColumn.panel &&
            sourceColumnSlot.belongToGroup === destinationColumnSlot.belongToGroup &&
            (sourceColumnSlot.dikeColumn.columnType === 'Data-Column' || sourceColumnSlot.dikeColumn.columnType === 'Group-Column')) {
            // Interchange columSlots:
            if ((destinationColumnSlot.dikeColumn.columnType === 'Data-Column' ||
                destinationColumnSlot.dikeColumn.columnType === 'Group-Column') &&
                sourceColumnSlot.dikeColumn.columnId !== destinationColumnSlot.dikeColumn.columnId) {
                // Given the belongToGroup id, retrieve the corresponding DkColumnMesh list instance:
                let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(sourceColumnSlot.belongToGroup);
                if (listInstance.swapColumnSlotNodes(sourceColumnSlot, destinationColumnSlot)) {
                    this.changeColSlots();
                    this.changeGridTemplateColumns();
                }
            }
        }
    }
    /**
     * Instance level-list method.
     *
     * Source slot will be place before or after the destination gutter slot.
     *
     * Source slot will be place before the gutter slot, if the slot lives in the right panel. Otherwise,
     * the source slot will be place after the destination gutter slot.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column.
     * @param {DkMeshSlot} destinationSlot The destination gutter.
     *
     * @returns {void} No return value.
     */
    swapColumnSlotToGutterSlot(sourceColumnSlot, destinationSlot) {
        if (sourceColumnSlot && destinationSlot && sourceColumnSlot.dikeColumn.panel === destinationSlot.dikeColumn.panel &&
            sourceColumnSlot.belongToGroup === destinationSlot.belongToGroup &&
            (sourceColumnSlot.dikeColumn.columnType === 'Data-Column' || sourceColumnSlot.dikeColumn.columnType === 'Group-Column')) {
            // Source columnSlot is moving to a gutter:
            if (destinationSlot.dikeColumn.columnType === 'Gutter-Column' &&
                sourceColumnSlot.dikeColumn.columnId !== destinationSlot.dikeColumn.columnIdBelongTo) {
                // Given the belongToGroup id, retrieve the corresponding DkColumnMesh intance:
                let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(sourceColumnSlot.belongToGroup);
                if (listInstance.swapToGutterSlotNode(sourceColumnSlot, destinationSlot)) {
                    this.changeColSlots();
                    this.changeGridTemplateColumns();
                }
            }
        }
    }
    /**
     * Instance level-list method.
     *
     * External column will be place before or after the destination gutter slot. External column must
     * live in a different panel of the destination gutter slot.
     *
     * If external column is a Group column and the same group exists in the
     * destination panel, then it will be joined to its group. After the joining operation,
     * the group is moved before or after the destination gutter slot.
     *
     * If external column is a data column, the data column is moved before or after the destination gutter slot.
     *
     * External column will be place before the gutter slot, if the slot lives in the right panel. Otherwise,
     * the external solumn will be place after the destination gutter slot.
     *
     * @param {DkColumnDef} externalColumnDef The external column which will be place before or after the destination gutter slot.
     * @param {DkMeshSlot} destinationSlot The destination gutter slot.
     *
     * @returns {boolean} True if the movement was done successfully.
     */
    insertExternalColumnSlotToGutter(externalColumnDef, destinationSlot) {
        if (externalColumnDef && destinationSlot && (isDkDataColumnDef(externalColumnDef) || isDkGroupColumnDef(externalColumnDef)) &&
            destinationSlot.dikeColumn.columnType === 'Gutter-Column' &&
            externalColumnDef.belongToGroup === destinationSlot.belongToGroup &&
            externalColumnDef.panel !== destinationSlot.dikeColumn.panel) {
            // Firstly, given the belongToGroup id, retrieve the corresponding DkColumnMesh intance:
            let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(destinationSlot.belongToGroup);
            let result = false;
            /**
             * If the given external DkColumnDef is a column group and exists in the destination panel,
             * join the external DkColumnDef to its corresponding group:
             */
            if (isDkGroupColumnDef(externalColumnDef) && listInstance.doesNodeSlotExist(externalColumnDef.slotId, false)) {
                // Join the groups:
                this.joinGroupColumnIntoList(externalColumnDef, this.gridColumnMesh);
                // After the joining, the external DkColumnDef is now inserted into the destination list, swap it to the destination gutter slot:
                const groupSlot = listInstance.getDikeColumnMeshSlotByUniqueId(externalColumnDef.slotId, false);
                // In the instance list, move the joined-group slot to destination gutter slot:
                result = listInstance.swapToGutterSlotNode(groupSlot, destinationSlot);
                /**
                 * Set result to true.
                 *
                 * 1. When the swapToGutterSlotNode(...) method is executed and the operation is
                 *    successfully achieved, the method will return true.
                 *
                 * 2. On the other hand, the method swapToGutterSlotNode(...) could return false because the target slot
                 *    is a contiguous group-column slot. Therefore, the movement is not done and this
                 *    operation will return false. But the joining operation was successfully done. Then,
                 *    the changes in the UI must be displayed.
                 *
                 * That is why, regardless the swapToGutterSlotNode(...) result is, after the joining operation
                 * the result is set to true.
                 */
                result = true;
            }
            else {
                /**
                 * The external column is not a column group or it is a data column, or it does not exist.
                 *
                 * The idea is adding the external column to the list instance:
                 *
                 *  (a).  If the list is an instance of type InOrderDkColumnMesh (groupPanel, leftPanel, centerPanel), we
                 *        insert the external column before the Head node (at the complement gutter place).
                 *
                 *  (b).  Otherwise, the external column is inserted after the Tail node (in the complement gutter place).
                 *
                 * IMPORTANT: We insert the external column at the complement gutter place due to the swapToGutterSlotNode(...)
                 *            method moves the source slot regardless it be already there.
                 */
                // Get the Head or the Tail node to retrieve their order:
                externalColumnDef.order = listInstance instanceof InOrderDkColumnMesh ? listInstance.first.value.dikeColumn.order - 1 :
                    listInstance.last.value.dikeColumn.order + 1;
                // Add the column group to the list instance:
                const newSlot = this.addColumnIntoList(externalColumnDef, listInstance, externalColumnDef.belongToGroup);
                // Then, move the new group slot to the destination gutter slot:
                result = listInstance.swapToGutterSlotNode(newSlot, destinationSlot);
            }
            if (result) {
                this.changeColSlots();
                this.changeGridTemplateColumns();
                return result;
            }
        }
        return false;
    }
    /**
     * Instance level-list method.
     *
     * External column will be place at the destination column slot. External column must
     * live in a different panel of the destination column slot.
     *
     * If external column is a Group column and the same group exists in the
     * destination panel, then it will be joined to its group. Otherwise, the external
     * column slot will be place at the place occupied by destination column slot.
     *
     * Destination column slot will be removed from the destination panel.
     *
     * @param {DkColumnDef} externalColumnDef The external column which will be added to the destination panel.
     * @param {DkColumnMeshSlot} destinationColumnSlot The destination column slot which will be removed of the destination panel in
     * order to give its place.
     *
     * @returns {boolean} True if the movement was done successfully.
     */
    insertExternalColumnDefAtDestinationColumnSlot(externalColumnDef, destinationColumnSlot) {
        if (externalColumnDef && destinationColumnSlot && (isDkDataColumnDef(externalColumnDef) || isDkGroupColumnDef(externalColumnDef)) &&
            (destinationColumnSlot.dikeColumn.columnType === 'Data-Column' ||
                destinationColumnSlot.dikeColumn.columnType === 'Group-Column') &&
            externalColumnDef.belongToGroup === destinationColumnSlot.belongToGroup &&
            externalColumnDef.panel !== destinationColumnSlot.dikeColumn.panel) {
            // Firstly, given the belongToGroup id, retrieve the corresponding DkColumnMesh intance:
            let listInstance = this.gridColumnMesh.getDikeColumnMeshListInstance(destinationColumnSlot.belongToGroup);
            let externalSlot;
            let result = false;
            /**
             * If the given external DkColumnDef is a group column and exists in the destination panel,
             * join the external DkColumnDef to its corresponding group:
             */
            if (isDkGroupColumnDef(externalColumnDef) && listInstance.doesNodeSlotExist(externalColumnDef.slotId, false)) {
                // Join the groups:
                this.joinGroupColumnIntoList(externalColumnDef, this.gridColumnMesh);
                /**
                 * After the joining, the source group slot now lives in the destination panel,
                 * then we have to move the joined column to the place where destinationColumnSlot occupies:
                 */
                externalSlot = listInstance.getDikeColumnMeshSlotByUniqueId(externalColumnDef.slotId, false);
            }
            else {
                /**
                 * The external column is not a column group or it is a data column, or it does not exist.
                 *
                 * The idea is adding the external column to the list instance before the head node.
                 */
                // Get the head node to retrieve its order, minus a unit, and assign it to the external column group:
                externalColumnDef.order = listInstance.first.value.dikeColumn.order - 1;
                // Add the column group to the list instance:
                externalSlot = this.addColumnIntoList(externalColumnDef, listInstance, externalColumnDef.belongToGroup);
            }
            // Execute the movement in the same instance list and then remove the destination column slot:
            result = listInstance.swapColumnSlotNodes(externalSlot, destinationColumnSlot) ?
                !!listInstance.removeColumnMeshSlot(this.gridFactoryColumns, destinationColumnSlot) : false;
            // Everything was ok:
            if (result) {
                this.changeColSlots();
                this.changeGridTemplateColumns();
                return result;
            }
        }
        return false;
    }
    /**
     * Panel-tree structure method.
     *
     * It receives a group or data column that will be inserted into the panel list. If the column is a group
     * column, the method is called recursively until it reaches the leaves (data columns).
     *
     * The given column is inserted into the given DkColumnMesh instance level-list represented by currentLevelList
     * parameter.
     *
     * The method adds the column filterability if the column has a filter specified.
     *
     * Finally, the method is used for internal purposes. Therefore, is used to insert cloned columns as well.
     *
     * @param {DkGroupColumnDef | DkDataColumnDef} columnDef The group or data column to be inserted into the panel list.
     * @param {DkColumnMesh} currentLevelList An instance of type DkColumnMesh that corresponds to the given group represented by belongToGroup.
     * @param {string} belongToGroup The group id which the given column belongs to.
     *
     * @returns {DkColumnMeshSlot} The just inserted slot.
     */
    addColumnIntoList(columnDef, currentLevelList, belongToGroup) {
        // Before inserting the column validate some fields:
        columnDefFieldValidation(columnDef, this.dikeConfig);
        // Is a group column?
        if (isDkGroupColumnDef(columnDef) && columnDef.children && columnDef.children.length > 0) {
            /**
             * We need to pass the parent group id to its childrens.
             *
             * We have to differentiate a normal column from cloned column. If slotId field has a value,
             * then the given column is considered a cloned column. Therefore, we take the slotId from
             * the cloned column.
             */
            let groupId = columnDef.slotId !== null && columnDef.slotId !== undefined ? columnDef.slotId : generateUUID();
            let childrenList = this.createChildrenList(this.panel, groupId);
            childrenList.level = currentLevelList.level + 1;
            columnDef.children.forEach(childColumn => {
                this.addColumnIntoList(childColumn, childrenList, groupId);
            });
            let groupColumn = this.gridFactoryColumns.createDikeGroupColumn(columnDef.fieldName, columnDef.headerText);
            groupColumn.order = columnDef.order;
            groupColumn.headerTooltip = columnDef.headerTooltip;
            groupColumn.resizable = columnDef.resizable;
            groupColumn.draggable = columnDef.draggable;
            groupColumn.locked = columnDef.locked;
            groupColumn.visible = columnDef.visible;
            groupColumn.displayMenu = columnDef.displayMenu;
            groupColumn.sortable = false;
            groupColumn.filterable = false;
            groupColumn.panel = this.panel;
            let groupSlot = this.gridFactoryMeshSlots.createDikeGroupColumnMeshSlot(groupColumn);
            // The groupId at slot level will be permanent:
            groupSlot.slotId = groupId;
            // Store the group id which the current slot belong to:
            groupSlot.belongToGroup = belongToGroup;
            groupSlot.dikeGutterSlot.belongToGroup = belongToGroup;
            // The given display status is stored in the new group slot, but this value will be evaluated:
            groupSlot.displayStatus = columnDef.displayStatus;
            // At creation stage, group columns can not change its display status, but this value will be evaluated:
            groupSlot.canChangeDisplayStatus = false;
            // It does not matter if the given column is a cloned or new column, it always have the initial display-on value:
            groupSlot.initialDisplayOn = columnDef.displayOn;
            // Add the group to the current list:
            currentLevelList.insert(groupSlot, childrenList);
            return groupSlot;
        }
        else if (isDkDataColumnDef(columnDef)) {
            let dataColumn = this.gridFactoryColumns.createDikeDataColumn(columnDef.fieldName, columnDef.headerText, columnDef.dataType);
            dataColumn.order = columnDef.order;
            dataColumn.width = columnDef.width;
            dataColumn.minWidth = columnDef.minWidth;
            dataColumn.maxWidth = columnDef.maxWidth;
            dataColumn.contentAlign = columnDef.contentAlign;
            dataColumn.headerTooltip = columnDef.headerTooltip;
            dataColumn.resizable = columnDef.resizable;
            dataColumn.draggable = columnDef.draggable;
            dataColumn.locked = columnDef.locked;
            dataColumn.visible = columnDef.visible;
            dataColumn.sortable = columnDef.sortable;
            dataColumn.filterable = columnDef.filterable;
            dataColumn.editable = columnDef.editable;
            dataColumn.groupable = columnDef.groupable;
            dataColumn.displayMenu = columnDef.displayMenu;
            dataColumn.panel = this.panel;
            if (columnDef.getValue) {
                dataColumn.getValue = columnDef.getValue;
            }
            if (columnDef.setValue) {
                dataColumn.setValue = columnDef.setValue;
            }
            let dataSlot = this.gridFactoryMeshSlots.createDikeDataColumnMeshSlot(dataColumn);
            // If the given data column is a cloned column, take the existing slotId. Otherwise, generate a new UUID:
            dataSlot.slotId = columnDef.slotId !== null && columnDef.slotId !== undefined ? columnDef.slotId : generateUUID();
            // Store the group id which data slot belongs to:
            dataSlot.belongToGroup = belongToGroup;
            dataSlot.dikeGutterSlot.belongToGroup = belongToGroup;
            // Since the given column is a data column, its display status will always be OPEN:
            dataSlot.displayStatus = 'open';
            // Data columns can never change its display status:
            dataSlot.canChangeDisplayStatus = false;
            // It does not matter if the given column is a cloned or new column, it always have the initial display-on value:
            dataSlot.initialDisplayOn = columnDef.displayOn;
            // Add the data column which is a leaf in the tree (children equals null):
            currentLevelList.insert(dataSlot, null);
            // Is the columnDef a cloned column?
            if (columnDef.slotId !== null && columnDef.slotId !== undefined && columnDef.slotId.trim() !== '') {
                // Is the cloned column sorted?
                if (this.sortDispatcher.isColumnActiveSortable(columnDef.columnId)) {
                    // Set the new sorting active key with dataColumn.columnId value:
                    this.sortDispatcher.updateActiveSortable(dataColumn.columnId);
                }
                // Remove previous sortables. From the UI, MatSort directive will add the new sortable for the new dataColumn.columnId:
                this.sortDispatcher.removeSortable(columnDef.columnId);
                this.sortDispatcher.removeSortable(this.sortDispatcher.getSortAlternativeColumnId(columnDef.columnId));
                // Silently, remove and set filterability, meaning not sending register and deregister events:
                if (dataColumn.filterable) {
                    this.gridFilterConfig.cloneFilterable(columnDef.columnId, dataColumn.columnId);
                }
                // Now for row-filter:
                if (this.gridFilterConfig.allowRowFilter) {
                    this.gridFilterConfig.cloneFilterable(this.gridFilterConfig.getRowFilterColumnId(columnDef.columnId), this.gridFilterConfig.getRowFilterColumnId(dataColumn.columnId));
                }
                /**
                 * Editable column.
                 *
                 *    1.  It does not matter if the cloned column is editable or not. The edition field
                 *        settings must be saved because during execution the column could become editable.
                 *
                 *    2.  Same as before, the edition template must be save for later use. A cloned
                 *        column always has an edition template either one defined by the user or
                 *        the default template.
                 */
                // Assign the edition field settings, if they were provided:
                if (!!columnDef.editionSettings) {
                    dataSlot.editionSettings = Object.assign({}, columnDef.editionSettings);
                }
                /**
                 * Then get its edition template:
                 *
                 * Cloned columns come from an instance of DkColumnMeshSlot.
                 * A DkColumnMeshSlot instance will always hold a TemplateRef<any> reference. This
                 * reference could be one defined by the user or the default one. Therefore,
                 * the cast done below is always valid.
                 */
                dataSlot.editionTemplate = columnDef.editionTemplate;
                /**
                 * Then get its display template:
                 *
                 * Cloned columns come from an instance of DkColumnMeshSlot.
                 * A DkColumnMeshSlot instance will always hold a TemplateRef<any> reference. This
                 * reference could be one defined by the user or the default one. Therefore,
                 * the cast done below is always valid.
                 */
                dataSlot.displayTemplate = columnDef.displayTemplate;
            }
            else {
                // The new column has an initial filter:
                if (dataColumn.filterable) {
                    this.setColumnSlotFilterability(dataSlot, dataColumn.filterable, columnDef.filter, columnDef.customFilterConditions);
                }
                /**
                 * Editable.
                 *
                 * It does not matter if the given new column is not editable. If the user
                 * has defined its own template, that template is going to be stored in the
                 * corresponding data slot.
                 *
                 * Consider that the user wants to provide its own template and at a later time
                 * execution the given new column will be editable. Then, the column will take
                 * the user-defined template.
                 *
                 * Set or merge the edition settings for the given column.
                 * If the given column does not have an edition template, its corresponding default
                 * template will be assigned.
                 */
                // Get the edition settings:
                dataSlot.editionSettings = this.gridEditionConfig.getEditionSettings(columnDef.dataType, dataSlot.editionSettings, columnDef.editionSettings);
                // Assing the edition template:
                if (!!columnDef.editionTemplate) {
                    /**
                     * New columns come from the UI (DikeGridColumn component) or those defined by an
                     * intance of type DkDataColumnDef.
                     *
                     * The only place where the user could define an Observable waiting for the template is
                     * from an intance of type DkDataColumnDef.
                     */
                    if (columnDef.editionTemplate instanceof Observable) {
                        columnDef.editionTemplate.pipe(take(1)).subscribe(value => {
                            if (!!value) {
                                dataSlot.editionTemplate = value;
                            }
                            else {
                                Promise.resolve().then(() => {
                                    /**
                                     * IMPORTANT:
                                     *
                                     * When getting the default edition template for a new column, the merged
                                     * edition settings must be provided because those settings have the correct
                                     * options.
                                     */
                                    dataSlot.editionTemplate = this.gridEditionConfig.getDefaultEditionTemplate(columnDef.dataType, dataSlot.editionSettings);
                                });
                            }
                        });
                    }
                    else {
                        dataSlot.editionTemplate = columnDef.editionTemplate;
                    }
                }
                else {
                    /**
                     * IMPORTANT:
                     *
                     * Remember that default templates are queried in the DikeGrid component. Those templates are
                     * available in ngAfterViewInit() life cycle hook. Therefore, template assigment must be done at
                     * the end of the current event-loop.
                     */
                    Promise.resolve().then(() => {
                        dataSlot.editionTemplate = this.gridEditionConfig.getDefaultEditionTemplate(columnDef.dataType, dataSlot.editionSettings);
                    });
                }
                // Assign the display template:
                if (!!columnDef.displayTemplate) {
                    /**
                     * New columns come from the UI (DikeGridColumn component) or those defined by an
                     * intance of type DkDataColumnDef.
                     *
                     * The only place where the user could define an Observable waiting for the template is
                     * from an intance of type DkDataColumnDef.
                     */
                    if (columnDef.displayTemplate instanceof Observable) {
                        columnDef.displayTemplate.pipe(take(1)).subscribe(value => {
                            if (!!value) {
                                dataSlot.displayTemplate = value;
                            }
                            else {
                                Promise.resolve().then(() => {
                                    dataSlot.displayTemplate = this.gridConfig.getDefaultDisplayTemplate(columnDef.dataType);
                                });
                            }
                        });
                    }
                    else {
                        dataSlot.displayTemplate = columnDef.displayTemplate;
                    }
                }
                else {
                    /**
                     * IMPORTANT:
                     *
                     * Remember that default templates are queried in the DikeGrid component. Those templates are
                     * available in ngAfterViewInit() life cycle hook. Therefore, template assigment must be done at
                     * the end of the current event-loop.
                     */
                    Promise.resolve().then(() => {
                        dataSlot.displayTemplate = this.gridConfig.getDefaultDisplayTemplate(columnDef.dataType);
                    });
                }
            }
            return dataSlot;
        }
        else {
            throw new Error(`Error from DkColumnStructure - The given column with fieldName: ${columnDef.fieldName} and headerText: ${columnDef.headerText} does not match to any valid DkColumnDef.`);
        }
    }
    /**
     * Panel-tree structure method.
     *
     * The method only accepts cloned columns.
     *
     * It is called recursively finding all the group and data columns that do not exist
     * in the destination panel inserting them into its corresponding level-list instance.
     *
     * @param {DkGroupColumnDef | DkDataColumnDef} columnDef The group or data column to be inserted into the panel list.
     *
     * @returns {void} No return value.
     */
    joinGroupColumnIntoList(columnDef, startingList) {
        if (columnDef.belongToGroup === null || columnDef.belongToGroup === undefined) {
            throw new Error(`Error from DkColumnStructure - Fatal. The joinGroupColumnIntoList method only accepts cloned columns (columnDef.belongToGroup can not be null or undefined).`);
        }
        // Given the DkColumnDef, retrieve the list instance where the column lives:
        let listInstance = startingList.getDikeColumnMeshListInstance(columnDef.belongToGroup);
        // Does the given DkColumnDef exists in the target list instance?
        if (listInstance.doesNodeSlotExist(columnDef.slotId, false)) {
            if (isDkGroupColumnDef(columnDef)) {
                if (columnDef.children && columnDef.children.length > 0) {
                    columnDef.children.forEach(child => this.joinGroupColumnIntoList(child, listInstance));
                }
                else {
                    throw new Error(`Error from DkColumnStructure - Fatal. The given group column with fieldName: ${columnDef.fieldName} and headerText: ${columnDef.headerText} already exists in the current panel ${this.panel} but it does not have children when it was expected it has.`);
                }
            }
            else {
                throw new Error(`Error from DkColumnStructure - Fatal. The given data column with fieldName: ${columnDef.fieldName} and headerText: ${columnDef.headerText} already exists in the current panel ${this.panel}.`);
            }
        }
        else {
            this.addColumnIntoList(columnDef, listInstance, columnDef.belongToGroup);
        }
    }
    clearFilterablesAndSortablesFromRemovedColumnSlot(columnDef) {
        /**
         * This method is invoked when a column has been removed, definitely:
         */
        if (isDkGroupColumnDef(columnDef) && columnDef.children && columnDef.children.length > 0) {
            // Iterate over every child column until reach the leaves (data column slots):
            columnDef.children.forEach(childColumn => this.clearFilterablesAndSortablesFromRemovedColumnSlot(childColumn));
            // Remember, only data columns could be filterables:
        }
        else if (isDkDataColumnDef(columnDef)) {
            // Remove context filters:
            this.removeFilterable(columnDef.columnId);
            // Remove row filter:
            this.removeFilterable(this.gridFilterConfig.getRowFilterColumnId(columnDef.columnId));
            // If the given data column is the active sorting, clear it:
            if (this.sortDispatcher.isColumnActiveSortable(columnDef.columnId)) {
                this.sortDispatcher.clearSorting();
            }
            // Remove from sortables:
            this.sortDispatcher.removeSortable(columnDef.columnId);
            this.sortDispatcher.removeSortable(this.sortDispatcher.getSortAlternativeColumnId(columnDef.columnId));
        }
    }
    addFilterable(filterable) {
        // If the given filterable already exists in the internal Map, it will be overwritten:
        this.gridFilterConfig.register(filterable);
    }
    removeFilterable(columnId) {
        if (this.gridFilterConfig.filterables.has(columnId)) {
            let filterable = this.gridFilterConfig.filterables.get(columnId);
            this.gridFilterConfig.deregister(filterable);
        }
    }
    changeListHeight(value) {
        this.listHeightSubject.next(value);
    }
    changeOuterColumnSlots() {
        // Before verifying group columns' display status, we MUST verify every column visibility:
        this.gridColumnMesh.verifyColumnVisibility();
        // After changing a column we must check if columns' display status are correct:
        this.gridColumnMesh.verifyGroupColumnDisplayStatus();
        this.changeListHeight(this.gridColumnMesh.calculateListVisibleHeight('open'));
        // Before delivering the changes, establish all the slot positions:
        let horizontalGutter = this.gridColumnMesh.setColumnMeshSlotPlacement('open', this.gridColumnMesh.greatestHeight, this.getOuterSlots(), this.scrollbarGapSlot);
        this.horizontalGutterSlotSubject.next(horizontalGutter);
        this.outerColumnSlotsSubject.next(this.getOuterSlots());
    }
    changeColSlots() {
        // Before verifying group columns' display status, we MUST verify every column visibility:
        this.gridColumnMesh.verifyColumnVisibility();
        // After changing a column we must check if columns' display status are correct:
        this.gridColumnMesh.verifyGroupColumnDisplayStatus();
        // Once a column was added / deleted / dragged, we have to get the new height of the root list:
        this.changeListHeight(this.gridColumnMesh.calculateListVisibleHeight('open'));
        // Before delivering the changes, establish all the slot positions:
        let horizontalGutter = this.gridColumnMesh.setColumnMeshSlotPlacement('open', this.gridColumnMesh.greatestHeight, this.getOuterSlots(), this.scrollbarGapSlot);
        this.horizontalGutterSlotSubject.next(horizontalGutter);
        this.colSlotsSubject.next(this.gridColumnMesh.getNodesInOrder('open'));
        this.dataColumnSlotsSubject.next(this.gridColumnMesh.getLeavesArray('open'));
        this.columnSetVisibilitySubject.next(this.gridColumnMesh.isColumnMeshVisible());
    }
    changeScrollbarGapSlot(value) {
        // Before verifying group columns' display status, we MUST verify every column visibility:
        this.gridColumnMesh.verifyColumnVisibility();
        // After changing a column we must check if columns' display status are correct:
        this.gridColumnMesh.verifyGroupColumnDisplayStatus();
        this.changeListHeight(this.gridColumnMesh.calculateListVisibleHeight('open'));
        // Before delivering the changes, establish all the slot positions:
        let horizontalGutter = this.gridColumnMesh.setColumnMeshSlotPlacement('open', this.gridColumnMesh.greatestHeight, this.getOuterSlots(), value);
        this.horizontalGutterSlotSubject.next(horizontalGutter);
        this.scrollbarGapSlotSubject.next(value);
    }
    changeGutterSlotOver(value) {
        this.gutterSlotOverSubject.next(value);
    }
    changeGutterSlotResized(value) {
        this.gutterSlotResizingSubject.next(value);
    }
    changePanelResized(value) {
        this.panelResizingSubject.next(value);
    }
    emitColumnResizing(columnSlot) {
        // Only Data Columns can change its width:
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.columnResizedSubject.next(this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot));
        }
    }
}

class PreOrderDkColumnMesh extends DkColumnMesh {
    constructor(rightOuterGutterSlot, belongToGroupId) {
        super(belongToGroupId);
        this.rightOuterGutterSlot = rightOuterGutterSlot;
        this.rightOuterGutterSlot.belongToGroup = this.belongToGroupId;
    }
    isComplementGutter(gutter) {
        return gutter.dikeColumn.columnId === this.rightOuterGutterSlot.dikeColumn.columnId;
    }
    getContentMeshTemplate(displayStatus, outerSlots) {
        return `${this.getOuterColumnSlotsTemplate(outerSlots)} ${this.getColumnSlotsTemplate(displayStatus)}`.trim();
    }
    getHeaderMeshTemplate(displayStatus, outerSlots, scrollbarGapSlot) {
        let scrollbarGapMesh = scrollbarGapSlot ? `${scrollbarGapSlot.dikeColumn.width}px` : '';
        return `${this.getOuterColumnSlotsTemplate(outerSlots)} ${this.getColumnSlotsTemplate(displayStatus)} ${scrollbarGapMesh}`.trim();
    }
    getEdgeGutters(displayStatus, isComplementGutter) {
        let edgeGutters = [];
        let visibleNode = isComplementGutter ? this.getLastVisibleNode(displayStatus) : this.getFirstVisibleNode(displayStatus);
        if (visibleNode) {
            edgeGutters.push(isComplementGutter ? visibleNode.value.complementDikeGutterSlot : visibleNode.value.dikeGutterSlot);
            if (visibleNode.children) {
                edgeGutters.push(...visibleNode.children.getEdgeGutters(displayStatus, isComplementGutter));
            }
        }
        return edgeGutters;
    }
    /**
     * Source column slot will be place before the destination gutter slot.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column slot.
     * @param {DkMeshSlot} destinationGutterSlot The destination gutter.
     *
     * @returns {boolean} True if the movement was done successfully.
     */
    swapToGutterSlotNode(sourceColumnSlot, destinationGutterSlot) {
        // sourceNode is searched in the linked-list because we need the node not the column slot:
        let sourceNode = this.getDikeColumnMeshSlotNode(sourceColumnSlot.dikeColumn.columnId);
        // Get the node which has the given gutter slot:
        let destinationNode = destinationGutterSlot && destinationGutterSlot.dikeColumn.columnType === 'Gutter-Column' ?
            this.getDikeColumnMeshSlotNode(destinationGutterSlot.dikeColumn.columnIdBelongTo) : null;
        if (sourceNode && destinationNode && sourceNode !== destinationNode &&
            sourceNode.value.belongToGroup === destinationNode.value.belongToGroup) {
            let contiguousNodes = this.areNodesContiguous(sourceNode, destinationNode);
            // The destination gutter is the complementDikeGutterSlot:
            if (destinationGutterSlot.dikeColumn.columnId === this.rightOuterGutterSlot.dikeColumn.columnId) {
                let isolatedNode = this.removeNode(sourceNode);
                this.insertNodeAfter(isolatedNode, destinationNode);
                return true;
            }
            else if (contiguousNodes.contiguous) {
                // Nodes are contiguous and the movement direction is towards the left:
                if (contiguousNodes.leftDestination) {
                    let isolatedNode = this.removeNode(sourceNode);
                    this.insertNodeBefore(isolatedNode, destinationNode);
                    return true;
                }
            }
            else {
                let isolatedNode = this.removeNode(sourceNode);
                this.insertNodeBefore(isolatedNode, destinationNode);
                return true;
            }
        }
        return false;
    }
    calculateContainerWidth(displayStatus, outerSlots, scrollbarGapSlot) {
        return this.calculateOuterColumnSlotsContainerWidth(outerSlots) +
            this.calculateColumnSlotsMeshContainerWidth(displayStatus) +
            (scrollbarGapSlot ? scrollbarGapSlot.dikeColumn.width : 0);
    }
    setColumnMeshSlotPlacement(displayStatus, greatestHeight, outerSlots, scrollbarGapSlot) {
        /**
         * Before calculating slot positions set complementDikeGutterSlot property to
         * null and isFirst / isLast properties to false for every DkColumnMeshSlot
         * which lives in the list.
         */
        this.resetDikeColumnSlotGutters();
        // Set the first and last nodes in the whole tree:
        this.setFirstVisibleNodesInTree(displayStatus);
        this.setLastVisibleNodesInTree(displayStatus);
        // Then set the rightOuterGutterSlot:
        this.setComplementDikeGutterSlot(displayStatus);
        const gridColumnStart = 1;
        const gridRowStart = 1;
        // Calculate the positions for outer slots:
        let outerSpanCounter = this.calculateOuterColumnMeshSlotsPlacement(greatestHeight, gridColumnStart, gridRowStart, outerSlots);
        // Calculate the positions for every slot in the double-linked list:
        let columnSpanCounter = this.calculateColumnMeshSlotsPlacement(displayStatus, greatestHeight, gridColumnStart + outerSpanCounter, gridRowStart);
        // Calculate the position for the scrollbar gap:
        if (scrollbarGapSlot) {
            this.calculateScrollbarGapMeshSlotPlacement(greatestHeight, gridColumnStart + outerSpanCounter + columnSpanCounter, gridRowStart, scrollbarGapSlot);
        }
        /**
         * Get the first and the last visible descendant node:
         */
        let firstVisibleDescendantNode = null;
        // Get the last visible leaf:
        let lastVisibleDescendantNode = this.getLastVisibleNode(displayStatus, true);
        // If outerSpanCounter is greater than zero it means this panel has the outer slots:
        if (outerSpanCounter > 0) {
            // We create a node just to maintain variable compatibility:
            firstVisibleDescendantNode = this.createNode(outerSlots[0], null);
        }
        else {
            // Get the first visible leaf:
            firstVisibleDescendantNode = this.getFirstVisibleNode(displayStatus, true);
        }
        // Get all columnIds of the visible slots:
        this.getChildrenIds(displayStatus);
        // Then set sibling column ids per list in each node belonging the same list:
        this.spreadSiblingColumnIds(displayStatus);
        if (firstVisibleDescendantNode && lastVisibleDescendantNode) {
            return {
                gridColumnStart: firstVisibleDescendantNode.value.dikeGutterSlot ?
                    firstVisibleDescendantNode.value.dikeGutterSlot.slotPosition.gridColumnStart :
                    firstVisibleDescendantNode.value.slotPosition.gridColumnStart,
                gridColumnEnd: lastVisibleDescendantNode.value.complementDikeGutterSlot ?
                    lastVisibleDescendantNode.value.complementDikeGutterSlot.slotPosition.gridColumnStart + spanUnit :
                    lastVisibleDescendantNode.value.slotPosition.gridColumnStart + spanUnit,
                gridRowStart: greatestHeight * DkGridRowUnit,
                gridRowEnd: `span ${DkGridHorizontalGutterUnit}`
            };
        }
        return null;
    }
    calculateColumnSlotsMeshContainerWidth(displayStatus) {
        let columnsWidth = 0;
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    columnsWidth += current.children.calculateColumnSlotsMeshContainerWidth(current.value.displayStatus);
                }
                else {
                    if (current.value.dikeGutterSlot) {
                        columnsWidth += current.value.dikeGutterSlot.dikeColumn.width;
                    }
                    columnsWidth += current.value.dikeColumn.width;
                    if (current.value.complementDikeGutterSlot) {
                        columnsWidth += current.value.complementDikeGutterSlot.dikeColumn.width;
                    }
                }
            }
            current = current.next;
        }
        return columnsWidth;
    }
    calculateColumnMeshSlotsPlacement(displayStatus, currentHeight, gridColumnStart, gridRowStart) {
        /**
         * IMPORTANT:
         *
         * 1. Before traversing the tree in order to establish the slot positions,
         *    the following methods MUST be executed in the following order:
         *
         *      (a). verifyGroupColumnDisplayStatus();
         *      (b). calculateListVisibleHeight();
         *
         * 2. For the first invocation currentHeight will be the greatest height. Then
         *    we pass the children height for each level.
         */
        let current = this.headNode;
        let currentGridColumnStart = gridColumnStart;
        let spanCounter = 0;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    // Get the height of the current children list:
                    let childrenHeight = current.children.listHeight;
                    /**
                     * The current node is not a leaf then its grid-row-end will be given by:
                     *
                     * grid-row-end = (listHeight - childrenHeight) * DkGridRowUnit;
                     */
                    // currentGridRowTracks represents a complete row track:
                    let currentGridRowTracks = currentHeight - childrenHeight;
                    // currentGridRowEndSpan represents the actual span units the column group must grow:
                    let currentGridRowEndSpan = (currentHeight - childrenHeight) * DkGridRowUnit;
                    // The grid-column-end for a non-leaf node will be given by the sum of its children columns span:
                    let childrenSpan = current.children.calculateColumnMeshSlotsPlacement(current.value.displayStatus, childrenHeight, currentGridColumnStart, gridRowStart + currentGridRowEndSpan);
                    /**
                     * Determine how many horizontal spanUnits we have to substract in order
                     * to display the left and the right gutter:
                     *
                     * 1. Since we are in PreOrderDkColumnMesh instance, the left-gutter always
                     *    be visible.
                     *
                     * 2. It is going to be enough to verify the most-right gutter visibility. If the
                     *    column group is the last visible node in the list then it will have its
                     *    complementDikeGutterSlot property pointing to the rightOuterGutterSlot instance.
                     *    Therefore, we will substract 2 spanUnits, otherwise only 1 spanUnit.
                     */
                    let actualColumnGroupSpan = current.value.complementDikeGutterSlot ? childrenSpan - spanUnit * 2 : childrenSpan - spanUnit;
                    /**
                     * Column group Horizontal Gutter.
                     *
                     * The column group horizontal gutter will occupy the whole children span units
                     * including the children's gutters.
                     *
                     * 1. Horizontal position.
                     *    (a). grid-column-start. This will be given by the same grid-column-start of the column group.
                     *    (b). grid-column-end. It will be given in span units. The value will be the whole span units
                     *                          the children columns occupy.
                     *
                     * 2. Vertical position.
                     *    (a). grid-row-start. As we state in the main algorithm, it will be given by the previous
                     *         grid-row-start position plus the previous span units. Remember its previous slot is the
                     *         column group itself.
                     *    (b). grid-row-end. It will be one horizontal gutter unit.
                     */
                    current.value.horizontalGutter = {
                        gridColumnStart: currentGridColumnStart,
                        // gridColumnEnd: `span ${childrenSpan}`,
                        gridColumnEnd: currentGridColumnStart + childrenSpan,
                        gridRowStart: gridRowStart + currentGridRowEndSpan - DkGridHorizontalGutterUnit,
                        gridRowEnd: `span ${DkGridHorizontalGutterUnit}`
                    };
                    // Firstly, display the column group's left gutter:
                    if (current.value.dikeGutterSlot) {
                        current.value.dikeGutterSlot.slotPosition = {
                            gridColumnStart: currentGridColumnStart,
                            // gridColumnEnd: `span ${spanUnit}`,
                            gridColumnEnd: currentGridColumnStart + spanUnit,
                            gridRowStart: gridRowStart,
                            gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                        };
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.dikeGutterSlot.slotHeight = currentGridRowTracks;
                        // Then prepare the next grid-column-start:
                        currentGridColumnStart += spanUnit;
                    }
                    // Then display the column group:
                    current.value.slotPosition = {
                        gridColumnStart: currentGridColumnStart,
                        // gridColumnEnd: `span ${actualColumnGroupSpan}`,
                        gridColumnEnd: currentGridColumnStart + actualColumnGroupSpan,
                        gridRowStart: gridRowStart,
                        gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                    };
                    // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                    current.value.slotHeight = currentGridRowTracks;
                    // Prepare the next grid-column-start position:
                    currentGridColumnStart += actualColumnGroupSpan;
                    // Lastly, display the most- right gutter, if it has the instance:
                    if (current.value.complementDikeGutterSlot) {
                        current.value.complementDikeGutterSlot.slotPosition = {
                            gridColumnStart: currentGridColumnStart,
                            // gridColumnEnd: `span ${spanUnit}`,
                            gridColumnEnd: currentGridColumnStart + spanUnit,
                            gridRowStart: gridRowStart,
                            gridRowEnd: `span ${currentGridRowEndSpan - DkGridHorizontalGutterUnit}`
                        };
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.complementDikeGutterSlot.slotHeight = currentGridRowTracks;
                        currentGridColumnStart += spanUnit;
                    }
                    /**
                     * Since we did not modify the returned childrenSpan counter, that are the actual
                     * span tracks for the next grid-column-start:
                     */
                    spanCounter += childrenSpan;
                }
                else {
                    let leafNodePosition = {
                        gridColumnStart: currentGridColumnStart,
                        gridColumnEnd: `span ${spanUnit}`,
                        gridRowStart: gridRowStart,
                        gridRowEnd: `span ${currentHeight * DkGridRowUnit - DkGridHorizontalGutterUnit}`
                    };
                    // Firstly, set the position for the column left gutter:
                    if (current.value.dikeGutterSlot) {
                        current.value.dikeGutterSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.dikeGutterSlot.slotHeight = currentHeight;
                        currentGridColumnStart += spanUnit;
                        spanCounter += spanUnit;
                    }
                    // Then update the slot position where the column lives:
                    current.value.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                    // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                    current.value.slotHeight = currentHeight;
                    currentGridColumnStart += spanUnit;
                    spanCounter += spanUnit;
                    // Lastly, check the most-right gutter:
                    if (current.value.complementDikeGutterSlot) {
                        current.value.complementDikeGutterSlot.slotPosition = Object.assign(Object.assign({}, leafNodePosition), { gridColumnStart: currentGridColumnStart, gridColumnEnd: currentGridColumnStart + spanUnit });
                        // slotHeight will be given by complete tracks. In the UI we have to substract the horizontal gutter height:
                        current.value.complementDikeGutterSlot.slotHeight = currentHeight;
                        currentGridColumnStart += spanUnit;
                        spanCounter += spanUnit;
                    }
                }
            }
            current = current.next;
        }
        return spanCounter;
    }
    getColumnSlotsTemplate(displayStatus) {
        let meshTemplate = '';
        let current = this.headNode;
        while (current) {
            if (current.value.dikeColumn.visible && current.value.currentDisplayOn === displayStatus) {
                if (current.children) {
                    meshTemplate += current.children.getColumnSlotsTemplate(current.value.displayStatus);
                }
                else {
                    // Firstly, draw the dikeGutterSlot first which represents the left-gutter for each column:
                    if (current.value.dikeGutterSlot) {
                        meshTemplate += `${current.value.dikeGutterSlot.dikeColumn.width}px `;
                    }
                    // Then, draw the column itself:
                    meshTemplate += `${current.value.dikeColumn.width}px `;
                    /**
                     * Lastly, draw the right-outer-gutter:
                     *
                     * The method setComplementDikeGutterSlot() will mark all the nodes
                     * which belong to the last visible branch. Therefore, it does not
                     * matter if we evaluate the complementDikeGutterSlot for each leaf,
                     * only the last visible node for each level will have the most-rightOuterGutterSlot
                     * instance.
                     */
                    if (current.value.complementDikeGutterSlot) {
                        meshTemplate += `${current.value.complementDikeGutterSlot.dikeColumn.width}px `;
                    }
                }
            }
            current = current.next;
        }
        return meshTemplate;
    }
    setComplementDikeGutterSlot(displayStatus) {
        let lastVisibleNode = this.getLastVisibleNode(displayStatus);
        this.rightOuterGutterSlot.dikeColumn.columnIdBelongTo = '';
        if (lastVisibleNode) {
            this.rightOuterGutterSlot.dikeColumn.columnIdBelongTo = lastVisibleNode.value.dikeColumn.columnId;
            lastVisibleNode.value.complementDikeGutterSlot = this.rightOuterGutterSlot;
            if (lastVisibleNode.children) {
                lastVisibleNode.children.setComplementDikeGutterSlot(lastVisibleNode.value.displayStatus);
            }
        }
    }
}

class GroupDkColumnMesh extends InOrderDkColumnMesh {
    constructor(leftOuterGutterSlot, belongToGroupId) {
        super(leftOuterGutterSlot, belongToGroupId);
    }
    insert(value, children) {
        this.append(value, children);
    }
}

class DkGroupColumnStructure extends DkColumnStructure {
    constructor(panel, dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig) {
        super(panel, dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig);
        this.dataColumnDefIdentities = new Map();
        this.gridTemplateColumnsGroupSubject = new BehaviorSubject('');
    }
    get onGridTemplateColumnsGroupChanged$() {
        return this.gridTemplateColumnsGroupSubject.asObservable();
    }
    // The method returns columns that are not groupable:
    addColumn(dataColumn) {
        let dataSlot = this.addColumnIntoList(dataColumn, this.gridColumnMesh, ROOT_GROUP_ID);
        this.changeColSlots();
        this.changeGridTemplateColumns();
        return dataSlot;
    }
    addColumnsFromPanel(columns) {
        if (!!columns && columns.length > 0) {
            columns.forEach(dataColumn => {
                // All columns should have been cloned and must exist in the Indentities-Map variable:
                if (dataColumn.slotId && dataColumn.belongToGroup &&
                    dataColumn.panel !== this.panel && this.dataColumnDefIdentities.has(dataColumn.slotId)) {
                    this.addColumnIntoList(dataColumn, this.gridColumnMesh, ROOT_GROUP_ID);
                }
            });
            this.changeColSlots();
            this.changeGridTemplateColumns();
        }
    }
    cloneColumnSlotForMoving(columnSlot, destinationSlot) {
        // The given column slot must belong to the group panel and must be a data column:
        if (columnSlot.dikeColumn.panel === this.panel && columnSlot.dikeColumn.columnType === 'Data-Column') {
            // The given column slot must be stored in the Map structure called this.dataColumnDefIdentities:
            if (this.dataColumnDefIdentities.has(columnSlot.slotId)) {
                // Clone the data column from the linked-list instance:
                let dataColumnDef = this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot);
                // Retrieve the identity of the given column slot:
                let dataSlotInfo = this.dataColumnDefIdentities.get(columnSlot.slotId);
                if (isDkGroupColumnDef(dataSlotInfo.branch)) {
                    // Copy the original displayOn property:
                    dataColumnDef.displayOn = dataSlotInfo.leafDataColumnDef.displayOn;
                    // Update the branch including its leaf:
                    dataSlotInfo.leafDataColumnDef = dataColumnDef;
                    dataSlotInfo.leafParent.children[0] = dataSlotInfo.leafDataColumnDef;
                    dataSlotInfo.leafDataColumnDef.belongToGroup = dataSlotInfo.leafParent.slotId;
                    dataSlotInfo.branch.panel = 'groupPanel';
                    return this.gridFactoryColumns.cloneDikeGroupColumnDef(dataSlotInfo.branch);
                }
                else if (isDkDataColumnDef(dataSlotInfo.branch)) {
                    // Copy the original displayOn property:
                    dataColumnDef.displayOn = dataSlotInfo.leafDataColumnDef.displayOn;
                    dataSlotInfo.leafDataColumnDef = dataColumnDef;
                    dataSlotInfo.branch = dataColumnDef;
                    return this.gridFactoryColumns.cloneDikeDataColumnDef(dataSlotInfo.leafDataColumnDef);
                }
            }
            throw new Error(`Error from DkGroupColumnStructure - The given column slot (${columnSlot.dikeColumn.fieldName} - ${columnSlot.dikeColumn.headerText}) is not stored in the internal Map structure.`);
        }
        throw new Error(`Error from DkGroupColumnStructure - The given column slot (${columnSlot.dikeColumn.fieldName} - ${columnSlot.dikeColumn.headerText}) can not be cloned because it does not belong to the current panel (${this.panel}).`);
    }
    removeClonedColumnSlot(columnSlot, notifyChanges = true) {
        // Remove the column slot from the group panel linked-list:
        let removedColumnDef = super.removeClonedColumnSlot(columnSlot, notifyChanges);
        // Delete the entry from the slot-identities Map structure:
        if (this.dataColumnDefIdentities.has(removedColumnDef.slotId)) {
            this.dataColumnDefIdentities.delete(removedColumnDef.slotId);
        }
        return removedColumnDef;
    }
    createChildrenList(panel, belongToGroupId) {
        return new GroupDkColumnMesh(this.gridFactoryMeshSlots.createDikeGutterMeshSlot(panel, panel), belongToGroupId);
    }
    getOuterSlots() {
        return [];
    }
    changeGridTemplateColumns() {
        this.gridTemplateColumnsGroupSubject.next(this.gridColumnMesh.getContentMeshTemplate('open', this.getOuterSlots()));
        this.containerWidthSubject.next(this.gridColumnMesh.calculateContainerWidth('open', this.getOuterSlots(), this.scrollbarGapSlot));
    }
}

class DkContentColumnStructure extends DkColumnStructure {
    constructor(panel, dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig) {
        super(panel, dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig);
        this.changeClearFilterSubscription = Subscription.EMPTY;
        this.changeEditionStateSubscription = Subscription.EMPTY;
        this.dataSourceIndexSlot = null;
        this.dataSourceIndexSlotSubject = new BehaviorSubject(this.dataSourceIndexSlot);
        this.gridTemplateColumnsContentSubject = new BehaviorSubject('');
        this.gridTemplateColumnsHeaderSubject = new BehaviorSubject('');
        this.columnGroupStatusSubject = new Subject();
        this.columnLockedSubject = new Subject();
        this.columnUnLockedSubject = new Subject();
        this.columnVisibleSubject = new Subject();
        this.setChangeClearFilterSubscription();
        this.setChangeEditionStateSubscription();
    }
    destroy() {
        this.changeClearFilterSubscription.unsubscribe();
        this.changeEditionStateSubscription.unsubscribe();
    }
    get onDataSourceIndexSlotChanged$() {
        return this.dataSourceIndexSlotSubject.asObservable();
    }
    get onGridTemplateColumnsContentChanged$() {
        return this.gridTemplateColumnsContentSubject.asObservable();
    }
    get onGridTemplateColumnsHeaderChanged$() {
        return this.gridTemplateColumnsHeaderSubject.asObservable();
    }
    get onColumnGroupStatusChanged$() {
        return this.columnGroupStatusSubject.asObservable();
    }
    get onColumnLockedChanged$() {
        return this.columnLockedSubject.asObservable();
    }
    get onColumnUnLockedChanged$() {
        return this.columnUnLockedSubject.asObservable();
    }
    get onColumnVisibleChanged$() {
        return this.columnVisibleSubject.asObservable();
    }
    setRowIndexColumnSlot(visible, width = 0) {
        this.dataSourceIndexSlot = null;
        if (visible) {
            this.dataSourceIndexSlot = this.gridFactoryMeshSlots.createDikeRowIndexMeshSlot(this.panel, width);
        }
        this.changeDataSourceIndexSlot(this.dataSourceIndexSlot);
        this.changeOuterColumnSlots();
        this.changeGridTemplateColumns();
    }
    /**
     * Panel-tree structure method.
     *
     * This method is used for inserting new columns or cloned ones.
     * To differentiate a cloned column its slotId and its belongToGroup fields will not be null.
     *
     * If the given DkColumnDef is a cloned column, then the joinColumnGroup(...) method is called.
     * Otherwise, the column is treat as a new column and addColumnIntoList(...) method is called instead.
     *
     * @param {string} columnDef The column which will be inserted in the panel tree.
     *
     * @returns {void} No return value.
     */
    addColumn(columnDef) {
        // The given DkColumnDef is a cloned column:
        if (columnDef.slotId && columnDef.belongToGroup) {
            this.joinGroupColumnIntoList(columnDef, this.gridColumnMesh);
        }
        else {
            // Insert the given DkColumnDef in the panel tree as a new column:
            this.addColumnIntoList(columnDef, this.gridColumnMesh, ROOT_GROUP_ID);
        }
        this.changeColSlots();
        this.changeGridTemplateColumns();
    }
    addColumnsFromPanel(columns) {
        if (!!columns && columns.length > 0) {
            columns.forEach(columnDef => {
                // The given columns should have been cloned:
                if (columnDef.slotId && columnDef.belongToGroup && columnDef.panel !== this.panel) {
                    this.joinGroupColumnIntoList(columnDef, this.gridColumnMesh);
                }
            });
            this.changeColSlots();
            this.changeGridTemplateColumns();
        }
    }
    cloneColumnSlotForMoving(columnSlot, destinationPanel) {
        // If destination panel is the groupPanel, return the whole branch:
        if (destinationPanel instanceof DkGroupColumnStructure) {
            return this.cloneColumnSlot(columnSlot, true);
        }
        else if (destinationPanel instanceof DkContentColumnStructure) {
            /**
             * If the destination panel is any of the Content panels:
             *
             *  1.  If the column's group exists in destination panel, only the partial branch will
             *      be cloned, from the given column until the leaves.
             *
             *  2.  Otherwise, the whole branch will be cloned until the root.
             */
            return this.cloneColumnSlot(columnSlot, !destinationPanel.doesGroupExist(columnSlot.belongToGroup));
        }
        return null;
    }
    setColumnSlotVisible(columnSlot, isVisible) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') {
            // The visibility change was successful:
            if (this.gridColumnMesh.setColumnMeshSlotVisible(columnSlot, isVisible)) {
                this.changeColSlots();
                this.changeGridTemplateColumns();
                // Emit the corresponding event:
                this.emitColumnVisible(columnSlot);
            }
        }
    }
    setColumnSlotEditable(columnSlot, isEditable, settings) {
        var _a;
        // Only data columns could be editables:
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            columnSlot.dikeColumn.editable = isEditable;
            // In order to assign the new edition configuration, editable flag MUST be true.
            if (isEditable && !!settings) {
                // Set or merge the edition settings for the given column:
                columnSlot.editionSettings = this.gridEditionConfig.getEditionSettings(columnSlot.dikeColumn.dataType, columnSlot.editionSettings, settings.editionSettings);
                // Set the edition template if it was provided:
                columnSlot.editionTemplate = (_a = settings.editionTemplate) !== null && _a !== void 0 ? _a : columnSlot.editionTemplate;
            }
            // Clone the given columnSlot to change the reference within the double linked-list:
            let cloneColumnMeshSlot = this.gridFactoryMeshSlots.cloneDikeColumnMeshSlot(columnSlot);
            // Change the reference with the cloned one:
            if (this.gridColumnMesh.changeColumnMeshSlotReference(columnSlot, cloneColumnMeshSlot)) {
                // Finally, notify the change:
                this.changeColSlots();
            }
        }
    }
    setColumnSlotGroupable(columnSlot, isGroupable) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            columnSlot.dikeColumn.groupable = isGroupable;
            this.changeColSlots();
        }
    }
    setDefaultEditionTemplateColumnSlot(columnSlot) {
        // Only data columns could be editables:
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            Promise.resolve().then(() => {
                /**
                 * IMPORTANT:
                 *
                 *    1.  Since this method could be invoked before the ngAfterViewInit life cycle hook
                 *        the assignment is done inside a promise scheduling its execution as a microtask.
                 *
                 *    2.  The edition settings for the given column slot must have been provided previously
                 *        because those settings have the correct options.
                 */
                columnSlot.editionTemplate = this.gridEditionConfig.getDefaultEditionTemplate(columnSlot.dikeColumn.dataType, columnSlot.editionSettings);
                // Clone the given columnSlot to change the reference within the double linked-list:
                let cloneColumnMeshSlot = this.gridFactoryMeshSlots.cloneDikeColumnMeshSlot(columnSlot);
                // Change the reference with the cloned one:
                if (this.gridColumnMesh.changeColumnMeshSlotReference(columnSlot, cloneColumnMeshSlot)) {
                    // Finally, notify the change:
                    this.changeColSlots();
                }
            });
        }
    }
    setDisplayTemplateColumnSlot(columnSlot, displayTemplate) {
        // Only data columns could have a display template:
        if (columnSlot.dikeColumn.columnType === 'Data-Column' && !!displayTemplate) {
            columnSlot.displayTemplate = displayTemplate;
            // Clone the given columnSlot to change the reference within the double linked-list:
            let cloneColumnMeshSlot = this.gridFactoryMeshSlots.cloneDikeColumnMeshSlot(columnSlot);
            // Change the reference with the cloned one:
            if (this.gridColumnMesh.changeColumnMeshSlotReference(columnSlot, cloneColumnMeshSlot)) {
                // Finally, notify the change:
                this.changeColSlots();
            }
        }
    }
    setDefaultDisplayTemplateColumnSlot(columnSlot) {
        // Only data columns could have a display template:
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            Promise.resolve().then(() => {
                /**
                 * IMPORTANT:
                 *
                 *  Since this method could be invoked before the ngAfterViewInit life cycle hook
                 *  the assignment is done inside a promise scheduling its execution as a microtask.
                 */
                columnSlot.displayTemplate = this.gridConfig.getDefaultDisplayTemplate(columnSlot.dikeColumn.dataType);
                // Clone the given columnSlot to change the reference within the double linked-list:
                let cloneColumnMeshSlot = this.gridFactoryMeshSlots.cloneDikeColumnMeshSlot(columnSlot);
                // Change the reference with the cloned one:
                if (this.gridColumnMesh.changeColumnMeshSlotReference(columnSlot, cloneColumnMeshSlot)) {
                    // Finally, notify the change:
                    this.changeColSlots();
                }
            });
        }
    }
    setColumnSlotDraggable(columnSlot, isDraggable) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') {
            columnSlot.dikeColumn.draggable = isDraggable;
            this.changeColSlots();
        }
    }
    setColumnSlotLocking(columnSlot, isLocked) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') {
            columnSlot.dikeColumn.locked = isLocked;
            this.changeColSlots();
            // Emit the column that changed its locked property:
            if (columnSlot.dikeColumn.locked) {
                this.emitColumnLocking(columnSlot);
            }
            else {
                this.emitColumnUnLocking(columnSlot);
            }
        }
    }
    setColumnSlotResizable(columnSlot, isResizable) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') {
            columnSlot.dikeColumn.resizable = isResizable;
            this.changeColSlots();
        }
    }
    changeColumnSlotWidth(columnSlot, columnSize) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            columnSlot.dikeColumn.width = columnSize.width > 0 ? columnSize.width : this.dikeConfig.COLUMN_WIDTH;
            // Establish the new value for minWidth depending on the new width value:
            columnSlot.dikeColumn.minWidth = columnSlot.dikeColumn.minWidth < columnSlot.dikeColumn.width ?
                columnSlot.dikeColumn.minWidth : columnSlot.dikeColumn.width;
            // Establish the new value for minWidth depending on the new width value:
            columnSlot.dikeColumn.maxWidth = columnSlot.dikeColumn.maxWidth > columnSlot.dikeColumn.width ?
                columnSlot.dikeColumn.maxWidth : columnSlot.dikeColumn.width;
            // Set the provided minWidth:
            if (columnSize.minWidth !== null && columnSize.minWidth !== undefined) {
                columnSlot.dikeColumn.minWidth = columnSize.minWidth < columnSlot.dikeColumn.width ? columnSize.minWidth : columnSlot.dikeColumn.width;
            }
            // Set the provided maxWidth:
            if (columnSize.maxWidth !== null && columnSize.maxWidth !== undefined) {
                columnSlot.dikeColumn.maxWidth = columnSize.maxWidth > columnSlot.dikeColumn.width ? columnSize.maxWidth : columnSlot.dikeColumn.width;
            }
            this.changeColSlots();
            // Emit the column that changed its size:
            this.emitColumnResizing(columnSlot);
        }
    }
    setDisplayStatusToColumnSlotGroup(columnId, displayStatus) {
        let columnSlotGroup = this.gridColumnMesh.getDikeColumnMeshSlot(columnId);
        if (columnSlotGroup && columnSlotGroup.dikeColumn.columnType === 'Group-Column') {
            if (columnSlotGroup.displayStatus !== displayStatus) {
                columnSlotGroup.displayStatus = displayStatus;
                this.changeColSlots();
                this.changeGridTemplateColumns();
                // Emit the status change:
                this.emitColumnGroupStatusChanging(columnSlotGroup);
            }
        }
    }
    setColumnSlotSortable(columnSlot, isSortable) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            columnSlot.dikeColumn.sortable = isSortable;
            /**
             * If the the DikeGrid instance is sorted by the given data column and
             * we are going to make it non-sortable, clear the current sorting.
             */
            if (!isSortable && this.sortDispatcher.isColumnActiveSortable(columnSlot.dikeColumn.columnId)) {
                this.sortDispatcher.clearSorting();
            }
            this.changeColSlots();
        }
    }
    changeColumnSlotFilter(columnSlot, newFilter) {
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column' &&
            columnSlot.dikeColumn.filterable && newFilter && newFilter.length > 0) {
            // Retrieve the filterable from the Map structure:
            let filterable = this.gridFilterConfig.filterables.get(columnSlot.dikeColumn.columnId);
            // If the filterable exists means that the column was regsitered in the Map structure:
            if (!!filterable) {
                // Send the filter to be applied:
                this.gridFilterConfig.applyFilter(Object.assign(Object.assign({}, filterable), { filter: [...newFilter] }));
                // Finally, notify the change:
                this.changeColSlots();
            }
        }
    }
    createChildrenList(panel, belongToGroupId) {
        return panel === 'rightPanel' ?
            new PreOrderDkColumnMesh(this.gridFactoryMeshSlots.createDikeGutterMeshSlot(panel, panel), belongToGroupId) :
            new InOrderDkColumnMesh(this.gridFactoryMeshSlots.createDikeGutterMeshSlot(panel, panel), belongToGroupId);
    }
    getOuterSlots() {
        let outerSlots = [];
        if (this.dataSourceIndexSlot) {
            outerSlots.push(this.dataSourceIndexSlot);
        }
        return outerSlots;
    }
    changeGridTemplateColumns() {
        this.gridTemplateColumnsContentSubject.next(this.gridColumnMesh.getContentMeshTemplate('open', this.getOuterSlots()));
        this.gridTemplateColumnsHeaderSubject.next(this.gridColumnMesh.getHeaderMeshTemplate('open', this.getOuterSlots(), this.scrollbarGapSlot));
        this.containerWidthSubject.next(this.gridColumnMesh.calculateContainerWidth('open', this.getOuterSlots(), this.scrollbarGapSlot));
    }
    emitColumnGroupStatusChanging(columnSlot) {
        // Only column Groups can change its status:
        if (columnSlot.dikeColumn.columnType === 'Group-Column') {
            this.columnGroupStatusSubject.next(this.cloneColumnSlot(columnSlot, false));
        }
    }
    emitColumnLocking(columnSlot) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.columnLockedSubject.next(this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot));
        }
        else if (columnSlot.dikeColumn.columnType === 'Group-Column') {
            // Emit only the group itself and its child columns:
            this.columnLockedSubject.next(this.cloneColumnSlot(columnSlot, false));
        }
    }
    emitColumnUnLocking(columnSlot) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.columnUnLockedSubject.next(this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot));
        }
        else if (columnSlot.dikeColumn.columnType === 'Group-Column') {
            // Emit only the group itself and its child columns:
            this.columnUnLockedSubject.next(this.cloneColumnSlot(columnSlot, false));
        }
    }
    emitColumnVisible(columnSlot) {
        if (columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.columnVisibleSubject.next(this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(columnSlot));
        }
        else if (columnSlot.dikeColumn.columnType === 'Group-Column') {
            // Emit only the group itself and its child columns:
            this.columnVisibleSubject.next(this.cloneColumnSlot(columnSlot, false));
        }
    }
    changeDataSourceIndexSlot(value) {
        this.dataSourceIndexSlotSubject.next(value);
    }
    setChangeEditionStateSubscription() {
        this.changeEditionStateSubscription.unsubscribe();
        /**
         * Every time the user change the view (edition or normal), the DkDataColumnDef Array from the
         * Behavior subject of the DkGridColumnDef service will be updated, due to the
         * changeColSlots() invocation.
         *
         * With the previous update, when the user invoke the findColumn() or findNode() method,
         * the user will have the latest set of the DkDataColumnDef Array.
         */
        this.changeEditionStateSubscription = this.gridEditionConfig.onEditionFilterStateChanged$.subscribe(() => this.changeColSlots());
    }
    setChangeClearFilterSubscription() {
        const clearFilter$ = merge(this.gridFilterConfig.clearFilterEmitter.asObservable(), this.gridFilterConfig.clearEditionFilterEmitter.asObservable());
        this.changeClearFilterSubscription.unsubscribe();
        /**
         * Every time the user clear the filters, the DkDataColumnDef Array from the
         * Behavior subject of the DkGridColumnDef service will be updated, due to the
         * changeColSlots() invocation.
         *
         * With the previous update, when the user invoke the findColumn() or findNode() method,
         * the user will have the latest set of the DkDataColumnDef Array.
         */
        this.changeClearFilterSubscription = clearFilter$.subscribe(() => this.changeColSlots());
    }
}

class DkPanelDispatcher {
    constructor(panelInstances) {
        this.panelInstances = panelInstances;
        this.changesListHeightSubscription = Subscription.EMPTY;
        this.changesColumnSlotsSubscription = Subscription.EMPTY;
        this.changesDataColumnSlotsSubscription = Subscription.EMPTY;
        this.changesShareableDropElementsSubscription = Subscription.EMPTY;
        this.emitColumnsChangingSubscription = Subscription.EMPTY;
        // Insert the panels into the record variable:
        this.panels = {};
        this.panelInstances.forEach(panelInstance => this.panels[panelInstance.panel] = panelInstance);
        this.columnSlotsSubject = new BehaviorSubject([]);
        this.dataColumnSlotsSubject = new BehaviorSubject([]);
        this.columnsChangedEmitter = new EventEmitter();
        this.columnsRemovedEmitter = new EventEmitter();
        this.setEmitColumnsChangingSubscription();
    }
    destroy() {
        this.columnSlotsSubject.complete();
        this.dataColumnSlotsSubject.complete();
        this.shareableDropElementsSubject.complete();
        this.changesListHeightSubscription.unsubscribe();
        this.changesColumnSlotsSubscription.unsubscribe();
        this.changesDataColumnSlotsSubscription.unsubscribe();
        this.changesShareableDropElementsSubscription.unsubscribe();
        this.emitColumnsChangingSubscription.unsubscribe();
    }
    get onColumnSlotsChanged$() {
        return this.columnSlotsSubject.asObservable();
    }
    get onDataColumnSlotsChanged$() {
        return this.dataColumnSlotsSubject.asObservable();
    }
    get onShareDropElementsChanged$() {
        return this.shareableDropElementsSubject.asObservable();
    }
    cloneColumnSlot(columnSlot, lineOfAscent = false) {
        if (!!this.panels && !!this.panels[columnSlot.dikeColumn.panel]) {
            return this.panels[columnSlot.dikeColumn.panel].cloneColumnSlot(columnSlot, lineOfAscent);
        }
        return null;
    }
    removeColumnSlot(columns) {
        if (!Array.isArray(columns)) {
            columns = [columns];
        }
        let deletedColumns = [];
        columns.forEach(column => {
            // Search the given columnId in all panels, recursively if there are Group Columns in the list:
            let columnSlot = this.getColumnSlot(column.columnId);
            // The given columnId was found, and it must be either a DATA_COLUMN or a GROUP_COLUMN:
            if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
                columnSlot.dikeColumn.columnType === 'Group-Column')) {
                deletedColumns.push(this.panels[columnSlot.dikeColumn.panel].removeColumnSlot(columnSlot));
            }
        });
        const finalColumns = deletedColumns.filter(column => !!column);
        // There was actually deleted columns:
        if (finalColumns.length > 0) {
            this.columnsRemovedEmitter.emit(finalColumns);
        }
    }
    getColumnSlots() {
        return this.panelInstances
            .map(panel => panel.getColumnSlots())
            .reduce((accumSlots, slots) => [...accumSlots, ...slots], []);
    }
    getDataColumnSlots() {
        return this.panelInstances
            .map(panel => panel.getDataColumnSlots())
            .reduce((accumSlots, slots) => [...accumSlots, ...slots], []);
    }
    getAllDataColumnSlots() {
        return this.panelInstances
            .map(panel => panel.getAllDataColumnSlots())
            .reduce((accumSlots, slots) => [...accumSlots, ...slots], []);
    }
    doesDataColumnSlotExist(panel, slotId) {
        return this.panels[panel].getAllDataColumnSlots().find(dataSlot => dataSlot.slotId === slotId);
    }
    getColumnSlot(columnId) {
        let foundColumnSlot = null;
        for (let i = 0; i < this.panelInstances.length; i++) {
            foundColumnSlot = this.panelInstances[i].getColumnSlot(columnId);
            if (foundColumnSlot) {
                return foundColumnSlot;
            }
        }
        return foundColumnSlot;
    }
    getSlot(columnId) {
        let foundSlot = null;
        for (let i = 0; i < this.panelInstances.length; i++) {
            foundSlot = this.panelInstances[i].getSlot(columnId);
            if (foundSlot) {
                return foundSlot;
            }
        }
        return foundSlot;
    }
    getShareDropElementIds(panel, panelSlots) {
        let panelShareables = new Map();
        panelSlots.filter(slot => slot.dikeColumn.visible).forEach(slot => {
            if (!panelShareables.has(slot.belongToGroup)) {
                let currentDropElementIds = panel.getListDropppableIdsByBelongToGroupSlot(slot.belongToGroup);
                let groupDropElementIds = {};
                groupDropElementIds['source-column-container'] = [...currentDropElementIds['source-column-container']];
                groupDropElementIds['drop-swap-column-container'] = [...currentDropElementIds['drop-swap-column-container']];
                groupDropElementIds['drop-gutter-container'] = [...currentDropElementIds['drop-gutter-container']];
                groupDropElementIds['drop-border-container'] = [];
                panelShareables.set(slot.belongToGroup, groupDropElementIds);
            }
        });
        return panelShareables;
    }
    cleanInternalUseField(columns) {
        /**
         * This method is invoked only when a new set of columns are added.
         *
         * The given columns variable array is traversed.
         *
         * The most IMPORTANT reason is to delete the columnId, slotId and belongToGroup fields
         * which were necessary to populate the DkGridFactoryColumns.rootColumns array (when columns
         * are difined via the UI). Or these fields could have been set by the user.
         *
         * We have to set those fields to null because we will use them to differentiate new columns from
         * CLONED columns.
         *
         * Remember, when we move a column to different panel, we have to clone the column we
         * are moving.
         */
        columns.forEach(columnDef => {
            columnDef.slotId = null;
            columnDef.belongToGroup = null;
            columnDef.columnId = null;
            if (isDkGroupColumnDef(columnDef) && columnDef.children && columnDef.children.length > 0) {
                this.cleanInternalUseField(columnDef.children);
            }
        });
    }
    setEmitColumnsChangingSubscription() {
        const columnSlots$ = this.onColumnSlotsChanged$.pipe(map(slots => {
            let columns = [];
            // Only get root columns, then clone each one until the leaves:
            slots
                .filter(slot => slot.belongToGroup === ROOT_GROUP_ID)
                .forEach(slot => columns.push(this.cloneColumnSlot(slot)));
            return columns;
        }));
        this.emitColumnsChangingSubscription.unsubscribe();
        this.emitColumnsChangingSubscription = columnSlots$.subscribe(value => this.columnsChangedEmitter.emit(value));
    }
}

class DkGridFactoryMeshSlots {
    constructor(gridFactoryColumns) {
        this.gridFactoryColumns = gridFactoryColumns;
    }
    createDikeGutterMeshSlot(panel, fieldName) {
        return new DkGutterMeshSlot(this.gridFactoryColumns.createDikeGutterColumn(panel, fieldName));
    }
    createDikeRowIndexMeshSlot(panel, width) {
        return this.createDikeColumnMeshSlot(this.gridFactoryColumns.createDikeRowIndexColumn(panel, width), this.gridFactoryColumns.createDikeGutterColumn(panel, 'Row-Index-Column'));
    }
    createDikeScrollbarGapMeshSlot(panel, width) {
        return this.createDikeColumnMeshSlot(this.gridFactoryColumns.createDikeScrollbarGapColumn(panel, width));
    }
    createDikeDataColumnMeshSlot(dikeDataColumn) {
        let newColumn = this.gridFactoryColumns.createDikeDataColumn(dikeDataColumn.fieldName, dikeDataColumn.headerText, dikeDataColumn.dataType);
        newColumn.columnId = dikeDataColumn.columnId;
        return this.createDikeColumnMeshSlot(newColumn.assign(dikeDataColumn), this.gridFactoryColumns.createDikeGutterColumn(dikeDataColumn.panel, dikeDataColumn.fieldName));
    }
    createDikeGroupColumnMeshSlot(dikeGroupColumn) {
        let newColumn = this.gridFactoryColumns.createDikeGroupColumn(dikeGroupColumn.fieldName, dikeGroupColumn.headerText);
        newColumn.columnId = dikeGroupColumn.columnId;
        return this.createDikeColumnMeshSlot(newColumn.assign(dikeGroupColumn), this.gridFactoryColumns.createDikeGutterColumn(dikeGroupColumn.panel, dikeGroupColumn.fieldName));
    }
    cloneDikeColumnMeshSlot(columnSlot) {
        /**
         * This method is invoked only when a DkColumnMeshSlot reference must be changed.
         *
         * A DkColumnMeshSlot must be changed when:
         *
         * The user change the edition or display template for the given
         * columnSlot. This reference changing must be done because any of
         * the templates are read via its corresponding pipe.
         */
        if (columnSlot.dikeColumn instanceof DkDataColumn) {
            let dataColumn = this.gridFactoryColumns.createDikeDataColumn(columnSlot.dikeColumn.fieldName, columnSlot.dikeColumn.headerText, columnSlot.dikeColumn.dataType).assign(columnSlot.dikeColumn);
            dataColumn.columnId = columnSlot.dikeColumn.columnId;
            let dataSlot = this.createDikeDataColumnMeshSlot(dataColumn);
            dataSlot.slotId = columnSlot.slotId;
            dataSlot.belongToGroup = columnSlot.belongToGroup;
            dataSlot.dikeGutterSlot.belongToGroup = columnSlot.belongToGroup;
            // Since the given column is a data column, its display status will always be OPEN:
            dataSlot.displayStatus = 'open';
            // Data columns can never change its display status:
            dataSlot.canChangeDisplayStatus = false;
            // It does not matter if the given column is a cloned or new column, it always have the initial display-on value:
            dataSlot.initialDisplayOn = columnSlot.initialDisplayOn;
            // Assign the edition field settings, if they were provided:
            if (!!columnSlot.editionSettings) {
                dataSlot.editionSettings = Object.assign({}, columnSlot.editionSettings);
            }
            /**
             * Then get its edition template:
             *
             * Cloned columns come from an instance of DkColumnMeshSlot.
             * A DkColumnMeshSlot instance will always hold a TemplateRef<any> reference. This
             * reference could be defined by the user or the default one.
             */
            dataSlot.editionTemplate = columnSlot.editionTemplate;
            /**
             * Then get its display template:
             *
             * Cloned columns come from an instance of DkColumnMeshSlot.
             * A DkColumnMeshSlot instance will always hold a TemplateRef<any> reference. This
             * reference could be defined by the user or the default one.
             */
            dataSlot.displayTemplate = columnSlot.displayTemplate;
            return dataSlot;
        }
        else {
            throw new Error('Error from DkGridFactoryColumns - Only DkDataColumn<T, unknown> are allowed to be cloned.');
        }
    }
    createDikeColumnMeshSlot(dikeColumn, dikeGutterColumn = null) {
        if (dikeColumn.columnType === 'Gutter-Column') {
            throw new Error('Error from DkGridFactoryColumns - DkColumnMeshSlot can not contain a Gutter as its main internal column.');
        }
        return new DkColumnMeshSlot(dikeColumn, dikeGutterColumn);
    }
}
DkGridFactoryMeshSlots.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryMeshSlots, deps: [{ token: DkGridFactoryColumns }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridFactoryMeshSlots.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryMeshSlots });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryMeshSlots, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridFactoryColumns }]; } });

class DkSortDispatcher {
    constructor(dikeConfig) {
        this.dikeConfig = dikeConfig;
        this.changeAllowSortingSubscription = Subscription.EMPTY;
        this.allowSortingSubject = new BehaviorSubject(false);
        this.dataSortSubject = new BehaviorSubject(null);
        this.sortChangeEmitter = new EventEmitter();
        this.setChangeAllowSortingSubscription();
    }
    ngOnDestroy() {
        this.allowSortingSubject.complete();
        this.changeAllowSortingSubscription.unsubscribe();
    }
    get onAllowSortingChanged$() {
        return this.allowSortingSubject.asObservable();
    }
    get onDataSortChanged$() {
        return this.dataSortSubject.asObservable();
    }
    get allowSorting() {
        return this.allowSortingSubject.value;
    }
    set allowSorting(value) {
        this.changeAllowSorting(value);
    }
    get dataSort() {
        return this.dataSortSubject.value;
    }
    set dataSort(value) {
        this.changeDataSort(value);
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    isColumnActiveSortable(columnId) {
        return !!this.dataSort && this.dataSort.active && this.dataSort.active === columnId;
    }
    updateActiveSortable(newColumnId) {
        /**
         * Since a new sorting task is going to run, the previous direction must be set in
         * order to get the same direction the previous active key had after invoking the sort
         * method:
         */
        this.dataSort.direction = this.getPreviousActiveSortDirection(this.dataSort.sortables.get(this.dataSort.active));
        // Set the new key as active:
        this.dataSort.active = newColumnId;
        /**
         * The sort method must be invoked in the next VM turn because
         * the newKey probably does not exist:
         */
        setTimeout(() => {
            this.dataSort.sort(this.dataSort.sortables.get(newColumnId));
        }, 0);
    }
    clearSorting() {
        if (!!this.dataSort) {
            this.dataSort.sort({
                id: '',
                disableClear: false,
                start: undefined
            });
        }
    }
    getSortAlternativeColumnId(columnId) {
        return `${columnId}-${this.dikeConfig.SORT_SUFIX}`;
    }
    addSortable(columnId) {
        let newSortable = null;
        if (!!this.dataSort && !this.dataSort.sortables.has(columnId)) {
            newSortable = {
                id: columnId,
                start: undefined,
                disableClear: undefined
            };
            this.dataSort.register(Object.assign({}, newSortable));
        }
        return newSortable;
    }
    removeSortable(columnId) {
        let deletedSortable = null;
        if (!!this.dataSort && this.dataSort.sortables.has(columnId)) {
            let sortable = this.dataSort.sortables.get(columnId);
            deletedSortable = Object.assign({}, sortable);
            this.dataSort.deregister(sortable);
        }
        return deletedSortable;
    }
    quickSort(rows, direction, column) {
        if (rows.length < 2) {
            return rows;
        }
        else {
            const pivot = Math.floor(rows.length / 2);
            let less = [], greater = [], equal = [];
            equal.push(rows[pivot]);
            const pivotValue = column.getValue(rows[pivot].entry);
            for (let i = 0; i < rows.length; i++) {
                const value = column.getValue(rows[i].entry);
                if (pivot !== i) {
                    if (value < pivotValue) {
                        less.push(rows[i]);
                    }
                    else if (value > pivotValue) {
                        greater.push(rows[i]);
                    }
                    else {
                        equal.push(rows[i]);
                    }
                }
            }
            if (direction === 'desc') {
                let tmpArr = less;
                less = greater;
                greater = tmpArr;
            }
            return [...this.quickSort(less, direction, column), ...equal, ...this.quickSort(greater, direction, column)];
        }
    }
    getPreviousActiveSortDirection(sortable) {
        if (!sortable) {
            return '';
        }
        let disableClear = sortable.disableClear !== null && sortable.disableClear !== undefined ? sortable.disableClear : this.dataSort.disableClear;
        let sortingSet = this.getSortDirectionStates(sortable.start || this.dataSort.start, disableClear);
        let prevIndex = sortingSet.indexOf(this.dataSort.direction) - 1;
        if (prevIndex < 0) {
            prevIndex = sortingSet.length - 1;
        }
        return sortingSet[prevIndex];
    }
    getSortDirectionStates(start, disableClear) {
        let orderingSet = ['asc', 'desc'];
        if (start === 'desc') {
            orderingSet = orderingSet.reverse();
        }
        if (!disableClear) {
            orderingSet.push('');
        }
        return orderingSet;
    }
    changeAllowSorting(value) {
        this.allowSortingSubject.next(value);
    }
    changeDataSort(value) {
        this.dataSortSubject.next(value);
    }
    setChangeAllowSortingSubscription() {
        this.changeAllowSortingSubscription.unsubscribe();
        this.changeAllowSortingSubscription = this.onAllowSortingChanged$.subscribe(allowSorting => {
            if (!allowSorting) {
                Promise.resolve().then(() => this.clearSorting());
            }
        });
    }
}
DkSortDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortDispatcher, deps: [{ token: CONFIG_GRID }], target: i0.ɵɵFactoryTarget.Injectable });
DkSortDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }];
    } });

class DkGridSelectionConfig {
    constructor() {
        this.defaultSelectableFn = (entry) => true;
        this.allowSelectionSubject = new BehaviorSubject(false);
        this.enableAllRowsSelectionSubject = new BehaviorSubject(false);
        this.selectableFnSubject = new BehaviorSubject(this.defaultSelectableFn);
        this.selectionEmitter = new EventEmitter();
        this.selectedRowEmitter = new EventEmitter();
        this.deselectedRowEmitter = new EventEmitter();
    }
    ngOnDestroy() {
        this.allowSelectionSubject.complete();
        this.enableAllRowsSelectionSubject.complete();
        this.selectableFnSubject.complete();
    }
    get onAllowSelectionChanged$() {
        return this.allowSelectionSubject.asObservable();
    }
    get onEnableAllRowsSelectionChanged$() {
        return this.enableAllRowsSelectionSubject.asObservable();
    }
    get onSelectableFnChanged$() {
        return this.selectableFnSubject.asObservable();
    }
    get allowSelection() {
        return this.allowSelectionSubject.value;
    }
    set allowSelection(value) {
        this.changeAllowSelection(value);
    }
    get enableAllRowsSelection() {
        return this.enableAllRowsSelectionSubject.value;
    }
    set enableAllRowsSelection(value) {
        this.changeEnableAllRowsSelection(value);
    }
    get selectableFn() {
        return this.selectableFnSubject.value;
    }
    set selectableFn(value) {
        this.changeSelectableFn(value !== null && value !== void 0 ? value : this.defaultSelectableFn);
    }
    changeAllowSelection(value) {
        this.allowSelectionSubject.next(value);
    }
    changeEnableAllRowsSelection(value) {
        this.enableAllRowsSelectionSubject.next(value);
    }
    changeSelectableFn(value) {
        this.selectableFnSubject.next(value);
    }
}
DkGridSelectionConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelectionConfig, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DkGridSelectionConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelectionConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelectionConfig, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

const ROW_GROUPING_INDENT = new InjectionToken('row-grouping-indent');
const ROW_GROUPING_INDENT_WIDTH = new InjectionToken('row-grouping-indent-width');

class DkRowGroupingConfig {
    constructor(dikeConfig, gridRowGroupingIndent, gridRowGroupingIndentWidth) {
        this.dikeConfig = dikeConfig;
        if (gridRowGroupingIndent === null || gridRowGroupingIndent === undefined) {
            gridRowGroupingIndent = this.dikeConfig.ROW_GROUPING_INDENT;
        }
        if (gridRowGroupingIndentWidth === null || gridRowGroupingIndentWidth === undefined) {
            gridRowGroupingIndentWidth = this.dikeConfig.ROW_GROUPING_INDENT_WIDTH;
        }
        this.allowRowGroupingSubject = new BehaviorSubject(false);
        this.displayRowGroupingIndentSubject = new BehaviorSubject(gridRowGroupingIndent);
        this.rowGroupingIndentWidthSubject = new BehaviorSubject(this.validateRowGroupingIndentWidth(gridRowGroupingIndentWidth));
    }
    ngOnDestroy() {
        this.allowRowGroupingSubject.complete();
        this.displayRowGroupingIndentSubject.complete();
        this.rowGroupingIndentWidthSubject.complete();
    }
    get onAllowRowGroupingChanged$() {
        return this.allowRowGroupingSubject.asObservable();
    }
    get onDisplayRowGroupingIndentChanged$() {
        return this.displayRowGroupingIndentSubject.asObservable();
    }
    get onRowGroupingIndentWidthChanged$() {
        return this.rowGroupingIndentWidthSubject.asObservable();
    }
    get allowRowGrouping() {
        return this.allowRowGroupingSubject.value;
    }
    set allowRowGrouping(value) {
        this.changeAllowRowGrouping(value);
    }
    get displayRowGroupingIndent() {
        return this.displayRowGroupingIndentSubject.value;
    }
    set displayRowGroupingIndent(value) {
        this.changeDisplayRowGroupingIndent(value);
    }
    get rowGroupingIndentWidth() {
        return this.rowGroupingIndentWidthSubject.value;
    }
    set rowGroupingIndentWidth(value) {
        this.changerowGroupingIndentWidth(this.validateRowGroupingIndentWidth(value));
    }
    validateRowGroupingIndentWidth(value) {
        return value < this.dikeConfig.ROW_GROUPING_INDENT_WIDTH ? this.dikeConfig.ROW_GROUPING_INDENT_WIDTH : value;
    }
    changeAllowRowGrouping(value) {
        this.allowRowGroupingSubject.next(value);
    }
    changeDisplayRowGroupingIndent(value) {
        this.displayRowGroupingIndentSubject.next(value);
    }
    changerowGroupingIndentWidth(value) {
        this.rowGroupingIndentWidthSubject.next(value);
    }
}
DkRowGroupingConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingConfig, deps: [{ token: CONFIG_GRID }, { token: ROW_GROUPING_INDENT, optional: true }, { token: ROW_GROUPING_INDENT_WIDTH, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
DkRowGroupingConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingConfig, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_GROUPING_INDENT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_GROUPING_INDENT_WIDTH]
                    }] }];
    } });

class DkGroupPanelDispatcher extends DkPanelDispatcher {
    constructor(dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig, rowGroupingConfig) {
        super([
            new DkGroupColumnStructure('groupPanel', dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig)
        ]);
        this.gridFactoryColumns = gridFactoryColumns;
        this.rowGroupingConfig = rowGroupingConfig;
        this.nonGroupableDataColumnsSubject = new Subject();
        this.shareableDropElementsSubject = new BehaviorSubject({
            groupPanel: new Map()
        });
        this.rowGroupingAreaUUID = generateUUID();
        this.setChangeColumnSlotsSubscription();
        this.setChangeDataColumnSlotsSubscription();
        this.setChangeListHeightSubscription();
        this.setChangeShareableDropElementsSubscription();
    }
    ngOnDestroy() {
        super.destroy();
        this.nonGroupableDataColumnsSubject.complete();
    }
    get onNonGroupableDataColumnsChanged$() {
        return this.nonGroupableDataColumnsSubject.asObservable();
    }
    get groupPanel() {
        return this.panels.groupPanel;
    }
    get rowGroupingAreaId() {
        return this.rowGroupingAreaUUID;
    }
    // This method inserts only new columns:
    addColumns(columns) {
        if (!Array.isArray(columns)) {
            columns = [columns];
        }
        // ColumnId, slotId and belongToGroup must be set to null:
        this.cleanInternalUseField(columns);
        // Add the given columns if only if allowGrouping flag is true:
        columns.filter(() => this.rowGroupingConfig.allowRowGrouping).forEach(column => {
            if (column.panel === null || column.panel === undefined || column.panel !== 'groupPanel') {
                column.panel = 'groupPanel';
            }
            // Since this method receive only root columns (new columns), the display-on property of these columns must be 'OPEN':
            column.displayOn = 'open';
            // Is the given column a group column?
            if (isDkGroupColumnDef(column)) {
                // This method splits the group into branches and return them as groupable and non-groupable:
                let columnSet = this.splitGroupableAndNonGroupableBranches(column);
                // Insert every groupable data column:
                for (let linkTo of columnSet.groupable.values()) {
                    // Before inserting the new data column its identifiers must be erased because is a new data column:
                    linkTo.clonedDataColumnDef.slotId = null;
                    linkTo.clonedDataColumnDef.columnId = null;
                    linkTo.clonedDataColumnDef.belongToGroup = null;
                    linkTo.clonedDataColumnDef.panel = 'groupPanel';
                    // Insert the DataColumnDef into the group panel linked-list:
                    let dataSlot = this.groupPanel.addColumn(linkTo.clonedDataColumnDef);
                    /**
                     * After insertion:
                     *
                     *  1.  Add the data branch to the dataColumnDefIdentities Map which lives in the group panel
                     *      instance. The slot id will be the id from the just inserted data slot.
                     *
                     *  2.  Update the data column reference with the actual reference comming from cloning the
                     *      group panel data slot.
                     *
                     *  IMPORTANT:  The second step is queued at the end of the current VM turn. This columns are
                     *              new columns and new columns must take its display or edition template either from
                     *              the user definition or the default one. In both cases, templates are taken at the
                     *              end of the current event-loop.
                     *
                     *              Therefore, this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(...) method
                     *              is queued after the templates are queried from the UI template. Remember that
                     *              template assignment is done inside the method addColumnIntoList(...) scheduled in a
                     *              promise.
                     */
                    // Add to actual data branch identities Map structure:
                    this.groupPanel.dataColumnDefIdentities.set(dataSlot.slotId, linkTo);
                    // Update references:
                    Promise.resolve().then(() => {
                        linkTo.clonedDataColumnDef = this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(dataSlot);
                    });
                }
                // Reject every non-groupable data column branch:
                this.changeNonGroupableDataColumns(this.rejectNonGroupableDataColumns(columnSet.nonGroupable));
                // Clear the local Map variables:
                columnSet.groupable.clear();
                columnSet.nonGroupable.clear();
            }
            else if (isDkDataColumnDef(column)) {
                // Insert the DataColumnDef into the group panel linked-list if only if the data column is defined as groupable:
                if (column.groupable) {
                    let dataSlot = this.groupPanel.addColumn(column);
                    let dataColumnIdentity = {
                        clonedDataColumnDef: null,
                        leafDataColumnDef: null,
                        branch: null,
                        leafParent: null
                    };
                    // Add to actual data branch identities Map structure:
                    this.groupPanel.dataColumnDefIdentities.set(dataSlot.slotId, dataColumnIdentity);
                    // Update references:
                    Promise.resolve().then(() => {
                        dataColumnIdentity.clonedDataColumnDef = this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(dataSlot);
                        dataColumnIdentity.leafDataColumnDef = this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(dataSlot);
                        dataColumnIdentity.branch = dataColumnIdentity.leafDataColumnDef;
                    });
                }
                else {
                    // Otherwise, the data column will be rejected and inserted into the center panel:
                    column.panel = 'centerPanel';
                    this.changeNonGroupableDataColumns([column]);
                }
            }
        });
    }
    movePanelColumnSlots(fromPanel, destinationPanel, onlyVisibleColumnSlots) {
        /**
         * Columns could only come from any of the Content panels.
         *
         * NOTE: allowRowGrouping flag must be set to true.
         */
        if (this.rowGroupingConfig.allowRowGrouping && !!fromPanel && !!destinationPanel &&
            fromPanel instanceof DkContentColumnStructure) {
            /**
             * Get all column slots from the source panel:
             *
             *  1.  Data slots must be draggable, not locked, and groupable.
             *  2.  Group slots are allowed to pass this filter to splitting them into
             *      branches. Every data slot from every branch must be draggable,
             *      not locked, and groupable.
             */
            let fromColumnSlots = fromPanel.getAllRootColumnSlots()
                .filter(rootSlot => onlyVisibleColumnSlots ? rootSlot.dikeColumn.visible : true)
                .filter(rootSlot => {
                return rootSlot.dikeColumn.columnType === 'Group-Column' ||
                    (rootSlot.dikeColumn.columnType === 'Data-Column' &&
                        rootSlot.dikeColumn.draggable && !rootSlot.dikeColumn.locked && rootSlot.dikeColumn.groupable);
            });
            // Clone every column slot from the source panel:
            let fromClonedColumnsDef = [...fromColumnSlots.map(slot => fromPanel.cloneColumnSlotForMoving(slot, destinationPanel))];
            // Get only those data columns that are actually groupables from DkGroupColumnDef instances and register all data columns in the internal Map:
            let actualGroupableColumns = this.getActualGroupableFromClonedColumnsDef(fromClonedColumnsDef);
            // Once the columns have been collected into an array, insert them into the group panel:
            destinationPanel.addColumnsFromPanel(actualGroupableColumns);
            // Retrieve the column slots from the source panel which are going to be deleted:
            let actualColumnSlotsForDeletion = [
                ...actualGroupableColumns.map(dataColumnDef => fromPanel.getColumnSlot(dataColumnDef.columnId))
            ];
            // Once column slots are inserted into the group Panel, delete them from the source panel:
            actualColumnSlotsForDeletion.forEach((fromSlot, index) => {
                fromPanel.removeClonedColumnSlot(fromSlot, index === actualColumnSlotsForDeletion.length - 1);
            });
            // Return the data columns that have been added to the group panel:
            return actualGroupableColumns;
        }
        return [];
    }
    moveColumnSlotIntoPanel(columnSlot, fromPanel, destinationPanel) {
        /**
         * 1. This method invocation could be due to the following:
         *
         *    (a).  Drag a column to the row-grouping area or,
         *    (b).  Change a column to the group panel via the context menu.
         *    (c).  Programmatically, invoke addColumnIntoPanel(...) method which belongs to
         *          the DkGridColumnDef service.
         *
         * 2. If the column slot is a data column it must be draggable, not locked, and groupable.
         *
         * 3. If the column slot is a group column it does not matter if the group is neither draggable, not locked
         *    nor groupable. Its data columns (the leaves of the group) must be draggables and not locked, and groupables.
         *
         * 3. The given column slot could come from any of the Content Panels.
         *
         * NOTE: allowRowGrouping flag must be set to true.
         */
        // The given column slot must be draggable and not locked:
        if (this.rowGroupingConfig.allowRowGrouping && !!columnSlot && fromPanel !== destinationPanel &&
            fromPanel instanceof DkContentColumnStructure && fromPanel.panel === columnSlot.dikeColumn.panel) {
            if (columnSlot.dikeColumn.columnType === 'Group-Column' ||
                (columnSlot.dikeColumn.columnType === 'Data-Column' &&
                    columnSlot.dikeColumn.draggable && !columnSlot.dikeColumn.locked && columnSlot.dikeColumn.groupable)) {
                // Clone the given column slot from the source panel:
                let fromClonedColumnDef = fromPanel.cloneColumnSlotForMoving(columnSlot, destinationPanel);
                /**
                 * Get only those data columns that are actually groupables from the cloned column def:
                 *
                 *  1.  Remember that the given column slot could be a slot that contains an
                 *      instance of type DkGroupColumn.
                 *  2.  It is important to notice that the given column slot will contain an
                 *      instance of type DkGroupColumn that has many children, if the method is invoked
                 *      programmatically.
                 *  3.  from the UI only data columns could be drag and drop into the group panel. Data
                 *      columns could belong to a group and the cloning operation will return a group but
                 *      that cloned group will be a branch.
                 */
                let actualGroupableColumns = this.getActualGroupableFromClonedColumnsDef([fromClonedColumnDef]);
                // Once the columns have been collected into an array, insert them into the group panel:
                destinationPanel.addColumnsFromPanel(actualGroupableColumns);
                // Retrieve the column slots from the source panel which are going to be deleted:
                let actualColumnSlotsForDeletion = [
                    ...actualGroupableColumns.map(dataColumnDef => fromPanel.getColumnSlot(dataColumnDef.columnId))
                ];
                // Once column slots are inserted into the group Panel, delete them from the source panel:
                actualColumnSlotsForDeletion.forEach((fromSlot, index) => {
                    fromPanel.removeClonedColumnSlot(fromSlot, index === actualColumnSlotsForDeletion.length - 1);
                });
                return actualGroupableColumns;
            }
        }
        // The given column does not pass the validations:
        return [];
    }
    moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * 1. Source slots must belong to any panel from the Content Panels.
         * 2. Destination slot must belong to group panel.
         * 3. Source slot must be a data column.
         * 4. Source slot must be draggable, not locked, and groupable.
         * 5. Destination slot must be a gutter slot.
         *
         * NOTE: allowRowGrouping flag must be set to true.
         */
        if (this.rowGroupingConfig.allowRowGrouping && !!sourceSlot && !!destinationSlot && sourcePanel !== destinationPanel &&
            sourcePanel instanceof DkContentColumnStructure && sourcePanel.panel === sourceSlot.dikeColumn.panel &&
            destinationPanel.panel === destinationSlot.dikeColumn.panel &&
            sourceSlot.dikeColumn.columnType === 'Data-Column' &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked && sourceSlot.dikeColumn.groupable &&
            destinationSlot.dikeColumn.columnType === 'Gutter-Column') {
            let gutterOwner = destinationPanel.getColumnSlot(destinationSlot.dikeColumn.columnIdBelongTo);
            // The gutter owner must be draggable and not locked as well:
            if (!!gutterOwner && gutterOwner.dikeColumn.draggable && !gutterOwner.dikeColumn.locked) {
                // Clone the source slot until its branch:
                let sourceClonedColumnDef = sourcePanel.cloneColumnSlotForMoving(sourceSlot, destinationPanel);
                /**
                 * If the given data slot belongs to a group column, the returned DkColumnDef
                 * reference (sourceClonedColumnDef) holds a data branch. It is known that this data slot
                 * is cloned from the data slot until the root group delivering a data branch.
                 *
                 * It does not matter if the given data slot belongs to a group column or to the root group (ROOT_GROUP_ID),
                 * calling getActualGroupableFromClonedColumnsDef(...) will register the resulting DkDataColumnDef
                 * instance in the internal Map.
                 */
                let actualGroupableDataColumnDef = this.getActualGroupableFromClonedColumnsDef([sourceClonedColumnDef]);
                // Source slot and destination gutter slot must belong to the same group:
                actualGroupableDataColumnDef[0].belongToGroup = ROOT_GROUP_ID;
                // Add the cloned dataColumnDef into the group panel:
                if (destinationPanel.insertExternalColumnSlotToGutter(actualGroupableDataColumnDef[0], destinationSlot)) {
                    // Remove the source slot from its DkColumnMesh list instance:
                    sourcePanel.removeClonedColumnSlot(sourceSlot);
                    // Then establish the new order:
                    sourcePanel.setColumnSlotsOrder(0);
                    destinationPanel.setColumnSlotsOrder(0);
                }
            }
        }
    }
    swapColumnSlotsInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        throw new Error(`Error from DkGroupPanelDispatcher - Swapping a column from any of the Content Panels with a column from the Group Panel is not allowed.`);
    }
    joinColumnGroupSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        throw new Error(`Error from DkGroupPanelDispatcher - Since the Group Panel does not store group columns joining group columns is an invalid operation.`);
    }
    getActualGroupableFromClonedColumnsDef(clonedColumnsDef) {
        // Get only those data columns that are actually groupables from the given cloned columns:
        let actualGroupableColumns = [];
        // The given array could contain data or group columns:
        clonedColumnsDef.forEach(column => {
            if (isDkGroupColumnDef(column)) {
                // From the given group column split them into groupable and non-groupable branches:
                let columnSet = this.splitGroupableAndNonGroupableBranches(column);
                for (let [slotId, linkTo] of columnSet.groupable.entries()) {
                    /**
                     * Add the data column identity to the Map variable.
                     *
                     * The data column slot id is inserting before actually adding the
                     * data column to the group panel linked-list. The addColumnsFromPanel(...)
                     * method must verify the slot identity existance in the Map structure
                     * before inserting the data column to the linked-list.
                     */
                    this.groupPanel.dataColumnDefIdentities.set(slotId, linkTo);
                    // Save the actual data column for later insertion:
                    actualGroupableColumns.push(linkTo.clonedDataColumnDef);
                }
                // Clear the local Map variables:
                columnSet.groupable.clear();
                columnSet.nonGroupable.clear();
            }
            else if (isDkDataColumnDef(column)) {
                // This will be a clon of the original column before moving it:
                let leafDataColumnDef = this.gridFactoryColumns.cloneDikeDataColumnDef(column);
                /**
                 * Add the data column identity to the Map variable.
                 *
                 * The data column slot id is inserting before actually adding the
                 * data column to the group panel linked-list. The addColumnsFromPanel(...)
                 * method must verify the slot identity existance in the Map structure
                 * before inserting the data column to the linked-list.
                 */
                this.groupPanel.dataColumnDefIdentities.set(column.slotId, {
                    clonedDataColumnDef: column,
                    leafDataColumnDef,
                    branch: leafDataColumnDef,
                    leafParent: null
                });
                // Save the data column for later insertion:
                actualGroupableColumns.push(column);
            }
        });
        return actualGroupableColumns;
    }
    splitGroupableAndNonGroupableBranches(column) {
        // Clone the given group column:
        let ownColumnGroupDef = this.gridFactoryColumns.cloneDikeGroupColumnDef(column);
        // Get all data columns with its corresponding branch. If the given column does not have ids this method will generate new ones:
        let dataBranches = new Map(this.extractDataColumns(ownColumnGroupDef, null, null));
        // Then split the original set of branches into groupable and non-groupable:
        let splitDataBranchSet = {
            groupable: new Map(),
            nonGroupable: new Map()
        };
        for (let [slotId, linkTo] of dataBranches.entries()) {
            // The original data column must be draggable, not locked and groupable:
            if (linkTo.leafDataColumnDef.draggable && !linkTo.leafDataColumnDef.locked && linkTo.leafDataColumnDef.groupable) {
                // All root column slots must be set its displayOn property to OPEN:
                linkTo.clonedDataColumnDef.displayOn = 'open';
                splitDataBranchSet.groupable.set(slotId, linkTo);
            }
            else {
                splitDataBranchSet.nonGroupable.set(slotId, linkTo);
            }
        }
        return splitDataBranchSet;
    }
    getLeafFromBranch(columnDef, parent) {
        if (isDkGroupColumnDef(columnDef)) {
            return this.getLeafFromBranch(columnDef.children[0], columnDef);
        }
        else if (isDkDataColumnDef(columnDef)) {
            return { dataColumn: columnDef, parent };
        }
        return null;
    }
    extractDataColumns(columnDef, parent, ancestors) {
        let branches = [];
        /**
         * This method is invoke if only if the given columnDef is an instance of type DkGroupColumnDef.
         * Therefore, given the DkGroupColumnDef, the method is called recursively until the leaves, obtaining
         * every data column (leaves) with its complete branch until the root.
         *
         * Every data column is stored in the internal Map structure called dataColumnDefIdentity.
         *
         * If the given group is defined at initialization phase the corresponding identifiers are created.
         *
         * Clone the given columnDef.
         *
         *    1.  If the given columnDef is an instance of type DkGroupColumnDef clone it but without its
         *        children.
         *
         *    2.  Or if the given column is an instance of type DkDataColumnDef create a new instance and
         *        assign to it the given columnDef.
         */
        if (isDkGroupColumnDef(columnDef) && !!columnDef.children && columnDef.children.length > 0) {
            // Create a new instance based on the given columnDef but without the child columns:
            let groupColumnDef = this.gridFactoryColumns.createDikeGroupColumnDefFromGroupColumnDef(columnDef);
            // If the given columnDef is a new group meaning that it was defined at creation time:
            if (!groupColumnDef.slotId) {
                groupColumnDef.slotId = generateUUID();
                groupColumnDef.columnId = generateUUID();
                groupColumnDef.belongToGroup = !parent ? ROOT_GROUP_ID : parent.slotId;
            }
            // If the parent is null means that the given columnDef is the roor of the entire given column group:
            if (!parent) {
                ancestors = groupColumnDef;
            }
            else {
                // Otherwise, add the given columnDef group to its parent instance:
                parent.children.push(groupColumnDef);
            }
            columnDef.children.forEach(childColumn => {
                /**
                 * Before called the method recursively the children array of the cloned columnDef group
                 * must be cleared. When the iteration reaches a leaf the complete branch must be cloned from
                 * the ancestors instance group and clearing the children array avoid having sibling when cloning
                 * the branch.
                 */
                groupColumnDef.children = [];
                /**
                 * The method is called recursively until the leaves sending the follwing:
                 *
                 *  1.  The given child column.
                 *  2.  The current parent which is the clon of given columnDef group.
                 *  3.  The ancestors group which always be the root of the entire group.
                 */
                branches = [...branches, ...this.extractDataColumns(childColumn, groupColumnDef, ancestors)];
            });
        }
        else if (isDkDataColumnDef(columnDef)) {
            // Create a new instance based on the given columnDef:
            let dataColumnDef = this.gridFactoryColumns.cloneDikeDataColumnDef(columnDef);
            // If the given columnDef is a new data column meaning that it was defined at creation time:
            if (!dataColumnDef.slotId) {
                dataColumnDef.slotId = generateUUID();
                dataColumnDef.columnId = generateUUID();
                dataColumnDef.belongToGroup = parent.slotId;
            }
            // Add the just created clon of the given data columnDef to the given parent group:
            parent.children.push(dataColumnDef);
            // Once the just cloned data column has been added to the given parent, clone the whole branch:
            let completeBranch = this.gridFactoryColumns.cloneDikeGroupColumnDef(ancestors);
            // Get a clon from the original data column but the one that has identifiers:
            let clonedDataColumnDef = this.gridFactoryColumns.cloneDikeDataColumnDef(dataColumnDef);
            ;
            // Then get the reference of the data column from the cloned branch. This reference points to the actual DkDataColumnDef instance and its parent:
            let leafDataInfo = this.getLeafFromBranch(completeBranch, null);
            /**
             * Finally, associate the data column with its group branch:
             *
             *  1.  Branch will hold the original data column and its ancestors until the root group column node.
             *  2.  Therefore, the leafDataColumnDef reference will point to the original data column as well.
             */
            branches.push([leafDataInfo.dataColumn.slotId, {
                    clonedDataColumnDef,
                    leafDataColumnDef: leafDataInfo.dataColumn,
                    branch: completeBranch,
                    leafParent: leafDataInfo.parent
                }]);
        }
        return branches;
    }
    rejectNonGroupableDataColumns(nonGroupable) {
        /**
         * Rejection is executed over new group columns. It means group columns that were
         * defined at creation time.
         *
         * Remember that all identifiers for these group columns were created when extractDataColumns(...)
         * method was executed because these group columns did not have identifiers at all.
         *
         * Therefore, the rejected data columns (the leaves) MUST be treated as new columns in its corresponding
         * content panel. The latter is important because there are some task that are done at creation column
         * slots such as setting filterability and edition settings, gets or sets the edition and display templates
         * for the given data slot.
         *
         * To conclude, the identifiers of the rejected data columns must be erased.
         */
        let columnDefBranches = [];
        for (let linkTo of nonGroupable.values()) {
            // Erase the identifiers of the given data column:
            linkTo.leafDataColumnDef.slotId = null;
            linkTo.leafDataColumnDef.columnId = null;
            /**
             * The root node of the given branch is set to where the data column will be inserted.
             *
             * The panel value of the given data column is assigned to the root node of the given
             * branch, if this value is different from 'groupPanel'. Otherwise, the 'centerPanel'
             * value is assigned.
             */
            linkTo.branch.panel = linkTo.leafDataColumnDef.panel !== 'groupPanel' ? linkTo.leafDataColumnDef.panel : 'centerPanel';
            // The data column is ready to be inserted into its corresponding content panel:
            columnDefBranches.push(linkTo.branch);
        }
        return columnDefBranches;
    }
    changeNonGroupableDataColumns(value) {
        return this.nonGroupableDataColumnsSubject.next(value);
    }
    setChangeColumnSlotsSubscription() {
        this.changesColumnSlotsSubscription.unsubscribe();
        this.changesColumnSlotsSubscription = this.groupPanel.onColumnSlotsChanged$
            .subscribe(value => this.columnSlotsSubject.next(value));
    }
    setChangeDataColumnSlotsSubscription() {
        this.changesDataColumnSlotsSubscription.unsubscribe();
        this.changesDataColumnSlotsSubscription = this.groupPanel.onDataColumnSlotsChanged$
            .subscribe(slots => this.dataColumnSlotsSubject.next(slots));
    }
    setChangeListHeightSubscription() {
        this.changesListHeightSubscription.unsubscribe();
        this.changesListHeightSubscription = this.groupPanel.onListHeightChanged$.subscribe(value => {
            this.groupPanel.setGreatestHeight(value);
        });
    }
    setChangeShareableDropElementsSubscription() {
        let columnSlotsSource$ = this.groupPanel.onColumnSlotsChanged$.pipe(map(slots => this.getShareDropElementIds(this.groupPanel, slots)));
        this.changesShareableDropElementsSubscription.unsubscribe();
        this.changesShareableDropElementsSubscription = columnSlotsSource$.subscribe(groupShareables => {
            this.shareableDropElementsSubject.next({
                groupPanel: groupShareables
            });
        });
    }
}
DkGroupPanelDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGroupPanelDispatcher, deps: [{ token: CONFIG_GRID }, { token: DkGridConfig }, { token: DkGridFactoryColumns }, { token: DkGridFactoryMeshSlots }, { token: DkGridFilterConfig }, { token: DkSortDispatcher }, { token: DkGridEditionConfig }, { token: DkRowGroupingConfig }], target: i0.ɵɵFactoryTarget.Injectable });
DkGroupPanelDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGroupPanelDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGroupPanelDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGridConfig }, { type: DkGridFactoryColumns }, { type: DkGridFactoryMeshSlots }, { type: DkGridFilterConfig }, { type: DkSortDispatcher }, { type: DkGridEditionConfig }, { type: DkRowGroupingConfig }];
    } });

class DkRowGroupingDispatcher {
    constructor(groupPanelDispatcher, gridFactoryColumns) {
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.gridFactoryColumns = gridFactoryColumns;
        this.changeGroupPanelCardinalitySubscription = Subscription.EMPTY;
        this.groupPanelCardinalitySubject = new BehaviorSubject(this.groupPanelDispatcher.getColumnSlots().length);
        this.collapseGroupSubject = new Subject();
        this.rootGroupRowSubject = new BehaviorSubject(null);
        this.collapseGroupRowEmitter = new EventEmitter();
        this.setGroupPanelCardinalitySubscription();
    }
    ngOnDestroy() {
        this.groupPanelCardinalitySubject.complete();
        this.collapseGroupSubject.complete();
        this.changeGroupPanelCardinalitySubscription.unsubscribe();
    }
    get onGroupPanelCardinalityChanged$() {
        return this.groupPanelCardinalitySubject.asObservable();
    }
    get onCollapseGroupChanged$() {
        return this.collapseGroupSubject.asObservable();
    }
    get onRootGroupRowChanged$() {
        return this.rootGroupRowSubject.asObservable();
    }
    get groupPanelCardinality() {
        return this.groupPanelCardinalitySubject.value;
    }
    collapseGroup(group) {
        // Prepare the event:
        const collapseEvent = {
            groupId: group.id,
            collapse: !group.collapse,
            groupKey: group.key,
            groupLevel: group.level
        };
        /**
         * This observable is listened by the DkGroupingDataSource instances.
         * When the event is dispatched the collapse property of the sent group is changed.
         */
        this.changeCollapseGroup(collapseEvent);
        // Emit the event outside the DikeGrid instance:
        // To avoid lagging the UI, this event is sent in the next event-loop turn:
        setTimeout(() => this.collapseGroupRowEmitter.emit(Object.assign(Object.assign({}, collapseEvent), { dataColumn: this.gridFactoryColumns.cloneDikeDataColumnDef(group.dataColumn), dataRowEntries: [...group.dataRows] })), 0);
    }
    isThereDeeperLevel(level) {
        let groupSlots = this.groupPanelDispatcher.getColumnSlots();
        return groupSlots.length > 0 && ((level + 1) < groupSlots.length);
    }
    getGroupByColumn(level) {
        return this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(this.groupPanelDispatcher.getColumnSlots()[level]);
    }
    createRowGroups(currentGroup) {
        var _a;
        let rowGroups = new Map();
        const nextDepperLevel = currentGroup.level + 1;
        const dataColumn = this.getGroupByColumn(nextDepperLevel);
        // Iterate over every data row and insert it into the corresponding array depending on the data column value:
        for (let i = 0; i < currentGroup.dataRows.length; i++) {
            let rowValue = dataColumn.getValue(currentGroup.dataRows[i].entry);
            // Null, undefined or an empty string (after converting) are considered null values (Empty values):
            if (dataColumn.dataType === 'Text' || dataColumn.dataType === 'Binary') {
                rowValue = rowValue === null || rowValue === undefined || new String(rowValue).valueOf().trim() === '' ? null : rowValue;
            }
            else if (dataColumn.dataType === 'Numeric') {
                rowValue = rowValue === null || rowValue === undefined ||
                    new String(rowValue).valueOf().trim() === '' || Number.isNaN(new Number(rowValue).valueOf()) ? null : rowValue;
            }
            else if (dataColumn.dataType === 'Date') {
                // If rowValue is equal to null the dateValue is not invalid, instead it will have: Wed Dec 31 1969 18:00:00 GMT-0600 (Central Standard Time):
                let dateValue = new Date(rowValue);
                // Therefore, we have to evaluate the null value:
                if (rowValue === null || dateValue.toString() === 'Invalid Date') {
                    rowValue = null;
                }
                else {
                    rowValue = new Date(dateValue.getFullYear(), dateValue.getMonth(), dateValue.getDate()).toString();
                }
            }
            let rowValueSet = (_a = rowGroups.get(rowValue)) !== null && _a !== void 0 ? _a : [];
            rowValueSet.push(currentGroup.dataRows[i]);
            rowGroups.set(rowValue, rowValueSet);
        }
        return rowGroups;
    }
    get rootGroupRow() {
        return this.rootGroupRowSubject.value;
    }
    set rootGroupRow(value) {
        this.changeRootGroupRow(value);
    }
    setGroupPanelCardinalitySubscription() {
        const groupPanelCardinality$ = this.groupPanelDispatcher.onColumnSlotsChanged$.pipe(map(groupSlots => groupSlots.length));
        this.changeGroupPanelCardinalitySubscription.unsubscribe();
        this.changeGroupPanelCardinalitySubscription = groupPanelCardinality$.subscribe(value => {
            this.groupPanelCardinalitySubject.next(value);
        });
    }
    changeCollapseGroup(value) {
        this.collapseGroupSubject.next(value);
    }
    changeRootGroupRow(value) {
        this.rootGroupRowSubject.next(value);
    }
}
DkRowGroupingDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingDispatcher, deps: [{ token: DkGroupPanelDispatcher }, { token: DkGridFactoryColumns }], target: i0.ɵɵFactoryTarget.Injectable });
DkRowGroupingDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGroupPanelDispatcher }, { type: DkGridFactoryColumns }]; } });

class DkContentPanelDispatcher extends DkPanelDispatcher {
    constructor(dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig, gridSelectionConfig, generalNotifier, rowGroupingConfig, rowGroupingDispatcher) {
        super([
            new DkContentColumnStructure('leftPanel', dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig),
            new DkContentColumnStructure('centerPanel', dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig),
            new DkContentColumnStructure('rightPanel', dikeConfig, gridConfig, gridFactoryColumns, gridFactoryMeshSlots, gridFilterConfig, sortDispatcher, gridEditionConfig)
        ]);
        this.gridSelectionConfig = gridSelectionConfig;
        this.generalNotifier = generalNotifier;
        this.rowGroupingConfig = rowGroupingConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.changesContainerWidthSubscription = Subscription.EMPTY;
        this.changesPanelsVisibilitySubscription = Subscription.EMPTY;
        // Subscriptions for Event emitters:
        this.emitColumnGroupStatusSubscription = Subscription.EMPTY;
        this.emitColumnLockedSubscription = Subscription.EMPTY;
        this.emitColumnUnLockedSubscription = Subscription.EMPTY;
        this.emitColumnVisibleSubscription = Subscription.EMPTY;
        this.dikeConfig = dikeConfig;
        this.gridConfig = gridConfig;
        this.gridEditionConfig = gridEditionConfig;
        this.gridSelectionConfig = gridSelectionConfig;
        this.generalNotifier = generalNotifier;
        this.isDataSourceIndexVisible = false;
        this.dataSourceIndexWidth = 0;
        this.listHeightSubject = new BehaviorSubject(0);
        this.gridTemplateHeaderColumnPanelsSubject = new BehaviorSubject('');
        this.gridTemplateContentColumnPanelsSubject = new BehaviorSubject('');
        this.panelsVisibilitySubject = new BehaviorSubject(this.calculatePanelsVisibilityTruthTable(false, false, false));
        this.currentScrollingPanelSubject = new BehaviorSubject(null);
        this.moveHorizontalScrollingSubject = new Subject();
        this.shareableDropElementsSubject = new BehaviorSubject({
            leftPanel: new Map(),
            centerPanel: new Map(),
            rightPanel: new Map()
        });
        this.columnGroupStatusEmitter = new EventEmitter();
        this.columnLockedEmitter = new EventEmitter();
        this.columnUnLockedEmitter = new EventEmitter();
        this.columnVisibleEmitter = new EventEmitter();
        this.setChangeListHeightSubscription();
        this.setChangeColumnSlotsSubscription();
        this.setChangeDataColumnSlotsSubscription();
        this.setChangeContainerWidthSubscription();
        this.setChangePanelsVisibilitySubscription();
        this.setChangeShareableDropElementsSubscription();
        this.setEmitColumnGroupStatusSubscription();
        this.setEmitColumnLockedSubscription();
        this.setEmitColumnUnLockedSubscription();
        this.setEmitColumnVisibleSubscription();
    }
    ngOnDestroy() {
        super.destroy();
        this.listHeightSubject.complete();
        this.gridTemplateHeaderColumnPanelsSubject.complete();
        this.gridTemplateContentColumnPanelsSubject.complete();
        this.panelsVisibilitySubject.complete();
        this.currentScrollingPanelSubject.complete();
        this.moveHorizontalScrollingSubject.complete();
        this.changesContainerWidthSubscription.unsubscribe();
        this.changesPanelsVisibilitySubscription.unsubscribe();
        this.emitColumnGroupStatusSubscription.unsubscribe();
        this.emitColumnLockedSubscription.unsubscribe();
        this.emitColumnUnLockedSubscription.unsubscribe();
        this.emitColumnVisibleSubscription.unsubscribe();
        this.leftPanel.removeAllFilterables();
        this.centerPanel.removeAllFilterables();
        this.rightPanel.removeAllFilterables();
        this.leftPanel.destroy();
        this.centerPanel.destroy();
        this.rightPanel.destroy();
    }
    get onListHeightChanged$() {
        return this.listHeightSubject.asObservable();
    }
    get onGridTemplateHeaderColumnPanelsChanged$() {
        return this.gridTemplateHeaderColumnPanelsSubject.asObservable().pipe(observeOn(asapScheduler));
    }
    get onGridTemplateContentColumnPanelsChanged$() {
        return this.gridTemplateContentColumnPanelsSubject.asObservable().pipe(observeOn(asapScheduler));
    }
    get onPanelsVisibilityChanged$() {
        return this.panelsVisibilitySubject.asObservable();
    }
    get onCurrentScrollingPanelChanged$() {
        return this.currentScrollingPanelSubject.asObservable();
    }
    get onMoveHorizontalScrollingChanged$() {
        return this.moveHorizontalScrollingSubject.asObservable();
    }
    get contentPanels() {
        return this.panels;
    }
    get leftPanel() {
        return this.panels.leftPanel;
    }
    get centerPanel() {
        return this.panels.centerPanel;
    }
    get rightPanel() {
        return this.panels.rightPanel;
    }
    /**
     * The method could receive one column or an array of columns of type DkColumnDef.
     *
     * This method will be used to insert new columns specified by the client user.
     * The columns could be specified inside the DikeGrid template component through
     * DikeGridColumn component via Content projection. Also, the user could instantiate
     * an object or an array of objects of type DkColumnDef directly.
     *
     * IMPORTANT NOTE: This method receive only root columns.
     *
     * @param {DkColumnDef | DkColumnDef[]} columns The column or columns to be added.
     *
     * @returns {void} No return value.
     */
    addColumns(columns) {
        if (!Array.isArray(columns)) {
            columns = [columns];
        }
        // ColumnId, slotId and belongToGroup must be set to null:
        this.cleanInternalUseField(columns);
        columns.forEach(column => {
            if (column.panel === null || column.panel === undefined ||
                (column.panel !== 'leftPanel' && column.panel !== 'centerPanel' && column.panel !== 'rightPanel')) {
                column.panel = 'centerPanel';
            }
            // Since this method receive only root columns (new columns), the display-on property of these columns must be 'OPEN':
            column.displayOn = 'open';
            this.panels[column.panel].addColumn(column);
        });
    }
    movePanelColumnSlots(fromPanel, destinationPanel, onlyVisibleColumnSlots) {
        /**
         *  1.  Columns could come from the groupPanel or from any of the Content panels.
         *  2.  Column slots must be draggable and not locked.
         */
        if (!!fromPanel && !!destinationPanel && fromPanel.panel !== destinationPanel.panel) {
            // Get all column slots from the source panel:
            let fromColumnSlots = fromPanel.getAllRootColumnSlots()
                .filter(rootSlot => onlyVisibleColumnSlots ? rootSlot.dikeColumn.visible : true)
                .filter(rootSlot => rootSlot.dikeColumn.draggable && !rootSlot.dikeColumn.locked);
            // Clone every column slot from the source panel:
            let fromClonedColumnsDef = [...fromColumnSlots.map(slot => fromPanel.cloneColumnSlotForMoving(slot, destinationPanel))];
            // Once the column slots have been cloned, insert them into the destination panel:
            destinationPanel.addColumnsFromPanel(fromClonedColumnsDef);
            // Once column slots are inserted into the destination Panel, delete them from the source panel:
            fromColumnSlots.forEach((fromSlot, index) => {
                fromPanel.removeClonedColumnSlot(fromSlot, index === fromColumnSlots.length - 1);
            });
            // Return the columns that have been added to the destination panel:
            return fromClonedColumnsDef;
        }
        return [];
    }
    moveColumnSlotIntoPanel(columnSlot, fromPanel, destinationPanel) {
        /**
         * 1. This method invocation could be due to the following:
         *
         *    (a). Drag a column to a valid border or,
         *    (b). Change a column to other content panel via the context menu.
         *
         * 2. The column slot must be draggable and not locked.
         *
         * 3. The given column slot could come from any of the content panels or even from
         *    the group panel.
         */
        // The given column slot must be draggable and not locked:
        if (!!columnSlot && columnSlot.dikeColumn.draggable && !columnSlot.dikeColumn.locked &&
            columnSlot.dikeColumn.panel === fromPanel.panel && columnSlot.dikeColumn.panel !== destinationPanel.panel) {
            // Clone the given column slot to be inserted into the destination panel:
            let clonedColumnDef = fromPanel.cloneColumnSlotForMoving(columnSlot, destinationPanel);
            /**
             * The column which will be added to the new panel, always will be added
             * at the beginning of the panel:
             */
            clonedColumnDef.order = 0;
            // Once the column slot is cloned insert it in the destination panel:
            destinationPanel.addColumn(clonedColumnDef);
            // The given column slot is deleted from its source panel:
            fromPanel.removeClonedColumnSlot(columnSlot);
            // After moving the columns, the new order in each panel is established:
            fromPanel.setColumnSlotsOrder(0);
            destinationPanel.setColumnSlotsOrder(0);
            return [clonedColumnDef];
        }
        return [];
    }
    moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * 1. The source panel could be any of the Content Panels even the Group Panel.
         *
         * 2. Source and destination slots must belong to the same group.
         *    In case the source slot comes from the Group Panel, the source slot, that it is
         *    a data slot, belongs to the root group.
         *
         * 3. Source slot must be draggable and not locked.
         *
         * 4. Source and destination slots belong to a different panel.
         *
         * 5. Source slot must be a data or group column.
         *
         * 6. Destination slot must be a gutter slot.
         */
        if (!!sourceSlot && !!destinationSlot && sourcePanel !== destinationPanel &&
            sourceSlot.belongToGroup === destinationSlot.belongToGroup && sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked &&
            sourceSlot.dikeColumn.panel !== destinationSlot.dikeColumn.panel &&
            (sourceSlot.dikeColumn.columnType === 'Data-Column' ||
                sourceSlot.dikeColumn.columnType === 'Group-Column') &&
            destinationSlot.dikeColumn.columnType === 'Gutter-Column') {
            let gutterOwner = destinationPanel.getColumnSlot(destinationSlot.dikeColumn.columnIdBelongTo);
            // The gutter owner must be draggable and not locked as well:
            if (!!gutterOwner && gutterOwner.dikeColumn.draggable && !gutterOwner.dikeColumn.locked) {
                /**
                 * If the given source slot comes from the Group Panel and belongs to a group,
                 * the cloning operation will return the complete branch where the root group
                 * column belongs to ROOT_GROUP_ID.
                 */
                let sourceClonedColumnDef = sourcePanel.cloneColumnSlotForMoving(sourceSlot, destinationPanel);
                /**
                 * Add the cloned source slot into the destination panel.
                 *
                 * If the cloning operation returns a group column, the insertExternalColumnSlotToGutter(...)
                 * method will join the group, if the group exists in the destination panel, an then
                 * will move the joined group to the gutter position.
                 */
                if (destinationPanel.insertExternalColumnSlotToGutter(sourceClonedColumnDef, destinationSlot)) {
                    // Remove the source slot from its DkColumnMesh list instance:
                    sourcePanel.removeClonedColumnSlot(sourceSlot);
                    // Then establish the new order:
                    sourcePanel.setColumnSlotsOrder(0);
                    destinationPanel.setColumnSlotsOrder(0);
                }
            }
        }
    }
    joinColumnGroupSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * 1. Source and destination slots must belong to the same group.
         * 2. Source slot must come from any Content Panel.
         * 3. Source slot must be draggable and not locked.
         * 3. Source and destination slots belong to a different panels.
         * 4. Both of them must be group columns.
         * 5. Source and destination slots are the same group that had been split before.
         */
        if (!!sourceSlot && !!destinationSlot && sourceSlot.belongToGroup === destinationSlot.belongToGroup &&
            sourcePanel instanceof DkContentColumnStructure && sourcePanel.panel === sourceSlot.dikeColumn.panel &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked &&
            destinationPanel.panel === destinationSlot.dikeColumn.panel &&
            sourceSlot.dikeColumn.panel !== destinationSlot.dikeColumn.panel &&
            sourceSlot.dikeColumn.columnType === 'Group-Column' &&
            destinationSlot.dikeColumn.columnType === 'Group-Column' &&
            sourceSlot.slotId === destinationSlot.slotId) {
            /**
             * Source and destinations slots have the same slotId.
             * It means both of them are Group columns.
             *
             * Therefore, we have to join source slot with destination slot.
             * Joining functionality is done inside DkColumnStructure class
             * through addColumn(...) method and cloning functionality is
             * done in this class through moveColumnSlotIntoPanel(...) method.
             *
             * moveColumnSlotIntoPanel(...) method calls addColumn(...).
             */
            this.moveColumnSlotIntoPanel(sourceSlot, sourcePanel, destinationPanel);
        }
    }
    swapColumnSlotsInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * 1. Source and destination slots must belong to the same group.
         * 2. Source and destination slots must be draggable and not locked.
         * 3. Source and destination slots belong to different panels.
         * 4. Both of them must be either a data column or a group column.
         * 5. Source and destination slots are different slots.
         */
        if (!!sourceSlot && !!destinationSlot && sourceSlot.belongToGroup === destinationSlot.belongToGroup &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked &&
            destinationSlot.dikeColumn.draggable && !destinationSlot.dikeColumn.locked &&
            sourceSlot.dikeColumn.panel !== destinationSlot.dikeColumn.panel &&
            (sourceSlot.dikeColumn.columnType === 'Data-Column' ||
                sourceSlot.dikeColumn.columnType === 'Group-Column') &&
            (destinationSlot.dikeColumn.columnType === 'Data-Column' ||
                destinationSlot.dikeColumn.columnType === 'Group-Column') &&
            sourceSlot.slotId !== destinationSlot.slotId) {
            /**
             * Since source and destination slots belong to the same group and live in different panel,
             * then it is not necessary to evaluate if the group exists in the destination panel. Therefore,
             * we only clone the current slots and its children.
             */
            let sourceClonedColumnDef = sourcePanel.cloneColumnSlot(sourceSlot, false);
            let destinationClonedColumnDef = destinationPanel.cloneColumnSlot(destinationSlot, false);
            // This operation will remove destinationColumnSlot from its DkColumnMesh instance list:
            if (destinationPanel.insertExternalColumnDefAtDestinationColumnSlot(sourceClonedColumnDef, destinationSlot)) {
                // Then set the new order:
                destinationPanel.setColumnSlotsOrder(0);
                // This operation will remove sourceColumnSlot from its DkColumnMesh instance list:
                if (sourcePanel.insertExternalColumnDefAtDestinationColumnSlot(destinationClonedColumnDef, sourceSlot)) {
                    // Then set the new order:
                    sourcePanel.setColumnSlotsOrder(0);
                }
            }
        }
    }
    changeColumnSlotFilter(columnSlot, newFilter) {
        /**
         * 1. The column exist in the double-linked list.
         * 2. The given column is a Data column.
         * 3. The given column is filterable.
         * 4. The given filter is not empty, null or undefined.
         */
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column' &&
            columnSlot.dikeColumn.filterable && newFilter && newFilter.length > 0) {
            this.panels[columnSlot.dikeColumn.panel].changeColumnSlotFilter(columnSlot, newFilter);
        }
    }
    /**
     * To set or unset a filter to a column.
     *
     * @param {DkDataColumnDef} column The column to which a filter will be added or removed.
     * @param {boolean} isFilterable The flag that indicates if the filter will be added or removed.
     * @param {DkFilter} filter Optional parameter. The filter which will be applied to the column.
     * @param {CustomFilterConditionInstance} customFilterConditions Optional parameter. The conditions defined by the user that will apply only to this column.
     *
     * @returns {void} No return value.
     */
    setColumnSlotFilterability(columnSlot, isFilterable, filter, customFilterConditions) {
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotFilterability(columnSlot, isFilterable, filter, customFilterConditions);
        }
    }
    /**
     * Change the column visibility.
     *
     * If the column has children, all of them get the column's visibility state.
     *
     * If the column has a parent column, then the parent must change its visibility
     * state depending on its child columns. This verification is done via the
     * verifyColumnVisibility() method from DkColumnMesh class.
     *
     * @param {DkColumnDef} column The column to which a visibility is applied.
     * @param {boolean} isVisible The flag that indicates if the column is visible or not.
     *
     * @returns {void} No return value.
     */
    setColumnSlotVisible(columnSlot, isVisible) {
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column')) {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotVisible(columnSlot, isVisible);
        }
    }
    setColumnSlotEditable(columnSlot, isEditable, settings) {
        // Only data columns could be editable:
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotEditable(columnSlot, isEditable, settings);
        }
    }
    setDefaultEditionTemplateColumnSlot(columnSlot) {
        // Only data columns could be editable:
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setDefaultEditionTemplateColumnSlot(columnSlot);
        }
    }
    setDisplayTemplateColumnSlot(columnSlot, displayTemplate) {
        // Only data columns could have a display template:
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setDisplayTemplateColumnSlot(columnSlot, displayTemplate);
        }
    }
    setDefaultDisplayTemplateColumnSlot(columnSlot) {
        // Only data columns could have a display template:
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setDefaultDisplayTemplateColumnSlot(columnSlot);
        }
    }
    setColumnSlotLocking(columnSlot, isLocked) {
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') && columnSlot.dikeColumn.draggable) {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotLocking(columnSlot, isLocked);
        }
    }
    setColumnSlotResizable(columnSlot, isResizable) {
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column')) {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotResizable(columnSlot, isResizable);
        }
    }
    changeColumnSlotWidth(columnSlot, columnSize) {
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].changeColumnSlotWidth(columnSlot, columnSize);
        }
    }
    changeColumnSlotGroupStatus(columnGroupSlot, status) {
        if (!!columnGroupSlot && columnGroupSlot.dikeColumn.columnType === 'Group-Column' && columnGroupSlot.displayStatus !== status) {
            this.panels[columnGroupSlot.dikeColumn.panel].setDisplayStatusToColumnSlotGroup(columnGroupSlot.dikeColumn.columnId, status);
        }
    }
    setColumnSlotGroupable(columnSlot, isGroupable) {
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotGroupable(columnSlot, isGroupable);
        }
    }
    setColumnSlotSortable(columnSlot, isSortable) {
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.panels[columnSlot.dikeColumn.panel].setColumnSlotSortable(columnSlot, isSortable);
        }
    }
    /**
     * To show or hide the index datasource column.
     *
     * panelsVisibilityTable parameter is used to establish which panel the index source column will have. The index column
     * will be set in the most-left visible panel.
     *
     * If the PanelsVisibilityTruthTable is not provides it will be calculated with the last visible state of
     * each panel.
     *
     * @param {boolean} visible The flag that indicates if the index column will be show or hide.
     * @param {number} width The width the column will have.
     * @param {PanelsVisibilityTruthTable} panelsVisibilityTable Optional parameter. The visibility state of the three panels.
     *
     * @returns {void} No return value.
     */
    setRowIndexColumnSlot(visible, width = 0, panelsVisibilityTable = null) {
        this.isDataSourceIndexVisible = visible;
        this.dataSourceIndexWidth = width;
        let panelsTable = panelsVisibilityTable ? panelsVisibilityTable : this.calculatePanelsVisibilityTruthTable(this.panels.leftPanel.isColumnStructureVisible(), this.panels.centerPanel.isColumnStructureVisible(), this.panels.rightPanel.isColumnStructureVisible());
        if (panelsTable.noPanel) {
            this.leftPanel.setRowIndexColumnSlot(false);
            this.centerPanel.setRowIndexColumnSlot(false);
            this.rightPanel.setRowIndexColumnSlot(false);
        }
        else if (panelsTable.R) {
            this.leftPanel.setRowIndexColumnSlot(false);
            this.centerPanel.setRowIndexColumnSlot(false);
            this.rightPanel.setRowIndexColumnSlot(this.isDataSourceIndexVisible, this.dataSourceIndexWidth);
        }
        else if (panelsTable.C || panelsTable.CR) {
            this.leftPanel.setRowIndexColumnSlot(false);
            this.centerPanel.setRowIndexColumnSlot(this.isDataSourceIndexVisible, this.dataSourceIndexWidth);
            this.rightPanel.setRowIndexColumnSlot(false);
        }
        else if (panelsTable.L || panelsTable.LR || panelsTable.LC || panelsTable.LCR) {
            this.leftPanel.setRowIndexColumnSlot(this.isDataSourceIndexVisible, this.dataSourceIndexWidth);
            this.centerPanel.setRowIndexColumnSlot(false);
            this.rightPanel.setRowIndexColumnSlot(false);
        }
    }
    isLeftPanelScrollGap(panelsTable) {
        return panelsTable.L;
    }
    isCenterPanelScrollGap(panelsTable) {
        return panelsTable.C || panelsTable.LC;
    }
    isRightPanelScrollGap(panelsTable) {
        return panelsTable.R || panelsTable.CR || panelsTable.LR || panelsTable.LCR;
    }
    moveHorizontalScroll(units) {
        // Retrieve the panel that has the current horizontal scroll bar:
        let currentScrollingPanel = this.getCurrentHorizontalScrollingPanel();
        if (!!currentScrollingPanel) {
            // Get the current left offset:
            let leftOffset = this.getMeasureScrollLeftOffset(currentScrollingPanel);
            // Notify to all subscribers. The movement will be only for one unit:
            this.moveHorizontalScrollingSubject.next(leftOffset > 0 ? leftOffset - units : leftOffset + units);
        }
    }
    getMeasureScrollLeftOffset(panel) {
        return this.panels[panel].getMeasureScrollLeftOffset();
    }
    setMeasureScrollLeftOffset(panel, value) {
        this.panels[panel].setMeasureScrollLeftOffset(value);
    }
    getCurrentHorizontalScrollingPanel() {
        return this.currentScrollingPanelSubject.value;
    }
    getPanelsVisibilityTruthTable() {
        return this.panelsVisibilitySubject.value;
    }
    setOuterSlots(isLPVisible, isCPVisible, isRPVisible) {
        let panelsVisibility = this.calculatePanelsVisibilityTruthTable(isLPVisible, isCPVisible, isRPVisible);
        this.setRowIndexColumnSlot(this.isDataSourceIndexVisible, this.dataSourceIndexWidth, panelsVisibility);
    }
    getContentContainerGridTemplateColumns(allowRowGroupingIndent, groupPanelCardinality, rowGroupingIndentWidth, editionMode, checkboxSelection, lpWidth, cpWidth, rpWidth, scrollbarWidth, isContent = false) {
        let panelsTable = this.calculatePanelsVisibilityTruthTable(this.panels.leftPanel.isColumnStructureVisible(), this.panels.centerPanel.isColumnStructureVisible(), this.panels.rightPanel.isColumnStructureVisible());
        let scrollbarGap = 0;
        const rowGroupingIndent = allowRowGroupingIndent && groupPanelCardinality > 0 ? `${rowGroupingIndentWidth * groupPanelCardinality + this.dikeConfig.ROW_GROUPING_COLLAPSE_CELL_WIDTH}px ` : '';
        const editionModeColumn = editionMode ? `${this.dikeConfig.ROW_EDITION_MENU_CELL_WIDTH}px` : '';
        const checkboxSelectionColumn = checkboxSelection ? `${this.dikeConfig.ROW_SELECTION_CELL_WIDTH}px` : '';
        if (isContent) {
            scrollbarGap = scrollbarWidth;
        }
        // scroll-panel:
        if (panelsTable.noPanel || panelsTable.R || panelsTable.C || panelsTable.L) {
            return `${rowGroupingIndent} ${checkboxSelectionColumn} ${editionModeColumn} 1fr`.trim();
        }
        // scroll-panel / right-panel-left-division:
        if (panelsTable.CR || panelsTable.LR) {
            return `${rowGroupingIndent} ${checkboxSelectionColumn} ${editionModeColumn} 1fr ${this.gridConfig.divisionPanelGap}px ${rpWidth - scrollbarGap}px`.trim();
        }
        // left-panel / left-panel-right-division:
        if (panelsTable.LC) {
            return `${rowGroupingIndent} ${checkboxSelectionColumn} ${editionModeColumn} ${lpWidth}px ${this.gridConfig.divisionPanelGap}px 1fr`.trim();
        }
        // left-panel / left-panel-right-division / scroll-panel / right-panel-left-division:
        if (panelsTable.LCR) {
            return `${rowGroupingIndent} ${checkboxSelectionColumn} ${editionModeColumn} ${lpWidth}px ${this.gridConfig.divisionPanelGap}px 1fr ${this.gridConfig.divisionPanelGap}px ${rpWidth - scrollbarGap}px`.trim();
        }
        throw new Error(`Error from DkContentPanelDispatcher: Invalid state for panels combination (leftPanelWidth=${lpWidth})/centerPanelWidth=${cpWidth}/rightPanelWidth=${rpWidth}).`);
    }
    calculatePanelsVisibilityTruthTable(isLPVisible, isCPVisible, isRPVisible) {
        /**
         * Panels Visibility truth table: L, C, R ==> O
         *
         * L stands for Left panel.
         * C stands for Center panel.
         * R stands for Right panel.
         * O stands for Outcome.
         *
         * Where O could take the following values:
         *  noPanel, R, C, CR, L, LR, LC and LCR.
         */
        return {
            noPanel: !isLPVisible && !isCPVisible && !isRPVisible,
            R: !isLPVisible && !isCPVisible && isRPVisible,
            C: !isLPVisible && isCPVisible && !isRPVisible,
            CR: !isLPVisible && isCPVisible && isRPVisible,
            L: isLPVisible && !isCPVisible && !isRPVisible,
            LR: isLPVisible && !isCPVisible && isRPVisible,
            LC: isLPVisible && isCPVisible && !isRPVisible,
            LCR: isLPVisible && isCPVisible && isRPVisible
        };
    }
    changeCurrentHorizontalScrollingPanel(panelsTable) {
        // noPanel;
        let scrollingPanel = null;
        if (panelsTable.L || panelsTable.LR) {
            scrollingPanel = 'leftPanel';
        }
        else if (panelsTable.C || panelsTable.LC || panelsTable.CR || panelsTable.LCR) {
            scrollingPanel = 'centerPanel';
        }
        else if (panelsTable.R) {
            scrollingPanel = 'rightPanel';
        }
        this.currentScrollingPanelSubject.next(scrollingPanel);
    }
    setChangeListHeightSubscription() {
        let listHeightSource$ = combineLatest([
            this.panels.leftPanel.onListHeightChanged$,
            this.panels.centerPanel.onListHeightChanged$,
            this.panels.rightPanel.onListHeightChanged$
        ]);
        this.changesListHeightSubscription.unsubscribe();
        /**
         * The greatest height will give us the grid-template-rows for the header:
         */
        this.changesListHeightSubscription = listHeightSource$.subscribe(([leftHeight, centerHeight, rightHeight]) => {
            let greatestHeight = Math.max(leftHeight, centerHeight, rightHeight);
            this.panels.leftPanel.setGreatestHeight(greatestHeight);
            this.panels.centerPanel.setGreatestHeight(greatestHeight);
            this.panels.rightPanel.setGreatestHeight(greatestHeight);
            this.listHeightSubject.next(greatestHeight);
        });
    }
    setChangePanelsVisibilitySubscription() {
        let panelsVisibility$ = combineLatest([
            this.panels.leftPanel.onColumnSetVisibilityChanged$,
            this.panels.centerPanel.onColumnSetVisibilityChanged$,
            this.panels.rightPanel.onColumnSetVisibilityChanged$,
            this.gridConfig.onInitializedChanged$
        ]);
        this.changesPanelsVisibilitySubscription.unsubscribe();
        this.changesPanelsVisibilitySubscription = panelsVisibility$.subscribe(([lpVisibility, cpVisibility, rpVisibilty, initializedGrid]) => {
            let panelsTable = this.calculatePanelsVisibilityTruthTable(lpVisibility, cpVisibility, rpVisibilty);
            this.setOuterSlots(lpVisibility, cpVisibility, rpVisibilty);
            this.panelsVisibilitySubject.next(panelsTable);
            this.changeCurrentHorizontalScrollingPanel(panelsTable);
            /**
             * Move column slots from right-panel to center-panel.
             *
             * Due to R is an invalid state, all column slots which live in the right-panel are
             * moved to the center-panel.
             *
             * The movement is scheduled at the beginning of the next event-loop.
             * During initialization the R state is ignored. Once the Angular Framework has
             * executed the lyfe cycle hook ngAfterViewInit from the DikeGrid component the R
             * state is evaluated.
             */
            if (initializedGrid && panelsTable.R) {
                setTimeout(() => this.movePanelColumnSlots(this.rightPanel, this.centerPanel, true), 0);
            }
        });
    }
    setChangeContainerWidthSubscription() {
        const editionMode$ = combineLatest([
            this.gridEditionConfig.onAllowEditionChanged$,
            this.gridEditionConfig.onEditionModeChanged$
        ]).pipe(map(([allowEdition, editionMode]) => allowEdition && editionMode));
        const rowGroupingIndent$ = combineLatest([
            this.rowGroupingConfig.onAllowRowGroupingChanged$,
            this.rowGroupingConfig.onDisplayRowGroupingIndentChanged$
        ]).pipe(map(([allowRowGrouping, displayRowGroupingIndent]) => allowRowGrouping && displayRowGroupingIndent));
        const containerWidth$ = combineLatest([
            rowGroupingIndent$,
            this.rowGroupingDispatcher.onGroupPanelCardinalityChanged$,
            this.rowGroupingConfig.onRowGroupingIndentWidthChanged$,
            editionMode$,
            this.gridSelectionConfig.onAllowSelectionChanged$,
            this.panels.leftPanel.onContainerWidthChanged$,
            this.panels.centerPanel.onContainerWidthChanged$,
            this.panels.rightPanel.onContainerWidthChanged$,
            this.generalNotifier.onScrollbarWidthChanged$
        ]);
        this.changesContainerWidthSubscription.unsubscribe();
        this.changesContainerWidthSubscription = containerWidth$.subscribe(([rowGroupingIndent, groupPanelCardinality, rowGroupingIndentWidth, editionMode, selectionMode, lpWidth, cpWidth, rpWidth, scrollbarWidth]) => {
            this.gridTemplateHeaderColumnPanelsSubject.next(this.getContentContainerGridTemplateColumns(rowGroupingIndent, groupPanelCardinality, rowGroupingIndentWidth, editionMode, selectionMode, lpWidth, cpWidth, rpWidth, scrollbarWidth));
            this.gridTemplateContentColumnPanelsSubject.next(this.getContentContainerGridTemplateColumns(rowGroupingIndent, groupPanelCardinality, rowGroupingIndentWidth, editionMode, selectionMode, lpWidth, cpWidth, rpWidth, scrollbarWidth, true));
        });
    }
    setChangeDataColumnSlotsSubscription() {
        const dataColumnSlotsSource$ = combineLatest([
            this.panels.leftPanel.onDataColumnSlotsChanged$,
            this.panels.centerPanel.onDataColumnSlotsChanged$,
            this.panels.rightPanel.onDataColumnSlotsChanged$
        ]);
        const slots$ = dataColumnSlotsSource$.pipe(map(([leftSlots, centerSlots, rightSlots]) => [...leftSlots, ...centerSlots, ...rightSlots]));
        this.changesDataColumnSlotsSubscription.unsubscribe();
        this.changesDataColumnSlotsSubscription = slots$.subscribe(slots => this.dataColumnSlotsSubject.next(slots));
    }
    setChangeColumnSlotsSubscription() {
        const columnSlotsSource$ = combineLatest([
            this.panels.leftPanel.onColumnSlotsChanged$,
            this.panels.centerPanel.onColumnSlotsChanged$,
            this.panels.rightPanel.onColumnSlotsChanged$
        ]);
        const slots$ = columnSlotsSource$.pipe(map(([leftSlots, centerSlots, rightSlots]) => [...leftSlots, ...centerSlots, ...rightSlots]));
        this.changesColumnSlotsSubscription.unsubscribe();
        this.changesColumnSlotsSubscription = slots$.subscribe(slots => this.columnSlotsSubject.next(slots));
    }
    setChangeShareableDropElementsSubscription() {
        let columnSlotsSource$ = combineLatest([
            this.panels.leftPanel.onColumnSlotsChanged$.pipe(map(leftSlots => this.getShareDropElementIds(this.panels.leftPanel, leftSlots))),
            this.panels.centerPanel.onColumnSlotsChanged$.pipe(map(centerSlots => this.getShareDropElementIds(this.panels.centerPanel, centerSlots))),
            this.panels.rightPanel.onColumnSlotsChanged$.pipe(map(rightSlots => this.getShareDropElementIds(this.panels.rightPanel, rightSlots)))
        ]);
        this.changesShareableDropElementsSubscription.unsubscribe();
        this.changesShareableDropElementsSubscription = columnSlotsSource$.subscribe(([leftShareables, centerShareables, rightShareables]) => {
            this.shareableDropElementsSubject.next({
                leftPanel: leftShareables, centerPanel: centerShareables, rightPanel: rightShareables
            });
        });
    }
    setEmitColumnGroupStatusSubscription() {
        this.emitColumnGroupStatusSubscription.unsubscribe();
        const columnGroupStatus$ = merge(this.leftPanel.onColumnGroupStatusChanged$, this.centerPanel.onColumnGroupStatusChanged$, this.rightPanel.onColumnGroupStatusChanged$);
        this.emitColumnGroupStatusSubscription = columnGroupStatus$.subscribe(columnGroup => this.columnGroupStatusEmitter.emit(columnGroup));
    }
    setEmitColumnLockedSubscription() {
        this.emitColumnLockedSubscription.unsubscribe();
        const columnLocking$ = merge(this.leftPanel.onColumnLockedChanged$, this.centerPanel.onColumnLockedChanged$, this.rightPanel.onColumnLockedChanged$);
        this.emitColumnLockedSubscription = columnLocking$.subscribe(column => this.columnLockedEmitter.emit(column));
    }
    setEmitColumnVisibleSubscription() {
        this.emitColumnVisibleSubscription.unsubscribe();
        const columnVisible$ = merge(this.leftPanel.onColumnVisibleChanged$, this.centerPanel.onColumnVisibleChanged$, this.rightPanel.onColumnVisibleChanged$);
        this.emitColumnVisibleSubscription = columnVisible$.subscribe(column => this.columnVisibleEmitter.emit(column));
    }
    setEmitColumnUnLockedSubscription() {
        this.emitColumnUnLockedSubscription.unsubscribe();
        const columnUnLocking$ = merge(this.leftPanel.onColumnUnLockedChanged$, this.centerPanel.onColumnUnLockedChanged$, this.rightPanel.onColumnUnLockedChanged$);
        this.emitColumnUnLockedSubscription = columnUnLocking$.subscribe(column => this.columnUnLockedEmitter.emit(column));
    }
}
DkContentPanelDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentPanelDispatcher, deps: [{ token: CONFIG_GRID }, { token: DkGridConfig }, { token: DkGridFactoryColumns }, { token: DkGridFactoryMeshSlots }, { token: DkGridFilterConfig }, { token: DkSortDispatcher }, { token: DkGridEditionConfig }, { token: DkGridSelectionConfig }, { token: DkGeneralNotifier }, { token: DkRowGroupingConfig }, { token: DkRowGroupingDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkContentPanelDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentPanelDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentPanelDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGridConfig }, { type: DkGridFactoryColumns }, { type: DkGridFactoryMeshSlots }, { type: DkGridFilterConfig }, { type: DkSortDispatcher }, { type: DkGridEditionConfig }, { type: DkGridSelectionConfig }, { type: DkGeneralNotifier }, { type: DkRowGroupingConfig }, { type: DkRowGroupingDispatcher }];
    } });

class DkGridContentStructure {
    constructor(dikeConfig, gridHeaderRowHeight, gridFilterRowHeight, gridContentRowHeight, gridFilterConfig, contentPanelDispatcher) {
        this.dikeConfig = dikeConfig;
        this.gridHeaderRowHeight = gridHeaderRowHeight;
        this.gridFilterRowHeight = gridFilterRowHeight;
        this.gridContentRowHeight = gridContentRowHeight;
        this.gridFilterConfig = gridFilterConfig;
        this.contentPanelDispatcher = contentPanelDispatcher;
        if (this.gridHeaderRowHeight === null || this.gridHeaderRowHeight === undefined) {
            this.gridHeaderRowHeight = this.dikeConfig.HEADER_ROW_HEIGHT;
        }
        if (this.gridFilterRowHeight === null || this.gridFilterRowHeight === undefined) {
            this.gridFilterRowHeight = this.dikeConfig.FILTER_ROW_HEIGHT;
        }
        if (this.gridContentRowHeight === null || this.gridContentRowHeight === undefined) {
            this.gridContentRowHeight = this.dikeConfig.CONTENT_ROW_HEIGHT;
        }
        this.unsubscribeAll = new Subject();
        this.gridContentMesh = new DkGridContentMesh();
        this.gridContentMesh.headerRowHeight = this.createGridRowHeader(this.gridHeaderRowHeight);
        /**
         * Take the flag from the corresponding config service (DkGridFilterConfig).
         *
         * The DkGridContentMesh instance needs to know if the row-filtering is
         * allowed or not, in order to display or hide the row-filtering section.
         */
        this.gridContentMesh.rowFiltering = this.gridFilterConfig.allowRowFilter;
        this.gridContentMesh.filterRowHeight = this.createGridRowFilter(this.gridFilterRowHeight);
        this.gridContentMesh.contentRowHeight = this.createGridRowContent(this.gridContentRowHeight);
        this.gridContentMesh.horizontalScrollHeight = this.dikeConfig.HORIZONTAL_SCROLL_HEIGHT;
        this.headerRowHeightSubject = new BehaviorSubject(this.createGridRowHeader(this.gridHeaderRowHeight));
        this.filterRowHeightSubject = new BehaviorSubject(this.createGridRowFilter(this.gridFilterRowHeight));
        this.contentRowHeightSubject = new BehaviorSubject(this.createGridRowContent(this.gridContentRowHeight));
        this.contentViewPortHeightSubject = new BehaviorSubject(0);
        this.horizontalScrollHeightSubject = new BehaviorSubject(this.gridContentMesh.horizontalScrollHeight);
        this.updateCdkVirtualScrollViewport = new Subject();
        this.gridTemplateColumnsSubject = new BehaviorSubject(this.gridContentMesh.getGridContentMeshTemplateColumns());
        this.gridTemplateRowsSubject = new BehaviorSubject(this.gridContentMesh.getGridContentMeshTemplateRows());
        this.gridHeaderTemplateRowsSubject = new BehaviorSubject('');
        /**
         * DkContentPanelDispatcher service will give us the greatest height of
         * every root list (root lists from left-panel, center-panel and right-panel).
         *
         * The greatest height of the lists will give us the grid-template-rows property
         * for the header:
         */
        this.contentPanelDispatcher.onListHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridContentMesh.headerRows = value;
            this.changeGridTemplateRows(this.gridContentMesh.getGridContentMeshTemplateRows());
            this.changeGridHeaderTemplateRows(this.gridContentMesh.headerRowHeight, this.gridContentMesh.headerRows);
            this.changeCdkScrollViewport();
        });
        this.gridFilterConfig.onAllowRowFilterChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridContentMesh.rowFiltering = value;
            this.changeGridTemplateRows(this.gridContentMesh.getGridContentMeshTemplateRows());
            this.changeCdkScrollViewport();
        });
    }
    ngOnDestroy() {
        this.headerRowHeightSubject.complete();
        this.filterRowHeightSubject.complete();
        this.contentRowHeightSubject.complete();
        this.contentViewPortHeightSubject.complete();
        this.horizontalScrollHeightSubject.complete();
        this.updateCdkVirtualScrollViewport.complete();
        this.gridTemplateColumnsSubject.complete();
        this.gridTemplateRowsSubject.complete();
        this.gridHeaderTemplateRowsSubject.complete();
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    get onGridTemplateColumnsChanged$() {
        return this.gridTemplateColumnsSubject.asObservable();
    }
    get onGridTemplateRowsChanged$() {
        return this.gridTemplateRowsSubject.asObservable();
    }
    get onGridHeaderTemplateRowsChanged$() {
        return this.gridHeaderTemplateRowsSubject.asObservable();
    }
    get onHeaderRowHeightChanged$() {
        return this.headerRowHeightSubject.asObservable();
    }
    get onFilterRowHeightChanged$() {
        return this.filterRowHeightSubject.asObservable();
    }
    get onContentRowHeightChanged$() {
        return this.contentRowHeightSubject.asObservable();
    }
    get onContentViewPortHeightChanged$() {
        return this.contentViewPortHeightSubject.asObservable();
    }
    get onHorizontalScrollHeightChanged$() {
        return this.horizontalScrollHeightSubject.asObservable();
    }
    get onUpdateCdkScrollViewport$() {
        return this.updateCdkVirtualScrollViewport.asObservable();
    }
    get headerRowHeight() {
        return this.gridHeaderRowHeight;
    }
    set headerRowHeight(height) {
        this.gridHeaderRowHeight = height > 0 ? height : this.dikeConfig.HEADER_ROW_HEIGHT;
        this.gridContentMesh.headerRowHeight = this.createGridRowHeader(this.gridHeaderRowHeight);
        this.changeHeaderRowHeight(this.createGridRowHeader(this.gridHeaderRowHeight));
        this.changeGridTemplateRows(this.gridContentMesh.getGridContentMeshTemplateRows());
        this.changeGridHeaderTemplateRows(this.gridContentMesh.headerRowHeight, this.gridContentMesh.headerRows);
        this.changeCdkScrollViewport();
    }
    get filterRowHeight() {
        return this.gridFilterRowHeight;
    }
    set filterRowHeight(height) {
        this.gridFilterRowHeight = height > 0 ? height : this.dikeConfig.FILTER_ROW_HEIGHT;
        this.gridContentMesh.filterRowHeight = this.createGridRowFilter(this.gridFilterRowHeight);
        // Despite the fact that the row-filter is hidden or not, the new value must be stored in the Behaviour Subject:
        this.changeFilterRowHeight(this.createGridRowFilter(this.gridFilterRowHeight));
        if (this.gridFilterConfig.allowRowFilter) {
            this.changeGridTemplateRows(this.gridContentMesh.getGridContentMeshTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    get contentRowHeight() {
        return this.gridContentRowHeight;
    }
    set contentRowHeight(height) {
        this.gridContentRowHeight = height > 0 ? height : this.dikeConfig.CONTENT_ROW_HEIGHT;
        this.gridContentMesh.contentRowHeight = this.createGridRowContent(this.gridContentRowHeight);
        this.changeContentRowHeight(this.createGridRowContent(this.gridContentRowHeight));
        this.changeCdkScrollViewport();
    }
    setContentViewPortHeight(height) {
        this.gridContentMesh.contentViewPortHeight = height > 0 ? height : 0;
        this.changeContentViewPortHeight(this.gridContentMesh.contentViewPortHeight);
    }
    getContentViewPortHeight() {
        return this.gridContentMesh.contentViewPortHeight;
    }
    setHorizontalScrollHeight(height) {
        this.gridContentMesh.horizontalScrollHeight = height > 0 ? height : this.dikeConfig.HORIZONTAL_SCROLL_HEIGHT;
        this.changeHorizontalScrollHeight(this.gridContentMesh.horizontalScrollHeight);
        this.changeGridTemplateRows(this.gridContentMesh.getGridContentMeshTemplateRows());
        this.changeCdkScrollViewport();
    }
    createGridRowHeader(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    createGridRowFilter(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    createGridRowContent(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    changeHeaderRowHeight(headerRow) {
        this.headerRowHeightSubject.next(headerRow);
    }
    changeFilterRowHeight(filterRow) {
        this.filterRowHeightSubject.next(filterRow);
    }
    changeContentRowHeight(contentRow) {
        this.contentRowHeightSubject.next(contentRow);
    }
    changeContentViewPortHeight(height) {
        this.contentViewPortHeightSubject.next(height);
    }
    changeHorizontalScrollHeight(horizontalScrollHeight) {
        this.horizontalScrollHeightSubject.next(horizontalScrollHeight);
    }
    changeCdkScrollViewport() {
        this.updateCdkVirtualScrollViewport.next();
    }
    changeGridTemplateRows(templateRows) {
        this.gridTemplateRowsSubject.next(templateRows);
    }
    changeGridHeaderTemplateRows(headerRow, rows) {
        let templateRows = `${headerRow.contentHeight}px ${headerRow.horizontalGutterHeight}px `;
        this.gridHeaderTemplateRowsSubject.next(templateRows.repeat(rows));
    }
}
DkGridContentStructure.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentStructure, deps: [{ token: CONFIG_GRID }, { token: HEADER_ROW_HEIGHT, optional: true }, { token: FILTER_ROW_HEIGHT, optional: true }, { token: CONTENT_ROW_HEIGHT, optional: true }, { token: DkGridFilterConfig }, { token: DkContentPanelDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridContentStructure.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentStructure });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentStructure, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [HEADER_ROW_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [FILTER_ROW_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CONTENT_ROW_HEIGHT]
                    }] }, { type: DkGridFilterConfig }, { type: DkContentPanelDispatcher }];
    } });

class DkGridUI {
    constructor(dikeConfig) {
        this.dikeConfig = dikeConfig;
        this.gridElevationSubject = new BehaviorSubject(false);
        this.gridElevationValueSubject = new BehaviorSubject(this.dikeConfig.GRID_ELEVATION);
        this.gridElevationClassSubject = new BehaviorSubject(this.createMatElevationClass(this.dikeConfig.GRID_ELEVATION));
        this.verticalRowLinesSubject = new BehaviorSubject(this.dikeConfig.VERTICAL_ROW_LINES);
        this.stripedRowsSubject = new BehaviorSubject(this.dikeConfig.STRIPED_ROWS);
    }
    ngOnDestroy() {
        this.verticalRowLinesSubject.complete();
        this.stripedRowsSubject.complete();
    }
    get onGridElevationChanged$() {
        return this.gridElevationSubject.asObservable();
    }
    get onGridElevationValueChanged$() {
        return this.gridElevationValueSubject.asObservable();
    }
    get onGridElevationClassChanged$() {
        return this.gridElevationClassSubject.asObservable();
    }
    get onVerticalRowLinesChanged$() {
        return this.verticalRowLinesSubject.asObservable();
    }
    get onStripedRowsChanged$() {
        return this.stripedRowsSubject.asObservable();
    }
    get gridElevation() {
        return this.gridElevationSubject.value;
    }
    set gridElevation(value) {
        this.changeGridElevation(value);
    }
    get gridElevationValue() {
        return this.gridElevationValueSubject.value;
    }
    set gridElevationValue(value) {
        let elevationValue = this.dikeConfig.GRID_ELEVATION;
        if (value >= this.dikeConfig.MIN_GRID_ELEVATION && value <= this.dikeConfig.MAX_GRID_ELEVATION) {
            elevationValue = value;
        }
        this.changeGridElevationValue(elevationValue);
        this.changeGridElevationClass(this.createMatElevationClass(elevationValue));
    }
    get verticalRowLines() {
        return this.verticalRowLinesSubject.value;
    }
    set verticalRowLines(value) {
        this.changeVerticalRowLines(value);
    }
    get stripedRows() {
        return this.stripedRowsSubject.value;
    }
    set stripedRows(value) {
        this.changeStripedRows(value);
    }
    isInOrderComplementGutterHidden(panel, isThereOuterColumns, panelsVisibility) {
        if (panelsVisibility.L || panelsVisibility.LR || panelsVisibility.C || panelsVisibility.CR) {
            /**
             * In this scenario it does not matter the panel beacuse it is only displayed L or C
             * which are an inOrder panel. Then the validation onluy depends on outer columns visibility:
             */
            return !isThereOuterColumns;
        }
        else if ((panelsVisibility.LC || panelsVisibility.LCR) && panel === 'leftPanel') {
            /**
             * In this scenario both inOrder panels are displayed. The condition depends on left panel
             * rendering. It means when the center panel header instance is rendering, its complement gutter
             * is always visible:
             */
            return !isThereOuterColumns;
        }
        // By default the complement gutter for inOrder panel is always visible:
        return false;
    }
    createMatElevationClass(value) {
        return `mat-elevation-z${value}`;
    }
    changeGridElevation(value) {
        this.gridElevationSubject.next(value);
    }
    changeGridElevationValue(value) {
        this.gridElevationValueSubject.next(value);
    }
    changeGridElevationClass(value) {
        this.gridElevationClassSubject.next(value);
    }
    changeVerticalRowLines(value) {
        this.verticalRowLinesSubject.next(value);
    }
    changeStripedRows(value) {
        this.stripedRowsSubject.next(value);
    }
}
DkGridUI.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridUI, deps: [{ token: CONFIG_GRID }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridUI.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridUI });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridUI, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }];
    } });

class RowFilterColumnIdPipe {
    constructor(gridFilterConfig) {
        this.gridFilterConfig = gridFilterConfig;
    }
    transform(columnId) {
        return this.gridFilterConfig.getRowFilterColumnId(columnId);
    }
}
RowFilterColumnIdPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFilterColumnIdPipe, deps: [{ token: DkGridFilterConfig }], target: i0.ɵɵFactoryTarget.Pipe });
RowFilterColumnIdPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFilterColumnIdPipe, name: "rowFilterColumnId" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFilterColumnIdPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'rowFilterColumnId'
                }]
        }], ctorParameters: function () { return [{ type: DkGridFilterConfig }]; } });

class DkRowFilterComponent {
    constructor(cdr, gridContentStructure, gridUI, gridFilterConfig, gridEditionConfig, contentPanelDispatcher) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.gridUI = gridUI;
        this.gridFilterConfig = gridFilterConfig;
        this.gridEditionConfig = gridEditionConfig;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.isThereOuterColumns = false;
        this.inOrderComplementGutterVisibility = true;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.panel = this.columnStructure.panel;
        this.scrollbarSlot$ = this.columnStructure.onScrollbarGapSlotChanged$;
        this.horizontalGutterSlot$ = this.columnStructure.onHorizontalGutterSlotChanged$;
        this.gutterSlotAction$ = merge(this.columnStructure.onGutterSlotOverChanged$, this.columnStructure.onGutterSlotResizingChanged$);
        this.outerColumnSlots$ = this.columnStructure.onOuterColumnSlotsChanged$;
        this.visibleDataColumnSlots$ = combineLatest([
            this.columnStructure.onDataColumnSlotsChanged$,
            this.columnStructure.onOuterColumnSlotsChanged$,
            this.contentPanelDispatcher.onPanelsVisibilityChanged$
        ]).pipe(map(([dataSlots, outerSlots, panelsVisibility]) => {
            this.isThereOuterColumns = outerSlots.length > 0;
            this.panelsVisibility = panelsVisibility;
            this.inOrderComplementGutterVisibility = !this.gridUI.isInOrderComplementGutterHidden(this.panel, this.isThereOuterColumns, this.panelsVisibility);
            let visibleDataSlots = dataSlots.filter(slot => slot.dikeColumn.visible);
            visibleDataSlots.forEach(slot => {
                let rowFilterColumnId = this.gridFilterConfig.getRowFilterColumnId(slot.dikeColumn.columnId);
                if (!this.gridFilterConfig.filterables.has(rowFilterColumnId)) {
                    this.gridFilterConfig.register({
                        columnId: rowFilterColumnId,
                        fieldName: slot.dikeColumn.fieldName,
                        headerText: slot.dikeColumn.headerText,
                        dataType: slot.dikeColumn.dataType === 'Binary' ? 'Text' : slot.dikeColumn.dataType
                    });
                }
            });
            return visibleDataSlots;
        }));
        this.gridEditionConfig.onEditionFilterStateChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.editionFilterState = value;
            this.cdr.markForCheck();
        });
        this.gridContentStructure.onFilterRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.filterRowHeightPx = `${value.contentHeight}px`;
            this.filterHorizontalGutterHeightPx = `${value.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
        this.gridUI.onVerticalRowLinesChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.isVerticalRowsVisible = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        // Before destroying the dike-row-filter component, remove all the row-filterables from the Map structure:
        this.columnStructure.removeAllFilterables(true);
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkRowFilterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowFilterComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }, { token: DkGridUI }, { token: DkGridFilterConfig }, { token: DkGridEditionConfig }, { token: DkContentPanelDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkRowFilterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkRowFilterComponent, selector: "dk-row-filter", inputs: { columnStructure: "columnStructure" }, ngImport: i0, template: "<div class=\"dkg-row-filter-wrapper\"\n  [dkGridTemplateColumnsHeader]=\"columnStructure\">\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n\n      [cellHeight]=\"filterRowHeightPx\">\n\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"filterRowHeightPx\"\n      [isEmpty]=\"!isVerticalRowsVisible\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container [ngSwitch]=\"panel\">\n\n    <ng-container *ngSwitchCase=\"'rightPanel'\">\n      <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngSwitchDefault>\n      <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n  </ng-container>\n\n  <div *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\">\n\n  </div>\n\n  <ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n    <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"hgSlot.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\"\n        [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n        [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-container>\n\n  <ng-template #completeGutter>\n    <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n      [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n  </ng-template>\n\n  <ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n        [isEmpty]=\"!isVerticalRowsVisible || !inOrderComplementGutterVisibility\"\n        [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-empty-cell\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n        [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n        [cellHeight]=\"filterRowHeightPx\"\n        [contentAlign]=\"columnSlot.dikeColumn.contentAlign\">\n\n        <ng-container [ngTemplateOutlet]=\"editionFilterState ? rowEditionFilter : rowDataFilter\"\n          [ngTemplateOutletContext]=\"{ contentAlign: columnSlot.dikeColumn.contentAlign, rowColumnId: columnSlot.dikeColumn.columnId | rowFilterColumnId }\">\n        </ng-container>\n\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalRowsVisible\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n        [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalRowsVisible\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n        [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-empty-cell\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n        [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n        [cellHeight]=\"filterRowHeightPx\"\n        [contentAlign]=\"columnSlot.dikeColumn.contentAlign\">\n\n        <ng-container [ngTemplateOutlet]=\"editionFilterState ? rowEditionFilter : rowDataFilter\"\n          [ngTemplateOutletContext]=\"{ contentAlign: columnSlot.dikeColumn.contentAlign, rowColumnId: columnSlot.dikeColumn.columnId | rowFilterColumnId }\">\n        </ng-container>\n\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n        [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n      </dk-grid-vertical-gutter>\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #rowDataFilter let-contentAlign=\"contentAlign\" let-columnId=\"rowColumnId\">\n    <dk-column-filter\n      [contentAlign]=\"contentAlign\"\n      [isFilterRow]=\"true\"\n      [columnId]=\"columnId\">\n    </dk-column-filter>\n  </ng-template>\n\n  <ng-template #rowEditionFilter let-contentAlign=\"contentAlign\" let-columnId=\"rowColumnId\">\n    <dk-column-filter\n      [contentAlign]=\"contentAlign\"\n      [isFilterRow]=\"true\"\n      [columnId]=\"columnId\">\n    </dk-column-filter>\n  </ng-template>\n\n</div>\n", styles: [".dkg-row-filter-wrapper{height:100%;display:grid;grid-template-rows:1fr 3px}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: DkColumnFilterComponent, selector: "dk-column-filter", inputs: ["columnId", "isFilterRow", "contentAlign"], exportAs: ["dkgColumnFilter"] }], directives: [{ type: DkGridTemplateColumnsHeaderDirective, selector: "[dkGridTemplateColumnsHeader]", inputs: ["dkGridTemplateColumnsHeader"], exportAs: ["dkgTemplateColumnsHeader"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i8.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: ["dkGridColResizer", "columnStructure", "resizerType", "columnId", "gutterSlot"], exportAs: ["dkgColResizer"] }], pipes: { "async": i8.AsyncPipe, "gutterFlexboxPosition": GutterFlexboxPositionPipe, "rowFilterColumnId": RowFilterColumnIdPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-row-filter', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-filter-wrapper\"\n  [dkGridTemplateColumnsHeader]=\"columnStructure\">\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n\n      [cellHeight]=\"filterRowHeightPx\">\n\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"filterRowHeightPx\"\n      [isEmpty]=\"!isVerticalRowsVisible\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container [ngSwitch]=\"panel\">\n\n    <ng-container *ngSwitchCase=\"'rightPanel'\">\n      <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngSwitchDefault>\n      <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n  </ng-container>\n\n  <div *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\">\n\n  </div>\n\n  <ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n    <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"hgSlot.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\"\n        [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n        [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n        [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-container>\n\n  <ng-template #completeGutter>\n    <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n      [gutterHeight]=\"filterHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n  </ng-template>\n\n  <ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n        [isEmpty]=\"!isVerticalRowsVisible || !inOrderComplementGutterVisibility\"\n        [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-empty-cell\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n        [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n        [cellHeight]=\"filterRowHeightPx\"\n        [contentAlign]=\"columnSlot.dikeColumn.contentAlign\">\n\n        <ng-container [ngTemplateOutlet]=\"editionFilterState ? rowEditionFilter : rowDataFilter\"\n          [ngTemplateOutletContext]=\"{ contentAlign: columnSlot.dikeColumn.contentAlign, rowColumnId: columnSlot.dikeColumn.columnId | rowFilterColumnId }\">\n        </ng-container>\n\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalRowsVisible\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n        [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalRowsVisible\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n        [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-empty-cell\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n        [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n        [cellHeight]=\"filterRowHeightPx\"\n        [contentAlign]=\"columnSlot.dikeColumn.contentAlign\">\n\n        <ng-container [ngTemplateOutlet]=\"editionFilterState ? rowEditionFilter : rowDataFilter\"\n          [ngTemplateOutletContext]=\"{ contentAlign: columnSlot.dikeColumn.contentAlign, rowColumnId: columnSlot.dikeColumn.columnId | rowFilterColumnId }\">\n        </ng-container>\n\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"filterRowHeightPx\"\n        [isEmpty]=\"!isVerticalRowsVisible\"\n        [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n        [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n      </dk-grid-vertical-gutter>\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #rowDataFilter let-contentAlign=\"contentAlign\" let-columnId=\"rowColumnId\">\n    <dk-column-filter\n      [contentAlign]=\"contentAlign\"\n      [isFilterRow]=\"true\"\n      [columnId]=\"columnId\">\n    </dk-column-filter>\n  </ng-template>\n\n  <ng-template #rowEditionFilter let-contentAlign=\"contentAlign\" let-columnId=\"rowColumnId\">\n    <dk-column-filter\n      [contentAlign]=\"contentAlign\"\n      [isFilterRow]=\"true\"\n      [columnId]=\"columnId\">\n    </dk-column-filter>\n  </ng-template>\n\n</div>\n", styles: [".dkg-row-filter-wrapper{height:100%;display:grid;grid-template-rows:1fr 3px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }, { type: DkGridUI }, { type: DkGridFilterConfig }, { type: DkGridEditionConfig }, { type: DkContentPanelDispatcher }]; }, propDecorators: { columnStructure: [{
                type: Input
            }] } });

class DkFilteringModule {
}
DkFilteringModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilteringModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkFilteringModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilteringModule, declarations: [DkBinaryFilterComponent,
        DkColumnFilterComponent,
        DkDateFilterComponent,
        DkMultipleNumericFilterComponent,
        DkMultipleTextFilterComponent,
        DkNumericFilterComponent,
        DkRowFilterComponent,
        DkTextFilterComponent,
        RowFilterColumnIdPipe], imports: [CommonModule,
        ReactiveFormsModule,
        MatIconModule,
        MatCheckboxModule,
        MatSelectModule,
        MatListModule,
        MatFormFieldModule,
        MatRadioModule,
        MatDatepickerModule,
        MatInputModule,
        MatButtonModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkColumnFilterComponent,
        DkRowFilterComponent] });
DkFilteringModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilteringModule, imports: [[
            CommonModule,
            ReactiveFormsModule,
            MatIconModule,
            MatCheckboxModule,
            MatSelectModule,
            MatListModule,
            MatFormFieldModule,
            MatRadioModule,
            MatDatepickerModule,
            MatInputModule,
            MatButtonModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilteringModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkBinaryFilterComponent,
                        DkColumnFilterComponent,
                        DkDateFilterComponent,
                        DkMultipleNumericFilterComponent,
                        DkMultipleTextFilterComponent,
                        DkNumericFilterComponent,
                        DkRowFilterComponent,
                        DkTextFilterComponent,
                        RowFilterColumnIdPipe
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatIconModule,
                        MatCheckboxModule,
                        MatSelectModule,
                        MatListModule,
                        MatFormFieldModule,
                        MatRadioModule,
                        MatDatepickerModule,
                        MatInputModule,
                        MatButtonModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkColumnFilterComponent,
                        DkRowFilterComponent
                    ]
                }]
        }] });

class DkGridMesh {
    constructor() {
        this.topBorder = { borderId: generateUUID(), borderGap: 0, borderWidth: 0, borderType: 'topBorder' };
        this.rightBorder = { borderId: generateUUID(), borderGap: 0, borderWidth: 0, borderType: 'rightBorder' };
        this.bottomBorder = { borderId: generateUUID(), borderGap: 0, borderWidth: 0, borderType: 'bottomBorder' };
        this.leftBorder = { borderId: generateUUID(), borderGap: 0, borderWidth: 0, borderType: 'leftBorder' };
        this.rhFooter = 0;
        this.gridAllowRowGrouping = false;
        this.gridRowGrouping = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.gridAllowPagination = false;
        this.gridRowPaginator = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.gridEditionToolbarVisible = false;
        this.gridEditionToolbarPosition = 'bottom';
        this.gridEditionToolbarRow = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.contentContainer = '1fr';
        this.gridSize = {
            width: 0,
            height: 0
        };
    }
    get borderTop() {
        return this.topBorder;
    }
    set borderTop(value) {
        if (value.borderType === 'topBorder') {
            this.topBorder.borderGap = value.borderGap > 0 ? value.borderGap : 0;
            this.topBorder.borderWidth = value.borderWidth > 0 ? value.borderWidth : 0;
        }
    }
    get borderRight() {
        return this.rightBorder;
    }
    set borderRight(value) {
        if (value.borderType === 'rightBorder') {
            this.rightBorder.borderGap = value.borderGap > 0 ? value.borderGap : 0;
            this.rightBorder.borderWidth = value.borderWidth > 0 ? value.borderWidth : 0;
        }
    }
    get borderBottom() {
        return this.bottomBorder;
    }
    set borderBottom(value) {
        if (value.borderType === 'bottomBorder') {
            this.bottomBorder.borderGap = value.borderGap > 0 ? value.borderGap : 0;
            this.bottomBorder.borderWidth = value.borderWidth > 0 ? value.borderWidth : 0;
        }
    }
    get borderLeft() {
        return this.leftBorder;
    }
    set borderLeft(value) {
        if (value.borderType === 'leftBorder') {
            this.leftBorder.borderGap = value.borderGap > 0 ? value.borderGap : 0;
            this.leftBorder.borderWidth = value.borderWidth > 0 ? value.borderWidth : 0;
        }
    }
    get allowRowGrouping() {
        return this.gridAllowRowGrouping;
    }
    set allowRowGrouping(value) {
        this.gridAllowRowGrouping = value;
    }
    get rowGroupingRow() {
        return this.gridRowGrouping;
    }
    set rowGroupingRow(value) {
        this.gridRowGrouping.contentHeight = value.contentHeight > 0 ? value.contentHeight : 0;
        this.gridRowGrouping.horizontalGutterHeight = value.horizontalGutterHeight > 0 ? value.horizontalGutterHeight : 0;
        this.gridRowGrouping.rowHeight = this.gridRowGrouping.contentHeight + this.gridRowGrouping.horizontalGutterHeight;
    }
    get allowPagination() {
        return this.gridAllowPagination;
    }
    set allowPagination(value) {
        this.gridAllowPagination = value;
    }
    get paginatorRow() {
        return this.gridRowPaginator;
    }
    set paginatorRow(value) {
        this.gridRowPaginator.contentHeight = value.contentHeight > 0 ? value.contentHeight : 0;
        this.gridRowPaginator.horizontalGutterHeight = value.horizontalGutterHeight > 0 ? value.horizontalGutterHeight : 0;
        this.gridRowPaginator.rowHeight = this.gridRowPaginator.contentHeight + this.gridRowPaginator.horizontalGutterHeight;
    }
    get footerRowHeight() {
        return this.rhFooter;
    }
    set footerRowHeight(height) {
        this.rhFooter = height > 0 ? height : 0;
    }
    get displayEditionToolbar() {
        return this.gridEditionToolbarVisible;
    }
    set displayEditionToolbar(value) {
        this.gridEditionToolbarVisible = value;
    }
    get editionToolbarPosition() {
        return this.gridEditionToolbarPosition;
    }
    set editionToolbarPosition(value) {
        this.gridEditionToolbarPosition = value;
    }
    get editionToolbarRow() {
        return this.gridEditionToolbarRow;
    }
    set editionToolbarRow(value) {
        this.gridEditionToolbarRow.contentHeight = value.contentHeight > 0 ? value.contentHeight : 0;
        this.gridEditionToolbarRow.horizontalGutterHeight = value.horizontalGutterHeight > 0 ? value.horizontalGutterHeight : 0;
        this.gridEditionToolbarRow.rowHeight = this.gridEditionToolbarRow.contentHeight + this.gridEditionToolbarRow.horizontalGutterHeight;
    }
    get size() {
        return this.gridSize;
    }
    set size(value) {
        this.gridSize.width = value.width;
        this.gridSize.height = value.height;
    }
    getGridMeshTemplateRows() {
        let rowGroupingRow = this.gridAllowRowGrouping && this.gridRowGrouping.rowHeight > 0 ? `${this.gridRowGrouping.rowHeight}px` : '';
        let paginatorRow = this.gridAllowPagination && this.gridRowPaginator.rowHeight > 0 ? `${this.gridRowPaginator.rowHeight}px` : '';
        let footerRow = this.rhFooter > 0 ? `${this.rhFooter}px` : '';
        let editionToolbarRow = this.gridEditionToolbarVisible && this.gridEditionToolbarRow.rowHeight > 0 ? `${this.gridEditionToolbarRow.rowHeight}px` : '';
        let finalTemplate = this.gridEditionToolbarPosition === 'top' ?
            `${editionToolbarRow} ${rowGroupingRow} ${this.contentContainer} ${paginatorRow} ${footerRow}`.trim() :
            `${rowGroupingRow} ${this.contentContainer} ${editionToolbarRow} ${paginatorRow} ${footerRow}`.trim();
        return finalTemplate;
    }
    getGridMeshTemplateColumns() {
        return '1fr';
    }
    getMainWrapperTemplateRows() {
        let topBorderColumn = this.topBorder.borderGap > 0 ? `${this.topBorder.borderGap}px` : '';
        let bottomBorderColumn = this.bottomBorder.borderGap > 0 ? `${this.bottomBorder.borderGap}px` : '';
        return `${topBorderColumn} ${this.contentContainer} ${bottomBorderColumn}`.trim();
    }
    getMainWrapperTemplateColumns() {
        let leftBorderColumn = this.leftBorder.borderGap > 0 ? `${this.leftBorder.borderGap}px` : '';
        let rightBorderColumn = this.rightBorder.borderGap > 0 ? `${this.rightBorder.borderGap}px` : '';
        return `${leftBorderColumn} ${this.contentContainer} ${rightBorderColumn}`.trim();
    }
}

class DkPaginationDispatcher {
    constructor(dikeConfig) {
        this.dikeConfig = dikeConfig;
        this.allowPaginationSubject = new BehaviorSubject(this.dikeConfig.ALLOW_PAGINATION);
        this.paginatorSubject = new BehaviorSubject(null);
        this.pageEmitter = new EventEmitter();
        this.paginatorEmitter = new EventEmitter();
    }
    ngOnDestroy() {
        this.allowPaginationSubject.complete();
    }
    get onPaginatorChanged$() {
        return this.paginatorSubject.asObservable();
    }
    get onAllowPaginationChanged$() {
        return this.allowPaginationSubject.asObservable();
    }
    get paginator() {
        return this.paginatorSubject.value;
    }
    set paginator(value) {
        this.changePaginator(value);
    }
    get allowPagination() {
        return this.allowPaginationSubject.value;
    }
    set allowPagination(value) {
        this.changeAllowPagination(value);
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    changePaginator(value) {
        this.paginatorSubject.next(value);
    }
    changeAllowPagination(value) {
        this.allowPaginationSubject.next(value);
    }
}
DkPaginationDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPaginationDispatcher, deps: [{ token: CONFIG_GRID }], target: i0.ɵɵFactoryTarget.Injectable });
DkPaginationDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPaginationDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPaginationDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }];
    } });

class DkGridStructure {
    constructor(dikeConfig, gridRowGroupingRowHeight, gridRowGroupingColumnHeight, gridPaginationRowHeight, gridEditionToolbarRowHeight, gridEditionToolbarItemHeight, gridBorderWidth, gridBorderGap, paginationDispatcher, gridEditionConfig, rowGroupingConfig) {
        this.dikeConfig = dikeConfig;
        this.gridRowGroupingRowHeight = gridRowGroupingRowHeight;
        this.gridRowGroupingColumnHeight = gridRowGroupingColumnHeight;
        this.gridPaginationRowHeight = gridPaginationRowHeight;
        this.gridEditionToolbarRowHeight = gridEditionToolbarRowHeight;
        this.gridEditionToolbarItemHeight = gridEditionToolbarItemHeight;
        this.gridBorderWidth = gridBorderWidth;
        this.gridBorderGap = gridBorderGap;
        this.paginationDispatcher = paginationDispatcher;
        this.gridEditionConfig = gridEditionConfig;
        this.rowGroupingConfig = rowGroupingConfig;
        this.changesAllowRowGroupingSubscription = Subscription.EMPTY;
        this.changesAllowPaginationSubscription = Subscription.EMPTY;
        this.changesEditionConfigSubscription = Subscription.EMPTY;
        if (this.gridRowGroupingRowHeight === null || this.gridRowGroupingRowHeight === undefined) {
            this.gridRowGroupingRowHeight = this.dikeConfig.ROW_GROUPING_ROW_HEIGHT;
        }
        if (this.gridRowGroupingColumnHeight === null || this.gridRowGroupingColumnHeight === undefined) {
            this.gridRowGroupingColumnHeight = this.dikeConfig.ROW_GROUPING_COLUMN_HEIGHT;
        }
        if (this.gridPaginationRowHeight === null || this.gridPaginationRowHeight === undefined) {
            this.gridPaginationRowHeight = this.dikeConfig.PAGINATION_ROW_HEIGHT;
        }
        if (this.gridEditionToolbarRowHeight === null || this.gridEditionToolbarRowHeight === undefined) {
            this.gridEditionToolbarRowHeight = this.dikeConfig.EDITION_TOOLBAR_ROW_HEIGHT;
        }
        if (this.gridEditionToolbarItemHeight === null || this.gridEditionToolbarItemHeight === undefined) {
            this.gridEditionToolbarItemHeight = this.dikeConfig.EDITION_TOOLBAR_ITEM_HEIGHT;
        }
        if (this.gridBorderWidth === null || this.gridBorderWidth === undefined || this.gridBorderWidth <= 0) {
            this.gridBorderWidth = this.dikeConfig.BORDER_WIDTH;
        }
        if (this.gridBorderGap === null || this.gridBorderGap === undefined || this.gridBorderGap <= 0) {
            this.gridBorderGap = this.dikeConfig.BORDER_GAP;
        }
        this.wrapperId = generateUUID();
        this.gridMesh = new DkGridMesh();
        this.gridSizeSubject = new BehaviorSubject(this.createGridSize(this.gridMesh.size));
        this.gridMesh.displayEditionToolbar = this.gridEditionConfig.allowEdition && this.gridEditionConfig.editionMode && this.gridEditionConfig.editionToolbar;
        this.gridMesh.editionToolbarPosition = this.gridEditionConfig.editionToolbarPosition;
        this.gridMesh.editionToolbarRow = this.createGridRowToolbar(this.gridEditionToolbarRowHeight);
        this.editionToolbarVisibilitySubject = new BehaviorSubject(this.gridMesh.displayEditionToolbar);
        this.editionToolbarRowSubject = new BehaviorSubject(this.createGridRowToolbar(this.gridEditionToolbarRowHeight));
        this.editionToolbarItemHeightSubject = new BehaviorSubject(this.gridEditionToolbarItemHeight);
        this.gridMesh.allowRowGrouping = this.rowGroupingConfig.allowRowGrouping;
        this.gridMesh.rowGroupingRow = this.createGridRowGrouping(this.gridRowGroupingRowHeight);
        this.rowGroupingSubject = new BehaviorSubject(this.createGridRowGrouping(this.gridRowGroupingRowHeight));
        this.rowGroupingColumnHeightSubject = new BehaviorSubject(this.gridRowGroupingColumnHeight);
        this.gridMesh.allowPagination = this.paginationDispatcher.allowPagination;
        this.gridMesh.paginatorRow = this.createGridRowPagination(this.gridPaginationRowHeight);
        this.paginationRowSubject = new BehaviorSubject(this.createGridRowPagination(this.gridPaginationRowHeight));
        this.gridMesh.borderTop = { borderGap: this.gridBorderGap, borderWidth: this.gridBorderWidth, borderType: 'topBorder' };
        this.borderTopSubject = new BehaviorSubject(this.createGridBorder(this.gridMesh.borderTop));
        this.gridMesh.borderRight = { borderGap: this.gridBorderGap, borderWidth: this.gridBorderWidth, borderType: 'rightBorder' };
        this.borderRightSubject = new BehaviorSubject(this.createGridBorder(this.gridMesh.borderRight));
        this.gridMesh.borderBottom = { borderGap: this.gridBorderGap, borderWidth: this.gridBorderWidth, borderType: 'bottomBorder' };
        this.borderBottomSubject = new BehaviorSubject(this.createGridBorder(this.gridMesh.borderBottom));
        this.gridMesh.borderLeft = { borderGap: this.gridBorderGap, borderWidth: this.gridBorderWidth, borderType: 'leftBorder' };
        this.borderLeftSubject = new BehaviorSubject(this.createGridBorder(this.gridMesh.borderLeft));
        this.updateCdkVirtualScrollViewport = new Subject();
        this.gridTemplateColumnsSubject = new BehaviorSubject(this.gridMesh.getGridMeshTemplateColumns());
        this.gridTemplateRowsSubject = new BehaviorSubject(this.gridMesh.getGridMeshTemplateRows());
        this.mainWrapperTemplateColumnsSubject = new BehaviorSubject(this.gridMesh.getMainWrapperTemplateColumns());
        this.mainWrapperTemplateRowsSubject = new BehaviorSubject(this.gridMesh.getMainWrapperTemplateRows());
        this.setChangesAllowRowGroupingSubscription();
        this.setChangesAllowPaginationSubscription();
        this.setChangeEditionConfigSubscription();
    }
    ngOnDestroy() {
        this.gridSizeSubject.complete();
        this.editionToolbarVisibilitySubject.complete();
        this.editionToolbarRowSubject.complete();
        this.editionToolbarItemHeightSubject.complete();
        this.rowGroupingSubject.complete();
        this.rowGroupingColumnHeightSubject.complete();
        this.paginationRowSubject.complete();
        this.borderTopSubject.complete();
        this.borderRightSubject.complete();
        this.borderBottomSubject.complete();
        this.borderLeftSubject.complete();
        this.updateCdkVirtualScrollViewport.complete();
        this.gridTemplateColumnsSubject.complete();
        this.gridTemplateRowsSubject.complete();
        this.mainWrapperTemplateColumnsSubject.complete();
        this.mainWrapperTemplateRowsSubject.complete();
        this.changesAllowRowGroupingSubscription.unsubscribe();
        this.changesAllowPaginationSubscription.unsubscribe();
        this.changesEditionConfigSubscription.unsubscribe();
    }
    get onGridSizeChanged$() {
        return this.gridSizeSubject.asObservable();
    }
    get mainWrapperId() {
        return this.wrapperId;
    }
    get mainWrapperElementRef() {
        return this.wrapperElementRef;
    }
    set mainWrapperElementRef(value) {
        this.wrapperElementRef = value;
    }
    get onMainWrapperTemplateColumnsChanged$() {
        return this.mainWrapperTemplateColumnsSubject.asObservable();
    }
    get onMainWrapperTemplateRowsChanged$() {
        return this.mainWrapperTemplateRowsSubject.asObservable();
    }
    get onGridTemplateColumnsChanged$() {
        return this.gridTemplateColumnsSubject.asObservable();
    }
    get onGridTemplateRowsChanged$() {
        return this.gridTemplateRowsSubject.asObservable();
    }
    get onEditionToolbarVisibilityChanged$() {
        return this.editionToolbarVisibilitySubject.asObservable();
    }
    get onEditionToolbarRowChanged$() {
        return this.editionToolbarRowSubject.asObservable();
    }
    get onEditionToolbarItemHeightChanged$() {
        return this.editionToolbarItemHeightSubject.asObservable();
    }
    get onRowGroupingRowChanged$() {
        return this.rowGroupingSubject.asObservable();
    }
    get onRowGroupingColumnHeightChanged$() {
        return this.rowGroupingColumnHeightSubject.asObservable();
    }
    get onPaginationRowChanged$() {
        return this.paginationRowSubject.asObservable();
    }
    get onBorderTopChanged$() {
        return this.borderTopSubject.asObservable();
    }
    get onBorderRightChanged$() {
        return this.borderRightSubject.asObservable();
    }
    get onBorderBottomChanged$() {
        return this.borderBottomSubject.asObservable();
    }
    get onBorderLeftChanged$() {
        return this.borderLeftSubject.asObservable();
    }
    get onUpdateCdkScrollViewport$() {
        return this.updateCdkVirtualScrollViewport.asObservable();
    }
    get borderWidth() {
        return this.gridBorderWidth;
    }
    get borderGap() {
        return this.gridBorderGap;
    }
    setGridSize(size) {
        this.gridMesh.size.height = size.height > 0 ? size.height : 0;
        this.gridMesh.size.width = size.width > 0 ? size.width : 0;
        this.changeGridSize(this.createGridSize(this.gridMesh.size));
        this.changeCdkScrollViewport();
    }
    setBorderTop(borderTop) {
        if (borderTop.borderType === 'topBorder') {
            this.gridMesh.borderTop = {
                borderGap: borderTop.borderGap > 0 ? borderTop.borderGap : this.gridBorderGap,
                borderWidth: borderTop.borderWidth > 0 ? borderTop.borderWidth : this.gridBorderWidth,
                borderType: 'topBorder'
            };
            this.changeBorderTop(this.createGridBorder(this.gridMesh.borderTop));
            this.changeMainWrapperTemplateRows(this.gridMesh.getMainWrapperTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    setBorderRight(borderRight) {
        if (borderRight.borderType === 'rightBorder') {
            this.gridMesh.borderRight = {
                borderGap: borderRight.borderGap > 0 ? borderRight.borderGap : this.gridBorderGap,
                borderWidth: borderRight.borderWidth > 0 ? borderRight.borderWidth : this.gridBorderWidth,
                borderType: 'rightBorder'
            };
            this.changeBorderRight(this.createGridBorder(this.gridMesh.borderRight));
            this.changeMainWrapperTemplateColumns(this.gridMesh.getMainWrapperTemplateColumns());
            this.changeCdkScrollViewport();
        }
    }
    setBorderBottom(borderBottom) {
        if (borderBottom.borderType === 'bottomBorder') {
            this.gridMesh.borderBottom = {
                borderGap: borderBottom.borderGap > 0 ? borderBottom.borderGap : this.gridBorderGap,
                borderWidth: borderBottom.borderWidth > 0 ? borderBottom.borderWidth : this.gridBorderWidth,
                borderType: 'bottomBorder'
            };
            this.changeBorderBottom(this.createGridBorder(this.gridMesh.borderBottom));
            this.changeMainWrapperTemplateRows(this.gridMesh.getMainWrapperTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    setBorderLeft(borderLeft) {
        if (borderLeft.borderType === 'leftBorder') {
            this.gridMesh.borderLeft = {
                borderGap: borderLeft.borderGap > 0 ? borderLeft.borderGap : this.gridBorderGap,
                borderWidth: borderLeft.borderWidth > 0 ? borderLeft.borderWidth : this.gridBorderWidth,
                borderType: 'leftBorder'
            };
            this.changeBorderLeft(this.createGridBorder(this.gridMesh.borderLeft));
            this.changeMainWrapperTemplateColumns(this.gridMesh.getMainWrapperTemplateColumns());
            this.changeCdkScrollViewport();
        }
    }
    get editionToolbarRow() {
        return this.editionToolbarRowSubject.value;
    }
    get editionToolbarRowHeight() {
        return this.gridEditionToolbarRowHeight;
    }
    set editionToolbarRowHeight(height) {
        this.gridEditionToolbarRowHeight = height > 0 ? height : this.dikeConfig.EDITION_TOOLBAR_ROW_HEIGHT;
        this.gridMesh.editionToolbarRow = this.createGridRowToolbar(this.gridEditionToolbarRowHeight);
        // It does not matter if the edition toolbar is hidden, the new value must be stored in the Behaviour Subject:
        this.changeEditionToolbarRow(this.createGridRowToolbar(this.gridEditionToolbarRowHeight));
        if (this.gridMesh.displayEditionToolbar) {
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    get editionToolbarItemHeight() {
        return this.editionToolbarItemHeightSubject.value;
    }
    set editionToolbarItemHeight(value) {
        this.gridEditionToolbarItemHeight = value > 0 ? value : this.dikeConfig.EDITION_TOOLBAR_ITEM_HEIGHT;
        this.changeEditionToolbarItemHeight(this.gridEditionToolbarItemHeight);
    }
    get rowGroupingRow() {
        return this.rowGroupingSubject.value;
    }
    get rowGroupingRowHeight() {
        return this.gridRowGroupingRowHeight;
    }
    get rowGroupingColumnHeight() {
        return this.rowGroupingColumnHeightSubject.value;
    }
    set rowGroupingColumnHeight(value) {
        this.gridRowGroupingColumnHeight = value > 0 ? value : this.dikeConfig.ROW_GROUPING_COLUMN_HEIGHT;
        this.changeRowGroupingColumnHeight(this.gridRowGroupingColumnHeight);
    }
    set rowGroupingRowHeight(height) {
        this.gridRowGroupingRowHeight = height > 0 ? height : this.dikeConfig.ROW_GROUPING_ROW_HEIGHT;
        this.gridMesh.rowGroupingRow = this.createGridRowGrouping(this.gridRowGroupingRowHeight);
        // It does not matter if the row-grouping area is hidden, the new value must be stored in the Behaviour Subject:
        this.changeRowGrouping(this.createGridRowGrouping(this.gridRowGroupingRowHeight));
        if (this.gridMesh.allowRowGrouping) {
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    get paginationRow() {
        return this.paginationRowSubject.value;
    }
    get paginationRowHeight() {
        return this.gridPaginationRowHeight;
    }
    set paginationRowHeight(height) {
        this.gridPaginationRowHeight = height > 0 ? height : this.dikeConfig.PAGINATION_ROW_HEIGHT;
        this.gridMesh.paginatorRow = this.createGridRowPagination(this.gridPaginationRowHeight);
        // It does not matter if the paginator is hidden, the new value must be stored in the Behaviour Subject:
        this.changePaginationRow(this.createGridRowPagination(this.gridPaginationRowHeight));
        if (this.gridMesh.allowPagination) {
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        }
    }
    createGridSize(size) {
        return { height: size.height, width: size.width };
    }
    createGridBorder(border) {
        return {
            borderId: border.borderId,
            borderGap: border.borderGap,
            borderWidth: border.borderWidth,
            borderType: border.borderType
        };
    }
    createGridRowGrouping(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    createGridRowToolbar(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    createGridRowPagination(height) {
        return {
            contentHeight: height - this.dikeConfig.ROW_GAP,
            horizontalGutterHeight: this.dikeConfig.ROW_GAP,
            rowHeight: height
        };
    }
    changeGridSize(size) {
        this.gridSizeSubject.next(size);
    }
    changeBorderTop(borderTop) {
        this.borderTopSubject.next(borderTop);
    }
    changeBorderRight(borderRight) {
        this.borderRightSubject.next(borderRight);
    }
    changeBorderBottom(borderBottom) {
        this.borderBottomSubject.next(borderBottom);
    }
    changeBorderLeft(borderLeft) {
        this.borderLeftSubject.next(borderLeft);
    }
    changeEditionToolbarVisibility(visible) {
        this.editionToolbarVisibilitySubject.next(visible);
    }
    changeEditionToolbarRow(editionToolbarRow) {
        this.editionToolbarRowSubject.next(editionToolbarRow);
    }
    changeEditionToolbarItemHeight(value) {
        this.editionToolbarItemHeightSubject.next(value);
    }
    changeRowGrouping(rowGrouping) {
        this.rowGroupingSubject.next(rowGrouping);
    }
    changeRowGroupingColumnHeight(value) {
        this.rowGroupingColumnHeightSubject.next(value);
    }
    changePaginationRow(paginationRow) {
        this.paginationRowSubject.next(paginationRow);
    }
    changeCdkScrollViewport() {
        this.updateCdkVirtualScrollViewport.next();
    }
    changeMainWrapperTemplateColumns(templateColumns) {
        this.mainWrapperTemplateColumnsSubject.next(templateColumns);
    }
    changeMainWrapperTemplateRows(templateRows) {
        this.mainWrapperTemplateRowsSubject.next(templateRows);
    }
    changeGridTemplateRows(templateRows) {
        this.gridTemplateRowsSubject.next(templateRows);
    }
    setChangesAllowRowGroupingSubscription() {
        this.changesAllowRowGroupingSubscription.unsubscribe();
        this.changesAllowRowGroupingSubscription = this.rowGroupingConfig.onAllowRowGroupingChanged$.subscribe(value => {
            this.gridMesh.allowRowGrouping = value;
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        });
    }
    setChangesAllowPaginationSubscription() {
        this.changesAllowPaginationSubscription.unsubscribe();
        this.changesAllowPaginationSubscription = this.paginationDispatcher.onAllowPaginationChanged$.subscribe(value => {
            this.gridMesh.allowPagination = value;
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        });
    }
    setChangeEditionConfigSubscription() {
        /**
         * Since the edition toolbar depends on allowEdition and editionMode
         * variables, the provided value for the edition toolbar visibility is
         * stored in its correspondig variable in the DkGridEditionConfig service,
         * but the structural changes are not delivered.
         *
         * The structural changes and the edition toolbar visibility change itself
         * are sent only when allowEdition and editionMode are true. That is why a
         * subscription is created for listening the changes on onAllowEditionChanged$,
         * onEditionModeChanged$ and onEditionToolbarChanged$ observables from
         * DkGridEditionConfig service.
         */
        let editionConfig$ = combineLatest([
            this.gridEditionConfig.onAllowEditionChanged$,
            this.gridEditionConfig.onEditionModeChanged$,
            this.gridEditionConfig.onEditionToolbarChanged$,
            this.gridEditionConfig.onEditionToolbarPositionChanged$
        ]);
        this.changesEditionConfigSubscription.unsubscribe();
        this.changesEditionConfigSubscription = editionConfig$.subscribe(([allowEdition, editionMode, editionToolbar, position]) => {
            // editionToolbar and its position properties both from DkGridMesh class can be modified only from this subscription:
            this.gridMesh.displayEditionToolbar = allowEdition && editionMode && editionToolbar;
            this.gridMesh.editionToolbarPosition = position;
            this.changeEditionToolbarVisibility(this.gridMesh.displayEditionToolbar);
            this.changeGridTemplateRows(this.gridMesh.getGridMeshTemplateRows());
            this.changeCdkScrollViewport();
        });
    }
}
DkGridStructure.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridStructure, deps: [{ token: CONFIG_GRID }, { token: ROW_GROUPING_ROW_HEIGHT, optional: true }, { token: ROW_GROUPING_COLUMN_HEIGHT, optional: true }, { token: PAGINATION_ROW_HEIGHT, optional: true }, { token: EDITION_TOOLBAR_ROW_HEIGHT, optional: true }, { token: EDITION_TOOLBAR_ITEM_HEIGHT, optional: true }, { token: BORDER_WIDTH, optional: true }, { token: BORDER_GAP, optional: true }, { token: DkPaginationDispatcher }, { token: DkGridEditionConfig }, { token: DkRowGroupingConfig }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridStructure.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridStructure });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridStructure, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_GROUPING_ROW_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [ROW_GROUPING_COLUMN_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [PAGINATION_ROW_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [EDITION_TOOLBAR_ROW_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [EDITION_TOOLBAR_ITEM_HEIGHT]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [BORDER_WIDTH]
                    }] }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [BORDER_GAP]
                    }] }, { type: DkPaginationDispatcher }, { type: DkGridEditionConfig }, { type: DkRowGroupingConfig }];
    } });

class DkGridSelection {
    constructor(gridSelectionConfig, rowGroupingDispatcher) {
        this.gridSelectionConfig = gridSelectionConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.changesAllowSelectionSubscription = Subscription.EMPTY;
        this.selectedRows = [];
        this.setChangesAllowSelectionSubscription();
    }
    ngOnDestroy() {
        this.releaseSelection();
        this.changesAllowSelectionSubscription.unsubscribe();
    }
    get selectionChange() {
        return this.gridSelectionConfig.selectionEmitter.asObservable();
    }
    get selectedRowChange() {
        return this.gridSelectionConfig.selectedRowEmitter.asObservable();
    }
    get deselectedRowChange() {
        return this.gridSelectionConfig.deselectedRowEmitter.asObservable();
    }
    get selectableRows() {
        return this.gridSelectionConfig.selectableFn;
    }
    set selectableRows(value) {
        /**
         * When a new Selectable function is provided the current selected rows must be
         * evaluated with the given Selectable fuction getting those rows which meet the
         * new selection criteria.
         *
         * Note:  If the given value is null or undefined a default value is assigned
         *        instead. This validation is done in the DkGridSelectionConfig
         *        service instance.
         */
        this.gridSelectionConfig.selectableFn = value;
        if (this.selectedRows.length > 0) {
            // Get the new set filtering those rows that meet the new selection criteria:
            let newSelectedRows = this.selectedRows.filter(row => {
                row.selected = this.selectableRows(row.entry);
                return row.selected;
            });
            // Point to the new reference:
            this.selectedRows = newSelectedRows;
            // Then emit all the selected rows:
            this.changeSelection(this.selectedRows);
        }
    }
    selectOne(row) {
        if (this.gridSelectionConfig.allowSelection &&
            !this.selectedRows.some(selected => selected.id === row.id) &&
            this.selectableRows(row.entry)) {
            row.selected = true;
            this.selectedRows.push(row);
            // Emit the selected row:
            this.changeSelectedRow(row);
            // Then emit all the selected rows:
            this.changeSelection(this.selectedRows);
        }
    }
    select(rows) {
        if (this.gridSelectionConfig.allowSelection) {
            // Get all the rows that have not been selected:
            let deselectedRows = rows.filter(row => !row.selected && this.selectableRows(row.entry));
            // Then mark them as selected:
            deselectedRows.forEach(row => {
                row.selected = true;
                this.selectedRows.push(row);
            });
            // Then emit all the selected rows:
            if (deselectedRows.length > 0) {
                this.changeSelection(this.selectedRows);
            }
        }
    }
    deselectOne(row) {
        if (this.gridSelectionConfig.allowSelection) {
            // Get the new set without the given row:
            let newSelectedRows = this.selectedRows.filter(selected => selected.id !== row.id);
            if (newSelectedRows.length < this.selectedRows.length) {
                // Mark the row as deselected:
                row.selected = false;
                // Emit the deselected row:
                this.changeDeselectedRow(row);
                // Point to the new reference:
                this.selectedRows = newSelectedRows;
                // Then emit all the selected rows:
                this.changeSelection(this.selectedRows);
            }
        }
    }
    deselect(rows) {
        if (this.gridSelectionConfig.allowSelection) {
            // Get the rows which are selected:
            let givenSelectedRows = rows.filter(row => row.selected);
            // If the given rows have at least one selected row:
            if (givenSelectedRows.length > 0) {
                // Iterate over every selected row and deselect them:
                givenSelectedRows.forEach(row => row.selected = false);
                // Get only the selected rows and update the reference:
                this.selectedRows = this.selectedRows.filter(row => row.selected);
                // Then emit all the selected rows:
                this.changeSelection(this.selectedRows);
            }
        }
    }
    getSelectedRows() {
        return [...this.selectedRows];
    }
    getSelectedEntries() {
        return [...this.selectedRows.map(selected => selected.entry)];
    }
    selectAll() {
        if (this.gridSelectionConfig.allowSelection && this.gridSelectionConfig.enableAllRowsSelection) {
            this.rowGroupingDispatcher.rootGroupRow.selected = true;
        }
    }
    deselectAll() {
        if (this.gridSelectionConfig.allowSelection && this.gridSelectionConfig.enableAllRowsSelection) {
            this.rowGroupingDispatcher.rootGroupRow.selected = false;
        }
    }
    releaseSelection() {
        this.selectedRows.forEach(row => row.selected = false);
        this.selectedRows = [];
        this.changeSelection(this.selectedRows);
    }
    changeSelection(value) {
        this.gridSelectionConfig.selectionEmitter.emit(value);
    }
    changeSelectedRow(value) {
        this.gridSelectionConfig.selectedRowEmitter.emit(value);
    }
    changeDeselectedRow(value) {
        this.gridSelectionConfig.deselectedRowEmitter.emit(value);
    }
    setChangesAllowSelectionSubscription() {
        this.changesAllowSelectionSubscription.unsubscribe();
        // If the user disallowed the selection capability, then all selected rows are deselected:
        this.changesAllowSelectionSubscription = this.gridSelectionConfig.onAllowSelectionChanged$.subscribe(allowSelection => {
            if (!allowSelection) {
                this.releaseSelection();
            }
        });
    }
}
DkGridSelection.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelection, deps: [{ token: DkGridSelectionConfig }, { token: DkRowGroupingDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridSelection.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelection });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSelection, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridSelectionConfig }, { type: DkRowGroupingDispatcher }]; } });

class UpdateFieldCommand {
    constructor(gridDataStore, rowId, field, timestamp) {
        this.gridDataStore = gridDataStore;
        this.rowId = rowId;
        this.field = field;
        this.timestamp = timestamp;
    }
    execute() {
        this.gridDataStore.updateField(this.rowId, 'Modified', this.field, this.timestamp);
    }
}
class UpdateRowCommand {
    constructor(gridDataStore, rowId, fields, timestamp) {
        this.gridDataStore = gridDataStore;
        this.rowId = rowId;
        this.fields = fields;
        this.timestamp = timestamp;
    }
    execute() {
        this.gridDataStore.updateRow(this.rowId, 'Modified', this.fields, this.timestamp);
    }
}
class DeleteRowCommand {
    constructor(gridDataStore, rowId, timestamp) {
        this.gridDataStore = gridDataStore;
        this.rowId = rowId;
        this.timestamp = timestamp;
    }
    execute() {
        this.gridDataStore.deleteRow(this.rowId, this.timestamp);
    }
}

class Memento {
    constructor(mementoTimestamp) {
        this.mementoTimestamp = mementoTimestamp;
        this.mementoId = generateUUID();
    }
    get timestamp() {
        return this.mementoTimestamp;
    }
    get snapShotId() {
        return this.mementoId;
    }
}
class RowMemento extends Memento {
    constructor(gridDataStore, rowId, rowStatus, fields, timestamp) {
        super(timestamp);
        this.gridDataStore = gridDataStore;
        this.rowId = rowId;
        this.rowStatus = rowStatus;
        this.fields = fields;
    }
    restore() {
        this.gridDataStore.updateRow(this.rowId, this.rowStatus, this.fields, this.timestamp);
    }
}

class DkGridRowEntry {
    constructor(timestampCreation) {
        this.isGroup = false;
        this.isSelected = false;
        this.selectedSubject = new Subject();
        this.timestampSubject = new BehaviorSubject(timestampCreation);
    }
    get selectedChange() {
        return this.selectedSubject.asObservable();
    }
    get timestampChange() {
        return this.timestampSubject.asObservable();
    }
    get timestamp() {
        return this.timestampSubject.value;
    }
    set timestamp(value) {
        this.changeTimestamp(value);
    }
    get selected() {
        return this.isSelected;
    }
    set selected(value) {
        this.changeSelected(value);
    }
    changeSelected(value) {
        this.isSelected = value;
        this.selectedSubject.next(value);
    }
    changeTimestamp(value) {
        this.timestampSubject.next(value);
    }
    dispose() {
        this.selectedSubject.complete();
        this.timestampSubject.complete();
    }
}
class DkGridGroupRowEntry extends DkGridRowEntry {
    constructor(groupKey, groupId, groupLevel, groupTotalCount, dataColumnDef, dataRowEntries, timestamp) {
        super(timestamp);
        this.groupKey = groupKey;
        this.groupId = groupId;
        this.groupLevel = groupLevel;
        this.groupTotalCount = groupTotalCount;
        this.dataColumnDef = dataColumnDef;
        this.dataRowEntries = dataRowEntries;
        this.isGroup = true;
        this.selectedRowsCount = 0;
        // By default any group will listen its data row children:
        this.selectedRowsTotal = this.groupTotalCount;
        this.collapseSubject = new BehaviorSubject(true);
        this.allRowsSelectedSubject = new BehaviorSubject(false);
        this.someRowsSelectedSubject = new BehaviorSubject(false);
        // Get the selected rows, if any:
        let selectedRows = this.dataRowEntries.filter(row => row.selected);
        // This assignment provokes that allRowsSelectedSubject and someRowsSelectedSubject update their values:
        this.rowSelectionCount = selectedRows.length;
    }
    get collapseChange() {
        return this.collapseSubject.asObservable();
    }
    get allRowsSelectedChange() {
        return this.allRowsSelectedSubject.asObservable().pipe(tap(value => this.isSelected = value));
    }
    get someRowsSelectedChange() {
        return this.someRowsSelectedSubject.asObservable();
    }
    get key() {
        return this.groupKey;
    }
    get id() {
        return this.groupId;
    }
    get level() {
        return this.groupLevel;
    }
    get count() {
        return this.groupCount;
    }
    set count(value) {
        this.groupCount = value;
    }
    get totalCount() {
        return this.groupTotalCount;
    }
    get totalSelectableRows() {
        return this.selectedRowsTotal;
    }
    set totalSelectableRows(value) {
        this.selectedRowsTotal = value > 0 ? value : 0;
    }
    get rowSelectionCount() {
        return this.selectedRowsCount;
    }
    set rowSelectionCount(value) {
        if (value < 0) {
            value = 0;
        }
        else if (value > this.selectedRowsTotal) {
            value = this.selectedRowsTotal;
        }
        this.selectedRowsCount = value;
        this.changeAllRowsSelected(this.selectedRowsCount > 0 && this.selectedRowsCount === this.selectedRowsTotal);
        this.changeSomeRowsSelected(this.selectedRowsCount > 0 && this.selectedRowsCount < this.selectedRowsTotal);
    }
    get collapse() {
        return this.collapseSubject.value;
    }
    set collapse(value) {
        this.changeCollapse(value);
    }
    get allRowsSelected() {
        return this.allRowsSelectedSubject.value;
    }
    set allRowsSelected(value) {
        this.changeAllRowsSelected(value);
    }
    get someRowsSelected() {
        return this.someRowsSelectedSubject.value;
    }
    set someRowsSelected(value) {
        this.changeSomeRowsSelected(value);
    }
    get dataColumn() {
        return this.dataColumnDef;
    }
    get dataRows() {
        return this.dataRowEntries;
    }
    dispose() {
        super.dispose();
        this.dataColumnDef = null;
        this.dataRowEntries = null;
        this.collapseSubject.complete();
        this.allRowsSelectedSubject.complete();
        this.someRowsSelectedSubject.complete();
    }
    changeCollapse(value) {
        this.collapseSubject.next(value);
    }
    changeAllRowsSelected(value) {
        // Send the given value if only if is different from the stored value:
        if (value !== this.allRowsSelected) {
            this.allRowsSelectedSubject.next(value);
        }
    }
    changeSomeRowsSelected(value) {
        // Send the given value if only if is different from the stored value:
        if (value !== this.someRowsSelected) {
            this.someRowsSelectedSubject.next(value);
        }
    }
}
class DkGridDataRowEntry extends DkGridRowEntry {
    constructor(rowId, timestamp, rowEntry) {
        super(timestamp);
        this.rowId = rowId;
        this.rowEntry = rowEntry;
        this.rowStatus = 'Read';
        this.isRowEditingSubject = new BehaviorSubject(false);
        this.rowFormFields = new Map();
        this.rowFormGroupSubject = new BehaviorSubject(new FormGroup({}));
        this.rowEditionActions = new BehaviorSubject({ edit: true, delete: true, save: false, cancel: false });
    }
    get rowFormGroupChange() {
        return this.rowFormGroupSubject.asObservable();
    }
    get editionActionsChange() {
        return this.rowEditionActions.asObservable();
    }
    get isEditingChange() {
        return this.isRowEditingSubject.asObservable();
    }
    get id() {
        return this.rowId;
    }
    get entry() {
        return this.rowEntry;
    }
    get status() {
        return this.rowStatus;
    }
    set status(value) {
        this.rowStatus = value;
    }
    get isEditing() {
        return this.isRowEditingSubject.value;
    }
    set isEditing(value) {
        this.changeRowEditing(value);
        this.changeRowEditionActions(this.isEditing);
    }
    get rowFormGroup() {
        return this.rowFormGroupSubject.value;
    }
    set rowFormGroup(value) {
        this.changeRowFormGroup(value);
    }
    getRowPanelFormGroup(panel) {
        return this.rowFormGroupSubject.value.get(panel);
    }
    dispose() {
        super.dispose();
        this.rowFormFields.clear();
        this.rowEditionActions.complete();
        this.rowFormGroupSubject.next(null);
        this.rowFormGroupSubject.complete();
        this.isRowEditingSubject.complete();
    }
    changeRowEditionActions(isRowEditing) {
        if (isRowEditing) {
            this.rowEditionActions.next({ edit: false, delete: false, save: true, cancel: true });
        }
        else {
            this.rowEditionActions.next({ edit: true, delete: true, save: false, cancel: false });
        }
    }
    changeRowFormGroup(value) {
        this.rowFormGroupSubject.next(value);
    }
    changeRowEditing(value) {
        this.isRowEditingSubject.next(value);
    }
}

class DkDataSource extends DataSource {
    constructor() {
        super();
    }
}
class DkGridDataSource extends DkDataSource {
    constructor() {
        super();
        this.rowsSubject = new BehaviorSubject([]);
        this.dataDeliverySubject = new BehaviorSubject('');
    }
    get dataDeliveryChanges() {
        return this.dataDeliverySubject.asObservable();
    }
    get data() {
        return this.rowsSubject.value;
    }
    set data(value) {
        this.changeRows(value !== null && value !== void 0 ? value : []);
    }
    get entries() {
        return [...this.rowsSubject.value.map(row => row.entry)];
    }
    set entries(value) {
        value = value !== null && value !== void 0 ? value : [];
        let rowId = 0;
        let timestampCreation = Date.now();
        // Before wrapping the given entries, dispose the current rows:
        this.data.forEach(row => row.dispose());
        // Wrap and broadcast the new rows:
        this.changeRows(value.map(entry => new DkGridDataRowEntry(rowId++, timestampCreation, entry)));
        // Notify that a new data set was wrapped:
        this.changeDataDelivery(generateUUID());
    }
    connect() {
        return this.rowsSubject.asObservable();
    }
    /**
     * It does not matter how many times we disconnect the decorators,
     * the base data stream continue alive.
     *
     * disconnect() method is defined empty for two reasons:
     *
     *  1.  Every time a new datasource is bound to the CdkVirtualFor directive, the
     *      cdkVirtualFor disconnect the previuos datasource.
     *
     *  2.  Before creating a new set of decorators the previous decorators
     *      must be removed and a new decorated instance is created. Remember that
     *      changing decorators is a very common task.
     *
     * Due to the previous reasons, if releasing-resources logic would have been left in the disconnect
     * method, in the first changing-decorators operation the base data stream (the rowsSubject subject)
     * would be completed.
     */
    disconnect() { }
    reconnect() { }
    dispose(releaseSource) {
        if (releaseSource) {
            this.rowsSubject.complete();
        }
    }
    changeRows(value) {
        this.rowsSubject.next([...value]);
    }
    changeDataDelivery(deliveryId) {
        this.dataDeliverySubject.next(deliveryId);
    }
}

class DkContentDataSource extends DkDataSource {
    constructor(dikeDataSource) {
        super();
        this.dikeDataSource = dikeDataSource;
        this.contentSubject = new BehaviorSubject([]);
        this.changeSubscription = Subscription.EMPTY;
    }
    get data() {
        return this.contentSubject.value;
    }
    set data(value) {
        this.changeContentData(value !== null && value !== void 0 ? value : []);
    }
    connect() {
        return this.contentSubject.asObservable();
    }
    disconnect() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        this.dikeDataSource.forEach(datasource => datasource.disconnect());
        this.changeSubscription.unsubscribe();
    }
    reconnect() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        this.dikeDataSource.forEach(datasource => datasource.reconnect());
        this.setChangeSubscription(true);
    }
    dispose(releaseSource) {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        this.dikeDataSource.forEach(datasource => datasource.dispose(releaseSource));
        this.changeSubscription.unsubscribe();
        this.contentSubject.complete();
    }
    changeContentData(value) {
        this.contentSubject.next([...value]);
    }
}

class DkGroupedContentDataSource extends DkContentDataSource {
    constructor(gridDataSource, gridSelectionConfig, gridSelection, dataSourceDispatcher, rowGroupingDispatcher, generalNotifier) {
        // The inner dataSource always holds the decorated data rows but for the sake of simplicity the actual dataSource is assgined:
        super(gridDataSource);
        this.gridDataSource = gridDataSource;
        this.gridSelectionConfig = gridSelectionConfig;
        this.gridSelection = gridSelection;
        this.dataSourceDispatcher = dataSourceDispatcher;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.generalNotifier = generalNotifier;
        this.changeRowSelectionSubscription = Subscription.EMPTY;
        this.changeSomeRowSelectionSubscription = Subscription.EMPTY;
        this.changeAllRowSelectionSubscription = Subscription.EMPTY;
        this.changeGroupSelectionSubscription = Subscription.EMPTY;
    }
    setChangeRowSelectionSubscription(groupRow) {
        const rowSelection$ = merge(...groupRow.dataRows.map(row => row.selectedChange));
        const selection$ = this.gridSelectionConfig.onAllowSelectionChanged$.pipe(switchMap(allowSelection => allowSelection ? rowSelection$ : NEVER));
        // Before subscribing to selection observable establish the maximum numbers of selectable rows:
        groupRow.totalSelectableRows = groupRow.dataRows.length;
        this.changeRowSelectionSubscription.unsubscribe();
        this.changeRowSelectionSubscription = selection$.subscribe(rowSelected => {
            if (rowSelected) {
                groupRow.rowSelectionCount += 1;
            }
            else {
                groupRow.rowSelectionCount -= 1;
            }
        });
    }
    setChangeSomeRowSelectionSubscription(parentGroup, childGroups) {
        const someGroupSelection$ = merge(...childGroups.map(group => group.someRowsSelectedChange.pipe(skip(1))));
        const someSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$.pipe(switchMap(allowSelection => allowSelection ? someGroupSelection$ : NEVER));
        // Before subscribing to selection observable establish the maximum numbers of selectable rows:
        parentGroup.totalSelectableRows = childGroups.length;
        this.changeSomeRowSelectionSubscription.unsubscribe();
        this.changeSomeRowSelectionSubscription = someSelection$.subscribe(someSelected => {
            /**
             * Is the given value the actual value for the parent group?
             *
             * Premises:
             *    1.  The someRowsSelectedChange Observable will fire a value, if only if the
             *        new value is different from the stored value (see DkGridGroupRowEntry
             *        class definition).
             *
             *    2.  Therefore, when this subscription receives a new value in the someSelected
             *        variable, means that any of the childGroups has emitted a new value for its
             *        someRowsSelectedChange Observable.
             *
             *    3.  If one of the data rows is selected the complete branch of groups will have
             *        a status of Indeterminate. The same for any of the groups before reaching
             *        the root group.
             *
             * Scenario:
             *    Consider having two child groups. These child groups are leaves meaning that
             *    every child group listens the selection events from its data rows.
             *
             *    Supposing every child group has only two data rows.
             *
             *    Follow the steps:
             *
             *      1.  The user selects one of the data rows in child group One.
             *            (a).  The child group One will emit a true value for its someRowsSelectedChange Observable
             *                  because it passed from false to true.
             *
             *            (b).  This subscription receives the false value emitted from the child group and this
             *                  value is set in the parent group.
             *
             *      2.  The second data row from child group One is selected.
             *            (a).  The group One will emit a false value for its someRowsSelectedChange Observable
             *                  because it passed from true to false.
             *
             *            (b).  The child group One has all its data rows selected that is why its someRowsSelected
             *                  property is false.
             *
             *            (c).  Another Observable that also emits a true value is allRowsSelectedChange from group
             *                  One. This value causes to increment the rowSelectionCount from parent group meaning
             *                  that the parent group has one child selected (in this case its child group One).
             *
             *    PROBLEM:
             *      If the given value is passed until the root without evaluating the current state of the parent
             *      group, a wrong value will be emitted.
             *
             *    SOLUTION:
             *      It is very important evaluating the current state of the current parent group because.
             *
             *        1.  According to the scenario the child group One emits a false value for its someRowsSelectedChange
             *            Observable. The state is totally correct for the child group One but not for its parent group.
             *
             *        2.  The parent group must have an Indeterminate state meaning that its someRowsSelectedChange
             *            Observable have to emit a true value. That is why the rowSelectionCount evaluation from the
             *            parent group is necessary.
             */
            parentGroup.someRowsSelected = (parentGroup.rowSelectionCount > 0 &&
                parentGroup.rowSelectionCount < parentGroup.totalSelectableRows) || someSelected;
        });
    }
    setChangeAllRowSelectionSubscription(parentGroup, childGroups) {
        const allGroupSelection$ = merge(...childGroups.map(group => group.allRowsSelectedChange.pipe(skip(1))));
        const allSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$.pipe(switchMap(allowSelection => allowSelection ? allGroupSelection$ : NEVER));
        // Before subscribing to selection observable establish the maximum numbers of selectable rows:
        parentGroup.totalSelectableRows = childGroups.length;
        this.changeAllRowSelectionSubscription.unsubscribe();
        this.changeAllRowSelectionSubscription = allSelection$.subscribe(allSelected => {
            if (allSelected) {
                parentGroup.rowSelectionCount += 1;
            }
            else {
                parentGroup.rowSelectionCount -= 1;
            }
        });
    }
    setChangeGroupSelectionSubscription(groupRow) {
        const groupSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$.pipe(switchMap(allowSelection => allowSelection ? groupRow.selectedChange : NEVER));
        this.changeGroupSelectionSubscription.unsubscribe();
        this.changeGroupSelectionSubscription = groupSelection$.subscribe(isGroupSelected => {
            if (isGroupSelected) {
                this.gridSelection.select(groupRow.dataRows);
            }
            else {
                this.gridSelection.deselect(groupRow.dataRows);
            }
        });
    }
    getDecoratedGridDataSource(gridDataSource) {
        // Then DkFilteringDataSource will be the second decorator, if edition is allowed:
        let dikeDecoratorDataSource = this.dataSourceDispatcher.createEditionFilteringDecorator(gridDataSource);
        return this.dataSourceDispatcher.decoratorCtxFn()(dikeDecoratorDataSource);
    }
}

class DkJoiningDataSource extends DkContentDataSource {
    constructor(dikeDataSource) {
        super(dikeDataSource);
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        let dikeDataSources = this.getDikeDataSource();
        /**
         * As a wrapper, get the previous result stream:
         *
         * Get an array of Observable for later destructuring assignment.
         *
         *  Despite the fact that there is a signature of zip that says that it is
         *  posible to pass an array of Observables, zip does not accept an array of
         *  Observables.
         *
         *  The solution is destructuring the array of Observables an assign the result
         *  of it.
         *
         *  https://stackoverflow.com/questions/42066387/observable-zip-does-not-call-subscribe-next-if-sources-are-given-as-array
         */
        let dikeDataSource$ = dikeDataSources.map(dataSource => dataSource.connect());
        const rows$ = zip(...dikeDataSource$).pipe(map(rows => rows.reduce((accumRows, currentRows) => [...accumRows, ...currentRows], [])));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = rows$.subscribe(rows => {
            this.data = rows;
        });
    }
    getDikeDataSource() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        return this.dikeDataSource;
    }
}

class DkPushingGroupDataSource extends DkContentDataSource {
    constructor(dikeDataSource, groupDataSource, generalNotifier) {
        super(dikeDataSource);
        this.groupDataSource = groupDataSource;
        this.generalNotifier = generalNotifier;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        const pushGroup$ = merge(this.groupDataSource.onPushingDataGroupChanged$, this.generalNotifier.initialized());
        // As a wrapper, get the previous result stream:
        const rows$ = this.getDikeDataSource().connect();
        let pushGroupRows$ = combineLatest([rows$, pushGroup$]).pipe(map(([rows, _]) => rows));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = pushGroupRows$.subscribe(rows => this.data = rows);
    }
    getDikeDataSource() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        return this.dikeDataSource[0];
    }
}

const ROOT_GROUP_DATASOURCE = 'root-group-datasource';
class DkGroupingDataSource extends DkGroupedContentDataSource {
    constructor(gridDataSource, groupRow, gridSelectionConfig, gridSelection, dataSourceDispatcher, rowGroupingDispatcher, generalNotifier) {
        /**
         * The inner dataSource always holds the decorated data rows:
         *
         * It will hold a decorated DkGridDataSource<T> instance, full of data, when the group is
         * open or closed.
         *
         *    1. A group is an actual leaf when there is no more groups beneath.
         *
         *    2. And, a closed group could be considered a leaf despite the group could have
         *       more groups beneath.
         *
         * At creation time for the sake of simplicity the actual data is passed in to the
         * super class.
         */
        super(gridDataSource, gridSelectionConfig, gridSelection, dataSourceDispatcher, rowGroupingDispatcher, generalNotifier);
        this.groupRow = groupRow;
        this.pushingGroupDataSubject = new Subject();
        // The root group never listen for its data rows:
        if (this.groupRow.id !== ROOT_GROUP_DATASOURCE) {
            this.setChangeRowSelectionSubscription(this.groupRow);
        }
        if (this.groupRow.id !== ROOT_GROUP_DATASOURCE ||
            this.groupRow.id === ROOT_GROUP_DATASOURCE && this.gridSelectionConfig.enableAllRowsSelection) {
            this.setChangeGroupSelectionSubscription(this.groupRow);
        }
        this.setChangeSubscription();
    }
    get onPushingDataGroupChanged$() {
        return this.pushingGroupDataSubject.asObservable();
    }
    get groupRowEntry() {
        return this.groupRow;
    }
    disconnect() {
        if (this.isLeaf() || this.isGroupLeaf()) {
            /**
             * A group is delivering the actual data:
             *
             *  1.  When a group is closed
             *  2.  Or, a group is open and is an actual leaf.
             */
            this.getDikeDataSource().disconnect();
        }
        else {
            // The group is open and is not a leaf:
            this.joiningDataSource.disconnect();
        }
        this.changeSubscription.unsubscribe();
    }
    reconnect() {
        if (this.isLeaf() || this.isGroupLeaf()) {
            /**
             * A group is delivering the actual data:
             *
             *  1.  When a group is closed
             *  2.  Or, a group is open and is an actual leaf.
             */
            this.getDikeDataSource().reconnect();
        }
        else {
            // The group is open and is not a leaf:
            this.joiningDataSource.reconnect();
        }
        this.setChangeSubscription(true);
    }
    dispose(releaseSource) {
        super.dispose(releaseSource);
        if (!!this.joiningDataSource) {
            this.joiningDataSource.dispose(releaseSource);
        }
        // Release the Map of child groups:
        if (!!this.childrenGroups) {
            this.childrenGroups.clear();
        }
        // Dispose the self row group:
        this.groupRow.dispose();
        this.pushingGroupDataSubject.complete();
        this.changeRowSelectionSubscription.unsubscribe();
        this.changeSomeRowSelectionSubscription.unsubscribe();
        this.changeAllRowSelectionSubscription.unsubscribe();
        this.changeGroupSelectionSubscription.unsubscribe();
    }
    createChildrenDataSourceGroups(currentGroup) {
        const nextDepperLevel = currentGroup.level + 1;
        const rowGroups = this.rowGroupingDispatcher.createRowGroups(currentGroup);
        const groupingDataSources = new Map();
        // Iterate over the just created data groups:
        for (let [groupKey, groupDataRows] of rowGroups.entries()) {
            // Save the group data rows in a new DkGridDataSource<T> instance:
            let gridDataSource = new DkGridDataSource();
            gridDataSource.data = groupDataRows;
            // Create the corresponding DkGroupingDataSource instance and save it into the Map:
            groupingDataSources.set(groupKey, new DkGroupingDataSource(gridDataSource, new DkGridGroupRowEntry(groupKey, generateUUID(), nextDepperLevel, groupDataRows.length, this.rowGroupingDispatcher.getGroupByColumn(nextDepperLevel), groupDataRows, Date.now()), this.gridSelectionConfig, this.gridSelection, this.dataSourceDispatcher, this.rowGroupingDispatcher, this.generalNotifier));
        }
        return groupingDataSources;
    }
    isGroupLeaf() {
        // A closed group is considered a leaf:
        return this.groupRow.collapse;
    }
    isLeaf() {
        /**
         * An actual leaf is when there is no more deeper levels.
         *
         * Exception:
         *    The root group will not be considered in this validation because
         *    it will be a false leaf due to the level it has.
         *
         *    Remember that root group has a level equals to -1 for the
         *    following reasons:
         *
         *      (a).  The root group is never displayed in the UI.
         *      (b).  The levels beneath to the root group must match
         *            with the columns existing in the group panel.
         */
        return this.groupRow.id !== ROOT_GROUP_DATASOURCE && !this.rowGroupingDispatcher.isThereDeeperLevel(this.groupRow.level);
    }
    pushingGroupData() {
        this.pushingGroupDataSubject.next();
    }
    getDecoratedGridDataSource(gridDataSource) {
        // Firstly, establish default decorators (or the ones provided by the user) including the edition filtering decorator:
        let dikeDecoratorDataSource = super.getDecoratedGridDataSource(gridDataSource);
        /**
         * When data is row grouped:
         *
         * 1. DkRefreshingDataSource will be always the first decorator. Its purpose is
         *    re-sending all the data when some rows are updated.
         *
         * 2. DkPushingGroupDataSource will be always the last decorator and it exists
         *    if only if the data is presented as a tree. Its purpose is re-sending the data
         *    existing in every leaf.
         *        (a).  Although a close group delivers an empty array it could be considered
         *              a leaf beacause it holds the actual data array of type DkGridDataRowEntry.
         *
         *        (b).  Every DkPushingGroupDataSource instance only listens the Suject
         *              living in the DkGroupingDataSource instance that created it.
         *
         *    IMPORTANT:  If the data is not push for every existing leaf, the zip operator
         *                living in every DkJoiningDataSource instance will not emit.
         */
        return new DkPushingGroupDataSource(dikeDecoratorDataSource, this, this.generalNotifier);
    }
    getDataSourceStream() {
        // The group is open:
        if (!this.groupRow.collapse) {
            // Is there one immediate deeper level?
            if (this.rowGroupingDispatcher.isThereDeeperLevel(this.groupRow.level)) {
                // Have not the children groups already been created?
                if (!this.joiningDataSource) {
                    // Create the children groups for the current group:
                    this.childrenGroups = this.createChildrenDataSourceGroups(this.groupRow);
                    // Get the array of the children grouping dataSources:
                    const groupingDataSources = Array.from(this.childrenGroups.values());
                    // Get the array of the children group row entries:
                    const groupRowEntries = groupingDataSources.map(groupDS => groupDS.groupRowEntry);
                    // Stop listening selection changes from data rows:
                    this.changeRowSelectionSubscription.unsubscribe();
                    // Listen for selection observables from children group entries:
                    this.setChangeAllRowSelectionSubscription(this.groupRow, groupRowEntries);
                    this.setChangeSomeRowSelectionSubscription(this.groupRow, groupRowEntries);
                    // Then create the DkJoiningDataSource instance:
                    this.joiningDataSource = new DkJoiningDataSource(groupingDataSources);
                }
                else {
                    this.joiningDataSource.reconnect();
                }
                // Disconnect the previous dataSource (an empty stream is a close group):
                if (!!this.dikeDataSource) {
                    this.getDikeDataSource().disconnect();
                }
                return this.joiningDataSource.connect();
            }
        }
        /**
         * Return the actual data rows:
         *
         *  1.  If the group is closed,
         *  2.  Or, there is no a deeper level.
         *
         * Both cases are considered leaves.
         */
        // If the group was open and it has children, disconnect the joining dataSource:
        if (!!this.joiningDataSource) {
            this.joiningDataSource.disconnect();
        }
        // Disconnect the previous dataSource stream:
        if (!!this.dikeDataSource) {
            this.getDikeDataSource().disconnect();
        }
        // Create a new decorated instance:
        this.dikeDataSource = this.getDecoratedGridDataSource(this.gridDataSource);
        return this.getDikeDataSource().connect();
    }
    setChangeSubscription(isReconnection = false) {
        const collapseGroup$ = merge(this.rowGroupingDispatcher.onCollapseGroupChanged$, this.generalNotifier.initialized()).pipe(filter(groupEvent => {
            // When a group is created the void observable is consumed. Therefore, is not an actual event:
            if (typeof groupEvent !== 'undefined') {
                // The event belongs to the current group, take the new collapse value:
                if (groupEvent.groupId === this.groupRow.id) {
                    this.groupRow.collapse = groupEvent.collapse;
                }
                else if (groupEvent.groupId !== '' && (this.isLeaf() || this.isGroupLeaf())) {
                    // The event does not belong to the current group and it is a leaf, then it has to emit the data it has:
                    this.pushingGroupData();
                }
            }
            /**
             * Pass to the next Rx operator, if only if:
             *
             *  1.  The subscription is running due to a reconnection or creation phase.
             *  2.  Or, the event was fired and the event belongs to the current Group instance.
             */
            return typeof groupEvent === 'undefined' || groupEvent.groupId === this.groupRow.id;
        }), switchMap(groupEvent => {
            /**
             * The subscription is being created due to a reconnection.
             *
             * Premises:
             *
             *  (a).  When JS executes the method setChangeSubscription(...), creates a
             *        closure around the Observable execution. It means that the Observable
             *        execution is done in its own context.
             *
             *  (b).  All variables outside this closure are preserved. It means that
             *        isReconnection parameter is always true when the Observable is executing.
             *
             *  (c).  Lastly, this is undefined during the Observable execution.
             *
             * Problem:
             *
             *    When a reconnected group receives an event, the group always return its
             *    Observable that the group had just when the group was being reconnected.
             *    Therefore, it means the group never changes its Observable.
             *
             * Solution:
             *
             *    When the group is reconnected the setChangeSubscription(...) method is
             *    executed again for the first time meaning that the first consumed Observable
             *    is this.generalNotifier.initialized() which returns void.
             *
             *    It is enough validating if the group is reconnected and if it is the first time
             *    the Observable execution is run.
             */
            if (isReconnection && typeof groupEvent === 'undefined') {
                if (this.isLeaf() || this.isGroupLeaf()) {
                    return this.getDikeDataSource().connect();
                }
                else {
                    return this.joiningDataSource.connect();
                }
            }
            else {
                // The subscription is created due to either the group is being created or a group event was fired:
                return this.getDataSourceStream();
            }
        }));
        // All groups will listen onCollapseGroupChanged$ Observable except the ROOT_GROUP_DATASOURCE:
        const rows$ = of(this.groupRow).pipe(switchMap(currentGroup => currentGroup.id === ROOT_GROUP_DATASOURCE ? this.getDataSourceStream() : collapseGroup$));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = rows$.subscribe(rows => {
            let finalRows = rows;
            // Update the group counting:
            if (this.isLeaf() || this.isGroupLeaf()) {
                this.groupRow.count = rows.length;
            }
            else {
                this.groupRow.count = rows
                    .filter(row => row instanceof DkGridGroupRowEntry)
                    .reduce((accum, current) => current.count + accum, 0);
            }
            // There are some rows that passed the filter (or there is no any filter at all):
            if (rows.length > 0) {
                // If the group is closed the result must be empty:
                if (this.isGroupLeaf()) {
                    finalRows = [];
                }
                // Set the group row at the beginning of the array:
                if (this.groupRow.id !== ROOT_GROUP_DATASOURCE) {
                    finalRows.unshift(this.groupRow);
                }
            }
            // Then broadcast:
            this.data = finalRows;
        });
    }
    getDikeDataSource() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        return this.dikeDataSource[0];
    }
}

class DkWrappingDataSource extends DkGroupedContentDataSource {
    constructor(gridDataSource, gridSelectionConfig, gridSelection, dataSourceDispatcher, rowGroupingDispatcher, generalNotifier) {
        super(gridDataSource, gridSelectionConfig, gridSelection, dataSourceDispatcher, rowGroupingDispatcher, generalNotifier);
        this.DISPOSING_SUBSET_ROWS = 2500;
        this.rootGroupRowSubject = new BehaviorSubject(null);
        this.setChangeSubscription();
    }
    get onRootGroupRowChanged$() {
        return this.rootGroupRowSubject.asObservable();
    }
    disconnect() {
        // Disconnect the wrapped dataSources:
        super.disconnect();
        // Disconnect the local datasource:
        if (!!this.groupingDataSource) {
            this.groupingDataSource.disconnect();
        }
    }
    dispose(releaseSource) {
        // Release the wrapped dataSources:
        super.dispose(releaseSource);
        // Release the local datasource:
        if (!!this.groupingDataSource) {
            this.groupingDataSource.dispose(releaseSource);
        }
        // Dispose all the rows. Remember that the DkWrappingDataSource instance holds the entire set of rows:
        setTimeout(() => this.disposeDataRows(this.gridDataSource.data, 0, this.DISPOSING_SUBSET_ROWS), 0);
        // Release the inner subjects and references from the root group:
        this.disposeRootGroup();
        // Then close the rootGroupRowSubject subject:
        this.rootGroupRowSubject.complete();
        this.changeRowSelectionSubscription.unsubscribe();
        this.changeGroupSelectionSubscription.unsubscribe();
    }
    getDataSourceStream() {
        /**
         * When getDataSourceStream() is invoked everything will be set again:
         *
         *    1.  Dispose the current tree calling this.groupingDataSource.dispose(),
         *    2.  Unsubscribe to selecting events.
         *    3.  Dispose the root group.
         *    4.  Dispose the current decorators.
         */
        // 1. Dispose the previous DkGroupingDataSource instance:
        if (!!this.groupingDataSource) {
            this.groupingDataSource.dispose(true);
            this.groupingDataSource = null;
        }
        // 2. Unsubscribe to selecting events:
        this.changeRowSelectionSubscription.unsubscribe();
        this.changeGroupSelectionSubscription.unsubscribe();
        // 3. Before creating the new root group, dispose the current one:
        this.disposeRootGroup();
        // Create the root group-row:
        const rootGroupRow = new DkGridGroupRowEntry(null, ROOT_GROUP_DATASOURCE, -1, this.gridDataSource.data.length, null, this.gridDataSource.data, Date.now());
        // The root group-row is always open:
        rootGroupRow.collapse = false;
        // Broadcast the new root group:
        this.changeRootGroupRow(rootGroupRow);
        // There are slots in the group panel:
        if (this.rowGroupingDispatcher.groupPanelCardinality > 0) {
            // Create a new instance of type DkGridDataSource<T>:
            let gridDataSource = new DkGridDataSource();
            gridDataSource.data = this.gridDataSource.data;
            // Create the root DkGroupingDataSource instance:
            this.groupingDataSource = new DkGroupingDataSource(gridDataSource, rootGroupRow, this.gridSelectionConfig, this.gridSelection, this.dataSourceDispatcher, this.rowGroupingDispatcher, this.generalNotifier);
            /**
             * Since a DkGroupingDataSource instance will be delivered, dispose the decorators
             * but do not close the BehaviorSubject from the original DkGridDataSource.
             *
             * This invocation will only close the decorators' BehaviorSubject.
             */
            if (!!this.dikeDataSource) {
                this.getDikeDataSource().dispose(false);
            }
            return this.groupingDataSource.connect();
        }
        // Subscribe to all selected observables from every data row:
        this.setChangeRowSelectionSubscription(rootGroupRow);
        // There is no columns in the group panel, then the wrapping dataSource is responsible for the root group selected event:
        if (this.gridSelectionConfig.enableAllRowsSelection) {
            this.setChangeGroupSelectionSubscription(rootGroupRow);
        }
        //
        /**
         * Dispose the current decorators because a new DkDecoratorDataSource instance will be delivered.
         * Be aware that we do not close the BehaviorSubject from the original DkGridDataSource.
         *
         * This invocation will only close the decorators' BehaviorSubject.
         */
        if (!!this.dikeDataSource) {
            this.getDikeDataSource().dispose(false);
        }
        // Create the new decorated instance:
        this.dikeDataSource = this.getDecoratedGridDataSource(this.gridDataSource);
        // Return the decorated dataSource:
        return this.getDikeDataSource().connect();
    }
    setChangeSubscription() {
        const contentDataSource$ = this.gridDataSource.dataDeliveryChanges.pipe(filter(deliveryId => deliveryId !== ''), switchMap(() => this.rowGroupingDispatcher.onGroupPanelCardinalityChanged$), switchMap(() => this.getDataSourceStream()));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = contentDataSource$.subscribe(rows => this.data = rows);
    }
    getDikeDataSource() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        return this.dikeDataSource[0];
    }
    disposeRootGroup() {
        if (!!this.rootGroupRowSubject.value) {
            this.rootGroupRowSubject.value.dispose();
        }
    }
    disposeDataRows(rows, start, end) {
        // Get the subset from the start index trying obtaining the size of the subset.
        // Remember that slice method will take all the elements if the rest of them are less than the size of the subset.
        const subsetRows = rows.slice(start, end);
        // Set the next start index and the next end index. They will be use for slice in the next iteration:
        const nextStart = start + subsetRows.length;
        const nextEnd = end + subsetRows.length;
        // Are there more rows?
        if (nextStart < rows.length) {
            // Schedule the next subset:
            setTimeout(() => this.disposeDataRows(rows, nextStart, nextEnd));
        }
        // Iterate over the subset of rows and dispose each of them:
        subsetRows.forEach(row => row.dispose());
    }
    changeRootGroupRow(rootGroupRow) {
        this.rootGroupRowSubject.next(rootGroupRow);
    }
}

class DkDecoratorDataSource extends DkDataSource {
    constructor(dikeDataSource) {
        super();
        this.dikeDataSource = dikeDataSource;
        this.decoratorSubject = new BehaviorSubject([]);
        this.changeSubscription = Subscription.EMPTY;
    }
    get data() {
        return this.decoratorSubject.value;
    }
    set data(value) {
        this.changeDecoratorData(value !== null && value !== void 0 ? value : []);
    }
    connect() {
        return this.decoratorSubject.asObservable();
    }
    disconnect() {
        this.dikeDataSource.disconnect();
        this.changeSubscription.unsubscribe();
    }
    reconnect() {
        this.dikeDataSource.reconnect();
        this.setChangeSubscription();
    }
    dispose(releaseSource) {
        this.dikeDataSource.dispose(releaseSource);
        this.changeSubscription.unsubscribe();
        this.decoratorSubject.complete();
    }
    changeDecoratorData(value) {
        this.decoratorSubject.next([...value]);
    }
}

class DkRefreshingDataSource extends DkDecoratorDataSource {
    constructor(dikeDataSource, generalNotifier) {
        super(dikeDataSource);
        this.generalNotifier = generalNotifier;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        const refreshChange$ = this.generalNotifier ?
            merge(this.generalNotifier.initialized(), this.generalNotifier.onRefreshDataSourceChanged$) : of(null);
        // As a wrapper, get the previous result stream:
        const rows$ = this.dikeDataSource.connect();
        const refreshRows$ = combineLatest([rows$, refreshChange$]).pipe(map(([rows, _]) => rows));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = refreshRows$.subscribe(rows => this.data = rows);
    }
}

class DkEditionStateDataSource extends DkDecoratorDataSource {
    constructor(dikeDataSource, gridEditionConfig) {
        super(dikeDataSource);
        this.gridEditionConfig = gridEditionConfig;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        const editionFilterChange$ = this.gridEditionConfig.onEditionFilterChanged$;
        // As a wrapper, get the previous result stream:
        const rows$ = this.dikeDataSource.connect();
        const editionfilteredRows$ = combineLatest([rows$, editionFilterChange$]).pipe(map(([rows, lastEditionFilter]) => {
            // Edition filter state is on, take the last applied filter:
            if (this.gridEditionConfig.editionFilterState && typeof lastEditionFilter !== 'undefined') {
                // If the user wants to display the rows which are being edited:
                if (lastEditionFilter === 'Editing') {
                    return rows.filter(row => row.isEditing);
                    // Otherwise, apply the last filter which corresponds to a RowStatus enum entry:
                }
                else {
                    return rows.filter(row => row.status === lastEditionFilter && !row.isEditing);
                }
            }
            else {
                return rows.filter(row => row.status !== 'Deleted');
            }
        }));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = editionfilteredRows$.subscribe(rows => this.data = rows);
    }
}

class DkEditionFilteringDataSource extends DkDecoratorDataSource {
    constructor(dikeDataSource, gridFilterConfig, filterDispatcher, gridMessaging) {
        super(dikeDataSource);
        this.gridFilterConfig = gridFilterConfig;
        this.filterDispatcher = filterDispatcher;
        this.gridMessaging = gridMessaging;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        const filterChange$ = this.gridFilterConfig ?
            merge(this.gridFilterConfig.initialized(), this.gridFilterConfig.editionFilterEmitter.asObservable(), this.gridFilterConfig.clearEditionFilterEmitter.asObservable()) : of(null);
        // As a wrapper, get the previous result stream:
        const rows$ = this.dikeDataSource.connect();
        let lastFilterable;
        const filteredRows$ = combineLatest([rows$, filterChange$]).pipe(switchMap(([rows, filterable]) => {
            // Save the last emitted filterable:
            lastFilterable = filterable;
            return of(this.filter(rows));
        }), catchError((error, source) => {
            console.error(`The last Filterable was removed:`, lastFilterable);
            console.error(`Actual error:`, error);
            // Clear the filter from the last filterable:
            if (!!lastFilterable && this.gridFilterConfig.filterables.has(lastFilterable.columnId)) {
                let filterable = this.gridFilterConfig.filterables.get(lastFilterable.columnId);
                this.gridFilterConfig.filterables.set(lastFilterable.columnId, Object.assign(Object.assign({}, filterable), { filter: [] }));
                this.gridMessaging.sendPackage({
                    message: 'An error ocurred during filtering. The last filterable was not applied.',
                    data: { error }
                });
            }
            return source;
        }));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = filteredRows$.subscribe(rows => this.data = rows);
    }
    filter(rows) {
        if (this.gridFilterConfig === null || this.gridFilterConfig === undefined || !this.filterDispatcher.isFilterApplied()) {
            return rows;
        }
        return this.filterDispatcher.filterEntries(rows, this.gridFilterConfig.filterables);
    }
}

class DkPagingDataSource extends DkContentDataSource {
    constructor(dikeDataSource, paginationDispatcher) {
        super(dikeDataSource);
        this.paginationDispatcher = paginationDispatcher;
        this.internalPageChanges = new Subject();
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        // As a wrapper, get the previous result stream:
        const rows$ = this.getDikeDataSource().connect();
        /**
         * Retrieving the Paginator instance:
         *
         *  1.  Subscribe to the Observable that delivers the Paginator instance: DkPaginationDispatcher.onPaginatorChanged$.
         *      The Observable comes from a BehaviorSubject.
         *
         *  2.  If the Paginator instance is retrieved, a subscription to the page EventEmitter will be done.
         *      This subscription will be initialized with an Observable<void>.
         *
         *  3.  If the Paginator instance is not present, a subscription will be made to an Observable<void>.
         */
        const paginationChange$ = this.paginationDispatcher.onPaginatorChanged$.pipe(switchMap(paginator => !!paginator ?
            merge(paginator.page, this.internalPageChanges, paginator.initialized) : this.paginationDispatcher.initialized()));
        const pagedRows$ = combineLatest([rows$, paginationChange$]).pipe(tap(([rows]) => this.updatePaginator(rows.length)), map(([rows]) => this.page(rows)));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = pagedRows$.subscribe(rows => this.data = rows);
    }
    page(rows) {
        if (!this.paginationDispatcher.paginator) {
            return rows;
        }
        const startIndex = this.paginationDispatcher.paginator.pageIndex * this.paginationDispatcher.paginator.pageSize;
        return rows.slice(startIndex, startIndex + this.paginationDispatcher.paginator.pageSize);
    }
    updatePaginator(dataLength) {
        Promise.resolve().then(() => {
            /**
             * Update the lentgh and the pageIndex of the Paginator:
             *
             *  (1). If the Paginator is present.
             *  (2). If the length of the data is different from the length value stored in the Paginator.
             */
            if (!this.paginationDispatcher.paginator || this.paginationDispatcher.paginator.length === dataLength) {
                return;
            }
            this.paginationDispatcher.paginator.length = dataLength;
            if (this.paginationDispatcher.paginator.pageIndex > 0) {
                const lastPageIndex = Math.ceil(this.paginationDispatcher.paginator.length / this.paginationDispatcher.paginator.pageSize) - 1 || 0;
                const newPageIndex = Math.min(this.paginationDispatcher.paginator.pageIndex, lastPageIndex);
                if (newPageIndex !== this.paginationDispatcher.paginator.pageIndex) {
                    this.paginationDispatcher.paginator.pageIndex = newPageIndex;
                    this.internalPageChanges.next();
                }
            }
        });
    }
    getDikeDataSource() {
        if (!Array.isArray(this.dikeDataSource)) {
            this.dikeDataSource = [this.dikeDataSource];
        }
        return this.dikeDataSource[0];
    }
}

class DkFilterDispatcher {
    constructor(contentPanelDispatcher, gridFilterConfig, filterFactory) {
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.gridFilterConfig = gridFilterConfig;
        this.filterFactory = filterFactory;
    }
    filterEntries(entries, filterables) {
        // The initialRows will be the entire entries set:
        let initialRows = entries;
        /**
         * At the beginning, the filteredRows are the entire set of original entries.
         * If there are not any filters to apply, the method does not filter just pass
         * the original entries:
         */
        let filteredRows = entries;
        // Get all filterables that has at least one filter specified:
        let actualFilterables = this.getActiveFilter(filterables);
        actualFilterables.forEach(currentFilterable => {
            // Get the conditions which will be executed:
            let filterDispatcherConditions = this.filterFactory.getFilterDispatcherConditionInstance(currentFilterable);
            let columSlot = null;
            /**
             * If the currentFilterable is a row-filter, it does not matter if the column is marked as filterable.
             * Row-filter are independent from column filters. Row-filters are not set by the user, row-filters
             * are set establishing allowRowFiltering DikeGrid @Input property to true.
             */
            if (this.filterFactory.isRowFilter(currentFilterable)) {
                columSlot = this.contentPanelDispatcher.getAllDataColumnSlots().find(dataColumnSlot => dataColumnSlot.dikeColumn.columnId === this.gridFilterConfig.getColumnIdFromFilterable(currentFilterable));
            }
            else {
                /**
                 * If the currentFilterable is not a row-filter, the column represented by the Fitlerable must
                 * has been marked as filterable:
                 */
                columSlot = this.contentPanelDispatcher.getAllDataColumnSlots().find(dataColumnSlot => dataColumnSlot.dikeColumn.filterable && dataColumnSlot.dikeColumn.columnId === this.gridFilterConfig.getColumnIdFromFilterable(currentFilterable));
            }
            /**
             * The data column slot have been retrieved from any of the content panels.
             *
             * This ensures that the filters only apply to content panels. If the column slot
             * lives in the group panel its filter is ignored.
             */
            if (!!columSlot) {
                // The currentFilterable exists in the linked-list and is marked as filterable:
                let dataColumnDef = this.contentPanelDispatcher.cloneColumnSlot(columSlot);
                filteredRows = initialRows.filter(row => {
                    if (!filterDispatcherConditions.orConditionsEval(row.entry, currentFilterable, dataColumnDef)) {
                        return filterDispatcherConditions.andConditionsEval(row.entry, currentFilterable, dataColumnDef);
                    }
                    else {
                        return true;
                    }
                });
                initialRows = filteredRows;
            }
        });
        return filteredRows;
    }
    isFilterApplied() {
        /**
         * Premise: Only content columns are considered for filtering.
         *
         * At least one filterable must have a filter.
         */
        for (const filterable of this.gridFilterConfig.filterables.values()) {
            if (!!filterable.filter && filterable.filter.length > 0 && !!this.contentPanelDispatcher.getAllDataColumnSlots().find(dataColumnSlot => dataColumnSlot.dikeColumn.columnId === this.gridFilterConfig.getColumnIdFromFilterable(filterable))) {
                return true;
            }
        }
        return false;
    }
    getActiveFilter(filterables) {
        let activeFilters = [];
        filterables.forEach(current => {
            if (current.filter && current.filter.length > 0) {
                activeFilters.push(Object.assign(Object.assign({}, current), { orConditions: current.filter.filter(value => value.logicalOperator === 'or'), andConditions: current.filter.filter(value => value.logicalOperator === 'and') }));
            }
        });
        return activeFilters;
    }
}
DkFilterDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterDispatcher, deps: [{ token: DkContentPanelDispatcher }, { token: DkGridFilterConfig }, { token: DkFilterFactory }], target: i0.ɵɵFactoryTarget.Injectable });
DkFilterDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkFilterDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkContentPanelDispatcher }, { type: DkGridFilterConfig }, { type: DkFilterFactory }]; } });

class DkGridMessaging {
    constructor() {
        this.packageChange = new EventEmitter();
    }
    ngOnDestroy() {
        this.packageChange.complete();
    }
    sendTextMessage(message) {
        this.packageChange.emit({
            timestamp: Date.now(),
            message: message,
            data: null,
        });
    }
    sendPackage(dikePackage) {
        this.packageChange.emit(Object.assign(Object.assign({}, dikePackage), { timestamp: Date.now() }));
    }
}
DkGridMessaging.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMessaging, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DkGridMessaging.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMessaging });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMessaging, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class DkDataSourceDispatcher {
    constructor(gridSelection, gridSelectionConfig, gridEditionConfig, rowGroupingConfig, rowGroupingDispatcher, paginationDispatcher, gridFilterConfig, filterDispatcher, generalNotifier, gridMessaging) {
        this.gridSelection = gridSelection;
        this.gridSelectionConfig = gridSelectionConfig;
        this.gridEditionConfig = gridEditionConfig;
        this.rowGroupingConfig = rowGroupingConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.paginationDispatcher = paginationDispatcher;
        this.gridFilterConfig = gridFilterConfig;
        this.filterDispatcher = filterDispatcher;
        this.generalNotifier = generalNotifier;
        this.gridMessaging = gridMessaging;
        this.changeDataDeliverySubscription = Subscription.EMPTY;
        this.changeObservableDataSourceSubscription = Subscription.EMPTY;
        this.changeContentDataSourceSubscription = Subscription.EMPTY;
        this.changeRootGroupRowSubscription = Subscription.EMPTY;
        this.changeEditionFilterStateSubscription = Subscription.EMPTY;
        this.dataDeliveryId = '';
        this.isCustomDataSourceType = false;
        this.gridDataSourceSubject = new BehaviorSubject(null);
        this.contentDataSourceSubject = new BehaviorSubject(null);
        this.decoratorFnSubject = new BehaviorSubject(null);
        this.tempDisableSortPaginationSubject = new BehaviorSubject(false);
        this.dataDeliveryEmitter = new EventEmitter();
        this.setChangeEditionFilterStateSubscription();
    }
    ngOnDestroy() {
        this.contentDataSourceSubject.value.dispose(true);
        this.gridDataSourceSubject.complete();
        this.contentDataSourceSubject.complete();
        this.decoratorFnSubject.complete();
        this.changeDataDeliverySubscription.unsubscribe();
        this.changeObservableDataSourceSubscription.unsubscribe();
        this.changeContentDataSourceSubscription.unsubscribe();
        this.changeRootGroupRowSubscription.unsubscribe();
        this.changeEditionFilterStateSubscription.unsubscribe();
    }
    get onDikeGridDataSourceChanged$() {
        return this.gridDataSourceSubject.asObservable();
    }
    get onContentDataSourceChanged$() {
        return this.contentDataSourceSubject.asObservable();
    }
    get onDecoratorFnChanged$() {
        return this.decoratorFnSubject.asObservable();
    }
    get onTempDisableSortPaginationChanged$() {
        return this.tempDisableSortPaginationSubject.asObservable();
    }
    get gridDataSource() {
        return this.gridDataSourceSubject.value;
    }
    get decoratorCtxFn() {
        return this.decoratorFnSubject.value;
    }
    set decoratorCtxFn(value) {
        this.changeDecoratorFn(value);
    }
    attachDikeGridDataSource(value, dikeGrid) {
        // Every time that the datasource has been changed the loading indicator will be displayed:
        dikeGrid.waitingIndicator.loadingIndicator();
        /**
         * Before evaluating the type of the given DkGridDataSourceInput unsubscribe the
         * changeObservableDataSourceSubscription subscription.
         *
         * It does not matter if the previous DkGridDataSourceInput instance does not
         * contain an Observable or a custom DataSource.
         */
        this.changeObservableDataSourceSubscription.unsubscribe();
        // Every time the user sets a new DkGridDataSourceInput, we evaluate if it is a custom DataSource:
        this.isCustomDataSourceType = this.isCustomDataSource(value);
        /**
         * Establish the corresponding DkGridDataSource instance.
         *
         * An instance of type DkGridDataSource will be created depending on the
         * DikeGrid @Input property datasource. Despite the fact the type of datasource the
         * user provides, remember that an instance of type DkGridDataSource will be always
         * created because it serves as a wrapper of every entry.
         *
         * IMPORTANT:
         *    In this method the DkGridDataSource instance is NOT decorated but the
         *    corresponding decoration function is saved in the decoratorFnSubject
         *    Behaviour Subject.
         */
        // Enable the header checkbox:
        this.gridSelectionConfig.enableAllRowsSelection = !this.isCustomDataSource(value);
        // Is the given value a DataSource?
        if (isDataSource(value)) {
            // 1. The user has provided their own instance of type DkGridDataSource<T>:
            if (value instanceof DkGridDataSource) {
                // The given instance is different from the stored instance:
                if (value !== this.gridDataSource) {
                    /**
                     * Point to the provided reference broadcasting it and
                     * Listen all changes in every new data set:
                     */
                    this.setChangeDataDeliverySubscription(value, dikeGrid);
                }
            }
            else {
                /**
                 * 2. The user has provided their own DataSource instance.
                 *
                 *  (a).  Since DikeGridContent component has an input datasource of type DkDataSource<DkGridRowEntry>,
                 *        this.gridDataSource acts as a wrapper to create every DkGridDataRowEntry<T> instance when the
                 *        entries are set.
                 *
                 *  (b).  If edition is allowed, this.gridDataSource will be wrapped by EDITION_FILTERING decorator.
                 *
                 * Therefore:
                 *
                 *  (a).  Get a new instance which will be the wrapper, broadcast it and,
                 *  (b).  Listen all changes in every new data set.
                 */
                this.setChangeDataDeliverySubscription(new DkGridDataSource(), dikeGrid);
                // Once all the wrappers are set, connect to the given DataSource:
                this.setChangeObservableDataSourceSubscription(value.connect(null), this.gridDataSource);
            }
            // 3. The user has provided an Observable:
        }
        else if (value instanceof Observable) {
            /**
             *  (a).  Get a new instance which will be the wrapper, broadcast it and,
             *  (b).  Listen all changes in every new data set.
             */
            this.setChangeDataDeliverySubscription(new DkGridDataSource(), dikeGrid);
            // The data provided by the Observable is passed into the DkGridDataSource<T> instance.
            this.setChangeObservableDataSourceSubscription(value, this.gridDataSource);
            // 4. The user has provided an Array or a null value or undefined. When a null or undefined value is provided an empty array is delivered:
        }
        else {
            // Get a new instance, broadcast it and listen all changes in every new data set:
            this.setChangeDataDeliverySubscription(new DkGridDataSource(), dikeGrid);
            // The provided array is passed in to the current instance of DkGridDataSource.
            this.gridDataSource.entries = value;
        }
        /**
         * Determine which type of Content DataSource will be delivered.
         *
         * Premise:
         *    Remember that this method is invoked due to the user has provided a new datasource @Input property.
         *
         * At this point the BehaviorSubject gridDataSourceSubject is pointing to the actual instance of type
         * DkGridDataSource<T> which will be holding the data rows provided by the user.
         */
        this.changeDikeGridContentDataSource(this.gridDataSource, dikeGrid);
    }
    getDefaultDataSourceDecorators(dikeDataSource, dikeGrid) {
        let dikeDecoratorDataSource = dikeDataSource;
        // Create the Filtering decorator. It could be the first or the second wrapper, depends on allowEdition property:
        dikeDecoratorDataSource = dikeGrid.dataSourceFactory.createFilteringDecorator(dikeDecoratorDataSource);
        // Create the Sorting wrapper:
        dikeDecoratorDataSource = dikeGrid.dataSourceFactory.createSortingDecorator(dikeDecoratorDataSource);
        return dikeDecoratorDataSource;
    }
    isCustomDataSource(datasource) {
        return !!datasource && isDataSource(datasource) && !(datasource instanceof DkGridDataSource);
    }
    createEditionFilteringDecorator(gridDataSource) {
        // Point to the original DkGridDataSource instance:
        let dikeDecoratorDataSource = gridDataSource;
        /**
         * Creating an instance of type DkEditionStateDataSource means that the user enables edition.
         *
         * Remember that setting this decorator will enable the UI button Filter rows (for filtering edited rows):
         */
        if (this.gridEditionConfig.allowEdition) {
            // DkRefreshingDataSource decorator will be always attached as the first decorator:
            dikeDecoratorDataSource = this.createRefreshingDecorator(gridDataSource);
            // Create the edition state decorator:
            dikeDecoratorDataSource = new DkEditionStateDataSource(dikeDecoratorDataSource, this.gridEditionConfig);
            // Enable edition filters:
            this.gridEditionConfig.enableEditionFilterRows = true;
            // Edition is allowed and the user has provided their own DataSource implementation:
            if (this.isCustomDataSourceType) {
                // Add the DkEditionFilteringDataSource for filtering edited rows in memory:
                dikeDecoratorDataSource = new DkEditionFilteringDataSource(dikeDecoratorDataSource, this.gridFilterConfig, this.filterDispatcher, this.gridMessaging);
            }
        }
        return dikeDecoratorDataSource;
    }
    createRefreshingDecorator(gridDataSource) {
        return new DkRefreshingDataSource(gridDataSource, this.generalNotifier);
    }
    createPagedDataSource(dikeDataSource) {
        return new DkPagingDataSource(dikeDataSource, this.paginationDispatcher);
    }
    setChangeObservableDataSourceSubscription(dataSource$, dikeGridDataSource) {
        this.changeObservableDataSourceSubscription.unsubscribe();
        if (!!dataSource$ && dataSource$ instanceof Observable) {
            this.changeObservableDataSourceSubscription = dataSource$.subscribe(value => dikeGridDataSource.entries = value);
        }
    }
    setChangeDataDeliverySubscription(dikeGridDataSource, dikeGrid) {
        this.changeDataDeliverySubscription.unsubscribe();
        if (!!dikeGridDataSource) {
            // Broadcast the new DkGridDataSource<T> instance:
            this.changeDikeGridDataSource(dikeGridDataSource);
            // After the broadcast, the instance is referenced by the BehaviorSubject subject:
            this.changeDataDeliverySubscription = this.gridDataSource.dataDeliveryChanges.pipe(filter(value => value !== ''), tap(() => dikeGrid.waitingIndicator.hideWaitingIndicator()), observeOn(asyncScheduler)).subscribe(value => {
                // The data has been changed meaning that the user has provided a new set of entries:
                if (value !== this.dataDeliveryId) {
                    // Release the previous edition:
                    dikeGrid.releaseEdition();
                    // Release the previous selection:
                    dikeGrid.releaseSelection();
                    /**
                     * If the paginator is present and the current datasource is not a custom implementation,
                     * move to the first page. Otherwise if the new data set is smaller, it will not be displayed:
                     */
                    if (!!this.paginationDispatcher.paginator && !this.isCustomDataSource(dikeGrid.datasource)) {
                        this.paginationDispatcher.paginator.firstPage();
                    }
                    // Save the current delivery id:
                    this.dataDeliveryId = value;
                    // Emit the current delivery id to the outside:
                    this.dataDeliveryEmitter.emit(value);
                }
            });
        }
    }
    setChangeRootGroupRowSubscription(wrappingDataSource) {
        this.changeRootGroupRowSubscription.unsubscribe();
        this.changeRootGroupRowSubscription = wrappingDataSource.onRootGroupRowChanged$
            .subscribe(rootGroup => this.rowGroupingDispatcher.rootGroupRow = rootGroup);
    }
    setChangeEditionFilterStateSubscription() {
        /**
         * Sorting and Paging operations are temporarily disable when
         * the following conditions are met:
         *
         *  (a). The user has provided their own DataSource implementation.
         *  (b). The user has enabled the edition and is navigating the edited rows.
         *
         * Since the DkDataSourceDispatcher service knows the type of the DataSource,
         * this service is responsible of verifying the above conditions.
         *
         * The this.gridEditionConfig.onEditionFilterStateChanged$ observable delivers
         * a true value when the user is navigating the edited rows.
         */
        this.changeEditionFilterStateSubscription.unsubscribe();
        this.changeEditionFilterStateSubscription = this.gridEditionConfig.onEditionFilterStateChanged$
            .subscribe(editionFilterState => this.tempDisableSortPaginationSubject.next(editionFilterState && this.isCustomDataSourceType));
    }
    changeDikeGridDataSource(value) {
        this.gridDataSourceSubject.next(value);
    }
    changeDikeGridContentDataSource(gridDataSource, dikeGrid) {
        // Dispose the previous decorators. This is the only place where decorators are disposed:
        if (!!this.contentDataSourceSubject.value) {
            this.contentDataSourceSubject.value.dispose(true);
        }
        let contentDataSource = null;
        // If the provided dataSource is not custom:
        if (!this.isCustomDataSource(dikeGrid.datasource)) {
            // Create a DkWrappingDataSource instance:
            let wrappingDataSource = new DkWrappingDataSource(gridDataSource, this.gridSelectionConfig, this.gridSelection, this, this.rowGroupingDispatcher, this.generalNotifier);
            // After creating the wrapping dataSource attach to the root group row Observable:
            this.setChangeRootGroupRowSubscription(wrappingDataSource);
            /**
             * DkPagingDataSource.
             *
             * Premises:
             *
             *    1.  It does not matter what type of dataSource the Dispatcher resolves, paging applies to
             *        the final dataSource decorator.
             *
             *    2.  DkPagingDataSource is a content decorator and is able to receive rows of type DkGridRowEntry.
             *
             * IMPORTANT: The createPagedDataSource(...) method always return an instance of type DkPagingDataSource.
             *            The DkPagingDataSource instance wraps the DkPaginationDispatcher service instance to listen
             *            the onPaginatorChanged$ observable giving the ability to react when the MatPaginator is
             *            present or not.
             */
            contentDataSource = this.createPagedDataSource(wrappingDataSource);
        }
        else {
            /**
             * The user has provided their own DataSource<T> implementation:
             * DkRefreshingDataSource, DkEditionStateDataSource and DkEditionFilteringDataSource decorators must be set:
             */
            contentDataSource = this.createEditionFilteringDecorator(gridDataSource);
            // Disable row-grouping, if the user had enabled it:
            setTimeout(() => {
                dikeGrid.allowRowGrouping = false;
                this.rowGroupingConfig.allowRowGrouping = false;
            }, 0);
        }
        // Then broadcast the content dataSource:
        this.contentDataSourceSubject.next(contentDataSource);
    }
    changeDecoratorFn(value) {
        this.decoratorFnSubject.next(value);
    }
}
DkDataSourceDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataSourceDispatcher, deps: [{ token: DkGridSelection }, { token: DkGridSelectionConfig }, { token: DkGridEditionConfig }, { token: DkRowGroupingConfig }, { token: DkRowGroupingDispatcher }, { token: DkPaginationDispatcher }, { token: DkGridFilterConfig }, { token: DkFilterDispatcher }, { token: DkGeneralNotifier }, { token: DkGridMessaging }], target: i0.ɵɵFactoryTarget.Injectable });
DkDataSourceDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataSourceDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataSourceDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridSelection }, { type: DkGridSelectionConfig }, { type: DkGridEditionConfig }, { type: DkRowGroupingConfig }, { type: DkRowGroupingDispatcher }, { type: DkPaginationDispatcher }, { type: DkGridFilterConfig }, { type: DkFilterDispatcher }, { type: DkGeneralNotifier }, { type: DkGridMessaging }]; } });

class DkGridDataStore {
    constructor(dataSourceDispatcher, generalNotifier) {
        this.dataSourceDispatcher = dataSourceDispatcher;
        this.generalNotifier = generalNotifier;
        this.changeDataSourceSubscription = Subscription.EMPTY;
        this.rowsInEdition = new Map();
        this.setChangeDataSourceSubscription();
    }
    ngOnDestroy() {
        this.changeDataSourceSubscription.unsubscribe();
    }
    updateField(rowId, rowStatus, field, timestamp) {
        let row = this.gridDataSource.data[rowId];
        field.updateValue(row.entry, field.value);
        // Change the same row reference:
        row.timestamp = timestamp;
        row.status = rowStatus;
    }
    updateRow(rowId, rowStatus, fields, timestamp) {
        let row = this.gridDataSource.data[rowId];
        // Update all the specified fields:
        fields.forEach(field => {
            field.updateValue(row.entry, field.value);
        });
        // Change the same row reference:
        row.timestamp = timestamp;
        row.status = rowStatus;
    }
    deleteRow(rowId, timestamp) {
        let row = this.gridDataSource.data[rowId];
        // Change the same row reference:
        row.timestamp = timestamp;
        row.status = 'Deleted';
    }
    setEditionRowState(row) {
        if (!row.isEditing) {
            row.isEditing = true;
            this.rowsInEdition.set(row.id, row);
        }
    }
    cancelEditionRowState(row) {
        if (row.isEditing && this.rowsInEdition.has(row.id)) {
            row.isEditing = false;
            this.rowsInEdition.delete(row.id);
        }
    }
    filterRows(compareFn) {
        return !!this.gridDataSource ? this.gridDataSource.data.filter(compareFn) : [];
    }
    getRow(rowId) {
        return !!this.gridDataSource ? this.gridDataSource.data[rowId] : null;
    }
    getRowsInEditionState() {
        let rowsInEditionArray = [];
        this.rowsInEdition.forEach(value => rowsInEditionArray.push(value));
        return rowsInEditionArray;
    }
    getDeletedRows() {
        return !!this.gridDataSource ? this.gridDataSource.data.filter(row => row.status === 'Deleted') : [];
    }
    getUpdatedRows() {
        return !!this.gridDataSource ? this.gridDataSource.data.filter(row => row.status === 'Modified') : [];
    }
    sendChanges() {
        this.generalNotifier.refreshDataSource();
    }
    releaseRowsInEdition() {
        // Take the rows in edition state and cancel them:
        this.getRowsInEditionState().forEach(row => this.cancelEditionRowState(row));
        // Clear the Map that stores the rows in edition:
        this.rowsInEdition.clear();
    }
    setChangeDataSourceSubscription() {
        this.changeDataSourceSubscription.unsubscribe();
        this.changeDataSourceSubscription = this.dataSourceDispatcher.onDikeGridDataSourceChanged$.subscribe(value => this.gridDataSource = value);
    }
}
DkGridDataStore.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDataStore, deps: [{ token: DkDataSourceDispatcher }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridDataStore.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDataStore });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDataStore, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkDataSourceDispatcher }, { type: DkGeneralNotifier }]; } });

class DkGridCommandFactory {
    constructor(gridDataStore) {
        this.gridDataStore = gridDataStore;
    }
    createUpdateFieldCommand(rowId, field, timestamp) {
        return new UpdateFieldCommand(this.gridDataStore, rowId, field, timestamp);
    }
    createUpdateRowCommand(rowId, fields, timestamp) {
        return new UpdateRowCommand(this.gridDataStore, rowId, fields, timestamp);
    }
    createDeleteRowCommand(rowId, timestamp) {
        return new DeleteRowCommand(this.gridDataStore, rowId, timestamp);
    }
    createRowMemento(rowId, rowStatus, fields, timestamp) {
        return new RowMemento(this.gridDataStore, rowId, rowStatus, fields, timestamp);
    }
}
DkGridCommandFactory.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandFactory, deps: [{ token: DkGridDataStore }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridCommandFactory.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandFactory });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandFactory, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridDataStore }]; } });

class DkGridPanelDispatcher extends DkPanelDispatcher {
    constructor(rowGroupingConfig, contentPanelDispatcher, groupPanelDispatcher) {
        super([
            contentPanelDispatcher.leftPanel,
            contentPanelDispatcher.centerPanel,
            contentPanelDispatcher.rightPanel,
            groupPanelDispatcher.groupPanel
        ]);
        this.rowGroupingConfig = rowGroupingConfig;
        this.changeNonGroupableSubscription = Subscription.EMPTY;
        this.emitColumnResizingSubscription = Subscription.EMPTY;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.shareableDropElementsSubject = new BehaviorSubject({
            groupPanel: new Map(),
            leftPanel: new Map(),
            centerPanel: new Map(),
            rightPanel: new Map()
        });
        this.columnResizedEmitter = new EventEmitter();
        this.columnMovedEmitter = new EventEmitter();
        this.setChangeColumnSlotsSubscription();
        this.setChangeDataColumnSlotsSubscription();
        this.setChangeNonGroupableSubscription();
        this.setChangeShareableDropElementsSubscription();
        this.setEmitColumnResizingSubscription();
    }
    ngOnDestroy() {
        super.destroy();
        this.changeNonGroupableSubscription.unsubscribe();
        this.emitColumnResizingSubscription.unsubscribe();
    }
    get gridPanels() {
        return this.panels;
    }
    // This method inserts only new columns:
    addColumns(columns) {
        if (!Array.isArray(columns)) {
            columns = [columns];
        }
        let contentPanelColumns = [];
        let groupPanelColumns = [];
        columns.forEach(column => {
            if (column.panel === 'groupPanel' && this.rowGroupingConfig.allowRowGrouping) {
                groupPanelColumns.push(column);
            }
            else {
                contentPanelColumns.push(column);
            }
        });
        if (contentPanelColumns.length > 0) {
            this.contentPanelDispatcher.addColumns(contentPanelColumns);
        }
        if (groupPanelColumns.length > 0) {
            this.groupPanelDispatcher.addColumns(groupPanelColumns);
        }
    }
    movePanelColumnSlots(fromPanel, destinationPanel, onlyVisibleColumnSlots) {
        let movedColumns = [];
        if (fromPanel !== destinationPanel) {
            if (destinationPanel instanceof DkGroupColumnStructure) {
                movedColumns = this.groupPanelDispatcher.movePanelColumnSlots(fromPanel, destinationPanel, onlyVisibleColumnSlots);
            }
            else if (destinationPanel instanceof DkContentColumnStructure) {
                movedColumns = this.contentPanelDispatcher.movePanelColumnSlots(fromPanel, destinationPanel, onlyVisibleColumnSlots);
            }
            // Emit the event data:
            this.emitColumnsToPanel(destinationPanel, movedColumns);
        }
        return movedColumns;
    }
    moveColumnSlotIntoPanel(columnSlot, fromPanel, destinationPanel) {
        let movedColumns = [];
        if (!!columnSlot && columnSlot.dikeColumn.panel === fromPanel.panel && fromPanel !== destinationPanel) {
            if (destinationPanel instanceof DkGroupColumnStructure) {
                movedColumns = this.groupPanelDispatcher.moveColumnSlotIntoPanel(columnSlot, fromPanel, destinationPanel);
            }
            else if (destinationPanel instanceof DkContentColumnStructure) {
                movedColumns = this.contentPanelDispatcher.moveColumnSlotIntoPanel(columnSlot, fromPanel, destinationPanel);
            }
            // Emit the event data:
            this.emitColumnsToPanel(destinationPanel, movedColumns);
        }
        return movedColumns;
    }
    moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        if (!!sourceSlot && !!sourcePanel && !!destinationSlot && !!destinationPanel &&
            sourceSlot.dikeColumn.panel === sourcePanel.panel &&
            destinationSlot.dikeColumn.panel === destinationPanel.panel &&
            sourcePanel !== destinationPanel && destinationSlot.dikeColumn.columnType === 'Gutter-Column') {
            const gutterOwner = destinationPanel.getColumnSlot(destinationSlot.dikeColumn.columnIdBelongTo);
            // Before moving the source column slot, get the column movement:
            const movement = this.isBeforeOrAfterMovement(destinationSlot, gutterOwner);
            // Move the source column slot:
            if (destinationPanel instanceof DkGroupColumnStructure) {
                this.groupPanelDispatcher.moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
            }
            else if (destinationPanel instanceof DkContentColumnStructure) {
                this.contentPanelDispatcher.moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
            }
            // Emit the event data:
            this.emitColumnToGutter(destinationPanel, sourceSlot.slotId, gutterOwner.slotId, movement);
        }
    }
    swapColumnSlotsInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        if (!!sourceSlot && !!sourcePanel && !!destinationSlot && !!destinationPanel &&
            sourceSlot.dikeColumn.panel === sourcePanel.panel &&
            destinationSlot.dikeColumn.panel === destinationPanel.panel &&
            sourcePanel !== destinationPanel) {
            this.contentPanelDispatcher.swapColumnSlotsInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
            // Emit event data:
            this.emitSwappedColumnsInDifferentPanel(sourcePanel, destinationPanel, sourceSlot.slotId, destinationSlot.slotId);
        }
    }
    joinColumnGroupSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        if (!!sourceSlot && !!destinationSlot && !!sourcePanel && !!destinationPanel &&
            sourceSlot.belongToGroup === destinationSlot.belongToGroup &&
            sourceSlot.dikeColumn.panel !== destinationSlot.dikeColumn.panel &&
            sourceSlot.slotId === destinationSlot.slotId) {
            this.contentPanelDispatcher.joinColumnGroupSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
            // Emit the event data:
            this.emitJoinedColumnGroup(destinationPanel, destinationSlot.slotId);
        }
    }
    interchageColumnSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * sourceSlot must be an instance of DkColumnMeshSlot it means
         * that sourceSlot holds an instance of DkDataColumn or
         * DkGroupColumn.
         *
         * Remember the following:
         *    1. Only DikeDataColums or DikeGroupColumns can be dragged.
         *    2. Movements can be done between columns of the same group.
         *
         * IMPORTANT: This method is invoked by the UI components: DkGridRowHeaderComponent and DkGridRowGroupingComponent.
         */
        if (!!sourceSlot && !!destinationSlot && !!sourcePanel && !!destinationPanel &&
            (sourceSlot.dikeColumn.columnType === 'Data-Column' ||
                sourceSlot.dikeColumn.columnType === 'Group-Column') &&
            this.doSlotsBelongToSameGroup(sourcePanel, sourceSlot, destinationPanel, destinationSlot)) {
            // Slots are in the same grid panel:
            if (sourceSlot.dikeColumn.panel === destinationSlot.dikeColumn.panel) {
                if ((destinationSlot.dikeColumn.columnType === 'Data-Column' ||
                    destinationSlot.dikeColumn.columnType === 'Group-Column') &&
                    sourceSlot.dikeColumn.columnId !== destinationSlot.dikeColumn.columnId) {
                    this.swapColumnSlotsInSamePanel(sourcePanel, sourceSlot, destinationSlot);
                }
                else if (destinationSlot.dikeColumn.columnType === 'Gutter-Column' &&
                    sourceSlot.dikeColumn.columnId !== destinationSlot.dikeColumn.columnIdBelongTo) {
                    this.moveColumnSlotToGutterSlotInSamePanel(sourcePanel, sourceSlot, destinationSlot);
                }
                // Destination is a Group or Data column that lives in other panel (Content Panel):
            }
            else if ((destinationSlot.dikeColumn.columnType === 'Group-Column' ||
                destinationSlot.dikeColumn.columnType === 'Data-Column') &&
                sourcePanel instanceof DkContentColumnStructure && destinationPanel instanceof DkContentColumnStructure) {
                /**
                 * Source and destinations slots have the same slotId.
                 * It means both of them are group columns and are the
                 * same group that was split before.
                 */
                if (sourceSlot.slotId === destinationSlot.slotId) {
                    this.joinColumnGroupSlots(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
                }
                else {
                    // Source and destination slots belong to the same group and live in different panel,
                    this.swapColumnSlotsInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
                }
            }
            else if (destinationSlot.dikeColumn.columnType === 'Gutter-Column') {
                // Destination is a Gutter that lives in other panel:
                this.moveColumnSlotToGutterSlotInDifferentPanel(sourcePanel, sourceSlot, destinationPanel, destinationSlot);
            }
        }
    }
    doSlotsBelongToSameGroup(sourcePanel, sourceSlot, destinationPanel, destinationSlot) {
        /**
         * Premise for all scenarios:
         *    sourceSlot.belongToGroup must be equal to destinationSlot.belongToGroup
         *
         * Exception:
         *    When a data slot that belongs to a group column is dragged (or moved programmatically) to
         *    the Group panel, the mentioned premise is not fulfilled at all because all columns and gutters
         *    that live in the groupPanel belong to the root group (ROOT_GROUP_ID). Nevertheless,
         *    the movement is totally valid.
         *
         * Therefore, before finding the correct scenario, belonging-to-Group requirement must be evaluated.
         */
        return (sourcePanel instanceof DkContentColumnStructure &&
            destinationPanel instanceof DkGroupColumnStructure &&
            sourceSlot.dikeColumn.columnType === 'Data-Column' &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked && sourceSlot.dikeColumn.groupable &&
            destinationSlot.dikeColumn.columnType === 'Gutter-Column') ||
            sourceSlot.belongToGroup === destinationSlot.belongToGroup;
    }
    swapColumnSlotsInSamePanel(sourcePanel, sourceSlot, destinationSlot) {
        /**
         * 1. Source and destination slots must belong to the same group.
         * 2. Source and destination slots must be draggable and not locked.
         * 3. Source and destination slots muts belong to the same panel.
         * 4. Both of them must be either a data column or a group column.
         * 5. They must be different to each other.
         */
        if (sourceSlot && destinationSlot && sourceSlot.belongToGroup === destinationSlot.belongToGroup &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked &&
            destinationSlot.dikeColumn.draggable && !destinationSlot.dikeColumn.locked &&
            sourceSlot.dikeColumn.panel === destinationSlot.dikeColumn.panel &&
            (sourceSlot.dikeColumn.columnType === 'Data-Column' ||
                sourceSlot.dikeColumn.columnType === 'Group-Column') &&
            (destinationSlot.dikeColumn.columnType === 'Data-Column' ||
                destinationSlot.dikeColumn.columnType === 'Group-Column') &&
            sourceSlot.dikeColumn.columnId !== destinationSlot.dikeColumn.columnId) {
            sourcePanel.swapColumnSlots(sourceSlot, destinationSlot);
            sourcePanel.setColumnSlotsOrder(0);
            // Emit the event data:
            this.emitSwappedColumnsInSamePanel(sourcePanel, sourceSlot.slotId, destinationSlot.slotId);
        }
    }
    moveColumnSlotToGutterSlotInSamePanel(sourcePanel, sourceSlot, destinationSlot) {
        /**
         * 1. Source and destination slots must belong to the same group.
         * 2. Source slot must be draggable and not locked.
         * 3. Source and destination slots muts belong to the same panel.
         * 4. Source slot must be a data or group column.
         * 5. Destination slot must be a gutter slot.
         * 6. The destination gutter slot can not belong to the source slot.
         * 7. The gutter owner must be draggable and not locked as well.
         */
        if (sourceSlot && destinationSlot &&
            sourceSlot.belongToGroup === destinationSlot.belongToGroup &&
            sourceSlot.dikeColumn.draggable && !sourceSlot.dikeColumn.locked &&
            sourceSlot.dikeColumn.panel === destinationSlot.dikeColumn.panel &&
            (sourceSlot.dikeColumn.columnType === 'Data-Column' ||
                sourceSlot.dikeColumn.columnType === 'Group-Column') &&
            destinationSlot.dikeColumn.columnType === 'Gutter-Column' &&
            sourceSlot.dikeColumn.columnId !== destinationSlot.dikeColumn.columnIdBelongTo) {
            let gutterOwner = sourcePanel.getColumnSlot(destinationSlot.dikeColumn.columnIdBelongTo);
            // The gutter owner must be draggable as well:
            if (!!gutterOwner && gutterOwner.dikeColumn.draggable && !gutterOwner.dikeColumn.locked) {
                // Before moving the source column slot, get the column movement:
                const movement = this.isBeforeOrAfterMovement(destinationSlot, gutterOwner);
                // Move the source column slot:
                sourcePanel.swapColumnSlotToGutterSlot(sourceSlot, destinationSlot);
                sourcePanel.setColumnSlotsOrder(0);
                // Emit the event data:
                this.emitColumnToGutter(sourcePanel, sourceSlot.slotId, gutterOwner.slotId, movement);
            }
        }
    }
    setChangeColumnSlotsSubscription() {
        const gridPanelColumns$ = combineLatest([
            this.groupPanelDispatcher.onColumnSlotsChanged$,
            this.contentPanelDispatcher.onColumnSlotsChanged$
        ]).pipe(map(([groupSlots, contentSlots]) => [...groupSlots, ...contentSlots]));
        this.changesColumnSlotsSubscription.unsubscribe();
        this.changesColumnSlotsSubscription = gridPanelColumns$.subscribe(value => this.columnSlotsSubject.next(value));
    }
    setChangeDataColumnSlotsSubscription() {
        const gridPanelDataColumns$ = combineLatest([
            this.groupPanelDispatcher.onDataColumnSlotsChanged$,
            this.contentPanelDispatcher.onDataColumnSlotsChanged$
        ]).pipe(map(([groupSlots, contentSlots]) => [...groupSlots, ...contentSlots]));
        this.changesDataColumnSlotsSubscription.unsubscribe();
        this.changesDataColumnSlotsSubscription = gridPanelDataColumns$.subscribe(value => this.dataColumnSlotsSubject.next(value));
    }
    setChangeListHeightSubscription() {
        return;
    }
    setChangeShareableDropElementsSubscription() {
        let panelShareables$ = combineLatest([
            this.groupPanelDispatcher.onShareDropElementsChanged$,
            this.contentPanelDispatcher.onShareDropElementsChanged$
        ]);
        this.changesShareableDropElementsSubscription.unsubscribe();
        this.changesShareableDropElementsSubscription = panelShareables$.subscribe(([groupShareables, contentShareables]) => {
            this.shareableDropElementsSubject.next({
                groupPanel: groupShareables.groupPanel,
                leftPanel: contentShareables.leftPanel,
                centerPanel: contentShareables.centerPanel,
                rightPanel: contentShareables.rightPanel
            });
        });
    }
    setChangeNonGroupableSubscription() {
        /**
         * This subscription is for a group that contains some data columns
         * that are not groupable but the group column was defined to be inserted
         * into the group panel.
         *
         * Remember that this subscription is reached only for new group columns
         * definitions.
         */
        this.changeNonGroupableSubscription.unsubscribe();
        this.changeNonGroupableSubscription = this.groupPanelDispatcher.onNonGroupableDataColumnsChanged$
            .subscribe(value => value.forEach(columnDef => {
            if (columnDef.panel !== 'groupPanel') {
                this.panels[columnDef.panel].addColumn(columnDef);
            }
            else {
                throw new Error(`Error from DkGridPanelDispatcher - A rejected data branch can not belong to group panel because it was already rejected from the group panel.`);
            }
        }));
    }
    isBeforeOrAfterMovement(destinationGutterSlot, gutterOwner) {
        if (!!destinationGutterSlot && !!gutterOwner && destinationGutterSlot.dikeColumn.columnType === 'Gutter-Column') {
            if (gutterOwner.dikeColumn.panel === 'groupPanel' || gutterOwner.dikeColumn.panel === 'leftPanel' || gutterOwner.dikeColumn.panel === 'centerPanel') {
                if (gutterOwner.complementDikeGutterSlot === destinationGutterSlot) {
                    return 'column-before';
                }
                else {
                    return 'column-after';
                }
            }
            else if (gutterOwner.dikeColumn.panel === 'rightPanel') {
                if (gutterOwner.complementDikeGutterSlot === destinationGutterSlot) {
                    return 'column-after';
                }
                else {
                    return 'column-before';
                }
            }
        }
    }
    setEmitColumnResizingSubscription() {
        this.emitColumnResizingSubscription.unsubscribe();
        const columnResized$ = merge(this.panels.leftPanel.onColumnSizeChanged$, this.panels.centerPanel.onColumnSizeChanged$, this.panels.rightPanel.onColumnSizeChanged$, this.panels.groupPanel.onColumnSizeChanged$);
        this.emitColumnResizingSubscription = columnResized$.subscribe(column => this.columnResizedEmitter.emit(column));
    }
    emitSwappedColumnsInSamePanel(destinationPanel, slotId1, slotId2) {
        /**
         * This method must be invoked after the movement.
         */
        // Get the column slots:
        const columnSlot1 = destinationPanel.getColumnSlotByUniqueId(slotId1);
        const columnSlot2 = destinationPanel.getColumnSlotByUniqueId(slotId2);
        if (!!columnSlot1 && !!columnSlot2) {
            // Prepare the object for emission:
            const moveEventData = {
                type: 'swap-columns',
                movedColumns: [
                    destinationPanel.cloneColumnSlot(columnSlot1, false),
                    destinationPanel.cloneColumnSlot(columnSlot2, false)
                ]
            };
            // Emit the event data:
            this.columnMovedEmitter.emit(moveEventData);
        }
    }
    emitSwappedColumnsInDifferentPanel(sourcePanel, destinationPanel, sourceSlotId, destinationSlotId) {
        /**
         * This method must be invoked after the movement.
         */
        // Now, the source panel has the destination slot:
        const columnSlot1 = sourcePanel.getColumnSlotByUniqueId(destinationSlotId);
        // Now, the destination panel has the source slot:
        const columnSlot2 = destinationPanel.getColumnSlotByUniqueId(sourceSlotId);
        if (!!columnSlot1 && !!columnSlot2) {
            // Prepare the object for emission:
            const moveEventData = {
                type: 'swap-columns',
                movedColumns: [
                    sourcePanel.cloneColumnSlot(columnSlot1, false),
                    destinationPanel.cloneColumnSlot(columnSlot2, false)
                ]
            };
            // Emit the event data:
            this.columnMovedEmitter.emit(moveEventData);
        }
    }
    emitJoinedColumnGroup(destinationPanel, groupSlotId) {
        /**
         * This method must be invoked after the movement.
         */
        const groupSlot = destinationPanel.getColumnSlotByUniqueId(groupSlotId);
        if (!!groupSlot) {
            // Prepare the object for emission:
            const moveEventData = {
                type: 'join-column-groups',
                movedColumns: [
                    destinationPanel.cloneColumnSlot(groupSlot, false)
                ],
                destinationPanel: destinationPanel.panel
            };
            // Emit the event data:
            this.columnMovedEmitter.emit(moveEventData);
        }
    }
    emitColumnToGutter(destinationPanel, sourceSlotId, gutterOwnerSlotId, movement) {
        /**
         * This method must be invoked after the movement.
         */
        const sourceSlot = destinationPanel.getColumnSlotByUniqueId(sourceSlotId);
        const gutterOwnerSlot = destinationPanel.getColumnSlotByUniqueId(gutterOwnerSlotId);
        if (!!sourceSlot && !!gutterOwnerSlot) {
            let moveEventData = null;
            if (movement === 'column-after') {
                moveEventData = {
                    type: 'column-after',
                    movedColumns: [destinationPanel.cloneColumnSlot(sourceSlot, false)],
                    destinationPanel: destinationPanel.panel,
                    afterColumn: destinationPanel.cloneColumnSlot(gutterOwnerSlot, false)
                };
            }
            else if (movement === 'column-before') {
                moveEventData = {
                    type: 'column-before',
                    movedColumns: [destinationPanel.cloneColumnSlot(sourceSlot, false)],
                    destinationPanel: destinationPanel.panel,
                    beforeColumn: destinationPanel.cloneColumnSlot(gutterOwnerSlot, false)
                };
            }
            // Emit the event data:
            if (!!moveEventData) {
                this.columnMovedEmitter.emit(moveEventData);
            }
        }
    }
    emitColumnsToPanel(destinationPanel, movedColumns) {
        /**
         * This method must be invoked after the movement.
         */
        const movedColumnSlots = !!movedColumns && movedColumns.length > 0 ?
            movedColumns.map(columnDef => destinationPanel.getColumnSlotByUniqueId(columnDef.slotId)) : [];
        if (!!movedColumnSlots && movedColumnSlots.length > 0) {
            // Prepare the object for emission:
            const moveEventData = {
                type: 'columns-to-panel',
                movedColumns: movedColumnSlots.map(columnSlot => destinationPanel.cloneColumnSlot(columnSlot, false)),
                destinationPanel: destinationPanel.panel
            };
            // Emit the event data:
            this.columnMovedEmitter.emit(moveEventData);
        }
    }
}
DkGridPanelDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPanelDispatcher, deps: [{ token: DkRowGroupingConfig }, { token: DkContentPanelDispatcher }, { token: DkGroupPanelDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridPanelDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPanelDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPanelDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkRowGroupingConfig }, { type: DkContentPanelDispatcher }, { type: DkGroupPanelDispatcher }]; } });

class DkGridColumnDef {
    constructor(gridFactoryColumns, gridPanelDispatcher, contentPanelDispatcher) {
        this.gridFactoryColumns = gridFactoryColumns;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.changeColumnDefSubscription = Subscription.EMPTY;
        this.columnDefSubject = new BehaviorSubject([]);
        this.setChangeColumnDefSubscription();
    }
    get columnSizeChange() {
        return this.gridPanelDispatcher.columnResizedEmitter.asObservable();
    }
    get columnGroupStatusChange() {
        return this.contentPanelDispatcher.columnGroupStatusEmitter.asObservable();
    }
    get columnLockedChange() {
        return this.contentPanelDispatcher.columnLockedEmitter.asObservable();
    }
    get columnUnLockedChange() {
        return this.contentPanelDispatcher.columnUnLockedEmitter.asObservable();
    }
    get columnVisibleChange() {
        return this.contentPanelDispatcher.columnVisibleEmitter.asObservable();
    }
    get columnMove() {
        return this.gridPanelDispatcher.columnMovedEmitter.asObservable();
    }
    get columnsChange() {
        return this.gridPanelDispatcher.columnsChangedEmitter.asObservable();
    }
    get contentPanelsColumnsChange() {
        return this.contentPanelDispatcher.columnsChangedEmitter.asObservable();
    }
    get columnsRemovedChange() {
        return this.gridPanelDispatcher.columnsRemovedEmitter.asObservable();
    }
    ngOnDestroy() {
        this.columnDefSubject.next([]);
        this.columnDefSubject.complete();
        this.changeColumnDefSubscription.unsubscribe();
    }
    addColumns(columns) {
        if (!Array.isArray(columns)) {
            columns = [columns];
        }
        // Since this method only adds new columns, the given columns are cloned:
        const newClonedColumns = this.cloneColumns(columns);
        // Once the columns have been cloned, establish their order:
        this.orderColumns(newClonedColumns, this.getColumns().length);
        // Add columns in its corresponding panels:
        this.gridPanelDispatcher.addColumns(newClonedColumns);
    }
    removeColumns(columns) {
        this.gridPanelDispatcher.removeColumnSlot(columns);
    }
    findColumn(compare) {
        return this.searchColumnInArray(this.getColumns(), compare);
    }
    findNode(compare) {
        return this.searchNodeInTree(this.getLinkedColumns(this.getColumns()), compare);
    }
    swapColumns(sourceColumn, destinationColumn) {
        let sourceColumnSlot = this.gridPanelDispatcher.gridPanels[sourceColumn.panel].getColumnSlot(sourceColumn.columnId);
        let destinationColumnSlot = this.gridPanelDispatcher.gridPanels[destinationColumn.panel].getColumnSlot(destinationColumn.columnId);
        // Columns must belong to the same group:
        if (!!sourceColumnSlot && !!destinationColumnSlot && sourceColumnSlot !== destinationColumnSlot &&
            sourceColumnSlot.dikeColumn.columnId !== destinationColumnSlot.dikeColumn.columnId &&
            sourceColumnSlot.belongToGroup === destinationColumnSlot.belongToGroup) {
            // Swap columns in the same panel:
            if (sourceColumnSlot.dikeColumn.panel === destinationColumnSlot.dikeColumn.panel) {
                this.gridPanelDispatcher.swapColumnSlotsInSamePanel(this.gridPanelDispatcher.gridPanels[sourceColumn.panel], sourceColumnSlot, destinationColumnSlot);
                // Swap columns in different panel but both of them come from any of the Content Panels:
            }
            else if (sourceColumnSlot.dikeColumn.panel !== destinationColumnSlot.dikeColumn.panel &&
                (sourceColumnSlot.dikeColumn.panel === 'leftPanel' || sourceColumnSlot.dikeColumn.panel === 'centerPanel' ||
                    sourceColumnSlot.dikeColumn.panel === 'rightPanel') &&
                (destinationColumnSlot.dikeColumn.panel === 'leftPanel' || destinationColumnSlot.dikeColumn.panel === 'centerPanel' ||
                    destinationColumnSlot.dikeColumn.panel === 'rightPanel')) {
                // Are source and destination columns the same group?
                if (sourceColumnSlot.slotId === destinationColumnSlot.slotId) {
                    // This is a group that has been split, join it:
                    this.gridPanelDispatcher.joinColumnGroupSlots(this.gridPanelDispatcher.gridPanels[sourceColumnSlot.dikeColumn.panel], sourceColumnSlot, this.gridPanelDispatcher.gridPanels[destinationColumnSlot.dikeColumn.panel], destinationColumnSlot);
                }
                else {
                    // Otherwise interchange the given columns:
                    this.gridPanelDispatcher.swapColumnSlotsInDifferentPanel(this.gridPanelDispatcher.gridPanels[sourceColumnSlot.dikeColumn.panel], sourceColumnSlot, this.gridPanelDispatcher.gridPanels[destinationColumnSlot.dikeColumn.panel], destinationColumnSlot);
                }
            }
        }
    }
    movePanelColumns(fromPanel, destinationPanel, onlyVisibleColumns = false) {
        if (fromPanel !== destinationPanel) {
            this.gridPanelDispatcher.movePanelColumnSlots(this.gridPanelDispatcher.gridPanels[fromPanel], this.gridPanelDispatcher.gridPanels[destinationPanel], onlyVisibleColumns);
        }
    }
    moveColumnIntoPanel(column, panel) {
        // Get the source column slot:
        let columnSlot = this.gridPanelDispatcher.gridPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot) {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(columnSlot, this.gridPanelDispatcher.gridPanels[column.panel], this.gridPanelDispatcher.gridPanels[panel]);
        }
    }
    moveColumnAfter(column, targetColumn) {
        let sourcePanel = this.gridPanelDispatcher.gridPanels[column.panel];
        let columnSlot = sourcePanel.getColumnSlot(column.columnId);
        let destinationPanel = this.gridPanelDispatcher.gridPanels[targetColumn.panel];
        let targetColumnSlot = destinationPanel.getColumnSlot(targetColumn.columnId);
        let targetGutter = null;
        /**
         * Inserting a column after the target column.
         *
         * Only columns from leftPanel, centerPanel and groupPanel could add a column at its right because
         * these panels contain a linked-list instance of type InOrderDkColumnMesh.
         *
         * InOrderDkColumnMesh instances hold slots that have its default gutter at its right. Only
         * the first slot has the complement gutter which is the left gutter.
         *
         * It does not matter if the given column is a data or group column because to achieve the
         * movement everthing comes down to belongToGroup property. Both columns must belong to the
         * same group.
         *
         * Exception:
         *
         *    If the given target column belongs to the right panel and is the last column, the movement
         *    is allowed because the column will be inserted a the right of the target column. The given
         *    column will ocuppy the place of the the target column's complement gutter.
         */
        if (!!columnSlot && !!targetColumnSlot && columnSlot !== targetColumnSlot) {
            // Does the given target column belong to the rightPanel as is it the last column?
            if (targetColumnSlot.dikeColumn.panel === 'rightPanel' && !!this.gridPanelDispatcher.gridPanels.rightPanel.lastColumnSlot &&
                this.gridPanelDispatcher.gridPanels.rightPanel.lastColumnSlot.dikeColumn.columnId === targetColumnSlot.dikeColumn.columnId) {
                // This is the exception, move the given column to the complement gutter position:
                targetGutter = targetColumnSlot.complementDikeGutterSlot;
            }
            else if (targetColumnSlot.dikeColumn.panel === 'leftPanel' ||
                targetColumnSlot.dikeColumn.panel === 'centerPanel' ||
                targetColumnSlot.dikeColumn.panel === 'groupPanel') {
                targetGutter = targetColumnSlot.dikeGutterSlot;
            }
            if (!!targetGutter && columnSlot.dikeColumn.panel === targetColumnSlot.dikeColumn.panel &&
                this.gridPanelDispatcher.doSlotsBelongToSameGroup(sourcePanel, columnSlot, destinationPanel, targetGutter)) {
                this.gridPanelDispatcher.moveColumnSlotToGutterSlotInSamePanel(this.gridPanelDispatcher.gridPanels[columnSlot.dikeColumn.panel], columnSlot, targetGutter);
            }
            else if (!!targetGutter && this.gridPanelDispatcher.doSlotsBelongToSameGroup(sourcePanel, columnSlot, destinationPanel, targetGutter)) {
                this.gridPanelDispatcher.moveColumnSlotToGutterSlotInDifferentPanel(this.gridPanelDispatcher.gridPanels[columnSlot.dikeColumn.panel], columnSlot, this.gridPanelDispatcher.gridPanels[targetColumnSlot.dikeColumn.panel], targetGutter);
            }
        }
    }
    moveColumnBefore(column, targetColumn) {
        let sourcePanel = this.gridPanelDispatcher.gridPanels[column.panel];
        let columnSlot = sourcePanel.getColumnSlot(column.columnId);
        let destinationPanel = this.gridPanelDispatcher.gridPanels[targetColumn.panel];
        let targetColumnSlot = destinationPanel.getColumnSlot(targetColumn.columnId);
        let targetGutter = null;
        /**
         * Inserting a column before the target column.
         *
         * Only columns from rightPanel could add a column at its left because
         * this panel contain a linked-list instance of type PreOrderDkColumnMesh.
         *
         * PreOrderDkColumnMesh instances hold slots that have its default gutter at its left. Only
         * the last slot has the complement gutter which is the right gutter.
         *
         * It does not matter if the given column is a data or group column because to achieve the
         * movement everthing comes down to belongToGroup property. Both columns must belong to the
         * same group.
         *
         * Exception:
         *
         *    If the given target column belongs to the left, center or group panel and is the first column, the movement
         *    is allowed because the column will be inserted a the left of the target column. The given
         *    column will ocuppy the place of the the target column's complement gutter.
         */
        if (!!columnSlot && !!targetColumnSlot && columnSlot !== targetColumnSlot) {
            // Does the given target column belong to the rightPanel as is it the last column?
            if ((targetColumnSlot.dikeColumn.panel === 'leftPanel' || targetColumnSlot.dikeColumn.panel === 'centerPanel' ||
                targetColumnSlot.dikeColumn.panel === 'groupPanel') && !!this.gridPanelDispatcher.gridPanels[targetColumnSlot.dikeColumn.panel].firstColumnSlot &&
                this.gridPanelDispatcher.gridPanels[targetColumnSlot.dikeColumn.panel].firstColumnSlot.dikeColumn.columnId === targetColumnSlot.dikeColumn.columnId) {
                // This is the exception, move the given column to the complement gutter position:
                targetGutter = targetColumnSlot.complementDikeGutterSlot;
            }
            else if (targetColumnSlot.dikeColumn.panel === 'rightPanel') {
                targetGutter = targetColumnSlot.dikeGutterSlot;
            }
            if (!!targetGutter && columnSlot.dikeColumn.panel === targetColumnSlot.dikeColumn.panel &&
                this.gridPanelDispatcher.doSlotsBelongToSameGroup(sourcePanel, columnSlot, destinationPanel, targetGutter)) {
                this.gridPanelDispatcher.moveColumnSlotToGutterSlotInSamePanel(this.gridPanelDispatcher.gridPanels[columnSlot.dikeColumn.panel], columnSlot, targetGutter);
            }
            else if (!!targetGutter && this.gridPanelDispatcher.doSlotsBelongToSameGroup(sourcePanel, columnSlot, destinationPanel, targetGutter)) {
                this.gridPanelDispatcher.moveColumnSlotToGutterSlotInDifferentPanel(this.gridPanelDispatcher.gridPanels[columnSlot.dikeColumn.panel], columnSlot, this.gridPanelDispatcher.gridPanels[targetColumnSlot.dikeColumn.panel], targetGutter);
            }
        }
    }
    getColumns() {
        return this.columnDefSubject.value;
    }
    getLinkedColumns(columns) {
        return this.createLinkedDikeColumnDefStructure(columns, null);
    }
    setColumnVisible(column, isVisible) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column')) {
            this.contentPanelDispatcher.setColumnSlotVisible(columnSlot, isVisible);
        }
    }
    setColumnEditable(column, isEditable, settings) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setColumnSlotEditable(columnSlot, isEditable, settings);
        }
    }
    setDefaultEditionTemplateColumn(column) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setDefaultEditionTemplateColumnSlot(columnSlot);
        }
    }
    setDisplayTemplateColumn(column, displayTemplate) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setDisplayTemplateColumnSlot(columnSlot, displayTemplate);
        }
    }
    setDefaultDisplayTemplateColumn(column) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setDefaultDisplayTemplateColumnSlot(columnSlot);
        }
    }
    lockColumn(column) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        // The data column or column group must be draggable, to be able to toggle between lock and unlock:
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') && columnSlot.dikeColumn.draggable) {
            this.contentPanelDispatcher.setColumnSlotLocking(columnSlot, true);
        }
    }
    unlockColumn(column) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        // The data column or column group must be draggable, to be able to toggle between lock and unlock:
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column') && columnSlot.dikeColumn.draggable) {
            this.contentPanelDispatcher.setColumnSlotLocking(columnSlot, false);
        }
    }
    setColumnResizable(column, isResizable) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && (columnSlot.dikeColumn.columnType === 'Data-Column' ||
            columnSlot.dikeColumn.columnType === 'Group-Column')) {
            this.contentPanelDispatcher.setColumnSlotResizable(columnSlot, isResizable);
        }
    }
    changeColumnWidth(column, columnSize) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.changeColumnSlotWidth(columnSlot, columnSize);
        }
    }
    setColumnGroupable(column, isGroupable) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setColumnSlotGroupable(columnSlot, isGroupable);
        }
    }
    setColumnFilterability(column, isFilterable, filter, customFilterConditions) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setColumnSlotFilterability(columnSlot, isFilterable, filter, customFilterConditions);
        }
    }
    changeColumnFilter(column, filter) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column' &&
            columnSlot.dikeColumn.filterable && filter && filter.length > 0) {
            this.contentPanelDispatcher.changeColumnSlotFilter(columnSlot, filter);
        }
    }
    displayRowIndexColumn(visible, width = 0) {
        this.contentPanelDispatcher.setRowIndexColumnSlot(visible, width);
    }
    changeColumnGroupStatus(columnGroup, status) {
        // Get the target column slot:
        let columnGroupSlot = this.contentPanelDispatcher.contentPanels[columnGroup.panel].getColumnSlot(columnGroup.columnId);
        if (!!columnGroupSlot && columnGroupSlot.dikeColumn.columnType === 'Group-Column' && columnGroupSlot.displayStatus !== status) {
            this.contentPanelDispatcher.changeColumnSlotGroupStatus(columnGroupSlot, status);
        }
    }
    setColumnSortable(column, isSortable) {
        // Get the target column slot:
        let columnSlot = this.contentPanelDispatcher.contentPanels[column.panel].getColumnSlot(column.columnId);
        if (!!columnSlot && columnSlot.dikeColumn.columnType === 'Data-Column') {
            this.contentPanelDispatcher.setColumnSlotSortable(columnSlot, isSortable);
        }
    }
    // This method clone new columns:
    cloneColumns(columns) {
        let clonedColumns = [];
        columns.forEach(column => {
            if (isDkGroupColumnDef(column)) {
                clonedColumns.push(this.gridFactoryColumns.cloneDikeGroupColumnDef(column));
            }
            else if (isDkDataColumnDef(column)) {
                clonedColumns.push(this.gridFactoryColumns.cloneDikeDataColumnDef(column));
            }
        });
        return clonedColumns;
    }
    // This method orders new columns:
    orderColumns(columns, levelCardinality) {
        // First, get the maximum order value, for the given level:
        let maxOrder = columns.reduce((previous, current) => Math.max(previous, current.order), -Infinity);
        for (let i = 0; i < columns.length; i++) {
            const currentColumn = columns[i];
            if (isDkGroupColumnDef(currentColumn) && !!currentColumn.children && currentColumn.children.length > 0) {
                // Since the child double-linked list does not exist, its cardinality is zero:
                this.orderColumns(currentColumn.children, 0);
            }
            // Set the order of the current column according to its position in the array:
            currentColumn.order = currentColumn.order >= 0 ? currentColumn.order : ++maxOrder + levelCardinality;
        }
    }
    createLinkedDikeColumnDefStructure(columns, parent) {
        let linkedColumns = [];
        for (let i = 0; i < columns.length; i++) {
            let columnDef = columns[i];
            let parentColumn = {
                column: columnDef,
                parent: parent
            };
            if (isDkGroupColumnDef(columnDef)) {
                parentColumn.children = this.createLinkedDikeColumnDefStructure(columnDef.children, parentColumn);
            }
            linkedColumns.push(parentColumn);
        }
        return linkedColumns;
    }
    searchColumnInArray(columnSet, compare) {
        for (let i = 0; i < columnSet.length; i++) {
            let column = columnSet[i];
            if (compare(column)) {
                return column;
            }
            if (isDkGroupColumnDef(column)) {
                let foundColumn = this.searchColumnInArray(column.children, compare);
                if (!!foundColumn) {
                    return foundColumn;
                }
            }
        }
        return null;
    }
    searchNodeInTree(nodes, compare) {
        for (let i = 0; i < nodes.length; i++) {
            let node = nodes[i];
            if (compare(node)) {
                return node;
            }
            if (node.children && node.children.length > 0) {
                let foundNode = this.searchNodeInTree(node.children, compare);
                if (!!foundNode) {
                    return foundNode;
                }
            }
        }
        return null;
    }
    setChangeColumnDefSubscription() {
        const columnsDef$ = this.gridPanelDispatcher.columnsChangedEmitter.asObservable();
        this.changeColumnDefSubscription.unsubscribe();
        this.changeColumnDefSubscription = columnsDef$.subscribe(columns => this.columnDefSubject.next(columns));
    }
}
DkGridColumnDef.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColumnDef, deps: [{ token: DkGridFactoryColumns }, { token: DkGridPanelDispatcher }, { token: DkContentPanelDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridColumnDef.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColumnDef });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridColumnDef, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridFactoryColumns }, { type: DkGridPanelDispatcher }, { type: DkContentPanelDispatcher }]; } });

class DkGridRowEditionDispatcher {
    constructor(gridConfig, contentPanelDispatcher, gridCommandFactory, gridSelection, gridDataStore, gridEditionConfig, gridColumnDef, gridMessaging) {
        this.gridConfig = gridConfig;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.gridCommandFactory = gridCommandFactory;
        this.gridSelection = gridSelection;
        this.gridDataStore = gridDataStore;
        this.gridEditionConfig = gridEditionConfig;
        this.gridColumnDef = gridColumnDef;
        this.gridMessaging = gridMessaging;
        this.history = new Map();
        this.cardinalityHistory = new Map();
        this.rowsInEdition = new FormGroup({});
        this.rowsInEditionSubject = new Subject();
        this.editionRowEmitter = new EventEmitter();
        this.updateRowEmitter = new EventEmitter();
        this.cancelRowEditionEmitter = new EventEmitter();
        this.deleteRowEmitter = new EventEmitter();
        this.undoRowUpdateEmitter = new EventEmitter();
    }
    ngOnDestroy() {
        // Invoking resetEdition() method will empty the Map that lives in the DkGridDataStore service:
        this.releaseEdition();
        this.rowsInEditionSubject.complete();
    }
    get onRowsInEditionChanged$() {
        return this.rowsInEditionSubject.asObservable();
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    cardinalityRowHistory(rowId) {
        return this.getCardinalityRowHistorySubject(rowId).asObservable();
    }
    createRowFormGroup(row, panel, dataSlots) {
        if (!this.gridEditionConfig.allowEdition) {
            return;
        }
        if (panel !== 'leftPanel' && panel !== 'centerPanel' && panel !== 'rightPanel') {
            return;
        }
        // Get the FormGroup for the given panel:
        let currentFormGroup = row.getRowPanelFormGroup(panel);
        /**
         * Always ask for new memory, this ensure that the pipe RowFormControlInstancePipe
         * reads the last value due to a change in the ColumnSlots array:
         */
        let rowGroup = new FormGroup({});
        dataSlots.forEach(dataSlot => {
            if (dataSlot.dikeColumn.editable) {
                let control;
                let controlValue;
                let formField;
                // The FormGroup was created previously with the current slot:
                if (currentFormGroup && currentFormGroup.get(dataSlot.slotId)) {
                    // Get the FormControl given by the current slot:
                    control = currentFormGroup.get(dataSlot.slotId);
                    // Take the reference from the source of truth:
                    formField = row.rowFormFields.get(dataSlot.slotId);
                    // Update the source of truth with the current values:
                    formField.value = control.value;
                    formField.touched = control.touched;
                    formField.dirty = control.dirty;
                    formField.validators = this.getValidators(dataSlot);
                    formField.asyncValidators = this.getAsyncValidators(dataSlot);
                    // Once the values have been taken, remove the control from the current FormGroup:
                    currentFormGroup.removeControl(dataSlot.slotId);
                    // The FormControl has not been added to the source of truth:
                }
                else if (!row.rowFormFields.has(dataSlot.slotId)) {
                    // Get the value from the entry object:
                    controlValue = dataSlot.dikeColumn.getValue(row.entry);
                    // Add the control value and its validators to the source of truth:
                    row.rowFormFields.set(dataSlot.slotId, {
                        slotId: dataSlot.slotId,
                        fieldName: dataSlot.dikeColumn.fieldName,
                        headerText: dataSlot.dikeColumn.headerText,
                        value: controlValue,
                        touched: false,
                        dirty: false,
                        validators: this.getValidators(dataSlot),
                        asyncValidators: this.getAsyncValidators(dataSlot),
                        updateOn: this.getUpdateOnValue(dataSlot)
                    });
                }
                // Take the values from the source of truth for the current slot (the entry must exist in the private Map variable):
                formField = row.rowFormFields.get(dataSlot.slotId);
                // Create a new instance of FormControl:
                control = new FormControl(formField.value, {
                    validators: formField.validators,
                    asyncValidators: formField.asyncValidators,
                    updateOn: formField.updateOn
                });
                // Add the new control to the new FormGroup:
                rowGroup.addControl(dataSlot.slotId, control);
                if (formField.touched) {
                    this.markAncestorsAsTouched(control);
                }
                if (formField.dirty) {
                    this.markAncestorsAsDirty(control);
                }
                // Since validators are set dynamically, update the value of validity of the new FormControl:
                control.updateValueAndValidity();
                // The column is not editable but exists in the FormGroup, remove from the group:
            }
            else if (currentFormGroup && currentFormGroup.get(dataSlot.slotId)) {
                currentFormGroup.removeControl(dataSlot.slotId);
            }
        });
        /**
         * Update the remaining fields values in the source of truth.
         *
         * A field could be left in the currentFormGroup due to:
         *
         *  1. Columns that must be hidden because they belong to a group.
         *  2. Columns could have been moved to other panel.
         *  3. Swapping columns between panels.
         */
        if (currentFormGroup) {
            for (let slotId in currentFormGroup.controls) {
                // Get the remaining control from the current FormGroup:
                let remainingControl = currentFormGroup.get(slotId);
                // Update the values of the remaining control in the source of truth:
                let remainingField = row.rowFormFields.get(slotId);
                remainingField.value = remainingControl.value;
                remainingField.touched = remainingControl.touched;
                remainingField.dirty = remainingControl.dirty;
                let control = null;
                /**
                 * Does the column slot live in the current panel?
                 *
                 * The remaining field still lives in the given panel because
                 * it could have been hidden because the field belongs to a group or
                 * the user hides it, explicitly.
                 *
                 * If the remaining field still belongs to the given panel, add to the
                 * current panel FormGroup.
                 */
                let remainingDataSlot = this.contentPanelDispatcher.doesDataColumnSlotExist(panel, slotId);
                if (remainingDataSlot) {
                    // Update validators in the source of truth:
                    remainingField.validators = this.getValidators(remainingDataSlot);
                    remainingField.asyncValidators = this.getAsyncValidators(remainingDataSlot);
                    remainingField.updateOn = this.getUpdateOnValue(remainingDataSlot);
                    // Create a new instance of the remaining FormControl:
                    control = new FormControl(remainingField.value, {
                        validators: remainingField.validators,
                        asyncValidators: remainingField.asyncValidators,
                        updateOn: remainingField.updateOn
                    });
                    // Add to the current panel FormGroup:
                    rowGroup.addControl(slotId, control);
                    if (remainingField.touched) {
                        this.markAncestorsAsTouched(control);
                    }
                    if (remainingField.dirty) {
                        this.markAncestorsAsDirty(control);
                    }
                    // Since validators are set dynamically, update the value of validity of the new FormControl:
                    control.updateValueAndValidity();
                }
                else {
                    /**
                     * After searching the remaining field in the current panel and it does not live in the
                     * current panel anymore, an iteration must be done over the other panels, different from
                     * the current FormGroup, looking for the remaining field.
                     */
                    let complementPanels = this.getComplementPanels(panel);
                    // Look for the current slotId in the complement panels:
                    for (let i = 0; i < complementPanels.length && !control; i++) {
                        // Get the panel group from the current row FormGroup reference:
                        let panelGroup = row.getRowPanelFormGroup(complementPanels[i]);
                        if (panelGroup) {
                            control = panelGroup.get(slotId);
                        }
                    }
                    // The formControl lives in other panel, set its actual values:
                    if (control) {
                        control.setValue(remainingField.value);
                        if (remainingField.touched) {
                            this.markAncestorsAsTouched(control);
                        }
                        if (remainingField.dirty) {
                            this.markAncestorsAsDirty(control);
                        }
                        control.updateValueAndValidity();
                    }
                }
            }
            // Remove the old group:
            row.rowFormGroup.removeControl(panel);
        }
        /**
         * Once the proccess has finished for the given panel:
         *
         *  1. Get the new reference for the whole row, adding the complement FormGroups and marking
         *     ancestors for each panel as dirty if the panel is dirty. Same for touched property.
         *
         *  2. Add the new reference for the given panel to the new reference for the whole row. Same
         *     as before, mark ancestors as dirty and touched if applies.
         *
         *  3. If the given row is being edited, add the new reference to the set of the rows which
         *     are being edited (rowsInEdition). Same as before, mark ancestors as dirty and
         *     touched if applies.
         *
         *  4. Finally, update the FormGroup reference (rowFormGroup) from DkGridDataRowEntry class.
         */
        /**
         * 1. Get a new reference for the whole row.
         *
         *    Creating a new row group reference will allow update value, validity and states
         *    of the root FormGroup. Its is very important to reflect the correct status of the
         *    whole row groups because at the moment of saving field values, only rows which
         *    pristine status are false will be taken.
         *
         *    The new row group reference will have:
         *
         *      1. Group panels, different from the given panel, will be preserved (complement panels).
         *      2. The new panel group given by panel will be created given by the slot changes (dataSlots argument).
         */
        let rowPanelGroups = this.changeRowFormGroupReference(row, panel);
        // 2. Add the new rowGroup to the new reference of the new whole-row groups:
        rowPanelGroups.addControl(panel, rowGroup);
        if (rowGroup.dirty) {
            this.markAncestorsAsDirty(rowGroup);
        }
        if (rowGroup.touched) {
            this.markAncestorsAsTouched(rowGroup);
        }
        rowGroup.updateValueAndValidity();
        // 3. If the given row is being edited, add to rowsInEdition FormGroup:
        if (row.isEditing) {
            // Replace the given FormGroup in the rowsInEdition, otherwise add it:
            this.rowsInEdition.setControl(`${row.id}`, rowPanelGroups);
            this.changeRowsInEditionSet();
            if (rowPanelGroups.dirty) {
                this.markAncestorsAsDirty(rowPanelGroups);
            }
            if (rowPanelGroups.touched) {
                this.markAncestorsAsTouched(rowPanelGroups);
            }
            rowPanelGroups.updateValueAndValidity();
        }
        // 4. Update the reference from DkGridDataRowEntry class to point to the new memory-address location:
        row.rowFormGroup = rowPanelGroups;
    }
    markRowAsPristine(row) {
        // Get all data slots, visible and non-visible columns:
        let slots = this.contentPanelDispatcher.getAllDataColumnSlots();
        // Filter those slots which are editable:
        slots.filter(slot => slot.dikeColumn.editable).forEach(slot => {
            let panelGroup = row.getRowPanelFormGroup(slot.dikeColumn.panel);
            // Get the group where the current slot lives:
            if (panelGroup) {
                let control = panelGroup.get(slot.slotId);
                if (control) {
                    // Get the original value:
                    let fieldValue = slot.dikeColumn.getValue(row.entry);
                    /**
                     * Set the original value in the FormControl.
                     * Remember that reset() method marks the control as pristine and untoched.
                     * Important: if reset() method is invoke with no parameters, its sets the value to null.
                     */
                    control.reset(fieldValue);
                    control.updateValueAndValidity();
                    // Update the values in the source of truth:
                    let formField = row.rowFormFields.get(slot.slotId);
                    if (formField) {
                        formField.value = fieldValue;
                        formField.touched = false;
                        formField.dirty = false;
                    }
                }
            }
        });
        // Once all the field are reset, then mark each group as pristine and untouched:
        ['leftPanel',
            'centerPanel',
            'rightPanel'].forEach(panel => {
            let panelGroup = row.getRowPanelFormGroup(panel);
            if (panelGroup) {
                panelGroup.markAsPristine();
                panelGroup.markAsUntouched();
                panelGroup.updateValueAndValidity();
            }
        });
        // Then, mark the entire row as pristine and intouched:
        row.rowFormGroup.markAsPristine();
        row.rowFormGroup.markAsUntouched();
        row.rowFormGroup.updateValueAndValidity();
    }
    markGridEditionAsPristine() {
        this.rowsInEdition.markAsPristine();
        this.rowsInEdition.markAsUntouched();
        this.rowsInEdition.updateValueAndValidity();
    }
    areGridRowsInEditionPristine() {
        let isPristine = true;
        for (let rowId in this.rowsInEdition.controls) {
            let rowFormGroup = this.rowsInEdition.get(rowId);
            if (!rowFormGroup.pristine) {
                isPristine = false;
                break;
            }
        }
        return isPristine;
    }
    editRow(row) {
        if (this.gridEditionConfig.allowEdition) {
            if (this.canEditMoreRows()) {
                if (!!row && !row.isEditing) {
                    // row.isEditing = true;
                    this.gridDataStore.setEditionRowState(row);
                    // Add the given row to the set of rows which are being edited:
                    this.rowsInEdition.addControl(`${row.id}`, row.rowFormGroup);
                    this.changeRowsInEditionSet();
                    // Send the row that start being edited:
                    this.changeEditionRow(row);
                }
            }
            else {
                this.gridMessaging.sendTextMessage('The maximum number of rows in the edition state have been reached');
            }
        }
    }
    updateRow(row) {
        if (this.gridEditionConfig.allowEdition && !!row && row.status !== 'Deleted' && row.isEditing &&
            !row.rowFormGroup.pristine && row.rowFormGroup.valid) {
            let fieldChanges = this.getFieldUpdateArray(row);
            if (fieldChanges.rowFieldUpdate.length > 0) {
                // If the row is selected, deselect it:
                if (row.selected) {
                    this.gridSelection.deselectOne(row);
                }
                let updateAction = this.getUpdateAction(row, fieldChanges, Date.now());
                if (!!updateAction) {
                    updateAction.execute();
                    // Once the row has been modified, cancel its edition:
                    this.cancelRowEdition(row, false);
                    // After executing the update command, reflect the changes to the datasource:
                    this.gridDataStore.sendChanges();
                    // Send the row that has been updated:
                    this.changeSaveRow(this.gridDataStore.getRow(row.id));
                }
            }
        }
    }
    cancelRowEdition(row, sendEvent = true) {
        if (this.gridEditionConfig.allowEdition && !!row && row.isEditing) {
            // Mark form controls as untouched and pristine. Also set the field values from the row.entry to the source of truth:
            this.markRowAsPristine(row);
            // row.isEditing = false;
            this.gridDataStore.cancelEditionRowState(row);
            // Remove the given row from the set of rows which are being edited:
            this.rowsInEdition.removeControl(`${row.id}`);
            this.changeRowsInEditionSet();
            // Send the row which was being edited:
            if (sendEvent) {
                this.changeCancelRowEdition(row);
            }
        }
    }
    undoRowUpdate(row) {
        // Verify if the given row has been stored in the history:
        if (this.gridEditionConfig.allowEdition && this.doesRowHaveMementos(row)) {
            // Get the last memento pushed into the Memento's stack:
            let lastMemento = this.getLastMemento(row);
            if (!!lastMemento) {
                // If the row is selected, deselect it:
                if (row.selected) {
                    this.gridSelection.deselectOne(row);
                }
                // Restore the row to its previous state:
                lastMemento.restore();
                // Mark form controls as untouched and pristine. Also set the field values from the row.entry to the source of truth:
                this.markRowAsPristine(row);
                // Broadcast the cardinality of the given row:
                this.changeCardinalityRowHistory(row.id);
                // After restoring the row, reflect the changes to the datasource:
                this.gridDataStore.sendChanges();
                // Send the row that is restored:
                this.changeUndoRowUpdate(this.gridDataStore.getRow(row.id));
            }
        }
    }
    deleteRow(row) {
        if (this.gridEditionConfig.allowEdition && !!row && row.status !== 'Deleted') {
            // If the row is selected, deselect it:
            if (row.selected) {
                this.gridSelection.deselectOne(row);
            }
            // Get the delete command:
            let deleteAction = this.getDeleteAction(row, Date.now());
            if (!!deleteAction) {
                deleteAction.execute();
                // After executing the delete command, reflect the changes to the datasource:
                this.gridDataStore.sendChanges();
                // Send the row which has been deleted:
                this.changeDeleteRowEdition(this.gridDataStore.getRow(row.id));
            }
        }
    }
    saveEdition() {
        /**
         * Only save those rows which are not pristine and are valid.
         * This method send changes only when the last row is updated.
         */
        let validRows = this.gridEditionConfig.allowEdition ? this.gridDataStore.getRowsInEditionState().filter(row => row.status !== 'Deleted' &&
            !row.rowFormGroup.pristine &&
            row.rowFormGroup.valid) : [];
        // Are there valid rows to be updated?:
        if (validRows.length > 0) {
            // Create the observable which will be sent in the next frame of the event-loop:
            let validRowsForSaving$ = of(validRows).pipe(tap(() => {
                if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsUpdate) {
                    this.gridConfig.displayProcessingIndicator();
                }
            }), observeOn(asyncScheduler));
            validRowsForSaving$.subscribe(rows => {
                // From valid rows, deselect those which had been selected:
                this.gridSelection.deselect(rows);
                // Get the current timestamp which will be set for all the edited rows:
                let timestamp = Date.now();
                // Execute the updates:
                rows.forEach(row => {
                    // Get the changes from the current row:
                    let fieldChanges = this.getFieldUpdateArray(row);
                    // Are there actual changes?
                    if (!!fieldChanges.rowFieldUpdate && fieldChanges.rowFieldUpdate.length > 0) {
                        let updateAction = this.getUpdateAction(row, fieldChanges, timestamp);
                        if (!!updateAction) {
                            updateAction.execute();
                        }
                    }
                    // As a final step, cancel the row edtion. This method calls markRowAsPristine(...) method:
                    this.cancelRowEdition(row, false);
                });
                // After updating all the valid rows, reflect the changes to the datasource:
                this.gridDataStore.sendChanges();
                // Finally, send the rows which have been updated:
                this.changeSaveRow(this.gridDataStore.filterRows(row => row.status === 'Modified' && row.timestamp === timestamp));
                /**
                 * If there are not more rows which are being edited,
                 * then return the user to the data view:
                 */
                if (this.gridEditionConfig.editionFilterState && !this.areThereRowsInEdition()) {
                    this.gridEditionConfig.cancelEditionFilter();
                }
                if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsUpdate) {
                    // Hide the processing indicator scheduling to the next frame of the event-loop:
                    setTimeout(() => this.gridConfig.hideWaitingIndicator(), 0);
                }
            });
        }
    }
    deleteRows(givenRows) {
        /**
         * Delete all the given rows which are not being edited and
         * they has not been deleted before:
         */
        const validRows = this.gridEditionConfig.allowEdition ?
            givenRows.filter(row => !row.isEditing && row.status !== 'Deleted') : [];
        if (validRows.length > 0) {
            const timestamp = Date.now();
            // Splitting the delete operation is allowed:
            if (this.gridEditionConfig.gridEditionSettings.splitDeleteOperation) {
                this.deleteSubsetOfValidRows(validRows, timestamp, 0, this.gridEditionConfig.gridEditionSettings.deleteOperationRowSubsetSize);
            }
            else {
                // Create the observable which will be sent in the next frame of the event-loop:
                const rowsForDeletion$ = of(validRows).pipe(tap(() => {
                    if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsDeletion) {
                        this.gridConfig.displayProcessingIndicator();
                    }
                }), observeOn(asyncScheduler));
                rowsForDeletion$.subscribe(rows => {
                    // Clear selected rows which will be deleted:
                    this.gridSelection.deselect(rows);
                    // Get the delete command for every valid row:
                    rows.forEach(row => {
                        let deleteAction = this.getDeleteAction(row, timestamp);
                        if (!!deleteAction) {
                            deleteAction.execute();
                        }
                    });
                    // After deleting the whole valid rows, reflect the changes to the datasource:
                    this.gridDataStore.sendChanges();
                    // Finally, send all deleted rows:
                    this.changeDeleteRowEdition(this.gridDataStore.filterRows(row => row.status === 'Deleted' && row.timestamp === timestamp));
                    if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsDeletion) {
                        // Hide wait indicator scheduling to the next frame of the event-loop:
                        setTimeout(() => this.gridConfig.hideWaitingIndicator(), 0);
                    }
                });
            }
        }
    }
    cancelEdition() {
        let rowsInEdition = this.gridEditionConfig.allowEdition ? this.gridDataStore.getRowsInEditionState() : [];
        if (rowsInEdition.length > 0) {
            // Create the observable which will be sent in the next frame of the event-loop:
            let rowsBeingEdited$ = of(rowsInEdition).pipe(tap(() => {
                if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsCancelation) {
                    this.gridConfig.displayProcessingIndicator();
                }
            }), observeOn(asyncScheduler));
            rowsBeingEdited$.subscribe(rows => {
                // Cancel edition for filtered rows. This method calls markRowAsPristine(...):
                rows.forEach(row => this.cancelRowEdition(row, false));
                // Send the corresponding event:
                this.changeCancelRowEdition(rows);
                // If the user is navigating the edition filters (rows editing), return to data view:
                if (this.gridEditionConfig.editionFilterState) {
                    this.gridEditionConfig.cancelEditionFilter();
                }
                if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsCancelation) {
                    // Hide the processing indicator scheduling to the next frame of the event-loop:
                    setTimeout(() => this.gridConfig.hideWaitingIndicator(), 0);
                }
            });
        }
    }
    undoRows(givenRows) {
        /**
         * Filter the given rows, getting:
         *  1.  Rows which are not being edited and,
         *  2.  are deleted or modified and,
         *  3.  at least, have one Memento.
         */
        const validRows = this.gridEditionConfig.allowEdition ? givenRows.filter(row => {
            return !row.isEditing &&
                (row.status === 'Deleted' || row.status === 'Modified') &&
                this.doesRowHaveMementos(row);
        }) : [];
        if (validRows.length > 0) {
            if (this.gridEditionConfig.gridEditionSettings.splitUndoOperation) {
                this.restoreSubsetOfValidRows(validRows, [], 0, this.gridEditionConfig.gridEditionSettings.undoOperationRowSubsetSize);
            }
            else {
                // Create the observable which will be sent in the next frame of the event-loop:
                const rowsForUndo$ = of(validRows).pipe(tap(() => {
                    if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsRestoration) {
                        this.gridConfig.displayProcessingIndicator();
                    }
                }), observeOn(asyncScheduler));
                rowsForUndo$.subscribe(rows => {
                    // Clear selected rows which will be restored:
                    this.gridSelection.deselect(rows);
                    let restoredRows = [];
                    // Get the last memento for every valid selected row:
                    rows.forEach(row => {
                        let lastMemento = this.getLastMemento(row);
                        if (!!lastMemento) {
                            // Restore the row to its previous state:
                            lastMemento.restore();
                            // Mark form controls as untouched and pristine. Also set the field values from the row.entry to the source of truth:
                            this.markRowAsPristine(row);
                            // Broadcast the cardinality of the given row:
                            this.changeCardinalityRowHistory(row.id);
                            // Get the just restored row:
                            restoredRows.push(this.gridDataStore.getRow(row.id));
                        }
                    });
                    // Once all the valid rows have been restored to its previous states, reflect the changes in the datasource:
                    this.gridDataStore.sendChanges();
                    // Send the rows that have been restored:
                    this.changeUndoRowUpdate(restoredRows);
                    if (this.gridEditionConfig.editionFilterState) {
                        if ((this.gridEditionConfig.editionFilter === 'Modified' && !this.areThereRowsModified()) ||
                            this.gridEditionConfig.editionFilter === 'Deleted' && !this.areThereRowsRemoved()) {
                            this.gridEditionConfig.cancelEditionFilter();
                        }
                    }
                    if (this.gridEditionConfig.gridEditionSettings.waitForMultipleRowsRestoration) {
                        // Schedule to the next frame of the event-loop:
                        setTimeout(() => this.gridConfig.hideWaitingIndicator(), 0);
                    }
                });
            }
        }
    }
    canEditMoreRows() {
        return this.gridEditionConfig.gridEditionSettings.maxRowsInEdition === -1 ||
            this.getRowsInEdition().length < this.gridEditionConfig.gridEditionSettings.maxRowsInEdition;
    }
    getRowsInEdition() {
        return this.gridDataStore.getRowsInEditionState();
    }
    getUpdatedRows() {
        return this.gridDataStore.getUpdatedRows();
    }
    getDeletedRows() {
        return this.gridDataStore.getDeletedRows();
    }
    areThereRowsInEdition() {
        return Object.keys(this.rowsInEdition.controls).length > 0;
    }
    areThereRowsModified() {
        return this.gridDataStore.getUpdatedRows().length > 0;
    }
    areThereRowsRemoved() {
        return this.gridDataStore.getDeletedRows().length > 0;
    }
    clearHistory() {
        // Clear history of Mementos:
        this.history.clear();
        // Clear the Behaviour subjects:
        this.cardinalityHistory.forEach(value => value.complete());
        this.cardinalityHistory.clear();
    }
    releaseEdition() {
        /**
         * The purpose of this method is release all the retained objects and let the
         * DkGridRowEditionDispatcher service as it was at creation phase.
         */
        /**
         * 1. The DkGridRowEditionDispatcher service is responsible for the DkGridDataStore service.
         *    Therefore, cancel the rows in edition and create a new Map from the DkGridDataStore service:
         */
        this.gridDataStore.releaseRowsInEdition();
        /**
         * 2. Cancel the edition filters. If the user is navigating the edited rows,
         *    this action will return the user to the standard view.
         */
        this.gridEditionConfig.cancelEditionFilter();
        // 3. Clear the FormGroup that stores the rows in edition:
        const rowIds = Object.keys(this.rowsInEdition.controls);
        rowIds.forEach(rowId => this.rowsInEdition.removeControl(`${rowId}`));
        // 4. Clear the history Map and the Map of Behavior subjects:
        this.clearHistory();
    }
    getUpdateAction(row, fieldChanges, timestamp) {
        if (row && row.status !== 'Deleted' && row.isEditing && !row.rowFormGroup.pristine && row.rowFormGroup.valid) {
            if (fieldChanges.rowFieldUpdate && fieldChanges.rowFieldUpdate.length > 0) {
                // Before creating the row-update command, save its current state:
                this.saveCurrentRowState(row, fieldChanges.currentRowState);
                // Then create the command instance:
                return this.gridCommandFactory.createUpdateRowCommand(row.id, fieldChanges.rowFieldUpdate, timestamp);
            }
        }
        return null;
    }
    getDeleteAction(row, timestamp) {
        if (row && row.status !== 'Deleted') {
            // Before creating the row-delete command, save its current status:
            this.saveCurrentRowState(row, []);
            // Then create the command which will change its status to DELETED:
            return this.gridCommandFactory.createDeleteRowCommand(row.id, timestamp);
        }
        return null;
    }
    getLastMemento(row) {
        // Verify if the given row has been stored in the history:
        if (this.doesRowHaveMementos(row)) {
            let undoMementos = this.history.get(row.id);
            // Does the given row has at least one previous state to restore from?
            if (undoMementos.length > 0) {
                return undoMementos.pop();
            }
        }
        return null;
    }
    doesRowHaveMementos(row) {
        return !!row && this.history.has(row.id) && this.history.get(row.id).length > 0;
    }
    saveCurrentRowState(row, undoFields) {
        // There are some history that has been saved for the given row:
        let undoHistory = this.history.has(row.id) ? this.history.get(row.id) : [];
        // Save the last undo command with the timestamp from the given row:
        undoHistory.push(this.gridCommandFactory.createRowMemento(row.id, row.status, undoFields, row.timestamp));
        // Save mementos into the history map:
        this.history.set(row.id, undoHistory);
        // Broadcast the cardinality of the given row:
        this.changeCardinalityRowHistory(row.id);
    }
    getFieldUpdateArray(row) {
        let rowFieldUpdate = [];
        let currentRowState = [];
        // Get all data slots, visible and non-visible columns:
        let slots = this.contentPanelDispatcher.getAllDataColumnSlots();
        // Filter those slots which are editable:
        slots.filter(slot => slot.dikeColumn.editable).forEach(slot => {
            let panelGroup = row.getRowPanelFormGroup(slot.dikeColumn.panel);
            // Get the FormGroup where the current slot value lives:
            if (panelGroup) {
                let control = panelGroup.get(slot.slotId);
                // Save the field if it has changes:
                if (control && !control.pristine) {
                    // Save the new values:
                    rowFieldUpdate.push({
                        updateValue: slot.dikeColumn.setValue,
                        value: control.value
                    });
                    // Save the current state of the given row for undo operation (Memento instance):
                    currentRowState.push({
                        updateValue: slot.dikeColumn.setValue,
                        value: slot.dikeColumn.getValue(row.entry)
                    });
                }
            }
        });
        return { rowFieldUpdate, currentRowState };
    }
    changeRowFormGroupReference(row, panel) {
        let complementPanels = this.getComplementPanels(panel);
        /**
         * Creating the new reference for the whole row:
         *
         *  Since the FormGroup reference is changed, the EditionValidationSettings must be
         *  set in the new FormGroup reference.
         */
        let rowGroups = new FormGroup({}, {
            validators: !!this.gridEditionConfig.gridEditionSettings.crossFieldValidation &&
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.customValidator ?
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.customValidator(this.gridColumnDef) : null,
            asyncValidators: !!this.gridEditionConfig.gridEditionSettings.crossFieldValidation &&
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.customAsyncValidator ?
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.customAsyncValidator(this.gridColumnDef) : null,
            updateOn: !!this.gridEditionConfig.gridEditionSettings.crossFieldValidation &&
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.updateOn ?
                this.gridEditionConfig.gridEditionSettings.crossFieldValidation.updateOn : null
        });
        complementPanels.forEach(cPanel => {
            // Get the FormGroup given by the current complement panel (cPanel):
            let panelGroup = row.getRowPanelFormGroup(cPanel);
            if (panelGroup) {
                // Firstly, add the FormGroup to the new reference:
                rowGroups.addControl(cPanel, panelGroup);
                // Remove the panel group from the old row group:
                row.rowFormGroup.removeControl(cPanel);
                // The current FormGroup is dirty, then mark its ancestors (rowGroups) as dirty, as well:
                if (panelGroup.dirty) {
                    this.markAncestorsAsDirty(panelGroup);
                }
                // The current FormGroup is touched, then mark its ancestors (rowGroups) as touched, as well:
                if (panelGroup.touched) {
                    this.markAncestorsAsTouched(panelGroup);
                }
                panelGroup.updateValueAndValidity();
            }
        });
        return rowGroups;
    }
    markAncestorsAsDirty(control) {
        if (control) {
            control.markAsDirty();
            if (control.parent) {
                this.markAncestorsAsDirty(control.parent);
            }
        }
    }
    markAncestorsAsTouched(control) {
        if (control) {
            control.markAsTouched();
            if (control.parent) {
                this.markAncestorsAsTouched(control.parent);
            }
        }
    }
    getComplementPanels(panel) {
        switch (panel) {
            case 'leftPanel':
                return ['centerPanel', 'rightPanel'];
            case 'centerPanel':
                return ['leftPanel', 'rightPanel'];
            case 'rightPanel':
                return ['leftPanel', 'centerPanel'];
        }
    }
    getValidators(dataSlot) {
        let fieldValidators = dataSlot.editionSettings &&
            dataSlot.editionSettings.validators !== null && dataSlot.editionSettings.validators !== undefined &&
            dataSlot.editionSettings.validators.length > 0 ?
            [...dataSlot.editionSettings.validators] : undefined;
        if (dataSlot.editionSettings &&
            dataSlot.editionSettings.required !== null && dataSlot.editionSettings.required !== undefined &&
            dataSlot.editionSettings.required) {
            if (!fieldValidators) {
                fieldValidators = [Validators.required];
            }
            else {
                fieldValidators.push(Validators.required);
            }
        }
        return fieldValidators;
    }
    getAsyncValidators(dataSlot) {
        return dataSlot.editionSettings &&
            dataSlot.editionSettings.asyncValidators !== null && dataSlot.editionSettings.asyncValidators !== undefined &&
            dataSlot.editionSettings.asyncValidators.length > 0 ?
            [...dataSlot.editionSettings.asyncValidators] : undefined;
    }
    getUpdateOnValue(dataSlot) {
        return dataSlot.editionSettings &&
            dataSlot.editionSettings.updateOn !== null && dataSlot.editionSettings.updateOn !== undefined ?
            dataSlot.editionSettings.updateOn : 'change';
    }
    deleteSubsetOfValidRows(validRows, timestamp, start, end) {
        // Get the subset from the start index trying obtaining the size of the subset.
        // Remember that slice method will take all the elements if the rest of them are less than the size of the subset.
        let validSubsetRows = validRows.slice(start, end);
        // Set the next start index and the next end index. They will be use for slice in the next iteration:
        let nextStart = start + validSubsetRows.length;
        let nextEnd = end + validSubsetRows.length;
        if (nextStart < validRows.length) {
            setTimeout(() => this.deleteSubsetOfValidRows(validRows, timestamp, nextStart, nextEnd));
        }
        else {
            setTimeout(() => {
                // Finally, send all deleted rows:
                this.changeDeleteRowEdition(this.gridDataStore.filterRows(row => row.status === 'Deleted' && row.timestamp === timestamp));
            });
        }
        if (validSubsetRows.length > 0) {
            // Clear selected rows which were deleted:
            this.gridSelection.deselect(validSubsetRows);
            // Get the delete command for every valid selected row:
            validSubsetRows.forEach(row => {
                let deleteAction = this.getDeleteAction(row, timestamp);
                if (!!deleteAction) {
                    deleteAction.execute();
                }
            });
            // After deleting this subset of rows, reflect the changes in the datasource:
            this.gridDataStore.sendChanges();
        }
    }
    restoreSubsetOfValidRows(validRows, restoredRows, start, end) {
        // Get the subset from the start index trying obtaining the size of the subset.
        // Remember that slice method will take all the elements if the rest of them are less than the size of the subset.
        let validSubsetRows = validRows.slice(start, end);
        // Set the next start index and the next end index. They will be use for slice in the next iteration:
        let nextStart = start + validSubsetRows.length;
        let nextEnd = end + validSubsetRows.length;
        if (nextStart < validRows.length) {
            setTimeout(() => this.restoreSubsetOfValidRows(validRows, restoredRows, nextStart, nextEnd));
        }
        else {
            setTimeout(() => {
                // Finally, send all deleted rows:
                this.changeUndoRowUpdate(restoredRows);
            });
        }
        if (validSubsetRows.length > 0) {
            // Clear selected rows which will be restored:
            this.gridSelection.deselect(validSubsetRows);
            // Get the last memento for every valid selected row:
            validSubsetRows.forEach(row => {
                let lastMemento = this.getLastMemento(row);
                if (!!lastMemento) {
                    // Restore the row to its previous state:
                    lastMemento.restore();
                    // Broadcast the cardinality of the given row:
                    this.changeCardinalityRowHistory(row.id);
                    // Get the just restored row (the new allocated memory):
                    restoredRows.push(this.gridDataStore.getRow(row.id));
                }
            });
            // After restoring this subset of rows, reflect the changes in the datasource:
            this.gridDataStore.sendChanges();
        }
    }
    getCardinalityRowHistorySubject(rowId) {
        if (!this.cardinalityHistory.has(rowId)) {
            this.cardinalityHistory.set(rowId, new BehaviorSubject(0));
        }
        return this.cardinalityHistory.get(rowId);
    }
    changeCardinalityRowHistory(rowId) {
        let cardinality = 0;
        if (this.history.has(rowId)) {
            cardinality = this.history.get(rowId).length;
        }
        this.getCardinalityRowHistorySubject(rowId).next(cardinality);
    }
    changeRowsInEditionSet() {
        /**
         * Every time an adition or deletion to the rowsInEdition FormGroup
         * occurs, notify to the client.
         */
        this.rowsInEditionSubject.next();
    }
    changeEditionRow(row) {
        this.editionRowEmitter.emit(row);
    }
    changeSaveRow(savedRows) {
        this.updateRowEmitter.emit(savedRows);
    }
    changeCancelRowEdition(cancelledRows) {
        this.cancelRowEditionEmitter.emit(cancelledRows);
    }
    changeDeleteRowEdition(deletedRows) {
        this.deleteRowEmitter.emit(deletedRows);
    }
    changeUndoRowUpdate(restoredRows) {
        this.undoRowUpdateEmitter.emit(restoredRows);
    }
}
DkGridRowEditionDispatcher.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionDispatcher, deps: [{ token: DkGridConfig }, { token: DkContentPanelDispatcher }, { token: DkGridCommandFactory }, { token: DkGridSelection }, { token: DkGridDataStore }, { token: DkGridEditionConfig }, { token: DkGridColumnDef }, { token: DkGridMessaging }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridRowEditionDispatcher.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionDispatcher });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionDispatcher, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridConfig }, { type: DkContentPanelDispatcher }, { type: DkGridCommandFactory }, { type: DkGridSelection }, { type: DkGridDataStore }, { type: DkGridEditionConfig }, { type: DkGridColumnDef }, { type: DkGridMessaging }]; } });

class DkGridEditionToolbarDirective {
    constructor(dikeConfig, cdr, gridEditionConfig, gridStructure, generalNotifier) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridEditionConfig = gridEditionConfig;
        this.gridStructure = gridStructure;
        this.generalNotifier = generalNotifier;
        this.changesEditionToolbarPositionSubscription = Subscription.EMPTY;
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    get horizontalGutterHeightPx() {
        return `${this.rowEditionToolbar.horizontalGutterHeight}px`;
    }
    get horizontalGutterHeight() {
        return this.rowEditionToolbar.horizontalGutterHeight;
    }
    get contentHeightPx() {
        return `${this.rowEditionToolbar.contentHeight}px`;
    }
    get contentHeight() {
        return this.rowEditionToolbar.contentHeight;
    }
    get rowHeightPx() {
        return `${this.rowEditionToolbar.rowHeight}px`;
    }
    get rowHeight() {
        return this.rowEditionToolbar.rowHeight;
    }
    ngOnInit() {
        this.setChangeEditionToolbarSubscription();
    }
    ngOnDestroy() {
        this.changesEditionToolbarPositionSubscription.unsubscribe();
    }
    setChangeEditionToolbarSubscription() {
        let toolbarConfig$ = combineLatest([
            this.generalNotifier.onScrollbarWidthChanged$,
            this.gridEditionConfig.onEditionToolbarPositionChanged$,
            this.gridStructure.onEditionToolbarRowChanged$
        ]);
        this.changesEditionToolbarPositionSubscription.unsubscribe();
        this.changesEditionToolbarPositionSubscription = toolbarConfig$.subscribe(([scrollbarWidth, position, toolbarRow]) => {
            this.rowEditionToolbar = toolbarRow;
            this.gridTemplateColumnsValue = position === 'top' ?
                `1fr ${this.dikeConfig.COLUMN_GAP}px ${scrollbarWidth}px` : '1fr';
            this.gridTemplateRowsValue = position === 'top' ?
                `${toolbarRow.contentHeight}px ${toolbarRow.horizontalGutterHeight}px` :
                `${toolbarRow.horizontalGutterHeight}px ${toolbarRow.contentHeight}px`;
            this.cdr.markForCheck();
        });
    }
}
DkGridEditionToolbarDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionToolbarDirective, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridEditionConfig }, { token: DkGridStructure }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Directive });
DkGridEditionToolbarDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridEditionToolbarDirective, selector: "[dkGridEditionToolbar]", host: { properties: { "style.display": "formatContext", "style.grid-template-rows": "gridTemplateRowsValue", "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgEditionToolbar"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionToolbarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridEditionToolbar]',
                    exportAs: 'dkgEditionToolbar',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridEditionConfig }, { type: DkGridStructure }, { type: DkGeneralNotifier }];
    } });

class DkGridEditionToolbarComponent {
    constructor(cdr, gridStructure, gridEditionConfig, gridSelection, gridSelectionConfig, rowEditionDispatcher) {
        this.cdr = cdr;
        this.gridStructure = gridStructure;
        this.gridEditionConfig = gridEditionConfig;
        this.gridSelection = gridSelection;
        this.gridSelectionConfig = gridSelectionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
        this.headerEditionActionsSubscription = Subscription.EMPTY;
        this.headerDeleteActionSubscription = Subscription.EMPTY;
        this.headerUndoActionSubscription = Subscription.EMPTY;
        this.toolbarPosition = this.gridEditionConfig.editionToolbarPosition;
        this.toolbarAlignment = this.gridEditionConfig.editionToolbarAlignment;
        this.toolbarAlignmentStyle = this.getToolbarAlignmentStyle(this.toolbarAlignment);
        this.unsubscribeAll = new Subject();
    }
    ngOnChanges(changes) {
        if (changes['toolbarAlignment']) {
            this.toolbarAlignmentStyle = this.getToolbarAlignmentStyle(this.toolbarAlignment);
        }
    }
    ngOnInit() {
        this.isEditionFilter$ = this.gridEditionConfig.onEditionFilterStateChanged$;
        this.allowSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$;
        this.enableEditionFilterRows$ = this.gridEditionConfig.onEnableEditionFilterRowsChanged$;
        this.editionToolbarItemHeight$ = this.gridStructure.onEditionToolbarItemHeightChanged$.pipe(map(value => `${value}px`));
        this.setMultipleEditionActionsSubscription();
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.headerEditionActionsSubscription.unsubscribe();
        this.headerDeleteActionSubscription.unsubscribe();
        this.headerUndoActionSubscription.unsubscribe();
    }
    onSaveEdition() {
        // Save all rows which are not pristine and are valid:
        this.rowEditionDispatcher.saveEdition();
    }
    onDeleteRows() {
        // From the UI, delete the selected rows:
        this.rowEditionDispatcher.deleteRows(this.gridSelection.getSelectedRows());
    }
    onCancelEdition() {
        // Cancels all the rows which are being edited:
        this.rowEditionDispatcher.cancelEdition();
    }
    onRestoreRows() {
        // From the UI, restore the selected rows:
        this.rowEditionDispatcher.undoRows(this.gridSelection.getSelectedRows());
    }
    onEditingFilter() {
        this.gridEditionConfig.editionFilter = 'Editing';
    }
    onUpdatedFilter() {
        this.gridEditionConfig.editionFilter = 'Modified';
    }
    onDeletedFilter() {
        this.gridEditionConfig.editionFilter = 'Deleted';
    }
    onCancelEditionFilter() {
        this.gridEditionConfig.cancelEditionFilter();
    }
    getToolbarAlignmentStyle(value) {
        switch (value) {
            case 'center':
                return { 'justify-content': 'center' };
            case 'right':
                return { 'justify-content': 'flex-end' };
            default:
                return { 'justify-content': 'flex-start' };
        }
    }
    setMultipleEditionActionsSubscription() {
        const saveCancelActions$ = combineLatest([
            merge(this.rowEditionDispatcher.initialized(), this.rowEditionDispatcher.rowsInEdition.statusChanges),
            this.gridEditionConfig.onEditionFilterChanged$
        ]);
        this.headerEditionActionsSubscription.unsubscribe();
        this.headerEditionActionsSubscription = saveCancelActions$.subscribe(([_, lastEditionFilter]) => {
            let rowsInEditionCardinality = this.rowEditionDispatcher.areThereRowsInEdition();
            /**
             * Save and Cancel actions could be enabled only when no filter is applied or
             * when the user is viewing all the rows which are being edited:
             */
            let isCorrectView = lastEditionFilter === 'Editing' || lastEditionFilter === undefined;
            // Save action:
            this.saveAction = isCorrectView && rowsInEditionCardinality &&
                !this.rowEditionDispatcher.rowsInEdition.pristine &&
                this.rowEditionDispatcher.rowsInEdition.valid;
            // Cancel action:
            this.cancelAction = isCorrectView && rowsInEditionCardinality;
            this.cdr.markForCheck();
        });
        const deleteAction$ = combineLatest([
            merge(this.rowEditionDispatcher.initialized(), this.rowEditionDispatcher.onRowsInEditionChanged$),
            this.gridEditionConfig.onEditionFilterChanged$,
            merge(this.gridSelection.selectionChange, of(this.gridSelection.getSelectedRows()))
        ]);
        this.headerDeleteActionSubscription.unsubscribe();
        this.headerDeleteActionSubscription = deleteAction$.subscribe(([_, lastEditionFilter, selectedRows]) => {
            // Delete action could be enabled only when no filter is applied (normal view):
            let isCorrectView = lastEditionFilter === undefined;
            // If the view is correct, then verify if the selected rows are valid:
            if (isCorrectView) {
                this.deleteAction = selectedRows.filter(row => !row.isEditing &&
                    row.status !== 'Deleted').length > 0;
            }
            else {
                // Otherwise, the Delete action is not allowed:
                this.deleteAction = false;
            }
            this.cdr.markForCheck();
        });
        const undoAction$ = combineLatest([
            this.gridEditionConfig.onEditionFilterChanged$,
            merge(this.gridSelection.selectionChange, of(this.gridSelection.getSelectedRows()))
        ]);
        this.headerUndoActionSubscription.unsubscribe();
        this.headerUndoActionSubscription = undoAction$.subscribe(([lastEditionFilter, selectedRows]) => {
            /**
             * Undo action could be enabled only when the user is viewing
             * all rows which have been modified or deleted, and at least,
             * one of those rows is selected:
             */
            this.undoAction = (lastEditionFilter === 'Modified' && selectedRows.filter(row => !row.isEditing &&
                row.status === 'Modified').length > 0) ||
                (lastEditionFilter === 'Deleted' && selectedRows.filter(row => !row.isEditing &&
                    row.status === 'Deleted').length > 0);
            this.cdr.markForCheck();
        });
    }
}
DkGridEditionToolbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionToolbarComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridStructure }, { token: DkGridEditionConfig }, { token: DkGridSelection }, { token: DkGridSelectionConfig }, { token: DkGridRowEditionDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridEditionToolbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridEditionToolbarComponent, selector: "dk-grid-edition-toolbar", inputs: { toolbarPosition: "toolbarPosition", toolbarAlignment: "toolbarAlignment" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"dkg-edition-toolbar-wrapper\" dkGridEditionToolbar #gridEditionToolbar=\"dkgEditionToolbar\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    [gridColumnEnd]=\"toolbarPosition === 'top' ? 'span 3' : 'span 1'\"\n    [gridRowStart]=\"toolbarPosition === 'top' ? 1 : 2\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridEditionToolbar.contentHeightPx\">\n\n    <div class=\"dkg-edition-toolbar-container\" [ngStyle]=\"toolbarAlignmentStyle\">\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n        [disabled]=\"!saveAction\"\n        matRipple\n        (click)=\"onSaveEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <ng-container *ngIf=\"allowSelection$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [disabled]=\"!deleteAction\"\n          matRipple\n          (click)=\"onDeleteRows()\">\n          <mat-icon>delete</mat-icon>\n          <span>Remove</span>\n        </button>\n\n        <dk-grid-vertical-gutter *ngIf=\"allowSelection$ | async\"\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n        [disabled]=\"!cancelAction\"\n        matRipple\n        (click)=\"onCancelEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <ng-container *ngIf=\"allowSelection$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [disabled]=\"!undoAction\"\n          matRipple\n          (click)=\"onRestoreRows()\">\n          <mat-icon>undo</mat-icon>\n          <span>Restore</span>\n        </button>\n\n        <dk-grid-vertical-gutter *ngIf=\"allowSelection$ | async\"\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <ng-container *ngIf=\"enableEditionFilterRows$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [matMenuTriggerFor]=\"filterMenu\"\n          matRipple>\n          <mat-icon>filter_alt</mat-icon>\n          <span>Edition Filter</span>\n        </button>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <mat-menu #filterMenu=\"matMenu\">\n        <ng-template matMenuContent>\n          <button mat-menu-item\n            (click)=\"onEditingFilter()\">\n            <mat-icon>edit</mat-icon>\n            <span>Editing</span>\n          </button>\n          <button mat-menu-item\n            (click)=\"onUpdatedFilter()\">\n            <mat-icon>done</mat-icon>\n            <span>Modified</span>\n          </button>\n          <button mat-menu-item\n            (click)=\"onDeletedFilter()\">\n            <mat-icon>delete</mat-icon>\n            <span>Removed</span>\n          </button>\n          <button mat-menu-item [disabled]=\"!(isEditionFilter$ | async)\"\n            (click)=\"onCancelEditionFilter()\">\n            <mat-icon>arrow_back</mat-icon>\n            <span>Back</span>\n          </button>\n        </ng-template>\n      </mat-menu>\n\n\n    </div>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    [gridColumnEnd]=\"toolbarPosition === 'top' ? 'span 2' : 'span 1'\"\n    [gridRowStart]=\"toolbarPosition === 'top' ? 2 : 1\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridEditionToolbar.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n</div>\n", styles: [".dkg-edition-toolbar-container{display:flex;flex-direction:row}.dkg-edition-toolbar-item{display:flex;flex-direction:row;justify-content:flex-start;align-items:center;align-self:center;background:transparent;border:none;outline:none;cursor:pointer;text-decoration:none;height:48px;min-width:132px;padding-left:16px;padding-right:16px}.dkg-edition-toolbar-item:disabled{pointer-events:none}.dkg-edition-toolbar-item mat-icon{margin-right:16px}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i9$1.MatMenu, selector: "mat-menu", exportAs: ["matMenu"] }, { type: i9$1.MatMenuItem, selector: "[mat-menu-item]", inputs: ["disabled", "disableRipple", "role"], exportAs: ["matMenuItem"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }], directives: [{ type: DkGridEditionToolbarDirective, selector: "[dkGridEditionToolbar]", exportAs: ["dkgEditionToolbar"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i8$1.MatRipple, selector: "[mat-ripple], [matRipple]", inputs: ["matRippleColor", "matRippleUnbounded", "matRippleCentered", "matRippleRadius", "matRippleAnimation", "matRippleDisabled", "matRippleTrigger"], exportAs: ["matRipple"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i9$1.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", exportAs: ["matMenuTrigger"] }, { type: i9$1.MatMenuContent, selector: "ng-template[matMenuContent]" }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEditionToolbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-edition-toolbar', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-edition-toolbar-wrapper\" dkGridEditionToolbar #gridEditionToolbar=\"dkgEditionToolbar\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    [gridColumnEnd]=\"toolbarPosition === 'top' ? 'span 3' : 'span 1'\"\n    [gridRowStart]=\"toolbarPosition === 'top' ? 1 : 2\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridEditionToolbar.contentHeightPx\">\n\n    <div class=\"dkg-edition-toolbar-container\" [ngStyle]=\"toolbarAlignmentStyle\">\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n        [disabled]=\"!saveAction\"\n        matRipple\n        (click)=\"onSaveEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <ng-container *ngIf=\"allowSelection$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [disabled]=\"!deleteAction\"\n          matRipple\n          (click)=\"onDeleteRows()\">\n          <mat-icon>delete</mat-icon>\n          <span>Remove</span>\n        </button>\n\n        <dk-grid-vertical-gutter *ngIf=\"allowSelection$ | async\"\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n        [disabled]=\"!cancelAction\"\n        matRipple\n        (click)=\"onCancelEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n\n      <dk-grid-vertical-gutter\n        [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n      </dk-grid-vertical-gutter>\n\n      <ng-container *ngIf=\"allowSelection$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [disabled]=\"!undoAction\"\n          matRipple\n          (click)=\"onRestoreRows()\">\n          <mat-icon>undo</mat-icon>\n          <span>Restore</span>\n        </button>\n\n        <dk-grid-vertical-gutter *ngIf=\"allowSelection$ | async\"\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <ng-container *ngIf=\"enableEditionFilterRows$ | async\">\n        <button class=\"dkg-edition-toolbar-item\" [style.height]=\"editionToolbarItemHeight$ | async\"\n          [matMenuTriggerFor]=\"filterMenu\"\n          matRipple>\n          <mat-icon>filter_alt</mat-icon>\n          <span>Edition Filter</span>\n        </button>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"editionToolbarItemHeight$ | async\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <mat-menu #filterMenu=\"matMenu\">\n        <ng-template matMenuContent>\n          <button mat-menu-item\n            (click)=\"onEditingFilter()\">\n            <mat-icon>edit</mat-icon>\n            <span>Editing</span>\n          </button>\n          <button mat-menu-item\n            (click)=\"onUpdatedFilter()\">\n            <mat-icon>done</mat-icon>\n            <span>Modified</span>\n          </button>\n          <button mat-menu-item\n            (click)=\"onDeletedFilter()\">\n            <mat-icon>delete</mat-icon>\n            <span>Removed</span>\n          </button>\n          <button mat-menu-item [disabled]=\"!(isEditionFilter$ | async)\"\n            (click)=\"onCancelEditionFilter()\">\n            <mat-icon>arrow_back</mat-icon>\n            <span>Back</span>\n          </button>\n        </ng-template>\n      </mat-menu>\n\n\n    </div>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    [gridColumnEnd]=\"toolbarPosition === 'top' ? 'span 2' : 'span 1'\"\n    [gridRowStart]=\"toolbarPosition === 'top' ? 2 : 1\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridEditionToolbar.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n</div>\n", styles: [".dkg-edition-toolbar-container{display:flex;flex-direction:row}.dkg-edition-toolbar-item{display:flex;flex-direction:row;justify-content:flex-start;align-items:center;align-self:center;background:transparent;border:none;outline:none;cursor:pointer;text-decoration:none;height:48px;min-width:132px;padding-left:16px;padding-right:16px}.dkg-edition-toolbar-item:disabled{pointer-events:none}.dkg-edition-toolbar-item mat-icon{margin-right:16px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridStructure }, { type: DkGridEditionConfig }, { type: DkGridSelection }, { type: DkGridSelectionConfig }, { type: DkGridRowEditionDispatcher }]; }, propDecorators: { toolbarPosition: [{
                type: Input
            }], toolbarAlignment: [{
                type: Input
            }] } });

var ErrorType;
(function (ErrorType) {
    ErrorType["MIN"] = "min";
    ErrorType["MAX"] = "max";
    ErrorType["REQUIRED"] = "required";
    ErrorType["REQUIRED_TRUE"] = "required";
    ErrorType["EMAIL"] = "email";
    ErrorType["MIN_LENGTH"] = "minlength";
    ErrorType["MAX_LENGTH"] = "maxlength";
    ErrorType["PATTERN"] = "pattern";
})(ErrorType || (ErrorType = {}));
class DkErrorMessage {
    constructor() {
        this.indexMessages = {};
    }
    assign(messages) {
        for (let errorKey in messages.indexMessages) {
            this.indexMessages[errorKey] = messages.indexMessages[errorKey];
        }
        return this;
    }
    get messages() {
        let arrayMessages = [];
        for (let errorKey in this.indexMessages) {
            arrayMessages.push(this.indexMessages[errorKey]);
        }
        return arrayMessages;
    }
    addMessage(errorKey, errorMessage) {
        if (!!errorKey && errorKey.trim() !== '' && !!errorMessage && errorMessage.trim() !== '') {
            this.indexMessages[errorKey] = errorMessage;
        }
        return this;
    }
    removeMessage(errorKey) {
        let foundMessage = this.getMessage(errorKey);
        if (!!foundMessage) {
            delete this.indexMessages[errorKey];
        }
        return foundMessage;
    }
    getMessage(errorKey) {
        return this.indexMessages[errorKey] ? this.indexMessages[errorKey] : undefined;
    }
}

class DkStandardErrorMessage extends DkErrorMessage {
    constructor() {
        super();
        this.addMessage(ErrorType.MIN, 'The minimum number is incorrect');
        this.addMessage(ErrorType.MAX, 'The maximum number is incorrect');
        this.addMessage(ErrorType.REQUIRED, 'Required field');
        this.addMessage(ErrorType.EMAIL, 'The email pattern is incorrect');
        this.addMessage(ErrorType.MIN_LENGTH, 'The minimum length is incorrect');
        this.addMessage(ErrorType.MAX_LENGTH, 'The maximum length is incorrect');
        this.addMessage(ErrorType.PATTERN, 'Wrong pattern');
    }
}
class CustomErrorMessage extends DkErrorMessage {
    constructor() {
        super();
    }
}

class DkEditionErrorMessagesFactory {
    constructor(customErrorMessages) {
        this.customErrorMessages = customErrorMessages;
        // Standard errors:
        this.dikeStandardErrorMessages = new DkStandardErrorMessage();
        if (this.customErrorMessages === null || this.customErrorMessages === undefined) {
            this.customErrorMessages = new CustomErrorMessage();
        }
    }
    initialized() {
        return defer(() => {
            return new Observable(observer => {
                observer.next();
                observer.complete();
            });
        });
    }
    getErrorMessage(errorKey, customMessages) {
        let customInstance = new CustomErrorMessage();
        customInstance.assign(this.dikeStandardErrorMessages).assign(this.customErrorMessages);
        if (customMessages !== null && customMessages !== undefined) {
            customInstance.assign(customMessages);
        }
        return customInstance.getMessage(errorKey);
    }
}
DkEditionErrorMessagesFactory.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditionErrorMessagesFactory, deps: [{ token: CUSTOM_EDITION_ERROR_MESSAGES, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
DkEditionErrorMessagesFactory.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditionErrorMessagesFactory });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditionErrorMessagesFactory, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: CustomErrorMessage, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CUSTOM_EDITION_ERROR_MESSAGES]
                    }] }];
    } });

class DkEditionErrorNotificationDirective {
    constructor(elementRef, render2, editionErrorFactory, gridMessaging) {
        this.elementRef = elementRef;
        this.render2 = render2;
        this.editionErrorFactory = editionErrorFactory;
        this.gridMessaging = gridMessaging;
        this.changesEditionControlSubscription = Subscription.EMPTY;
        this.changesEditionControlStatusSubscription = Subscription.EMPTY;
    }
    ngOnChanges(changes) {
        if (changes['editionControl']) {
            this.setChangesEditionControlSubscription();
        }
    }
    ngOnDestroy() {
        this.changesEditionControlSubscription.unsubscribe();
        this.changesEditionControlStatusSubscription.unsubscribe();
    }
    onMouseOver() {
        if (!!this.editionControl && !!this.editionControl.errors) {
            this.render2.setStyle(this.elementRef.nativeElement, 'cursor', 'pointer');
        }
    }
    onMouseLeave() {
        this.render2.setStyle(this.elementRef.nativeElement, 'cursor', 'default');
    }
    setChangesEditionControlSubscription() {
        this.changesEditionControlSubscription.unsubscribe();
        this.changesEditionControlStatusSubscription.unsubscribe();
        if (!!this.editionControl) {
            this.changesEditionControlStatusSubscription = merge(this.editionControl.statusChanges, this.editionErrorFactory.initialized()).subscribe(() => {
                if (!!this.editionControl.errors) {
                    this.render2.addClass(this.elementRef.nativeElement, this.errorIndicatorClass);
                }
                else {
                    this.render2.removeClass(this.elementRef.nativeElement, this.errorIndicatorClass);
                }
            });
            this.changesEditionControlSubscription = fromEvent(this.elementRef.nativeElement, 'click').subscribe(() => {
                if (!!this.editionControl.errors) {
                    for (let error in this.editionControl.errors) {
                        let errorMessage = this.editionErrorFactory.getErrorMessage(error, this.customErrorMessages);
                        // If the error was defined, notify to the user:
                        if (!!errorMessage) {
                            this.gridMessaging.sendTextMessage(errorMessage);
                        }
                    }
                }
            });
        }
    }
}
DkEditionErrorNotificationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditionErrorNotificationDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: DkEditionErrorMessagesFactory }, { token: DkGridMessaging }], target: i0.ɵɵFactoryTarget.Directive });
DkEditionErrorNotificationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkEditionErrorNotificationDirective, selector: "[dkEditionErrorNotification]", inputs: { editionControl: ["dkEditionErrorNotification", "editionControl"], customErrorMessages: "customErrorMessages", errorIndicatorClass: "errorIndicatorClass" }, host: { listeners: { "mouseenter": "onMouseOver()", "mouseleave": "onMouseLeave()" } }, exportAs: ["dkgEditionErrorNotification"], usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditionErrorNotificationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkEditionErrorNotification]',
                    exportAs: 'dkgEditionErrorNotification'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: DkEditionErrorMessagesFactory }, { type: DkGridMessaging }]; }, propDecorators: { editionControl: [{
                type: Input,
                args: ['dkEditionErrorNotification']
            }], customErrorMessages: [{
                type: Input
            }], errorIndicatorClass: [{
                type: Input
            }], onMouseOver: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

class DkGridCellComponent {
    constructor() {
        this.cellHeight = '';
        this.contentAlign = 'start';
        this.isEditionContainer = false;
        this.editionControl = null;
        this.isColumnOver$ = of({ isOver: false, isForHeaderRow: false });
    }
    ngOnInit() {
        this.isOverValue$ = this.isColumnOver$.pipe(map(value => {
            return value.isOver;
        }));
    }
}
DkGridCellComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCellComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DkGridCellComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridCellComponent, selector: "dk-grid-cell", inputs: { isColumnOver$: "isColumnOver$", cellHeight: "cellHeight", contentAlign: "contentAlign", isEditionContainer: "isEditionContainer", editionControl: "editionControl", customErrorMessages: "customErrorMessages" }, host: { properties: { "class.dkg-cell-edition-container": "isEditionContainer" }, classAttribute: "dkg-cell" }, ngImport: i0, template: "<div *ngIf=\"isEditionContainer\" [ngStyle]=\"{ height: cellHeight }\"\n  class=\"dkg-cell-error-left-indicator-space-position\"\n  [class.dkg-column-over-column]=\"isOverValue$ | async\">\n</div>\n\n<div *ngIf=\"isEditionContainer\" [ngStyle]=\"{ height: cellHeight }\"\n  class=\"dkg-cell-error-left-indicator-position\"\n\n  [class.dkg-column-over-column]=\"isOverValue$ | async\"\n\n  [dkEditionErrorNotification]=\"editionControl\"\n  [customErrorMessages]=\"customErrorMessages\"\n  errorIndicatorClass=\"dkg-cell-error-left-indicator\">\n\n</div>\n\n<div class=\"dkg-cell-wrapper\"\n  [ngStyle]=\"{ height: cellHeight }\"\n\n  [class.dkg-cell-wrapper-position]=\"isEditionContainer\"\n  [class.dkg-cell-wrapper-left-padding]=\"!isEditionContainer\"\n\n  [class.dkg-cell-content-start-align]=\"contentAlign === 'start'\"\n  [class.dkg-cell-content-left-align]=\"contentAlign === 'left'\"\n  [class.dkg-cell-content-center-align]=\"contentAlign === 'center'\"\n  [class.dkg-cell-content-right-align]=\"contentAlign === 'right'\"\n  [class.dkg-cell-content-end-align]=\"contentAlign === 'end'\"\n\n  [class.dkg-column-over-column]=\"isOverValue$ | async\">\n\n  <ng-content></ng-content>\n\n</div>\n", styles: [".dkg-cell-edition-container{display:grid;grid-template-columns:1px 6px 1fr}.dkg-cell-wrapper{display:flex;flex-direction:row;flex-wrap:nowrap;align-items:center;justify-content:center;padding-right:7px;box-sizing:border-box;min-width:0}.dkg-cell-wrapper p{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin:0}.dkg-cell-wrapper>*:not([mat-icon-button]){width:100%}.dkg-cell-wrapper.dkg-cell-content-start-align>*{text-align:start}.dkg-cell-wrapper.dkg-cell-content-left-align>*{text-align:left}.dkg-cell-wrapper.dkg-cell-content-center-align>*{text-align:center}.dkg-cell-wrapper.dkg-cell-content-right-align>*{text-align:right}.dkg-cell-wrapper.dkg-cell-content-end-align>*{text-align:end}.dkg-cell-wrapper-left-padding{padding-left:7px}.dkg-cell-wrapper-position{grid-column:3/span 1}.dkg-cell-error-left-indicator-space-position{grid-column:1/span 1}.dkg-cell-error-left-indicator-position{grid-column:2/span 1}.dkg-cell-error-left-indicator{border-top:0;border-left-width:4px;border-left-style:solid;border-top-left-radius:4px;border-bottom-left-radius:4px}\n"], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: DkEditionErrorNotificationDirective, selector: "[dkEditionErrorNotification]", inputs: ["dkEditionErrorNotification", "customErrorMessages", "errorIndicatorClass"], exportAs: ["dkgEditionErrorNotification"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-cell', host: {
                        'class': 'dkg-cell',
                        '[class.dkg-cell-edition-container]': 'isEditionContainer'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *ngIf=\"isEditionContainer\" [ngStyle]=\"{ height: cellHeight }\"\n  class=\"dkg-cell-error-left-indicator-space-position\"\n  [class.dkg-column-over-column]=\"isOverValue$ | async\">\n</div>\n\n<div *ngIf=\"isEditionContainer\" [ngStyle]=\"{ height: cellHeight }\"\n  class=\"dkg-cell-error-left-indicator-position\"\n\n  [class.dkg-column-over-column]=\"isOverValue$ | async\"\n\n  [dkEditionErrorNotification]=\"editionControl\"\n  [customErrorMessages]=\"customErrorMessages\"\n  errorIndicatorClass=\"dkg-cell-error-left-indicator\">\n\n</div>\n\n<div class=\"dkg-cell-wrapper\"\n  [ngStyle]=\"{ height: cellHeight }\"\n\n  [class.dkg-cell-wrapper-position]=\"isEditionContainer\"\n  [class.dkg-cell-wrapper-left-padding]=\"!isEditionContainer\"\n\n  [class.dkg-cell-content-start-align]=\"contentAlign === 'start'\"\n  [class.dkg-cell-content-left-align]=\"contentAlign === 'left'\"\n  [class.dkg-cell-content-center-align]=\"contentAlign === 'center'\"\n  [class.dkg-cell-content-right-align]=\"contentAlign === 'right'\"\n  [class.dkg-cell-content-end-align]=\"contentAlign === 'end'\"\n\n  [class.dkg-column-over-column]=\"isOverValue$ | async\">\n\n  <ng-content></ng-content>\n\n</div>\n", styles: [".dkg-cell-edition-container{display:grid;grid-template-columns:1px 6px 1fr}.dkg-cell-wrapper{display:flex;flex-direction:row;flex-wrap:nowrap;align-items:center;justify-content:center;padding-right:7px;box-sizing:border-box;min-width:0}.dkg-cell-wrapper p{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin:0}.dkg-cell-wrapper>*:not([mat-icon-button]){width:100%}.dkg-cell-wrapper.dkg-cell-content-start-align>*{text-align:start}.dkg-cell-wrapper.dkg-cell-content-left-align>*{text-align:left}.dkg-cell-wrapper.dkg-cell-content-center-align>*{text-align:center}.dkg-cell-wrapper.dkg-cell-content-right-align>*{text-align:right}.dkg-cell-wrapper.dkg-cell-content-end-align>*{text-align:end}.dkg-cell-wrapper-left-padding{padding-left:7px}.dkg-cell-wrapper-position{grid-column:3/span 1}.dkg-cell-error-left-indicator-space-position{grid-column:1/span 1}.dkg-cell-error-left-indicator-position{grid-column:2/span 1}.dkg-cell-error-left-indicator{border-top:0;border-left-width:4px;border-left-style:solid;border-top-left-radius:4px;border-bottom-left-radius:4px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { isColumnOver$: [{
                type: Input
            }], cellHeight: [{
                type: Input
            }], contentAlign: [{
                type: Input
            }], isEditionContainer: [{
                type: Input
            }], editionControl: [{
                type: Input
            }], customErrorMessages: [{
                type: Input
            }] } });

class DkGridRowEditionMenuComponent {
    constructor(dikeConfig, cdr, gridEditionConfig, gridSelection, gridSelectionConfig, rowEditionDispatcher) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridEditionConfig = gridEditionConfig;
        this.gridSelection = gridSelection;
        this.gridSelectionConfig = gridSelectionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
        this.rowEditionActionsSubscription = Subscription.EMPTY;
        this.headerEditionActionsSubscription = Subscription.EMPTY;
        this.headerDeleteActionSubscription = Subscription.EMPTY;
        this.headerUndoActionSubscription = Subscription.EMPTY;
        // Only content rows will have the row input property:
        this.row = null;
        this.isHeaderRow = false;
        this.isEmptyRow = false;
        this.rowContentHeightPx = '';
        this.rowHorizontalGutterHeightPx = '';
        this.rowContentWidthPx = `${this.dikeConfig.ROW_EDITION_MENU_CELL_WIDTH - this.dikeConfig.COLUMN_GAP}px`;
        this.rowVerticalGutterWidthPx = `${this.dikeConfig.COLUMN_GAP}px`;
        this.crossFieldValidationErrors = !!this.gridEditionConfig.gridEditionSettings.crossFieldValidation ?
            this.gridEditionConfig.gridEditionSettings.crossFieldValidation.errorMessages : null;
        this.isVerticalLineVisible = true;
        this.unsubscribeAll = new Subject();
    }
    ngOnChanges(changes) {
        if (changes['rowContentHeightPx'] || changes['rowHorizontalGutterHeightPx']) {
            this.setGridDisplay();
        }
        if (changes['row']) {
            this.setRowEditionActionsSubscription();
            this.cardinalityRowHistory$ = this.rowEditionDispatcher.cardinalityRowHistory(this.row.id);
        }
    }
    ngOnInit() {
        this.isEditionFilter$ = this.gridEditionConfig.onEditionFilterStateChanged$;
        this.editionToolbar$ = this.gridEditionConfig.onEditionToolbarChanged$;
        if (this.isHeaderRow) {
            this.editionFilter$ = this.gridEditionConfig.onEditionFilterChanged$;
            this.allowSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$;
            this.enableEditionFilterRows$ = this.gridEditionConfig.onEnableEditionFilterRowsChanged$;
            this.gridEditionConfig.onEditionToolbarChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(isEditionToolbar => {
                if (!isEditionToolbar) {
                    this.setMultipleEditionActionsSubscription();
                }
                else {
                    this.headerEditionActionsSubscription.unsubscribe();
                    this.headerDeleteActionSubscription.unsubscribe();
                    this.headerUndoActionSubscription.unsubscribe();
                }
            });
        }
    }
    ngOnDestroy() {
        this.rowEditionActionsSubscription.unsubscribe();
        this.headerEditionActionsSubscription.unsubscribe();
        this.headerDeleteActionSubscription.unsubscribe();
        this.headerUndoActionSubscription.unsubscribe();
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    onSaveEdition() {
        // Save all rows which are not pristine and are valid:
        this.rowEditionDispatcher.saveEdition();
    }
    onDeleteRows() {
        // From the UI, delete the selected rows:
        this.rowEditionDispatcher.deleteRows(this.gridSelection.getSelectedRows());
    }
    onCancelEdition() {
        // Cancels all the rows which are being edited:
        this.rowEditionDispatcher.cancelEdition();
    }
    onRestoreRows() {
        // From the UI, restore the selected rows:
        this.rowEditionDispatcher.undoRows(this.gridSelection.getSelectedRows());
    }
    onRowEdition() {
        this.rowEditionDispatcher.editRow(this.row);
    }
    onDeleteRow() {
        this.rowEditionDispatcher.deleteRow(this.row);
    }
    onSaveRowEdition() {
        this.rowEditionDispatcher.updateRow(this.row);
        /**
         * Premises:
         *
         *  1.  The user is in edition filters, specifically viewing rows in edition.
         *  2.  There are only one row which is being edited.
         *
         *  If the user has saved the unique row which is being edited, then return the
         *  user to the data wiew.
         */
        if (this.gridEditionConfig.editionFilterState && !this.rowEditionDispatcher.areThereRowsInEdition()) {
            this.gridEditionConfig.cancelEditionFilter();
        }
    }
    onCancelRowEdition() {
        this.rowEditionDispatcher.cancelRowEdition(this.row);
        /**
         * If the user cancels the last and unique row which is being
         * edited and, the user is in editionFilter state, return the
         * user to the data viewing.
         */
        if (this.gridEditionConfig.editionFilterState && !this.rowEditionDispatcher.areThereRowsInEdition()) {
            this.gridEditionConfig.cancelEditionFilter();
        }
        else if (this.gridEditionConfig.editionFilterState) {
            /**
           * Remember, when cancelling edition at row level we  must
           * verify if the user is in edition filter view. If so, the
           * user is viewing the rows which are being edited. We have to
           * resend the last edition filter avoiding keeping the cancelled
           * row in the view.
           */
            this.gridEditionConfig.editionFilter = 'Editing';
        }
    }
    onUndoRowUpdate() {
        this.rowEditionDispatcher.undoRowUpdate(this.row);
        /**
         * If the user clicks on any undo button means that the user is in editionFilter view.
         *
         * If the user undo the unique row displayed, we must verify which view the user is: Modified
         * rows or Removed rows.
         *
         * Depending on which edition filter the user is, we verify if there are more rows
         * in specific state.
         */
        if (this.gridEditionConfig.editionFilterState) {
            if ((this.gridEditionConfig.editionFilter === 'Modified' && !this.rowEditionDispatcher.areThereRowsModified()) ||
                this.gridEditionConfig.editionFilter === 'Deleted' && !this.rowEditionDispatcher.areThereRowsRemoved()) {
                this.gridEditionConfig.cancelEditionFilter();
            }
        }
    }
    onEditingFilter() {
        this.gridEditionConfig.editionFilter = 'Editing';
    }
    onUpdatedFilter() {
        this.gridEditionConfig.editionFilter = 'Modified';
    }
    onDeletedFilter() {
        this.gridEditionConfig.editionFilter = 'Deleted';
    }
    onCancelEditionFilter() {
        this.gridEditionConfig.cancelEditionFilter();
    }
    setGridDisplay() {
        this.rowGridDisplay = {
            display: 'grid',
            gridTemplateRows: `${this.rowContentHeightPx} ${this.rowHorizontalGutterHeightPx}`,
            gridTemplateColumns: `${this.rowContentWidthPx} ${this.rowVerticalGutterWidthPx}`
        };
    }
    setRowEditionActionsSubscription() {
        this.rowEditionActionsSubscription.unsubscribe();
        this.rowEditionActionsSubscription = this.row.editionActionsChange.subscribe(value => {
            this.rowEditAction = value.edit;
            this.rowDeleteAction = value.delete;
            this.rowSaveAction = value.save;
            this.rowCancelAction = value.cancel;
            this.cdr.markForCheck();
        });
    }
    setMultipleEditionActionsSubscription() {
        const headerActions$ = combineLatest([
            merge(this.rowEditionDispatcher.initialized(), this.rowEditionDispatcher.rowsInEdition.statusChanges),
            this.gridEditionConfig.onEditionFilterChanged$
        ]);
        this.headerEditionActionsSubscription.unsubscribe();
        this.headerEditionActionsSubscription = headerActions$.subscribe(([_, lastEditionFilter]) => {
            let rowsInEditionCardinality = this.rowEditionDispatcher.areThereRowsInEdition();
            /**
             * Save and Cancel actions could be enabled only when no filter is applied or
             * when the user is viewing all the rows which are being edited:
             */
            let isCorrectView = lastEditionFilter === 'Editing' || lastEditionFilter === undefined;
            // Save action:
            this.saveAction = isCorrectView && rowsInEditionCardinality &&
                !this.rowEditionDispatcher.rowsInEdition.pristine &&
                this.rowEditionDispatcher.rowsInEdition.valid;
            // Cancel action:
            this.cancelAction = isCorrectView && rowsInEditionCardinality;
            this.cdr.markForCheck();
        });
        const deleteAction$ = combineLatest([
            merge(this.rowEditionDispatcher.initialized(), this.rowEditionDispatcher.onRowsInEditionChanged$),
            this.gridEditionConfig.onEditionFilterChanged$,
            merge(this.gridSelection.selectionChange, of(this.gridSelection.getSelectedRows()))
        ]);
        this.headerDeleteActionSubscription.unsubscribe();
        this.headerDeleteActionSubscription = deleteAction$.subscribe(([_, lastEditionFilter, selectedRows]) => {
            // Delete action could be enabled only when no edition filter is applied (normal view):
            let isCorrectView = lastEditionFilter === undefined;
            // If the view is correct, then verify if the selected rows are valid:
            if (isCorrectView) {
                this.deleteAction = selectedRows.filter(row => !row.isEditing &&
                    row.status !== 'Deleted').length > 0;
            }
            else {
                // Otherwise, the Delete action is not allowed:
                this.deleteAction = false;
            }
            this.cdr.markForCheck();
        });
        const undoAction$ = combineLatest([
            this.gridEditionConfig.onEditionFilterChanged$,
            merge(this.gridSelection.selectionChange, of(this.gridSelection.getSelectedRows()))
        ]);
        this.headerUndoActionSubscription.unsubscribe();
        this.headerUndoActionSubscription = undoAction$.subscribe(([lastEditionFilter, selectedRows]) => {
            /**
             * Undo action could be enabled only when the user is viewing
             * all rows which have been modified or deleted, and at least,
             * one of those rows is selected:
             */
            this.undoAction = (lastEditionFilter === 'Modified' && selectedRows.filter(row => !row.isEditing &&
                row.status === 'Modified').length > 0) ||
                (lastEditionFilter === 'Deleted' && selectedRows.filter(row => !row.isEditing &&
                    row.status === 'Deleted').length > 0);
            this.cdr.markForCheck();
        });
    }
}
DkGridRowEditionMenuComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionMenuComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridEditionConfig }, { token: DkGridSelection }, { token: DkGridSelectionConfig }, { token: DkGridRowEditionDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowEditionMenuComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowEditionMenuComponent, selector: "dk-grid-row-edition-menu", inputs: { row: "row", isHeaderRow: "isHeaderRow", isEmptyRow: "isEmptyRow", rowContentHeightPx: "rowContentHeightPx", rowHorizontalGutterHeightPx: "rowHorizontalGutterHeightPx", isVerticalLineVisible: "isVerticalLineVisible" }, host: { properties: { "class.dkg-row-edition-invalid": "row && row.isEditing && row.rowFormGroup.invalid", "class.dkg-row-edition-menu-header": "isHeaderRow", "style.display": "rowGridDisplay.display", "style.gridTemplateRows": "rowGridDisplay.gridTemplateRows", "style.gridTemplateColumns": "rowGridDisplay.gridTemplateColumns" }, classAttribute: "dkg-row-edition-menu" }, usesOnChanges: true, ngImport: i0, template: "<dk-grid-empty-cell *ngIf=\"isHeaderRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  [isHeaderCell]=\"isHeaderRow\"\n  contentAlign=\"center\">\n\n  <ng-container *ngIf=\"isHeaderRow && !(editionToolbar$ | async)\">\n    <ng-container *ngTemplateOutlet=\"headerGeneralMenu\"></ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"isHeaderRow && (editionToolbar$ | async)\">\n    <ng-container *ngIf=\"editionFilter$ | async as editionFilter\">\n      <ng-container *ngTemplateOutlet=\"editionFilterIcons; context: { editionFilter: editionFilter }\" ></ng-container>\n    </ng-container>\n  </ng-container>\n\n</dk-grid-empty-cell>\n\n<dk-grid-cell *ngIf=\"!isHeaderRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  contentAlign=\"center\"\n\n  [isEditionContainer]=\"row && row.isEditing\"\n  [editionControl]=\"row && row.isEditing ? (row.rowFormGroupChange | async) : null\"\n  [customErrorMessages]=\"row && row.isEditing ? crossFieldValidationErrors : null\">\n\n  <ng-container *ngIf=\"!isHeaderRow && row\">\n    <ng-container *ngIf=\"(isEditionFilter$ | async); else rowContextEditionMenu\">\n      <ng-container *ngIf=\"row.isEditing; else undoRowChanges\">\n        <ng-container *ngTemplateOutlet=\"rowContextEditionMenu\"></ng-container>\n      </ng-container>\n    </ng-container>\n  </ng-container>\n\n</dk-grid-cell>\n\n<dk-grid-vertical-gutter *ngIf=\"!isEmptyRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"2\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [isEmpty]=\"!isVerticalLineVisible\"\n  [isHeaderGutter]=\"isHeaderRow\"\n  [gutterHeight]=\"rowContentHeightPx\">\n</dk-grid-vertical-gutter>\n\n<dk-grid-horizontal-gutter *ngIf=\"!isEmptyRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 2\"\n  [gridRowStart]=\"2\"\n  gridRowEnd=\"span 1\"\n\n  [gutterHeight]=\"rowHorizontalGutterHeightPx\">\n</dk-grid-horizontal-gutter>\n\n<ng-template #headerGeneralMenu>\n  <button mat-icon-button [matMenuTriggerFor]=\"headerMenu\">\n    <ng-container *ngIf=\"editionFilter$ | async as editionFilter; else dataView\">\n      <ng-container *ngTemplateOutlet=\"editionFilterIcons; context: { editionFilter: editionFilter }\" ></ng-container>\n    </ng-container>\n\n    <ng-template #dataView>\n      <mat-icon>more_horiz</mat-icon>\n    </ng-template>\n  </button>\n\n  <mat-menu #headerMenu=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item [disabled]=\"!saveAction\"\n        (click)=\"onSaveEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n      <button mat-menu-item *ngIf=\"allowSelection$ | async\" [disabled]=\"!deleteAction\"\n        (click)=\"onDeleteRows()\">\n        <mat-icon>delete</mat-icon>\n        <span>Remove</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!cancelAction\"\n        (click)=\"onCancelEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n      <button mat-menu-item *ngIf=\"allowSelection$ | async\" [disabled]=\"!undoAction\"\n        (click)=\"onRestoreRows()\">\n        <mat-icon>undo</mat-icon>\n        <span>Restore</span>\n      </button>\n      <button mat-menu-item [matMenuTriggerFor]=\"filterMenu\" *ngIf=\"enableEditionFilterRows$ | async\">\n        <mat-icon>filter_alt</mat-icon>\n        <span>Edition Filter</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n  <mat-menu #filterMenu=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item\n        (click)=\"onEditingFilter()\">\n        <mat-icon>edit</mat-icon>\n        <span>Editing</span>\n      </button>\n      <button mat-menu-item\n        (click)=\"onUpdatedFilter()\">\n        <mat-icon>done</mat-icon>\n        <span>Modified</span>\n      </button>\n      <button mat-menu-item\n        (click)=\"onDeletedFilter()\">\n        <mat-icon>delete</mat-icon>\n        <span>Removed</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!(isEditionFilter$ | async)\"\n        (click)=\"onCancelEditionFilter()\">\n        <mat-icon>arrow_back</mat-icon>\n        <span>Back</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n</ng-template>\n\n<ng-template #editionFilterIcons let-editionFilter=\"editionFilter\">\n  <ng-container [ngSwitch]=\"editionFilter\">\n    <mat-icon *ngSwitchCase=\"'Editing'\" matTooltip=\"Editing\">edit</mat-icon>\n    <mat-icon *ngSwitchCase=\"'Modified'\" matTooltip=\"Modified\">done</mat-icon>\n    <mat-icon *ngSwitchCase=\"'Deleted'\" matTooltip=\"Removed\">delete</mat-icon>\n  </ng-container>\n</ng-template>\n\n<ng-template #undoRowChanges>\n  <button mat-icon-button\n    (click)=\"onUndoRowUpdate()\">\n    <mat-icon\n      [matBadge]=\"cardinalityRowHistory$ | async\"\n      matBadgeColor=\"warn\">undo</mat-icon>\n  </button>\n</ng-template>\n\n<ng-template #rowContextEditionMenu>\n  <button mat-icon-button [matMenuTriggerFor]=\"rowEditionMenuOptions\">\n    <ng-container *ngIf=\"!row.isEditing; else inEdition\">\n      <mat-icon>more_vert</mat-icon>\n    </ng-container>\n\n    <ng-template #inEdition>\n      <mat-icon>edit</mat-icon>\n    </ng-template>\n  </button>\n\n  <mat-menu #rowEditionMenuOptions=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item [disabled]=\"!rowEditAction\"\n        (click)=\"onRowEdition()\">\n        <mat-icon>edit</mat-icon>\n        <span>Edit</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowSaveAction || !this.row.rowFormGroup.valid || this.row.rowFormGroup.pristine\"\n        (click)=\"onSaveRowEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowDeleteAction\"\n        (click)=\"onDeleteRow()\">\n        <mat-icon>delete</mat-icon>\n        <span>Remove</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowCancelAction\"\n        (click)=\"onCancelRowEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n</ng-template>\n", styles: [""], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridCellComponent, selector: "dk-grid-cell", inputs: ["isColumnOver$", "cellHeight", "contentAlign", "isEditionContainer", "editionControl", "customErrorMessages"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i9$1.MatMenu, selector: "mat-menu", exportAs: ["matMenu"] }, { type: i9$1.MatMenuItem, selector: "[mat-menu-item]", inputs: ["disabled", "disableRipple", "role"], exportAs: ["matMenuItem"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i9$1.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", exportAs: ["matMenuTrigger"] }, { type: i9$1.MatMenuContent, selector: "ng-template[matMenuContent]" }, { type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i14.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i15.MatBadge, selector: "[matBadge]", inputs: ["matBadgeDisabled", "matBadgeColor", "matBadgeOverlap", "matBadgePosition", "matBadge", "matBadgeDescription", "matBadgeSize", "matBadgeHidden"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-edition-menu', host: {
                        'class': 'dkg-row-edition-menu',
                        '[class.dkg-row-edition-invalid]': 'row && row.isEditing && row.rowFormGroup.invalid',
                        '[class.dkg-row-edition-menu-header]': 'isHeaderRow',
                        '[style.display]': 'rowGridDisplay.display',
                        '[style.gridTemplateRows]': 'rowGridDisplay.gridTemplateRows',
                        '[style.gridTemplateColumns]': 'rowGridDisplay.gridTemplateColumns'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<dk-grid-empty-cell *ngIf=\"isHeaderRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  [isHeaderCell]=\"isHeaderRow\"\n  contentAlign=\"center\">\n\n  <ng-container *ngIf=\"isHeaderRow && !(editionToolbar$ | async)\">\n    <ng-container *ngTemplateOutlet=\"headerGeneralMenu\"></ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"isHeaderRow && (editionToolbar$ | async)\">\n    <ng-container *ngIf=\"editionFilter$ | async as editionFilter\">\n      <ng-container *ngTemplateOutlet=\"editionFilterIcons; context: { editionFilter: editionFilter }\" ></ng-container>\n    </ng-container>\n  </ng-container>\n\n</dk-grid-empty-cell>\n\n<dk-grid-cell *ngIf=\"!isHeaderRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  contentAlign=\"center\"\n\n  [isEditionContainer]=\"row && row.isEditing\"\n  [editionControl]=\"row && row.isEditing ? (row.rowFormGroupChange | async) : null\"\n  [customErrorMessages]=\"row && row.isEditing ? crossFieldValidationErrors : null\">\n\n  <ng-container *ngIf=\"!isHeaderRow && row\">\n    <ng-container *ngIf=\"(isEditionFilter$ | async); else rowContextEditionMenu\">\n      <ng-container *ngIf=\"row.isEditing; else undoRowChanges\">\n        <ng-container *ngTemplateOutlet=\"rowContextEditionMenu\"></ng-container>\n      </ng-container>\n    </ng-container>\n  </ng-container>\n\n</dk-grid-cell>\n\n<dk-grid-vertical-gutter *ngIf=\"!isEmptyRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"2\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [isEmpty]=\"!isVerticalLineVisible\"\n  [isHeaderGutter]=\"isHeaderRow\"\n  [gutterHeight]=\"rowContentHeightPx\">\n</dk-grid-vertical-gutter>\n\n<dk-grid-horizontal-gutter *ngIf=\"!isEmptyRow\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 2\"\n  [gridRowStart]=\"2\"\n  gridRowEnd=\"span 1\"\n\n  [gutterHeight]=\"rowHorizontalGutterHeightPx\">\n</dk-grid-horizontal-gutter>\n\n<ng-template #headerGeneralMenu>\n  <button mat-icon-button [matMenuTriggerFor]=\"headerMenu\">\n    <ng-container *ngIf=\"editionFilter$ | async as editionFilter; else dataView\">\n      <ng-container *ngTemplateOutlet=\"editionFilterIcons; context: { editionFilter: editionFilter }\" ></ng-container>\n    </ng-container>\n\n    <ng-template #dataView>\n      <mat-icon>more_horiz</mat-icon>\n    </ng-template>\n  </button>\n\n  <mat-menu #headerMenu=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item [disabled]=\"!saveAction\"\n        (click)=\"onSaveEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n      <button mat-menu-item *ngIf=\"allowSelection$ | async\" [disabled]=\"!deleteAction\"\n        (click)=\"onDeleteRows()\">\n        <mat-icon>delete</mat-icon>\n        <span>Remove</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!cancelAction\"\n        (click)=\"onCancelEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n      <button mat-menu-item *ngIf=\"allowSelection$ | async\" [disabled]=\"!undoAction\"\n        (click)=\"onRestoreRows()\">\n        <mat-icon>undo</mat-icon>\n        <span>Restore</span>\n      </button>\n      <button mat-menu-item [matMenuTriggerFor]=\"filterMenu\" *ngIf=\"enableEditionFilterRows$ | async\">\n        <mat-icon>filter_alt</mat-icon>\n        <span>Edition Filter</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n  <mat-menu #filterMenu=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item\n        (click)=\"onEditingFilter()\">\n        <mat-icon>edit</mat-icon>\n        <span>Editing</span>\n      </button>\n      <button mat-menu-item\n        (click)=\"onUpdatedFilter()\">\n        <mat-icon>done</mat-icon>\n        <span>Modified</span>\n      </button>\n      <button mat-menu-item\n        (click)=\"onDeletedFilter()\">\n        <mat-icon>delete</mat-icon>\n        <span>Removed</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!(isEditionFilter$ | async)\"\n        (click)=\"onCancelEditionFilter()\">\n        <mat-icon>arrow_back</mat-icon>\n        <span>Back</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n</ng-template>\n\n<ng-template #editionFilterIcons let-editionFilter=\"editionFilter\">\n  <ng-container [ngSwitch]=\"editionFilter\">\n    <mat-icon *ngSwitchCase=\"'Editing'\" matTooltip=\"Editing\">edit</mat-icon>\n    <mat-icon *ngSwitchCase=\"'Modified'\" matTooltip=\"Modified\">done</mat-icon>\n    <mat-icon *ngSwitchCase=\"'Deleted'\" matTooltip=\"Removed\">delete</mat-icon>\n  </ng-container>\n</ng-template>\n\n<ng-template #undoRowChanges>\n  <button mat-icon-button\n    (click)=\"onUndoRowUpdate()\">\n    <mat-icon\n      [matBadge]=\"cardinalityRowHistory$ | async\"\n      matBadgeColor=\"warn\">undo</mat-icon>\n  </button>\n</ng-template>\n\n<ng-template #rowContextEditionMenu>\n  <button mat-icon-button [matMenuTriggerFor]=\"rowEditionMenuOptions\">\n    <ng-container *ngIf=\"!row.isEditing; else inEdition\">\n      <mat-icon>more_vert</mat-icon>\n    </ng-container>\n\n    <ng-template #inEdition>\n      <mat-icon>edit</mat-icon>\n    </ng-template>\n  </button>\n\n  <mat-menu #rowEditionMenuOptions=\"matMenu\">\n    <ng-template matMenuContent>\n      <button mat-menu-item [disabled]=\"!rowEditAction\"\n        (click)=\"onRowEdition()\">\n        <mat-icon>edit</mat-icon>\n        <span>Edit</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowSaveAction || !this.row.rowFormGroup.valid || this.row.rowFormGroup.pristine\"\n        (click)=\"onSaveRowEdition()\">\n        <mat-icon>save_alt</mat-icon>\n        <span>Save</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowDeleteAction\"\n        (click)=\"onDeleteRow()\">\n        <mat-icon>delete</mat-icon>\n        <span>Remove</span>\n      </button>\n      <button mat-menu-item [disabled]=\"!rowCancelAction\"\n        (click)=\"onCancelRowEdition()\">\n        <mat-icon>clear</mat-icon>\n        <span>Cancel</span>\n      </button>\n    </ng-template>\n  </mat-menu>\n\n</ng-template>\n", styles: [""] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridEditionConfig }, { type: DkGridSelection }, { type: DkGridSelectionConfig }, { type: DkGridRowEditionDispatcher }];
    }, propDecorators: { row: [{
                type: Input
            }], isHeaderRow: [{
                type: Input
            }], isEmptyRow: [{
                type: Input
            }], rowContentHeightPx: [{
                type: Input
            }], rowHorizontalGutterHeightPx: [{
                type: Input
            }], isVerticalLineVisible: [{
                type: Input
            }] } });

class DkGridRowEditionTriggersDirective {
    constructor(gridEditionConfig, rowEditionDispatcher) {
        this.gridEditionConfig = gridEditionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
    }
    onDblClickRow(e) {
        e.stopPropagation();
        if (this.gridEditionConfig.gridEditionSettings.rowEditionDblClick &&
            this.gridEditionConfig.allowEdition && this.gridEditionConfig.editionMode && !!this.row) {
            if (!this.row.isEditing && !this.gridEditionConfig.editionFilterState) {
                this.rowEditionDispatcher.editRow(this.row);
            }
        }
    }
    onKeyupEnter() {
        if (this.gridEditionConfig.gridEditionSettings.rowEditionEnterkey) {
            this.rowEditionDispatcher.updateRow(this.row);
            /**
             * If the unique row, which is being edited, has been saved and
             * the user is in edition filters (rows editing):
             */
            if (this.gridEditionConfig.editionFilterState && !this.rowEditionDispatcher.areThereRowsInEdition()) {
                this.gridEditionConfig.cancelEditionFilter();
            }
        }
    }
    onKeyupEscape() {
        if (this.gridEditionConfig.gridEditionSettings.rowEditionEscKey) {
            this.rowEditionDispatcher.cancelRowEdition(this.row);
            // If the unique row which is being edited has been cancelled, return the user to the data view:
            if (this.gridEditionConfig.editionFilterState && !this.rowEditionDispatcher.areThereRowsInEdition()) {
                this.gridEditionConfig.cancelEditionFilter();
            }
        }
    }
}
DkGridRowEditionTriggersDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionTriggersDirective, deps: [{ token: DkGridEditionConfig }, { token: DkGridRowEditionDispatcher }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowEditionTriggersDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowEditionTriggersDirective, selector: "[dkGridRowEditionTriggers]", inputs: { row: ["dkGridRowEditionTriggers", "row"] }, host: { listeners: { "dblclick": "onDblClickRow($event)", "keyup.enter": "onKeyupEnter()", "keyup.escape": "onKeyupEscape()" } }, exportAs: ["dkgRowEditionTriggers"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEditionTriggersDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRowEditionTriggers]',
                    exportAs: 'dkgRowEditionTriggers'
                }]
        }], ctorParameters: function () { return [{ type: DkGridEditionConfig }, { type: DkGridRowEditionDispatcher }]; }, propDecorators: { row: [{
                type: Input,
                args: ['dkGridRowEditionTriggers']
            }], onDblClickRow: [{
                type: HostListener,
                args: ['dblclick', ['$event']]
            }], onKeyupEnter: [{
                type: HostListener,
                args: ['keyup.enter']
            }], onKeyupEscape: [{
                type: HostListener,
                args: ['keyup.escape']
            }] } });

class DkEditingModule {
}
DkEditingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkEditingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditingModule, declarations: [DkGridEditionToolbarComponent,
        DkGridRowEditionMenuComponent,
        DkGridCellComponent,
        DkEditionErrorNotificationDirective,
        DkGridEditionToolbarDirective,
        DkGridRowEditionTriggersDirective], imports: [CommonModule,
        MatRippleModule,
        MatIconModule,
        MatMenuModule,
        MatButtonModule,
        MatBadgeModule,
        MatTooltipModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkGridEditionToolbarComponent,
        DkGridRowEditionMenuComponent,
        DkGridCellComponent,
        DkGridRowEditionTriggersDirective] });
DkEditingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditingModule, imports: [[
            CommonModule,
            MatRippleModule,
            MatIconModule,
            MatMenuModule,
            MatButtonModule,
            MatBadgeModule,
            MatTooltipModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkEditingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridEditionToolbarComponent,
                        DkGridRowEditionMenuComponent,
                        DkGridCellComponent,
                        DkEditionErrorNotificationDirective,
                        DkGridEditionToolbarDirective,
                        DkGridRowEditionTriggersDirective
                    ],
                    imports: [
                        CommonModule,
                        MatRippleModule,
                        MatIconModule,
                        MatMenuModule,
                        MatButtonModule,
                        MatBadgeModule,
                        MatTooltipModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridEditionToolbarComponent,
                        DkGridRowEditionMenuComponent,
                        DkGridCellComponent,
                        DkGridRowEditionTriggersDirective
                    ]
                }]
        }] });

class RowFormControlInstancePipe {
    transform(panelGroup, slotId) {
        return panelGroup.get(slotId);
    }
}
RowFormControlInstancePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFormControlInstancePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
RowFormControlInstancePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFormControlInstancePipe, name: "rowFormControlInstance" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowFormControlInstancePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'rowFormControlInstance'
                }]
        }] });

class RowEditionTemplatePipe {
    transform(columnSlot) {
        return columnSlot.editionTemplate;
    }
}
RowEditionTemplatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEditionTemplatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
RowEditionTemplatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEditionTemplatePipe, name: "rowEditionTemplate" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEditionTemplatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'rowEditionTemplate'
                }]
        }] });

class RowDisplayTemplatePipe {
    transform(columnSlot) {
        return columnSlot.displayTemplate;
    }
}
RowDisplayTemplatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowDisplayTemplatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
RowDisplayTemplatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowDisplayTemplatePipe, name: "rowDisplayTemplate" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowDisplayTemplatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'rowDisplayTemplate'
                }]
        }] });

class RowEntryPipe {
    transform(timestamp, row) {
        return row.entry;
    }
}
RowEntryPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEntryPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
RowEntryPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEntryPipe, name: "rowEntry" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: RowEntryPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'rowEntry'
                }]
        }] });

class FieldValuePipe {
    transform(timestamp, row, getter) {
        return getter(row.entry);
    }
}
FieldValuePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: FieldValuePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FieldValuePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: FieldValuePipe, name: "fieldValue" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: FieldValuePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'fieldValue'
                }]
        }] });

class DkGridRowComponent {
    constructor(cdr, gridContentStructure, gridEditionConfig, rowEditionDispatcher) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.gridEditionConfig = gridEditionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
        this.changeTimestampSubscription = Subscription.EMPTY;
        this.changeRowEditingSubscription = Subscription.EMPTY;
        this.isThereOuterColumns = false;
        this.isVerticalLineVisible = true;
        this.isRowEditing = false;
        this.rowTimestamp = 0;
        this.unsubscribeAll = new Subject();
    }
    ngOnChanges(changes) {
        if (changes['row']) {
            /**
             * Every time a row instance changes subscribe to the timestampChange observable.
             *
             * We know that every time the timestamp changes, means that the user has updated
             * the given row.
             *
             * The fieldValue pipe reacts over the timestamp value changing.
             */
            this.setChangeTimestampSubscription(this.row);
            // We have to listen if the given row changes to edit mode:
            this.setChangeRowEditingSubscription(this.row);
        }
    }
    ngOnInit() {
        this.panel = this.columnStructure.panel;
        this.horizontalGutterSlot$ = this.columnStructure.onHorizontalGutterSlotChanged$;
        this.gutterSlotAction$ = merge(this.columnStructure.onGutterSlotOverChanged$, this.columnStructure.onGutterSlotResizingChanged$);
        this.outerColumnSlots$ = this.columnStructure.onOuterColumnSlotsChanged$.pipe(tap(outerColumns => this.isThereOuterColumns = outerColumns.length > 0));
        this.visibleDataColumnSlots$ = this.columnStructure.onDataColumnSlotsChanged$.pipe(map(slots => slots.filter(slot => slot.dikeColumn.visible)), tap(slots => {
            if (this.gridEditionConfig.allowEdition && this.row.isEditing) {
                this.rowEditionDispatcher.createRowFormGroup(this.row, this.panel, slots);
            }
        }));
        this.gridContentStructure.onContentRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.contentRowHeightPx = `${value.contentHeight}px`;
            this.contentHorizontalGutterHeightPx = `${value.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.changeTimestampSubscription.unsubscribe();
        this.changeRowEditingSubscription.unsubscribe();
    }
    setChangeTimestampSubscription(row) {
        this.changeTimestampSubscription.unsubscribe();
        this.changeTimestampSubscription = row.timestampChange.subscribe((value) => {
            this.rowTimestamp = value;
            this.cdr.markForCheck();
        });
    }
    setChangeRowEditingSubscription(row) {
        this.changeRowEditingSubscription.unsubscribe();
        this.changeRowEditingSubscription = row.isEditingChange.subscribe((value) => {
            // If the user change the row to edit mode, create the FormGroup:
            if (this.gridEditionConfig.allowEdition && value) {
                this.rowEditionDispatcher.createRowFormGroup(this.row, this.panel, this.columnStructure.getDataColumnSlots().filter(slot => slot.dikeColumn.visible));
            }
            // Update the view:
            this.isRowEditing = value;
            this.cdr.markForCheck();
        });
    }
}
DkGridRowComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }, { token: DkGridEditionConfig }, { token: DkGridRowEditionDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowComponent, selector: "dk-grid-row", inputs: { columnStructure: "columnStructure", row: "row", sourceIndex: "sourceIndex", isVerticalLineVisible: "isVerticalLineVisible" }, host: { classAttribute: "dkg-row" }, usesOnChanges: true, ngImport: i0, template: "<ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n\n    [cellHeight]=\"contentRowHeightPx\"\n    [contentAlign]=\"outerColumnSlot.dikeColumn.contentAlign\">\n\n    <ng-container [ngSwitch]=\"outerColumnSlot.dikeColumn.fieldName\">\n      <ng-container *ngSwitchCase=\"'Row-Index-Column'\"><p>{{ sourceIndex | number }}</p></ng-container>\n      <ng-container *ngSwitchDefault><p>{{ outerColumnSlot.dikeColumn.headerText }}</p></ng-container>\n    </ng-container>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n    [gutterHeight]=\"contentRowHeightPx\"\n    [isEmpty]=\"!isVerticalLineVisible\">\n  </dk-grid-vertical-gutter>\n\n</ng-container>\n\n<ng-container [ngSwitch]=\"panel\">\n\n  <ng-container *ngSwitchCase=\"'rightPanel'\">\n    <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n  </ng-container>\n\n  <ng-container *ngSwitchDefault>\n    <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n  </ng-container>\n\n</ng-container>\n\n<ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n  <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n    <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n    <dk-grid-vertical-gutter\n      dkGridItemPlacement\n      [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\"\n      [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n  </ng-container>\n\n</ng-container>\n\n<ng-template #completeGutter>\n  <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"hgSlot.gridColumnStart\"\n    [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n    [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n</ng-template>\n\n<ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n  <ng-container *ngFor=\"let columnSlot of visibleColumnSlots; last as last;\">\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || !isThereOuterColumns\"\n\n      [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n      [cellHeight]=\"contentRowHeightPx\"\n      [contentAlign]=\"columnSlot.dikeColumn.contentAlign\"\n      [isEditionContainer]=\"isRowEditing && columnSlot.dikeColumn.editable\"\n      [editionControl]=\"isRowEditing && columnSlot.dikeColumn.editable ? (row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId) : null\"\n      [customErrorMessages]=\"isRowEditing && columnSlot.dikeColumn.editable ? columnSlot.editionSettings?.errorMessages : null\">\n\n        <ng-container [ngSwitch]=\"isRowEditing && columnSlot.dikeColumn.editable\">\n\n          <ng-container *ngSwitchCase=\"true\">\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowEditionTemplate; context: { control: row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId, options: columnSlot.editionSettings?.options }\"></ng-container>\n          </ng-container>\n\n          <ng-container *ngSwitchDefault>\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowDisplayTemplate; context: { rowEntry: rowTimestamp | rowEntry:row, fieldValue: rowTimestamp | fieldValue:row:columnSlot.dikeColumn.getValue }\"></ng-container>\n          </ng-container>\n\n        </ng-container>\n\n    </dk-grid-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || last\"\n\n      [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalLineVisible && !last\"\n      [columnStructure]=\"columnStructure\"\n      [columnId]=\"columnSlot.dikeColumn.columnId\"\n      [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n      [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n</ng-template>\n\n<ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n  <ng-container *ngFor=\"let columnSlot of visibleColumnSlots; first as first; last as last;\">\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || (!isThereOuterColumns && first)\"\n\n      [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalLineVisible && (!first || first && isThereOuterColumns)\"\n      [columnStructure]=\"columnStructure\"\n      [columnId]=\"columnSlot.dikeColumn.columnId\"\n      [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n      [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n      [cellHeight]=\"contentRowHeightPx\"\n      [contentAlign]=\"columnSlot.dikeColumn.contentAlign\"\n      [isEditionContainer]=\"isRowEditing && columnSlot.dikeColumn.editable\"\n      [editionControl]=\"isRowEditing && columnSlot.dikeColumn.editable ? (row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId) : null\"\n      [customErrorMessages]=\"isRowEditing && columnSlot.dikeColumn.editable ? columnSlot.editionSettings?.errorMessages : null\">\n\n        <ng-container [ngSwitch]=\"isRowEditing && columnSlot.dikeColumn.editable\">\n\n          <ng-container *ngSwitchCase=\"true\">\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowEditionTemplate; context: { control: row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId, options: columnSlot.editionSettings?.options }\"></ng-container>\n          </ng-container>\n\n          <ng-container *ngSwitchDefault>\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowDisplayTemplate; context: { rowEntry: rowTimestamp | rowEntry:row, fieldValue: rowTimestamp | fieldValue:row:columnSlot.dikeColumn.getValue }\"></ng-container>\n          </ng-container>\n\n        </ng-container>\n\n    </dk-grid-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"last\"\n\n      [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n    </dk-grid-vertical-gutter>\n  </ng-container>\n\n</ng-template>\n", styles: [""], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: DkGridCellComponent, selector: "dk-grid-cell", inputs: ["isColumnOver$", "cellHeight", "contentAlign", "isEditionContainer", "editionControl", "customErrorMessages"] }], directives: [{ type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i8.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: ["dkGridColResizer", "columnStructure", "resizerType", "columnId", "gutterSlot"], exportAs: ["dkgColResizer"] }], pipes: { "async": i8.AsyncPipe, "number": i8.DecimalPipe, "rowFormControlInstance": RowFormControlInstancePipe, "rowEditionTemplate": RowEditionTemplatePipe, "rowDisplayTemplate": RowDisplayTemplatePipe, "rowEntry": RowEntryPipe, "fieldValue": FieldValuePipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row', host: {
                        'class': 'dkg-row'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n\n    [cellHeight]=\"contentRowHeightPx\"\n    [contentAlign]=\"outerColumnSlot.dikeColumn.contentAlign\">\n\n    <ng-container [ngSwitch]=\"outerColumnSlot.dikeColumn.fieldName\">\n      <ng-container *ngSwitchCase=\"'Row-Index-Column'\"><p>{{ sourceIndex | number }}</p></ng-container>\n      <ng-container *ngSwitchDefault><p>{{ outerColumnSlot.dikeColumn.headerText }}</p></ng-container>\n    </ng-container>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n    [gutterHeight]=\"contentRowHeightPx\"\n    [isEmpty]=\"!isVerticalLineVisible\">\n  </dk-grid-vertical-gutter>\n\n</ng-container>\n\n<ng-container [ngSwitch]=\"panel\">\n\n  <ng-container *ngSwitchCase=\"'rightPanel'\">\n    <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n  </ng-container>\n\n  <ng-container *ngSwitchDefault>\n    <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleDataColumnSlots$ | async }\"></ng-container>\n  </ng-container>\n\n</ng-container>\n\n<ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n  <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n    <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n    <dk-grid-vertical-gutter\n      dkGridItemPlacement\n      [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\"\n      [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n      [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n\n  </ng-container>\n\n</ng-container>\n\n<ng-template #completeGutter>\n  <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"hgSlot.gridColumnStart\"\n    [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n    [gutterHeight]=\"contentHorizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n</ng-template>\n\n<ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n  <ng-container *ngFor=\"let columnSlot of visibleColumnSlots; last as last;\">\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || !isThereOuterColumns\"\n\n      [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n      [cellHeight]=\"contentRowHeightPx\"\n      [contentAlign]=\"columnSlot.dikeColumn.contentAlign\"\n      [isEditionContainer]=\"isRowEditing && columnSlot.dikeColumn.editable\"\n      [editionControl]=\"isRowEditing && columnSlot.dikeColumn.editable ? (row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId) : null\"\n      [customErrorMessages]=\"isRowEditing && columnSlot.dikeColumn.editable ? columnSlot.editionSettings?.errorMessages : null\">\n\n        <ng-container [ngSwitch]=\"isRowEditing && columnSlot.dikeColumn.editable\">\n\n          <ng-container *ngSwitchCase=\"true\">\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowEditionTemplate; context: { control: row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId, options: columnSlot.editionSettings?.options }\"></ng-container>\n          </ng-container>\n\n          <ng-container *ngSwitchDefault>\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowDisplayTemplate; context: { rowEntry: rowTimestamp | rowEntry:row, fieldValue: rowTimestamp | fieldValue:row:columnSlot.dikeColumn.getValue }\"></ng-container>\n          </ng-container>\n\n        </ng-container>\n\n    </dk-grid-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || last\"\n\n      [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalLineVisible && !last\"\n      [columnStructure]=\"columnStructure\"\n      [columnId]=\"columnSlot.dikeColumn.columnId\"\n      [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n      [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n</ng-template>\n\n<ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n  <ng-container *ngFor=\"let columnSlot of visibleColumnSlots; first as first; last as last;\">\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"!isVerticalLineVisible || (!isThereOuterColumns && first)\"\n\n      [dkGridColResizer]=\"columnSlot.dikeColumn.resizable && isVerticalLineVisible && (!first || first && isThereOuterColumns)\"\n      [columnStructure]=\"columnStructure\"\n      [columnId]=\"columnSlot.dikeColumn.columnId\"\n      [gutterSlot]=\"columnSlot.dikeGutterSlot\"\n\n      [isColumnOver$]=\"columnSlot.dikeGutterSlot.onColumnOverChanged$\"\n      [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\">\n    </dk-grid-vertical-gutter>\n\n    <dk-grid-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      [isColumnOver$]=\"columnSlot.onColumnOverChanged$\"\n      [cellHeight]=\"contentRowHeightPx\"\n      [contentAlign]=\"columnSlot.dikeColumn.contentAlign\"\n      [isEditionContainer]=\"isRowEditing && columnSlot.dikeColumn.editable\"\n      [editionControl]=\"isRowEditing && columnSlot.dikeColumn.editable ? (row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId) : null\"\n      [customErrorMessages]=\"isRowEditing && columnSlot.dikeColumn.editable ? columnSlot.editionSettings?.errorMessages : null\">\n\n        <ng-container [ngSwitch]=\"isRowEditing && columnSlot.dikeColumn.editable\">\n\n          <ng-container *ngSwitchCase=\"true\">\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowEditionTemplate; context: { control: row.getRowPanelFormGroup(panel) | rowFormControlInstance:columnSlot.slotId, options: columnSlot.editionSettings?.options }\"></ng-container>\n          </ng-container>\n\n          <ng-container *ngSwitchDefault>\n            <ng-container *ngTemplateOutlet=\"columnSlot | rowDisplayTemplate; context: { rowEntry: rowTimestamp | rowEntry:row, fieldValue: rowTimestamp | fieldValue:row:columnSlot.dikeColumn.getValue }\"></ng-container>\n          </ng-container>\n\n        </ng-container>\n\n    </dk-grid-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.complementDikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      [gutterHeight]=\"contentRowHeightPx\"\n      [isEmpty]=\"last\"\n\n      [isColumnOver$]=\"columnSlot.complementDikeGutterSlot.onColumnOverChanged$\">\n    </dk-grid-vertical-gutter>\n  </ng-container>\n\n</ng-template>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }, { type: DkGridEditionConfig }, { type: DkGridRowEditionDispatcher }]; }, propDecorators: { columnStructure: [{
                type: Input
            }], row: [{
                type: Input
            }], sourceIndex: [{
                type: Input
            }], isVerticalLineVisible: [{
                type: Input
            }] } });

class DkGridRowEmptyComponent {
    constructor(cdr, gridContentStructure) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.horizontalGutterSlot$ = this.columnStructure.onHorizontalGutterSlotChanged$;
        this.gridContentStructure.onContentRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.rowHeight = `${value.rowHeight}px`;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridRowEmptyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEmptyComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowEmptyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowEmptyComponent, selector: "dk-grid-row-empty", inputs: { columnStructure: "columnStructure" }, host: { classAttribute: "dkg-row-empty" }, ngImport: i0, template: "<ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"hgSlot.gridColumnStart\"\n    [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n    [cellHeight]=\"rowHeight\">\n\n  </dk-grid-empty-cell>\n</ng-container>\n", styles: [""], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowEmptyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-empty', host: {
                        'class': 'dkg-row-empty'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"hgSlot.gridColumnStart\"\n    [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n    [cellHeight]=\"rowHeight\">\n\n  </dk-grid-empty-cell>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }]; }, propDecorators: { columnStructure: [{
                type: Input
            }] } });

class DkGridRowDirective {
    constructor(cdr, gridContentStructure) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
        this.formatContext = 'grid';
        this.unsubscribeAll = new Subject();
    }
    get display() {
        return this.formatContext;
    }
    get height() {
        return this.rowHeight;
    }
    get gridTemplateColumns() {
        return this.gridTemplateColumnsValue;
    }
    get gridTemplateRows() {
        return this.gridTemplateRowsValue;
    }
    ngOnInit() {
        this.gridContentStructure.onContentRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.rowHeight = `${value.rowHeight}px`;
            this.gridTemplateRowsValue = `${value.contentHeight}px ${value.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
        this.columnStructure.onGridTemplateColumnsContentChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridRowDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowDirective, selector: "[dkGridRow]", inputs: { columnStructure: ["dkGridRow", "columnStructure"] }, host: { properties: { "style.display": "this.display", "style.height": "this.height", "style.grid-template-columns": "this.gridTemplateColumns", "style.grid-template-rows": "this.gridTemplateRows" } }, exportAs: ["dkgRow"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRow]',
                    exportAs: 'dkgRow'
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }]; }, propDecorators: { columnStructure: [{
                type: Input,
                args: ['dkGridRow']
            }], display: [{
                type: HostBinding,
                args: ['style.display']
            }], height: [{
                type: HostBinding,
                args: ['style.height']
            }], gridTemplateColumns: [{
                type: HostBinding,
                args: ['style.grid-template-columns']
            }], gridTemplateRows: [{
                type: HostBinding,
                args: ['style.grid-template-rows']
            }] } });

class DkRowsModule {
}
DkRowsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkRowsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowsModule, declarations: [DkGridRowComponent,
        DkGridRowEmptyComponent,
        DkGridRowDirective,
        FieldValuePipe,
        RowEntryPipe,
        RowDisplayTemplatePipe,
        RowEditionTemplatePipe,
        RowFormControlInstancePipe], imports: [CommonModule,
        DkEditingModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkGridRowComponent,
        DkGridRowEmptyComponent,
        DkGridRowDirective] });
DkRowsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowsModule, imports: [[
            CommonModule,
            DkEditingModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridRowComponent,
                        DkGridRowEmptyComponent,
                        DkGridRowDirective,
                        FieldValuePipe,
                        RowEntryPipe,
                        RowDisplayTemplatePipe,
                        RowEditionTemplatePipe,
                        RowFormControlInstancePipe
                    ],
                    imports: [
                        CommonModule,
                        DkEditingModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridRowComponent,
                        DkGridRowEmptyComponent,
                        DkGridRowDirective
                    ]
                }]
        }] });

class DkPanelDivisionComponent {
    constructor() {
        this.isHeaderDivision = false;
        this.divisionHeight = '';
        this.divisionWidth = '';
        this.divisionWidthResizing = '';
        this.divisionSpaceWidth = '';
    }
    ngOnInit() {
    }
}
DkPanelDivisionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelDivisionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DkPanelDivisionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkPanelDivisionComponent, selector: "dk-panel-division", inputs: { isHeaderDivision: "isHeaderDivision", divisionHeight: "divisionHeight", divisionWidth: "divisionWidth", divisionWidthResizing: "divisionWidthResizing", divisionSpaceWidth: "divisionSpaceWidth", isPanelResizing$: "isPanelResizing$" }, host: { properties: { "style.height": "divisionHeight", "style.width": "divisionSpaceWidth", "class.dkg-panel-division-header": "isHeaderDivision" }, classAttribute: "dkg-panel-division" }, ngImport: i0, template: "<div [ngStyle]=\"{ 'border-right-width': (isPanelResizing$ | async) ?  divisionWidthResizing : divisionWidth }\"\n  [class.dkg-panel-division-normal-line]=\"!(isPanelResizing$ | async)\"\n  [class.dkg-panel-division-resizing-line]=\"(isPanelResizing$ | async)\">\n</div>\n", styles: [".dkg-panel-division{justify-self:center;align-self:center;display:flex;flex-direction:row;justify-content:center}.dkg-panel-division-resizing-line,.dkg-panel-division-normal-line{border-top:0;border-right-style:solid}\n"], directives: [{ type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelDivisionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-panel-division', host: {
                        'class': 'dkg-panel-division',
                        '[style.height]': 'divisionHeight',
                        '[style.width]': 'divisionSpaceWidth',
                        '[class.dkg-panel-division-header]': 'isHeaderDivision'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div [ngStyle]=\"{ 'border-right-width': (isPanelResizing$ | async) ?  divisionWidthResizing : divisionWidth }\"\n  [class.dkg-panel-division-normal-line]=\"!(isPanelResizing$ | async)\"\n  [class.dkg-panel-division-resizing-line]=\"(isPanelResizing$ | async)\">\n</div>\n", styles: [".dkg-panel-division{justify-self:center;align-self:center;display:flex;flex-direction:row;justify-content:center}.dkg-panel-division-resizing-line,.dkg-panel-division-normal-line{border-top:0;border-right-style:solid}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { isHeaderDivision: [{
                type: Input
            }], divisionHeight: [{
                type: Input
            }], divisionWidth: [{
                type: Input
            }], divisionWidthResizing: [{
                type: Input
            }], divisionSpaceWidth: [{
                type: Input
            }], isPanelResizing$: [{
                type: Input
            }] } });

class DkGridPanelsContainerDirective {
    constructor(cdr, contentPanelDispatcher) {
        this.cdr = cdr;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.unsubscribeAll = new Subject();
        this.currentPanelVisibility = this.contentPanelDispatcher.getPanelsVisibilityTruthTable();
        this.isContentPanelContainer = false;
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '1fr 1fr 1fr';
        this.gridTemplateRowsValue = '1fr';
    }
    ngOnInit() {
        this.gridTemplateColumnsPanel$ = this.isContentPanelContainer ? this.contentPanelDispatcher.onGridTemplateContentColumnPanelsChanged$ :
            this.contentPanelDispatcher.onGridTemplateHeaderColumnPanelsChanged$;
        this.gridTemplateColumnsPanel$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.currentPanelVisibility = this.contentPanelDispatcher.getPanelsVisibilityTruthTable();
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridPanelsContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPanelsContainerDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkContentPanelDispatcher }], target: i0.ɵɵFactoryTarget.Directive });
DkGridPanelsContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridPanelsContainerDirective, selector: "[dkGridPanelsContainer]", inputs: { isContentPanelContainer: ["dkGridPanelsContainer", "isContentPanelContainer"] }, host: { properties: { "style.display": "formatContext", "style.grid-template-columns": "gridTemplateColumnsValue", "style.grid-template-rows": "gridTemplateRowsValue" } }, exportAs: ["dkgPanelsContainer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPanelsContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridPanelsContainer]',
                    exportAs: 'dkgPanelsContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkContentPanelDispatcher }]; }, propDecorators: { isContentPanelContainer: [{
                type: Input,
                args: ['dkGridPanelsContainer']
            }] } });

class DkRowPanelsComponent {
    constructor(dikeConfig, contentPanelDispatcher, scrollDispatcher, gridEditionConfig, gridSelectionConfig, rowGroupingConfig, rowGroupingDispatcher) {
        this.dikeConfig = dikeConfig;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.scrollDispatcher = scrollDispatcher;
        this.gridEditionConfig = gridEditionConfig;
        this.gridSelectionConfig = gridSelectionConfig;
        this.rowGroupingConfig = rowGroupingConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.changeScrollingSubscription = Subscription.EMPTY;
        this.isContentContainer = false;
        this.wrapperType = 'content';
        this.unsubscribeAll = new Subject();
        this.currentCdkScrollableSubject = new BehaviorSubject(null);
    }
    ngOnInit() {
        this.onRowGroupingIndent$ = combineLatest([
            this.rowGroupingConfig.onAllowRowGroupingChanged$,
            this.rowGroupingConfig.onDisplayRowGroupingIndentChanged$,
            this.rowGroupingDispatcher.onGroupPanelCardinalityChanged$
        ]).pipe(map(([allowRowGrouping, displayRowGroupingIndent, groupPanelCardinality]) => allowRowGrouping && displayRowGroupingIndent && groupPanelCardinality > 0));
        this.onEditionMode$ = combineLatest([
            this.gridEditionConfig.onAllowEditionChanged$,
            this.gridEditionConfig.onEditionModeChanged$
        ]).pipe(map(([allowEdition, editionMode]) => allowEdition && editionMode));
        this.onAllowSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$;
    }
    ngAfterViewInit() {
        /**
         * Firstly, by default all CdkScrollable containers must be listeners.
         * They are not sent when a scroll event occurs.
         *
         * Deregister all CdkScrollable containers from the ScrollDispatcher service.
         */
        this.scrollablePanels.forEach(cdkScrollablePanel => this.scrollDispatcher.deregister(cdkScrollablePanel));
        /**
         * Secondly, subscribing to the scrolling panel changes will help to
         * store the current CdkScrollable container in the private BehaviorSubject
         * currentCdkScrollableSubject.
         *
         * This will avoid iterating over the QueryList scrollablePanels every time
         * the container, that has the horizontal-scroll bar, needs to be moved.
         */
        this.contentPanelDispatcher.onCurrentScrollingPanelChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => this.currentCdkScrollableSubject.next(!!value ? this.getCdkScrollablePanel(value) : null));
        // Then subscribe to scroll events:
        this.setChangeScrollingSubscription();
    }
    ngAfterViewChecked() {
        // Move the current CdkScrollable to the correct position:
        Promise.resolve().then(() => this.moveCdkScrollable());
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.currentCdkScrollableSubject.next(null);
        this.currentCdkScrollableSubject.complete();
        this.changeScrollingSubscription.unsubscribe();
    }
    moveCdkScrollable() {
        let cdkScrollablePanel = this.currentCdkScrollableSubject.value;
        if (!!cdkScrollablePanel) {
            cdkScrollablePanel.scrollTo({
                left: this.contentPanelDispatcher.getMeasureScrollLeftOffset(this.contentPanelDispatcher.getCurrentHorizontalScrollingPanel())
            });
        }
    }
    getCdkScrollablePanel(panel) {
        return this.scrollablePanels.find(cdkScrollableItem => cdkScrollableItem.getElementRef().nativeElement.attributes.getNamedItem('scrollable-panel-wrapper').value === panel);
    }
    setChangeScrollingSubscription() {
        /**
         * Events could be fired from the DikeGridHorizontalScrolling component or from
         * the header. When the user is dragging a column and the user drags the column
         * beyond the visible area, the horizontal scrolling of the header is moved
         * towards the dragged column.
         *
         * As a first condition, the CdkVirtualScrollViewport vertical scrolling is ignored.
         * Remember that CdkVirtualScrollViewport does not have horizontal scrolling.
         */
        let horizontalScrolling$ = this.scrollDispatcher.scrolled(this.dikeConfig.THROTTLE_SCROLL_TIME).pipe(filter(value => !!value && typeof value !== 'undefined' && !(value instanceof CdkVirtualScrollViewport)), 
        // As a second condition, moving the CdkScrollable instance which fires the event is avoided:
        filter(value => this.currentCdkScrollableSubject.value && this.currentCdkScrollableSubject.value !== value), 
        // Lastly, panels only listen the CdkScrollable which lives in DkGridHorizontalScrollingComponent:
        filter(value => typeof value !== 'undefined' && !!value.getElementRef().nativeElement.attributes.getNamedItem('horizontal-scroll-panel-name')));
        this.changeScrollingSubscription.unsubscribe();
        this.changeScrollingSubscription = horizontalScrolling$.subscribe(value => {
            if (typeof value !== 'undefined') {
                let leftOffset = value.measureScrollOffset('left');
                this.currentCdkScrollableSubject.value.scrollTo({ left: leftOffset });
                this.contentPanelDispatcher.setMeasureScrollLeftOffset(this.contentPanelDispatcher.getCurrentHorizontalScrollingPanel(), leftOffset);
            }
        });
    }
}
DkRowPanelsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowPanelsComponent, deps: [{ token: CONFIG_GRID }, { token: DkContentPanelDispatcher }, { token: i2.ScrollDispatcher }, { token: DkGridEditionConfig }, { token: DkGridSelectionConfig }, { token: DkRowGroupingConfig }, { token: DkRowGroupingDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkRowPanelsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkRowPanelsComponent, selector: "dk-row-panels", inputs: { isContentContainer: "isContentContainer", wrapperType: "wrapperType" }, viewQueries: [{ propertyName: "scrollablePanels", predicate: CdkScrollable, descendants: true }], ngImport: i0, template: "<div class=\"dkg-row-panels-wrapper\" [attr.wrapper-type]=\"wrapperType\"\n  [dkGridPanelsContainer]=\"isContentContainer\"\n  #gridPanelsContainer=\"dkgPanelsContainer\">\n\n  <!-- row grouping indent -->\n  <ng-container *ngIf=\"onRowGroupingIndent$ | async\">\n    <ng-content select=\"[row-grouping-indent]\"></ng-content>\n  </ng-container>\n\n  <!-- row selection checkbox -->\n  <ng-container *ngIf=\"onAllowSelection$ | async\">\n    <ng-content select=\"[row-checkbox-selection]\"></ng-content>\n  </ng-container>\n\n  <!-- row edition menu -->\n  <ng-container *ngIf=\"onEditionMode$ | async\">\n    <ng-content select=\"[row-edition-menu]\"></ng-content>\n  </ng-container>\n\n  <!-- left-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.leftPanel.onColumnSetVisibilityChanged$ | async\">\n    <div class=\"dkg-left-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.leftPanel.panel\">\n\n      <ng-content select=\"[left-panel]\"></ng-content>\n    </div>\n\n    <ng-container *ngIf=\"gridPanelsContainer.currentPanelVisibility.LC || gridPanelsContainer.currentPanelVisibility.LCR\">\n      <ng-content select=\"[left-panel-right-division]\"></ng-content>\n    </ng-container>\n  </ng-container>\n\n  <!-- center-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.centerPanel.onColumnSetVisibilityChanged$ | async\">\n    <div class=\"dkg-center-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.centerPanel.panel\">\n\n      <ng-content select=\"[center-panel]\"></ng-content>\n    </div>\n  </ng-container>\n\n  <!-- right-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.rightPanel.onColumnSetVisibilityChanged$ | async\">\n    <ng-container *ngIf=\"!gridPanelsContainer.currentPanelVisibility.R\">\n      <ng-content select=\"[right-panel-left-division]\"></ng-content>\n    </ng-container>\n\n    <div class=\"dkg-right-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.rightPanel.panel\">\n\n      <ng-content select=\"[right-panel]\"></ng-content>\n    </div>\n  </ng-container>\n</div>\n", styles: [".dkg-row-panels-wrapper{height:100%;width:100%}.dkg-left-panel-wrapper,.dkg-center-panel-wrapper,.dkg-right-panel-wrapper{overflow:hidden}.dkg-left-panel-wrapper::-webkit-scrollbar,.dkg-center-panel-wrapper::-webkit-scrollbar,.dkg-right-panel-wrapper::-webkit-scrollbar{display:none}\n"], directives: [{ type: DkGridPanelsContainerDirective, selector: "[dkGridPanelsContainer]", inputs: ["dkGridPanelsContainer"], exportAs: ["dkgPanelsContainer"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.CdkScrollable, selector: "[cdk-scrollable], [cdkScrollable]" }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowPanelsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-row-panels', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-panels-wrapper\" [attr.wrapper-type]=\"wrapperType\"\n  [dkGridPanelsContainer]=\"isContentContainer\"\n  #gridPanelsContainer=\"dkgPanelsContainer\">\n\n  <!-- row grouping indent -->\n  <ng-container *ngIf=\"onRowGroupingIndent$ | async\">\n    <ng-content select=\"[row-grouping-indent]\"></ng-content>\n  </ng-container>\n\n  <!-- row selection checkbox -->\n  <ng-container *ngIf=\"onAllowSelection$ | async\">\n    <ng-content select=\"[row-checkbox-selection]\"></ng-content>\n  </ng-container>\n\n  <!-- row edition menu -->\n  <ng-container *ngIf=\"onEditionMode$ | async\">\n    <ng-content select=\"[row-edition-menu]\"></ng-content>\n  </ng-container>\n\n  <!-- left-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.leftPanel.onColumnSetVisibilityChanged$ | async\">\n    <div class=\"dkg-left-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.leftPanel.panel\">\n\n      <ng-content select=\"[left-panel]\"></ng-content>\n    </div>\n\n    <ng-container *ngIf=\"gridPanelsContainer.currentPanelVisibility.LC || gridPanelsContainer.currentPanelVisibility.LCR\">\n      <ng-content select=\"[left-panel-right-division]\"></ng-content>\n    </ng-container>\n  </ng-container>\n\n  <!-- center-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.centerPanel.onColumnSetVisibilityChanged$ | async\">\n    <div class=\"dkg-center-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.centerPanel.panel\">\n\n      <ng-content select=\"[center-panel]\"></ng-content>\n    </div>\n  </ng-container>\n\n  <!-- right-panel -->\n  <ng-container *ngIf=\"contentPanelDispatcher.rightPanel.onColumnSetVisibilityChanged$ | async\">\n    <ng-container *ngIf=\"!gridPanelsContainer.currentPanelVisibility.R\">\n      <ng-content select=\"[right-panel-left-division]\"></ng-content>\n    </ng-container>\n\n    <div class=\"dkg-right-panel-wrapper\" cdkScrollable\n      [attr.scrollable-panel-wrapper]=\"contentPanelDispatcher.rightPanel.panel\">\n\n      <ng-content select=\"[right-panel]\"></ng-content>\n    </div>\n  </ng-container>\n</div>\n", styles: [".dkg-row-panels-wrapper{height:100%;width:100%}.dkg-left-panel-wrapper,.dkg-center-panel-wrapper,.dkg-right-panel-wrapper{overflow:hidden}.dkg-left-panel-wrapper::-webkit-scrollbar,.dkg-center-panel-wrapper::-webkit-scrollbar,.dkg-right-panel-wrapper::-webkit-scrollbar{display:none}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkContentPanelDispatcher }, { type: i2.ScrollDispatcher }, { type: DkGridEditionConfig }, { type: DkGridSelectionConfig }, { type: DkRowGroupingConfig }, { type: DkRowGroupingDispatcher }];
    }, propDecorators: { isContentContainer: [{
                type: Input
            }], wrapperType: [{
                type: Input
            }], scrollablePanels: [{
                type: ViewChildren,
                args: [CdkScrollable]
            }] } });

class DkPanelsModule {
}
DkPanelsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkPanelsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelsModule, declarations: [DkPanelDivisionComponent,
        DkRowPanelsComponent,
        DkGridPanelsContainerDirective], imports: [CommonModule,
        ScrollingModule], exports: [DkPanelDivisionComponent,
        DkRowPanelsComponent] });
DkPanelsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelsModule, imports: [[
            CommonModule,
            ScrollingModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPanelsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkPanelDivisionComponent,
                        DkRowPanelsComponent,
                        DkGridPanelsContainerDirective
                    ],
                    imports: [
                        CommonModule,
                        ScrollingModule
                    ],
                    exports: [
                        DkPanelDivisionComponent,
                        DkRowPanelsComponent
                    ]
                }]
        }] });

class DkGridSorting {
    constructor(sortDispatcher, gridColumnDef) {
        this.sortDispatcher = sortDispatcher;
        this.gridColumnDef = gridColumnDef;
        this.changeDataSortSubscription = Subscription.EMPTY;
        this.setChangeDataSortSubscription();
    }
    get sortChange() {
        return this.sortDispatcher.sortChangeEmitter.asObservable();
    }
    ngOnDestroy() {
        this.changeDataSortSubscription.unsubscribe();
    }
    sortBy(column, direction) {
        const columnDef = this.gridColumnDef.findColumn(col => col.columnId === column.columnId);
        /**
         * 1. The given column exist.
         * 2. Sorting operation is allowed.
         * 3. The given column is a data column and is sortable.
         */
        if (!!columnDef && this.sortDispatcher.allowSorting && isDkDataColumnDef(columnDef) && columnDef.sortable) {
            // Get the sortable from the MatSort directive:
            const matSortable = this.sortDispatcher.dataSort.sortables.get(columnDef.columnId);
            /**
             * Even though the given column exists and is sortable, its corresponding MatSortable does not
             * exist in the sortables Map. The MatSortable does not exist in the Map because the given
             * data column could belong to a column group and it is not visible.
             *
             * In general, despite a data column exists in the double linked-list and is sortable,
             * if the column is non-visible the column will not exist in the Map sortables.
             */
            if (!!matSortable) {
                // Does the DikeGrid is sorted by the given data column?:
                const isActiveSorted = this.sortDispatcher.isColumnActiveSortable(columnDef.columnId);
                /**
                 * When are we going to sort?
                 *
                 *  1.  If the DikeGrid is not sorted by the given data column.
                 *
                 *  2.  When the DikeGrid is sorted by the given data column, but the direction
                 *      param is different from the current sort direction.
                 */
                if (!this.sortDispatcher.isColumnActiveSortable(columnDef.columnId) || this.sortDispatcher.dataSort.direction !== direction) {
                    // This allow to toggle between 'asc' and 'desc' direction:
                    matSortable.disableClear = true;
                    // If the DikeGrid is not sorted by the given data column, set the initial direction:
                    if (!isActiveSorted) {
                        matSortable.start = direction;
                    }
                    // Sort by the given data column:
                    this.sortDispatcher.dataSort.sort(matSortable);
                    // Turn off the disableClear flag:
                    setTimeout(() => matSortable.disableClear = false, 0);
                }
            }
        }
    }
    isDikeGridSortedBy(column) {
        return this.sortDispatcher.isColumnActiveSortable(column.columnId);
    }
    getCurrentSortable() {
        var _a, _b;
        return this.getCurrentDikeColumnSorted({
            active: (_a = this.sortDispatcher.dataSort) === null || _a === void 0 ? void 0 : _a.active,
            direction: (_b = this.sortDispatcher.dataSort) === null || _b === void 0 ? void 0 : _b.direction
        });
    }
    clearSorting() {
        if (this.sortDispatcher.allowSorting) {
            this.sortDispatcher.clearSorting();
        }
    }
    getCurrentDikeColumnSorted(currentSort) {
        let sortByColumn = null;
        if (!!currentSort.active && currentSort.active !== '' && currentSort.direction !== '') {
            // Get the column instance:
            const dataColumnDef = this.gridColumnDef.findColumn(column => column.columnId === currentSort.active);
            sortByColumn = {
                type: currentSort.direction,
                sortedColumn: DkDataColumnDef.getDataColumnDefInstance(dataColumnDef.fieldName, dataColumnDef.headerText, dataColumnDef.dataType).assign(dataColumnDef)
            };
        }
        return sortByColumn;
    }
    setChangeDataSortSubscription() {
        const dataSort$ = this.sortDispatcher.onDataSortChanged$.pipe(switchMap(dataSort => !!dataSort ? dataSort.sortChange : NEVER));
        this.changeDataSortSubscription.unsubscribe();
        this.changeDataSortSubscription = dataSort$.subscribe(sortBy => {
            let sortByColumn = null;
            if (!!sortBy.active && sortBy.active !== '' && sortBy.direction !== '') {
                sortByColumn = this.getCurrentDikeColumnSorted({
                    active: sortBy.active,
                    direction: sortBy.direction
                });
            }
            this.sortDispatcher.sortChangeEmitter.emit(sortByColumn);
        });
    }
}
DkGridSorting.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSorting, deps: [{ token: DkSortDispatcher }, { token: DkGridColumnDef }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridSorting.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSorting });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridSorting, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkSortDispatcher }, { type: DkGridColumnDef }]; } });

class DkColumnSortingComponent {
    constructor(gridSorting, sortDispatcher, gridFactoryColumns) {
        this.gridSorting = gridSorting;
        this.sortDispatcher = sortDispatcher;
        this.gridFactoryColumns = gridFactoryColumns;
        this.ascSorting = 'asc';
        this.descSorting = 'desc';
    }
    ngOnInit() {
        this.dataColumnDef = this.gridFactoryColumns.createDikeDataColumnDefFromColumnSlot(this.columnSlot);
        this.selectedSorting = this.sortDispatcher.isColumnActiveSortable(this.columnSlot.dikeColumn.columnId) ? this.sortDispatcher.dataSort.direction : '';
    }
    onRadioSortingGroupChanged(event) {
        this.gridSorting.sortBy(this.dataColumnDef, event.value);
    }
}
DkColumnSortingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnSortingComponent, deps: [{ token: DkGridSorting }, { token: DkSortDispatcher }, { token: DkGridFactoryColumns }], target: i0.ɵɵFactoryTarget.Component });
DkColumnSortingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkColumnSortingComponent, selector: "dk-column-sorting", inputs: { columnSlot: "columnSlot" }, host: { classAttribute: "dkg-column-sorting" }, exportAs: ["dkgColumnSorting"], ngImport: i0, template: "<mat-radio-group class=\"dkg-column-sorting-container\"\n  [value]=\"selectedSorting\"\n  (change)=\"onRadioSortingGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-sorting-option\" [value]=\"ascSorting\">\n    <div class=\"dkg-column-sorting-option-content\">\n      <mat-icon>\n        arrow_upward\n      </mat-icon>\n      <label>asc</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-sorting-option\" [value]=\"descSorting\">\n    <div class=\"dkg-column-sorting-option-content\">\n      <mat-icon>\n        arrow_downward\n      </mat-icon>\n      <label>desc</label>\n    </div>\n\n  </mat-radio-button>\n\n</mat-radio-group>\n\n", styles: [".dkg-column-sorting{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-column-sorting-container{display:flex;flex-flow:row wrap;justify-content:space-between;margin:7px 0}.dkg-column-sorting-option{margin:13px}.dkg-column-sorting-option-content{display:flex;flex-direction:row;justify-content:space-around}.dkg-column-sorting-option-content label{padding-left:7px;font-style:italic}\n"], components: [{ type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnSortingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-column-sorting', exportAs: 'dkgColumnSorting', host: {
                        'class': 'dkg-column-sorting'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-radio-group class=\"dkg-column-sorting-container\"\n  [value]=\"selectedSorting\"\n  (change)=\"onRadioSortingGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-sorting-option\" [value]=\"ascSorting\">\n    <div class=\"dkg-column-sorting-option-content\">\n      <mat-icon>\n        arrow_upward\n      </mat-icon>\n      <label>asc</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-sorting-option\" [value]=\"descSorting\">\n    <div class=\"dkg-column-sorting-option-content\">\n      <mat-icon>\n        arrow_downward\n      </mat-icon>\n      <label>desc</label>\n    </div>\n\n  </mat-radio-button>\n\n</mat-radio-group>\n\n", styles: [".dkg-column-sorting{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-column-sorting-container{display:flex;flex-flow:row wrap;justify-content:space-between;margin:7px 0}.dkg-column-sorting-option{margin:13px}.dkg-column-sorting-option-content{display:flex;flex-direction:row;justify-content:space-around}.dkg-column-sorting-option-content label{padding-left:7px;font-style:italic}\n"] }]
        }], ctorParameters: function () { return [{ type: DkGridSorting }, { type: DkSortDispatcher }, { type: DkGridFactoryColumns }]; }, propDecorators: { columnSlot: [{
                type: Input
            }] } });

class SortAlternativeColumnIdPipe {
    constructor(sortDispatcher) {
        this.sortDispatcher = sortDispatcher;
    }
    transform(columnId) {
        return this.sortDispatcher.getSortAlternativeColumnId(columnId);
    }
}
SortAlternativeColumnIdPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SortAlternativeColumnIdPipe, deps: [{ token: DkSortDispatcher }], target: i0.ɵɵFactoryTarget.Pipe });
SortAlternativeColumnIdPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SortAlternativeColumnIdPipe, name: "sortAlternativeColumnId" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SortAlternativeColumnIdPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sortAlternativeColumnId'
                }]
        }], ctorParameters: function () { return [{ type: DkSortDispatcher }]; } });

class DkSortingModule {
}
DkSortingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkSortingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortingModule, declarations: [DkColumnSortingComponent,
        SortAlternativeColumnIdPipe], imports: [CommonModule,
        MatIconModule,
        MatRadioModule], exports: [DkColumnSortingComponent,
        SortAlternativeColumnIdPipe] });
DkSortingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortingModule, imports: [[
            CommonModule,
            MatIconModule,
            MatRadioModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSortingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkColumnSortingComponent,
                        SortAlternativeColumnIdPipe
                    ],
                    imports: [
                        CommonModule,
                        MatIconModule,
                        MatRadioModule
                    ],
                    exports: [
                        DkColumnSortingComponent,
                        SortAlternativeColumnIdPipe
                    ]
                }]
        }] });

class DkContextMenuRef {
    constructor(overlayRef) {
        this.overlayRef = overlayRef;
        this.closeSubject = new Subject();
        this.overlayRef.keydownEvents().pipe(filter(value => value.key === 'Escape'), takeUntil(this.closeSubject)).subscribe(() => {
            this.close();
        });
    }
    close() {
        this.overlayRef.dispose();
        this.closeSubject.next();
    }
    get afterClosed$() {
        return this.closeSubject.asObservable();
    }
}

class DkColumnChooserComponent {
    constructor(cdr, gridColumnDef) {
        this.cdr = cdr;
        this.gridColumnDef = gridColumnDef;
        this.treeControl = new NestedTreeControl(node => isDkGroupColumnDef(node.column) ? node.children : null);
        this.dataSource = new MatTreeNestedDataSource();
        this.changesDikeColumnsSubscription = Subscription.EMPTY;
    }
    ngOnInit() {
        this.setChangeDikeColumnsSubscription();
    }
    ngOnDestroy() {
        this.changesDikeColumnsSubscription.unsubscribe();
    }
    hasChild(_, node) {
        if (isDkGroupColumnDef(node.column)) {
            return !!node.column.children && node.column.children.length > 0;
        }
        return false;
    }
    onCheckboxChange(event) {
        let currentNode = event.source.value;
        // Firstly, change checkbox's status locally:
        if (currentNode.column.columnId !== this.columnId) {
            currentNode.column.visible = event.checked;
            this.changeChildrenVisibility(currentNode, event.checked);
            this.changeParentVisibility(currentNode.parent);
            // Then update the source (linked-list of columns):
            this.gridColumnDef.setColumnVisible(currentNode.column, event.checked);
        }
        else {
            event.source.checked = !event.checked;
        }
    }
    changeChildrenVisibility(node, isVisible) {
        if (node.children && node.children.length > 0) {
            node.children.forEach(child => {
                child.column.visible = isVisible;
                this.changeChildrenVisibility(child, isVisible);
            });
        }
    }
    changeParentVisibility(parent) {
        if (parent === null || parent === undefined) {
            return;
        }
        if (parent.children && parent.children.length > 0) {
            let isVisible = false;
            parent.children.forEach(child => {
                isVisible = !isVisible ? child.column.visible : isVisible;
            });
            parent.column.visible = isVisible;
            this.changeParentVisibility(parent.parent);
        }
    }
    setChangeDikeColumnsSubscription() {
        const linkedColumns$ = merge(this.gridColumnDef.columnsChange, of(this.gridColumnDef.getColumns())).pipe(map(columns => this.gridColumnDef.getLinkedColumns(columns)));
        this.changesDikeColumnsSubscription.unsubscribe();
        this.changesDikeColumnsSubscription = linkedColumns$.subscribe(columns => {
            if (this.dataSource.data.length !== columns.length) {
                this.dataSource.data = columns;
                this.cdr.markForCheck();
            }
        });
    }
}
DkColumnChooserComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnChooserComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridColumnDef }], target: i0.ɵɵFactoryTarget.Component });
DkColumnChooserComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkColumnChooserComponent, selector: "dk-column-chooser", inputs: { columnId: "columnId" }, host: { classAttribute: "dkg-column-chooser" }, ngImport: i0, template: "<mat-tree class=\"dkg-column-chooser-tree\"\n  [dataSource]=\"dataSource\"\n  [treeControl]=\"treeControl\">\n\n  <!-- This is the tree node template for leaf nodes -->\n  <mat-tree-node *matTreeNodeDef=\"let node\" matTreeNodeToggle>\n    <li class=\"mat-tree-node\">\n      <!-- use a disabled button to provide padding for tree leaf -->\n      <button mat-icon-button disabled></button>\n      <mat-checkbox\n        [value]=\"node\"\n        [checked]=\"node.column.visible\"\n        (change)=\"onCheckboxChange($event)\">{{ node.column.headerText }}</mat-checkbox>\n      <button mat-icon-button disabled>\n        <mat-icon\n          [color]=\"node.column.displayOn === 'closed' ? 'accent' : 'primary'\">\n          {{ node.column.belongToGroup !== 'root-group' && node.column.displayOn === 'closed' ? 'fiber_manual_record' : '' }}\n        </mat-icon>\n      </button>\n    </li>\n  </mat-tree-node>\n  <!-- This is the tree node template for expandable nodes -->\n  <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasChild\">\n    <li>\n      <div class=\"mat-tree-node\">\n        <button mat-icon-button matTreeNodeToggle>\n          <mat-icon class=\"mat-icon-rtl-mirror\">\n            {{ treeControl.isExpanded(node) ? 'expand_more' : 'chevron_right' }}\n          </mat-icon>\n        </button>\n        <mat-checkbox\n          [value]=\"node\"\n          [checked]=\"node.column.visible\"\n          (change)=\"onCheckboxChange($event)\">{{ node.column.headerText }}</mat-checkbox>\n        <button mat-icon-button disabled>\n          <mat-icon\n            [color]=\"node.column.displayOn === 'closed' ? 'accent' : 'primary'\">\n            {{ node.column.belongToGroup !== 'root-group' && node.column.displayOn === 'closed' ? 'fiber_manual_record' : '' }}\n          </mat-icon>\n        </button>\n      </div>\n      <ul [class.dkg-column-chooser-tree-invisible]=\"!treeControl.isExpanded(node)\">\n        <ng-container matTreeNodeOutlet></ng-container>\n      </ul>\n    </li>\n  </mat-nested-tree-node>\n</mat-tree>\n", styles: [".dkg-column-chooser-tree-invisible{display:none}.dkg-column-chooser-tree ul{-webkit-padding-start:40px;padding-inline-start:40px}.dkg-column-chooser-tree ul,.dkg-column-chooser-tree li{margin-top:0;margin-bottom:0;list-style-type:none}\n"], components: [{ type: i2$1.MatTree, selector: "mat-tree", exportAs: ["matTree"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i2$1.MatTreeNodeDef, selector: "[matTreeNodeDef]", inputs: ["matTreeNodeDefWhen", "matTreeNode"] }, { type: i2$1.MatTreeNode, selector: "mat-tree-node", inputs: ["role", "disabled", "tabIndex"], exportAs: ["matTreeNode"] }, { type: i2$1.MatTreeNodeToggle, selector: "[matTreeNodeToggle]", inputs: ["matTreeNodeToggleRecursive"] }, { type: i2$1.MatNestedTreeNode, selector: "mat-nested-tree-node", inputs: ["role", "disabled", "tabIndex", "matNestedTreeNode"], exportAs: ["matNestedTreeNode"] }, { type: i2$1.MatTreeNodeOutlet, selector: "[matTreeNodeOutlet]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnChooserComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-column-chooser', host: {
                        'class': 'dkg-column-chooser'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-tree class=\"dkg-column-chooser-tree\"\n  [dataSource]=\"dataSource\"\n  [treeControl]=\"treeControl\">\n\n  <!-- This is the tree node template for leaf nodes -->\n  <mat-tree-node *matTreeNodeDef=\"let node\" matTreeNodeToggle>\n    <li class=\"mat-tree-node\">\n      <!-- use a disabled button to provide padding for tree leaf -->\n      <button mat-icon-button disabled></button>\n      <mat-checkbox\n        [value]=\"node\"\n        [checked]=\"node.column.visible\"\n        (change)=\"onCheckboxChange($event)\">{{ node.column.headerText }}</mat-checkbox>\n      <button mat-icon-button disabled>\n        <mat-icon\n          [color]=\"node.column.displayOn === 'closed' ? 'accent' : 'primary'\">\n          {{ node.column.belongToGroup !== 'root-group' && node.column.displayOn === 'closed' ? 'fiber_manual_record' : '' }}\n        </mat-icon>\n      </button>\n    </li>\n  </mat-tree-node>\n  <!-- This is the tree node template for expandable nodes -->\n  <mat-nested-tree-node *matTreeNodeDef=\"let node; when: hasChild\">\n    <li>\n      <div class=\"mat-tree-node\">\n        <button mat-icon-button matTreeNodeToggle>\n          <mat-icon class=\"mat-icon-rtl-mirror\">\n            {{ treeControl.isExpanded(node) ? 'expand_more' : 'chevron_right' }}\n          </mat-icon>\n        </button>\n        <mat-checkbox\n          [value]=\"node\"\n          [checked]=\"node.column.visible\"\n          (change)=\"onCheckboxChange($event)\">{{ node.column.headerText }}</mat-checkbox>\n        <button mat-icon-button disabled>\n          <mat-icon\n            [color]=\"node.column.displayOn === 'closed' ? 'accent' : 'primary'\">\n            {{ node.column.belongToGroup !== 'root-group' && node.column.displayOn === 'closed' ? 'fiber_manual_record' : '' }}\n          </mat-icon>\n        </button>\n      </div>\n      <ul [class.dkg-column-chooser-tree-invisible]=\"!treeControl.isExpanded(node)\">\n        <ng-container matTreeNodeOutlet></ng-container>\n      </ul>\n    </li>\n  </mat-nested-tree-node>\n</mat-tree>\n", styles: [".dkg-column-chooser-tree-invisible{display:none}.dkg-column-chooser-tree ul{-webkit-padding-start:40px;padding-inline-start:40px}.dkg-column-chooser-tree ul,.dkg-column-chooser-tree li{margin-top:0;margin-bottom:0;list-style-type:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridColumnDef }]; }, propDecorators: { columnId: [{
                type: Input
            }] } });

class DkColumnPinningComponent {
    constructor(gridConfig, gridPanelDispatcher, contentPanelDispatcher, rowGroupingConfig) {
        this.gridConfig = gridConfig;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.rowGroupingConfig = rowGroupingConfig;
        this.moveColumn = new EventEmitter();
        this.leftPanelOption = 'leftPanel';
        this.centerPanelOption = 'centerPanel';
        this.rightPanelOption = 'rightPanel';
        this.groupPanelOption = 'groupPanel';
        this.movable = false;
        this.groupable = false;
        this.allowLocking = false;
        this.allowRowGrouping = false;
        this.isColumnGroup = false;
    }
    ngOnChanges(changes) {
        if (changes['columnSlot']) {
            this.panel = this.columnSlot.dikeColumn.panel;
            this.movable = this.columnSlot.dikeColumn.draggable && !this.columnSlot.dikeColumn.locked;
            this.groupable = this.columnSlot.dikeColumn.groupable;
            this.allowLocking = this.gridConfig.allowColumnDragging && this.columnSlot.dikeColumn.draggable;
            this.isColumnGroup = this.columnSlot.dikeColumn.columnType === 'Group-Column';
        }
    }
    ngOnInit() {
        this.selectedOption = this.panel;
        /**
         * Remember that row-grouping allowable is set at the creation phase.
         * Therefore, it is not necessary listen to the Observable, just take
         * the created flag value.
         */
        this.allowRowGrouping = this.rowGroupingConfig.allowRowGrouping;
    }
    onRadioLockedGroupChanged(event) {
        this.contentPanelDispatcher.setColumnSlotLocking(this.columnSlot, event.value);
        /**
         * This is a workaround.
         *
         * The movable variable must change reactively.
         */
        this.movable = this.columnSlot.dikeColumn.draggable && !event.value;
    }
    onRadioPanelGroupChanged(event) {
        if (event.value !== '') {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(this.columnSlot, this.gridPanelDispatcher.gridPanels[this.panel], this.gridPanelDispatcher.gridPanels[event.value]);
            this.moveColumn.emit(true);
        }
    }
}
DkColumnPinningComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnPinningComponent, deps: [{ token: DkGridConfig }, { token: DkGridPanelDispatcher }, { token: DkContentPanelDispatcher }, { token: DkRowGroupingConfig }], target: i0.ɵɵFactoryTarget.Component });
DkColumnPinningComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkColumnPinningComponent, selector: "dk-column-pinning", inputs: { columnSlot: "columnSlot" }, outputs: { moveColumn: "moveColumn" }, host: { classAttribute: "dkg-column-pinning" }, exportAs: ["dkgColumnPinning"], usesOnChanges: true, ngImport: i0, template: "<mat-radio-group *ngIf=\"allowLocking\"\n  class=\"dkg-column-locking-container\"\n  [value]=\"columnSlot.dikeColumn.locked\"\n  (change)=\"onRadioLockedGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-locking-option\" [value]=\"false\">\n    <div class=\"dkg-column-locking-option-content\">\n      <mat-icon>lock_open</mat-icon>\n      <label>unlock</label>\n    </div>\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-locking-option\" [value]=\"true\">\n    <div class=\"dkg-column-locking-option-content\">\n      <mat-icon>lock</mat-icon>\n      <label>lock</label>\n    </div>\n  </mat-radio-button>\n\n</mat-radio-group>\n\n<mat-divider *ngIf=\"allowLocking\"></mat-divider>\n\n<mat-radio-group class=\"dkg-column-pinning-container\"\n  [value]=\"selectedOption\"\n  (change)=\"onRadioPanelGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"leftPanelOption\"\n    [disabled]=\"!(panel === leftPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M18.378,1.062H3.855c-0.309,0-0.559,0.25-0.559,0.559c0,0.309,0.25,0.559,0.559,0.559h13.964v13.964\n            c0,0.309,0.25,0.559,0.559,0.559c0.31,0,0.56-0.25,0.56-0.559V1.621C18.938,1.312,18.688,1.062,18.378,1.062z M16.144,3.296H1.621\n            c-0.309,0-0.559,0.25-0.559,0.559v14.523c0,0.31,0.25,0.56,0.559,0.56h14.523c0.309,0,0.559-0.25,0.559-0.56V3.855\n            C16.702,3.546,16.452,3.296,16.144,3.296z M15.586,17.262c0,0.31-0.25,0.558-0.56,0.558H2.738c-0.309,0-0.559-0.248-0.559-0.558\n            V4.972c0-0.309,0.25-0.559,0.559-0.559h12.289c0.31,0,0.56,0.25,0.56,0.559V17.262z\"></path>\n        </svg>\n      </mat-icon>\n      <label>left panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"centerPanelOption\"\n    [disabled]=\"!(panel === centerPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M5.029,1.734h10.935c0.317,0,0.575-0.257,0.575-0.575s-0.258-0.576-0.575-0.576H5.029\n            c-0.318,0-0.576,0.258-0.576,0.576S4.711,1.734,5.029,1.734z M1,5.188V19h18.417V5.188H1z M18.266,17.849H2.151V6.338h16.115\n            V17.849z M2.727,4.036H17.69c0.317,0,0.575-0.257,0.575-0.576c0-0.318-0.258-0.575-0.575-0.575H2.727\n            c-0.318,0-0.576,0.257-0.576,0.575C2.151,3.779,2.409,4.036,2.727,4.036z\"></path>\n        </svg>\n      </mat-icon>\n      <label>center panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"rightPanelOption\"\n    [disabled]=\"!(panel === rightPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M18.378,1.062H3.855c-0.309,0-0.559,0.25-0.559,0.559c0,0.309,0.25,0.559,0.559,0.559h13.964v13.964\n            c0,0.309,0.25,0.559,0.559,0.559c0.31,0,0.56-0.25,0.56-0.559V1.621C18.938,1.312,18.688,1.062,18.378,1.062z M16.144,3.296H1.621\n            c-0.309,0-0.559,0.25-0.559,0.559v14.523c0,0.31,0.25,0.56,0.559,0.56h14.523c0.309,0,0.559-0.25,0.559-0.56V3.855\n            C16.702,3.546,16.452,3.296,16.144,3.296z M15.586,17.262c0,0.31-0.25,0.558-0.56,0.558H2.738c-0.309,0-0.559-0.248-0.559-0.558\n            V4.972c0-0.309,0.25-0.559,0.559-0.559h12.289c0.31,0,0.56,0.25,0.56,0.559V17.262z\"></path>\n        </svg>\n      </mat-icon>\n      <label>right panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button *ngIf=\"allowRowGrouping && !isColumnGroup\"\n    class=\"dkg-column-pinning-option\"\n    [value]=\"groupPanelOption\"\n    [disabled]=\"!(panel === groupPanelOption || (movable && groupable))\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>toc</mat-icon>\n      <label>group panel</label>\n    </div>\n\n  </mat-radio-button>\n\n</mat-radio-group>\n\n", styles: [".dkg-column-pinning{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-column-locking-container,.dkg-column-pinning-container{display:flex;flex-flow:row wrap;justify-content:space-between;margin:7px 0}.dkg-column-locking-option,.dkg-column-pinning-option{margin:13px}.dkg-column-locking-option-content,.dkg-column-pinning-option-content{display:flex;flex-direction:row;justify-content:space-around}.dkg-column-locking-option-content label,.dkg-column-pinning-option-content label{padding-left:7px}\n"], components: [{ type: i3$1.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i7$2.MatDivider, selector: "mat-divider", inputs: ["vertical", "inset"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3$1.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnPinningComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-column-pinning', exportAs: 'dkgColumnPinning', host: {
                        'class': 'dkg-column-pinning'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-radio-group *ngIf=\"allowLocking\"\n  class=\"dkg-column-locking-container\"\n  [value]=\"columnSlot.dikeColumn.locked\"\n  (change)=\"onRadioLockedGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-locking-option\" [value]=\"false\">\n    <div class=\"dkg-column-locking-option-content\">\n      <mat-icon>lock_open</mat-icon>\n      <label>unlock</label>\n    </div>\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-locking-option\" [value]=\"true\">\n    <div class=\"dkg-column-locking-option-content\">\n      <mat-icon>lock</mat-icon>\n      <label>lock</label>\n    </div>\n  </mat-radio-button>\n\n</mat-radio-group>\n\n<mat-divider *ngIf=\"allowLocking\"></mat-divider>\n\n<mat-radio-group class=\"dkg-column-pinning-container\"\n  [value]=\"selectedOption\"\n  (change)=\"onRadioPanelGroupChanged($event)\">\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"leftPanelOption\"\n    [disabled]=\"!(panel === leftPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M18.378,1.062H3.855c-0.309,0-0.559,0.25-0.559,0.559c0,0.309,0.25,0.559,0.559,0.559h13.964v13.964\n            c0,0.309,0.25,0.559,0.559,0.559c0.31,0,0.56-0.25,0.56-0.559V1.621C18.938,1.312,18.688,1.062,18.378,1.062z M16.144,3.296H1.621\n            c-0.309,0-0.559,0.25-0.559,0.559v14.523c0,0.31,0.25,0.56,0.559,0.56h14.523c0.309,0,0.559-0.25,0.559-0.56V3.855\n            C16.702,3.546,16.452,3.296,16.144,3.296z M15.586,17.262c0,0.31-0.25,0.558-0.56,0.558H2.738c-0.309,0-0.559-0.248-0.559-0.558\n            V4.972c0-0.309,0.25-0.559,0.559-0.559h12.289c0.31,0,0.56,0.25,0.56,0.559V17.262z\"></path>\n        </svg>\n      </mat-icon>\n      <label>left panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"centerPanelOption\"\n    [disabled]=\"!(panel === centerPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M5.029,1.734h10.935c0.317,0,0.575-0.257,0.575-0.575s-0.258-0.576-0.575-0.576H5.029\n            c-0.318,0-0.576,0.258-0.576,0.576S4.711,1.734,5.029,1.734z M1,5.188V19h18.417V5.188H1z M18.266,17.849H2.151V6.338h16.115\n            V17.849z M2.727,4.036H17.69c0.317,0,0.575-0.257,0.575-0.576c0-0.318-0.258-0.575-0.575-0.575H2.727\n            c-0.318,0-0.576,0.257-0.576,0.575C2.151,3.779,2.409,4.036,2.727,4.036z\"></path>\n        </svg>\n      </mat-icon>\n      <label>center panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button class=\"dkg-column-pinning-option\"\n    [value]=\"rightPanelOption\"\n    [disabled]=\"!(panel === rightPanelOption || movable)\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>\n        <svg viewBox=\"0 0 20 20\">\n          <path d=\"M18.378,1.062H3.855c-0.309,0-0.559,0.25-0.559,0.559c0,0.309,0.25,0.559,0.559,0.559h13.964v13.964\n            c0,0.309,0.25,0.559,0.559,0.559c0.31,0,0.56-0.25,0.56-0.559V1.621C18.938,1.312,18.688,1.062,18.378,1.062z M16.144,3.296H1.621\n            c-0.309,0-0.559,0.25-0.559,0.559v14.523c0,0.31,0.25,0.56,0.559,0.56h14.523c0.309,0,0.559-0.25,0.559-0.56V3.855\n            C16.702,3.546,16.452,3.296,16.144,3.296z M15.586,17.262c0,0.31-0.25,0.558-0.56,0.558H2.738c-0.309,0-0.559-0.248-0.559-0.558\n            V4.972c0-0.309,0.25-0.559,0.559-0.559h12.289c0.31,0,0.56,0.25,0.56,0.559V17.262z\"></path>\n        </svg>\n      </mat-icon>\n      <label>right panel</label>\n    </div>\n\n  </mat-radio-button>\n\n  <mat-radio-button *ngIf=\"allowRowGrouping && !isColumnGroup\"\n    class=\"dkg-column-pinning-option\"\n    [value]=\"groupPanelOption\"\n    [disabled]=\"!(panel === groupPanelOption || (movable && groupable))\">\n\n    <div class=\"dkg-column-pinning-option-content\">\n      <mat-icon>toc</mat-icon>\n      <label>group panel</label>\n    </div>\n\n  </mat-radio-button>\n\n</mat-radio-group>\n\n", styles: [".dkg-column-pinning{height:100%;width:100%;box-sizing:border-box;padding:0 10px;display:flex;flex-direction:column;justify-content:flex-start}.dkg-column-locking-container,.dkg-column-pinning-container{display:flex;flex-flow:row wrap;justify-content:space-between;margin:7px 0}.dkg-column-locking-option,.dkg-column-pinning-option{margin:13px}.dkg-column-locking-option-content,.dkg-column-pinning-option-content{display:flex;flex-direction:row;justify-content:space-around}.dkg-column-locking-option-content label,.dkg-column-pinning-option-content label{padding-left:7px}\n"] }]
        }], ctorParameters: function () { return [{ type: DkGridConfig }, { type: DkGridPanelDispatcher }, { type: DkContentPanelDispatcher }, { type: DkRowGroupingConfig }]; }, propDecorators: { columnSlot: [{
                type: Input
            }], moveColumn: [{
                type: Output
            }] } });

class ColumnContextMenuContentHeightPipe {
    transform(contentHeight, tabHeader, padding, horizontalScrolling) {
        return contentHeight - tabHeader - padding - horizontalScrolling;
    }
}
ColumnContextMenuContentHeightPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnContextMenuContentHeightPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ColumnContextMenuContentHeightPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnContextMenuContentHeightPipe, name: "columnContextMenuContentHeight" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: ColumnContextMenuContentHeightPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'columnContextMenuContentHeight'
                }]
        }] });

class DkColumnContextMenuComponent {
    constructor(data, contextMenuRef, gridConfig, gridFilterConfig, sortDispatcher, dataSourceDispatcher) {
        this.gridConfig = gridConfig;
        this.gridFilterConfig = gridFilterConfig;
        this.sortDispatcher = sortDispatcher;
        this.dataSourceDispatcher = dataSourceDispatcher;
        this.isFilterable = false;
        this.displayFilterOptions = false;
        this.columnSlot = data.columnSlot;
        this.selfContextRef = contextMenuRef;
        this.tabHeader = 50;
        this.padding = 25;
        this.horizontalScrolling = 13;
        this.titleHeight = 50;
        this.filterOptionsHeight = 50;
        this.customScrollbars = this.gridConfig.customScrollbars;
        // Since dike-column-chooser is the first displayed tab only get the difference without the title:
        this.contentHeight = this.gridConfig.columnContextMenuHeight - this.titleHeight;
    }
    ngOnInit() {
        this.onDemandFilter$ = this.gridFilterConfig.onDemandFilterChanged$;
        this.isFilterable = this.columnSlot.dikeColumn.filterable && !!this.gridFilterConfig.filterables.get(this.columnSlot.dikeColumn.columnId);
        this.onAllowSorting$ = this.sortDispatcher.onAllowSortingChanged$;
        this.disableSortPagination$ = this.dataSourceDispatcher.onTempDisableSortPaginationChanged$;
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.displayFilterOptions = this.filterOptionsVisibility();
            if (this.isFilterable) {
                this.addFilterCondition = () => {
                    this.columnFiltering.addFilterCondition();
                };
                this.canAddFilterCondition = () => {
                    return this.columnFiltering.canAddFilterCondition();
                };
                this.clearFilter = () => {
                    this.columnFiltering.clearFilter();
                };
                this.applyFilterOnDemand = () => {
                    this.columnFiltering.applyFilter();
                };
            }
        }, 0);
    }
    addFilterCondition() {
        return;
    }
    canAddFilterCondition() {
        return false;
    }
    clearFilter() {
        return;
    }
    applyFilterOnDemand() {
        return;
    }
    calculateContentHeight(filterOptionsVisible) {
        let filterOptions = 0;
        if (filterOptionsVisible) {
            filterOptions = this.filterOptionsHeight;
        }
        return this.gridConfig.columnContextMenuHeight - this.titleHeight - filterOptions;
    }
    onMoveColumn(result) {
        if (result) {
            this.selfContextRef.close();
        }
    }
    onSelectedTabChange() {
        this.displayFilterOptions = this.filterOptionsVisibility();
        this.contentHeight = this.calculateContentHeight(this.displayFilterOptions);
    }
    filterOptionsVisibility() {
        return this.filterTab && this.filterTab.isActive;
    }
}
DkColumnContextMenuComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnContextMenuComponent, deps: [{ token: DK_CONTEXT_MENU_DATA }, { token: DkContextMenuRef }, { token: DkGridConfig }, { token: DkGridFilterConfig }, { token: DkSortDispatcher }, { token: DkDataSourceDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkColumnContextMenuComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkColumnContextMenuComponent, selector: "dk-column-context-menu", host: { properties: { "attr.dkg-custom-scrollbars": "customScrollbars" }, classAttribute: "dkg-column-context-menu" }, viewQueries: [{ propertyName: "filterTab", first: true, predicate: ["filterTab"], descendants: true }, { propertyName: "columnFiltering", first: true, predicate: ["columnFiltering"], descendants: true }], ngImport: i0, template: "<div class=\"dkg-column-context-menu-title\">\n  <div>{{ columnSlot.dikeColumn.headerText }}</div>\n  <button mat-icon-button (click)=\"selfContextRef.close()\" aria-label=\"Close menu\">\n    <mat-icon>close</mat-icon>\n  </button>\n</div>\n\n<div class=\"dkg-column-context-menu-content\" dike-tabs-types=\"icon\" [style.height.px]=\"contentHeight\">\n  <mat-tab-group (selectedTabChange)=\"onSelectedTabChange()\">\n    <mat-tab #columnTab=\"matTab\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"columnTab.isActive\">\n          <mat-icon>view_column</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-chooser\n          [columnId]=\"columnSlot.dikeColumn.columnId\">\n        </dk-column-chooser>\n      </div>\n    </mat-tab>\n\n    <mat-tab #filterTab=\"matTab\" *ngIf=\"isFilterable\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"filterTab.isActive\">\n          <mat-icon>filter_list</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-filter #columnFiltering=\"dkgColumnFilter\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\">\n        </dk-column-filter>\n      </div>\n    </mat-tab>\n\n    <mat-tab #sortTab=\"matTab\" *ngIf=\"(onAllowSorting$ | async) && columnSlot.dikeColumn.sortable\" [disabled]=\"disableSortPagination$ | async\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"sortTab.isActive\">\n          <mat-icon>sort_by_alpha</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-sorting #columnSorting=\"dkgColumnSorting\"\n          [columnSlot]=\"columnSlot\">\n        </dk-column-sorting>\n      </div>\n    </mat-tab>\n\n    <mat-tab #pinTab=\"matTab\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"pinTab.isActive\">\n          <mat-icon>push_pin</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-pinning\n          [columnSlot]=\"columnSlot\"\n          (moveColumn)=\"onMoveColumn($event)\">\n        </dk-column-pinning>\n      </div>\n    </mat-tab>\n\n  </mat-tab-group>\n  <mat-divider></mat-divider>\n</div>\n\n<div *ngIf=\"displayFilterOptions\" class=\"dkg-column-context-menu-footer\">\n  <button mat-flat-button *ngIf=\"canAddFilterCondition()\"\n    (click)=\"addFilterCondition()\">Add\n  </button>\n\n  <button mat-flat-button *ngIf=\"onDemandFilter$ | async\"\n    (click)=\"applyFilterOnDemand()\">Filter\n  </button>\n\n  <button mat-flat-button (click)=\"clearFilter()\">Clear\n  </button>\n\n</div>\n", styles: [".dkg-column-context-menu{width:100%;height:100%;box-sizing:border-box;border-radius:4px}.dkg-column-context-menu[dkg-custom-scrollbars=true] *{scrollbar-width:auto}.dkg-column-context-menu[dkg-custom-scrollbars=true] * ::-webkit-scrollbar{width:8px;height:8px}.dkg-column-context-menu[dkg-custom-scrollbars=true] * ::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-column-context-menu-title{display:flex;flex-direction:row;justify-content:space-between;align-items:center;height:50px;box-sizing:border-box;padding:.1em .7em;border-top-left-radius:4px;border-top-right-radius:4px}.dkg-column-context-menu-content{box-sizing:border-box;padding:.7em}.dkg-column-context-menu-footer{display:flex;flex-direction:row;justify-content:space-around;align-items:flex-start;height:50px;box-sizing:border-box;padding:0 .7em}.dkg-column-context-menu-tab-content{box-sizing:border-box;padding:.5em 0}div[dike-tabs-types=icon] .mat-tab-label[role^=tab]{min-width:72px}\n"], components: [{ type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i8$2.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "disableRipple"], exportAs: ["matTabGroup"] }, { type: i8$2.MatTab, selector: "mat-tab", inputs: ["disabled", "label", "aria-label", "aria-labelledby", "labelClass", "bodyClass"], exportAs: ["matTab"] }, { type: DkColumnChooserComponent, selector: "dk-column-chooser", inputs: ["columnId"] }, { type: DkColumnFilterComponent, selector: "dk-column-filter", inputs: ["columnId", "isFilterRow", "contentAlign"], exportAs: ["dkgColumnFilter"] }, { type: DkColumnSortingComponent, selector: "dk-column-sorting", inputs: ["columnSlot"], exportAs: ["dkgColumnSorting"] }, { type: DkColumnPinningComponent, selector: "dk-column-pinning", inputs: ["columnSlot"], outputs: ["moveColumn"], exportAs: ["dkgColumnPinning"] }, { type: i7$2.MatDivider, selector: "mat-divider", inputs: ["vertical", "inset"] }], directives: [{ type: i8$2.MatTabLabel, selector: "[mat-tab-label], [matTabLabel]" }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "columnContextMenuContentHeight": ColumnContextMenuContentHeightPipe, "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkColumnContextMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-column-context-menu', host: {
                        'class': 'dkg-column-context-menu',
                        '[attr.dkg-custom-scrollbars]': 'customScrollbars'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-column-context-menu-title\">\n  <div>{{ columnSlot.dikeColumn.headerText }}</div>\n  <button mat-icon-button (click)=\"selfContextRef.close()\" aria-label=\"Close menu\">\n    <mat-icon>close</mat-icon>\n  </button>\n</div>\n\n<div class=\"dkg-column-context-menu-content\" dike-tabs-types=\"icon\" [style.height.px]=\"contentHeight\">\n  <mat-tab-group (selectedTabChange)=\"onSelectedTabChange()\">\n    <mat-tab #columnTab=\"matTab\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"columnTab.isActive\">\n          <mat-icon>view_column</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-chooser\n          [columnId]=\"columnSlot.dikeColumn.columnId\">\n        </dk-column-chooser>\n      </div>\n    </mat-tab>\n\n    <mat-tab #filterTab=\"matTab\" *ngIf=\"isFilterable\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"filterTab.isActive\">\n          <mat-icon>filter_list</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-filter #columnFiltering=\"dkgColumnFilter\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\">\n        </dk-column-filter>\n      </div>\n    </mat-tab>\n\n    <mat-tab #sortTab=\"matTab\" *ngIf=\"(onAllowSorting$ | async) && columnSlot.dikeColumn.sortable\" [disabled]=\"disableSortPagination$ | async\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"sortTab.isActive\">\n          <mat-icon>sort_by_alpha</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-sorting #columnSorting=\"dkgColumnSorting\"\n          [columnSlot]=\"columnSlot\">\n        </dk-column-sorting>\n      </div>\n    </mat-tab>\n\n    <mat-tab #pinTab=\"matTab\">\n      <ng-template mat-tab-label>\n        <div [class.dkg-column-context-menu-active-tab]=\"pinTab.isActive\">\n          <mat-icon>push_pin</mat-icon>\n        </div>\n      </ng-template>\n\n      <div class=\"dkg-column-context-menu-tab-content\" [style.height.px]=\"contentHeight | columnContextMenuContentHeight:tabHeader:padding:horizontalScrolling\">\n        <dk-column-pinning\n          [columnSlot]=\"columnSlot\"\n          (moveColumn)=\"onMoveColumn($event)\">\n        </dk-column-pinning>\n      </div>\n    </mat-tab>\n\n  </mat-tab-group>\n  <mat-divider></mat-divider>\n</div>\n\n<div *ngIf=\"displayFilterOptions\" class=\"dkg-column-context-menu-footer\">\n  <button mat-flat-button *ngIf=\"canAddFilterCondition()\"\n    (click)=\"addFilterCondition()\">Add\n  </button>\n\n  <button mat-flat-button *ngIf=\"onDemandFilter$ | async\"\n    (click)=\"applyFilterOnDemand()\">Filter\n  </button>\n\n  <button mat-flat-button (click)=\"clearFilter()\">Clear\n  </button>\n\n</div>\n", styles: [".dkg-column-context-menu{width:100%;height:100%;box-sizing:border-box;border-radius:4px}.dkg-column-context-menu[dkg-custom-scrollbars=true] *{scrollbar-width:auto}.dkg-column-context-menu[dkg-custom-scrollbars=true] * ::-webkit-scrollbar{width:8px;height:8px}.dkg-column-context-menu[dkg-custom-scrollbars=true] * ::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-column-context-menu-title{display:flex;flex-direction:row;justify-content:space-between;align-items:center;height:50px;box-sizing:border-box;padding:.1em .7em;border-top-left-radius:4px;border-top-right-radius:4px}.dkg-column-context-menu-content{box-sizing:border-box;padding:.7em}.dkg-column-context-menu-footer{display:flex;flex-direction:row;justify-content:space-around;align-items:flex-start;height:50px;box-sizing:border-box;padding:0 .7em}.dkg-column-context-menu-tab-content{box-sizing:border-box;padding:.5em 0}div[dike-tabs-types=icon] .mat-tab-label[role^=tab]{min-width:72px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [DK_CONTEXT_MENU_DATA]
                    }] }, { type: DkContextMenuRef }, { type: DkGridConfig }, { type: DkGridFilterConfig }, { type: DkSortDispatcher }, { type: DkDataSourceDispatcher }];
    }, propDecorators: { filterTab: [{
                type: ViewChild,
                args: ['filterTab']
            }], columnFiltering: [{
                type: ViewChild,
                args: ['columnFiltering']
            }] } });

const CENTER = {
    originX: 'center',
    originY: 'center',
    overlayX: 'center',
    overlayY: 'center'
};
const TOP = {
    originX: 'center',
    originY: 'top',
    overlayX: 'center',
    overlayY: 'bottom'
};
const TOP_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'center',
    overlayY: 'bottom'
};
const BOTTOM = {
    originX: 'center',
    originY: 'bottom',
    overlayX: 'center',
    overlayY: 'top'
};
const BOTTOM_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'center',
    overlayY: 'top'
};
const LEFT = {
    originX: 'start',
    originY: 'center',
    overlayX: 'end',
    overlayY: 'center'
};
const TOP_LEFT = {
    originX: 'start',
    originY: 'top',
    overlayX: 'end',
    overlayY: 'bottom'
};
const LEFT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'end',
    overlayY: 'center'
};
const TOP_LEFT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'end',
    overlayY: 'bottom'
};
const BOTTOM_LEFT = {
    originX: 'start',
    originY: 'bottom',
    overlayX: 'end',
    overlayY: 'top'
};
const BOTTOM_LEFT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'end',
    overlayY: 'top'
};
const RIGHT = {
    originX: 'end',
    originY: 'center',
    overlayX: 'start',
    overlayY: 'center'
};
const RIGHT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'start',
    overlayY: 'center'
};
const TOP_RIGHT = {
    originX: 'end',
    originY: 'top',
    overlayX: 'start',
    overlayY: 'bottom'
};
const TOP_RIGHT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'start',
    overlayY: 'bottom'
};
const BOTTOM_RIGHT = {
    originX: 'end',
    originY: 'bottom',
    overlayX: 'start',
    overlayY: 'top'
};
const BOTTOM_RIGHT_OVERLAP = {
    originX: 'center',
    originY: 'center',
    overlayX: 'start',
    overlayY: 'top'
};

class DkContextMenu {
    constructor(overlay, injector) {
        this.overlay = overlay;
        this.injector = injector;
    }
    open(origin, component, config = {}) {
        const overlayRef = this.overlay.create(this.getOverlayConfig(origin, {
            width: config.width,
            height: config.height,
            hasBackdrop: config.hasBackdrop,
            panelClass: config.panelClass,
            backdropClass: config.backdropClass
        }));
        // Create the wrapper:
        const contextMenuRef = new DkContextMenuRef(overlayRef);
        // Create injector and set providers:
        const injector = this.createInjector(config.data, contextMenuRef);
        // Instance the given component type and inject data:
        const columnMenuPortal = new ComponentPortal(component, null, injector);
        // Add the portal to the overlay:
        overlayRef.attach(columnMenuPortal);
        return contextMenuRef;
    }
    getOverlayConfig(origin, { width, height, hasBackdrop, panelClass, backdropClass }) {
        return new OverlayConfig({
            width,
            height,
            hasBackdrop,
            panelClass,
            backdropClass,
            positionStrategy: this.getOverlayPosition(origin),
            scrollStrategy: this.overlay.scrollStrategies.block()
        });
    }
    getOverlayPosition(origin) {
        const positionStrategy = this.overlay.position()
            .flexibleConnectedTo(origin)
            .withPositions(this.getPositions())
            .withFlexibleDimensions(false)
            .withGrowAfterOpen(false)
            .withPush(true)
            .withViewportMargin(0)
            .withLockedPosition(true);
        return positionStrategy;
    }
    getPositions() {
        return [
            BOTTOM_RIGHT,
            BOTTOM_LEFT,
            BOTTOM,
            RIGHT,
            LEFT,
            TOP_RIGHT,
            TOP_LEFT,
            TOP
        ];
    }
    createInjector(data, contextMenuRef) {
        const injectionTokens = new WeakMap();
        injectionTokens.set(DkContextMenuRef, contextMenuRef);
        injectionTokens.set(DK_CONTEXT_MENU_DATA, data);
        return Injector.create({
            providers: [
                { provide: DkContextMenuRef, useValue: contextMenuRef },
                { provide: DK_CONTEXT_MENU_DATA, useValue: data }
            ],
            parent: this.injector
        });
    }
}
DkContextMenu.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenu, deps: [{ token: i1$1.Overlay }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
DkContextMenu.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenu });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenu, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.Injector }]; } });

class DkGridCellHeaderComponent {
    constructor(gridConfig, dikeContextMenu) {
        this.gridConfig = gridConfig;
        this.dikeContextMenu = dikeContextMenu;
        this.changeAllowColumnDraggingSubscription = Subscription.EMPTY;
        this.isMouseOver = false;
        this.columnId = '';
        this.sortable = false;
        this.cellHeaderHeight = '';
        this.isGroup = false;
        this.canChangeDisplayStatus = false;
        this.cursorType = 'default';
        this.allowColumnDragging = false;
    }
    ngOnInit() {
        this.columnSlot = this.columnStructure ? this.columnStructure.getColumnSlot(this.columnId) : null;
        this.allowColumnContextMenu$ = this.gridConfig.onAllowColumnContextMenuChanged$;
        this.allowColumnContextMenuForColumnSlot = !!this.columnSlot ? this.columnSlot.dikeColumn.displayMenu : false;
        this.setChangeAllowColumnDraggingSubscription();
    }
    ngOnDestroy() {
        this.changeAllowColumnDraggingSubscription.unsubscribe();
    }
    mouseOver() {
        this.isMouseOver = true;
        this.cursorType = this.allowColumnDragging ? 'grab' : 'default';
    }
    mouseLeave() {
        this.isMouseOver = false;
        this.cursorType = 'default';
    }
    mouseDown(e) {
        if (!this.allowColumnDragging) {
            e.preventDefault();
            this.cursorType = 'default';
            e.stopPropagation();
            return false;
        }
        this.cursorType = 'grabbing';
    }
    mouseUp() {
        this.cursorType = this.allowColumnDragging ? 'grab' : 'default';
    }
    onShowContextMenu(origin) {
        if (this.gridConfig.allowColumnContextMenu && !!this.columnSlot && this.columnSlot.dikeColumn.displayMenu) {
            this.dikeContextMenuRef = this.dikeContextMenu.open(origin.elementRef, DkColumnContextMenuComponent, {
                height: this.gridConfig.columnContextMenuHeight,
                width: this.gridConfig.columnContextMenuWidth,
                hasBackdrop: true,
                panelClass: 'dkg-column-context-menu-panel',
                backdropClass: 'dkg-column-context-menu-backdrop',
                data: {
                    columnSlot: this.columnSlot
                }
            });
        }
    }
    onChangeDisplayStatus(displayStatus) {
        this.columnStructure.setDisplayStatusToColumnSlotGroup(this.columnId, displayStatus);
    }
    setChangeAllowColumnDraggingSubscription() {
        this.changeAllowColumnDraggingSubscription.unsubscribe();
        this.changeAllowColumnDraggingSubscription = this.gridConfig.onAllowColumnDraggingChanged$.subscribe(value => this.allowColumnDragging = value);
    }
}
DkGridCellHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCellHeaderComponent, deps: [{ token: DkGridConfig }, { token: DkContextMenu }], target: i0.ɵɵFactoryTarget.Component });
DkGridCellHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridCellHeaderComponent, selector: "dk-grid-cell-header", inputs: { columnStructure: "columnStructure", columnId: "columnId", sortable: "sortable", cellHeaderHeight: "cellHeaderHeight", isGroup: "isGroup", canChangeDisplayStatus: "canChangeDisplayStatus", displayStatus: "displayStatus" }, host: { listeners: { "mouseover": "mouseOver()", "mouseleave": "mouseLeave()", "mousedown": "mouseDown($event)", "mouseup": "mouseUp()" }, properties: { "style.height": "cellHeaderHeight", "style.cursor": "cursorType" }, classAttribute: "dkg-cell-header" }, ngImport: i0, template: "<div class=\"dkg-cell-header-container dkg-cell-header-content\" [mat-sort-header]=\"columnId\" [disabled]=\"!sortable\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-cell-header-container dkg-cell-header-actions\">\n\n  <div class=\"dkg-cell-header-options\">\n    <button *ngIf=\"isMouseOver && (allowColumnContextMenu$ | async) && allowColumnContextMenuForColumnSlot\" cdkOverlayOrigin #origin=\"cdkOverlayOrigin\"\n      mat-icon-button (click)=\"onShowContextMenu(origin)\">\n      <mat-icon>menu</mat-icon>\n    </button>\n\n    <button *ngIf=\"isGroup && canChangeDisplayStatus && displayStatus === 'closed'\"\n      mat-icon-button (click)=\"onChangeDisplayStatus('open')\">\n      <mat-icon>keyboard_arrow_right</mat-icon>\n    </button>\n\n    <button *ngIf=\"isGroup && canChangeDisplayStatus && displayStatus === 'open'\"\n      mat-icon-button (click)=\"onChangeDisplayStatus('closed')\">\n      <mat-icon>keyboard_arrow_left</mat-icon>\n    </button>\n\n  </div>\n\n</div>\n", styles: [".dkg-cell-header{overflow:hidden;align-self:center;padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-between}.dkg-cell-header p{margin:0}.dkg-cell-header-container{display:flex;flex-direction:column;justify-content:center}.dkg-cell-header-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.dkg-cell-header-actions{box-sizing:border-box;opacity:.9}.dkg-cell-header-options{display:flex;flex-direction:row;justify-content:space-around}\n"], components: [{ type: i3$2.MatSortHeader, selector: "[mat-sort-header]", inputs: ["disabled", "mat-sort-header", "arrowPosition", "start", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$1.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCellHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-cell-header', host: {
                        'class': 'dkg-cell-header',
                        '[style.height]': 'cellHeaderHeight',
                        '[style.cursor]': 'cursorType'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-cell-header-container dkg-cell-header-content\" [mat-sort-header]=\"columnId\" [disabled]=\"!sortable\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-cell-header-container dkg-cell-header-actions\">\n\n  <div class=\"dkg-cell-header-options\">\n    <button *ngIf=\"isMouseOver && (allowColumnContextMenu$ | async) && allowColumnContextMenuForColumnSlot\" cdkOverlayOrigin #origin=\"cdkOverlayOrigin\"\n      mat-icon-button (click)=\"onShowContextMenu(origin)\">\n      <mat-icon>menu</mat-icon>\n    </button>\n\n    <button *ngIf=\"isGroup && canChangeDisplayStatus && displayStatus === 'closed'\"\n      mat-icon-button (click)=\"onChangeDisplayStatus('open')\">\n      <mat-icon>keyboard_arrow_right</mat-icon>\n    </button>\n\n    <button *ngIf=\"isGroup && canChangeDisplayStatus && displayStatus === 'open'\"\n      mat-icon-button (click)=\"onChangeDisplayStatus('closed')\">\n      <mat-icon>keyboard_arrow_left</mat-icon>\n    </button>\n\n  </div>\n\n</div>\n", styles: [".dkg-cell-header{overflow:hidden;align-self:center;padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-between}.dkg-cell-header p{margin:0}.dkg-cell-header-container{display:flex;flex-direction:column;justify-content:center}.dkg-cell-header-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.dkg-cell-header-actions{box-sizing:border-box;opacity:.9}.dkg-cell-header-options{display:flex;flex-direction:row;justify-content:space-around}\n"] }]
        }], ctorParameters: function () { return [{ type: DkGridConfig }, { type: DkContextMenu }]; }, propDecorators: { columnStructure: [{
                type: Input
            }], columnId: [{
                type: Input
            }], sortable: [{
                type: Input
            }], cellHeaderHeight: [{
                type: Input
            }], isGroup: [{
                type: Input
            }], canChangeDisplayStatus: [{
                type: Input
            }], displayStatus: [{
                type: Input
            }], mouseOver: [{
                type: HostListener,
                args: ['mouseover']
            }], mouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }], mouseDown: [{
                type: HostListener,
                args: ['mousedown', ['$event']]
            }], mouseUp: [{
                type: HostListener,
                args: ['mouseup']
            }] } });

class DkGridRowHeaderDirective {
    constructor(cdr, gridContentStructure) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    ngOnInit() {
        this.columnStructure.onGridTemplateColumnsHeaderChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
        this.gridContentStructure.onGridHeaderTemplateRowsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateRowsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridRowHeaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowHeaderDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowHeaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowHeaderDirective, selector: "[dkGridRowHeader]", inputs: { columnStructure: ["dkGridRowHeader", "columnStructure"] }, host: { properties: { "style.display": "formatContext", "style.grid-template-rows": "gridTemplateRowsValue", "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgRowHeader"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRowHeader]',
                    exportAs: 'dkgRowHeader',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }]; }, propDecorators: { columnStructure: [{
                type: Input,
                args: ['dkGridRowHeader']
            }] } });

class HeaderSlotHeightPipe {
    transform(slotHeight, gridRowHeader) {
        return `${slotHeight * gridRowHeader.rowHeight - gridRowHeader.horizontalGutterHeight}px`;
    }
}
HeaderSlotHeightPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: HeaderSlotHeightPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
HeaderSlotHeightPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: HeaderSlotHeightPipe, name: "headerSlotHeight" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: HeaderSlotHeightPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'headerSlotHeight'
                }]
        }] });

class DkGridRowHeaderComponent {
    constructor(dikeConfig, cdr, scrollDispatcher, gridConfig, gridStructure, gridContentStructure, contentPanelDispatcher, groupPanelDispatcher, gridPanelDispatcher, generalNotifier, gridUI) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.scrollDispatcher = scrollDispatcher;
        this.gridConfig = gridConfig;
        this.gridStructure = gridStructure;
        this.gridContentStructure = gridContentStructure;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.generalNotifier = generalNotifier;
        this.gridUI = gridUI;
        this.changeScrollingSubscription = Subscription.EMPTY;
        this.headerHorizontalGutterHeightPx = '';
        this.isDragging = false;
        this.gridRowHeader = { contentHeight: 0, horizontalGutterHeight: 0, rowHeight: 0 };
        this.isThereOuterColumns = false;
        this.inOrderComplementGutterVisibility = true;
        this.sourceContainer = 'source-column-container';
        this.dropSwapContainer = 'drop-swap-column-container';
        this.dropGutterContainer = 'drop-gutter-container';
        this.rowGroupingPanelId = this.groupPanelDispatcher.rowGroupingAreaId;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.panel = this.columnStructure.panel;
        this.scrollbarSlot$ = this.columnStructure.onScrollbarGapSlotChanged$;
        this.horizontalGutterSlot$ = this.columnStructure.onHorizontalGutterSlotChanged$;
        this.outerColumnSlots$ = this.columnStructure.onOuterColumnSlotsChanged$;
        this.allowColumnDragging$ = this.gridConfig.onAllowColumnDraggingChanged$;
        this.gutterSlotAction$ = merge(this.columnStructure.onGutterSlotOverChanged$, this.columnStructure.onGutterSlotResizingChanged$);
        let border$ = combineLatest([
            this.gridStructure.onBorderLeftChanged$,
            this.gridStructure.onBorderRightChanged$,
        ]);
        let columnSlots$ = combineLatest([
            this.columnStructure.onColumnSlotsChanged$,
            this.columnStructure.onOuterColumnSlotsChanged$
        ]);
        this.visibleColumnSlots$ = combineLatest([
            border$,
            columnSlots$,
            this.contentPanelDispatcher.onPanelsVisibilityChanged$,
            this.gridPanelDispatcher.onShareDropElementsChanged$
        ]).pipe(map(([[leftBorder, rightBorder], [slots, outerSlots], panelsVisibility, panelShareables]) => {
            this.borders = [leftBorder, rightBorder];
            this.shareables = {
                groupPanel: new Map(panelShareables.groupPanel),
                leftPanel: new Map(panelShareables.leftPanel),
                centerPanel: new Map(panelShareables.centerPanel),
                rightPanel: new Map(panelShareables.rightPanel)
            };
            this.isThereOuterColumns = outerSlots.length > 0;
            this.panelsVisibility = panelsVisibility;
            this.inOrderComplementGutterVisibility = !this.gridUI.isInOrderComplementGutterHidden(this.panel, this.isThereOuterColumns, this.panelsVisibility);
            return slots.filter(slot => slot.dikeColumn.visible);
        }));
        this.gridContentStructure.onHeaderRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridRowHeader = value;
            this.headerHorizontalGutterHeightPx = `${value.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
        this.generalNotifier.onDraggingNotifierChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(draggingWarning => {
            this.isDragging = draggingWarning;
            this.cdr.markForCheck();
        });
    }
    ngAfterViewInit() {
        this.setChangeScrollingSubscription();
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.changeScrollingSubscription.unsubscribe();
    }
    noDroppingAllowed() {
        return false;
    }
    onDragStart(event) {
        this.generalNotifier.notifyColumnSlotDragging(true);
    }
    onDragEnd(event) {
        this.generalNotifier.notifyColumnSlotDragging(false);
    }
    onDropListEntered(entered) {
        this.columnStructure.notifySlotOver(entered.container.data, true);
    }
    onDropListExited(exited) {
        this.columnStructure.notifySlotOver(exited.container.data, false);
    }
    onDrop(dropped) {
        let sourceSlot = dropped.previousContainer.data;
        let destinationSlot = dropped.container.data;
        this.columnStructure.notifySlotOver(destinationSlot, false);
        this.gridPanelDispatcher.interchageColumnSlots(this.gridPanelDispatcher.gridPanels[sourceSlot.dikeColumn.panel], sourceSlot, this.gridPanelDispatcher.gridPanels[destinationSlot.dikeColumn.panel], destinationSlot);
    }
    setChangeScrollingSubscription() {
        /**
         * The CdkScrollable which lives in the DkGridRowHeader component, only
         * listens scroll events from the CdkScrollable of the DikeGridHorizontalScrolling
         * component.
         *
         * Rules to mode the horizontal scroll:
         *
         *    1.  The given CdkScrollable must be different of null or undefined.
         *    2.  The CdkVirtualScrollViewport vertical scrolling is ignored. Remember
         *        that CdkVirtualScrollViewport does not have horizontal scrolling.
         *    3.  The given CdkScrollable must not be the CdkScrollable from the header itself.
         *    4.  The CdkScrollable from the header only listens events from the horizontal scroll bar.
         *    5.  When the user is dragging a column, the CdkScrollable from the header could be
         *        moved. Therefore, the header could be moved programmatically only when the user
         *        is moving the horizontal scroll bar and is not dragging a column.
         */
        let horizontalScrolling$ = this.scrollDispatcher.scrolled(this.dikeConfig.THROTTLE_SCROLL_TIME).pipe(filter(value => !!value && typeof value !== 'undefined' && !(value instanceof CdkVirtualScrollViewport) && value !== this.scrollableHeaderPanel), filter(value => typeof value !== 'undefined' &&
            !!value.getElementRef().nativeElement.attributes.getNamedItem('horizontal-scroll-panel-name') && !this.isDragging));
        this.changeScrollingSubscription.unsubscribe();
        this.changeScrollingSubscription = horizontalScrolling$.subscribe(value => {
            if (typeof value !== 'undefined') {
                let leftOffset = value.measureScrollOffset('left');
                this.scrollableHeaderPanel.scrollTo({ left: leftOffset });
            }
        });
    }
}
DkGridRowHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowHeaderComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i2.ScrollDispatcher }, { token: DkGridConfig }, { token: DkGridStructure }, { token: DkGridContentStructure }, { token: DkContentPanelDispatcher }, { token: DkGroupPanelDispatcher }, { token: DkGridPanelDispatcher }, { token: DkGeneralNotifier }, { token: DkGridUI }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowHeaderComponent, selector: "dk-grid-row-header", inputs: { columnStructure: "columnStructure" }, viewQueries: [{ propertyName: "scrollableHeaderPanel", first: true, predicate: CdkScrollable, descendants: true }], ngImport: i0, template: "<div class=\"dkg-row-header-wrapper\" [attr.scrollable-header-panel-name]=\"panel\"\n  [dkGridRowHeader]=\"columnStructure\"\n  cdkScrollable>\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"outerColumnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"outerColumnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [cellHeight]=\"outerColumnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n      [isHeaderCell]=\"true\">\n\n        <p>{{ outerColumnSlot.dikeColumn.headerText }}</p>\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [isHeaderGutter]=\"true\"\n      [gutterHeight]=\"outerColumnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container [ngSwitch]=\"panel\">\n\n    <ng-container *ngSwitchCase=\"'rightPanel'\">\n      <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngSwitchDefault>\n      <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n  </ng-container>\n\n  <ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n    <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"hgSlot.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\"\n        [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n        [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\">\n    <div [style.height]=\"scrollbarGapSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"scrollbarGapSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"scrollbarGapSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n    </div>\n  </ng-container>\n\n  <ng-template #completeGutter>\n    <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n      [gridRowStart]=\"hgSlot.gridRowStart\"\n      [gridRowEnd]=\"hgSlot.gridRowEnd\"\n\n      [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n  </ng-template>\n\n  <ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isEmpty]=\"!inOrderComplementGutterVisibility\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <div class=\"dkg-source-container\"\n        [class.dkg-dragging-front-container]=\"!isDragging\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n        [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n        [cdkDropListData]=\"columnSlot\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n        <dk-grid-cell-header\n          cdkDrag\n          [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n          cdkDragPreviewContainer=\"parent\"\n          (cdkDragStarted)=\"onDragStart($event)\"\n          (cdkDragEnded)=\"onDragEnd($event)\"\n\n          [columnStructure]=\"columnStructure\"\n          [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [sortable]=\"columnSlot.dikeColumn.sortable\"\n          [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n          [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n          [displayStatus]=\"columnSlot.displayStatus\">\n\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n          <dk-grid-draggable-cell\n            [draggable]=\"columnSlot.dikeColumn.draggable\"\n            [locked]=\"columnSlot.dikeColumn.locked\"\n            *cdkDragPreview>\n            <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n          </dk-grid-draggable-cell>\n\n          <div *cdkDragPlaceholder></div>\n\n        </dk-grid-cell-header>\n\n      </div>\n\n      <div class=\"dkg-drop-swap-container\"\n        [class.dkg-dragging-front-container]=\"isDragging\"\n        [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n        [cdkDropListData]=\"columnSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-cell-header *ngIf=\"allowColumnDragging$ | async\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n        [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\"\n        [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n        [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n        [displayStatus]=\"columnSlot.displayStatus\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n      </dk-grid-cell-header>\n\n      <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n          [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n          [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n          [resizerType]=\"columnSlot.dikeColumn.columnType\"\n          [columnStructure]=\"columnStructure\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n        </dk-grid-vertical-gutter>\n\n      </ng-container>\n\n      <dk-grid-horizontal-gutter *ngIf=\"columnSlot.horizontalGutter\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.horizontalGutter.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.horizontalGutter.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.horizontalGutter.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.horizontalGutter.gridRowEnd\"\n\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n          [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n          [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n          [resizerType]=\"columnSlot.dikeColumn.columnType\"\n          [columnStructure]=\"columnStructure\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n        </dk-grid-vertical-gutter>\n\n      </ng-container>\n\n      <div class=\"dkg-source-container\"\n        [class.dkg-dragging-front-container]=\"!isDragging\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n        [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n        [cdkDropListData]=\"columnSlot\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n        <dk-grid-cell-header\n          cdkDrag\n          [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n          cdkDragPreviewContainer=\"parent\"\n          (cdkDragStarted)=\"onDragStart($event)\"\n          (cdkDragEnded)=\"onDragEnd($event)\"\n\n          [columnStructure]=\"columnStructure\"\n          [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [sortable]=\"columnSlot.dikeColumn.sortable\"\n          [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n          [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n          [displayStatus]=\"columnSlot.displayStatus\">\n\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n          <dk-grid-draggable-cell\n            [draggable]=\"columnSlot.dikeColumn.draggable\"\n            [locked]=\"columnSlot.dikeColumn.locked\"\n            *cdkDragPreview>\n            <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n          </dk-grid-draggable-cell>\n\n          <div *cdkDragPlaceholder></div>\n\n        </dk-grid-cell-header>\n\n      </div>\n\n      <div class=\"dkg-drop-swap-container\"\n        [class.dkg-dragging-front-container]=\"isDragging\"\n        [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n        [cdkDropListData]=\"columnSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-cell-header *ngIf=\"allowColumnDragging$ | async\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n        [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\"\n        [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n        [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n        [displayStatus]=\"columnSlot.displayStatus\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n      </dk-grid-cell-header>\n\n      <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n          [gutterHeight]=\"columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <dk-grid-horizontal-gutter *ngIf=\"columnSlot.horizontalGutter\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.horizontalGutter.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.horizontalGutter.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.horizontalGutter.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.horizontalGutter.gridRowEnd\"\n\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n</div>\n\n<ng-template #displayHeaderValue let-column=\"dikeColumn\">\n  <p\n    [matTooltip]=\"column.headerTooltip\"\n    [matTooltipDisabled]=\"column.headerTooltip === ''\">\n\n    {{ column.headerText }}\n  </p>\n</ng-template>\n", styles: [".dkg-row-header-wrapper{overflow:hidden}.dkg-row-header-wrapper::-webkit-scrollbar{display:none}.dkg-source-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr}.dkg-drop-swap-container,.dkg-drop-gutter-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr;z-index:-1}.dkg-active-drop-gutter-container{border-top:0;border-right-style:solid;border-right-width:5px;box-sizing:border-box}.dkg-dragging-front-container{z-index:50}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: DkGridCellHeaderComponent, selector: "dk-grid-cell-header", inputs: ["columnStructure", "columnId", "sortable", "cellHeaderHeight", "isGroup", "canChangeDisplayStatus", "displayStatus"] }, { type: DkGridDraggableCellComponent, selector: "dk-grid-draggable-cell", inputs: ["draggable", "locked"] }], directives: [{ type: i2.CdkScrollable, selector: "[cdk-scrollable], [cdkScrollable]" }, { type: DkGridRowHeaderDirective, selector: "[dkGridRowHeader]", inputs: ["dkGridRowHeader"], exportAs: ["dkgRowHeader"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i8.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i8.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: i18.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i18.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { type: i18.CdkDragPreview, selector: "ng-template[cdkDragPreview]", inputs: ["data", "matchSize"] }, { type: i18.CdkDragPlaceholder, selector: "ng-template[cdkDragPlaceholder]", inputs: ["data"] }, { type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: ["dkGridColResizer", "columnStructure", "resizerType", "columnId", "gutterSlot"], exportAs: ["dkgColResizer"] }, { type: i14.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], pipes: { "async": i8.AsyncPipe, "headerSlotHeight": HeaderSlotHeightPipe, "columnOverValueForHeader": ColumnOverValueForHeaderPipe, "draggableContainerId": DraggableContainerIdPipe, "gutterFlexboxPosition": GutterFlexboxPositionPipe, "draggingConnectedContainerIds": DraggingConnectedContainerIdsPipe, "sortAlternativeColumnId": SortAlternativeColumnIdPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-header', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-header-wrapper\" [attr.scrollable-header-panel-name]=\"panel\"\n  [dkGridRowHeader]=\"columnStructure\"\n  cdkScrollable>\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"outerColumnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"outerColumnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [cellHeight]=\"outerColumnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n      [isHeaderCell]=\"true\">\n\n        <p>{{ outerColumnSlot.dikeColumn.headerText }}</p>\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [isHeaderGutter]=\"true\"\n      [gutterHeight]=\"outerColumnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container [ngSwitch]=\"panel\">\n\n    <ng-container *ngSwitchCase=\"'rightPanel'\">\n      <ng-container *ngTemplateOutlet=\"preOrder; context: { visibleColumnSlots: visibleColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngSwitchDefault>\n      <ng-container *ngTemplateOutlet=\"inOrder; context: { visibleColumnSlots: visibleColumnSlots$ | async }\"></ng-container>\n    </ng-container>\n\n  </ng-container>\n\n  <ng-container *ngIf=\"gutterSlotAction$ | async as gutterSlot; else completeGutter\">\n    <ng-container *ngIf=\"horizontalGutterSlot$ | async as hgSlot\">\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnStart > hgSlot.gridColumnStart\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"hgSlot.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnStart\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"gutterSlot.slotPosition.gridColumnEnd\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\"\n        [isColumnOver$]=\"gutterSlot.onColumnOverChanged$\"\n        [isColumnResizing$]=\"gutterSlot.onColumnResizingChanged$\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter *ngIf=\"gutterSlot.slotPosition.gridColumnEnd < hgSlot.gridColumnEnd\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"gutterSlot.slotPosition.gridColumnEnd\"\n        [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\">\n    <div [style.height]=\"scrollbarGapSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"scrollbarGapSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"scrollbarGapSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n    </div>\n  </ng-container>\n\n  <ng-template #completeGutter>\n    <dk-grid-horizontal-gutter *ngIf=\"horizontalGutterSlot$ | async as hgSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"hgSlot.gridColumnStart\"\n      [gridColumnEnd]=\"hgSlot.gridColumnEnd\"\n      [gridRowStart]=\"hgSlot.gridRowStart\"\n      [gridRowEnd]=\"hgSlot.gridRowEnd\"\n\n      [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n    </dk-grid-horizontal-gutter>\n  </ng-template>\n\n  <ng-template #inOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isEmpty]=\"!inOrderComplementGutterVisibility\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <div class=\"dkg-source-container\"\n        [class.dkg-dragging-front-container]=\"!isDragging\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n        [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n        [cdkDropListData]=\"columnSlot\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n        <dk-grid-cell-header\n          cdkDrag\n          [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n          cdkDragPreviewContainer=\"parent\"\n          (cdkDragStarted)=\"onDragStart($event)\"\n          (cdkDragEnded)=\"onDragEnd($event)\"\n\n          [columnStructure]=\"columnStructure\"\n          [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [sortable]=\"columnSlot.dikeColumn.sortable\"\n          [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n          [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n          [displayStatus]=\"columnSlot.displayStatus\">\n\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n          <dk-grid-draggable-cell\n            [draggable]=\"columnSlot.dikeColumn.draggable\"\n            [locked]=\"columnSlot.dikeColumn.locked\"\n            *cdkDragPreview>\n            <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n          </dk-grid-draggable-cell>\n\n          <div *cdkDragPlaceholder></div>\n\n        </dk-grid-cell-header>\n\n      </div>\n\n      <div class=\"dkg-drop-swap-container\"\n        [class.dkg-dragging-front-container]=\"isDragging\"\n        [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n        [cdkDropListData]=\"columnSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-cell-header *ngIf=\"allowColumnDragging$ | async\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n        [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\"\n        [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n        [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n        [displayStatus]=\"columnSlot.displayStatus\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n      </dk-grid-cell-header>\n\n      <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n          [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n          [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n          [resizerType]=\"columnSlot.dikeColumn.columnType\"\n          [columnStructure]=\"columnStructure\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n        </dk-grid-vertical-gutter>\n\n      </ng-container>\n\n      <dk-grid-horizontal-gutter *ngIf=\"columnSlot.horizontalGutter\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.horizontalGutter.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.horizontalGutter.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.horizontalGutter.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.horizontalGutter.gridRowEnd\"\n\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n  <ng-template #preOrder let-visibleColumnSlots=\"visibleColumnSlots\">\n    <ng-container *ngFor=\"let columnSlot of visibleColumnSlots\">\n\n      <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [gutterHeight]=\"columnSlot.dikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:false\"\n          [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n          [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n          [resizerType]=\"columnSlot.dikeColumn.columnType\"\n          [columnStructure]=\"columnStructure\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n        </dk-grid-vertical-gutter>\n\n      </ng-container>\n\n      <div class=\"dkg-source-container\"\n        [class.dkg-dragging-front-container]=\"!isDragging\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n        [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n        [cdkDropListData]=\"columnSlot\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n        <dk-grid-cell-header\n          cdkDrag\n          [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n          cdkDragPreviewContainer=\"parent\"\n          (cdkDragStarted)=\"onDragStart($event)\"\n          (cdkDragEnded)=\"onDragEnd($event)\"\n\n          [columnStructure]=\"columnStructure\"\n          [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n          [columnId]=\"columnSlot.dikeColumn.columnId\"\n          [sortable]=\"columnSlot.dikeColumn.sortable\"\n          [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n          [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n          [displayStatus]=\"columnSlot.displayStatus\">\n\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n          <dk-grid-draggable-cell\n            [draggable]=\"columnSlot.dikeColumn.draggable\"\n            [locked]=\"columnSlot.dikeColumn.locked\"\n            *cdkDragPreview>\n            <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n          </dk-grid-draggable-cell>\n\n          <div *cdkDragPlaceholder></div>\n\n        </dk-grid-cell-header>\n\n      </div>\n\n      <div class=\"dkg-drop-swap-container\"\n        [class.dkg-dragging-front-container]=\"isDragging\"\n        [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [ngStyle]=\"{ height: columnSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n        [cdkDropListData]=\"columnSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n        [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-cell-header *ngIf=\"allowColumnDragging$ | async\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeaderHeight]=\"columnSlot.slotHeight | headerSlotHeight:gridRowHeader\"\n        [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\"\n        [isGroup]=\"columnSlot.dikeColumn.columnType === 'Group-Column'\"\n        [canChangeDisplayStatus]=\"columnSlot.canChangeDisplayStatus\"\n        [displayStatus]=\"columnSlot.displayStatus\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n      </dk-grid-cell-header>\n\n      <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n        <div class=\"dkg-drop-gutter-container\"\n          [class.dkg-dragging-front-container]=\"isDragging\"\n          [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n          [ngStyle]=\"{ height: columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader }\"\n\n          cdkDropList\n          [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n          [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n          (cdkDropListDropped)=\"onDrop($event)\"\n          (cdkDropListEntered)=\"onDropListEntered($event)\"\n          (cdkDropListExited)=\"onDropListExited($event)\"\n\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\">\n\n        </div>\n\n        <dk-grid-vertical-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n          [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n          [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n          [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n          alignSelf=\"self-start\"\n\n          [isHeaderGutter]=\"true\"\n          [flexboxJustifyContent]=\"columnSlot | gutterFlexboxPosition:panel:panelsVisibility:true\"\n          [gutterHeight]=\"columnSlot.complementDikeGutterSlot.slotHeight | headerSlotHeight:gridRowHeader\">\n        </dk-grid-vertical-gutter>\n      </ng-container>\n\n      <dk-grid-horizontal-gutter *ngIf=\"columnSlot.horizontalGutter\"\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.horizontalGutter.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.horizontalGutter.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.horizontalGutter.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.horizontalGutter.gridRowEnd\"\n\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n\n    </ng-container>\n\n  </ng-template>\n\n</div>\n\n<ng-template #displayHeaderValue let-column=\"dikeColumn\">\n  <p\n    [matTooltip]=\"column.headerTooltip\"\n    [matTooltipDisabled]=\"column.headerTooltip === ''\">\n\n    {{ column.headerText }}\n  </p>\n</ng-template>\n", styles: [".dkg-row-header-wrapper{overflow:hidden}.dkg-row-header-wrapper::-webkit-scrollbar{display:none}.dkg-source-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr}.dkg-drop-swap-container,.dkg-drop-gutter-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr;z-index:-1}.dkg-active-drop-gutter-container{border-top:0;border-right-style:solid;border-right-width:5px;box-sizing:border-box}.dkg-dragging-front-container{z-index:50}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i2.ScrollDispatcher }, { type: DkGridConfig }, { type: DkGridStructure }, { type: DkGridContentStructure }, { type: DkContentPanelDispatcher }, { type: DkGroupPanelDispatcher }, { type: DkGridPanelDispatcher }, { type: DkGeneralNotifier }, { type: DkGridUI }];
    }, propDecorators: { columnStructure: [{
                type: Input
            }], scrollableHeaderPanel: [{
                type: ViewChild,
                args: [CdkScrollable]
            }] } });

class DkHeadersModule {
}
DkHeadersModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkHeadersModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkHeadersModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkHeadersModule, declarations: [DkGridRowHeaderComponent,
        DkGridCellHeaderComponent,
        DkGridRowHeaderDirective,
        HeaderSlotHeightPipe], imports: [CommonModule,
        DragDropModule,
        ScrollingModule,
        OverlayModule,
        MatSortModule,
        MatButtonModule,
        MatIconModule,
        MatTooltipModule,
        DkGuttersModule,
        DkCommonModule,
        DkSortingModule], exports: [DkGridRowHeaderComponent] });
DkHeadersModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkHeadersModule, imports: [[
            CommonModule,
            DragDropModule,
            ScrollingModule,
            OverlayModule,
            MatSortModule,
            MatButtonModule,
            MatIconModule,
            MatTooltipModule,
            DkGuttersModule,
            DkCommonModule,
            DkSortingModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkHeadersModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridRowHeaderComponent,
                        DkGridCellHeaderComponent,
                        DkGridRowHeaderDirective,
                        HeaderSlotHeightPipe
                    ],
                    imports: [
                        CommonModule,
                        DragDropModule,
                        ScrollingModule,
                        OverlayModule,
                        MatSortModule,
                        MatButtonModule,
                        MatIconModule,
                        MatTooltipModule,
                        DkGuttersModule,
                        DkCommonModule,
                        DkSortingModule
                    ],
                    exports: [
                        DkGridRowHeaderComponent
                    ]
                }]
        }] });

class SelectableRowPipe {
    transform(row, isSelectable) {
        return isSelectable(row.entry);
    }
}
SelectableRowPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SelectableRowPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
SelectableRowPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SelectableRowPipe, name: "selectableRowPipe" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: SelectableRowPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'selectableRowPipe'
                }]
        }] });

class DkGridRowSelectionComponent {
    constructor(dikeConfig, cdr, gridSelection, gridSelectionConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridSelection = gridSelection;
        this.gridSelectionConfig = gridSelectionConfig;
        this.changesSelectionSubscription = Subscription.EMPTY;
        this.row = null;
        this.isSelected = false;
        this.isHeaderRow = false;
        this.isIndependentTrack = true;
        this.rowContentHeightPx = '';
        this.rowHorizontalGutterHeightPx = '';
        this.isVerticalLineVisible = true;
        this.rowContentWidthPx = `${this.dikeConfig.ROW_SELECTION_CELL_WIDTH - this.dikeConfig.COLUMN_GAP}px`;
        this.rowVerticalGutterWidthPx = `${this.dikeConfig.COLUMN_GAP}px`;
    }
    ngOnChanges(changes) {
        if (changes['rowContentHeightPx'] || changes['rowHorizontalGutterHeightPx'] || changes['isIndependentTrack']) {
            this.setGridDisplay();
        }
        if (changes['row'] && !!this.row) {
            this.allSelected$ = null;
            this.someSelected$ = null;
            if (this.row instanceof DkGridGroupRowEntry) {
                this.allSelected$ = this.row.allRowsSelectedChange;
                this.someSelected$ = this.row.someRowsSelectedChange;
                this.enableAllRowSelection$ = this.isHeaderRow ? this.gridSelectionConfig.onEnableAllRowsSelectionChanged$ : of(true);
            }
            else {
                // Get the current select state for the given data column:
                this.isSelected = this.row.selected;
                // Then, listen to selection changes:
                this.setChangesSelectionSubscription(this.row);
            }
        }
    }
    ngOnDestroy() {
        this.changesSelectionSubscription.unsubscribe();
    }
    changeSelection(value) {
        if (value) {
            this.gridSelection.selectOne(this.row);
        }
        else {
            this.gridSelection.deselectOne(this.row);
        }
    }
    selectAll(value) {
        this.row.selected = value;
    }
    setGridDisplay() {
        const horizontalGutter = this.isIndependentTrack ? `${this.rowHorizontalGutterHeightPx}` : '';
        const verticalGutter = this.isIndependentTrack ? `${this.rowVerticalGutterWidthPx}` : '';
        this.rowGridDisplay = {
            display: 'grid',
            gridTemplateRows: `${this.rowContentHeightPx} ${horizontalGutter}`,
            gridTemplateColumns: `${this.rowContentWidthPx} ${verticalGutter}`
        };
    }
    setChangesSelectionSubscription(row) {
        this.changesSelectionSubscription.unsubscribe();
        this.changesSelectionSubscription = row.selectedChange.subscribe(value => {
            this.isSelected = value;
            this.cdr.markForCheck();
        });
    }
}
DkGridRowSelectionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowSelectionComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridSelection }, { token: DkGridSelectionConfig }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowSelectionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowSelectionComponent, selector: "dk-grid-row-selection", inputs: { row: "row", isHeaderRow: "isHeaderRow", isIndependentTrack: "isIndependentTrack", rowContentHeightPx: "rowContentHeightPx", rowHorizontalGutterHeightPx: "rowHorizontalGutterHeightPx", isVerticalLineVisible: "isVerticalLineVisible", selectableRow: "selectableRow" }, host: { properties: { "class.dkg-row-selection-header": "isHeaderRow", "style.display": "rowGridDisplay.display", "style.gridTemplateRows": "rowGridDisplay.gridTemplateRows", "style.gridTemplateColumns": "rowGridDisplay.gridTemplateColumns" }, classAttribute: "dkg-row-selection" }, usesOnChanges: true, ngImport: i0, template: "<dk-grid-empty-cell\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  [isHeaderCell]=\"isHeaderRow\"\n  contentAlign=\"center\">\n\n  <ng-container *ngIf=\"!!row && !row.isGroup; else groupRow\">\n    <mat-checkbox\n      [disabled]=\"!(row | selectableRowPipe:selectableRow)\"\n      [checked]=\"isSelected\"\n      (change)=\"changeSelection($event.checked)\">\n    </mat-checkbox>\n  </ng-container>\n\n  <ng-template #groupRow>\n    <mat-checkbox *ngIf=\"enableAllRowSelection$ | async\"\n      [checked]=\"allSelected$ | async\"\n      [indeterminate]=\"someSelected$ | async\"\n      (change)=\"selectAll($event.checked)\">\n    </mat-checkbox>\n  </ng-template>\n\n</dk-grid-empty-cell>\n\n<dk-grid-vertical-gutter\n  dkGridItemPlacement\n  [gridColumnStart]=\"2\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [isEmpty]=\"!isVerticalLineVisible || !isIndependentTrack\"\n  [isHeaderGutter]=\"isHeaderRow\"\n  [gutterHeight]=\"rowContentHeightPx\">\n</dk-grid-vertical-gutter>\n\n<dk-grid-horizontal-gutter *ngIf=\"isIndependentTrack\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 2\"\n  [gridRowStart]=\"2\"\n  gridRowEnd=\"span 1\"\n\n  [gutterHeight]=\"rowHorizontalGutterHeightPx\">\n</dk-grid-horizontal-gutter>\n", styles: [""], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }], directives: [{ type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "selectableRowPipe": SelectableRowPipe, "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowSelectionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-selection', host: {
                        'class': 'dkg-row-selection',
                        '[class.dkg-row-selection-header]': 'isHeaderRow',
                        '[style.display]': 'rowGridDisplay.display',
                        '[style.gridTemplateRows]': 'rowGridDisplay.gridTemplateRows',
                        '[style.gridTemplateColumns]': 'rowGridDisplay.gridTemplateColumns'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<dk-grid-empty-cell\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [cellHeight]=\"rowContentHeightPx\"\n  [isHeaderCell]=\"isHeaderRow\"\n  contentAlign=\"center\">\n\n  <ng-container *ngIf=\"!!row && !row.isGroup; else groupRow\">\n    <mat-checkbox\n      [disabled]=\"!(row | selectableRowPipe:selectableRow)\"\n      [checked]=\"isSelected\"\n      (change)=\"changeSelection($event.checked)\">\n    </mat-checkbox>\n  </ng-container>\n\n  <ng-template #groupRow>\n    <mat-checkbox *ngIf=\"enableAllRowSelection$ | async\"\n      [checked]=\"allSelected$ | async\"\n      [indeterminate]=\"someSelected$ | async\"\n      (change)=\"selectAll($event.checked)\">\n    </mat-checkbox>\n  </ng-template>\n\n</dk-grid-empty-cell>\n\n<dk-grid-vertical-gutter\n  dkGridItemPlacement\n  [gridColumnStart]=\"2\"\n  gridColumnEnd=\"span 1\"\n  [gridRowStart]=\"1\"\n  gridRowEnd=\"span 1\"\n\n  [isEmpty]=\"!isVerticalLineVisible || !isIndependentTrack\"\n  [isHeaderGutter]=\"isHeaderRow\"\n  [gutterHeight]=\"rowContentHeightPx\">\n</dk-grid-vertical-gutter>\n\n<dk-grid-horizontal-gutter *ngIf=\"isIndependentTrack\"\n  dkGridItemPlacement\n  [gridColumnStart]=\"1\"\n  gridColumnEnd=\"span 2\"\n  [gridRowStart]=\"2\"\n  gridRowEnd=\"span 1\"\n\n  [gutterHeight]=\"rowHorizontalGutterHeightPx\">\n</dk-grid-horizontal-gutter>\n", styles: [""] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridSelection }, { type: DkGridSelectionConfig }];
    }, propDecorators: { row: [{
                type: Input
            }], isHeaderRow: [{
                type: Input
            }], isIndependentTrack: [{
                type: Input
            }], rowContentHeightPx: [{
                type: Input
            }], rowHorizontalGutterHeightPx: [{
                type: Input
            }], isVerticalLineVisible: [{
                type: Input
            }], selectableRow: [{
                type: Input
            }] } });

class DkSelectionModule {
}
DkSelectionModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSelectionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkSelectionModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSelectionModule, declarations: [DkGridRowSelectionComponent,
        SelectableRowPipe], imports: [CommonModule,
        MatCheckboxModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkGridRowSelectionComponent] });
DkSelectionModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSelectionModule, imports: [[
            CommonModule,
            MatCheckboxModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkSelectionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridRowSelectionComponent,
                        SelectableRowPipe
                    ],
                    imports: [
                        CommonModule,
                        MatCheckboxModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridRowSelectionComponent
                    ]
                }]
        }] });

class DkGridFilter {
    constructor(gridFilterConfig, filterDispatcher, dataSourceDispatcher) {
        this.gridFilterConfig = gridFilterConfig;
        this.filterDispatcher = filterDispatcher;
        this.dataSourceDispatcher = dataSourceDispatcher;
        this.changeDataSourceSubscription = Subscription.EMPTY;
        this.setChangeDataSourceSubscription();
    }
    ngOnDestroy() {
        this.changeDataSourceSubscription.unsubscribe();
    }
    get registerFilterableChange() {
        return this.gridFilterConfig.registerEmitter.asObservable();
    }
    get deregisterFilterableChange() {
        return this.gridFilterConfig.deregisterEmitter.asObservable();
    }
    get filterChange() {
        return this.gridFilterConfig.filterEmitter.asObservable();
    }
    get editionFilterChange() {
        return this.gridFilterConfig.editionFilterEmitter.asObservable();
    }
    get clearFilterChange() {
        return this.gridFilterConfig.clearFilterEmitter.asObservable();
    }
    get clearEditionFilterChange() {
        return this.gridFilterConfig.clearEditionFilterEmitter.asObservable();
    }
    get filterables() {
        return this.gridFilterConfig.filterables;
    }
    clearFilter() {
        this.gridFilterConfig.clearFilter();
    }
    isFilterApplied() {
        return this.filterDispatcher.isFilterApplied();
    }
    getFilteredRows() {
        if (this.filterDispatcher.isFilterApplied()) {
            return !!this.gridDataSource && !!this.editionFiltering ?
                this.filterDispatcher.filterEntries(this.editionFiltering.data, this.gridFilterConfig.filterables) : [];
        }
        return [];
    }
    setChangeDataSourceSubscription() {
        this.changeDataSourceSubscription.unsubscribe();
        this.changeDataSourceSubscription = this.dataSourceDispatcher.onDikeGridDataSourceChanged$.pipe(filter(value => value != null && value != undefined)).subscribe(value => {
            // We receive the non-decorated dataSource:
            this.gridDataSource = value;
            /**
             * Decorate the DkGridDataSource with the edition decorators:
             *
             * Note: Refreshing decorator is set inside the method createEditionFilteringDecorator(...).
             */
            this.editionFiltering = this.dataSourceDispatcher.createEditionFilteringDecorator(this.gridDataSource);
        });
    }
}
DkGridFilter.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilter, deps: [{ token: DkGridFilterConfig }, { token: DkFilterDispatcher }, { token: DkDataSourceDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridFilter.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilter });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFilter, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridFilterConfig }, { type: DkFilterDispatcher }, { type: DkDataSourceDispatcher }]; } });

class DkGridRowGroupContainerDirective {
    constructor(dikeConfig, cdr, gridContentStructure, rowGroupingConfig) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.rowGroupingConfig = rowGroupingConfig;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    get horizontalGutterHeightPx() {
        return `${this.rowContent.horizontalGutterHeight}px`;
    }
    get horizontalGutterHeight() {
        return this.rowContent.horizontalGutterHeight;
    }
    get contentHeightPx() {
        return `${this.rowContent.contentHeight}px`;
    }
    get contentHeight() {
        return this.rowContent.contentHeight;
    }
    get rowHeightPx() {
        return `${this.rowContent.rowHeight}px`;
    }
    get rowHeight() {
        return this.rowContent.rowHeight;
    }
    ngOnChanges(changes) {
        if (changes['level']) {
            this.gridTemplateColumnsValue = this.getGridTemplateColumns(this.level, this.rowGroupingConfig.rowGroupingIndentWidth);
        }
    }
    ngOnInit() {
        this.gridContentStructure.onContentRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.rowContent = value;
            this.gridTemplateRowsValue = `${value.contentHeight}px ${value.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
        this.rowGroupingConfig.onRowGroupingIndentWidthChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = this.getGridTemplateColumns(this.level, value);
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    getGridTemplateColumns(level, rowGroupingIndentWidth) {
        const indent = `${level * rowGroupingIndentWidth}px`;
        const collapseIcon = `${this.dikeConfig.ROW_GROUPING_COLLAPSE_CELL_WIDTH}px`;
        const selectionCheckbox = `${this.dikeConfig.ROW_SELECTION_CELL_WIDTH}px`;
        const content = '1fr';
        const filterCount = `1fr`;
        const filterIcon = `${this.dikeConfig.ROW_GROUPING_INFO_ICON_WIDTH}px`;
        // grid-template-columns: Indent collapse-icon selection-checkbox Content filter-icon filter-count:
        return `${indent} ${collapseIcon} ${selectionCheckbox} ${content} ${filterCount} ${filterIcon}`;
    }
}
DkGridRowGroupContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupContainerDirective, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }, { token: DkRowGroupingConfig }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowGroupContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupContainerDirective, selector: "[dkGridRowGroupContainer]", inputs: { level: ["dkGridRowGroupContainer", "level"] }, host: { properties: { "style.display": "formatContext", "style.grid-template-columns": "gridTemplateColumnsValue", "style.grid-template-rows": "gridTemplateRowsValue" } }, exportAs: ["dkgRowGroupContainer"], usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRowGroupContainer]',
                    exportAs: 'dkgRowGroupContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue'
                    }
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }, { type: DkRowGroupingConfig }];
    }, propDecorators: { level: [{
                type: Input,
                args: ['dkGridRowGroupContainer']
            }] } });

class GroupDisplayTemplatePipe {
    transform(row) {
        return row.dataColumn.displayTemplate;
    }
}
GroupDisplayTemplatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupDisplayTemplatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
GroupDisplayTemplatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupDisplayTemplatePipe, name: "groupDisplayTemplate" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupDisplayTemplatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'groupDisplayTemplate'
                }]
        }] });

class GroupKeyPipe {
    transform(row) {
        return row.key;
    }
}
GroupKeyPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupKeyPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
GroupKeyPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupKeyPipe, name: "groupKey" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupKeyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'groupKey'
                }]
        }] });

class GroupCountPipe {
    transform(row, propertyName) {
        return row[propertyName];
    }
}
GroupCountPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupCountPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
GroupCountPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupCountPipe, name: "groupCount" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: GroupCountPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'groupCount'
                }]
        }] });

class DkGridRowGroupComponent {
    constructor(cdr, gridFilter, gridSelectionConfig, rowGroupingDispatcher) {
        this.cdr = cdr;
        this.gridFilter = gridFilter;
        this.gridSelectionConfig = gridSelectionConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.rowLevel = 0;
        this.isFilterApplied = false;
        this.unsubscribeAll = new Subject();
    }
    ngOnChanges(changes) {
        if (changes['row']) {
            this.rowLevel = this.row.level;
            this.isFilterApplied = this.gridFilter.isFilterApplied();
            this.allRowsSelected$ = this.row.allRowsSelectedChange;
            this.rowCollapse$ = this.row.collapseChange;
        }
    }
    ngOnInit() {
        const gridFilter$ = merge(this.gridFilter.clearFilterChange, this.gridFilter.clearEditionFilterChange, this.gridFilter.filterChange, this.gridFilter.editionFilterChange);
        gridFilter$.pipe(takeUntil(this.unsubscribeAll)).subscribe(() => {
            this.isFilterApplied = this.gridFilter.isFilterApplied();
            this.cdr.markForCheck();
        });
        this.onAllowSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$;
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    onOpenCloseGroup() {
        this.rowGroupingDispatcher.collapseGroup(this.row);
    }
}
DkGridRowGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridFilter }, { token: DkGridSelectionConfig }, { token: DkRowGroupingDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupComponent, selector: "dk-grid-row-group", inputs: { row: "row", rowGroupHeight: "rowGroupHeight" }, host: { properties: { "style.height": "rowGroupHeight" }, classAttribute: "dkg-row-group" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"dkg-row-group-wrapper\"\n  [class.dkg-row-group-selected]=\"allRowsSelected$ | async\"\n  [dkGridRowGroupContainer]=\"rowLevel\"\n  #rowGroupContainer=\"dkgRowGroupContainer\">\n\n  <!-- Indent -->\n  <dk-grid-empty-cell *ngIf=\"rowLevel > 0\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\">\n\n  </dk-grid-empty-cell>\n\n  <!-- Collapse icon -->\n  <dk-grid-empty-cell class=\"dkg-row-group-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"2\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <button mat-icon-button (click)=\"onOpenCloseGroup()\">\n      <ng-container *ngIf=\"(rowCollapse$ | async); else openGroup\">\n        <mat-icon>keyboard_arrow_right</mat-icon>\n      </ng-container>\n    </button>\n\n  </dk-grid-empty-cell>\n\n  <!-- Selection checkbox -->\n  <dk-grid-row-selection *ngIf=\"onAllowSelection$ | async\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"3\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [row]=\"row\"\n    [isIndependentTrack]=\"false\"\n    [rowContentHeightPx]=\"rowGroupContainer.contentHeightPx\">\n  </dk-grid-row-selection>\n\n  <!-- Content -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"(onAllowSelection$ | async) ? 4 : 3\"\n    [gridColumnEnd]=\"(onAllowSelection$ | async) ? 'span 1' : 'span 2'\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"start\">\n\n    <div class=\"dkg-row-group-content\" [style.height]=\"rowGroupContainer.contentHeightPx\">\n      <ng-container *ngIf=\"!!row.key; else empty\">\n        <ng-container *ngTemplateOutlet=\"row | groupDisplayTemplate; context: { fieldValue: row | groupKey }\"></ng-container>\n      </ng-container>\n      <ng-template #empty>\n        <p>Empty</p>\n      </ng-template>\n      <p>&nbsp;</p>\n      <p>( {{ row | groupCount:'totalCount' | number }} )</p>\n    </div>\n\n  </dk-grid-empty-cell>\n\n  <!-- filter rows -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"5\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"end\">\n\n    <p *ngIf=\"isFilterApplied\">{{ row.count | number }}</p>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-empty-cell class=\"dkg-row-group-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"6\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <mat-icon *ngIf=\"isFilterApplied\">filter_list</mat-icon>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 6\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"rowGroupContainer.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n  <ng-template #openGroup>\n    <mat-icon>keyboard_arrow_down</mat-icon>\n  </ng-template>\n</div>\n", styles: [".dkg-row-group-content{display:flex;flex-direction:row;justify-content:flex-start;align-items:center}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: DkGridRowSelectionComponent, selector: "dk-grid-row-selection", inputs: ["row", "isHeaderRow", "isIndependentTrack", "rowContentHeightPx", "rowHorizontalGutterHeightPx", "isVerticalLineVisible", "selectableRow"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }], directives: [{ type: DkGridRowGroupContainerDirective, selector: "[dkGridRowGroupContainer]", inputs: ["dkGridRowGroupContainer"], exportAs: ["dkgRowGroupContainer"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "async": i8.AsyncPipe, "groupDisplayTemplate": GroupDisplayTemplatePipe, "groupKey": GroupKeyPipe, "number": i8.DecimalPipe, "groupCount": GroupCountPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-group', host: {
                        'class': 'dkg-row-group',
                        '[style.height]': 'rowGroupHeight'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-group-wrapper\"\n  [class.dkg-row-group-selected]=\"allRowsSelected$ | async\"\n  [dkGridRowGroupContainer]=\"rowLevel\"\n  #rowGroupContainer=\"dkgRowGroupContainer\">\n\n  <!-- Indent -->\n  <dk-grid-empty-cell *ngIf=\"rowLevel > 0\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\">\n\n  </dk-grid-empty-cell>\n\n  <!-- Collapse icon -->\n  <dk-grid-empty-cell class=\"dkg-row-group-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"2\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <button mat-icon-button (click)=\"onOpenCloseGroup()\">\n      <ng-container *ngIf=\"(rowCollapse$ | async); else openGroup\">\n        <mat-icon>keyboard_arrow_right</mat-icon>\n      </ng-container>\n    </button>\n\n  </dk-grid-empty-cell>\n\n  <!-- Selection checkbox -->\n  <dk-grid-row-selection *ngIf=\"onAllowSelection$ | async\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"3\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [row]=\"row\"\n    [isIndependentTrack]=\"false\"\n    [rowContentHeightPx]=\"rowGroupContainer.contentHeightPx\">\n  </dk-grid-row-selection>\n\n  <!-- Content -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"(onAllowSelection$ | async) ? 4 : 3\"\n    [gridColumnEnd]=\"(onAllowSelection$ | async) ? 'span 1' : 'span 2'\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"start\">\n\n    <div class=\"dkg-row-group-content\" [style.height]=\"rowGroupContainer.contentHeightPx\">\n      <ng-container *ngIf=\"!!row.key; else empty\">\n        <ng-container *ngTemplateOutlet=\"row | groupDisplayTemplate; context: { fieldValue: row | groupKey }\"></ng-container>\n      </ng-container>\n      <ng-template #empty>\n        <p>Empty</p>\n      </ng-template>\n      <p>&nbsp;</p>\n      <p>( {{ row | groupCount:'totalCount' | number }} )</p>\n    </div>\n\n  </dk-grid-empty-cell>\n\n  <!-- filter rows -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"5\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"end\">\n\n    <p *ngIf=\"isFilterApplied\">{{ row.count | number }}</p>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-empty-cell class=\"dkg-row-group-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"6\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"rowGroupContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <mat-icon *ngIf=\"isFilterApplied\">filter_list</mat-icon>\n\n  </dk-grid-empty-cell>\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 6\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"rowGroupContainer.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n  <ng-template #openGroup>\n    <mat-icon>keyboard_arrow_down</mat-icon>\n  </ng-template>\n</div>\n", styles: [".dkg-row-group-content{display:flex;flex-direction:row;justify-content:flex-start;align-items:center}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridFilter }, { type: DkGridSelectionConfig }, { type: DkRowGroupingDispatcher }]; }, propDecorators: { row: [{
                type: Input
            }], rowGroupHeight: [{
                type: Input
            }] } });

class DkGridRowGroupingCellComponent {
    constructor(gridConfig, dikeContextMenu, gridPanelDispatcher) {
        this.gridConfig = gridConfig;
        this.dikeContextMenu = dikeContextMenu;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.changeAllowColumnDraggingSubscription = Subscription.EMPTY;
        this.isMouseOver = false;
        this.columnId = '';
        this.sortable = false;
        this.cellHeight = '';
        this.cursorType = 'default';
        this.isMovable = false;
        this.allowColumnDragging = false;
    }
    ngOnInit() {
        this.columnSlot = this.columnStructure ? this.columnStructure.getColumnSlot(this.columnId) : null;
        this.isMovable = !!this.columnSlot && this.columnSlot.dikeColumn.draggable && !this.columnSlot.dikeColumn.locked;
        /**
         * MUST CHANGE !!!
         *
         * For now, all sortable columns will be non-sortable columns when they
         * are inserted into the group panel.
         *
         * The idea is that any sortable column could sort the corresponding level
         * in the row-grouping tree.
         */
        this.sortable = false;
        /**
         * MUST CHANGE !!!
         *
         * Same as sortable. The context menu is hidden avoiding filtering operation
         * for filterable columns.
         *
         * The actual implementation will allow filtering the group nodes in the
         * row-grouping tree corresponding to the level the filterable-column represents.
         */
        this.contextMenu = false;
        this.setChangeAllowColumnDraggingSubscription();
    }
    ngOnDestroy() {
        this.changeAllowColumnDraggingSubscription.unsubscribe();
    }
    mouseOver() {
        this.isMouseOver = true;
        this.cursorType = this.allowColumnDragging ? 'grab' : 'default';
    }
    mouseLeave() {
        this.isMouseOver = false;
        this.cursorType = 'default';
    }
    mouseDown(e) {
        if (!this.allowColumnDragging) {
            e.preventDefault();
            this.cursorType = 'default';
            e.stopPropagation();
            return false;
        }
        this.cursorType = 'grabbing';
    }
    mouseUp() {
        this.cursorType = this.allowColumnDragging ? 'grab' : 'default';
    }
    onShowContextMenu(origin) {
        if (!!this.columnSlot) {
            this.dikeContextMenuRef = this.dikeContextMenu.open(origin.elementRef, DkColumnContextMenuComponent, {
                height: this.gridConfig.columnContextMenuHeight,
                width: this.gridConfig.columnContextMenuWidth,
                hasBackdrop: true,
                panelClass: 'dkg-column-context-menu-panel',
                backdropClass: 'dkg-column-context-menu-backdrop',
                data: {
                    columnSlot: this.columnSlot
                }
            });
        }
    }
    onRemoveColumn() {
        if (!!this.columnSlot) {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(this.columnSlot, this.gridPanelDispatcher.gridPanels[this.columnSlot.dikeColumn.panel], this.gridPanelDispatcher.gridPanels.centerPanel);
        }
    }
    setChangeAllowColumnDraggingSubscription() {
        this.changeAllowColumnDraggingSubscription.unsubscribe();
        this.changeAllowColumnDraggingSubscription = this.gridConfig.onAllowColumnDraggingChanged$.subscribe(value => this.allowColumnDragging = value);
    }
}
DkGridRowGroupingCellComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingCellComponent, deps: [{ token: DkGridConfig }, { token: DkContextMenu }, { token: DkGridPanelDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowGroupingCellComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupingCellComponent, selector: "dk-grid-row-grouping-cell", inputs: { columnStructure: "columnStructure", columnId: "columnId", sortable: "sortable", cellHeight: "cellHeight" }, host: { listeners: { "mouseover": "mouseOver()", "mouseleave": "mouseLeave()", "mousedown": "mouseDown($event)", "mouseup": "mouseUp()" }, properties: { "style.height": "cellHeight", "style.cursor": "cursorType" }, classAttribute: "dkg-row-grouping-cell dkg-row-grouping-cell-border" }, ngImport: i0, template: "<div class=\"dkg-row-grouping-cell-container dkg-row-grouping-cell-content\" [mat-sort-header]=\"columnId\" [disabled]=\"!sortable\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-row-grouping-cell-container dkg-row-grouping-cell-actions\">\n\n  <div class=\"dkg-row-grouping-cell-options\">\n    <button *ngIf=\"isMouseOver && contextMenu\" cdkOverlayOrigin #origin=\"cdkOverlayOrigin\"\n      mat-icon-button (click)=\"onShowContextMenu(origin)\">\n      <mat-icon>menu</mat-icon>\n    </button>\n\n    <button *ngIf=\"isMovable\"\n      mat-icon-button (click)=\"onRemoveColumn()\">\n      <mat-icon>close</mat-icon>\n    </button>\n\n  </div>\n\n</div>\n\n", styles: [".dkg-row-grouping-cell{overflow:hidden;align-self:center;padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-between}.dkg-row-grouping-cell p{margin:0}.dkg-row-grouping-cell-border{border-radius:4px}.dkg-row-grouping-cell-container{display:flex;flex-direction:column;justify-content:center}.dkg-row-grouping-cell-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.dkg-row-grouping-cell-actions{box-sizing:border-box;opacity:.9}.dkg-row-grouping-cell-options{display:flex;flex-direction:row;justify-content:space-around}\n"], components: [{ type: i3$2.MatSortHeader, selector: "[mat-sort-header]", inputs: ["disabled", "mat-sort-header", "arrowPosition", "start", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$1.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-grouping-cell', host: {
                        'class': 'dkg-row-grouping-cell dkg-row-grouping-cell-border',
                        '[style.height]': 'cellHeight',
                        '[style.cursor]': 'cursorType'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-grouping-cell-container dkg-row-grouping-cell-content\" [mat-sort-header]=\"columnId\" [disabled]=\"!sortable\">\n  <ng-content></ng-content>\n</div>\n\n<div class=\"dkg-row-grouping-cell-container dkg-row-grouping-cell-actions\">\n\n  <div class=\"dkg-row-grouping-cell-options\">\n    <button *ngIf=\"isMouseOver && contextMenu\" cdkOverlayOrigin #origin=\"cdkOverlayOrigin\"\n      mat-icon-button (click)=\"onShowContextMenu(origin)\">\n      <mat-icon>menu</mat-icon>\n    </button>\n\n    <button *ngIf=\"isMovable\"\n      mat-icon-button (click)=\"onRemoveColumn()\">\n      <mat-icon>close</mat-icon>\n    </button>\n\n  </div>\n\n</div>\n\n", styles: [".dkg-row-grouping-cell{overflow:hidden;align-self:center;padding-left:7px;padding-right:7px;display:flex;flex-direction:row;justify-content:space-between}.dkg-row-grouping-cell p{margin:0}.dkg-row-grouping-cell-border{border-radius:4px}.dkg-row-grouping-cell-container{display:flex;flex-direction:column;justify-content:center}.dkg-row-grouping-cell-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.dkg-row-grouping-cell-actions{box-sizing:border-box;opacity:.9}.dkg-row-grouping-cell-options{display:flex;flex-direction:row;justify-content:space-around}\n"] }]
        }], ctorParameters: function () { return [{ type: DkGridConfig }, { type: DkContextMenu }, { type: DkGridPanelDispatcher }]; }, propDecorators: { columnStructure: [{
                type: Input
            }], columnId: [{
                type: Input
            }], sortable: [{
                type: Input
            }], cellHeight: [{
                type: Input
            }], mouseOver: [{
                type: HostListener,
                args: ['mouseover']
            }], mouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }], mouseDown: [{
                type: HostListener,
                args: ['mousedown', ['$event']]
            }], mouseUp: [{
                type: HostListener,
                args: ['mouseup']
            }] } });

class DkGridRowGroupingDirective {
    constructor(cdr) {
        this.cdr = cdr;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '1fr';
    }
    ngOnInit() {
        this.columnStructure.onGridTemplateColumnsGroupChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridRowGroupingDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingDirective, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowGroupingDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupingDirective, selector: "[dkGridRowGrouping]", inputs: { columnStructure: ["dkGridRowGrouping", "columnStructure"] }, host: { properties: { "style.display": "formatContext", "style.grid-template-rows": "gridTemplateRowsValue", "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgRowGrouping"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRowGrouping]',
                    exportAs: 'dkgRowGrouping',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { columnStructure: [{
                type: Input,
                args: ['dkGridRowGrouping']
            }] } });

class DkGridRowGroupingComponent {
    constructor(gridConfig, gridStructure, groupPanelDispatcher, gridPanelDispatcher, generalNotifier) {
        this.gridConfig = gridConfig;
        this.gridStructure = gridStructure;
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.generalNotifier = generalNotifier;
        this.sourceContainer = 'source-column-container';
        this.dropSwapContainer = 'drop-swap-column-container';
        this.dropGutterContainer = 'drop-gutter-container';
        this.rowGroupingPanelId = this.groupPanelDispatcher.rowGroupingAreaId;
    }
    ngOnInit() {
        this.panel = this.columnStructure.panel;
        let border$ = combineLatest([
            this.gridStructure.onBorderLeftChanged$,
            this.gridStructure.onBorderRightChanged$,
        ]);
        this.visibleColumnSlots$ = combineLatest([
            border$,
            this.columnStructure.onColumnSlotsChanged$,
            this.gridPanelDispatcher.onShareDropElementsChanged$
        ]).pipe(map(([[leftBorder, rightBorder], slots, panelShareables]) => {
            this.borders = [leftBorder, rightBorder];
            this.shareables = {
                groupPanel: new Map(panelShareables.groupPanel),
                leftPanel: new Map(panelShareables.leftPanel),
                centerPanel: new Map(panelShareables.centerPanel),
                rightPanel: new Map(panelShareables.rightPanel)
            };
            return slots.filter(slot => slot.dikeColumn.visible);
        }));
        this.rowGroupingColumnHeight$ = this.gridStructure.onRowGroupingColumnHeightChanged$.pipe(map(value => `${value}px`));
        this.isDragging$ = this.generalNotifier.onDraggingNotifierChanged$;
        this.allowColumnDragging$ = this.gridConfig.onAllowColumnDraggingChanged$;
    }
    noDroppingAllowed() {
        return false;
    }
    onDragStart(event) {
        this.generalNotifier.notifyColumnSlotDragging(true);
    }
    onDragEnd(event) {
        this.generalNotifier.notifyColumnSlotDragging(false);
    }
    onDropListEntered(entered) {
        this.columnStructure.notifySlotOver(entered.container.data, true);
        this.generalNotifier.notifyRowGroupingColumnSlot(true);
    }
    onDropListExited(exited) {
        this.columnStructure.notifySlotOver(exited.container.data, false);
        this.generalNotifier.notifyRowGroupingColumnSlot(false);
    }
    onDrop(dropped) {
        let sourceSlot = dropped.previousContainer.data;
        let destinationSlot = dropped.container.data;
        this.columnStructure.notifySlotOver(destinationSlot, false);
        this.generalNotifier.notifyRowGroupingColumnSlot(false);
        this.gridPanelDispatcher.interchageColumnSlots(this.gridPanelDispatcher.gridPanels[sourceSlot.dikeColumn.panel], sourceSlot, this.gridPanelDispatcher.gridPanels[destinationSlot.dikeColumn.panel], destinationSlot);
    }
}
DkGridRowGroupingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingComponent, deps: [{ token: DkGridConfig }, { token: DkGridStructure }, { token: DkGroupPanelDispatcher }, { token: DkGridPanelDispatcher }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowGroupingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupingComponent, selector: "dk-grid-row-grouping", inputs: { columnStructure: "columnStructure" }, ngImport: i0, template: "<div class=\"dkg-row-grouping-wrapper\" [dkGridRowGrouping]=\"columnStructure\">\n\n  <ng-container *ngFor=\"let columnSlot of (visibleColumnSlots$ | async)\">\n\n    <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n      <div class=\"dkg-drop-gutter-container\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n        cdkDropList\n        [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n        [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [isEmpty]=\"true\"\n        [gutterHeight]=\"rowGroupingColumnHeight$ | async\">\n        </dk-grid-vertical-gutter>\n    </ng-container>\n\n    <div class=\"dkg-source-container\"\n      [class.dkg-dragging-front-container]=\"!(isDragging$ | async)\"\n      [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n      cdkDropList\n      [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n      [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n      [cdkDropListData]=\"columnSlot\"\n      [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n\n      <dk-grid-row-grouping-cell\n        cdkDrag\n        [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n        cdkDragPreviewContainer=\"parent\"\n        (cdkDragStarted)=\"onDragStart($event)\"\n        (cdkDragEnded)=\"onDragEnd($event)\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeight]=\"rowGroupingColumnHeight$ | async\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [sortable]=\"columnSlot.dikeColumn.sortable\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n        <dk-grid-draggable-cell\n          [draggable]=\"columnSlot.dikeColumn.draggable\"\n          [locked]=\"columnSlot.dikeColumn.locked\"\n          *cdkDragPreview>\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n        </dk-grid-draggable-cell>\n\n        <div *cdkDragPlaceholder></div>\n\n      </dk-grid-row-grouping-cell>\n\n    </div>\n\n    <div class=\"dkg-drop-swap-container dkg-row-grouping-cell-border\"\n      [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n      [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n      [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n      cdkDropList\n      [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n      [cdkDropListData]=\"columnSlot\"\n      (cdkDropListDropped)=\"onDrop($event)\"\n      (cdkDropListEntered)=\"onDropListEntered($event)\"\n      (cdkDropListExited)=\"onDropListExited($event)\"\n      [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n\n    </div>\n\n    <dk-grid-row-grouping-cell *ngIf=\"allowColumnDragging$ | async\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [columnStructure]=\"columnStructure\"\n      [cellHeight]=\"rowGroupingColumnHeight$ | async\"\n      [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\">\n\n      <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n    </dk-grid-row-grouping-cell>\n\n    <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n      <div class=\"dkg-drop-gutter-container\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n        [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [isEmpty]=\"true\"\n        [gutterHeight]=\"rowGroupingColumnHeight$ | async\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n        resizerType=\"Data-Column\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n      </dk-grid-vertical-gutter>\n\n    </ng-container>\n\n  </ng-container>\n</div>\n\n<ng-template #displayHeaderValue let-column=\"dikeColumn\">\n  <p\n    [matTooltip]=\"column.headerTooltip\"\n    [matTooltipDisabled]=\"column.headerTooltip === ''\">\n\n    {{ column.headerText }}\n  </p>\n</ng-template>\n", styles: [".dkg-row-grouping-wrapper{overflow:hidden}.dkg-row-grouping-wrapper::-webkit-scrollbar{display:none}\n"], components: [{ type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridRowGroupingCellComponent, selector: "dk-grid-row-grouping-cell", inputs: ["columnStructure", "columnId", "sortable", "cellHeight"] }, { type: DkGridDraggableCellComponent, selector: "dk-grid-draggable-cell", inputs: ["draggable", "locked"] }], directives: [{ type: DkGridRowGroupingDirective, selector: "[dkGridRowGrouping]", inputs: ["dkGridRowGrouping"], exportAs: ["dkgRowGrouping"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i18.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i18.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i18.CdkDragPreview, selector: "ng-template[cdkDragPreview]", inputs: ["data", "matchSize"] }, { type: i18.CdkDragPlaceholder, selector: "ng-template[cdkDragPlaceholder]", inputs: ["data"] }, { type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: ["dkGridColResizer", "columnStructure", "resizerType", "columnId", "gutterSlot"], exportAs: ["dkgColResizer"] }, { type: i14.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], pipes: { "async": i8.AsyncPipe, "columnOverValueForHeader": ColumnOverValueForHeaderPipe, "draggableContainerId": DraggableContainerIdPipe, "draggingConnectedContainerIds": DraggingConnectedContainerIdsPipe, "sortAlternativeColumnId": SortAlternativeColumnIdPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-grouping', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-grouping-wrapper\" [dkGridRowGrouping]=\"columnStructure\">\n\n  <ng-container *ngFor=\"let columnSlot of (visibleColumnSlots$ | async)\">\n\n    <ng-container *ngIf=\"columnSlot.complementDikeGutterSlot\">\n      <div class=\"dkg-drop-gutter-container\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        [class.dkg-active-drop-gutter-container]=\"(columnSlot.complementDikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n        cdkDropList\n        [id]=\"columnSlot.complementDikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n        [cdkDropListData]=\"columnSlot.complementDikeGutterSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.complementDikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [isEmpty]=\"true\"\n        [gutterHeight]=\"rowGroupingColumnHeight$ | async\">\n        </dk-grid-vertical-gutter>\n    </ng-container>\n\n    <div class=\"dkg-source-container\"\n      [class.dkg-dragging-front-container]=\"!(isDragging$ | async)\"\n      [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n      cdkDropList\n      [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:sourceContainer\"\n      [cdkDropListEnterPredicate]=\"noDroppingAllowed\"\n      [cdkDropListData]=\"columnSlot\"\n      [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n\n      <dk-grid-row-grouping-cell\n        cdkDrag\n        [cdkDragDisabled]=\"!(allowColumnDragging$ | async)\"\n        cdkDragPreviewContainer=\"parent\"\n        (cdkDragStarted)=\"onDragStart($event)\"\n        (cdkDragEnded)=\"onDragEnd($event)\"\n\n        [columnStructure]=\"columnStructure\"\n        [cellHeight]=\"rowGroupingColumnHeight$ | async\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [sortable]=\"columnSlot.dikeColumn.sortable\">\n\n        <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n\n        <dk-grid-draggable-cell\n          [draggable]=\"columnSlot.dikeColumn.draggable\"\n          [locked]=\"columnSlot.dikeColumn.locked\"\n          *cdkDragPreview>\n          <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n        </dk-grid-draggable-cell>\n\n        <div *cdkDragPlaceholder></div>\n\n      </dk-grid-row-grouping-cell>\n\n    </div>\n\n    <div class=\"dkg-drop-swap-container dkg-row-grouping-cell-border\"\n      [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n      [class.dkg-active-drop-column-container]=\"(columnSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n      [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n      cdkDropList\n      [id]=\"columnSlot.dikeColumn.columnId | draggableContainerId:dropSwapContainer\"\n      [cdkDropListData]=\"columnSlot\"\n      (cdkDropListDropped)=\"onDrop($event)\"\n      (cdkDropListEntered)=\"onDropListEntered($event)\"\n      (cdkDropListExited)=\"onDropListExited($event)\"\n      [cdkDropListConnectedTo]=\"columnSlot | draggingConnectedContainerIds:panel:shareables:borders:rowGroupingPanelId\"\n\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\">\n\n    </div>\n\n    <dk-grid-row-grouping-cell *ngIf=\"allowColumnDragging$ | async\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n      [gridRowStart]=\"columnSlot.slotPosition.gridRowStart\"\n      [gridRowEnd]=\"columnSlot.slotPosition.gridRowEnd\"\n      alignSelf=\"self-start\"\n\n      [columnStructure]=\"columnStructure\"\n      [cellHeight]=\"rowGroupingColumnHeight$ | async\"\n      [columnId]=\"columnSlot.dikeColumn.columnId | sortAlternativeColumnId\">\n\n      <ng-container *ngTemplateOutlet=\"displayHeaderValue; context: { dikeColumn: columnSlot.dikeColumn }\"></ng-container>\n    </dk-grid-row-grouping-cell>\n\n    <ng-container *ngIf=\"columnSlot.dikeGutterSlot\">\n      <div class=\"dkg-drop-gutter-container\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        [class.dkg-active-drop-gutter-container]=\"(columnSlot.dikeGutterSlot.onColumnOverChanged$ | async) | columnOverValueForHeader\"\n        [style.height]=\"rowGroupingColumnHeight$ | async\"\n\n        cdkDropList\n        [id]=\"columnSlot.dikeGutterSlot.dikeColumn.columnId | draggableContainerId:dropGutterContainer\"\n        [cdkDropListData]=\"columnSlot.dikeGutterSlot\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\">\n\n      </div>\n\n      <dk-grid-vertical-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n        [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n        [gridRowStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowStart\"\n        [gridRowEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridRowEnd\"\n        alignSelf=\"self-start\"\n\n        [isEmpty]=\"true\"\n        [gutterHeight]=\"rowGroupingColumnHeight$ | async\"\n        [isColumnResizing$]=\"columnSlot.dikeGutterSlot.onColumnResizingChanged$\"\n\n        [dkGridColResizer]=\"columnSlot.dikeColumn.resizable\"\n        resizerType=\"Data-Column\"\n        [columnStructure]=\"columnStructure\"\n        [columnId]=\"columnSlot.dikeColumn.columnId\"\n        [gutterSlot]=\"columnSlot.dikeGutterSlot\">\n      </dk-grid-vertical-gutter>\n\n    </ng-container>\n\n  </ng-container>\n</div>\n\n<ng-template #displayHeaderValue let-column=\"dikeColumn\">\n  <p\n    [matTooltip]=\"column.headerTooltip\"\n    [matTooltipDisabled]=\"column.headerTooltip === ''\">\n\n    {{ column.headerText }}\n  </p>\n</ng-template>\n", styles: [".dkg-row-grouping-wrapper{overflow:hidden}.dkg-row-grouping-wrapper::-webkit-scrollbar{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: DkGridConfig }, { type: DkGridStructure }, { type: DkGroupPanelDispatcher }, { type: DkGridPanelDispatcher }, { type: DkGeneralNotifier }]; }, propDecorators: { columnStructure: [{
                type: Input
            }] } });

class DkGridRowGroupingContainerDirective {
    constructor(dikeConfig, cdr, gridStructure, generalNotifier) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridStructure = gridStructure;
        this.generalNotifier = generalNotifier;
        this.changesRowGroupingRowSubscription = Subscription.EMPTY;
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
        this.rowGroupingRow = this.gridStructure.rowGroupingRow;
    }
    ngOnDestroy() {
        this.changesRowGroupingRowSubscription.unsubscribe();
    }
    ngAfterViewInit() {
        Promise.resolve().then(() => this.setChangesRowGroupingRowSubscription());
    }
    get horizontalGutterHeightPx() {
        return `${this.rowGroupingRow.horizontalGutterHeight}px`;
    }
    get horizontalGutterHeight() {
        return this.rowGroupingRow.horizontalGutterHeight;
    }
    get contentHeightPx() {
        return `${this.rowGroupingRow.contentHeight}px`;
    }
    get contentHeight() {
        return this.rowGroupingRow.contentHeight;
    }
    get rowHeightPx() {
        return `${this.rowGroupingRow.rowHeight}px`;
    }
    get rowHeight() {
        return this.rowGroupingRow.rowHeight;
    }
    setChangesRowGroupingRowSubscription() {
        let rowGroupingConfig$ = combineLatest([
            this.generalNotifier.onScrollbarWidthChanged$,
            this.gridStructure.onRowGroupingRowChanged$
        ]);
        this.changesRowGroupingRowSubscription.unsubscribe();
        this.changesRowGroupingRowSubscription = rowGroupingConfig$.subscribe(([scrollbarWidth, rowGroupingRow]) => {
            this.rowGroupingRow = rowGroupingRow;
            this.gridTemplateColumnsValue = `${this.dikeConfig.ROW_GROUPING_CELL_WIDTH}px 1fr ${this.dikeConfig.COLUMN_GAP}px ${scrollbarWidth}px`;
            this.gridTemplateRowsValue = `${rowGroupingRow.contentHeight}px ${rowGroupingRow.horizontalGutterHeight}px`;
            this.cdr.markForCheck();
        });
    }
}
DkGridRowGroupingContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingContainerDirective, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridStructure }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Directive });
DkGridRowGroupingContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupingContainerDirective, selector: "[dkGridRowGroupingContainer]", host: { properties: { "style.display": "formatContext", "style.grid-template-rows": "gridTemplateRowsValue", "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgRowGroupingContainer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridRowGroupingContainer]',
                    exportAs: 'dkgRowGroupingContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridStructure }, { type: DkGeneralNotifier }];
    } });

class DkGridRowGroupingPanelComponent {
    constructor(render2, generalNotifier, groupPanelDispatcher, gridPanelDispatcher) {
        this.render2 = render2;
        this.generalNotifier = generalNotifier;
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.dropRowGroupingAreaContainer = 'drop-row-grouping-area-container';
        this.rowGroupingPanelId = this.groupPanelDispatcher.rowGroupingAreaId;
    }
    ngOnInit() {
        this.isDragging$ = this.generalNotifier.onDraggingNotifierChanged$;
        this.rowGrouping$ = this.groupPanelDispatcher.onColumnSlotsChanged$.pipe(map(slots => slots.length > 0));
    }
    onDropListEntered(entered) {
        this.render2.addClass(entered.container.element.nativeElement, 'dkg-active-drop-row-grouping-area-container');
        this.generalNotifier.notifyRowGroupingColumnSlot(true);
    }
    onDropListExited(exited) {
        this.render2.removeClass(exited.container.element.nativeElement, 'dkg-active-drop-row-grouping-area-container');
        this.generalNotifier.notifyRowGroupingColumnSlot(false);
    }
    onDrop(dropped) {
        this.render2.removeClass(dropped.container.element.nativeElement, 'dkg-active-drop-row-grouping-area-container');
        this.generalNotifier.notifyRowGroupingColumnSlot(false);
        let droppedContainer = dropped.container.data;
        let droppedColumnSlot = dropped.previousContainer.data;
        if (droppedContainer === this.rowGroupingPanelId) {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(droppedColumnSlot, this.gridPanelDispatcher.gridPanels[droppedColumnSlot.dikeColumn.panel], this.groupPanelDispatcher.groupPanel);
        }
    }
    onClearGroupPanel() {
        this.gridPanelDispatcher.movePanelColumnSlots(this.gridPanelDispatcher.gridPanels.groupPanel, this.gridPanelDispatcher.gridPanels.centerPanel, false);
    }
}
DkGridRowGroupingPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingPanelComponent, deps: [{ token: i0.Renderer2 }, { token: DkGeneralNotifier }, { token: DkGroupPanelDispatcher }, { token: DkGridPanelDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridRowGroupingPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridRowGroupingPanelComponent, selector: "dk-grid-row-grouping-panel", inputs: { emptyPanelMessage: "emptyPanelMessage" }, ngImport: i0, template: "<div class=\"dkg-row-grouping-panel-wrapper\"\n  dkGridRowGroupingContainer #gridRowGroupingContainer=\"dkgRowGroupingContainer\"\n\n  [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n  cdkDropList\n  [id]=\"rowGroupingPanelId | draggableContainerId:dropRowGroupingAreaContainer\"\n  [cdkDropListData]=\"rowGroupingPanelId\"\n  (cdkDropListDropped)=\"onDrop($event)\"\n  (cdkDropListEntered)=\"onDropListEntered($event)\"\n  (cdkDropListExited)=\"onDropListExited($event)\">\n\n  <!-- row-grouping-icon -->\n  <dk-grid-empty-cell class=\"dkg-row-grouping-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridRowGroupingContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <button mat-icon-button [matMenuTriggerFor]=\"clearGroupPanel\">\n      <mat-icon>list</mat-icon>\n    </button>\n\n    <mat-menu #clearGroupPanel=\"matMenu\">\n      <ng-template matMenuContent>\n        <button mat-menu-item [disabled]=\"!(rowGrouping$ | async)\"\n          (click)=\"onClearGroupPanel()\">\n          <mat-icon>highlight_off</mat-icon>\n          <span>Clear</span>\n        </button>\n      </ng-template>\n    </mat-menu>\n\n</dk-grid-empty-cell>\n\n  <!-- row-grouping-columns -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"2\"\n    gridColumnEnd=\"span 2\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridRowGroupingContainer.contentHeightPx\">\n\n    <ng-container *ngIf=\"rowGrouping$ | async; else groupPanelEmpty\">\n      <ng-content></ng-content>\n    </ng-container>\n\n  </dk-grid-empty-cell>\n\n  <!-- row-grouping horizontal gutter -->\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 3\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridRowGroupingContainer.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n</div>\n\n<ng-template #groupPanelEmpty>\n  <p>{{ emptyPanelMessage }}</p>\n</ng-template>\n", styles: [".dkg-row-grouping-panel-wrapper{height:100%;width:100%;box-sizing:border-box}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i9$1.MatMenu, selector: "mat-menu", exportAs: ["matMenu"] }, { type: i9$1.MatMenuItem, selector: "[mat-menu-item]", inputs: ["disabled", "disableRipple", "role"], exportAs: ["matMenuItem"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }], directives: [{ type: DkGridRowGroupingContainerDirective, selector: "[dkGridRowGroupingContainer]", exportAs: ["dkgRowGroupingContainer"] }, { type: i18.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i9$1.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", exportAs: ["matMenuTrigger"] }, { type: i9$1.MatMenuContent, selector: "ng-template[matMenuContent]" }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "async": i8.AsyncPipe, "draggableContainerId": DraggableContainerIdPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGroupingPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-row-grouping-panel', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-row-grouping-panel-wrapper\"\n  dkGridRowGroupingContainer #gridRowGroupingContainer=\"dkgRowGroupingContainer\"\n\n  [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n  cdkDropList\n  [id]=\"rowGroupingPanelId | draggableContainerId:dropRowGroupingAreaContainer\"\n  [cdkDropListData]=\"rowGroupingPanelId\"\n  (cdkDropListDropped)=\"onDrop($event)\"\n  (cdkDropListEntered)=\"onDropListEntered($event)\"\n  (cdkDropListExited)=\"onDropListExited($event)\">\n\n  <!-- row-grouping-icon -->\n  <dk-grid-empty-cell class=\"dkg-row-grouping-icon\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridRowGroupingContainer.contentHeightPx\"\n    contentAlign=\"center\">\n\n    <button mat-icon-button [matMenuTriggerFor]=\"clearGroupPanel\">\n      <mat-icon>list</mat-icon>\n    </button>\n\n    <mat-menu #clearGroupPanel=\"matMenu\">\n      <ng-template matMenuContent>\n        <button mat-menu-item [disabled]=\"!(rowGrouping$ | async)\"\n          (click)=\"onClearGroupPanel()\">\n          <mat-icon>highlight_off</mat-icon>\n          <span>Clear</span>\n        </button>\n      </ng-template>\n    </mat-menu>\n\n</dk-grid-empty-cell>\n\n  <!-- row-grouping-columns -->\n  <dk-grid-empty-cell\n    dkGridItemPlacement\n    [gridColumnStart]=\"2\"\n    gridColumnEnd=\"span 2\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [cellHeight]=\"gridRowGroupingContainer.contentHeightPx\">\n\n    <ng-container *ngIf=\"rowGrouping$ | async; else groupPanelEmpty\">\n      <ng-content></ng-content>\n    </ng-container>\n\n  </dk-grid-empty-cell>\n\n  <!-- row-grouping horizontal gutter -->\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 3\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridRowGroupingContainer.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n</div>\n\n<ng-template #groupPanelEmpty>\n  <p>{{ emptyPanelMessage }}</p>\n</ng-template>\n", styles: [".dkg-row-grouping-panel-wrapper{height:100%;width:100%;box-sizing:border-box}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: DkGeneralNotifier }, { type: DkGroupPanelDispatcher }, { type: DkGridPanelDispatcher }]; }, propDecorators: { emptyPanelMessage: [{
                type: Input
            }] } });

class DkRowGroupingModule {
}
DkRowGroupingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkRowGroupingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingModule, declarations: [DkGridRowGroupComponent,
        DkGridRowGroupingComponent,
        DkGridRowGroupingCellComponent,
        DkGridRowGroupingPanelComponent,
        DkGridRowGroupContainerDirective,
        DkGridRowGroupingContainerDirective,
        DkGridRowGroupingDirective,
        GroupCountPipe,
        GroupDisplayTemplatePipe,
        GroupKeyPipe], imports: [CommonModule,
        DragDropModule,
        OverlayModule,
        MatSortModule,
        MatIconModule,
        MatMenuModule,
        MatButtonModule,
        MatTooltipModule,
        DkGuttersModule,
        DkCommonModule,
        DkSelectionModule,
        DkSortingModule], exports: [DkGridRowGroupComponent,
        DkGridRowGroupingComponent,
        DkGridRowGroupingPanelComponent] });
DkRowGroupingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingModule, imports: [[
            CommonModule,
            DragDropModule,
            OverlayModule,
            MatSortModule,
            MatIconModule,
            MatMenuModule,
            MatButtonModule,
            MatTooltipModule,
            DkGuttersModule,
            DkCommonModule,
            DkSelectionModule,
            DkSortingModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkRowGroupingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridRowGroupComponent,
                        DkGridRowGroupingComponent,
                        DkGridRowGroupingCellComponent,
                        DkGridRowGroupingPanelComponent,
                        DkGridRowGroupContainerDirective,
                        DkGridRowGroupingContainerDirective,
                        DkGridRowGroupingDirective,
                        GroupCountPipe,
                        GroupDisplayTemplatePipe,
                        GroupKeyPipe
                    ],
                    imports: [
                        CommonModule,
                        DragDropModule,
                        OverlayModule,
                        MatSortModule,
                        MatIconModule,
                        MatMenuModule,
                        MatButtonModule,
                        MatTooltipModule,
                        DkGuttersModule,
                        DkCommonModule,
                        DkSelectionModule,
                        DkSortingModule
                    ],
                    exports: [
                        DkGridRowGroupComponent,
                        DkGridRowGroupingComponent,
                        DkGridRowGroupingPanelComponent
                    ]
                }]
        }] });

class DkGridHorizontalScrollingComponent {
    constructor(dikeConfig, generalNotifier, scrollDispatcher) {
        this.dikeConfig = dikeConfig;
        this.generalNotifier = generalNotifier;
        this.scrollDispatcher = scrollDispatcher;
        this.changeScrollingSubscription = Subscription.EMPTY;
        this.isDragging = false;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.panel = this.columnStructure.panel;
        this.outerColumnSlots$ = this.columnStructure.onOuterColumnSlotsChanged$;
        this.scrollbarSlot$ = this.columnStructure.onScrollbarGapSlotChanged$;
        this.visibleDataColumnSlots$ = this.columnStructure.onDataColumnSlotsChanged$.pipe(map(slots => slots.filter(slot => slot.dikeColumn.visible)));
        this.generalNotifier.onDraggingNotifierChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(draggingWarning => this.isDragging = draggingWarning);
    }
    ngAfterViewInit() {
        this.setChangeScrollingSubscription();
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.changeScrollingSubscription.unsubscribe();
    }
    setChangeScrollingSubscription() {
        /**
         * DikeGridHorizontalScrolling component must listen the scroll events
         * from the header.
         *
         * When the user is dragging a column and the user drags the column
         * beyond the visible area, the horizontal scrolling of the header is moved
         * towards the dragged column.
         *
         * Rules to move the horizontal scroll:
         *
         *    1.  The given CdkScrollable must be different of null or undefined.
         *    2.  The CdkVirtualScrollViewport vertical scrolling is ignored. Remember
         *        that CdkVirtualScrollViewport does not have horizontal scrolling.
         *    3.  The given CdkScrollable must not be the horizontal scroll itself.
         *    4.  The CdkScrollable header contains the attribute 'scrollable-header-panel-name'.
         *    5.  The CdkScrollable header could be moved only when the user is dragging a column.
         */
        let headerScrolling$ = this.scrollDispatcher.scrolled(this.dikeConfig.THROTTLE_SCROLL_TIME).pipe(filter(value => !!value && typeof value !== 'undefined' && !(value instanceof CdkVirtualScrollViewport) && value !== this.scrollablePanel), filter(value => typeof value !== 'undefined' &&
            !!value.getElementRef().nativeElement.attributes.getNamedItem('scrollable-header-panel-name') && this.isDragging));
        this.changeScrollingSubscription.unsubscribe();
        this.changeScrollingSubscription = headerScrolling$.subscribe(value => {
            if (typeof value !== 'undefined') {
                let leftOffset = value.measureScrollOffset('left');
                this.scrollablePanel.scrollTo({ left: leftOffset });
            }
        });
    }
}
DkGridHorizontalScrollingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridHorizontalScrollingComponent, deps: [{ token: CONFIG_GRID }, { token: DkGeneralNotifier }, { token: i2.ScrollDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkGridHorizontalScrollingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridHorizontalScrollingComponent, selector: "dk-grid-horizontal-scrolling", inputs: { columnStructure: "columnStructure" }, viewQueries: [{ propertyName: "scrollablePanel", first: true, predicate: CdkScrollable, descendants: true }], ngImport: i0, template: "<div class=\"dkg-horizontal-scrolling-wrapping\" [attr.horizontal-scroll-panel-name]=\"panel\"\n  [dkGridTemplateColumnsHeader]=\"columnStructure\"\n  cdkScrollable>\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n      cellHeight=\"1px\">\n\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      gutterHeight=\"1px\"\n      [isEmpty]=\"true\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container *ngFor=\"let columnSlot of visibleDataColumnSlots$ | async as columnSlots;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      cellHeight=\"1px\">\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      gutterHeight=\"1px\"\n      [isEmpty]=\"true\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <div *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\"\n    [ngStyle]=\"{ 'height': '1px' }\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\"\n    alignSelf=\"self-start\">\n\n  </div>\n\n</div>\n", styles: [".dkg-horizontal-scrolling-wrapping{height:100%;width:100%;display:grid;grid-template-rows:1px 1fr;overflow-x:scroll;overflow-y:hidden}\n"], components: [{ type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }], directives: [{ type: i2.CdkScrollable, selector: "[cdk-scrollable], [cdkScrollable]" }, { type: DkGridTemplateColumnsHeaderDirective, selector: "[dkGridTemplateColumnsHeader]", inputs: ["dkGridTemplateColumnsHeader"], exportAs: ["dkgTemplateColumnsHeader"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridHorizontalScrollingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-horizontal-scrolling', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-horizontal-scrolling-wrapping\" [attr.horizontal-scroll-panel-name]=\"panel\"\n  [dkGridTemplateColumnsHeader]=\"columnStructure\"\n  cdkScrollable>\n\n  <ng-container *ngFor=\"let outerColumnSlot of outerColumnSlots$ | async as outerColumnSlots; last as last;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.slotPosition.gridColumnEnd\"\n      cellHeight=\"1px\">\n\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"!last && outerColumnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"outerColumnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      gutterHeight=\"1px\"\n      [isEmpty]=\"true\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <ng-container *ngFor=\"let columnSlot of visibleDataColumnSlots$ | async as columnSlots;\">\n    <dk-grid-empty-cell\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.slotPosition.gridColumnEnd\"\n\n      cellHeight=\"1px\">\n    </dk-grid-empty-cell>\n\n    <dk-grid-vertical-gutter *ngIf=\"columnSlot.dikeGutterSlot\"\n      dkGridItemPlacement\n      [gridColumnStart]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnStart\"\n      [gridColumnEnd]=\"columnSlot.dikeGutterSlot.slotPosition.gridColumnEnd\"\n\n      gutterHeight=\"1px\"\n      [isEmpty]=\"true\">\n    </dk-grid-vertical-gutter>\n\n  </ng-container>\n\n  <div *ngIf=\"scrollbarSlot$ | async as scrollbarGapSlot\"\n    [ngStyle]=\"{ 'height': '1px' }\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"scrollbarGapSlot.slotPosition.gridColumnStart\"\n    [gridColumnEnd]=\"scrollbarGapSlot.slotPosition.gridColumnEnd\"\n    alignSelf=\"self-start\">\n\n  </div>\n\n</div>\n", styles: [".dkg-horizontal-scrolling-wrapping{height:100%;width:100%;display:grid;grid-template-rows:1px 1fr;overflow-x:scroll;overflow-y:hidden}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGeneralNotifier }, { type: i2.ScrollDispatcher }];
    }, propDecorators: { columnStructure: [{
                type: Input
            }], scrollablePanel: [{
                type: ViewChild,
                args: [CdkScrollable]
            }] } });

class DkScrollingModule {
}
DkScrollingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkScrollingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkScrollingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkScrollingModule, declarations: [DkGridHorizontalScrollingComponent], imports: [CommonModule,
        ScrollingModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkGridHorizontalScrollingComponent] });
DkScrollingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkScrollingModule, imports: [[
            CommonModule,
            ScrollingModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkScrollingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridHorizontalScrollingComponent
                    ],
                    imports: [
                        CommonModule,
                        ScrollingModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridHorizontalScrollingComponent
                    ]
                }]
        }] });

class DkGridContentContainerDirective {
    constructor(cdr, gridContentStructure) {
        this.cdr = cdr;
        this.gridContentStructure = gridContentStructure;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    ngOnInit() {
        this.gridContentStructure.onGridTemplateRowsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateRowsValue = value;
            this.cdr.markForCheck();
        });
        this.gridContentStructure.onGridTemplateColumnsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridContentContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentContainerDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridContentStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridContentContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridContentContainerDirective, selector: "[dkGridContentContainer]", host: { properties: { "style.display": "formatContext", "style.grid-template-columns": "gridTemplateColumnsValue", "style.grid-template-rows": "gridTemplateRowsValue" } }, exportAs: ["dkgContentContainer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridContentContainer]',
                    exportAs: 'dkgContentContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridContentStructure }]; } });

class DkGridContentScrollbarDirective {
    constructor(elementRef, contentPanelDispatcher, generalNotifier) {
        this.elementRef = elementRef;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.generalNotifier = generalNotifier;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.contentPanelDispatcher.onPanelsVisibilityChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => this.setScrollbarGap(value));
    }
    ngAfterViewInit() {
        this.generalNotifier.scrollbarWidth = this.calculateScrollbarWidth();
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    calculateScrollbarWidth() {
        return Math.abs(this.elementRef.nativeElement.offsetWidth - this.elementRef.nativeElement.clientWidth);
    }
    setScrollbarGap(panelTable) {
        this.contentPanelDispatcher.leftPanel.setScrollbarGapColumnSlot(false);
        this.contentPanelDispatcher.centerPanel.setScrollbarGapColumnSlot(false);
        this.contentPanelDispatcher.rightPanel.setScrollbarGapColumnSlot(false);
        let registeredScrollbarwidth = this.generalNotifier.scrollbarWidth;
        let scrollbarGap = registeredScrollbarwidth > 0 ? registeredScrollbarwidth : this.calculateScrollbarWidth();
        if (this.contentPanelDispatcher.isLeftPanelScrollGap(panelTable)) {
            this.contentPanelDispatcher.leftPanel.setScrollbarGapColumnSlot(true, scrollbarGap);
        }
        else if (this.contentPanelDispatcher.isCenterPanelScrollGap(panelTable)) {
            this.contentPanelDispatcher.centerPanel.setScrollbarGapColumnSlot(true, scrollbarGap);
        }
        else if (this.contentPanelDispatcher.isRightPanelScrollGap(panelTable)) {
            this.contentPanelDispatcher.rightPanel.setScrollbarGapColumnSlot(true, scrollbarGap);
        }
        if (registeredScrollbarwidth <= 0) {
            this.generalNotifier.scrollbarWidth = scrollbarGap;
        }
    }
}
DkGridContentScrollbarDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentScrollbarDirective, deps: [{ token: i0.ElementRef }, { token: DkContentPanelDispatcher }, { token: DkGeneralNotifier }], target: i0.ɵɵFactoryTarget.Directive });
DkGridContentScrollbarDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridContentScrollbarDirective, selector: "[dkGridContentScrollbar]", exportAs: ["dkgContentScrollbar"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentScrollbarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridContentScrollbar]',
                    exportAs: 'dkgContentScrollbar'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: DkContentPanelDispatcher }, { type: DkGeneralNotifier }]; } });

class DkGridContentComponent {
    constructor(dikeConfig, cdr, gridConfig, gridStructure, gridContentStructure, contentPanelDispatcher, gridEditionConfig, gridSelectionConfig, gridFilterConfig, generalNotifier, rowGroupingConfig, rowGroupingDispatcher, gridUI) {
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.gridConfig = gridConfig;
        this.gridStructure = gridStructure;
        this.gridContentStructure = gridContentStructure;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.gridEditionConfig = gridEditionConfig;
        this.gridSelectionConfig = gridSelectionConfig;
        this.gridFilterConfig = gridFilterConfig;
        this.generalNotifier = generalNotifier;
        this.rowGroupingConfig = rowGroupingConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.gridUI = gridUI;
        this.changesDataColumnsSubscription = Subscription.EMPTY;
        this.changesBoundDataSubscription = Subscription.EMPTY;
        this.changesHeaderHeightSubscription = Subscription.EMPTY;
        this.changesGridStructureSubscription = Subscription.EMPTY;
        this.changesSelectionSubscription = Subscription.EMPTY;
        this.minBufferPx = 300;
        this.maxBufferPx = 650;
        this.divisionLineWidthPx = `${this.gridConfig.divisionPanelLineWidth}px`;
        this.divisionLineWidthResizingPx = `${this.gridConfig.divisionPanelLineWidthResizing}px`;
        this.divisionPanelSpaceWidthPx = `${this.gridConfig.divisionPanelGap}px`;
        this.headerRowContentHeightPx = '';
        this.headerRowHorizontalGutterHeightPx = '';
        this.filterRowHeightPx = '';
        this.filterRowContentHeightPx = '';
        this.filterRowHorizontalGutterHeightPx = '';
        this.contentRowHeightPx = '';
        this.contentRowContentHeightPx = '';
        this.contentRowHorizontalGutterHeightPx = '';
        this.horizontalScrollHeightPx = '';
        this.verticalGutterWidthPx = `${this.dikeConfig.COLUMN_GAP}px`;
        this.displayEmptyRow = false;
        this.stripedRows = false;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.onRootGroupRow$ = this.rowGroupingDispatcher.onRootGroupRowChanged$;
        this.contentRowHeight$ = this.gridContentStructure.onContentRowHeightChanged$;
        this.displayRowFiltering$ = this.gridFilterConfig.onAllowRowFilterChanged$;
        this.onRowGroupingIndent$ = combineLatest([
            this.rowGroupingConfig.onAllowRowGroupingChanged$,
            this.rowGroupingConfig.onDisplayRowGroupingIndentChanged$,
            this.rowGroupingDispatcher.onGroupPanelCardinalityChanged$
        ]).pipe(map(([allowRowGrouping, displayRowGroupingIndent, groupPanelCardinality]) => allowRowGrouping && displayRowGroupingIndent && groupPanelCardinality > 0));
        this.onEditionMode$ = combineLatest([
            this.gridEditionConfig.onAllowEditionChanged$,
            this.gridEditionConfig.onEditionModeChanged$
        ]).pipe(map(([allowEdition, editionMode]) => allowEdition && editionMode));
        this.onAllowSelection$ = this.gridSelectionConfig.onAllowSelectionChanged$;
        this.selectableFunction$ = this.gridSelectionConfig.onSelectableFnChanged$;
        this.generalNotifier.onScrollbarWidthChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => this.gridContentStructure.setHorizontalScrollHeight(value));
        this.gridContentStructure.onFilterRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.filterRowHeightPx = `${value.rowHeight}px`;
            this.filterRowContentHeightPx = `${value.contentHeight}px`;
            this.filterRowHorizontalGutterHeightPx = `${value.horizontalGutterHeight}px`;
            this.filterIndentGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${value.contentHeight}px ${value.horizontalGutterHeight}px`,
                gridTemplateColumns: `1fr ${this.verticalGutterWidthPx}`
            };
            this.filterSelectionGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${value.contentHeight}px ${value.horizontalGutterHeight}px`,
                gridTemplateColumns: `1fr ${this.verticalGutterWidthPx}`
            };
            this.cdr.markForCheck();
        });
        this.gridContentStructure.onContentRowHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.contentRowHeightPx = `${value.rowHeight}px`;
            this.contentRowContentHeightPx = `${value.contentHeight}px`;
            this.contentRowHorizontalGutterHeightPx = `${value.horizontalGutterHeight}px`;
            this.contentEmptyRowGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${value.contentHeight}px`,
                gridTemplateColumns: `1fr`
            };
            this.contentIndentGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${value.contentHeight}px ${value.horizontalGutterHeight}px`,
                gridTemplateColumns: `1fr ${this.verticalGutterWidthPx}`
            };
            this.cdr.markForCheck();
        });
        this.gridContentStructure.onHorizontalScrollHeightChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.horizontalScrollHeightPx = `${value}px`;
            this.horizontalScrollGridDisplay = {
                display: 'grid',
                gridTemplateRows: `1fr`,
                gridTemplateColumns: `1fr`
            };
            this.cdr.markForCheck();
        });
        this.gridUI.onStripedRowsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.stripedRows = value;
            this.cdr.markForCheck();
        });
        this.gridUI.onVerticalRowLinesChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.verticalRowsLinesVisible = value;
            this.cdr.markForCheck();
        });
        this.setChangesDataColumnsSubscription();
        this.setChangesHeaderHeightSubscription();
    }
    ngAfterViewInit() {
        this.setChangesBoundDataSubscription();
        /**
         * Once the CdkVirtualScrollViewport has been queried from the DOM, we have to get
         * its height. The height will be established in DkGridContentStructure service.
         *
         * In order to get the actual height of the CdkVirtualScrollViewport
         * we must first invoke checkViewportSize() method and then get the size
         * invoking getViewportSize() method.
         *
         * Angular's help says:
         *
         * checkViewportSize updates the viewport dimensions and re-render.
         */
        Promise.resolve().then(() => this.changeCdkVirtualScrollViewport());
        this.setChangesGridStructureSubscription();
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
        this.changesDataColumnsSubscription.unsubscribe();
        this.changesBoundDataSubscription.unsubscribe();
        this.changesHeaderHeightSubscription.unsubscribe();
        this.changesGridStructureSubscription.unsubscribe();
        this.changesSelectionSubscription.unsubscribe();
    }
    setChangesDataColumnsSubscription() {
        const dataColumns$ = this.contentPanelDispatcher.onDataColumnSlotsChanged$.pipe(map(slots => slots.filter(slot => slot.dikeColumn.visible)));
        this.changesDataColumnsSubscription.unsubscribe();
        this.changesDataColumnsSubscription = dataColumns$.subscribe(visibleSlots => {
            const cdkBufferPx = this.gridConfig.getCdkBufferPx(visibleSlots.length);
            this.minBufferPx = cdkBufferPx.minBufferPx;
            this.maxBufferPx = cdkBufferPx.maxBufferPx;
            this.cdr.markForCheck();
        });
    }
    changeCdkVirtualScrollViewport() {
        this.virtualScrollViewport.checkViewportSize();
        this.gridContentStructure.setContentViewPortHeight(this.virtualScrollViewport.getViewportSize());
    }
    setChangesBoundDataSubscription() {
        this.changesBoundDataSubscription.unsubscribe();
        this.changesBoundDataSubscription = this.virtualFor.dataStream.subscribe(value => {
            Promise.resolve().then(() => this.displayEmptyRow = value.length === 0);
        });
    }
    setChangesHeaderHeightSubscription() {
        const headerHeight$ = combineLatest([
            this.gridContentStructure.onHeaderRowHeightChanged$,
            this.contentPanelDispatcher.onListHeightChanged$
        ]);
        this.changesHeaderHeightSubscription.unsubscribe();
        this.changesHeaderHeightSubscription = headerHeight$.subscribe(([rowHeader, greatestHeight]) => {
            let totalHeaderContentHeight = greatestHeight * rowHeader.rowHeight - rowHeader.horizontalGutterHeight;
            this.headerRowContentHeightPx = `${totalHeaderContentHeight}px`;
            this.headerRowHorizontalGutterHeightPx = `${rowHeader.horizontalGutterHeight}px`;
            this.headerGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${totalHeaderContentHeight}px ${rowHeader.horizontalGutterHeight}px `,
                gridTemplateColumns: '1fr'
            };
            this.headerIndentGridDisplay = {
                display: 'grid',
                gridTemplateRows: `${totalHeaderContentHeight}px ${rowHeader.horizontalGutterHeight}px `,
                gridTemplateColumns: `1fr ${this.verticalGutterWidthPx}`
            };
            this.cdr.markForCheck();
        });
    }
    setChangesGridStructureSubscription() {
        /**
         * changesGridStructureSubscription subscription.
         *
         * This subscription listens for any change in the grid structure
         * itself (DkGridStructure) and in its content structure
         * (DkGridContentStructure).
         *
         * Any height change in above structures will change the height of
         * the CdkVirtualScrollViewport, therefore the CdkVirtualScrollViewport
         * must done a re-render after updating its dimensions.
         */
        const gridStructure$ = merge(this.gridStructure.onUpdateCdkScrollViewport$, this.gridContentStructure.onUpdateCdkScrollViewport$);
        this.changesGridStructureSubscription.unsubscribe();
        /**
         * THROTTLE_CHANGING_GRID_STRUCTURE_TIME.
         *
         * Since some structure changes deliver more than one notification, a
         * throttleTime operator is applied. Consider the following scenarios:
         *
         *  1. Column grouping. When a column is grouped the user could open or
         *     close the group if it is allowed. When an open or close action is
         *     performed, the height of the header changes.
         *
         *  2. When column is moving to othe panel or swapping with other column.
         *
         * Due to the movements involved in the above scenarios, many notifications
         * are sent to this subscription in the current event-loop. Remember that
         * only one virtualScrolling re-rendering is needed in the next event-loop.
         * That is why the throttleTime operator is used to take the first notification
         * and ignore the rest of them.
         */
        this.changesGridStructureSubscription = gridStructure$.pipe(throttleTime(this.dikeConfig.THROTTLE_CHANGING_GRID_STRUCTURE_TIME)).subscribe(() => setTimeout(() => this.changeCdkVirtualScrollViewport(), 0));
    }
}
DkGridContentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentComponent, deps: [{ token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: DkGridConfig }, { token: DkGridStructure }, { token: DkGridContentStructure }, { token: DkContentPanelDispatcher }, { token: DkGridEditionConfig }, { token: DkGridSelectionConfig }, { token: DkGridFilterConfig }, { token: DkGeneralNotifier }, { token: DkRowGroupingConfig }, { token: DkRowGroupingDispatcher }, { token: DkGridUI }], target: i0.ɵɵFactoryTarget.Component });
DkGridContentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridContentComponent, selector: "dk-grid-content", inputs: { datasource: "datasource" }, viewQueries: [{ propertyName: "virtualFor", first: true, predicate: CdkVirtualForOf, descendants: true }, { propertyName: "virtualScrollViewport", first: true, predicate: CdkVirtualScrollViewport, descendants: true }], ngImport: i0, template: "<div class=\"dkg-content-wrapper\"\n  dkGridContentContainer>\n\n  <!-- row header -->\n  <dk-row-panels wrapperType=\"header\">\n\n    <!-- indent -->\n    <div *ngIf=\"onRowGroupingIndent$ | async\"\n      row-grouping-indent [ngStyle]=\"headerIndentGridDisplay\">\n\n      <dk-grid-empty-cell\n        [cellHeight]=\"headerRowContentHeightPx\"\n        [isHeaderCell]=\"true\">\n\n        <span>Groups</span>\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerRowContentHeightPx\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"1\"\n        gridColumnEnd=\"span 2\"\n\n        [gutterHeight]=\"headerRowHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n    </div>\n\n    <!-- selection -->\n    <dk-grid-row-selection row-checkbox-selection *ngIf=\"onAllowSelection$ | async\"\n      [rowContentHeightPx]=\"headerRowContentHeightPx\"\n      [rowHorizontalGutterHeightPx]=\"headerRowHorizontalGutterHeightPx\"\n      [row]=\"onRootGroupRow$ | async\"\n      [isHeaderRow]=\"true\">\n    </dk-grid-row-selection>\n\n    <!-- edition -->\n    <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n      [rowContentHeightPx]=\"headerRowContentHeightPx\"\n      [rowHorizontalGutterHeightPx]=\"headerRowHorizontalGutterHeightPx\"\n      [isHeaderRow]=\"true\">\n    </dk-grid-row-edition-menu>\n\n    <!-- left panel header columns -->\n    <dk-grid-row-header left-panel\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n    </dk-grid-row-header>\n\n    <!-- left panel division -->\n    <div left-panel-right-division [ngStyle]=\"headerGridDisplay\">\n      <dk-panel-division\n        [isHeaderDivision]=\"true\"\n        [divisionHeight]=\"headerRowContentHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <dk-panel-division\n        [divisionHeight]=\"headerRowHorizontalGutterHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n    </div>\n\n    <!-- center panel header columns -->\n    <dk-grid-row-header center-panel\n      [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n    </dk-grid-row-header>\n\n    <!-- right panel division -->\n    <div right-panel-left-division [ngStyle]=\"headerGridDisplay\">\n      <dk-panel-division\n        [isHeaderDivision]=\"true\"\n        [divisionHeight]=\"headerRowContentHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <dk-panel-division\n        [divisionHeight]=\"headerRowHorizontalGutterHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n    </div>\n\n    <!-- right panel header columns -->\n    <dk-grid-row-header right-panel\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n    </dk-grid-row-header>\n  </dk-row-panels>\n\n  <!-- row filtering -->\n  <ng-container *ngIf=\"displayRowFiltering$ | async\">\n    <dk-row-panels wrapperType=\"filter\">\n\n      <!-- indent -->\n      <div *ngIf=\"onRowGroupingIndent$ | async\"\n        row-grouping-indent [ngStyle]=\"filterIndentGridDisplay\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"filterRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"filterRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"filterRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- selection -->\n      <div *ngIf=\"onAllowSelection$ | async\"\n        row-checkbox-selection [ngStyle]=\"filterSelectionGridDisplay\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"filterRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"filterRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"filterRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- edition -->\n      <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n        [rowContentHeightPx]=\"filterRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"filterRowHorizontalGutterHeightPx\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\">\n      </dk-grid-row-edition-menu>\n\n      <!-- left panel filter columns -->\n      <dk-row-filter left-panel\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n      </dk-row-filter>\n\n      <!-- left panel division -->\n      <dk-panel-division left-panel-right-division\n        [divisionHeight]=\"filterRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <!-- center panel filter columns -->\n      <dk-row-filter center-panel\n        [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n      </dk-row-filter>\n\n      <!-- right panel division -->\n      <dk-panel-division right-panel-left-division\n        [divisionHeight]=\"filterRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <!-- right panel filter columns -->\n      <dk-row-filter right-panel\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n      </dk-row-filter>\n    </dk-row-panels>\n  </ng-container>\n\n  <!-- row content -->\n  <cdk-virtual-scroll-viewport class=\"dkg-virtual-content-wrapper\"\n    dkGridContentScrollbar\n    [itemSize]=\"(contentRowHeight$ | async).rowHeight\"\n    [minBufferPx]=\"minBufferPx\"\n    [maxBufferPx]=\"maxBufferPx\">\n\n    <ng-container *cdkVirtualFor=\"let gridRow of datasource; index as i; odd as oddRow; even as evenRow; templateCacheSize: 35\">\n\n      <ng-container [ngTemplateOutlet]=\"gridRow.isGroup ? groupRow : dataRow\"\n        [ngTemplateOutletContext]=\"{ row: gridRow, rowHeight: contentRowHeightPx, odd: oddRow, even: evenRow }\">\n      </ng-container>\n\n    </ng-container>\n\n    <!-- empty row -->\n    <ng-container *ngIf=\"displayEmptyRow\">\n      <dk-row-panels [isContentContainer]=\"true\" wrapperType=\"empty-content\">\n\n        <!-- indent -->\n        <div *ngIf=\"onRowGroupingIndent$ | async\"\n          row-grouping-indent [ngStyle]=\"contentEmptyRowGridDisplay\">\n\n          <dk-grid-empty-cell\n            [cellHeight]=\"contentRowContentHeightPx\">\n          </dk-grid-empty-cell>\n        </div>\n\n        <!-- selection -->\n        <div *ngIf=\"onAllowSelection$ | async\"\n          row-checkbox-selection [ngStyle]=\"contentEmptyRowGridDisplay\">\n\n          <dk-grid-empty-cell\n            [cellHeight]=\"contentRowHeightPx\">\n          </dk-grid-empty-cell>\n        </div>\n\n        <!-- edition -->\n        <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n          [isEmptyRow]=\"true\"\n          [rowContentHeightPx]=\"contentRowContentHeightPx\"\n          [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\">\n        </dk-grid-row-edition-menu>\n\n        <!-- left panel columns -->\n        <dk-grid-row-empty left-panel\n          [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.leftPanel\">\n        </dk-grid-row-empty>\n\n        <!-- left panel division -->\n        <div left-panel-right-division [ngStyle]=\"{ height: contentRowHeightPx }\">\n        </div>\n\n        <!-- center panel columns -->\n        <dk-grid-row-empty center-panel\n          [columnStructure]=\"contentPanelDispatcher.centerPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.centerPanel\">\n        </dk-grid-row-empty>\n\n        <!-- right panel division -->\n        <div right-panel-left-division [ngStyle]=\"{ height: contentRowHeightPx }\">\n        </div>\n\n        <!-- right panel columns -->\n        <dk-grid-row-empty right-panel\n          [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.rightPanel\">\n        </dk-grid-row-empty>\n      </dk-row-panels>\n    </ng-container>\n\n  </cdk-virtual-scroll-viewport>\n\n  <ng-template #groupRow let-gridRow=\"row\" let-rowGroupHeight=\"rowHeight\">\n    <!-- group row -->\n    <dk-grid-row-group\n      [row]=\"gridRow\"\n      [rowGroupHeight]=\"rowGroupHeight\">\n    </dk-grid-row-group>\n  </ng-template>\n\n  <ng-template #dataRow let-gridRow=\"row\" let-oddRow=\"odd\" let-evenRow=\"even\">\n    <!-- data row -->\n    <dk-row-panels\n      [isContentContainer]=\"true\"\n      [dkGridRowEditionTriggers]=\"gridRow\">\n\n      <!-- indent -->\n      <div *ngIf=\"onRowGroupingIndent$ | async\"\n        row-grouping-indent [ngStyle]=\"contentIndentGridDisplay\"\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"contentRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"contentRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"contentRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- selection -->\n      <dk-grid-row-selection *ngIf=\"onAllowSelection$ | async\"\n        row-checkbox-selection\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [row]=\"gridRow\"\n        [selectableRow]=\"selectableFunction$ | async\"\n        [rowContentHeightPx]=\"contentRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\">\n      </dk-grid-row-selection>\n\n      <!-- edition -->\n      <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [row]=\"gridRow\"\n        [rowContentHeightPx]=\"contentRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\">\n      </dk-grid-row-edition-menu>\n\n      <!-- left panel content columns -->\n      <dk-grid-row left-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.leftPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n\n      <!-- left panel division -->\n      <dk-panel-division left-panel-right-division\n        [divisionHeight]=\"contentRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\"\n\n        [dkGridColResizer]=\"true\"\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n        resizerType=\"Panel\">\n      </dk-panel-division>\n\n      <!-- center panel content columns -->\n      <dk-grid-row center-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.centerPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.centerPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n\n      <!-- right panel division -->\n      <dk-panel-division right-panel-left-division\n        [divisionHeight]=\"contentRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\"\n\n        [dkGridColResizer]=\"true\"\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n        resizerType=\"Panel\">\n      </dk-panel-division>\n\n      <!-- right panel content columns -->\n      <dk-grid-row right-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.rightPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n    </dk-row-panels>\n  </ng-template>\n\n  <!-- row scrolling -->\n  <dk-row-panels wrapperType=\"scrolling\">\n\n    <!-- indent -->\n    <div *ngIf=\"onRowGroupingIndent$ | async\"\n      row-grouping-indent [ngStyle]=\"horizontalScrollGridDisplay\">\n\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- selection -->\n    <div *ngIf=\"onAllowSelection$ | async\"\n      row-checkbox-selection [ngStyle]=\"horizontalScrollGridDisplay\">\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- edition -->\n    <div *ngIf=\"onEditionMode$ | async\"\n      row-edition-menu [ngStyle]=\"horizontalScrollGridDisplay\">\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- left panel columns -->\n    <dk-grid-horizontal-scrolling left-panel\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n    </dk-grid-horizontal-scrolling>\n\n    <!-- left panel division -->\n    <dk-panel-division left-panel-right-division\n      [divisionHeight]=\"horizontalScrollHeightPx\"\n      [divisionWidth]=\"divisionLineWidthPx\"\n      [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n      [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n      [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\"\n\n      [dkGridColResizer]=\"true\"\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n      resizerType=\"Panel\">\n    </dk-panel-division>\n\n    <!-- center panel columns -->\n    <dk-grid-horizontal-scrolling center-panel\n      [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n    </dk-grid-horizontal-scrolling>\n\n    <!-- right panel division -->\n    <dk-panel-division right-panel-left-division\n      [divisionHeight]=\"horizontalScrollHeightPx\"\n      [divisionWidth]=\"divisionLineWidthPx\"\n      [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n      [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n      [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\"\n\n      [dkGridColResizer]=\"true\"\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n      resizerType=\"Panel\">\n    </dk-panel-division>\n\n    <!-- right panel columns -->\n    <dk-grid-horizontal-scrolling right-panel\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n    </dk-grid-horizontal-scrolling>\n  </dk-row-panels>\n\n</div>\n", styles: [".dkg-content-wrapper{height:100%;width:100%}.dkg-content-wrapper .dkg-virtual-content-wrapper{overflow-x:hidden;overflow-y:scroll;height:100%;width:100%}\n"], components: [{ type: DkRowPanelsComponent, selector: "dk-row-panels", inputs: ["isContentContainer", "wrapperType"] }, { type: DkGridEmptyCellComponent, selector: "dk-grid-empty-cell", inputs: ["isColumnOver$", "cellHeight", "isHeaderCell", "contentAlign"] }, { type: DkGridVerticalGutterComponent, selector: "dk-grid-vertical-gutter", inputs: ["isColumnOver$", "isColumnResizing$", "isEmpty", "isHeaderGutter", "gutterHeight", "flexboxJustifyContent"] }, { type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: DkGridRowSelectionComponent, selector: "dk-grid-row-selection", inputs: ["row", "isHeaderRow", "isIndependentTrack", "rowContentHeightPx", "rowHorizontalGutterHeightPx", "isVerticalLineVisible", "selectableRow"] }, { type: DkGridRowEditionMenuComponent, selector: "dk-grid-row-edition-menu", inputs: ["row", "isHeaderRow", "isEmptyRow", "rowContentHeightPx", "rowHorizontalGutterHeightPx", "isVerticalLineVisible"] }, { type: DkGridRowHeaderComponent, selector: "dk-grid-row-header", inputs: ["columnStructure"] }, { type: DkPanelDivisionComponent, selector: "dk-panel-division", inputs: ["isHeaderDivision", "divisionHeight", "divisionWidth", "divisionWidthResizing", "divisionSpaceWidth", "isPanelResizing$"] }, { type: DkRowFilterComponent, selector: "dk-row-filter", inputs: ["columnStructure"] }, { type: i2.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }, { type: DkGridRowEmptyComponent, selector: "dk-grid-row-empty", inputs: ["columnStructure"] }, { type: DkGridRowGroupComponent, selector: "dk-grid-row-group", inputs: ["row", "rowGroupHeight"] }, { type: DkGridRowComponent, selector: "dk-grid-row", inputs: ["columnStructure", "row", "sourceIndex", "isVerticalLineVisible"] }, { type: DkGridHorizontalScrollingComponent, selector: "dk-grid-horizontal-scrolling", inputs: ["columnStructure"] }], directives: [{ type: DkGridContentContainerDirective, selector: "[dkGridContentContainer]", exportAs: ["dkgContentContainer"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i8.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i2.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { type: DkGridContentScrollbarDirective, selector: "[dkGridContentScrollbar]", exportAs: ["dkgContentScrollbar"] }, { type: i2.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: DkGridRowDirective, selector: "[dkGridRow]", inputs: ["dkGridRow"], exportAs: ["dkgRow"] }, { type: DkGridRowEditionTriggersDirective, selector: "[dkGridRowEditionTriggers]", inputs: ["dkGridRowEditionTriggers"], exportAs: ["dkgRowEditionTriggers"] }, { type: DkGridColResizerDirective, selector: "[dkGridColResizer]", inputs: ["dkGridColResizer", "columnStructure", "resizerType", "columnId", "gutterSlot"], exportAs: ["dkgColResizer"] }], pipes: { "async": i8.AsyncPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid-content', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-content-wrapper\"\n  dkGridContentContainer>\n\n  <!-- row header -->\n  <dk-row-panels wrapperType=\"header\">\n\n    <!-- indent -->\n    <div *ngIf=\"onRowGroupingIndent$ | async\"\n      row-grouping-indent [ngStyle]=\"headerIndentGridDisplay\">\n\n      <dk-grid-empty-cell\n        [cellHeight]=\"headerRowContentHeightPx\"\n        [isHeaderCell]=\"true\">\n\n        <span>Groups</span>\n      </dk-grid-empty-cell>\n\n      <dk-grid-vertical-gutter\n        [isHeaderGutter]=\"true\"\n        [gutterHeight]=\"headerRowContentHeightPx\">\n      </dk-grid-vertical-gutter>\n\n      <dk-grid-horizontal-gutter\n        dkGridItemPlacement\n        [gridColumnStart]=\"1\"\n        gridColumnEnd=\"span 2\"\n\n        [gutterHeight]=\"headerRowHorizontalGutterHeightPx\">\n      </dk-grid-horizontal-gutter>\n    </div>\n\n    <!-- selection -->\n    <dk-grid-row-selection row-checkbox-selection *ngIf=\"onAllowSelection$ | async\"\n      [rowContentHeightPx]=\"headerRowContentHeightPx\"\n      [rowHorizontalGutterHeightPx]=\"headerRowHorizontalGutterHeightPx\"\n      [row]=\"onRootGroupRow$ | async\"\n      [isHeaderRow]=\"true\">\n    </dk-grid-row-selection>\n\n    <!-- edition -->\n    <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n      [rowContentHeightPx]=\"headerRowContentHeightPx\"\n      [rowHorizontalGutterHeightPx]=\"headerRowHorizontalGutterHeightPx\"\n      [isHeaderRow]=\"true\">\n    </dk-grid-row-edition-menu>\n\n    <!-- left panel header columns -->\n    <dk-grid-row-header left-panel\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n    </dk-grid-row-header>\n\n    <!-- left panel division -->\n    <div left-panel-right-division [ngStyle]=\"headerGridDisplay\">\n      <dk-panel-division\n        [isHeaderDivision]=\"true\"\n        [divisionHeight]=\"headerRowContentHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <dk-panel-division\n        [divisionHeight]=\"headerRowHorizontalGutterHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n    </div>\n\n    <!-- center panel header columns -->\n    <dk-grid-row-header center-panel\n      [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n    </dk-grid-row-header>\n\n    <!-- right panel division -->\n    <div right-panel-left-division [ngStyle]=\"headerGridDisplay\">\n      <dk-panel-division\n        [isHeaderDivision]=\"true\"\n        [divisionHeight]=\"headerRowContentHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <dk-panel-division\n        [divisionHeight]=\"headerRowHorizontalGutterHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n    </div>\n\n    <!-- right panel header columns -->\n    <dk-grid-row-header right-panel\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n    </dk-grid-row-header>\n  </dk-row-panels>\n\n  <!-- row filtering -->\n  <ng-container *ngIf=\"displayRowFiltering$ | async\">\n    <dk-row-panels wrapperType=\"filter\">\n\n      <!-- indent -->\n      <div *ngIf=\"onRowGroupingIndent$ | async\"\n        row-grouping-indent [ngStyle]=\"filterIndentGridDisplay\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"filterRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"filterRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"filterRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- selection -->\n      <div *ngIf=\"onAllowSelection$ | async\"\n        row-checkbox-selection [ngStyle]=\"filterSelectionGridDisplay\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"filterRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"filterRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"filterRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- edition -->\n      <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n        [rowContentHeightPx]=\"filterRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"filterRowHorizontalGutterHeightPx\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\">\n      </dk-grid-row-edition-menu>\n\n      <!-- left panel filter columns -->\n      <dk-row-filter left-panel\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n      </dk-row-filter>\n\n      <!-- left panel division -->\n      <dk-panel-division left-panel-right-division\n        [divisionHeight]=\"filterRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <!-- center panel filter columns -->\n      <dk-row-filter center-panel\n        [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n      </dk-row-filter>\n\n      <!-- right panel division -->\n      <dk-panel-division right-panel-left-division\n        [divisionHeight]=\"filterRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\">\n      </dk-panel-division>\n\n      <!-- right panel filter columns -->\n      <dk-row-filter right-panel\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n      </dk-row-filter>\n    </dk-row-panels>\n  </ng-container>\n\n  <!-- row content -->\n  <cdk-virtual-scroll-viewport class=\"dkg-virtual-content-wrapper\"\n    dkGridContentScrollbar\n    [itemSize]=\"(contentRowHeight$ | async).rowHeight\"\n    [minBufferPx]=\"minBufferPx\"\n    [maxBufferPx]=\"maxBufferPx\">\n\n    <ng-container *cdkVirtualFor=\"let gridRow of datasource; index as i; odd as oddRow; even as evenRow; templateCacheSize: 35\">\n\n      <ng-container [ngTemplateOutlet]=\"gridRow.isGroup ? groupRow : dataRow\"\n        [ngTemplateOutletContext]=\"{ row: gridRow, rowHeight: contentRowHeightPx, odd: oddRow, even: evenRow }\">\n      </ng-container>\n\n    </ng-container>\n\n    <!-- empty row -->\n    <ng-container *ngIf=\"displayEmptyRow\">\n      <dk-row-panels [isContentContainer]=\"true\" wrapperType=\"empty-content\">\n\n        <!-- indent -->\n        <div *ngIf=\"onRowGroupingIndent$ | async\"\n          row-grouping-indent [ngStyle]=\"contentEmptyRowGridDisplay\">\n\n          <dk-grid-empty-cell\n            [cellHeight]=\"contentRowContentHeightPx\">\n          </dk-grid-empty-cell>\n        </div>\n\n        <!-- selection -->\n        <div *ngIf=\"onAllowSelection$ | async\"\n          row-checkbox-selection [ngStyle]=\"contentEmptyRowGridDisplay\">\n\n          <dk-grid-empty-cell\n            [cellHeight]=\"contentRowHeightPx\">\n          </dk-grid-empty-cell>\n        </div>\n\n        <!-- edition -->\n        <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n          [isEmptyRow]=\"true\"\n          [rowContentHeightPx]=\"contentRowContentHeightPx\"\n          [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\">\n        </dk-grid-row-edition-menu>\n\n        <!-- left panel columns -->\n        <dk-grid-row-empty left-panel\n          [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.leftPanel\">\n        </dk-grid-row-empty>\n\n        <!-- left panel division -->\n        <div left-panel-right-division [ngStyle]=\"{ height: contentRowHeightPx }\">\n        </div>\n\n        <!-- center panel columns -->\n        <dk-grid-row-empty center-panel\n          [columnStructure]=\"contentPanelDispatcher.centerPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.centerPanel\">\n        </dk-grid-row-empty>\n\n        <!-- right panel division -->\n        <div right-panel-left-division [ngStyle]=\"{ height: contentRowHeightPx }\">\n        </div>\n\n        <!-- right panel columns -->\n        <dk-grid-row-empty right-panel\n          [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n          [dkGridRow]=\"contentPanelDispatcher.rightPanel\">\n        </dk-grid-row-empty>\n      </dk-row-panels>\n    </ng-container>\n\n  </cdk-virtual-scroll-viewport>\n\n  <ng-template #groupRow let-gridRow=\"row\" let-rowGroupHeight=\"rowHeight\">\n    <!-- group row -->\n    <dk-grid-row-group\n      [row]=\"gridRow\"\n      [rowGroupHeight]=\"rowGroupHeight\">\n    </dk-grid-row-group>\n  </ng-template>\n\n  <ng-template #dataRow let-gridRow=\"row\" let-oddRow=\"odd\" let-evenRow=\"even\">\n    <!-- data row -->\n    <dk-row-panels\n      [isContentContainer]=\"true\"\n      [dkGridRowEditionTriggers]=\"gridRow\">\n\n      <!-- indent -->\n      <div *ngIf=\"onRowGroupingIndent$ | async\"\n        row-grouping-indent [ngStyle]=\"contentIndentGridDisplay\"\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\">\n\n        <dk-grid-empty-cell\n          [cellHeight]=\"contentRowContentHeightPx\">\n        </dk-grid-empty-cell>\n\n        <dk-grid-vertical-gutter\n          [gutterHeight]=\"contentRowContentHeightPx\"\n          [isEmpty]=\"!verticalRowsLinesVisible\">\n        </dk-grid-vertical-gutter>\n\n        <dk-grid-horizontal-gutter\n          dkGridItemPlacement\n          [gridColumnStart]=\"1\"\n          gridColumnEnd=\"span 2\"\n\n          [gutterHeight]=\"contentRowHorizontalGutterHeightPx\">\n        </dk-grid-horizontal-gutter>\n      </div>\n\n      <!-- selection -->\n      <dk-grid-row-selection *ngIf=\"onAllowSelection$ | async\"\n        row-checkbox-selection\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [row]=\"gridRow\"\n        [selectableRow]=\"selectableFunction$ | async\"\n        [rowContentHeightPx]=\"contentRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\">\n      </dk-grid-row-selection>\n\n      <!-- edition -->\n      <dk-grid-row-edition-menu row-edition-menu *ngIf=\"onEditionMode$ | async\"\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [row]=\"gridRow\"\n        [rowContentHeightPx]=\"contentRowContentHeightPx\"\n        [rowHorizontalGutterHeightPx]=\"contentRowHorizontalGutterHeightPx\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\">\n      </dk-grid-row-edition-menu>\n\n      <!-- left panel content columns -->\n      <dk-grid-row left-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.leftPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n\n      <!-- left panel division -->\n      <dk-panel-division left-panel-right-division\n        [divisionHeight]=\"contentRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\"\n\n        [dkGridColResizer]=\"true\"\n        [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n        resizerType=\"Panel\">\n      </dk-panel-division>\n\n      <!-- center panel content columns -->\n      <dk-grid-row center-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.centerPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.centerPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n\n      <!-- right panel division -->\n      <dk-panel-division right-panel-left-division\n        [divisionHeight]=\"contentRowHeightPx\"\n        [divisionWidth]=\"divisionLineWidthPx\"\n        [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n        [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n        [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\"\n\n        [dkGridColResizer]=\"true\"\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n        resizerType=\"Panel\">\n      </dk-panel-division>\n\n      <!-- right panel content columns -->\n      <dk-grid-row right-panel\n        [class.dkg-row-odd]=\"oddRow\"\n        [class.dkg-row-even]=\"evenRow\"\n        [class.dkg-row-selected]=\"gridRow.selected\"\n        [class.dkg-row-striped]=\"stripedRows && !gridRow.selected\"\n        [isVerticalLineVisible]=\"verticalRowsLinesVisible\"\n        [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n        [dkGridRow]=\"contentPanelDispatcher.rightPanel\"\n        [sourceIndex]=\"gridRow.id\"\n        [row]=\"gridRow\">\n      </dk-grid-row>\n    </dk-row-panels>\n  </ng-template>\n\n  <!-- row scrolling -->\n  <dk-row-panels wrapperType=\"scrolling\">\n\n    <!-- indent -->\n    <div *ngIf=\"onRowGroupingIndent$ | async\"\n      row-grouping-indent [ngStyle]=\"horizontalScrollGridDisplay\">\n\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- selection -->\n    <div *ngIf=\"onAllowSelection$ | async\"\n      row-checkbox-selection [ngStyle]=\"horizontalScrollGridDisplay\">\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- edition -->\n    <div *ngIf=\"onEditionMode$ | async\"\n      row-edition-menu [ngStyle]=\"horizontalScrollGridDisplay\">\n      <dk-grid-empty-cell\n        [cellHeight]=\"horizontalScrollHeightPx\">\n      </dk-grid-empty-cell>\n    </div>\n\n    <!-- left panel columns -->\n    <dk-grid-horizontal-scrolling left-panel\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\">\n    </dk-grid-horizontal-scrolling>\n\n    <!-- left panel division -->\n    <dk-panel-division left-panel-right-division\n      [divisionHeight]=\"horizontalScrollHeightPx\"\n      [divisionWidth]=\"divisionLineWidthPx\"\n      [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n      [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n      [isPanelResizing$]=\"contentPanelDispatcher.leftPanel.onPanelResizingChanged$\"\n\n      [dkGridColResizer]=\"true\"\n      [columnStructure]=\"contentPanelDispatcher.leftPanel\"\n      resizerType=\"Panel\">\n    </dk-panel-division>\n\n    <!-- center panel columns -->\n    <dk-grid-horizontal-scrolling center-panel\n      [columnStructure]=\"contentPanelDispatcher.centerPanel\">\n    </dk-grid-horizontal-scrolling>\n\n    <!-- right panel division -->\n    <dk-panel-division right-panel-left-division\n      [divisionHeight]=\"horizontalScrollHeightPx\"\n      [divisionWidth]=\"divisionLineWidthPx\"\n      [divisionWidthResizing]=\"divisionLineWidthResizingPx\"\n      [divisionSpaceWidth]=\"divisionPanelSpaceWidthPx\"\n      [isPanelResizing$]=\"contentPanelDispatcher.rightPanel.onPanelResizingChanged$\"\n\n      [dkGridColResizer]=\"true\"\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\"\n      resizerType=\"Panel\">\n    </dk-panel-division>\n\n    <!-- right panel columns -->\n    <dk-grid-horizontal-scrolling right-panel\n      [columnStructure]=\"contentPanelDispatcher.rightPanel\">\n    </dk-grid-horizontal-scrolling>\n  </dk-row-panels>\n\n</div>\n", styles: [".dkg-content-wrapper{height:100%;width:100%}.dkg-content-wrapper .dkg-virtual-content-wrapper{overflow-x:hidden;overflow-y:scroll;height:100%;width:100%}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: DkGridConfig }, { type: DkGridStructure }, { type: DkGridContentStructure }, { type: DkContentPanelDispatcher }, { type: DkGridEditionConfig }, { type: DkGridSelectionConfig }, { type: DkGridFilterConfig }, { type: DkGeneralNotifier }, { type: DkRowGroupingConfig }, { type: DkRowGroupingDispatcher }, { type: DkGridUI }];
    }, propDecorators: { datasource: [{
                type: Input
            }], virtualFor: [{
                type: ViewChild,
                args: [CdkVirtualForOf]
            }], virtualScrollViewport: [{
                type: ViewChild,
                args: [CdkVirtualScrollViewport]
            }] } });

class DkContentModule {
}
DkContentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkContentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentModule, declarations: [DkGridContentComponent,
        DkGridContentContainerDirective,
        DkGridContentScrollbarDirective], imports: [CommonModule,
        ScrollingModule,
        DkEditingModule,
        DkFilteringModule,
        DkGuttersModule,
        DkHeadersModule,
        DkPanelsModule,
        DkRowGroupingModule,
        DkRowsModule,
        DkScrollingModule,
        DkSelectionModule,
        DkCommonModule], exports: [DkGridContentComponent] });
DkContentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentModule, imports: [[
            CommonModule,
            ScrollingModule,
            DkEditingModule,
            DkFilteringModule,
            DkGuttersModule,
            DkHeadersModule,
            DkPanelsModule,
            DkRowGroupingModule,
            DkRowsModule,
            DkScrollingModule,
            DkSelectionModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContentModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridContentComponent,
                        DkGridContentContainerDirective,
                        DkGridContentScrollbarDirective
                    ],
                    imports: [
                        CommonModule,
                        ScrollingModule,
                        DkEditingModule,
                        DkFilteringModule,
                        DkGuttersModule,
                        DkHeadersModule,
                        DkPanelsModule,
                        DkRowGroupingModule,
                        DkRowsModule,
                        DkScrollingModule,
                        DkSelectionModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridContentComponent
                    ]
                }]
        }] });

class DkGridPaginatorDirective {
    constructor(cdr, gridStructure) {
        this.cdr = cdr;
        this.gridStructure = gridStructure;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    get horizontalGutterHeightPx() {
        return `${this.rowPagination.horizontalGutterHeight}px`;
    }
    get horizontalGutterHeight() {
        return this.rowPagination.horizontalGutterHeight;
    }
    get contentHeightPx() {
        return `${this.rowPagination.contentHeight}px`;
    }
    get contentHeight() {
        return this.rowPagination.contentHeight;
    }
    get rowHeightPx() {
        return `${this.rowPagination.rowHeight}px`;
    }
    get rowHeight() {
        return this.rowPagination.rowHeight;
    }
    ngOnInit() {
        this.gridStructure.onPaginationRowChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.rowPagination = value;
            // Paginator will be always painted at the bottom of the content:
            this.gridTemplateColumnsValue = `1fr`;
            this.gridTemplateRowsValue = `${value.horizontalGutterHeight}px ${value.contentHeight}px`;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridPaginatorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPaginatorDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridPaginatorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridPaginatorDirective, selector: "[dkGridPaginator]", host: { properties: { "style.display": "formatContext", "style.grid-template-rows": "gridTemplateRowsValue", "style.grid-template-columns": "gridTemplateColumnsValue" } }, exportAs: ["dkgPaginator"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPaginatorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridPaginator]',
                    exportAs: 'dkgPaginator',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridStructure }]; } });

class DkPaginatorComponent {
    constructor(paginationDispatcher) {
        this.paginationDispatcher = paginationDispatcher;
        this.pageSize = 50;
        this.disabled = false;
    }
    ngOnChanges(changes) {
        /**
         * Page size changing.
         *
         * It is supposed when chaging the @Input property pageSize from MatPaginator
         * the PageEvent event should be emitted but not.
         *
         * Reviewing the source code of the MatPaginator component in github there is a
         * method called _changePageSize(pageSize: number). When this method is invoked a
         * PageEvent event is emmited.
         * The method is invoked only when a list of page sizes are rendered in a mat-select
         * component but this selection list could be hidden.
         *
         * Changing the value of the @Input property pageSize only changes the MatPaginator UI
         * displaying the new page size but it does not emmit the PageEvent event.
         *
         * Due to the previous situation the DkPagingDataSource decorator instance does not
         * updates the visible rows because it does not receive the corresponding PageEvent
         * event.
         *
         * The workaround.
         *
         * Since MatPaginator is instantiated inside a DikePaginator component instance, which
         * also has a pageSize @Input property, every change in the pageSize property from
         * DikePaginator component is caught and then the _changePageSize(pageSize: number)
         * method from MatPaginator is invoked achieving the correct functionality.
         *
         */
        if (changes['pageSize'] && !changes['pageSize'].firstChange) {
            this.paginationDispatcher.paginator._changePageSize(this.pageSize);
        }
    }
    ngAfterViewInit() {
        this.paginationDispatcher.paginator = this.matPaginator;
    }
    ngOnDestroy() {
        // The MatPaginator is destroyed:
        this.paginationDispatcher.paginator = null;
    }
}
DkPaginatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPaginatorComponent, deps: [{ token: DkPaginationDispatcher }], target: i0.ɵɵFactoryTarget.Component });
DkPaginatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkPaginatorComponent, selector: "dk-paginator", inputs: { pageSize: "pageSize", disabled: "disabled" }, viewQueries: [{ propertyName: "matPaginator", first: true, predicate: MatPaginator, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"dkg-paginator-wrapper\" dkGridPaginator #gridPaginator=\"dkgPaginator\">\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridPaginator.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n  <div class=\"dkg-paginator-container\" [style.height]=\"gridPaginator.contentHeightPx\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\">\n\n    <mat-paginator\n      color=\"accent\"\n      [showFirstLastButtons]=\"true\"\n      [pageSize]=\"pageSize\"\n      [disabled]=\"disabled\">\n    </mat-paginator>\n  </div>\n\n</div>\n", styles: [".dkg-paginator-container{display:flex;flex-direction:column;justify-content:center}\n"], components: [{ type: DkGridHorizontalGutterComponent, selector: "dk-grid-horizontal-gutter", inputs: ["isHeaderGutter", "gutterHeight"] }, { type: i3$3.MatPaginator, selector: "mat-paginator", inputs: ["disabled"], exportAs: ["matPaginator"] }], directives: [{ type: DkGridPaginatorDirective, selector: "[dkGridPaginator]", exportAs: ["dkgPaginator"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPaginatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-paginator', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"dkg-paginator-wrapper\" dkGridPaginator #gridPaginator=\"dkgPaginator\">\n\n  <dk-grid-horizontal-gutter\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"1\"\n    gridRowEnd=\"span 1\"\n\n    [gutterHeight]=\"gridPaginator.horizontalGutterHeightPx\">\n  </dk-grid-horizontal-gutter>\n\n  <div class=\"dkg-paginator-container\" [style.height]=\"gridPaginator.contentHeightPx\"\n    dkGridItemPlacement\n    [gridColumnStart]=\"1\"\n    gridColumnEnd=\"span 1\"\n    [gridRowStart]=\"2\"\n    gridRowEnd=\"span 1\">\n\n    <mat-paginator\n      color=\"accent\"\n      [showFirstLastButtons]=\"true\"\n      [pageSize]=\"pageSize\"\n      [disabled]=\"disabled\">\n    </mat-paginator>\n  </div>\n\n</div>\n", styles: [".dkg-paginator-container{display:flex;flex-direction:column;justify-content:center}\n"] }]
        }], ctorParameters: function () { return [{ type: DkPaginationDispatcher }]; }, propDecorators: { pageSize: [{
                type: Input
            }], disabled: [{
                type: Input
            }], matPaginator: [{
                type: ViewChild,
                args: [MatPaginator]
            }] } });

class DkPagingModule {
}
DkPagingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPagingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkPagingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPagingModule, declarations: [DkPaginatorComponent,
        DkGridPaginatorDirective], imports: [CommonModule,
        MatPaginatorModule,
        DkGuttersModule,
        DkCommonModule], exports: [DkPaginatorComponent] });
DkPagingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPagingModule, imports: [[
            CommonModule,
            MatPaginatorModule,
            DkGuttersModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkPagingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkPaginatorComponent,
                        DkGridPaginatorDirective
                    ],
                    imports: [
                        CommonModule,
                        MatPaginatorModule,
                        DkGuttersModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkPaginatorComponent
                    ]
                }]
        }] });

class DkGridMainContainerDirective {
    constructor(cdr, gridStructure) {
        this.cdr = cdr;
        this.gridStructure = gridStructure;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateRowsValue = '';
        this.gridTemplateColumnsValue = '';
    }
    ngOnInit() {
        this.gridStructure.onMainWrapperTemplateRowsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateRowsValue = value;
            this.cdr.markForCheck();
        });
        this.gridStructure.onMainWrapperTemplateColumnsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridMainContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMainContainerDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridMainContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridMainContainerDirective, selector: "[dkGridMainContainer]", host: { properties: { "style.display": "formatContext", "style.grid-template-columns": "gridTemplateColumnsValue", "style.grid-template-rows": "gridTemplateRowsValue" } }, exportAs: ["dkgMainContainer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMainContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridMainContainer]',
                    exportAs: 'dkgMainContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridStructure }]; } });

class DkGridWaitingIndicator {
    constructor(gridConfig) {
        this.gridConfig = gridConfig;
    }
    loadingIndicator() {
        this.gridConfig.displayLoadingIndicator();
    }
    processingIndicator() {
        this.gridConfig.displayProcessingIndicator();
    }
    customMessageIndicator(message) {
        this.gridConfig.displayWaitingIndicator(message);
    }
    hideWaitingIndicator() {
        this.gridConfig.hideWaitingIndicator();
    }
}

class DkFilteringDataSource extends DkDecoratorDataSource {
    constructor(dikeDataSource, gridFilterConfig, filterDispatcher, gridMessaging) {
        super(dikeDataSource);
        this.gridFilterConfig = gridFilterConfig;
        this.filterDispatcher = filterDispatcher;
        this.gridMessaging = gridMessaging;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        const filterChange$ = this.gridFilterConfig ?
            merge(this.gridFilterConfig.initialized(), this.gridFilterConfig.filterEmitter.asObservable(), this.gridFilterConfig.editionFilterEmitter.asObservable(), this.gridFilterConfig.clearFilterEmitter.asObservable(), this.gridFilterConfig.clearEditionFilterEmitter.asObservable()) : of(null);
        // As a wrapper, get the previous result stream:
        const rows$ = this.dikeDataSource.connect();
        let lastFilterable;
        const filteredRows$ = combineLatest([rows$, filterChange$]).pipe(switchMap(([rows, filterable]) => {
            // Save the last emitted filterable:
            lastFilterable = filterable;
            return of(this.filter(rows));
        }), catchError((error, source) => {
            console.error(`The last Filterable was removed:`, lastFilterable);
            console.error(`Actual error:`, error);
            // Clear the filter from the last filterable:
            if (!!lastFilterable && this.gridFilterConfig.filterables.has(lastFilterable.columnId)) {
                let filterable = this.gridFilterConfig.filterables.get(lastFilterable.columnId);
                this.gridFilterConfig.filterables.set(lastFilterable.columnId, Object.assign(Object.assign({}, filterable), { filter: [] }));
                this.gridMessaging.sendPackage({
                    message: 'An error ocurred during filtering. The last filterable was not applied.',
                    data: { error }
                });
            }
            return source;
        }));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = filteredRows$.subscribe(rows => this.data = rows);
    }
    filter(rows) {
        if (this.gridFilterConfig === null || this.gridFilterConfig === undefined || !this.filterDispatcher.isFilterApplied()) {
            return rows;
        }
        return this.filterDispatcher.filterEntries(rows, this.gridFilterConfig.filterables);
    }
}

class DkSortingDataSource extends DkDecoratorDataSource {
    constructor(dikeDataSource, gridColumnDef, sortDispatcher, gridMessaging) {
        super(dikeDataSource);
        this.gridColumnDef = gridColumnDef;
        this.sortDispatcher = sortDispatcher;
        this.gridMessaging = gridMessaging;
        this.setChangeSubscription();
    }
    setChangeSubscription() {
        // As a wrapper, get the previous result stream:
        const rows$ = this.dikeDataSource.connect();
        /**
         * Retrieving the MatSort instance:
         *
         *  1.  Subscribe to the Observable that delivers the MatSort instance: DikeSortingDispatcher.onDataSortChanged$.
         *      The Observable comes from a BehaviorSubject.
         *
         *  2.  If the MatSort instance is retrieved, a subscription to the MatSort.sortChange Observable will be done.
         *      This subscription will be initialized with an Observable<void>.
         *
         *  3.  If the MatSort instance is not present, a subscription will be made to an Observable<void>.
         *
         * NOTE:  this.sortDispatcher.sortChangeEmitter is only used to notify that a new sort event is fired. The quickSort()
         *        method is invoked passing in the last Sort stored in the MatSort instance.
         */
        const sortChange$ = this.sortDispatcher.onDataSortChanged$.pipe(switchMap(dataSort => !!dataSort ?
            merge(this.sortDispatcher.sortChangeEmitter.asObservable(), this.sortDispatcher.initialized()) :
            this.sortDispatcher.initialized()));
        const sortedRows$ = combineLatest([sortChange$, rows$]).pipe(map(([_, rows]) => {
            return this.order(rows, {
                active: !!this.sortDispatcher.dataSort ? this.sortDispatcher.dataSort.active : '',
                direction: !!this.sortDispatcher.dataSort ? this.sortDispatcher.dataSort.direction : ''
            });
        }), catchError((error, source) => {
            console.error(error);
            console.error(`The last Sortable was not applied `, this.sortDispatcher.dataSort.active);
            // Clear the last Sort:
            this.sortDispatcher.dataSort.active = '';
            this.sortDispatcher.dataSort.direction = '';
            this.gridMessaging.sendPackage({
                message: 'An error ocurred during sorting. The last sortable was not applied.',
                data: { error }
            });
            return source;
        }));
        const sorting$ = this.sortDispatcher.onAllowSortingChanged$.pipe(switchMap(allowSorting => allowSorting ? sortedRows$ : rows$));
        this.changeSubscription.unsubscribe();
        this.changeSubscription = sorting$.subscribe(sortedData => this.data = sortedData);
    }
    order(rows, sortBy) {
        if (!sortBy.active || sortBy.active === '' || sortBy.direction === '') {
            return rows;
        }
        // Get the column to which the sorting will be applied:
        const dataColumnDef = this.gridColumnDef.findColumn(column => isDkDataColumnDef(column) && column.columnId === `${sortBy.active}`);
        // If the data column have not been found, surely the column is in group panel:
        if (!dataColumnDef) {
            return rows;
        }
        return this.sortDispatcher.quickSort(rows, sortBy.direction, dataColumnDef);
    }
}

class DkGridFactoryDataSource {
    constructor(gridColumnDef, gridFilterConfig, sortDispatcher, filterDispatcher, gridMessaging) {
        this.gridColumnDef = gridColumnDef;
        this.gridFilterConfig = gridFilterConfig;
        this.sortDispatcher = sortDispatcher;
        this.filterDispatcher = filterDispatcher;
        this.gridMessaging = gridMessaging;
    }
    createFilteringDecorator(dikeDataSource) {
        return new DkFilteringDataSource(dikeDataSource, this.gridFilterConfig, this.filterDispatcher, this.gridMessaging);
    }
    createSortingDecorator(dikeDataSource) {
        return new DkSortingDataSource(dikeDataSource, this.gridColumnDef, this.sortDispatcher, this.gridMessaging);
    }
}
DkGridFactoryDataSource.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryDataSource, deps: [{ token: DkGridColumnDef }, { token: DkGridFilterConfig }, { token: DkSortDispatcher }, { token: DkFilterDispatcher }, { token: DkGridMessaging }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridFactoryDataSource.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryDataSource });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridFactoryDataSource, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGridColumnDef }, { type: DkGridFilterConfig }, { type: DkSortDispatcher }, { type: DkFilterDispatcher }, { type: DkGridMessaging }]; } });

class DkGridCommandSender {
    constructor() {
        this.commands = new Map();
    }
    getRowCommands(rowId) {
        if (this.commands.has(rowId)) {
            return this.commands.get(rowId);
        }
        return [];
    }
    addRowCommands(rowId, commands) {
        let currentCmds;
        if (this.commands.has(rowId)) {
            currentCmds = this.commands.get(rowId);
        }
        else {
            currentCmds = [];
        }
        commands = Array.isArray(commands) ? commands : [commands];
        this.commands.set(rowId, [...currentCmds, ...commands]);
    }
    executeRowCommands(rowId) {
        // An empty array is not allowed:
        if (this.commands.has(rowId) && this.commands.get(rowId).length === 0) {
            this.commands.delete(rowId);
        }
        if (!this.commands.has(rowId)) {
            throw new Error(`Error from DkGridCommandSender - There are not any defined command for the given rowId: ${rowId}`);
        }
        let commands = this.commands.get(rowId);
        commands.forEach(command => command.execute());
        // After execution delete command entries from the internal map:
        this.commands.delete(rowId);
    }
}
DkGridCommandSender.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandSender, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DkGridCommandSender.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandSender });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridCommandSender, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class DkGridEdition {
    constructor(dikeConfig, gridEditionConfig, rowEditionDispatcher) {
        this.dikeConfig = dikeConfig;
        this.gridEditionConfig = gridEditionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
        this.changeEditionConfigSubscription = Subscription.EMPTY;
        this.changeRowsInEditionSetSubscription = Subscription.EMPTY;
        this.setChangeEditionConfigSubscription();
        this.setChangeRowsInEditionSetSubscription();
    }
    ngOnDestroy() {
        this.changeEditionConfigSubscription.unsubscribe();
        this.changeRowsInEditionSetSubscription.unsubscribe();
    }
    get editionRowChange() {
        return this.rowEditionDispatcher.editionRowEmitter.asObservable();
    }
    get updateRowChange() {
        return this.rowEditionDispatcher.updateRowEmitter.asObservable();
    }
    get cancelRowEditionChange() {
        return this.rowEditionDispatcher.cancelRowEditionEmitter.asObservable();
    }
    get removeRowChange() {
        return this.rowEditionDispatcher.deleteRowEmitter.asObservable();
    }
    get restoreRowChange() {
        return this.rowEditionDispatcher.undoRowUpdateEmitter.asObservable();
    }
    get editionFilterStateChange() {
        return this.gridEditionConfig.editionFilterStateEmitter.asObservable();
    }
    get editionFilterState() {
        return this.gridEditionConfig.editionFilterState;
    }
    editRow(row) {
        this.rowEditionDispatcher.editRow(row);
    }
    updateRow(row) {
        this.rowEditionDispatcher.updateRow(row);
    }
    cancelRowEdition(row) {
        this.rowEditionDispatcher.cancelRowEdition(row);
    }
    removeRow(row) {
        this.rowEditionDispatcher.deleteRow(row);
    }
    restoreRow(row) {
        this.rowEditionDispatcher.undoRowUpdate(row);
    }
    updateRowsInEdition() {
        this.rowEditionDispatcher.saveEdition();
    }
    removeRows(rows) {
        this.rowEditionDispatcher.deleteRows(rows);
    }
    cancelRowsInEdition() {
        this.rowEditionDispatcher.cancelEdition();
    }
    restoreRows(rows) {
        this.rowEditionDispatcher.undoRows(rows);
    }
    setEditionFilter(value) {
        /**
         * Since this method is called from outside the
         * DikeGrid UI, edition must be allowed and the
         * edition mode must be on:
         */
        if (this.gridEditionConfig.allowEdition && this.gridEditionConfig.editionMode) {
            this.gridEditionConfig.editionFilter = value;
        }
    }
    cancelEditionFilter() {
        this.gridEditionConfig.cancelEditionFilter();
    }
    get rowsInEdition() {
        return this.rowEditionDispatcher.getRowsInEdition();
    }
    get modifiedRows() {
        return this.rowEditionDispatcher.getUpdatedRows();
    }
    get removedRows() {
        return this.rowEditionDispatcher.getDeletedRows();
    }
    setChangeRowsInEditionSetSubscription() {
        this.changeRowsInEditionSetSubscription.unsubscribe();
        this.changeRowsInEditionSetSubscription = this.rowEditionDispatcher.onRowsInEditionChanged$.pipe(throttleTime(this.dikeConfig.THROTTLE_CHANGING_GRID_EDITION_PRISTINE_STATUS)).subscribe(() => {
            setTimeout(() => {
                /**
                 * Mark DikeGrid edition as pristine.
                 *
                 * It means setting the rowsInEdition FormGroup pristine, if all of its child controls
                 * are pristine as well.
                 *
                 * Consider the following notes:
                 *
                 *  1.  AbstractConttol.markAsPristine() method will mark all children as pristine and,
                 *      recalculates the pristine status of all parent controls.
                 *
                 *  2.  When row edition is cancelled, all the controls in the row are reset (remember that
                 *      reset(...) method marks the control as pristine and untoched). Both, panels and the
                 *      row itself are marking as pristine as well. Cancel action causes that rowsInEdition
                 *      FormGroup, which is the parent of all rows that are being edited, recalculates its
                 *      pristine status.
                 *
                 *  3.  But, when a row or a group of rows are being edited and the end user removes a column,
                 *      an iteration must be done over all the rows in the rowsInEdition FormGroup in order
                 *      to know if the rowsInEdition FormGroup is pristine after column's deletion. After
                 *      iterating all the child rows, if all of them are pristine, the rowsInEdition must be
                 *      pristine as well. Therefore, the rowsInEdition FormGroup is marked pristine explicitly.
                 */
                if (this.rowEditionDispatcher.areGridRowsInEditionPristine()) {
                    this.rowEditionDispatcher.markGridEditionAsPristine();
                }
            }, 0);
        });
    }
    setChangeEditionConfigSubscription() {
        let editionConfig$ = combineLatest([
            this.gridEditionConfig.onAllowEditionChanged$,
            this.gridEditionConfig.onEditionModeChanged$
        ]);
        this.changeEditionConfigSubscription.unsubscribe();
        this.changeEditionConfigSubscription = editionConfig$.subscribe(([allowEdition, editionMode]) => {
            // Edition was cancelled:
            if (!(allowEdition && editionMode)) {
                // Firstly, cancel edition in those rows which are being edited:
                this.rowEditionDispatcher.cancelEdition();
                // Second, cancel editionFilterState:
                this.gridEditionConfig.cancelEditionFilter();
            }
        });
    }
}
DkGridEdition.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEdition, deps: [{ token: CONFIG_GRID }, { token: DkGridEditionConfig }, { token: DkGridRowEditionDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridEdition.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEdition });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridEdition, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: DkGridEditionConfig }, { type: DkGridRowEditionDispatcher }];
    } });

class DkGridRowGrouping {
    constructor(groupPanelDispatcher, gridPanelDispatcher, rowGroupingDispatcher) {
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
    }
    get groupPanelColumnsChange() {
        return this.groupPanelDispatcher.columnsChangedEmitter.asObservable();
    }
    get collapseGroupRowChange() {
        return this.rowGroupingDispatcher.collapseGroupRowEmitter.asObservable();
    }
    clearRowGrouping() {
        this.gridPanelDispatcher.movePanelColumnSlots(this.gridPanelDispatcher.gridPanels.groupPanel, this.gridPanelDispatcher.gridPanels.centerPanel, false);
    }
}
DkGridRowGrouping.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGrouping, deps: [{ token: DkGroupPanelDispatcher }, { token: DkGridPanelDispatcher }, { token: DkRowGroupingDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridRowGrouping.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGrouping });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridRowGrouping, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkGroupPanelDispatcher }, { type: DkGridPanelDispatcher }, { type: DkRowGroupingDispatcher }]; } });

class DkGridPagination {
    constructor(paginationDispatcher) {
        this.paginationDispatcher = paginationDispatcher;
        this.changePaginatorSubscription = Subscription.EMPTY;
        this.setChangePaginatorSubscription();
    }
    ngOnDestroy() {
        this.changePaginatorSubscription.unsubscribe();
    }
    get pageChange() {
        return this.paginationDispatcher.pageEmitter.asObservable();
    }
    get paginatorChange() {
        return this.paginationDispatcher.paginatorEmitter.asObservable();
    }
    get matPaginator() {
        return this.paginationDispatcher.paginator;
    }
    setChangePaginatorSubscription() {
        const pagination$ = this.paginationDispatcher.onPaginatorChanged$.pipe(tap(paginator => this.paginationDispatcher.paginatorEmitter.emit(paginator)), switchMap(paginator => !!paginator ? paginator.page : NEVER));
        this.changePaginatorSubscription.unsubscribe();
        this.changePaginatorSubscription = pagination$.subscribe(currentPage => this.paginationDispatcher.pageEmitter.emit(currentPage));
    }
}
DkGridPagination.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPagination, deps: [{ token: DkPaginationDispatcher }], target: i0.ɵɵFactoryTarget.Injectable });
DkGridPagination.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPagination });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridPagination, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: DkPaginationDispatcher }]; } });

class DkGridDimensionsDirective {
    constructor(elementRef, gridStructure, viewPortRuler) {
        this.elementRef = elementRef;
        this.gridStructure = gridStructure;
        this.viewPortRuler = viewPortRuler;
        this.unsubscribeAll = new Subject();
    }
    ngOnInit() {
        this.viewPortRuler.change().pipe(takeUntil(this.unsubscribeAll)).subscribe(() => {
            this.gridStructure.setGridSize(this.getDimensions());
        });
        /**
         * @Input('dkGridDimensions') changeSize$: Observable<void>;
         *
         * This input observable variable was created because the user could change the input variable
         * height or width of the DikeGrid. The changes are caught in the ngOnChanges method of
         * the DikeGrid.
         *
         * When a change is detected, the DikeGrid instance notifies to DkGridDimensionsDirective
         * in order to calculate the new dimension of the DikeGrid. Therefore, the new dimension is
         * stored in the DkGridStructure service.
         *
         * NOTE:  Getting dimensions are done in the next event-loop allowing the current change
         *        detection operation finish its execution.
         *
         * Remember:
         *
         *  1. DkGridStructure service is responsible to push the new dimension to its subscribers. One
         *     subscriber is the DikeGrid instance itself. The DikeGrid listens for height changes to
         *     calculate the total height, thus it can paint the LEFT and the RIGHT border accordingly.
         *
         *  2. Another important task is that CdkVirtualScrollViewport must re-calculate its dimension then
         *     re-render its content according with the new height.
         */
        this.changeSize$.pipe(takeUntil(this.unsubscribeAll)).subscribe(() => {
            setTimeout(() => this.gridStructure.setGridSize(this.getDimensions()), 0);
        });
    }
    ngAfterViewInit() {
        this.gridStructure.setGridSize(this.getDimensions());
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
    getDimensions() {
        return {
            width: this.elementRef.nativeElement.offsetWidth,
            height: this.elementRef.nativeElement.offsetHeight
        };
    }
}
DkGridDimensionsDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDimensionsDirective, deps: [{ token: i0.ElementRef }, { token: DkGridStructure }, { token: i1$1.ViewportRuler }], target: i0.ɵɵFactoryTarget.Directive });
DkGridDimensionsDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridDimensionsDirective, selector: "[dkGridDimensions]", inputs: { changeSize$: ["dkGridDimensions", "changeSize$"] }, exportAs: ["dkgDimensions"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridDimensionsDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridDimensions]',
                    exportAs: 'dkgDimensions'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: DkGridStructure }, { type: i1$1.ViewportRuler }]; }, propDecorators: { changeSize$: [{
                type: Input,
                args: ['dkGridDimensions']
            }] } });

class DkGridMainContentContainerDirective {
    constructor(cdr, gridStructure) {
        this.cdr = cdr;
        this.gridStructure = gridStructure;
        this.unsubscribeAll = new Subject();
        this.formatContext = 'grid';
        this.gridTemplateColumnsValue = '';
        this.gridTemplateRowsValue = '';
    }
    ngOnInit() {
        this.gridStructure.onGridTemplateRowsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateRowsValue = value;
            this.cdr.markForCheck();
        });
        this.gridStructure.onGridTemplateColumnsChanged$.pipe(takeUntil(this.unsubscribeAll)).subscribe(value => {
            this.gridTemplateColumnsValue = value;
            this.cdr.markForCheck();
        });
    }
    ngOnDestroy() {
        this.unsubscribeAll.next();
        this.unsubscribeAll.complete();
    }
}
DkGridMainContentContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMainContentContainerDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: DkGridStructure }], target: i0.ɵɵFactoryTarget.Directive });
DkGridMainContentContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: DkGridMainContentContainerDirective, selector: "[dkGridMainContentContainer]", host: { properties: { "style.display": "formatContext", "style.grid-template-columns": "gridTemplateColumnsValue", "style.grid-template-rows": "gridTemplateRowsValue" } }, exportAs: ["dkgMainContentContainer"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridMainContentContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dkGridMainContentContainer]',
                    exportAs: 'dkgMainContentContainer',
                    host: {
                        '[style.display]': 'formatContext',
                        '[style.grid-template-columns]': 'gridTemplateColumnsValue',
                        '[style.grid-template-rows]': 'gridTemplateRowsValue'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: DkGridStructure }]; } });

function scrollFactory(overlay) {
    return () => overlay.scrollStrategies.block();
}
class DkGridComponent {
    constructor(document, dikeConfig, cdr, render2, snackBar, gridConfig, gridMessaging, gridFilter, gridFilterConfig, filterFactory, gridColumnDef, gridSorting, sortDispatcher, paginationDispatcher, gridPagination, gridStructure, gridContentStructure, gridUI, gridFactoryColumns, dataSourceDispatcher, gridDataSourceFactory, gridEdition, gridEditionConfig, rowEditionDispatcher, gridSelection, gridSelectionConfig, generalNotifier, gridPanelDispatcher, contentPanelDispatcher, groupPanelDispatcher, rowGroupingConfig, rowGroupingDispatcher, gridRowGrouping) {
        this.document = document;
        this.dikeConfig = dikeConfig;
        this.cdr = cdr;
        this.render2 = render2;
        this.snackBar = snackBar;
        this.gridConfig = gridConfig;
        this.gridMessaging = gridMessaging;
        this.gridFilter = gridFilter;
        this.gridFilterConfig = gridFilterConfig;
        this.filterFactory = filterFactory;
        this.gridColumnDef = gridColumnDef;
        this.gridSorting = gridSorting;
        this.sortDispatcher = sortDispatcher;
        this.paginationDispatcher = paginationDispatcher;
        this.gridPagination = gridPagination;
        this.gridStructure = gridStructure;
        this.gridContentStructure = gridContentStructure;
        this.gridUI = gridUI;
        this.gridFactoryColumns = gridFactoryColumns;
        this.dataSourceDispatcher = dataSourceDispatcher;
        this.gridDataSourceFactory = gridDataSourceFactory;
        this.gridEdition = gridEdition;
        this.gridEditionConfig = gridEditionConfig;
        this.rowEditionDispatcher = rowEditionDispatcher;
        this.gridSelection = gridSelection;
        this.gridSelectionConfig = gridSelectionConfig;
        this.generalNotifier = generalNotifier;
        this.gridPanelDispatcher = gridPanelDispatcher;
        this.contentPanelDispatcher = contentPanelDispatcher;
        this.groupPanelDispatcher = groupPanelDispatcher;
        this.rowGroupingConfig = rowGroupingConfig;
        this.rowGroupingDispatcher = rowGroupingDispatcher;
        this.gridRowGrouping = gridRowGrouping;
        // Row Grouping events:
        this.groupPanelColumnsChange = this.groupPanelDispatcher.columnsChangedEmitter;
        this.collapseGroupRowChange = this.rowGroupingDispatcher.collapseGroupRowEmitter;
        // Pagination events:
        this.pageChange = this.paginationDispatcher.pageEmitter;
        this.paginatorChange = this.paginationDispatcher.paginatorEmitter;
        // Filter events:
        this.registerFilterableChange = this.gridFilterConfig.registerEmitter;
        this.deregisterFilterableChange = this.gridFilterConfig.deregisterEmitter;
        this.filterChange = this.gridFilterConfig.filterEmitter;
        this.editionFilterChange = this.gridFilterConfig.editionFilterEmitter;
        this.clearFilterChange = this.gridFilterConfig.clearFilterEmitter;
        this.clearEditionFilterChange = this.gridFilterConfig.clearEditionFilterEmitter;
        // Edition events:
        this.editionRowChange = this.rowEditionDispatcher.editionRowEmitter;
        this.updateRowChange = this.rowEditionDispatcher.updateRowEmitter;
        this.cancelRowEditionChange = this.rowEditionDispatcher.cancelRowEditionEmitter;
        this.removeRowChange = this.rowEditionDispatcher.deleteRowEmitter;
        this.restoreRowChange = this.rowEditionDispatcher.undoRowUpdateEmitter;
        this.editionFilterStateChange = this.gridEditionConfig.editionFilterStateEmitter;
        // Selection events:
        this.selectionChange = this.gridSelectionConfig.selectionEmitter;
        this.selectedRowChange = this.gridSelectionConfig.selectedRowEmitter;
        this.deselectedRowChange = this.gridSelectionConfig.deselectedRowEmitter;
        // DataSource events:
        this.dataDeliveryIdChange = this.dataSourceDispatcher.dataDeliveryEmitter;
        this.sortChange = this.sortDispatcher.sortChangeEmitter;
        // Column events:
        this.columnSizeChange = this.gridPanelDispatcher.columnResizedEmitter;
        this.columnGroupStatusChange = this.contentPanelDispatcher.columnGroupStatusEmitter;
        this.columnLockedChange = this.contentPanelDispatcher.columnLockedEmitter;
        this.columnUnLockedChange = this.contentPanelDispatcher.columnUnLockedEmitter;
        this.columnVisibleChange = this.contentPanelDispatcher.columnVisibleEmitter;
        this.columnMove = this.gridPanelDispatcher.columnMovedEmitter;
        this.columnsChange = this.gridPanelDispatcher.columnsChangedEmitter;
        this.contentPanelsColumnsChange = this.contentPanelDispatcher.columnsChangedEmitter;
        this.columnsRemovedChange = this.gridPanelDispatcher.columnsRemovedEmitter;
        /***********************************************/
        this.changeTotalGridHeightSubscription = Subscription.EMPTY;
        this.changeColumnDraggingSubscription = Subscription.EMPTY;
        this.changeGridElevationSubscription = Subscription.EMPTY;
        this.changeWaitIndicatorSubscription = Subscription.EMPTY;
        this.gridMessagingSubscription = Subscription.EMPTY;
        this.mainWrapperId = this.gridStructure.mainWrapperId;
        this.id = this.gridConfig.gridId;
        this.width = this.gridConfig.width;
        this.height = this.gridConfig.height;
        this.gridSizeNotifier = new Subject();
        this.filter = this.gridFilter;
        this.columnDef = this.gridColumnDef;
        this.edition = this.gridEdition;
        this.selection = this.gridSelection;
        this.sorting = this.gridSorting;
        this.pagination = this.gridPagination;
        this.rowGrouping = this.gridRowGrouping;
        this.dataSourceFactory = this.gridDataSourceFactory;
        this.waitingIndicator = new DkGridWaitingIndicator(this.gridConfig);
        this._allowRowGrouping = this.rowGroupingConfig.allowRowGrouping;
        this._displayRowGroupingIndent = this.rowGroupingConfig.displayRowGroupingIndent;
        this._rowGroupingIndentWidth = this.rowGroupingConfig.rowGroupingIndentWidth;
        this._allowPagination = this.paginationDispatcher.allowPagination;
        this._pageSize = this.dikeConfig.PAGE_SIZE;
        this._displayRowId = false;
        this._rowIdWidth = 0;
        this._striped = this.gridUI.stripedRows;
        this._verticalRowLines = this.gridUI.verticalRowLines;
        this._gridElevation = this.gridUI.gridElevation;
        this._gridElevationValue = this.gridUI.gridElevationValue;
        this._headerRowHeight = this.gridContentStructure.headerRowHeight;
        this._filterRowHeight = this.gridContentStructure.filterRowHeight;
        this._contentRowHeight = this.gridContentStructure.contentRowHeight;
        this._rowGroupingRowHeight = this.gridStructure.rowGroupingRowHeight;
        this._rowGroupingColumnHeight = this.gridStructure.rowGroupingColumnHeight;
        this._paginationRowHeight = this.gridStructure.paginationRowHeight;
        this.totalGridHeightPx = '';
        this.isDragging$ = of(false);
        this.bordersGap = this.gridStructure.borderGap > 0;
        this.dropBorderContainer = 'drop-border-container';
        this.dropBorderContainerWidthPx = `${this.gridStructure.borderWidth > this.dikeConfig.DROP_BORDER_CONTAINER_WIDTH ? this.gridStructure.borderWidth : this.dikeConfig.DROP_BORDER_CONTAINER_WIDTH}px`;
        this.borderWidthPx = `${this.gridStructure.borderWidth}px`;
        this._onDemandFilter = this.gridFilterConfig.onDemandFilter;
        this._allowRowFiltering = this.gridFilterConfig.allowRowFilter;
        this._allowSelection = this.gridSelectionConfig.allowSelection;
        this._allowEdition = this.gridEditionConfig.allowEdition;
        this._editionMode = this.gridEditionConfig.editionMode;
        this._editionToolbar = this.gridEditionConfig.editionToolbar;
        this.editionToolbarPosition = this.gridEditionConfig.editionToolbarPosition;
        this.editionToolbarAlignment = this.gridEditionConfig.editionToolbarAlignment;
        this._editionToolbarRowHeight = this.gridStructure.editionToolbarRowHeight;
        this._editionToolbarItemHeight = this.gridStructure.editionToolbarItemHeight;
        this.gridCustomFilterConditions = null;
        this.isWaitIndicatorActive = false;
        this.waitIndicatorMessage = '';
        this.customScrollbars = this.gridConfig.customScrollbars;
        this.matSelectPanelClass = this.gridConfig.customScrollbars ? this.dikeConfig.MAT_SELECT_PANEL_CLASS : '';
        this._allowSorting = this.sortDispatcher.allowSorting;
        this._allowColumnContextMenu = this.gridConfig.allowColumnContextMenu;
        this._allowColumnDragging = this.gridConfig.allowColumnDragging;
        this.gridColumnDefInstance = new EventEmitter();
        // Set the default decorators:
        this.dataSourceDispatcher.decoratorCtxFn = this.getDecoratorCtxFn(this.dataSourceDispatcher.getDefaultDataSourceDecorators);
        // And initialize the datasource with an empty array:
        this.datasource = [];
    }
    get displayRowId() { return this._displayRowId; }
    set displayRowId(value) { this._displayRowId = coerceBooleanProperty(value); }
    get rowIdWidth() { return this._rowIdWidth; }
    set rowIdWidth(value) { this._rowIdWidth = coerceNumberProperty(value); }
    get gridElevation() { return this._gridElevation; }
    set gridElevation(value) { this._gridElevation = coerceBooleanProperty(value); }
    get gridElevationValue() { return this._gridElevationValue; }
    set gridElevationValue(value) { this._gridElevationValue = coerceNumberProperty(value); }
    get verticalRowLines() { return this._verticalRowLines; }
    set verticalRowLines(value) { this._verticalRowLines = coerceBooleanProperty(value); }
    get striped() { return this._striped; }
    set striped(value) { this._striped = coerceBooleanProperty(value); }
    get headerRowHeight() { return this._headerRowHeight; }
    set headerRowHeight(value) { this._headerRowHeight = coerceNumberProperty(value); }
    get contentRowHeight() { return this._contentRowHeight; }
    set contentRowHeight(value) { this._contentRowHeight = coerceNumberProperty(value); }
    get allowRowGrouping() { return this._allowRowGrouping; }
    set allowRowGrouping(value) { this._allowRowGrouping = coerceBooleanProperty(value); }
    get rowGroupingRowHeight() { return this._rowGroupingRowHeight; }
    set rowGroupingRowHeight(value) { this._rowGroupingRowHeight = coerceNumberProperty(value); }
    get rowGroupingColumnHeight() { return this._rowGroupingColumnHeight; }
    set rowGroupingColumnHeight(value) { this._rowGroupingColumnHeight = coerceNumberProperty(value); }
    get displayRowGroupingIndent() { return this._displayRowGroupingIndent; }
    set displayRowGroupingIndent(value) { this._displayRowGroupingIndent = coerceBooleanProperty(value); }
    get rowGroupingIndentWidth() { return this._rowGroupingIndentWidth; }
    set rowGroupingIndentWidth(value) { this._rowGroupingIndentWidth = coerceNumberProperty(value); }
    get allowPagination() { return this._allowPagination; }
    set allowPagination(value) { this._allowPagination = coerceBooleanProperty(value); }
    get pageSize() { return this._pageSize; }
    set pageSize(value) { this._pageSize = coerceNumberProperty(value) > 0 ? coerceNumberProperty(value) : this.dikeConfig.PAGE_SIZE; }
    get paginationRowHeight() { return this._paginationRowHeight; }
    set paginationRowHeight(value) { this._paginationRowHeight = coerceNumberProperty(value); }
    get onDemandFilter() { return this._onDemandFilter; }
    set onDemandFilter(value) { this._onDemandFilter = coerceBooleanProperty(value); }
    get allowRowFiltering() { return this._allowRowFiltering; }
    set allowRowFiltering(value) { this._allowRowFiltering = coerceBooleanProperty(value); }
    get filterRowHeight() { return this._filterRowHeight; }
    set filterRowHeight(value) { this._filterRowHeight = coerceNumberProperty(value); }
    get allowEdition() { return this._allowEdition; }
    set allowEdition(value) { this._allowEdition = coerceBooleanProperty(value); }
    get editionMode() { return this._editionMode; }
    set editionMode(value) { this._editionMode = coerceBooleanProperty(value); }
    get editionToolbar() { return this._editionToolbar; }
    set editionToolbar(value) { this._editionToolbar = coerceBooleanProperty(value); }
    get editionToolbarRowHeight() { return this._editionToolbarRowHeight; }
    set editionToolbarRowHeight(value) { this._editionToolbarRowHeight = coerceNumberProperty(value); }
    get editionToolbarItemHeight() { return this._editionToolbarItemHeight; }
    set editionToolbarItemHeight(value) { this._editionToolbarItemHeight = coerceNumberProperty(value); }
    get allowSelection() { return this._allowSelection; }
    set allowSelection(value) { this._allowSelection = coerceBooleanProperty(value); }
    get allowColumnContextMenu() { return this._allowColumnContextMenu; }
    set allowColumnContextMenu(value) { this._allowColumnContextMenu = coerceBooleanProperty(value); }
    get allowColumnDragging() { return this._allowColumnDragging; }
    set allowColumnDragging(value) { this._allowColumnDragging = coerceBooleanProperty(value); }
    get allowSorting() { return this._allowSorting; }
    set allowSorting(value) { this._allowSorting = coerceBooleanProperty(value); }
    get initialized() {
        return this.gridConfig.isInitialized();
    }
    ngOnChanges(changes) {
        if (changes['id']) {
            this.gridConfig.gridId = this.id;
        }
        /**
         * height and width changes.
         *
         * The purpose of reacting of any change in height and width properties, is
         * triggering a subject called gridSizeNotifier via the changeGridSizeNotifier() method.
         *
         * The subject is listening in the dkGridDimensions directive where the
         * actual height and width of the grid is read.
         *
         * The first change is ignored because the initial dimensions are read in the
         * ngAfterViewInit() life cycle hook from dkGridDimensions directive.
         */
        if (changes['height'] && !changes['height'].firstChange) {
            // Save the new height:
            this.gridConfig.height = this.height;
            // Then update the grid size:
            this.changeGridSizeNotifier();
        }
        if (changes['width'] && !changes['width'].firstChange) {
            // Save the new width:
            this.gridConfig.width = this.width;
            // Then update the grid size:
            this.changeGridSizeNotifier();
        }
        if (changes['displayRowId'] || changes['rowIdWidth']) {
            this.contentPanelDispatcher.setRowIndexColumnSlot(this.displayRowId, this.rowIdWidth);
        }
        if (changes['gridElevation']) {
            this.gridUI.gridElevation = this.gridElevation;
        }
        if (changes['gridElevationValue']) {
            this.gridUI.gridElevationValue = this.gridElevationValue;
            // In case the provided value is less than 0 or greater than 24, reasign the vale comming from the service:
            this.gridElevationValue = this.gridUI.gridElevationValue;
        }
        if (changes['verticalRowLines']) {
            this.gridUI.verticalRowLines = this.verticalRowLines;
        }
        if (changes['striped']) {
            this.gridUI.stripedRows = this.striped;
        }
        if (changes['headerRowHeight']) {
            this.gridContentStructure.headerRowHeight = this.headerRowHeight;
        }
        if (changes['contentRowHeight']) {
            this.gridContentStructure.contentRowHeight = this.contentRowHeight;
        }
        if (changes['allowRowGrouping']) {
            // allowRowGrouping flag could be set only once for each DikeGrid instance:
            if (changes['allowRowGrouping'].firstChange) {
                this.rowGroupingConfig.allowRowGrouping = this.allowRowGrouping;
            }
            else {
                // Modifications done after the first change are now allowed.
                this.allowRowGrouping = this.rowGroupingConfig.allowRowGrouping;
            }
        }
        if (changes['displayRowGroupingIndent']) {
            this.rowGroupingConfig.displayRowGroupingIndent = this.displayRowGroupingIndent;
        }
        if (changes['rowGroupingIndentWidth']) {
            this.rowGroupingConfig.rowGroupingIndentWidth = this.rowGroupingIndentWidth;
        }
        if (changes['rowGroupingRowHeight']) {
            this.gridStructure.rowGroupingRowHeight = this.rowGroupingRowHeight;
        }
        if (changes['rowGroupingColumnHeight']) {
            this.gridStructure.rowGroupingColumnHeight = this.rowGroupingColumnHeight;
        }
        if (changes['allowPagination']) {
            this.paginationDispatcher.allowPagination = this.allowPagination;
        }
        if (changes['paginationRowHeight']) {
            this.gridStructure.paginationRowHeight = this.paginationRowHeight;
        }
        if (changes['allowSorting']) {
            this.sortDispatcher.allowSorting = this.allowSorting;
        }
        if (changes['onDemandFilter']) {
            this.gridFilterConfig.onDemandFilter = this.onDemandFilter;
        }
        if (changes['allowRowFiltering']) {
            this.gridFilterConfig.allowRowFilter = this.allowRowFiltering;
        }
        if (changes['filterRowHeight']) {
            this.gridContentStructure.filterRowHeight = this.filterRowHeight;
        }
        if (changes['allowEdition']) {
            // allowEdition flag could be set only once for each DikeGrid instance:
            if (changes['allowEdition'].firstChange) {
                this.gridEditionConfig.allowEdition = this.allowEdition;
            }
            else {
                /**
                 * Modifications done after the first change are now allowed.
                 *
                 * If the consumer change the allowEdition flag after the first change, the
                 * value stored in the Edition Config service is assigned to the
                 * allowEdition DikeGrid property.
                 *
                 * This assignment is very important because the decorator function will receive
                 * the DikeGrid component instance and the edition flag verification is only
                 * available from the DikeGrid component instance.
                 */
                this.allowEdition = this.gridEditionConfig.allowEdition;
            }
        }
        if (changes['editionMode']) {
            this.gridEditionConfig.editionMode = this.editionMode;
        }
        if (changes['editionToolbar']) {
            this.gridEditionConfig.editionToolbar = this.editionToolbar;
        }
        if (changes['editionToolbarPosition']) {
            this.gridEditionConfig.editionToolbarPosition = this.editionToolbarPosition;
        }
        if (changes['editionToolbarAlignment']) {
            this.gridEditionConfig.editionToolbarAlignment = this.editionToolbarAlignment;
        }
        if (changes['editionToolbarRowHeight']) {
            this.gridStructure.editionToolbarRowHeight = this.editionToolbarRowHeight;
        }
        if (changes['editionToolbarItemHeight']) {
            this.gridStructure.editionToolbarItemHeight = this.editionToolbarItemHeight;
        }
        if (changes['allowSelection']) {
            this.gridSelectionConfig.allowSelection = this.allowSelection;
        }
        if (changes['selectableRows']) {
            this.gridSelection.selectableRows = this.selectableRows;
        }
        if (changes['allowColumnContextMenu']) {
            this.gridConfig.allowColumnContextMenu = this.allowColumnContextMenu;
        }
        if (changes['allowColumnDragging']) {
            this.gridConfig.allowColumnDragging = this.allowColumnDragging;
        }
        if (changes['datasource']) {
            this.dataSourceDispatcher.attachDikeGridDataSource(this.datasource, this);
        }
    }
    ngOnInit() {
        // Listen to any change in the content datasource:
        this.contentDataSource$ = this.dataSourceDispatcher.onContentDataSourceChanged$;
        this.borderTop$ = this.gridStructure.onBorderTopChanged$;
        this.borderRight$ = this.gridStructure.onBorderRightChanged$;
        this.borderBottom$ = this.gridStructure.onBorderBottomChanged$;
        this.borderLeft$ = this.gridStructure.onBorderLeftChanged$;
        this.editionToolbarPosition$ = this.gridEditionConfig.onEditionToolbarPositionChanged$;
        /**
         * Remember that the editionToolbarVisibility$ Observable<boolean> depends on
         * three variables comming from DkGridEditionConfig service:
         *
         *  (a). DkGridEditionConfig.onAllowEditionChanged$.
         *  (b). DkGridEditionConfig.onEditionModeChanged$.
         *  (c). DkGridEditionConfig.onEditionToolbarChanged$.
         *
         * These variables are evaluated in DkGridStructure service.
         * The resulting evaluation is delivered via DkGridStructure.onEditionToolbarVisibilityChanged$.
         *
         * To conclude, DkGridStructure.onEditionToolbarVisibilityChanged$ observable delivers
         * a boolean value indicating if the Edition Toolbar is structurally visible.
         */
        this.editionToolbarVisibility$ = this.gridStructure.onEditionToolbarVisibilityChanged$;
        this.isDragging$ = this.generalNotifier.onDraggingNotifierChanged$;
        this.gridMessagingSubscription = this.gridMessaging.packageChange.subscribe((dikePackage) => {
            this.snackBar.open(dikePackage.message, 'Dismiss', {
                duration: 4000
            });
        });
        // Custom filters are set only at initialisation phase of each DikeGrid instance:
        if (this.gridCustomFilterConditions !== null && this.gridCustomFilterConditions !== undefined) {
            this.filterFactory.setGridCustomConditions(this.gridCustomFilterConditions);
        }
        // Edition settings at grid level are set only at initialisation phase for each DikeGrid instance:
        if (this.gridEditionSettings !== null && this.gridEditionSettings !== undefined) {
            this.gridEditionConfig.gridEditionSettings = this.gridEditionSettings;
        }
        // The decorator function could be set only at initialisation phase:
        if (this.decoratorFn !== null && this.decoratorFn !== undefined) {
            this.dataSourceDispatcher.decoratorCtxFn = this.getDecoratorCtxFn(this.decoratorFn);
        }
        this.groupColumnStructure = this.groupPanelDispatcher.groupPanel;
        this.setChangeTotalGridHeightSubscription();
        this.setChangeColumnDraggingSubscription();
        this.setChangeGridElevationSubscription();
        this.setChangeWaitIndicatorSubscription();
        // Emit the DkGridColumnDef instance service:
        this.gridColumnDefInstance.emit(this.gridColumnDef);
        this.disableSortPagination$ = this.dataSourceDispatcher.onTempDisableSortPaginationChanged$;
    }
    ngAfterContentInit() {
        // Once the root columns were read then add all the columns into its corresponding double-linked list:
        this.gridColumnDef.addColumns(this.gridFactoryColumns.rootColumns);
        // Finally, free the memory the rootColumns occupy:
        this.gridFactoryColumns.rootColumns = [];
    }
    ngAfterViewInit() {
        /**
         * Floating elements:
         *
         * The CDK FlexibleConnectedPositionStrategy gets the DOMRect object for the
         * origin and the overlayRef instances.
         *
         * Remember that the DOMRect represents the bounding client rect of an element.
         * The DOMRect containts the Viewport coordinates.
         *
         * Therefore, when an instance of a dike-grid is not at the top of the page, the Y
         * value of the divMainContainerRef must be substracted from the Y value of the final
         * point of the floating element.
         */
        this.gridStructure.mainWrapperElementRef = this.divMainContainerRef;
        // After querying the default templates for editing values:
        this.gridEditionConfig.textBoxTemplate = this.dikeTextBox;
        this.gridEditionConfig.multiTextBoxTemplate = this.dikeMultiTextBox;
        this.gridEditionConfig.textOptionsBoxTemplate = this.dikeTextOptionsBox;
        this.gridEditionConfig.numericBoxTemplate = this.dikeNumericBox;
        this.gridEditionConfig.numericOptionsBoxTemplate = this.dikeNumericOptionsBox;
        this.gridEditionConfig.dateBoxTemplate = this.dikeDateBox;
        this.gridEditionConfig.binaryBoxTemplate = this.dikeBinaryBox;
        this.gridEditionConfig.binaryOptionsBoxTemplate = this.dikeBinaryOptionsBox;
        // After querying the default templates for displaying values:
        this.gridConfig.textDisplayTemplate = this.dikeTextDisplay;
        this.gridConfig.numericDisplayTemplate = this.dikeNumericDisplay;
        this.gridConfig.dateDisplayTemplate = this.dikeDateDisplay;
        this.gridConfig.binaryDisplayTemplate = this.dikeBinaryDisplay;
        // Set the MatSort instance:
        this.sortDispatcher.dataSort = this._gridSort;
        // At this point the DikeGrid component instance has been built:
        this.gridConfig.initialized();
    }
    ngOnDestroy() {
        this.gridSizeNotifier.complete();
        this.registerFilterableChange.complete();
        this.deregisterFilterableChange.complete();
        this.filterChange.complete();
        this.editionFilterChange.complete();
        this.clearFilterChange.complete();
        this.clearEditionFilterChange.complete();
        this.editionRowChange.complete();
        this.updateRowChange.complete();
        this.cancelRowEditionChange.complete();
        this.removeRowChange.complete();
        this.restoreRowChange.complete();
        this.editionFilterStateChange.complete();
        this.selectedRowChange.complete();
        this.deselectedRowChange.complete();
        this.selectionChange.complete();
        this.columnSizeChange.complete();
        this.columnGroupStatusChange.complete();
        this.columnLockedChange.complete();
        this.columnUnLockedChange.complete();
        this.columnVisibleChange.complete();
        this.columnMove.complete();
        this.columnsChange.complete();
        this.contentPanelsColumnsChange.complete();
        this.columnsRemovedChange.complete();
        this.sortChange.complete();
        this.pageChange.complete();
        this.dataDeliveryIdChange.complete();
        this.changeTotalGridHeightSubscription.unsubscribe();
        this.changeColumnDraggingSubscription.unsubscribe();
        this.changeGridElevationSubscription.unsubscribe();
        this.changeWaitIndicatorSubscription.unsubscribe();
        this.gridMessagingSubscription.unsubscribe();
    }
    onDropListEntered(entered) {
        this.render2.addClass(entered.container.element.nativeElement, 'dkg-active-drop-border-container');
        this.generalNotifier.notifyColumnSlotPinning(true);
    }
    onDropListExited(exited) {
        this.render2.removeClass(exited.container.element.nativeElement, 'dkg-active-drop-border-container');
        this.generalNotifier.notifyColumnSlotPinning(false);
    }
    onDrop(dropped) {
        this.render2.removeClass(dropped.container.element.nativeElement, 'dkg-active-drop-border-container');
        this.generalNotifier.notifyColumnSlotPinning(false);
        let droppedContainer = dropped.container.data;
        let droppedColumnSlot = dropped.previousContainer.data;
        if (droppedContainer === 'leftBorder' && droppedColumnSlot.dikeColumn.panel !== 'leftPanel') {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(droppedColumnSlot, this.gridPanelDispatcher.gridPanels[droppedColumnSlot.dikeColumn.panel], this.gridPanelDispatcher.gridPanels.leftPanel);
        }
        else if (droppedContainer === 'rightBorder' && droppedColumnSlot.dikeColumn.panel !== 'rightPanel') {
            this.gridPanelDispatcher.moveColumnSlotIntoPanel(droppedColumnSlot, this.gridPanelDispatcher.gridPanels[droppedColumnSlot.dikeColumn.panel], this.gridPanelDispatcher.gridPanels.rightPanel);
        }
    }
    getDecoratorCtxFn(dataSourceDecoratorFn) {
        /**
         * Decorator function.
         *
         *  Premises:
         *    1.  Every decorator function has the signature defined by the type DataSourceDecoratorFn<T>.
         *
         *    2.  Every DikeGrid instance has an @Input property of type DataSourceDecoratorFn<T>. Therefore,
         *        the DikeGrid component is responsible for creating the closure which will be executed outside
         *        the DikeGrid instance itself.
         *
         *    3.  It has to be a closure because the decoration task must be executed in the context of its
         *        corresponding DikeGrid instance. Remember that the DikeGrid holds the MatSort directive and
         *        the MatPaginator component references.
         *
         *    4.  Remember that this function must be executed in every leaf of the row-grouping tree. The latter
         *        is posible because the created closure.
         */
        return () => {
            return (dikeDataSource) => {
                return dataSourceDecoratorFn(dikeDataSource, this);
            };
        };
    }
    releaseEdition() {
        this.rowEditionDispatcher.releaseEdition();
    }
    releaseSelection() {
        this.gridSelection.deselect(this.gridSelection.getSelectedRows());
        // Update the header-checkbox status if it is displayed:
        if (!!this.rowGroupingDispatcher.rootGroupRow) {
            this.rowGroupingDispatcher.rootGroupRow.allRowsSelected = false;
            this.rowGroupingDispatcher.rootGroupRow.someRowsSelected = false;
        }
    }
    changeGridSizeNotifier() {
        this.gridSizeNotifier.next();
    }
    setChangeTotalGridHeightSubscription() {
        let gridHeight$ = this.gridStructure.onGridSizeChanged$.pipe(map(size => size.height), observeOn(asapScheduler));
        this.changeTotalGridHeightSubscription.unsubscribe();
        this.changeTotalGridHeightSubscription = gridHeight$.subscribe(height => {
            this.totalGridHeightPx = `${height - this.gridStructure.borderGap * 2 + this.gridStructure.borderWidth * 2}px`;
            this.cdr.markForCheck();
        });
    }
    setChangeGridElevationSubscription() {
        let gridElevation$ = combineLatest([
            this.gridUI.onGridElevationChanged$,
            this.gridUI.onGridElevationClassChanged$
        ]);
        this.changeGridElevationSubscription.unsubscribe();
        this.changeGridElevationSubscription = gridElevation$.subscribe(([isElevated, elevationClass]) => {
            this.gridElevationClass = isElevated ? elevationClass : '';
        });
    }
    setChangeColumnDraggingSubscription() {
        let columnDragging$ = this.generalNotifier.onDraggingNotifierChanged$.pipe(tap(value => value ? this.render2.setStyle(this.document.body, 'cursor', 'grabbing') : this.render2.setStyle(this.document.body, 'cursor', 'default')));
        this.changeColumnDraggingSubscription.unsubscribe();
        this.changeColumnDraggingSubscription = columnDragging$.subscribe();
    }
    setChangeWaitIndicatorSubscription() {
        this.changeWaitIndicatorSubscription.unsubscribe();
        this.changeWaitIndicatorSubscription = this.gridConfig.onWaitIndicatorChanged$.subscribe(value => {
            var _a;
            this.isWaitIndicatorActive = value.active;
            this.waitIndicatorMessage = (_a = value.message) !== null && _a !== void 0 ? _a : '';
            this.cdr.markForCheck();
        });
    }
}
DkGridComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridComponent, deps: [{ token: DOCUMENT }, { token: CONFIG_GRID }, { token: i0.ChangeDetectorRef }, { token: i0.Renderer2 }, { token: i1$2.MatSnackBar }, { token: DkGridConfig }, { token: DkGridMessaging }, { token: DkGridFilter }, { token: DkGridFilterConfig }, { token: DkFilterFactory }, { token: DkGridColumnDef }, { token: DkGridSorting }, { token: DkSortDispatcher }, { token: DkPaginationDispatcher }, { token: DkGridPagination }, { token: DkGridStructure }, { token: DkGridContentStructure }, { token: DkGridUI }, { token: DkGridFactoryColumns }, { token: DkDataSourceDispatcher }, { token: DkGridFactoryDataSource }, { token: DkGridEdition }, { token: DkGridEditionConfig }, { token: DkGridRowEditionDispatcher }, { token: DkGridSelection }, { token: DkGridSelectionConfig }, { token: DkGeneralNotifier }, { token: DkGridPanelDispatcher }, { token: DkContentPanelDispatcher }, { token: DkGroupPanelDispatcher }, { token: DkRowGroupingConfig }, { token: DkRowGroupingDispatcher }, { token: DkGridRowGrouping }], target: i0.ɵɵFactoryTarget.Component });
DkGridComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: DkGridComponent, selector: "dk-grid", inputs: { id: "id", height: "height", width: "width", displayRowId: "displayRowId", rowIdWidth: "rowIdWidth", gridElevation: "gridElevation", gridElevationValue: "gridElevationValue", verticalRowLines: "verticalRowLines", striped: "striped", headerRowHeight: "headerRowHeight", contentRowHeight: "contentRowHeight", allowRowGrouping: "allowRowGrouping", rowGroupingRowHeight: "rowGroupingRowHeight", rowGroupingColumnHeight: "rowGroupingColumnHeight", displayRowGroupingIndent: "displayRowGroupingIndent", rowGroupingIndentWidth: "rowGroupingIndentWidth", allowPagination: "allowPagination", pageSize: "pageSize", paginationRowHeight: "paginationRowHeight", onDemandFilter: "onDemandFilter", allowRowFiltering: "allowRowFiltering", filterRowHeight: "filterRowHeight", gridCustomFilterConditions: "gridCustomFilterConditions", allowEdition: "allowEdition", editionMode: "editionMode", editionToolbar: "editionToolbar", editionToolbarPosition: "editionToolbarPosition", editionToolbarAlignment: "editionToolbarAlignment", editionToolbarRowHeight: "editionToolbarRowHeight", editionToolbarItemHeight: "editionToolbarItemHeight", gridEditionSettings: "gridEditionSettings", allowSelection: "allowSelection", selectableRows: "selectableRows", datasource: "datasource", decoratorFn: "decoratorFn", allowColumnContextMenu: "allowColumnContextMenu", allowColumnDragging: "allowColumnDragging", allowSorting: "allowSorting" }, outputs: { groupPanelColumnsChange: "groupPanelColumnsChange", collapseGroupRowChange: "collapseGroupRowChange", pageChange: "pageChange", paginatorChange: "paginatorChange", registerFilterableChange: "registerFilterableChange", deregisterFilterableChange: "deregisterFilterableChange", filterChange: "filterChange", editionFilterChange: "editionFilterChange", clearFilterChange: "clearFilterChange", clearEditionFilterChange: "clearEditionFilterChange", editionRowChange: "editionRowChange", updateRowChange: "updateRowChange", cancelRowEditionChange: "cancelRowEditionChange", removeRowChange: "removeRowChange", restoreRowChange: "restoreRowChange", editionFilterStateChange: "editionFilterStateChange", selectionChange: "selectionChange", selectedRowChange: "selectedRowChange", deselectedRowChange: "deselectedRowChange", dataDeliveryIdChange: "dataDeliveryIdChange", gridColumnDefInstance: "gridColumnDefInstance", sortChange: "sortChange", columnSizeChange: "columnSizeChange", columnGroupStatusChange: "columnGroupStatusChange", columnLockedChange: "columnLockedChange", columnUnLockedChange: "columnUnLockedChange", columnVisibleChange: "columnVisibleChange", columnMove: "columnMove", columnsChange: "columnsChange", contentPanelsColumnsChange: "contentPanelsColumnsChange", columnsRemovedChange: "columnsRemovedChange" }, host: { properties: { "attr.id": "this.id" } }, providers: [
        DkContextMenu,
        {
            provide: MAT_SELECT_SCROLL_STRATEGY,
            useFactory: scrollFactory,
            deps: [Overlay]
        },
        {
            provide: MAT_DATEPICKER_SCROLL_STRATEGY,
            useFactory: scrollFactory,
            deps: [Overlay]
        },
        {
            provide: MAT_MENU_SCROLL_STRATEGY,
            useFactory: scrollFactory,
            deps: [Overlay]
        },
        ScrollDispatcher,
        DkGridConfig,
        DkGridPanelDispatcher,
        DkGridColumnDef,
        DkGridFactoryColumns,
        DkGridFactoryMeshSlots,
        DkFilterFactory,
        DkGridFilterConfig,
        DkGridFilter,
        DkFilterDispatcher,
        DkGridContentStructure,
        DkContentPanelDispatcher,
        DkGridStructure,
        DkGridUI,
        DkGridSorting,
        DkSortDispatcher,
        DkGridMessaging,
        DkDataSourceDispatcher,
        DkGridFactoryDataSource,
        DkGridDataStore,
        DkGridCommandFactory,
        DkGridCommandSender,
        DkGridEdition,
        DkGridEditionConfig,
        DkGridRowEditionDispatcher,
        DkEditionErrorMessagesFactory,
        DkGridSelection,
        DkGridSelectionConfig,
        DkGeneralNotifier,
        DkGroupPanelDispatcher,
        DkRowGroupingDispatcher,
        DkRowGroupingConfig,
        DkGridRowGrouping,
        DkPaginationDispatcher,
        DkGridPagination
    ], queries: [{ propertyName: "dikeGridColumns", predicate: DkGridColumnComponent }], viewQueries: [{ propertyName: "_gridSort", first: true, predicate: MatSort, descendants: true }, { propertyName: "divMainContainerRef", first: true, predicate: DkGridMainContainerDirective, descendants: true, read: ElementRef }, { propertyName: "dikeTextBox", first: true, predicate: ["dikeTextBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeMultiTextBox", first: true, predicate: ["dikeMultiTextBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeTextOptionsBox", first: true, predicate: ["dikeTextOptionsBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeNumericBox", first: true, predicate: ["dikeNumericBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeNumericOptionsBox", first: true, predicate: ["dikeNumericOptionsBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeDateBox", first: true, predicate: ["dikeDateBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeBinaryBox", first: true, predicate: ["dikeBinaryBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeBinaryOptionsBox", first: true, predicate: ["dikeBinaryOptionsBox"], descendants: true, read: TemplateRef }, { propertyName: "dikeTextDisplay", first: true, predicate: ["dikeTextDisplay"], descendants: true, read: TemplateRef }, { propertyName: "dikeNumericDisplay", first: true, predicate: ["dikeNumericDisplay"], descendants: true, read: TemplateRef }, { propertyName: "dikeDateDisplay", first: true, predicate: ["dikeDateDisplay"], descendants: true, read: TemplateRef }, { propertyName: "dikeBinaryDisplay", first: true, predicate: ["dikeBinaryDisplay"], descendants: true, read: TemplateRef }], exportAs: ["dkgGrid"], usesOnChanges: true, ngImport: i0, template: "<div\n  [id]=\"mainWrapperId\"\n  [style.width]=\"width\"\n  [style.height]=\"height\"\n\n  dkGridMainContainer\n  [dkGridDimensions]=\"gridSizeNotifier.asObservable()\"\n  matSort [matSortDisabled]=\"!allowSorting || (disableSortPagination$ | async)\">\n\n  <ng-container *ngIf=\"borderLeft$ | async as borderLeft\">\n    <ng-container *ngIf=\"borderLeft.borderGap > 0\">\n      <div class=\"dkg-drop-border-container\"\n        [style.height]=\"totalGridHeightPx\"\n        [style.width]=\"dropBorderContainerWidthPx\"\n        [style.borderRightWidth]=\"dropBorderContainerWidthPx\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        cdkDropList\n        [id]=\"borderLeft.borderId | draggableContainerId:dropBorderContainer\"\n        [cdkDropListData]=\"borderLeft.borderType\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"1\"\n        [gridColumnEnd]=\"2\"\n        [gridRowStart]=\"2\"\n        [gridRowEnd]=\"3\"\n        alignSelf=\"center\"\n        justifySelf=\"end\">\n\n      </div>\n\n    </ng-container>\n  </ng-container>\n\n  <div *ngIf=\"isWaitIndicatorActive\"\n    class=\"dkg-grid-wait-indicator\"\n    [class.dkg-grid-layout-position-with-borders]=\"bordersGap\">\n\n    <ng-container *ngTemplateOutlet=\"dikeWaitIndicator; context: { message: waitIndicatorMessage }\"></ng-container>\n  </div>\n\n  <div class=\"dkg-grid-wrapper\"\n    [attr.dkg-custom-scrollbars]=\"customScrollbars\"\n    [style.border-width]=\"gridElevation ? 0 : borderWidthPx\"\n    [class.dkg-grid-border]=\"!gridElevation\"\n    [ngClass]=\"gridElevationClass\"\n    [class.dkg-grid-layout-position-with-borders]=\"bordersGap\"\n    dkGridMainContentContainer>\n\n    <ng-container *ngIf=\"(editionToolbarPosition$ | async) === 'top'\">\n      <ng-container *ngIf=\"editionToolbarVisibility$ | async\">\n        <dk-grid-edition-toolbar\n          toolbarPosition=\"top\"\n          [toolbarAlignment]=\"editionToolbarAlignment\">\n        </dk-grid-edition-toolbar>\n      </ng-container>\n    </ng-container>\n\n    <!-- Row Grouping -->\n    <ng-container *ngIf=\"allowRowGrouping\">\n      <dk-grid-row-grouping-panel\n        emptyPanelMessage=\"For row-grouping, drag columns to this panel\">\n\n        <dk-grid-row-grouping\n          [columnStructure]=\"groupColumnStructure\">\n        </dk-grid-row-grouping>\n\n      </dk-grid-row-grouping-panel>\n    </ng-container>\n\n    <dk-grid-content\n      [datasource]=\"contentDataSource$ | async\">\n    </dk-grid-content>\n\n    <ng-container *ngIf=\"(editionToolbarPosition$ | async) === 'bottom'\">\n      <ng-container *ngIf=\"editionToolbarVisibility$ | async\">\n        <dk-grid-edition-toolbar\n          toolbarPosition=\"bottom\"\n          [toolbarAlignment]=\"editionToolbarAlignment\">\n        </dk-grid-edition-toolbar>\n      </ng-container>\n    </ng-container>\n\n    <ng-container *ngIf=\"allowPagination\">\n      <dk-paginator [pageSize]=\"pageSize\" [disabled]=\"disableSortPagination$ | async\"></dk-paginator>\n    </ng-container>\n\n  </div>\n\n  <ng-container *ngIf=\"borderRight$ | async as borderRight\">\n    <ng-container *ngIf=\"borderRight.borderGap > 0\">\n      <div class=\"dkg-drop-border-container\"\n        [style.height]=\"totalGridHeightPx\"\n        [style.width]=\"dropBorderContainerWidthPx\"\n        [style.borderRightWidth]=\"dropBorderContainerWidthPx\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        cdkDropList\n        [id]=\"borderRight.borderId | draggableContainerId:dropBorderContainer\"\n        [cdkDropListData]=\"borderRight.borderType\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"3\"\n        [gridColumnEnd]=\"4\"\n        [gridRowStart]=\"2\"\n        [gridRowEnd]=\"3\"\n        alignSelf=\"center\"\n        justifySelf=\"start\">\n\n      </div>\n\n    </ng-container>\n  </ng-container>\n\n</div>\n\n<!-- DkColumnDataType - 'Text' -->\n<ng-template #dikeTextBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <input matInput\n      type=\"text\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n      <!-- <button mat-icon-button matSuffix>\n        <mat-icon>local_phone</mat-icon>\n      </button> -->\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeMultiTextBox let-control=\"control\">\n  <input type=\"text\"\n    [formControl]=\"control\">\n</ng-template>\n\n<ng-template #dikeTextOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeTextDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Numeric' -->\n<ng-template #dikeNumericBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <input matInput\n      type=\"number\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n  </mat-form-field>\n\n  <!-- <input type=\"number\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeNumericOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"number\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeNumericDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value | number }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Date' -->\n<ng-template #dikeDateBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <button mat-icon-button matPrefix (click)=\"control.setValue('')\">\n      <mat-icon>clear</mat-icon>\n    </button>\n    <input #dateInput matInput disabled-element\n      [matDatepicker]=\"dpValue\"\n      type=\"text\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n    <mat-datepicker-toggle matSuffix [for]=\"dpValue\"></mat-datepicker-toggle>\n    <mat-datepicker #dpValue></mat-datepicker>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeDateDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value | date:'shortDate' }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Binary' -->\n<ng-template #dikeBinaryBox let-control=\"control\">\n  <mat-checkbox\n    [formControl]=\"control\">\n  </mat-checkbox>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeBinaryDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value }}</p>\n</ng-template>\n\n<ng-template #dikeBinaryOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <!-- <mat-label>Select a value</mat-label> -->\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<!-- Wait indicator -->\n<ng-template #dikeWaitIndicator let-message=\"message\">\n  <mat-card class=\"dkg-grid-wait-indicator-content\">\n    <mat-card-content>\n      <p>{{ message }}</p>\n      <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\n    </mat-card-content>\n  </mat-card>\n</ng-template>\n", styles: [".dkg-drop-border-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr;z-index:-1;border-top:0;border-right-style:none}.dkg-active-drop-border-container{box-sizing:border-box;border-right-style:solid}.dkg-grid-wrapper{height:100%;box-sizing:border-box}.dkg-grid-wrapper[dkg-custom-scrollbars=true] *{scrollbar-width:auto}.dkg-grid-wrapper[dkg-custom-scrollbars=true] * ::-webkit-scrollbar{width:8px;height:8px}.dkg-grid-wrapper[dkg-custom-scrollbars=true] * ::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-grid-border{border-style:solid}.dkg-grid-layout-position-with-borders{grid-column:2/3;grid-row:2/3}.dkg-custom-select-panel{scrollbar-width:auto}.dkg-custom-select-panel::-webkit-scrollbar{width:8px;height:8px}.dkg-custom-select-panel::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-grid-wait-indicator{z-index:100;display:flex;flex-direction:column;justify-content:center;align-items:center}.dkg-grid-wait-indicator-content{min-width:215px}\n"], components: [{ type: DkGridEditionToolbarComponent, selector: "dk-grid-edition-toolbar", inputs: ["toolbarPosition", "toolbarAlignment"] }, { type: DkGridRowGroupingPanelComponent, selector: "dk-grid-row-grouping-panel", inputs: ["emptyPanelMessage"] }, { type: DkGridRowGroupingComponent, selector: "dk-grid-row-grouping", inputs: ["columnStructure"] }, { type: DkGridContentComponent, selector: "dk-grid-content", inputs: ["datasource"] }, { type: DkPaginatorComponent, selector: "dk-paginator", inputs: ["pageSize", "disabled"] }, { type: i6.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i7.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i8$1.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { type: i5$1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i9.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { type: i9.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i42.MatCard, selector: "mat-card", exportAs: ["matCard"] }, { type: i43.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }], directives: [{ type: DkGridMainContainerDirective, selector: "[dkGridMainContainer]", exportAs: ["dkgMainContainer"] }, { type: i3$2.MatSort, selector: "[matSort]", inputs: ["matSortDisabled", "matSortActive", "matSortStart", "matSortDirection", "matSortDisableClear"], outputs: ["matSortChange"], exportAs: ["matSort"] }, { type: DkGridDimensionsDirective, selector: "[dkGridDimensions]", inputs: ["dkGridDimensions"], exportAs: ["dkgDimensions"] }, { type: i8.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i18.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { type: DkGridItemPlacementDirective, selector: "[dkGridItemPlacement]", inputs: ["gridColumnStart", "gridColumnEnd", "gridRowStart", "gridRowEnd", "alignSelf", "justifySelf"], exportAs: ["dkgItemPlacement"] }, { type: i8.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: DkGridMainContentContainerDirective, selector: "[dkGridMainContentContainer]", exportAs: ["dkgMainContentContainer"] }, { type: i8.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i11.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i8.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { type: i6.MatPrefix, selector: "[matPrefix]" }, { type: i9.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { type: DisabledElementDirective, selector: "[disabled-element]" }, { type: i6.MatSuffix, selector: "[matSuffix]" }, { type: i42.MatCardContent, selector: "mat-card-content, [mat-card-content], [matCardContent]" }], pipes: { "async": i8.AsyncPipe, "draggableContainerId": DraggableContainerIdPipe, "number": i8.DecimalPipe, "date": i8.DatePipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dk-grid', exportAs: 'dkgGrid', providers: [
                        DkContextMenu,
                        {
                            provide: MAT_SELECT_SCROLL_STRATEGY,
                            useFactory: scrollFactory,
                            deps: [Overlay]
                        },
                        {
                            provide: MAT_DATEPICKER_SCROLL_STRATEGY,
                            useFactory: scrollFactory,
                            deps: [Overlay]
                        },
                        {
                            provide: MAT_MENU_SCROLL_STRATEGY,
                            useFactory: scrollFactory,
                            deps: [Overlay]
                        },
                        ScrollDispatcher,
                        DkGridConfig,
                        DkGridPanelDispatcher,
                        DkGridColumnDef,
                        DkGridFactoryColumns,
                        DkGridFactoryMeshSlots,
                        DkFilterFactory,
                        DkGridFilterConfig,
                        DkGridFilter,
                        DkFilterDispatcher,
                        DkGridContentStructure,
                        DkContentPanelDispatcher,
                        DkGridStructure,
                        DkGridUI,
                        DkGridSorting,
                        DkSortDispatcher,
                        DkGridMessaging,
                        DkDataSourceDispatcher,
                        DkGridFactoryDataSource,
                        DkGridDataStore,
                        DkGridCommandFactory,
                        DkGridCommandSender,
                        DkGridEdition,
                        DkGridEditionConfig,
                        DkGridRowEditionDispatcher,
                        DkEditionErrorMessagesFactory,
                        DkGridSelection,
                        DkGridSelectionConfig,
                        DkGeneralNotifier,
                        DkGroupPanelDispatcher,
                        DkRowGroupingDispatcher,
                        DkRowGroupingConfig,
                        DkGridRowGrouping,
                        DkPaginationDispatcher,
                        DkGridPagination
                    ], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  [id]=\"mainWrapperId\"\n  [style.width]=\"width\"\n  [style.height]=\"height\"\n\n  dkGridMainContainer\n  [dkGridDimensions]=\"gridSizeNotifier.asObservable()\"\n  matSort [matSortDisabled]=\"!allowSorting || (disableSortPagination$ | async)\">\n\n  <ng-container *ngIf=\"borderLeft$ | async as borderLeft\">\n    <ng-container *ngIf=\"borderLeft.borderGap > 0\">\n      <div class=\"dkg-drop-border-container\"\n        [style.height]=\"totalGridHeightPx\"\n        [style.width]=\"dropBorderContainerWidthPx\"\n        [style.borderRightWidth]=\"dropBorderContainerWidthPx\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        cdkDropList\n        [id]=\"borderLeft.borderId | draggableContainerId:dropBorderContainer\"\n        [cdkDropListData]=\"borderLeft.borderType\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"1\"\n        [gridColumnEnd]=\"2\"\n        [gridRowStart]=\"2\"\n        [gridRowEnd]=\"3\"\n        alignSelf=\"center\"\n        justifySelf=\"end\">\n\n      </div>\n\n    </ng-container>\n  </ng-container>\n\n  <div *ngIf=\"isWaitIndicatorActive\"\n    class=\"dkg-grid-wait-indicator\"\n    [class.dkg-grid-layout-position-with-borders]=\"bordersGap\">\n\n    <ng-container *ngTemplateOutlet=\"dikeWaitIndicator; context: { message: waitIndicatorMessage }\"></ng-container>\n  </div>\n\n  <div class=\"dkg-grid-wrapper\"\n    [attr.dkg-custom-scrollbars]=\"customScrollbars\"\n    [style.border-width]=\"gridElevation ? 0 : borderWidthPx\"\n    [class.dkg-grid-border]=\"!gridElevation\"\n    [ngClass]=\"gridElevationClass\"\n    [class.dkg-grid-layout-position-with-borders]=\"bordersGap\"\n    dkGridMainContentContainer>\n\n    <ng-container *ngIf=\"(editionToolbarPosition$ | async) === 'top'\">\n      <ng-container *ngIf=\"editionToolbarVisibility$ | async\">\n        <dk-grid-edition-toolbar\n          toolbarPosition=\"top\"\n          [toolbarAlignment]=\"editionToolbarAlignment\">\n        </dk-grid-edition-toolbar>\n      </ng-container>\n    </ng-container>\n\n    <!-- Row Grouping -->\n    <ng-container *ngIf=\"allowRowGrouping\">\n      <dk-grid-row-grouping-panel\n        emptyPanelMessage=\"For row-grouping, drag columns to this panel\">\n\n        <dk-grid-row-grouping\n          [columnStructure]=\"groupColumnStructure\">\n        </dk-grid-row-grouping>\n\n      </dk-grid-row-grouping-panel>\n    </ng-container>\n\n    <dk-grid-content\n      [datasource]=\"contentDataSource$ | async\">\n    </dk-grid-content>\n\n    <ng-container *ngIf=\"(editionToolbarPosition$ | async) === 'bottom'\">\n      <ng-container *ngIf=\"editionToolbarVisibility$ | async\">\n        <dk-grid-edition-toolbar\n          toolbarPosition=\"bottom\"\n          [toolbarAlignment]=\"editionToolbarAlignment\">\n        </dk-grid-edition-toolbar>\n      </ng-container>\n    </ng-container>\n\n    <ng-container *ngIf=\"allowPagination\">\n      <dk-paginator [pageSize]=\"pageSize\" [disabled]=\"disableSortPagination$ | async\"></dk-paginator>\n    </ng-container>\n\n  </div>\n\n  <ng-container *ngIf=\"borderRight$ | async as borderRight\">\n    <ng-container *ngIf=\"borderRight.borderGap > 0\">\n      <div class=\"dkg-drop-border-container\"\n        [style.height]=\"totalGridHeightPx\"\n        [style.width]=\"dropBorderContainerWidthPx\"\n        [style.borderRightWidth]=\"dropBorderContainerWidthPx\"\n        [class.dkg-dragging-front-container]=\"isDragging$ | async\"\n        cdkDropList\n        [id]=\"borderRight.borderId | draggableContainerId:dropBorderContainer\"\n        [cdkDropListData]=\"borderRight.borderType\"\n        (cdkDropListDropped)=\"onDrop($event)\"\n        (cdkDropListEntered)=\"onDropListEntered($event)\"\n        (cdkDropListExited)=\"onDropListExited($event)\"\n\n        dkGridItemPlacement\n        [gridColumnStart]=\"3\"\n        [gridColumnEnd]=\"4\"\n        [gridRowStart]=\"2\"\n        [gridRowEnd]=\"3\"\n        alignSelf=\"center\"\n        justifySelf=\"start\">\n\n      </div>\n\n    </ng-container>\n  </ng-container>\n\n</div>\n\n<!-- DkColumnDataType - 'Text' -->\n<ng-template #dikeTextBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <input matInput\n      type=\"text\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n      <!-- <button mat-icon-button matSuffix>\n        <mat-icon>local_phone</mat-icon>\n      </button> -->\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeMultiTextBox let-control=\"control\">\n  <input type=\"text\"\n    [formControl]=\"control\">\n</ng-template>\n\n<ng-template #dikeTextOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeTextDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Numeric' -->\n<ng-template #dikeNumericBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <input matInput\n      type=\"number\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n  </mat-form-field>\n\n  <!-- <input type=\"number\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeNumericOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"number\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeNumericDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value | number }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Date' -->\n<ng-template #dikeDateBox let-control=\"control\">\n  <mat-form-field floatLabel=\"never\">\n    <button mat-icon-button matPrefix (click)=\"control.setValue('')\">\n      <mat-icon>clear</mat-icon>\n    </button>\n    <input #dateInput matInput disabled-element\n      [matDatepicker]=\"dpValue\"\n      type=\"text\"\n      [formControl]=\"control\"\n      autocomplete=\"off\">\n    <mat-datepicker-toggle matSuffix [for]=\"dpValue\"></mat-datepicker-toggle>\n    <mat-datepicker #dpValue></mat-datepicker>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeDateDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value | date:'shortDate' }}</p>\n</ng-template>\n\n<!-- DkColumnDataType - 'Binary' -->\n<ng-template #dikeBinaryBox let-control=\"control\">\n  <mat-checkbox\n    [formControl]=\"control\">\n  </mat-checkbox>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<ng-template #dikeBinaryDisplay let-entry=\"rowEntry\" let-value=\"fieldValue\">\n  <p>{{ value }}</p>\n</ng-template>\n\n<ng-template #dikeBinaryOptionsBox let-control=\"control\" let-options=\"options\">\n  <mat-form-field floatLabel=\"never\">\n    <!-- <mat-label>Select a value</mat-label> -->\n    <mat-select [formControl]=\"control\" [panelClass]=\"matSelectPanelClass\">\n      <mat-option *ngFor=\"let option of options\" [value]=\"option.value\">\n        {{ option.label }}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n  <!-- <input type=\"text\"\n    [formControl]=\"control\"> -->\n</ng-template>\n\n<!-- Wait indicator -->\n<ng-template #dikeWaitIndicator let-message=\"message\">\n  <mat-card class=\"dkg-grid-wait-indicator-content\">\n    <mat-card-content>\n      <p>{{ message }}</p>\n      <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\n    </mat-card-content>\n  </mat-card>\n</ng-template>\n", styles: [".dkg-drop-border-container{display:grid;grid-template-columns:1fr;grid-template-rows:1fr;z-index:-1;border-top:0;border-right-style:none}.dkg-active-drop-border-container{box-sizing:border-box;border-right-style:solid}.dkg-grid-wrapper{height:100%;box-sizing:border-box}.dkg-grid-wrapper[dkg-custom-scrollbars=true] *{scrollbar-width:auto}.dkg-grid-wrapper[dkg-custom-scrollbars=true] * ::-webkit-scrollbar{width:8px;height:8px}.dkg-grid-wrapper[dkg-custom-scrollbars=true] * ::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-grid-border{border-style:solid}.dkg-grid-layout-position-with-borders{grid-column:2/3;grid-row:2/3}.dkg-custom-select-panel{scrollbar-width:auto}.dkg-custom-select-panel::-webkit-scrollbar{width:8px;height:8px}.dkg-custom-select-panel::-webkit-scrollbar-thumb{border-radius:4px;border-width:1px;border-style:solid}.dkg-grid-wait-indicator{z-index:100;display:flex;flex-direction:column;justify-content:center;align-items:center}.dkg-grid-wait-indicator-content{min-width:215px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: Document, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [CONFIG_GRID]
                    }] }, { type: i0.ChangeDetectorRef }, { type: i0.Renderer2 }, { type: i1$2.MatSnackBar }, { type: DkGridConfig }, { type: DkGridMessaging }, { type: DkGridFilter }, { type: DkGridFilterConfig }, { type: DkFilterFactory }, { type: DkGridColumnDef }, { type: DkGridSorting }, { type: DkSortDispatcher }, { type: DkPaginationDispatcher }, { type: DkGridPagination }, { type: DkGridStructure }, { type: DkGridContentStructure }, { type: DkGridUI }, { type: DkGridFactoryColumns }, { type: DkDataSourceDispatcher }, { type: DkGridFactoryDataSource }, { type: DkGridEdition }, { type: DkGridEditionConfig }, { type: DkGridRowEditionDispatcher }, { type: DkGridSelection }, { type: DkGridSelectionConfig }, { type: DkGeneralNotifier }, { type: DkGridPanelDispatcher }, { type: DkContentPanelDispatcher }, { type: DkGroupPanelDispatcher }, { type: DkRowGroupingConfig }, { type: DkRowGroupingDispatcher }, { type: DkGridRowGrouping }];
    }, propDecorators: { id: [{
                type: HostBinding,
                args: ['attr.id']
            }, {
                type: Input
            }], height: [{
                type: Input
            }], width: [{
                type: Input
            }], displayRowId: [{
                type: Input
            }], rowIdWidth: [{
                type: Input
            }], gridElevation: [{
                type: Input
            }], gridElevationValue: [{
                type: Input
            }], verticalRowLines: [{
                type: Input
            }], striped: [{
                type: Input
            }], headerRowHeight: [{
                type: Input
            }], contentRowHeight: [{
                type: Input
            }], allowRowGrouping: [{
                type: Input
            }], rowGroupingRowHeight: [{
                type: Input
            }], rowGroupingColumnHeight: [{
                type: Input
            }], displayRowGroupingIndent: [{
                type: Input
            }], rowGroupingIndentWidth: [{
                type: Input
            }], groupPanelColumnsChange: [{
                type: Output
            }], collapseGroupRowChange: [{
                type: Output
            }], allowPagination: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], paginationRowHeight: [{
                type: Input
            }], pageChange: [{
                type: Output
            }], paginatorChange: [{
                type: Output
            }], onDemandFilter: [{
                type: Input
            }], allowRowFiltering: [{
                type: Input
            }], filterRowHeight: [{
                type: Input
            }], gridCustomFilterConditions: [{
                type: Input
            }], registerFilterableChange: [{
                type: Output
            }], deregisterFilterableChange: [{
                type: Output
            }], filterChange: [{
                type: Output
            }], editionFilterChange: [{
                type: Output
            }], clearFilterChange: [{
                type: Output
            }], clearEditionFilterChange: [{
                type: Output
            }], allowEdition: [{
                type: Input
            }], editionMode: [{
                type: Input
            }], editionToolbar: [{
                type: Input
            }], editionToolbarPosition: [{
                type: Input
            }], editionToolbarAlignment: [{
                type: Input
            }], editionToolbarRowHeight: [{
                type: Input
            }], editionToolbarItemHeight: [{
                type: Input
            }], gridEditionSettings: [{
                type: Input
            }], editionRowChange: [{
                type: Output
            }], updateRowChange: [{
                type: Output
            }], cancelRowEditionChange: [{
                type: Output
            }], removeRowChange: [{
                type: Output
            }], restoreRowChange: [{
                type: Output
            }], editionFilterStateChange: [{
                type: Output
            }], allowSelection: [{
                type: Input
            }], selectableRows: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], selectedRowChange: [{
                type: Output
            }], deselectedRowChange: [{
                type: Output
            }], datasource: [{
                type: Input
            }], decoratorFn: [{
                type: Input
            }], dataDeliveryIdChange: [{
                type: Output
            }], allowColumnContextMenu: [{
                type: Input
            }], allowColumnDragging: [{
                type: Input
            }], gridColumnDefInstance: [{
                type: Output
            }], dikeGridColumns: [{
                type: ContentChildren,
                args: [DkGridColumnComponent]
            }], allowSorting: [{
                type: Input
            }], _gridSort: [{
                type: ViewChild,
                args: [MatSort]
            }], sortChange: [{
                type: Output
            }], columnSizeChange: [{
                type: Output
            }], columnGroupStatusChange: [{
                type: Output
            }], columnLockedChange: [{
                type: Output
            }], columnUnLockedChange: [{
                type: Output
            }], columnVisibleChange: [{
                type: Output
            }], columnMove: [{
                type: Output
            }], columnsChange: [{
                type: Output
            }], contentPanelsColumnsChange: [{
                type: Output
            }], columnsRemovedChange: [{
                type: Output
            }], divMainContainerRef: [{
                type: ViewChild,
                args: [DkGridMainContainerDirective, { read: ElementRef }]
            }], dikeTextBox: [{
                type: ViewChild,
                args: ['dikeTextBox', { read: TemplateRef }]
            }], dikeMultiTextBox: [{
                type: ViewChild,
                args: ['dikeMultiTextBox', { read: TemplateRef }]
            }], dikeTextOptionsBox: [{
                type: ViewChild,
                args: ['dikeTextOptionsBox', { read: TemplateRef }]
            }], dikeNumericBox: [{
                type: ViewChild,
                args: ['dikeNumericBox', { read: TemplateRef }]
            }], dikeNumericOptionsBox: [{
                type: ViewChild,
                args: ['dikeNumericOptionsBox', { read: TemplateRef }]
            }], dikeDateBox: [{
                type: ViewChild,
                args: ['dikeDateBox', { read: TemplateRef }]
            }], dikeBinaryBox: [{
                type: ViewChild,
                args: ['dikeBinaryBox', { read: TemplateRef }]
            }], dikeBinaryOptionsBox: [{
                type: ViewChild,
                args: ['dikeBinaryOptionsBox', { read: TemplateRef }]
            }], dikeTextDisplay: [{
                type: ViewChild,
                args: ['dikeTextDisplay', { read: TemplateRef }]
            }], dikeNumericDisplay: [{
                type: ViewChild,
                args: ['dikeNumericDisplay', { read: TemplateRef }]
            }], dikeDateDisplay: [{
                type: ViewChild,
                args: ['dikeDateDisplay', { read: TemplateRef }]
            }], dikeBinaryDisplay: [{
                type: ViewChild,
                args: ['dikeBinaryDisplay', { read: TemplateRef }]
            }] } });

class DkGridModule {
}
DkGridModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkGridModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridModule, declarations: [DkGridComponent,
        DkGridDimensionsDirective,
        DkGridMainContainerDirective,
        DkGridMainContentContainerDirective], imports: [CommonModule,
        ReactiveFormsModule,
        OverlayModule,
        DragDropModule,
        MatFormFieldModule,
        MatInputModule,
        MatSelectModule,
        MatButtonModule,
        MatIconModule,
        MatDatepickerModule,
        MatCheckboxModule,
        MatCardModule,
        MatProgressBarModule,
        MatSortModule,
        MatSnackBarModule,
        MatPaginatorModule,
        MatMenuModule,
        DkContentModule,
        DkEditingModule,
        DkPagingModule,
        DkRowGroupingModule,
        DkCommonModule], exports: [DkGridComponent] });
DkGridModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridModule, imports: [[
            CommonModule,
            ReactiveFormsModule,
            OverlayModule,
            DragDropModule,
            MatFormFieldModule,
            MatInputModule,
            MatSelectModule,
            MatButtonModule,
            MatIconModule,
            MatDatepickerModule,
            MatCheckboxModule,
            MatCardModule,
            MatProgressBarModule,
            MatSortModule,
            MatSnackBarModule,
            MatPaginatorModule,
            MatMenuModule,
            DkContentModule,
            DkEditingModule,
            DkPagingModule,
            DkRowGroupingModule,
            DkCommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkGridModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkGridComponent,
                        DkGridDimensionsDirective,
                        DkGridMainContainerDirective,
                        DkGridMainContentContainerDirective
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        OverlayModule,
                        DragDropModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatSelectModule,
                        MatButtonModule,
                        MatIconModule,
                        MatDatepickerModule,
                        MatCheckboxModule,
                        MatCardModule,
                        MatProgressBarModule,
                        MatSortModule,
                        MatSnackBarModule,
                        MatPaginatorModule,
                        MatMenuModule,
                        DkContentModule,
                        DkEditingModule,
                        DkPagingModule,
                        DkRowGroupingModule,
                        DkCommonModule
                    ],
                    exports: [
                        DkGridComponent
                    ]
                }]
        }] });

class DkContextMenuModule {
}
DkContextMenuModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkContextMenuModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenuModule, declarations: [DkColumnContextMenuComponent,
        DkColumnChooserComponent,
        DkColumnPinningComponent,
        ColumnContextMenuContentHeightPipe], imports: [CommonModule,
        CdkTreeModule,
        MatTreeModule,
        MatCheckboxModule,
        MatButtonModule,
        MatIconModule,
        MatTabsModule,
        MatDividerModule,
        MatRadioModule,
        DkFilteringModule,
        DkSortingModule], exports: [DkColumnContextMenuComponent] });
DkContextMenuModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenuModule, imports: [[
            CommonModule,
            CdkTreeModule,
            MatTreeModule,
            MatCheckboxModule,
            MatButtonModule,
            MatIconModule,
            MatTabsModule,
            MatDividerModule,
            MatRadioModule,
            DkFilteringModule,
            DkSortingModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkContextMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DkColumnContextMenuComponent,
                        DkColumnChooserComponent,
                        DkColumnPinningComponent,
                        ColumnContextMenuContentHeightPipe
                    ],
                    imports: [
                        CommonModule,
                        CdkTreeModule,
                        MatTreeModule,
                        MatCheckboxModule,
                        MatButtonModule,
                        MatIconModule,
                        MatTabsModule,
                        MatDividerModule,
                        MatRadioModule,
                        DkFilteringModule,
                        DkSortingModule
                    ],
                    exports: [
                        DkColumnContextMenuComponent
                    ]
                }]
        }] });

class DkDataGridModule {
}
DkDataGridModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DkDataGridModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataGridModule, imports: [DkGridModule,
        DkContentModule,
        DkEditingModule,
        DkFilteringModule,
        DkColumnsModule,
        DkGuttersModule,
        DkHeadersModule,
        DkPagingModule,
        DkPanelsModule,
        DkRowGroupingModule,
        DkRowsModule,
        DkScrollingModule,
        DkSelectionModule,
        DkSortingModule,
        DkCommonModule,
        DkContextMenuModule], exports: [DkGridComponent,
        DkGridColumnComponent] });
DkDataGridModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataGridModule, providers: [
        { provide: MAT_FORM_FIELD_DEFAULT_OPTIONS, useValue: { appearance: 'fill', floatLabel: 'never' } }
    ], imports: [[
            DkGridModule,
            DkContentModule,
            DkEditingModule,
            DkFilteringModule,
            DkColumnsModule,
            DkGuttersModule,
            DkHeadersModule,
            DkPagingModule,
            DkPanelsModule,
            DkRowGroupingModule,
            DkRowsModule,
            DkScrollingModule,
            DkSelectionModule,
            DkSortingModule,
            DkCommonModule,
            DkContextMenuModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: DkDataGridModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        DkGridModule,
                        DkContentModule,
                        DkEditingModule,
                        DkFilteringModule,
                        DkColumnsModule,
                        DkGuttersModule,
                        DkHeadersModule,
                        DkPagingModule,
                        DkPanelsModule,
                        DkRowGroupingModule,
                        DkRowsModule,
                        DkScrollingModule,
                        DkSelectionModule,
                        DkSortingModule,
                        DkCommonModule,
                        DkContextMenuModule
                    ],
                    exports: [
                        DkGridComponent,
                        DkGridColumnComponent
                    ],
                    providers: [
                        { provide: MAT_FORM_FIELD_DEFAULT_OPTIONS, useValue: { appearance: 'fill', floatLabel: 'never' } }
                    ]
                }]
        }] });

/*
 * Public API Surface of dk-data-grid
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BORDER_GAP, BORDER_WIDTH, COLUMN_CONTEXT_MENU, COLUMN_CONTEXT_MENU_HEIGHT, COLUMN_CONTEXT_MENU_WIDTH, CONTENT_ROW_HEIGHT, CUSTOM_BINARY_FILTER_CONDITIONS, CUSTOM_DATE_FILTER_CONDITIONS, CUSTOM_EDITION_ERROR_MESSAGES, CUSTOM_NUMERIC_FILTER_CONDITIONS, CUSTOM_ROW_DATE_FILTER_CONDITIONS, CUSTOM_ROW_NUMERIC_FILTER_CONDITIONS, CUSTOM_ROW_TEXT_FILTER_CONDITIONS, CUSTOM_SCROLLBARS, CUSTOM_TEXT_FILTER_CONDITIONS, ConditionType, CustomBinaryFilterCondition, CustomDateFilterCondition, CustomErrorMessage, CustomMultipleNumericFilterCondition, CustomMultipleTextFilterCondition, CustomNumericFilterCondition, CustomRowDateFilterCondition, CustomRowNumericFilterCondition, CustomRowTextCaseFilterCondition, CustomTextCaseFilterCondition, DELETE_OPERATION_ROW_SUBSET_SIZE, DIVISION_PANEL_GAP, DIVISION_PANEL_LINE_WIDTH, DIVISION_PANEL_LINE_WIDTH_RESIZING, DkBinaryColumnDef, DkColumnDef, DkDataColumnDef, DkDataGridModule, DkDataSource, DkDateColumnDef, DkDecoratorDataSource, DkFilteringDataSource, DkGridColumnComponent, DkGridColumnDef, DkGridComponent, DkGridDataRowEntry, DkGridDataSource, DkGridEdition, DkGridFactoryDataSource, DkGridFilter, DkGridPagination, DkGridRowEntry, DkGridRowGrouping, DkGridSelection, DkGridSorting, DkGridWaitingIndicator, DkGroupColumnDef, DkNumericColumnDef, DkSortingDataSource, DkTextColumnDef, EDITION_TOOLBAR_ITEM_HEIGHT, EDITION_TOOLBAR_ROW_HEIGHT, ErrorType, FILTER_ROW_HEIGHT, GRID_HEIGHT, GRID_WIDTH, HEADER_ROW_HEIGHT, LOADING_MESSAGE, MAX_ROWS_IN_EDITION, NUMERIC_FILTER_DEBOUNCE_TIME, PAGINATION_ROW_HEIGHT, PROCESSING_MESSAGE, ROW_EDITION_DBLCLICK, ROW_EDITION_ENTER_KEY, ROW_EDITION_ESC_KEY, ROW_GROUPING_COLUMN_HEIGHT, ROW_GROUPING_INDENT, ROW_GROUPING_INDENT_WIDTH, ROW_GROUPING_ROW_HEIGHT, SPLIT_DELETE_OPERATION, SPLIT_UNDO_OPERATION, TEXT_FILTER_DEBOUNCE_TIME, UNDO_OPERATION_ROW_SUBSET_SIZE, WAIT_FOR_MULTIPLE_ROWS_CANCELATION, WAIT_FOR_MULTIPLE_ROWS_DELETION, WAIT_FOR_MULTIPLE_ROWS_RESTORATION, WAIT_FOR_MULTIPLE_ROWS_UPDATE, isDkDataColumnDef, isDkGroupColumnDef };
//# sourceMappingURL=dk-grid-standard-angular.mjs.map
